*-------------------------------
* ATTACK.MOD
*-------------------------------
 DAT
 LST OFF

 ORG $8000

 USE MACROS
 USE EQUATES
 USE VARS
 USE LIB.JMP
 USE PLR.DSECT
 USE MON.DSECT
 USE MON2.DSECT

 TYP $F4
 do M16PLUS-1
 SAV RUN/MODULES/ATTACK.MOD
 fin

*
* Entry : MISCBUFF   - x position
*         MISCBUFF+1 - y position
*         MISCBUFF+2 - level
*         MISCBUFF+3 - 00=monster, FF=player
*         MISCBUFF+4 - 00=party members not included, FF=party members OK
*
* Exit  : MISCBUFF+3 - 00=ok, 7F=abort, FF=nothing
*

START LDA MISCBUFF
 STA X
 LDA MISCBUFF+1
 STA Y
 LDA MISCBUFF+2
 STA LEVEL
 LDA MISCBUFF+3
 BMIL :P

:M JSR PRINT
 GOTOXY 0;21
 ZAPLINE
 GOTOXY 10;19
 CLEOL
 NULL
 LDX #0
 LDA #0
 JSR LOADMON2
 LDA MON2BUFF
 STA :M2RECS
 LDA MON2BUFF+1
 STA :M2RECS+1

 LDX #0
]LOOP STZ :TABLEM2,X
 STZ :TABLEP,X
 STZ :TABLEP2,X
 INX
 BNE ]LOOP

 STZ :CNTRM2

]LOOP LDA :M2RECS
 ORA :M2RECS+1
 BEQ :M2DONE
 LDX :M2RECS
 LDA :M2RECS+1
 JSR LOADMON2
 LDA MTYPE
 ORA MTYPE+1
 BEQ :M2NEXT
 LDA MCOND
 AND #%1000_0000
 BNE :M2NEXT
 LDA MXPOS
 CMP X
 BNE :M2NEXT
 LDA MYPOS
 CMP Y
 BNE :M2NEXT
 LDA MZPOS
 CMP LEVEL
 BNE :M2NEXT
 LDX :CNTRM2
 LDA :M2RECS
 STA :TABLEM2,X
 INC :CNTRM2
:M2NEXT DEC :M2RECS
 BRA ]LOOP

:M2DONE LDA :CNTRM2
 BEQL :NOTHING
 CMP #1
 BEQL :ONEM2
 STZ POINTER
 LDA #0
 JSR :SHOWM2
 JSR PRINT
 GOTOXY 0;21
 ASC "Select target using pointer"
 CURSOROFF
 GOTOXY 39;15
 NULL
]TOPLOOP JSR DOPOINT
]LOOP JSR KEYIN
 CMP #$9B
 BEQL :MPOUT
 CMP #"J"-$40
 BEQ :MPDOWN
 CMP #"K"-$40
 BEQ :MPUP
 CMP #$8D
 BEQ :M2YES
 BRA ]LOOP

:MPDOWN LDA POINTER
 INC
 CMP :CNTRM2
 BCS :MPDOK2
 INC POINTER
 LDA CV
 CMP #22
 BNE :MPDOK2
 LDA POINTER
 JSR :SHOWM2
:MPDOK2 JMP ]TOPLOOP

:MPUP LDA POINTER
 BNE :MPUOK
 LDA #1
:MPUOK DEC
 STA POINTER
 LDA CV
 CMP #15
 BNE :MPUOK2
 LDA POINTER
 BEQ :MPUOK2
 INC
 AND #%0000_0111
 BNE :MPUOK2
 LDA POINTER
 SEC
 SBC #7
 STA POINTER
 JSR :SHOWM2
 LDA POINTER
 CLC
 ADC #7
 STA POINTER
:MPUOK2 JMP ]TOPLOOP

:M2YES LDX POINTER
 HEX 2C
:ONEM2 LDX #0
 LDA :TABLEM2,X
 STA VTEMP
 STZ VTEMP+1
 JSR CLRSIDE
 JSR PRINT
 GOTOXY 0;21
 ZAPLINE
 CURSORON
 NULL
 STZ MISCBUFF+3 ;Return with setting to attack monster
 RETURN

:MPOUT JSR CLRSIDE
 JSR PRINT
 GOTOXY 0;21
 ZAPLINE
 CURSORON
 NULL
 LDA #$7F
 STA MISCBUFF+3 ;Return with setting to abort
 RETURN

:SHOWM2 STA VTEMP
 JSR CLRSIDE
]LOOP LDX VTEMP
 LDA :TABLEM2,X
 BEQ :M2OUT
 TAX
 LDA #0
 JSR LOADMON2
 LDX MTYPE
 LDA MTYPE+1
 JSR LOADMON
 JSR PRINT
 HTAB 55
 NULL
 LDA MCOND
 AND #%1100_1001 ;Can monster move?
 BEQ :MMOK
 JSR PRINT
 COLOR PINK
 ASC "*"
 NULL
 BRA :SMN
:MMOK JSR PRINT
 ASC " "
 NULL
:SMN JSR PRINT
 COLOR ORANGE
 PRSTRING MNAME
 COLOR WHITE
 CR
 NULL
 LDA CV
 CMP #23
 BCS :M2OUT
 INC VTEMP
 LDA VTEMP
 CMP :CNTRM2
 BEQ ]LOOP
 BCC ]LOOP
:M2OUT RTS

:P JSR PRINT
 GOTOXY 0;21
 ZAPLINE
 GOTOXY 10;19
 CLEOL
 NULL
 LDX #0
 LDA #0
 JSR LOADPLR
 LDA PLRBUFF
 STA :PRECS
 LDA PLRBUFF+1
 STA :PRECS+1

 LDX #0
]LOOP STZ :TABLEP,X
 STZ :TABLEP2,X
 INX
 BNE ]LOOP

 STZ :CNTRP

]LOOP LDA :PRECS
 ORA :PRECS+1
 BEQ :PDONE
 LDX :PRECS
 LDA :PRECS+1
 JSR LOADPLR
 BIT PLRFREE
 BMI :PNEXT
 BIT MISCBUFF+4
 BMI :POVER
 LDA PLRPARTY
 CMP PARTYNUM
 BEQ :PNEXT
:POVER LDA PLRXPOS
 CMP X
 BNE :PNEXT
 LDA PLRYPOS
 CMP Y
 BNE :PNEXT
 LDA PLRZPOS
 CMP LEVEL
 BNE :PNEXT
 LDX :CNTRP
 LDA :PRECS
 STA :TABLEP,X
 LDA :PRECS+1
 STA :TABLEP2,X
 INC :CNTRP
:PNEXT DECR :PRECS
 BRA ]LOOP

:PDONE LDA :CNTRP
 BEQL :NOTHING
 CMP #1
 BEQL :ONEP
 STZ POINTER
 LDA #0
 JSR :SHOWP
 JSR PRINT
 GOTOXY 0;21
 ASC "Select target using pointer"
 CURSOROFF
 GOTOXY 39;15
 NULL
]TOPLOOP JSR DOPOINT
]LOOP JSR KEYIN
 CMP #$9B
 BEQL :MPOUT
 CMP #"J"-$40
 BEQ :PDOWN
 CMP #"K"-$40
 BEQ :PUP
 CMP #$8D
 BEQ :PYES
 BRA ]LOOP

:PDOWN LDA POINTER
 INC
 CMP :CNTRP
 BCS :PDOK2
 INC POINTER
 LDA CV
 CMP #22
 BNE :PDOK2
 LDA POINTER
 JSR :SHOWP
:PDOK2 JMP ]TOPLOOP

:PUP LDA POINTER
 BNE :PUOK
 LDA #1
:PUOK DEC
 STA POINTER
 LDA CV
 CMP #15
 BNE :PUOK2
 LDA POINTER
 BEQ :PUOK2
 INC
 AND #%0000_0111
 BNE :PUOK2
 LDA POINTER
 SEC
 SBC #7
 STA POINTER
 JSR :SHOWP
 LDA POINTER
 CLC
 ADC #7
 STA POINTER
:PUOK2 JMP ]TOPLOOP

:PYES LDX POINTER
 HEX 2C
:ONEP LDX #0
 LDA :TABLEP,X
 STA VTEMP
 LDA :TABLEP2,X
 STA VTEMP+1
 JSR CLRSIDE
 JSR PRINT
 GOTOXY 0;21
 ZAPLINE
 CURSORON
 NULL
 STZ MISCBUFF+3 ;Return with setting to attack char
 RETURN

:SHOWP STA VTEMP
 JSR CLRSIDE
]LOOP LDX VTEMP
 LDA :TABLEP,X
 ORA :TABLEP2,X
 BEQ :POUT
 LDA :TABLEP2,X
 TAY
 LDA :TABLEP,X
 TAX
 TYA
 JSR LOADPLR
 JSR PRINT
 HTAB 55
 NULL
 LDA PLRCOND
 AND #%1100_1001 ;Can player move?
 BEQ :PMOVEOK
 LDA PLRCOND
 AND #%1000_0000
 BEQ :PNOMOVE
 JSR PRINT
 COLOR PINK
 ASC "#" ;Dead
 COLOR WHITE
 NULL
 BRA :PMOVEOK2
:PNOMOVE JSR PRINT
 COLOR PINK
 ASC "*" ;Can't move
 COLOR WHITE
 NULL
 BRA :PMOVEOK2
:PMOVEOK JSR PRINT
 ASC " "
 NULL
:PMOVEOK2 LDA PLRPARTY
 CMP PARTYNUM
 BNE :SPOK
 JSR PRINT
 COLOR AQUAMARINE
 NULL
:SPOK JSR PRINT
 PRSTRING PLRNAME
 COLOR WHITE
 CR
 NULL
 LDA CV
 CMP #23
 BCS :POUT
 INC VTEMP
 LDA VTEMP
 CMP :CNTRP
 BEQ ]LOOP
 BCC ]LOOP
:POUT RTS

:NOTHING LDA #$FF ;Nothing
 STA MISCBUFF+3
 RETURN

:M2RECS DS 2
:PRECS DS 2

:CNTRM2 DS 1
:CNTRP DS 1

:TABLEM2 DS $100
:TABLEP DS $100
:TABLEP2 DS $100

DOPOINT LDA OLDPNTR
 AND #%0000_0111
 CLC
 ADC #15
 STA :CV+2
 JSR PRINT
 NORMAL
 MTOFF
 HTAB 54
:CV VTAB 0
 ASC " "
 NULL
 LDA POINTER
 AND #%0000_0111
 CLC
 ADC #15
 STA :CV2+2
 JSR PRINT
 HTAB 54
:CV2 VTAB 0
 NULL
 JSR SHOWPNTR
 LDA POINTER
 STA OLDPNTR
 RTS
POINTER DS 1
OLDPNTR DS 1

CLRSIDE LDX #7
]LOOP TXA
 CLC
 ADC #15
 STA :DH+3
 JSR PRINT
:DH GOTOXY 54;22
 CLEOL
 NULL
 DEX
 BPL ]LOOP
 RTS

X DS 1
Y DS 1
LEVEL DS 1

 LST ON
MODEND EQU *
 LST OFF

 do M16PLUS
 SAV RUN/MODULES/ATTACK.MOD
 fin

 END
