*-------------------------------
* FILE.PEEKER
*-------------------------------
 DAT
 LST OFF

 ORG $8000 ;Always

 USE MACROS
 USE EQUATES
 USE VARS
 USE LIB.JMP

 TYP $F4
 do M16PLUS-1
 DSK RUN/MODULES/FILE.PEEKER
 fin

 MODID "FILE.PEEKER"

START JSR PRINT
 HOME
 CURSORON
 BOX "File Peeker"
 NULL

 JSR TOPBIT
 JSR DISPLAY

BOT JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 CURSORON
 ASC "[F]ile, [E]dit, [R]ead, [W]rite, [X]-flip, ["
 MTON
 INVERSE
 ASC "H"
 NORMAL
 ASC ","
 INVERSE
 ASC "U"
 NORMAL
 MTOFF
 ASC "]-scan, [I]nfo, [Q]uit : "
 CLEOL
 NULL

GETKEY JSR KEYIN
 JSR UPPER
 LDX :KEYS
]LOOP2 CMP :KEYS,X
 BEQ :GOTONE
 DEX
 BNE ]LOOP2
 BRA GETKEY
:GOTONE DEX
 TXA
 ASL
 TAX
 JMP (:TABLE,X)

:KEYS DFB :ENDKEYS-*-1
 DFB "F"
 DFB "E"
 DFB "R"
 DFB "W"
 DFB "X"
 DFB "H"-$40
 DFB "U"-$40
 DFB "I"
 DFB "Q"
:ENDKEYS

:TABLE DA FNAME
 DA EDIT
 DA READ
 DA WRITE
 DA DOFLIP
 DA BACK1
 DA FORW1
 DA INFO
 DA EXIT

FORW1 LDA PATH
 BEQL GETKEY
 LDA GPARMS+7
 CMP #$F
 BNE :OK
 LDA RELBLOCK
 CMP #4
 BNE :OK
 STZ RELBLOCK
:OK INCR RELBLOCK
 STZ TEMP
 STZ FLIP
 LDA #"F"
 STA FBFLAG
 JMP READ2

BACK1 LDA PATH
 BEQL GETKEY
 LDA GPARMS+7
 CMP #$F
 BNE :OK
 LDA RELBLOCK
 CMP #1
 BNE :OK
 LDA #5
 STA RELBLOCK
:OK DECR RELBLOCK
 LDA RELBLOCK
 BNE :BLOK
 LDA RELBLOCK+1
 BNE :BLOK
 LDA BLOCKS
 STA RELBLOCK
 LDA BLOCKS+1
 STA RELBLOCK+1
:BLOK STZ TEMP
 STZ FLIP
 LDA #"B"
 STA FBFLAG
 JMP READ2

FNAME JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 ASC "Filename : "
 NULL
 GETLINE #63
 CPX #0
 BEQL BOT
 STX PATH
]LOOP LDA $200-1,X
 ORA #$80
 JSR UPPER
 STA PATH,X
 DEX
 BNE ]LOOP
 MLI_GET_FILE_INFO GPARMS
 BCC :OK
 STA TEMP
 JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 COLOR PINK
 ASC "MLI error $"
 COLOR YELLOW
 HEX8 TEMP
 COLOR PINK
 ASC ". "
 COLOR WHITE
 NULL
 GETRETURN
 JMP BOT
:OK JSR CLOSEALL
 MLI_OPEN OPARMS ;OPEN
 JSR MLIERR
 LDA OPARMS+5
 STA RPARMS+1
 STA MPARMS+1
 STA EPARMS+1
 MLI_GET_EOF EPARMS
 JSR MLIERR
 STZ FLIP
 LDA #1
 STA RELBLOCK
 STZ RELBLOCK+1
 STZ TEMP
 JMP READ2

WRITE LDA #$FF
 STA TEMP
 JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 ASC "Write"
 NULL
 BRA RWGO
READ LDA #0
 STA TEMP
 JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 ASC "Read"
 NULL
RWGO LDA PATH
 BNE :OK
 JSR PRINT
 ASC " - "
 COLOR PINK
 ASC "no file to read/write. "
 COLOR WHITE
 NULL
 GETRETURN
 JMP BOT
:OK JSR PRINT
 ASC " rel block $"
 NULL
 STZ BLOCK
 STZ BLOCK+1
 STZ FBFLAG
 GETLINE #4
 BCSL BOT
 CPX #0
 BEQ READ2
 LDY #0
]LOOP LDA $200,Y
 JSR ISHEX
 BCS :ERR
 LUP 4
 ASL BLOCK
 ROL BLOCK+1
 --^
 ORA BLOCK
 STA BLOCK
 INY
 DEX
 BNE ]LOOP
 BRA RWOK
:ERR JSR PRINT
 COLOR PINK
 ASC "  Illegal block. "
 COLOR WHITE
 NULL
 GETRETURN
 JMP BOT
READ2 LDA RELBLOCK
 STA BLOCK
 LDA RELBLOCK+1
 STA BLOCK+1
 JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 NULL
RWOK JSR :CALCMARK
 MLI_SET_MARK MPARMS
 BCS :ERR
 LDA TEMP
 BMI :WRITE
 STZ RPARMS+4
 LDA #2
 STA RPARMS+5
 MLI_READ RPARMS
 BCS :ERR
 LDA RPARMS+6
 STA RPARMS+4
 LDA RPARMS+7
 STA RPARMS+5
 BRA :CONT
:WRITE MLI_WRITE RPARMS
 BCS :ERR
:CONT LDA TEMP
 BMI :CONT2
 STZ FLIP
:CONT2 LDA BLOCK
 STA RELBLOCK
 LDA BLOCK+1
 STA RELBLOCK+1
 JSR TOPBIT
 JSR DISPLAY
 JMP BOT
:ERR STA ERR
 CMP #$4D
 BEQ :WRAP
 CMP #$4C
 BEQ :WRAP
:ERR2 JSR PRINT
 COLOR PINK
 ASC "MLI error $"
 COLOR YELLOW
 HEX8 ERR
 COLOR PINK
 ASC ". "
 COLOR WHITE
 NULL
 GETRETURN
 LDA FBFLAG
 BEQ :NOFB
 CMP #"F"
 BNE :BACK
 DECR RELBLOCK
 BRA :NOFB
:BACK INCR RELBLOCK
:NOFB JMP BOT
:CALCMARK LDA BLOCK
 STA MPARMS+3
 LDA BLOCK+1
 STA MPARMS+4
 DECR MPARMS+3
 ASL MPARMS+3 ;Multiply by 2 to get block number (for MARK)
 ROL MPARMS+4
 RTS

:WRAP LDA FBFLAG
 BEQ :NOFB
 CMP #"F"
 BNE :BACK2
 LDA #1
 STA RELBLOCK
 STZ RELBLOCK+1
 JMP READ2
:BACK2 DECR RELBLOCK
 JMP READ2

EDIT STZ :X
 STZ :Y
 STZ :FLAG
 JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 COLOR YELLOW
 ASC "Edit - arrow keys moves cursor, [TAB]-flip, [ESC]-exit"
 COLOR WHITE
 CURSOROFF
 NULL
 BRA :TOP2
:TOP JSR :NORM
:TOP2 JSR PRINT
 INVERSE
 NULL
 JSR :DOXY
 JSR :GETBYTE
 JSR PRBYTE
]LOOP JSR KEYIN
 JSR UPPER
 JSR ISHEX
 BCC :HEX
 LDX :KEYS
]LOOP2 CMP :KEYS,X
 BEQ :GOTONE
 DEX
 BNE ]LOOP2
 BRA ]LOOP
:GOTONE DEX
 TXA
 ASL
 TAX
 JMP (:TABLE,X)

:KEYS DFB :ENDKEYS-*-1
 DFB "H"-$40
 DFB "U"-$40
 DFB "J"-$40
 DFB "K"-$40
 DFB "I"-$40
 DFB "["-$40
:ENDKEYS

:TABLE DA :LEFT
 DA :RIGHT
 DA :DOWN
 DA :UP
 DA :TAB
 DA :ESC

:HEX STA TEMP
 JSR :GETBYTE
 ASL
 ASL
 ASL
 ASL
 ORA TEMP
 STA (CADD3),Y ;Put byte
 STA TEMP
 LDA :X
 CLC
 ADC #53
 STA :HTAB+2
 JSR PRINT
 NORMAL
:HTAB HTAB 0
 NULL
 LDA TEMP
 JSR COLORS
 ORA #$80
 CMP #$A0
 BCS :CHAROK
 LDA #"."
:CHAROK JSR COUT
 JSR PRINT
 COLOR WHITE
 NULL
 LDA :FLAG
 EOR #$FF
 STA :FLAG
 BMIL :TOP2
 JMP :RIGHT2

:NORM JSR PRINT
 NORMAL
 NULL
 JSR :DOXY
 JSR :GETBYTE
 JMP PRBYTE

:LEFT JSR :NORM
 STZ :FLAG
 DEC :X
 LDA :X
 CMP #$FF
 BNE :LOK
 LDA #$F
 STA :X
 DEC :Y
 LDA :Y
 CMP #$FF
 BNE :LOK
 LDA #$F
 STA :Y
 JSR :OVER
:LOK JMP :TOP

:RIGHT STZ :FLAG
:RIGHT2 JSR :NORM
 INC :X
 LDA :X
 CMP #$10
 BNE :ROK
 LDA #0
 STA :X
 INC :Y
 LDA :Y
 CMP #$10
 BNE :ROK
 LDA #0
 STA :Y
 JSR :OVER
:ROK JMP :TOP

:DOWN JSR :NORM
 STZ :FLAG
 INC :Y
 LDA :Y
 CMP #$10
 BNE :DOK
 LDA #0
 STA :Y
 JSR :OVER
:DOK JMP :TOP

:UP JSR :NORM
 STZ :FLAG
 DEC :Y
 LDA :Y
 CMP #$FF
 BNE :UOK
 LDA #$F
 STA :Y
 JSR :OVER
:UOK JMP :TOP

:TAB JSR :OVER
 STZ :FLAG
 JMP :TOP2

:OVER LDA FLIP
 EOR #1
 STA FLIP
 JSR PRINT
 NORMAL
 NULL
 JSR DISPLAY
 JSR PRINT
 CURSOROFF
 NULL
 RTS

:ESC JSR PRINT
 NORMAL
 NULL
 JSR :DOXY
 JSR :GETBYTE
 JSR PRBYTE
 JMP BOT

:GETBYTE LDA #<MISCBUFF
 STA CADD3
 LDA #>MISCBUFF
 CLC
 ADC FLIP
 STA CADD3+1
 LDA :Y
 ASL
 ASL
 ASL
 ASL
 CLC
 ADC :X
 TAY
 LDA (CADD3),Y ;Get byte
 RTS
:DOXY LDA :X
 ASL
 CLC
 ADC #4
 ADC :X
 STA :XY+2
 LDA :Y
 CLC
 ADC #6
 STA :XY+3
 JSR PRINT
:XY GOTOXY 0;0
 NULL
 RTS

:X DS 1
:Y DS 1
:FLAG DS 1

DOFLIP LDA FLIP
 EOR #1
 STA FLIP
 JSR DISPLAY
 JMP BOT

TOPBIT JSR PRINT
 GOTOXY 0;4
 ASC "File : "
 CLEOL
 COLOR AQUAMARINE
 PRSTRING PATH
 COLOR WHITE
 NULL
 LDA GPARMS+7 ;Storage_type
 CMP #1 ;Seedling
 BNE :FT2
 JSR PRINT
 ASC " <seedling>"
 NULL
 BRA :CONT
:FT2 CMP #2 ;Sapling
 BNE :FT3
 JSR PRINT
 ASC " <sapling>"
 NULL
 BRA :CONT
:FT3 CMP #3 ;Tree
 BNE :FTD
 JSR PRINT
 ASC " <tree>"
 NULL
 BRA :CONT
:FTD CMP #$D ;Directory
 BNE :DIR
 JSR PRINT
 ASC " <directory>"
 NULL
 BRA :CONT
:DIR CMP #$F ;Volume
 BNE :UN
 JSR PRINT
 ASC " <volume>"
 NULL
 BRA :CONT
:UN JSR PRINT
 ASC " <unknown storage type>"
 NULL
:CONT JSR PRINT
 GOTOXY 0;1
 ASC "Rel block # $"
 COLOR YELLOW
 HEX16 RELBLOCK
 COLOR WHITE
 CR
 ASC "Blocks/file $"
 COLOR YWLLOE
 HEX16 GPARMS+8
 COLOR WHITE
 NULL
 RTS

DISPLAY JSR PRINT
 GOTOXY 0;6
 CURSOROFF
 NULL
 LDA #<MISCBUFF
 STA CADD3
 LDA #>MISCBUFF
 CLC
 ADC FLIP
 STA CADD3+1
 LDY #0
]LOOP PUSH CADD3
 JSR PRINT
 COLOR WHITE
 NULL
 PULL CADD3
 LDA FLIP
 CLC
 ADC #"0"
 JSR COUT
 TYA
 JSR PRBYTE
 LDA #":"
 JSR COUT
]LOOP2 LDA (CADD3),Y
 JSR PRBYTE
 LDA #" "
 JSR COUT
 INY
 TYA
 AND #$F
 BNE ]LOOP2
 LDA #" "
 JSR COUT
 TYA
 SEC
 SBC #$10
 TAY
]LOOP3 LDA (CADD3),Y
 JSR COLORS
 ORA #$80
 CMP #$A0
 BCS :OK
 LDA #"."
:OK JSR COUT
 INY
 TYA
 AND #$F
 BNE ]LOOP3
 JSR PRINT
 CR
 NULL
 CPY #0
 BNE ]LOOP
 JSR PRINT
 COLOR WHITE
 CURSORON
 NULL
 RTS

COLORS STA :BYTE
 PUSH CADD3
 LDA :BYTE
 LSR
 LSR
 LSR
 LSR
 LSR
 TAX
 LDA CC,X
 STA :COLOR+2
 JSR PRINT
:COLOR COLOR 0
 NULL
 PULL CADD3
 LDA :BYTE
 RTS
:BYTE DS 1

CC DFB $3 ;00 - 1F (grey 1)
 DFB $C ;20 - 3F (grey 2)
 DFB $9 ;40 - 5F (orange)
 DFB $E ;60 - 7F (aquamarine)
 DFB $D ;80 - 9F (pink)
 DFB $B ;A0 - BF (yellow)
 DFB $B ;C0 - DF (yellow)
 DFB $B ;E0 - FF (yellow)

INFO LDA PATH
 BEQL GETKEY
 JSR PRINT
 GOTOXY 0;6
 CLEOS
 CURSORON
 ASC "Access bits.....%"
 PRNIBBLE GPARMS+3
 CR
 ASC "File type.......$"
 HEX8 GPARMS+4
 CR
 ASC "Auxiliary type..$"
 HEX16 GPARMS+5
 CR
 ASC "Storage type....$"
 HEX8 GPARMS+7
 CR
 ASC "Blocks used.....$"
 HEX16 GPARMS+8
 CR
 ASC "Last modified..."
 DATE GPARMS+$A
 ASC "  "
 TIME GPARMS+$C
 CR
 ASC "Created........."
 DATE GPARMS+$E
 ASC "  "
 TIME GPARMS+$10
 CR
 ASC "EOF.............$"
 HEX8 EPARMS+4
 HEX16 EPARMS+2
 CR
 CR
 ASC "Read/Write buffer is at $"
 HEX16 RPARMS+2
 GOTOXY 0;23
 COLOR PINK
 NULL
 GETRETURN
 JSR PRINT
 GOTOXY 0;6
 COLOR WHITE
 CLEOS
 NULL
 JSR DISPLAY
 JMP BOT

EXIT JSR CLOSEALL
 RETURN

ISHEX CMP #"A"
 BCS :LETTER
 CMP #"9"+1
 BCS :ERR
 CMP #"0"
 BCC :ERR
 SBC #"0"
 CLC
 RTS
:LETTER CMP #"F"+1
 BCS :ERR
 SBC #"A"-$B
 CLC
 RTS
:ERR SEC
 RTS

GPARMS DFB $A
 DA PATH
 DS 5
BLOCKS DS 2
 DS 8

OPARMS DFB 3
 DA PATH
 DA IOBUFFER
 DS 1

MPARMS DFB 2
 DS 1
 DS 3

EPARMS DFB 2
 DS 1
 DS 3

RPARMS DFB 4
 DS 1
 DA MISCBUFF
 DA $200
 DS 2

PATH DS 1+63 ;Pathname

TEMP DS 1
ERR DS 1
FLIP DFB 0
BLOCK DA 0
RELBLOCK DA 0
FBFLAG DS 1

 LST ON
MODEND EQU *
 LST OFF

 do M16PLUS
 SAV RUN/MODULES/FILE.PEEKER
 fin

 END
