*-------------------------------
* FONT.EDITOR
*-------------------------------
 DAT
 LST OFF

 XC
 XC

 ORG $8000 ;Always

 USE MACROS
 USE EQUATES
 USE LIB.JMP
 USE VARS

 TYP $F4
 do M16PLUS-1
 DSK RUN/MODULES/FONT.EDITOR
 fin

 MODID "FONT.EDITOR"

START JSR PRINT
 HOME
 CURSOROFF
 BOX "Font Editor"
 NULL

TOP JSR PRINT
 NORMAL
 MTOFF
 GOTOXY 0;4
 CLEOS
 CURSORON
 ASC "[L]oad, [S]ave, [ESC]-exit; Edit font $"
 COLOR YELLOW
 HEX8 FONT
 COLOR WHITE
 NULL

]LOOP JSR KEYIN
 CMP #$9B
 BEQL EXIT
 CMP #"L"
 BEQ :LOAD
 CMP #$8D
 BEQ :GO
 CMP #"S"
 BEQL :SAVE
 CMP #"0"
 BCC ]LOOP
 CMP #"9"+1
 BCC :NUM
 CMP #"A"
 BCC ]LOOP
 CMP #"F"+1
 BCS ]LOOP
 SEC
 SBC #7
:NUM SEC
 SBC #"0"
 STA VTEMP
 LUP 4
 ASL FONT
 --^
 LDA FONT
 ORA VTEMP
 STA FONT
 JSR PRINT
 CURSORLEFT
 CURSORLEFT
 COLOR YELLOW
 HEX8 FONT
 COLOR WHITE
 NULL
 JMP ]LOOP
:GO LDA FONT
 CMP #$00 ;Print terminate char
 BEQ ]LOOP
 CMP #$80 ;Print command char
 BEQ ]LOOP
 JMP EDIT
:LOAD JSR PRINT
 CR
 COLOR PINK
 ASC "Load (y/N)? : "
 COLOR WHITE
 NULL
 JSR KEYIN
 JSR UPPER
 CMP #"Y"
 BNEL TOP
 JSR COUT
 JSR LOADFILE
 STR "TC2.FONT"
 DA FONTS
 ADRL 0
 CLC
 XCE
 REP #$30
 PushLong :FONTPNTR
 PushLong FONTLOC
 PushLong #$1000
 Tool $2B02 ;BlockMove
 JSR ERROR
 SEC
 XCE
 JMP TOP
:SAVE JSR PRINT
 CR
 COLOR PINK
 ASC "Save (y/N)? : "
 COLOR WHITE
 NULL
 JSR KEYIN
 JSR UPPER
 CMP #"Y"
 BNEL TOP
 JSR COUT
 CLC
 XCE
 REP #$30
 PushLong FONTLOC
 PushLong :FONTPNTR
 PushLong #$1000
 Tool $2B02 ;BlockMove
 JSR ERROR
 SEC
 XCE
 JSR SAVEFILE
 STR "TC2.FONT"
 DA FONTS
 ADRL 0
 JMP TOP
:FONTPNTR ADRL FONTS

EXIT RETURN

EDIT JSR PRINT
 GOTOXY 0;6
 CLEOS
 NULL
 CLC
 XCE
 REP #$30
 LDA FONTLOC
 STA CADD
 LDA FONTLOC+2
 STA CADD+2
 LDA FONT
 ASL
 ASL
 ASL
 ASL
 TAY
 LDX #0
]LOOP LDA [CADD],Y
 STA LOC,X
 INY
 INY
 INX
 INX
 CPX #16
 BNE ]LOOP
 SEC
 XCE
 LDY #0
]LOOP LDA LOC,Y
 STA TEMP
 LDA LOC+1,Y
 STA TEMP+1
 LDX #0
]LOOP2 ASL TEMP+1
 ROL TEMP
 BCS :ASTER
 LDA #"."
 HEX 2C
:ASTER LDA #"*"
 JSR COUT
 INX
 CPX #16
 BNE ]LOOP2
 JSR PRINT
 CR
 NULL
 INY
 INY
 CPY #16
 BNE ]LOOP
 LDA FONT
 STA :C1
 STA :C2
 STA :C2+1
 STA :C2+2
 STA :C3
 STA :C3+1
 STA :C3+2
 STA :C4
 STA :C4+1
 STA :C4+2
 JSR PRINT
 GOTOXY 30;6
:C2 LINE "???"
 HTAB 30
:C3 LINE "???"
 HTAB 30
:C4 LINE "???"
 GOTOXY 0;6
 NULL

 STZ XLOC
 STZ YLOC

]TOPLOOP LDA CH
 STA :PCV+2
 LDA CV
 STA :PCV+3
 JSR PRINT
 GOTOXY 25;6
:C1 ASC "?"
:PCV GOTOXY 0;0
 NULL

]LOOP JSR KEYIN
 CMP #$9B
 BEQL TOP
 CMP #"H"-$40
 BEQL LEFT
 CMP #"U"-$40
 BEQL RIGHT
 CMP #"K"-$40
 BEQL UP
 CMP #"J"-$40
 BEQL DOWN
 CMP #" "
 BNE ]LOOP
:SPACE CLC
 XCE
 REP #$30
 LDX XLOC
 LDA #%1000_0000_0000_0000
]LOOP2 CPX #0
 BEQ :DONE
 LSR
 DEX
 BRA ]LOOP2
:DONE STA VTEMP
 SEP #$20
 LDX VTEMP
 LDA VTEMP+1
 STA VTEMP
 STX VTEMP+1
 REP #$20
 LDA FONTLOC
 STA CADD
 LDA FONTLOC+2
 STA CADD+2
 LDA FONT
 ASL
 ASL
 ASL
 ASL
 CLC
 ADC YLOC
 ADC YLOC
 TAY
 LDA [CADD],Y
 AND VTEMP
 SEP #$20
 BEQ :ZERO
 LDA #"."
 HEX 2C
:ZERO LDA #"*"
 PHA
 REP #$20
 LDA [CADD],Y
 EOR VTEMP
 STA [CADD],Y
 SEC
 XCE
 PLA
 JSR COUT
 JSR PRINT
 CURSORLEFT
 NULL
 JMP ]TOPLOOP

LEFT LDA XLOC
 BNE :OK
 LDA #15
 STA XLOC
 JSR PRINT
 HTAB 15
 NULL
 JMP ]LOOP
:OK DEC XLOC
 JSR PRINT
 CURSORLEFT
 NULL
 JMP ]LOOP

RIGHT LDA XLOC
 CMP #15
 BCC :OK
 STZ XLOC
 JSR PRINT
 HTAB 0
 NULL
 JMP ]LOOP
:OK INC XLOC
 JSR PRINT
 CURSORRIGHT
 NULL
 JMP ]LOOP

UP LDA YLOC
 BNE :OK
 LDA #7
 STA YLOC
 JSR PRINT
 VTAB 13
 NULL
 JMP ]LOOP
:OK DEC YLOC
 JSR PRINT
 CURSORUP
 NULL
 JMP ]LOOP

DOWN LDA YLOC
 CMP #7
 BCC :OK
 STZ YLOC
 JSR PRINT
 VTAB 6
 NULL
 JMP ]LOOP
:OK INC YLOC
 JSR PRINT
 CURSORDOWN
 NULL
 JMP ]LOOP

FONT DS 2
TEMP DS 2
LOC DS 16*2

XLOC DS 2
YLOC DS 2

FONTS DS $1000

 LST ON
MODEND EQU *
 LST OFF

 do M16PLUS
 SAV RUN/MODULES/FONT.EDITOR
 fin

 END
