*-------------------------------
* GAME.ACTION
*-------------------------------
 DAT
 LST OFF

 ORG $8000 ;Always

 USE MACROS
 USE EQUATES
 USE VARS
 USE LIB.JMP
 USE PLR.DSECT
 USE ITEM.DSECT
 USE ITEM2.DSECT

 TYP $F4
 do M16PLUS-1
 DSK RUN/MODULES/GAME.ACTION
 fin

 MODID "GAME.ACTION"

START JSR PRINT
 GOTOXY 0;14
 CURSOROFF
 INVERSE
 COLOR YELLOW
 ZAPLINE
 COLOR WHITE
 NORMAL
 VTAB 14
 COLOR ORANGE
 CENTER " Action "
 CR
 COLOR WHITE
 NULL

START2 LDX NUMPARTY
]LOOP LDA CURPARTY2-1,X
 BNE :GOT1
 LDA CURPARTY-1,X
 BNE :GOT1
 DEX
 BNE ]LOOP
 DEATH
:GOT1 STX NUMP
]LOOP LDA CURPARTY2-1,X
 CMP MPLR+1
 BNE :NONO
 LDA CURPARTY-1,X
 CMP MPLR
 BNE :NONO
 STX DPLR
 BRA :MPLROK
:NONO DEX
 BNE ]LOOP
 DEATH

:MPLROK JSR GETMAST
 LDA PLRZPOS
 STA CURLVL

TOPBOT JSR CLRBOT
 JSR DRAWBOT

TOPNAME JSR GETMAST
 JSR PRINT
 GOTOXY 19;15
 CLEOL
 COLOR AQUAMARINE
 PRSTRING PLRNAME
 COLOR WHITE
 NULL
 LDX PLRXPOS
 LDY PLRYPOS
 LDA PLRZPOS
 JSR SHOWMAP
 JSR GETMAST

TOP JSR PRINT
 GOTOXY 68;12
 CLEOL
 CURSORON
 NULL
]LOOP JSR KEYIN
 JSR UPPER
 LDX :KEYS
]LOOP2 CMP :KEYS,X
 BEQ :GOTONE
 DEX
 BNE ]LOOP2
 BRA ]LOOP
:GOTONE DEX
 TXA
 ASL
 TAX
 JMP (:TABLE,X)

:KEYS DFB :ENDKEYS-*-1
 DFB $9B
 DFB "E"
 DFB "H"
 DFB "V"
 DFB "P"
 DFB "T"
 DFB "B"
 DFB "D"
:ENDKEYS

:TABLE DA EXIT
 DA EXIT
 DA HELP
 DA VIEW
 DA PRAY
 DA DRINK
 DA BURY
 DA DIG

BURY JSR PRINT
 ASC "B"
 NULL
 LDX #79
 LDY #79
 LDA #23
 JSR PICKLINE
 LDA $200
 STA :BCHAR
 STZ UPDATEFLAG
 JSR CLRSIDE
 LDA PLRCOND
 AND #%1100_1001 ;Can you physically move?
 BEQ :CANBURY
 JSR PRINT
 GOTOXY 0;21
 COLOR AQUAMARINE
 PRSTRING PLRNAME
 COLOR PINK
 ASC " is unable to bury anything."
 COLOR WHITE
 NULL
 JMP TOP
:CANBURY LDX PLRXPOS
 LDY PLRYPOS
 JSR GETMAP ;Get the shape
 LDX OKSHAPES
]LOOP CMP OKSHAPES,X
 BEQ :OK
 DEX
 BNE ]LOOP
 JSR PRINT
 GOTOXY 0;21
 ZAPLINE
 COLOR PINK
 ASC "Can't bury anything here."
 COLOR WHITE
 SOUND $13;1;$80
 NULL
 JMP TOP
:NOROOM JSR CLRBOT
 JSR PRINT
 COLOR PINK
 ASC "No room left to bury any more items. "
 COLOR WHITE
 SOUND $13;1;$80
 NULL
 GETRETURN
 JMP TOP
:OK LDX #7
]LOOP LDA PLRITEM,X
 BNE :OK2
 DEX
 BPL ]LOOP
 LDX #-1
:OK2 INX
 STX :MAX
 LDX #0
 LDA #0
 JSR LOADITEM2
 LDA ITEM2BUFF
 STA :MAXI2
 JSR CLRBOT
 JSR PRINT
 ASC "Gold : "
 COLOR YELLOW
 DEC32 PLRGOLD
 COLOR WHITE
 NULL
 STZ :I2CNTR

 LDA #<PLRITEM
 STA :I+2
 LDA #15
 STA :V+3
 LDX #1
]LOOP STX :TEMPX
 LDA PLRITEM-1,X
 BEQ :TOPLOOP
 JSR PRINT
:V GOTOXY 40;15
 DEC8 :TEMPX
 ASC ")"
:I PRITEM PLRITEM
 NULL
 INC :V+3
 INC :I+2
 INC :TEMPX
 LDX :TEMPX
 CPX #9
 BNE ]LOOP

:TOPLOOP JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 NULL
 LDA :MAX
 BEQ :GONLY
 JSR PRINT
 ASC "(1-"
 DEC8 :MAX
 ASC ")-item to bury, "
 NULL
:GONLY JSR PRINT
 ASC "[G]old, [ESC]-exit : "
 NULL
]LOOP JSR KEYIN
 JSR UPPER
 CMP #$9B
 BEQL :EXIT
 CMP #"G"
 BEQL :DOGOLD
 SEC
 SBC #"1"
 CMP :MAX
 BCS ]LOOP
 STA :ITEM
 TAX
 LDA PLRITEM,X
 TAX
 LDA #0
 JSR LOADITEM
 JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 ASC "Bury your "
 COLOR GREEN
 PRSTRING INAME
 COLOR WHITE
 ASC " (y/N)? : "
 NULL
 JSR KEYIN
 JSR UPPER
 CMP #"Y"
 BNEL :TOPLOOP
 JSR CHECK8 ;Check number of items buried on this square
 CMP #8
 BCSL :NOROOM
 JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 COLOR GREEN
 PRSTRING INAME
 COLOR WHITE
 ASC " buried. "
 NULL
 STZ IDATA
 STZ IDATA+1
 STZ IDATA+2
 STZ IDATA+3
 LDX :ITEM
 LDA PLRITEM,X
 JSR :DROPIT
 LDX :ITEM
]LOOP LDA PLRITEM+1,X
 STA PLRITEM,X
 LDA PLRITEMX+1,X
 STA PLRITEMX,X
 INX
 CPX #8
 BCC ]LOOP
 STZ PLRITEM+7
 STZ PLRITEMX+7
 JSR CALCPLR
 LDX MPLR
 LDA MPLR+1
 JSR SAVEPLR
 GETRETURN
 LDA #$FF
 STA UPDATEFLAG
 JMP :OK

:DOGOLD LDA PLRGOLD
 ORA PLRGOLD+1
 ORA PLRGOLD+2
 ORA PLRGOLD+3
 BNE :GOLD2
 JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 COLOR PINK
 ASC "You have no gold to bury. "
 COLOR WHITE
 NULL
 GETRETURN
 JMP :TOPLOOP
:GOLD2 JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 ASC "Enter amount to bury : "
 NULL
 GETLINE #10
 CPX #0
 BEQL :TOPLOOP
 JSR GETNUM
 STX :GOLD
 STY :GOLD+1
 LDA VTEMP
 STA :GOLD+2
 LDA VTEMP+1
 STA :GOLD+3

 LDA :GOLD
 ORA :GOLD+1
 ORA :GOLD+2
 ORA :GOLD+3
 BEQL :TOPLOOP

 LDX #3
]LOOP LDA :GOLD,X
 CMP PLRGOLD,X
 BEQ :MAYBE
 BCC :CANPAY
 BCS :CANTPAY
:MAYBE DEX
 BPL ]LOOP
 BRA :CANPAY

:CANTPAY JSR PRINT
 GOTOXY 0;23
 COLOR PINK
 ASC "You don't have that much gold. "
 COLOR WHITE
 SOUND $02;1;LOUD
 NULL
 GETRETURN
 JMP :TOPLOOP

:CANPAY CLC
 XCE
 REP #$30
 LDA PLRGOLD
 SEC
 SBC :GOLD
 STA PLRGOLD
 LDA PLRGOLD+2
 SBC :GOLD+2
 STA PLRGOLD+2
 SEC
 XCE
 JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 ASC "Buried "
 COLOR YELLOW
 DEC32 :GOLD
 COLOR WHITE
 ASC " gold. "
 NULL
 LDA #0 ;0=gold
 JSR :DROPIT
 LDX MPLR
 LDA MPLR+1
 JSR SAVEPLR
 GETRETURN
 JMP :OK

:EXIT LDA :BCHAR
 CMP #' '
 BNE :RR
 JSR PRINT
 GOTOXY 0;23
 INVERSE
 COLOR YELLOW
 ZAPLINE
 COLOR WHITE
 NORMAL
 NULL
:RR BIT UPDATEFLAG
 BPL :RR2
 LDA #$FF ;Draw player stats only
 STA VTEMP
 CALL "DRAW.SCREEN"
:RR2 JMP TOPBOT

:DROPIT LDX PLRZPOS
 BNE :DROPIT2
 RTS
:DROPIT2 PHA
]LOOP INC :I2CNTR
 LDA :I2CNTR
 CMP :MAXI2
 BEQ :DIOK
 BCS :ADD1
:DIOK LDX :I2CNTR
 LDA #0
 JSR LOADITEM2
 BIT IFREE
 BPL ]LOOP
:PUT1 PLA
 STA INUM
 STZ IFREE
 LDA #$FF
 STA IBURIED
 LDA PLRXPOS
 STA IXPOS
 LDA PLRYPOS
 STA IYPOS
 LDA PLRZPOS
 STA IZPOS
 LDA INUM
 BNE :NOTG
 LDX #3
]LOOP LDA :GOLD,X
 STA IDATA,X
 DEX
 BPL ]LOOP
:NOTG LDX :I2CNTR
 LDA #0
 JMP SAVEITEM2

:ADD1 INC :MAXI2
 LDA :MAXI2
 STA ITEM2BUFF
 STZ ITEM2BUFF+1
 LDX #0
 LDA #0
 JSR SAVEITEM2
 BRA :PUT1

:I2CNTR DS 2
:ITEM DS 2
:MAX DS 2
:MAXI2 DS 2
:TEMPX DS 1
:GOLD DS 4
:BCHAR DS 1

DIG JSR PRINT
 ASC "D"
 NULL
 JSR CLRSIDE
 LDA PLRCOND
 AND #%1100_1001 ;Can you physically move?
 BEQ :CANDIG
 JSR PRINT
 GOTOXY 0;21
 ZAPLINE
 COLOR AQUAMARINE
 PRSTRING PLRNAME
 COLOR PINK
 ASC " is unable to dig. "
 COLOR WHITE
 NULL
 JMP TOP
:CANDIG LDX PLRXPOS
 LDY PLRYPOS
 JSR GETMAP ;Get the shape
 LDX OKSHAPES
]LOOP CMP OKSHAPES,X
 BEQ :OK
 DEX
 BNE ]LOOP
 JSR PRINT
 GOTOXY 0;21
 ZAPLINE
 COLOR PINK
 ASC "Can't dig up anything here."
 COLOR WHITE
 SOUND $13;1;$80
 NULL
 JMP TOP
:OK JSR PRITEMS ;Display anything buried
 LDA CV
 CMP #15
 BNE :SOME
 JSR PRINT
 GOTOXY 0;21
 ZAPLINE
 COLOR YELLOW
 ASC "Nothing buried here."
 COLOR WHITE
 NULL
 JMP TOP
:SOME JSR PRINT
 SOUND $15;1;LOUD
 GOTOXY 0;22
 CURSORON
 ASC "Get item #"
 NULL
 GETLINE #1
 CPX #0
 BNE :OK2
 JSR PRINT
 ZAPLINE
 NULL
 JSR CLRSIDE
 JMP TOP
:OK2 JSR GETNUM
 STX :ITEM
 DEX
 CPX ICNTR
 BCC :GOTIT
 JSR PRINT
 ZAPLINE
 NULL
 JSR CLRSIDE
 JSR PRINT
 COLOR PINK
 ASC "Not that many items buried here."
 SOUND $02;1;$80
 COLOR WHITE
 NULL
 JMP TOP
:GOTIT LDA ITBL,X
 TAX
 LDA #0
 JSR LOADITEM2

 LDX #0
]LOOP LDA PLRITEM,X
 BEQ :PUT
 INX
 CPX #8
 BNE ]LOOP

 LDA INUM
 BEQ :PUT
 JSR PRINT
 ZAPLINE
 NULL
 JSR CLRSIDE
 JSR PRINT
 COLOR PINK
 ASC "Can't carry any more items."
 SOUND $13;1;$80
 COLOR WHITE
 NULL
 JMP TOP

:PUT LDA INUM
 BNE :ANITEM
 JSR PRINT
 ZAPLINE
 NULL
 JSR CLRSIDE
 JSR PRINT
 CURSORDOWN
 ASC "Gold taken : "
 COLOR YELLOW
 DEC32 IDATA
 COLOR WHITE
 NULL
 CLC
 XCE
 REP #$30
 LDA PLRGOLD
 CLC
 ADC IDATA
 STA PLRGOLD
 LDA PLRGOLD+2
 ADC IDATA+2
 STA PLRGOLD+2
 SEC
 XCE
 JMP :SAVP

:ANITEM STA PLRITEM,X
 PHX
 LDX INUM
 LDA #0
 JSR LOADITEM
 LDA PLRCLASS
 JSR CHECKUSE ;Can we use this item?
 BCC :USEOK
 LDA #2 ;Unusable
 HEX 2C
:USEOK LDA #0 ;Can use
 PLX
 STA PLRITEMX,X
 JSR PRINT
 ZAPLINE
 NULL
 JSR CLRSIDE
 JSR PRINT
 CURSORDOWN
 PRSTRING INAME
 ASC " taken"
 NULL
:SAVP LDX MPLR
 LDA MPLR+1
 JSR SAVEPLR
 LDA #$FF
 STA IFREE
 LDX :ITEM
 LDA ICNTR,X
 TAX
 LDA #0
 JSR SAVEITEM2 ;Tell database this item is 'gone'
 JMP TOP
:ITEM DS 1

*
* Random event will happen :
*
* 1 = Gain 1-6 HP
* 2 = Lose 1-6 HP
* 3 = Cure poison
* 4 = Poisoned
* 5 = Can't see (blinded)
* 6 = Can see (blindness cured)
* 7 = Randomly teleported (this level)
*
DRINK JSR PRINT
 ASC "T"
 NULL
 LDA PLRCOND
 AND #%1100_1001 ;Can you physically move?
 BEQ :CANDRINK
 JSR PRINT
 GOTOXY 0;21
 ZAPLINE
 COLOR AQUAMARINE
 PRSTRING PLRNAME
 COLOR PINK
 ASC " is unable to drink. "
 COLOR WHITE
 NULL
 JMP TOP
:CANDRINK LDX PLRXPOS
 LDY PLRYPOS
 JSR GETMAP
 CMP #SHPFOUNTAIN
 BEQ :FOUNT
 CMP #SHPWATER
 BEQ :WATER
 JSR PRINT
 GOTOXY 0;21
 ZAPLINE
 COLOR PINK
 ASC "Nothing to drink."
 COLOR WHITE
 NULL
 JMP TOP
:WATER JSR PRINT
 GOTOXY 0;21
 ZAPLINE
 COLOR YELLOW
 ASC "Yuk! The water is salty!"
 COLOR WHITE
 NULL
 JMP TOP
:FOUNT JSR CLRBOT
 JSR PRINT
 COLOR AQUAMARINE
 PRSTRING PLRNAME
 COLOR WHITE
 ASC " drinks from the fountain."
 PRPAUSE 2
 ASC "."
 PRPAUSE 2
 ASC "."
 PRPAUSE 4
 NULL
 RANDNUM #7
 DEX
 TXA
 ASL
 TAX
 JMP (:EVENTS,X)

:EVENTS DA :GAINHP ;Gain HP
 DA :LOSEHP ;Lose HP
 DA :NOPOISON ;Cure poison
 DA :POISON ;Poisoned
 DA :BLINDED ;Blinded
 DA :CANSEE ;Blindness cured
 DA :TELEPORT ;Teleported this level

:GAINHP LDA PLRHP
 CMP PLRHP+1
 BEQL :NOTHING
 RANDNUM #6
 STX VTEMP
 LDA PLRHP+1
 SEC
 SBC PLRHP
 STA VTEMP+1
 LDA VTEMP
 CMP VTEMP+1
 BCC :GAINOK
 LDA VTEMP+1
 STA VTEMP
:GAINOK JSR PRINT
 CR
 CR
 ASC "..and is healed by "
 COLOR YELLOW
 DEC8 VTEMP
 COLOR WHITE
 ASC " HP"
 SOUND $27;1;LOUD
 NULL
 LDA VTEMP
 CLC
 ADC PLRHP
 CMP PLRHP+1
 BCC :GAINOK2
 LDA PLRHP+1
:GAINOK2 STA PLRHP
 LDX MPLR
 LDA MPLR+1
 JSR SAVEPLR
 LDA #$FF ;Draw player stats only
 STA VTEMP
 CALL "DRAW.SCREEN"
 JMP :EXIT

:LOSEHP RANDNUM #6
 STX VTEMP
 JSR PRINT
 CR
 CR
 ASC "..and loses "
 COLOR YELLOW
 DEC8 VTEMP
 COLOR WHITE
 ASC " HP"
 SOUND $13;1;LOUD
 NULL
 LDA PLRHP
 SEC
 SBC VTEMP
 STA PLRHP
 DEC
 CMP #$80
 BCCL :LALIVE
 LDA PLRHP
 EOR #$FF
 INC
 STA :NEGHP
 CMP PLRHP+1 ;HP gone full negative?
 BCS :DEAD
 LDX #3
 JSR ROLLD6 ;Roll vs Health
 LDA VTEMP
 CMP :NEGHP
 BEQ :LALIVE
 BCC :LALIVE
:DEAD NOTELOGSTR $1;"Roll vs health failed.. Player died #";PLRNAME
 PNOTELOGSTR $1;"Party member died - ";PLRNAME
 JSR PRINT
 COLOR PINK
 ASC " and dies!"
 SOUND $0D;1;LOUD
 COLOR WHITE
 NULL
 LDA PLRCOND
 ORA #%1000_0000 ;Dead
 STA PLRCOND
 LDA #$FF
 STA PLRCONDX+7 ;Dead 'forever' (+7 coz it's bit 7)
:LALIVE LDX MPLR
 LDA MPLR+1
 JSR SAVEPLR
 LDA #$FF ;Draw player stats only
 STA VTEMP
 CALL "DRAW.SCREEN"
 JMP :EXIT
:NEGHP DS 1

:NOPOISON LDA PLRCOND
 AND #%0010_0000
 BEQL :NOTHING
 LDA #%0010_0000
 TRB PLRCOND
 STZ PLRCONDX+5
 JSR PRINT
 CR
 CR
 ASC "..and is cured of poison!"
 SOUND $27;1;LOUD
 NULL
 LDX MPLR
 LDA MPLR+1
 JSR SAVEPLR
 LDA #$FF ;Draw player stats only
 STA VTEMP
 CALL "DRAW.SCREEN"
 JMP :EXIT

:POISON LDA PLRCOND
 AND #%0010_0000
 BNEL :NOTHING
 LDA #%0010_0000
 TSB PLRCOND
 LDA #$FF
 STA PLRCONDX+5
 JSR PRINT
 CR
 CR
 ASC "..and is poisoned!"
 SOUND $13;1;LOUD
 NULL
 LDX MPLR
 LDA MPLR+1
 JSR SAVEPLR
 LDA #$FF ;Draw player stats only
 STA VTEMP
 CALL "DRAW.SCREEN"
 JMP :EXIT

:BLINDED LDA PLRCOND
 AND #%0000_0010
 BNEL :NOTHING
 LDA #%0000_0010
 TSB PLRCOND
 LDA #$FF
 STA PLRCONDX+1
 JSR PRINT
 CR
 CR
 ASC "..and is blinded!"
 SOUND $13;1;LOUD
 NULL
 LDX MPLR
 LDA MPLR+1
 JSR SAVEPLR
 LDA #$FF ;Draw player stats only
 STA VTEMP
 CALL "DRAW.SCREEN"
 JSR GETMAST
 LDX PLRXPOS
 LDY PLRYPOS
 LDA PLRZPOS
 JSR SHOWMAP
 JMP :EXIT

:CANSEE LDA PLRCOND
 AND #%0000_0010
 BEQL :NOTHING
 LDA #%0000_0010
 TRB PLRCOND
 STZ PLRCONDX+1
 JSR PRINT
 CR
 CR
 ASC "..and is cured of blindness!"
 SOUND $27;1;LOUD
 NULL
 LDX MPLR
 LDA MPLR+1
 JSR SAVEPLR
 LDA #$FF ;Draw player stats only
 STA VTEMP
 CALL "DRAW.SCREEN"
 JSR GETMAST
 LDX PLRXPOS
 LDY PLRYPOS
 LDA PLRZPOS
 JSR SHOWMAP
 JMP :EXIT

:TELEPORT STZ :CNTR
]LOOP INC :CNTR
 LDA :CNTR
 CMP #32
 BEQL :NOTHING
 RANDNUM #$10
 DEX
 STX :XGOTO
 RANDNUM #$10
 DEX
 STX :YGOTO
 LDX :XGOTO
 LDY :YGOTO
 JSR CHECKPOS
 BCS ]LOOP
 LDX PLRXPOS
 LDY PLRYPOS
 LDA #-1
 JSR PUTMAP2
 LDX :XGOTO
 LDY :YGOTO
 LDA #1
 JSR PUTMAP2
 LDX PLRZPOS
 LDA #0
 JSR SAVEMAP2
 LDA :XGOTO
 STA PLRXPOS
 LDA :YGOTO
 STA PLRYPOS
 JSR PRINT
 CR
 CR
 ASC "..and is teleported!"
 SOUND $09;1;LOUD
 NULL
 LDX MPLR
 LDA MPLR+1
 JSR SAVEPLR
 LDX PLRXPOS
 LDY PLRYPOS
 LDA PLRZPOS
 JSR SHOWMAP
 JMP :EXIT
:CNTR DS 1
:XGOTO DS 1
:YGOTO DS 1

:NOTHING JSR PRINT
 CR
 CR
 ASC "..and nothing happens."
 SOUND $25;1;LOUD
 NULL

:EXIT JSR PRINT
 GOTOXY 0;21
 CURSORON
 NULL
 GETRETURN
 JMP TOPBOT

PRAY JSR PRINT
 ASC "P"
 NULL
 LDA PLRCOND
 AND #%1100_1001 ;Can you physically move?
 BEQ :CANPRAY
 JSR PRINT
 GOTOXY 0;21
 COLOR AQUAMARINE
 PRSTRING PLRNAME
 COLOR PINK
 ASC " is unable to pray. "
 COLOR WHITE
 NULL
 JMP TOP
:CANPRAY LDX PLRXPOS
 LDY PLRYPOS
 JSR GETMAP
 CMP #SHPALTAR
 BEQ :ALTAR
 JSR PRINT
 GOTOXY 0;21
 ZAPLINE
 COLOR PINK
 ASC "No altar to pray."
 COLOR WHITE
 NULL
 JMP TOP
:ALTAR JSR CLRBOT
 JSR PRINT
 COLOR AQUAMARINE
 PRSTRING PLRNAME
 COLOR WHITE
 ASC " is praying.."
 NULL
 CALL "GAME.PRAY"
 LDX MPLR
 LDA MPLR+1
 JSR SAVEPLR
 JSR PRINT
 CURSOROFF
 VTAB 23
 COLOR PINK
 CENTER " [Press any key] "
 NULL
 JSR KEYIN
 JSR PRINT
 INVERSE
 COLOR YELLOW
 ZAPLINE
 COLOR WHITE
 NORMAL
 NULL
 JMP TOPBOT

VIEW JSR PRINT
 GOTOXY 68;12
 CLEOL
 ASC "View"
 GOTOXY 0;22
 ZAPLINE
 CURSORUP
 ZAPLINE
 CURSORON
 ASC "Change view to player (1-"
 DEC8 NUMP
 ASC ") : "
 NULL
]LOOP JSR KEYIN
 CMP #$9B
 BEQ :ESC
 SEC
 SBC #"1"
 CMP NUMP
 BCS ]LOOP
 TAX
 LDA CURPARTY,X
 STA MPLR
 LDA CURPARTY2,X
 STA MPLR+1
 INX
 STX DPLR
:ESC JSR PRINT
 ZAPLINE
 CURSOROFF
 NULL
 JSR GETMAST
 JMP TOPNAME

HELP JSR PRINT
 GOTOXY 68;12
 CLEOL
 ASC "Help"
 NULL
 JSR CLRBOT
 JSR GETFILE
 DFB 15,22 ;Use lines x to y
 STR "HELP/ACTION"
 JSR PRINT
 COLOR YELLOW
 CURSOROFF
 GOTOXY 0;23
 COLOR PINK
 CENTER " Press [RETURN] "
 NULL
]LOOP JSR KEYIN
 CMP #$8D
 BEQ :YEP
 CMP #$9B
 BNE ]LOOP
:YEP JSR PRINT
 INVERSE
 COLOR YELLOW
 ZAPLINE
 COLOR WHITE
 NORMAL
 NULL
 JMP TOPBOT

EXIT JSR PRINT
 GOTOXY 68;12
 CLEOL
 ASC "Exit"
 CURSOROFF
 NULL
 RETURN

GETMAST LDX MPLR
 LDA MPLR+1
 JSR LOADPLR ;Get party 'leader'
 LDA PLRZPOS
 CMP CURLVL
 BEQ :RTS
 STA CURLVL
 LDX CURLVL
 LDA #0
 JSR LOADMAP
 LDX CURLVL
 LDA #0
 JSR LOADMAP2
:RTS RTS

CLRBOT JSR PRINT
 GOTOXY 0;22
 LUP 7
 ZAPLINE
 CURSORUP
 --^
 ZAPLINE
 NULL
 RTS

DRAWBOT JSR PRINT
 GOTOXY 0;15
 CURSORON
 COLOR AQUAMARINE
 LINE " 7 8 9"
 LINE "  \|/"
 LINE " 4-x-6"
 LINE "  /|\"
 LINE " 1 2 3"
 COLOR WHITE
 GOTOXY 10;15
 ASC "[V]iew : "
 GOTOXY 10;16
 ASC "[B]ury   [D]ig"
 GOTOXY 10;17
 ASC "[P]ray   [T]aste/drink"
 GOTOXY 10;18
 ASC "[H]elp"
 GOTOXY 10;19
 ASC "[E]xit"
 CURSOROFF
 NULL
 RTS

CURLVL DS 1
NUMP DS 1 ;Actual people in party

DPLR DFB 1

CHECKPOS JSR GETMAP
 STA :SHAPE
 LDX #0
]LOOP LDA :SHAPE+1,X
 CMP #$FF
 BEQ :BAD
 CMP :SHAPE
 BEQ :SHPOK
 INX
 BRA ]LOOP
:BAD SEC
 RTS
:SHPOK CLC
 RTS
:SHAPE DS 1

:OKSHAPES DFB SHPSPACE,SHPSTAIRS,SHPDARK,SHPSIGN,SHPWATER,SHPHILLS
 DFB $FF

PRITEMS LDX #0
 LDA #0
 JSR LOADITEM2
 LDA ITEM2BUFF
 STA :ITEMS
 STZ ICNTR
 JSR CLRSIDE
]LOOP LDA :ITEMS
 BEQ :DONEI
 LDX :ITEMS
 LDA #0
 JSR LOADITEM2
 LDA IFREE
 BMI :NEXTI
 BIT IBURIED ;Not buried
 BPL :NEXTI
 LDA IZPOS
 CMP PLRZPOS
 BNE :NEXTI
 LDA IXPOS
 CMP PLRXPOS
 BNE :NEXTI
 LDA IYPOS
 CMP PLRYPOS
 BNE :NEXTI
 LDX INUM
 CPX #0
 BNE :NOTG
 LDX :GP
 STX INAME
]LOOP2 LDA :GP,X
 STA INAME,X
 DEX
 BNE ]LOOP2
 BRA :GCONT
:NOTG LDA #0
 JSR LOADITEM
:GCONT JSR :DOPR
 BCS :DONEI
 LDA ICNTR
 CMP #8
 BEQ :DONEI
:NEXTI DEC :ITEMS
 BRA ]LOOP
:DONEI RTS
:GP STR "gold"

:DOPR LDX ICNTR
 LDA :ITEMS
 STA ITBL,X
 INC ICNTR
 JSR PRINT
 HTAB 40
 DEC8 ICNTR
 ASC ") "
 PRSTRING INAME
 CR
 NULL
 LDA CV
 CMP #23
 RTS
:ITEMS DS 1

ICNTR DS 1
ITBL DS 8 ;Only 8 items can be buried per square..

CLRSIDE JSR PRINT
 GOTOXY 40;22
 CLEOL
 LUP 7
 CURSORUP
 CLEOL
 --^
 NULL
 RTS

OKSHAPES DFB :END-*-1
 DFB SHPSPACE,SHPFF,SHPSWAMP,SHPHILLS,SHPDARK
:END

CHECK8 STZ :TOTAL
 LDX #0
 LDA #0
 JSR LOADITEM2
 LDX ITEM2BUFF
]LOOP CPX #0
 BEQ :DONE
 PHX
 LDA #0
 JSR LOADITEM2
 BIT IFREE
 BMI :NEXTI
 BIT IBURIED
 BPL :NEXTI
 LDA IZPOS
 CMP PLRZPOS
 BNE :NEXTI
 LDA IXPOS
 CMP PLRXPOS
 BNE :NEXTI
 LDA IYPOS
 CMP PLRYPOS
 BNE :NEXTI
 INC :TOTAL
:NEXTI PLX
 DEX
 BRA ]LOOP
:DONE LDA :TOTAL
 RTS
:TOTAL DS 1

UPDATEFLAG DFB 0 ;Did anything change?

 LST ON
MODEND EQU *
 LST OFF

 do M16PLUS
 SAV RUN/MODULES/GAME.ACTION
 fin

 END
