*-------------------------------
* GAME.COMBAT (part 1)
*-------------------------------
 DAT
 LST OFF

 REL

 USE MACROS
 USE EQUATES
 USE VARS
 USE TABLES
 USE LIB.JMP
 USE PLR.DSECT
 USE MON.DSECT
 USE MON2.DSECT
 USE ITEM.DSECT
 USE ITEM2.DSECT
 USE SCEN.DSECT
 USE PN.DSECT

 do M16PLUS-1
 DSK GAME.COMBAT1.L
 fin

 EXT CHAR,LOGATTACK,PLOGATTACK,MLOGATTACK,ARRESTPRTY

 MODID "GAME.COMBAT"

START JSR PRINT
 GOTOXY 0;14
 CURSOROFF
 INVERSE
 COLOR YELLOW
 ZAPLINE
 NORMAL
 SOUND $23;FOREVER;$60
 VTAB 14
 COLOR ORANGE
 CENTER " Combat "
 COLOR YELLOW
 CR
 COLOR WHITE
 CURSORON
 NULL

START2 LDX NUMPARTY
]LOOP LDA CURPARTY2-1,X
 BNE :GOT1
 LDA CURPARTY-1,X
 BNE :GOT1
 DEX
 BNE ]LOOP
 DEATH
:GOT1 STX NUMP

 LDX #0
 LDA #0
 JSR LOADITEM
 LDA ITEMBUFF
 STA MAXITEMS

 LDX #0
 LDA #0
 JSR LOADITEM2
 LDA ITEM2BUFF
 STA IRECS

 LDX #0
 LDA #0
 JSR LOADSCEN
 LDX SCENBUFF
 STX SCENITEMS
]LOOP PHX
 LDA #0
 JSR LOADSCEN
 PLX
 LDA SCITEM
 STA SCENITEMS,X
 DEX
 BNE ]LOOP
 LDX SCENARIO
 LDA #0
 JSR LOADSCEN
 LDA SCMON2KILL
 STA SCENMON

ASKTOP JSR PRINT
 GOTOXY 0;15
 CURSORON
 COLOR AQUAMARINE
 LINE " 7 8 9"
 LINE "  \|/"
 LINE " 4-x-6"
 LINE "  /|\"
 LINE " 1 2 3"
 COLOR WHITE
 GOTOXY 10;15
 ASC "[V]iew : "
 GOTOXY 10;16
 ASC "[H]elp"
 GOTOXY 10;17
 ASC "[E]xit"
 NULL

ASK4IT JSR GETMAST

 LDA PLRXPOS
 SEC
 SBC #4
 STA ANKX
 LDA PLRYPOS
 SEC
 SBC #4
 STA ANKY

 LDA #4
 STA XLOC
 STA YLOC

 STZ CNTR

 LDX PLRXPOS
 LDY PLRYPOS
 LDA PLRZPOS
 JSR SHOWMAP
 JSR LOADMAST

ASKIT ENT
 LDX #1
 LDY #1
 LDA #15
 JSR PICKLINE
 LDA $200
 CMP #" "
 BEQL ASKTOP
 JSR PRINT
 GOTOXY 19;15
 CLEOL
 PRSTRING PLRNAME
 GOTOXY 10;19
 CURSORON
 ASC "Points left : "
 CLEOL
 NULL
 LDX #0
]LOOP PHX
 STX VTEMP
 LDA CURPARTY2,X
 TAY
 LDA CURPARTY,X
 TAX
 TYA
 JSR LOADPLR
 INC VTEMP
 JSR PRINT
 ASC "#"
 COLOR YELLOW
 DEC8 VTEMP
 COLOR WHITE
 MTON
 INVERSE
 ASC "I"
 NORMAL
 MTOFF
 COLOR PINK
 DEC8NEG PLRCURRPNTS
 COLOR WHITE
 NULL
 PLX
 INX
 CPX NUMP
 BEQ :PNTSOK
 JSR PRINT
 MTON
 INVERSE
 ASC "Z_"
 NORMAL
 MTOFF
 NULL
 BRA ]LOOP
:PNTSOK JSR LOADMAST
 JSR PRINT
 GOTOXY 10;18
 CLEOL
 ASC "[RETURN]-attack"
 GOTOXY 68;12
 CLEOL
 INVERSE
 ASC " "
 NORMAL
 CURSOROFF
 NULL

TOP JSR TICKTOCK
 JSR WAITIN
 BCS :YES2
 JSR GETLOC
 JSR DOSPC
 JSR WAITIN
 BCS :YES
 JSR GETLOC
 JSR DOSHP
 JMP TOP
:YES PHA
 JSR GETLOC
 JSR DOSHP
 PLA
 JMP GOTKEY
:YES2 PHA
 JSR GETLOC
 JSR DOSPC
 PLA
 BRA :YES

WAITIN STZ :FLAG
 STZ :CNTR
 STZ :CNTR2
]LOOP BIT DUMBTERM
 BMI :OVER
 JSR CHECKCTRLX
 JSR CHECKIN ;Did we get something from the modem?
 BCS :KEY
:OVER LDA $C000
 BMI :KEY
 BIT :FLAG
 BMI :MINUS
:PLUS LDA $C019
 BPL ]LOOP
 LDA #$FF
 STA :FLAG
 BRA ]LOOP
:MINUS LDA $C019
 BMI ]LOOP
 INC :CNTR
 LDA :CNTR
 BNE ]LOOP
 INC :CNTR2
 LDA :CNTR2
 CMP #16
 BNE ]LOOP
 CLC
 RTS
:KEY SEC
 RTS
:FLAG DS 1
:CNTR DS 1
:CNTR2 DS 1

GOTKEY STA $C010
 PHA
 JSR INITCNTR
 JSR PRINT
 MTOFF
 NORMAL
 COLOR WHITE
 NULL
 PLA
 JSR UPPER
 CMP #$8D
 BEQL ATTACK
 CMP #"A"
 BEQL ATTACK
 CMP #"V"
 BEQL VIEW
 CMP #"H"
 BEQL HELP
 CMP #"E"
 BEQL EXIT
 CMP #$9B
 BEQL EXIT
 CMP #"H"-$40
 BEQ :LEFT
 CMP #"U"-$40
 BEQ :RIGHT
 CMP #"K"-$40
 BEQ :UP
 CMP #"J"-$40
 BEQ :DOWN
 CMP #"W"-$40
 BEQ :REFRESH
 CMP #"1"
 BCCL TOP
 CMP #"9"+1
 BCSL TOP
:KEYUP SEC
 SBC #"1"
 ASL
 TAX
 LDA XLOC
 LDY YLOC
 JMP (:KEYS,X)

:REFRESH JSR REFRESH
 JMP TOP

:LEFT LDA #"4"
 BRA :KEYUP
:RIGHT LDA #"6"
 BRA :KEYUP
:UP LDA #"8"
 BRA :KEYUP
:DOWN LDA #"2"
 BRA :KEYUP

:KEYS DA KEY1
 DA KEY2
 DA KEY3
 DA KEY4
 DA KEY5
 DA KEY6
 DA KEY7
 DA KEY8
 DA KEY9

KEY1 DEC
 INY
 BRA DOKEY

KEY2 INY
 BRA DOKEY

KEY3 INC
 INY
 BRA DOKEY

KEY4 DEC
 BRA DOKEY

KEY5 JMP TOP

KEY6 INC
 BRA DOKEY

KEY7 DEC
 DEY
 BRA DOKEY

KEY8 DEY
 BRA DOKEY

KEY9 INC
 DEY
 BRA DOKEY

DOKEY CMP #9
 BCS :NOX
 STA XLOC
:NOX CPY #9
 BCS :NOY
 STY YLOC
:NOY JMP TOP

XLOC DS 1
YLOC DS 1
ANKX DS 1
ANKY DS 1
CNTR DS 1

ATTACK JSR PRINT
 GOTOXY 10;18
 CLEOL
 GOTOXY 0;22
 ZAPLINE
 CURSORUP
 ZAPLINE
 CURSORON
 NULL
 LDX XLOC
 LDY YLOC
 JSR GETGRID
 CMP #$FF
 BEQ :NOSEE
 LDA ANKX
 CLC
 ADC XLOC
 STA X
 STA ATOX
 CMP #$10
 BCS :NOSEE
 LDA ANKY
 CLC
 ADC YLOC
 STA Y
 STA ATOY
 CMP #$10
 BCC :SEEOK
:NOSEE JSR PRINT
 COLOR PINK
 ASC "You cannot attack that square"
 COLOR WHITE
 NULL
 JMP ASKIT
:SEEOK LDX X
 LDY Y
 JSR GETMAP2
 STA SQUARE
 BNE :YEHOK
:NOTHING JSR PRINT
 GOTOXY 0;21
 COLOR PINK
 ASC "Nothing there to attack"
 COLOR WHITE
 NULL
 JMP ASKIT
:YEHOK LDA MPLR
 STA ATTACKER
 LDA MPLR+1
 STA ATTACKER+1
 LDX ATTACKER
 LDA ATTACKER+1
 JSR LOADPLR
 LDA PLRZPOS
 STA LEVEL

 LDX PLRXPOS
 LDY PLRYPOS
 JSR GETMAP
 CMP #SHPSAFETY
 BNE :CANDO
:INZONE JSR PRINT
 COLOR PINK
 ASC "You can't attack whilst on "
 COLOR AQUAMARINE
 ASC "holy ground"
 COLOR WHITE
 NULL
 JMP ASKIT
:CANDO
* CMP #SHPSTAIRS
* BNE :CANDO2
* CPX #STAIRSUP
* BNE :CANDO2
* LDA LEVEL
* CMP #1
* BEQ :INZONE
*:CANDO2

 LDA PLRXPOS
 SEC
 SBC X
 BCS :DOY
 EOR #$FF
 INC
:DOY STA TEMP
 LDA PLRYPOS
 SEC
 SBC Y
 BCS :POK
 EOR #$FF
 INC
:POK CMP TEMP
 BCS :TAKEY
 LDA TEMP
:TAKEY STA RANGE

 JSR PRINT
 GOTOXY 0;21
 NULL
 LDA PLRCURRPNTS
 DEC
 BPL :PNTSOK
 JSR PRINT
 COLOR PINK
 ASC "Not enough points"
 SOUND $13;1;LOUD
 COLOR WHITE
 NULL
 JMP ASKIT
:PNTSOK LDA PLRCOND
 AND #%1100_1001 ;Can u move?
 BEQ :FINE
 JSR PRINT
 COLOR PINK
 ASC "Unable to attack"
 SOUND $13;1;LOUD
 COLOR WHITE
 NULL
 JMP ASKIT
:FINE JSR PRINT
 GOTOXY 10;18
 CLEOL
 ASC "Attack "
 COLOR YELLOW
 PAD2 X
 ASC ","
 PAD2 Y
 COLOR WHITE
 ASC " (y/n)? : "
 NULL
]LOOP JSR KEYIN
 JSR UPPER
 CMP #"Y"
 BEQ :YES
 CMP #"N"
 BNE ]LOOP
 JSR PRINT
 ASC "N"
 NULL
 JMP ASKIT
:YES JSR PRINT
 ASC "Y"
 GOTOXY 0;21
 ZAPLINE
 NULL
 LDX X
 LDY Y
 JSR GETMAP
 CMP #SHPSAFETY
 BNE :NOZONE
:INZONE2 JSR PRINT
 COLOR PINK
 ASC "You can't attack anything on "
 COLOR AQUAMARINE
 ASC "holy ground"
 COLOR WHITE
 NULL
 JMP ASKIT
:NOZONE
* CMP #SHPSTAIRS
* BNE :NOZONE2
* CPX #STAIRSUP
* BNE :NOZONE2
* LDA LEVEL
* CMP #1
* BEQ :INZONE2
*:NOZONE2
 LDA SQUARE
 AND #$0F
 BEQ :M
 LDA SQUARE
 AND #$F0
 BEQL :P
 LDA SQUARE
 AND #%0000_1111
 CMP #1
 BNE :BOTH
 LDA X
 CMP PLRXPOS
 BNE :BOTH
 LDA Y
 CMP PLRYPOS
 BNE :BOTH
 JMP :M
:BOTH JSR PRINT
 GOTOXY 10;18
 ASC "Attack Monsters or Persons (m/p)? : "
 NULL
]LOOP JSR KEYIN
 JSR UPPER
 CMP #$9B
 BEQ :ESCA
 CMP #"M"
 BEQ :MPR
 CMP #"P"
 BNE ]LOOP
 JSR COUT
 BRA :P
:ESCA JSR PRINT
 GOTOXY 10;18
 CLEOL
 NULL
 JMP ASKIT

:MPR JSR COUT
:M LDA #0
 HEX 2C
:P LDA #$FF
 STA MISCBUFF+3 ;00=monster, FF=player
 STA :WHAT
 LDA X
 STA MISCBUFF
 LDA Y
 STA MISCBUFF+1
 LDA LEVEL
 STA MISCBUFF+2
 STZ MISCBUFF+4 ;Not on own party
 CALL "ATTACK.MOD"
 JSR LOADMAST
 LDA MISCBUFF+3
 BMIL :NOTHING
 CMP #$7F
 BEQL ASKIT
 LDA :WHAT ;00=monster, FF=player
 BPL :GOTMON
 JMP CHAR

:WHAT DS 1

:GOTMON LDA VTEMP
 STA VICTIM
 LDA VTEMP+1
 STA VICTIM+1
 LDX ATTACKER
 LDA ATTACKER+1
 JSR LOADPLR
 LDA #7
 STA TEMP
]LOOP LDX TEMP
 LDA PLRITEM,X
 TAX
 LDA #0
 JSR LOADITEM
 LDA ITYPE
 CMP #1 ;A weapon
 BNE :WNEXTM
 LDX TEMP
 LDA PLRITEMX,X
 CMP #1 ;Equipped?
 BEQ :GOTWEAPM
:WNEXTM DEC TEMP
 LDA TEMP
 BPL ]LOOP
 LDA #1 ;Make weapon into a 'fist' (for punching)
 STA IDAT1 ;Dam amount
 LDA #-2
 STA IDAT2 ;Dam modifier
 LDA #0
 STA IDAT3 ;Skill level
 LDA #3
 STA IDAT4 ;Dam type (cr)
 LDA #0
 STA IDAT5 ;Range
:GOTWEAPM LDA RANGE
 CMP IDAT5 ;Range
 BEQ :RANGEOKM
 BCC :RANGEOKM
 JSR PRINT
 COLOR PINK
 ASC "Out of range.."
 COLOR WHITE
 NULL
 JMP ASKIT

:RANGEOKM LDX VICTIM
 LDA VICTIM+1
 JSR LOADMON2
 LDX MON2BUFF
 LDA #0
 JSR LOADMON
 RANDNUM #2
 CPX #2
 BEQ :ASND2
:ASND1 JSR PRINT
 SOUND $16;1;LOUD
 NULL
 BRA :RNGNAME
:ASND2 JSR PRINT
 SOUND $17;1;LOUD
 NULL
:RNGNAME LDA MLEVEL
 BNE :NOG
 JSR PRINT
 COLOR AQUAMARINE
 NULL
 BRA :OAH
:NOG JSR PRINT
 COLOR ORANGE
 NULL
:OAH JSR PRINT
 PRSTRING MNAME
 COLOR WHITE
 ASC " "
 NULL
* JSR MLOGATTACK

 LDX ATTACKER
 LDA ATTACKER+1
 JSR LOADPLR
 CLC ;Add exp for attacking
 XCE
 REP #$30
 LDA PLRZPOS ;Exp = exp + (map level * 2)
 AND #$FF
 ASL
 CLC
 ADC PLREXP
 STA PLREXP
 LDA PLREXP+2
 ADC #0
 STA PLREXP+2
 SEC
 XCE
 DEC PLRCURRPNTS ;Subtract 1 action point
 LDA #%0001_0000
 TRB PLRCOND ;Become 'visible' if you attack
 LDX ATTACKER
 LDA ATTACKER+1
 JSR SAVEPLR

 LDA PLRDX
 CLC
 ADC IDAT3 ;Weapon skill
 ADC #2 ;DX+2
 STA SKILL ;Effective skill
 BIT PLRARRESTFLAG ;Under arrest?
 BPL :NOARR
 LDA SKILL
 SEC
 SBC #4
 BCS :ARROK
 LDA #1
:ARROK STA SKILL

:NOARR LDA PLRCLASS ;Attack bonus for elite
 CMP #1 ;Fighter
 BEQ :NC0
 CMP #5
 BCC :NC1
 INC SKILL
 CMP #5 ;Ninja
 BEQ :NC0
 CMP #9 ;Lord
 BNE :NC1
 INC SKILL
:NC0 INC SKILL

:NC1 LDA MCOND
 AND #%0100_1001 ;Paralyzed, asleep, stunned?
 BEQ :NC2
 INC SKILL
 INC SKILL
 JMP :DD2M
:NC2 LDA MCOND
 AND #%0000_0010 ;Blind?
 BEQ :NC3
 INC SKILL
:NC3 LDA MCOND
 AND #%0000_0100 ;Levitating?
 BEQ :NC4
 LDA SKILL
 SEC
 SBC #2
 STA SKILL
:NC4
 STZ DDAMAGE
 LDX #3
 JSR ROLLD6 ;Get Attack Roll (3d6)
 LDA VTEMP ;If roll <= SKILL then HIT
 CMP #3 ;Critical success (3 or 4)
 BEQ :DD1M ; hits automatically
 CMP #4
 BEQ :DD2M
 CMP SKILL
 BEQ :AOKM
 BCC :AOKM
 JMP :MISS
:DD1M LDA #3 ;Triple damage
 HEX 2C
:DD2M LDA #2 ;Double damage
 STA DDAMAGE
 JMP :HIT2M

:AOKM LDX VICTIM
 LDA VICTIM+1
 JSR LOADMON2
 LDX MON2BUFF
 LDA #0
 JSR LOADMON
 LDA MPD
 STA PD
 LDA MDR
 STA DR

 LDA PD
 CLC
 ADC MSPEED
 STA PD

 LDA PLRCLASS
 CMP #5 ;Ninja
 BNE :NOC
 DEC PD
:NOC LDA PLRCLASS
 CMP #9 ;Lord
 BNE :NOC2
 DEC PD

:NOC2 LDX #3
 JSR ROLLD6 ;Calculate Defense Roll (3d6)
 LDA VTEMP ;If roll <= PD then BLOCKED
 CMP PD ;else HIT
 BEQ :BLM
 BCS :HIT2M
:BLM JMP :BLOCKED

:HIT2M LDX ATTACKER
 LDA ATTACKER+1
 JSR LOADPLR
 LDA IDAT1 ;Dam amount (thr or sw)
 CMP #1
 BEQ :SWINGM
 CMP #2
 BEQ :THRUSTM
 RANDNUM #2
 STX IDAT1
 BRA :HIT2M
:THRUSTM LDA PLRST
 STA ATTACKST
 LDA PLRCLASS
 CMP #5 ;Ninja
 BNE :NNOC
 INC ATTACKST
:NNOC CMP #9 ;Lord
 BNE :NNOC2
 INC ATTACKST
:NNOC2 LDA ATTACKST
 DEC
 ASL
 TAX
 LDA DAMTHRUST,X ;Dam = xd+y (eg; 1d-2)
 STA DIEDAM
 LDA DAMTHRUST+1,X
 STA DAMMOD
 BRA :CONT2M
:SWINGM LDA PLRST
 STA ATTACKST
 LDA PLRCLASS
 CMP #5 ;Ninja
 BNE :N2NOC
 INC ATTACKST
:N2NOC CMP #9 ;Lord
 BNE :N2NOC2
 INC ATTACKST
:N2NOC2 LDA ATTACKST
 DEC
 ASL
 TAX
 LDA DAMSWING,X ;Dam = xd+y (eg; 1d-2)
 STA DIEDAM
 LDA DAMSWING+1,X
 STA DAMMOD
:CONT2M LDA DAMMOD
 CLC
 ADC IDAT2
 STA DAMMOD
 LDX DIEDAM
 JSR ROLLD6 ;Calc dam
 LDA VTEMP
 CLC
 ADC DAMMOD
 STA VTEMP
 LDA MCOND
 AND #%0000_1000 ;Asleep?
 BEQ :AWAKE
 ASL VTEMP ;Damage x 2!
:AWAKE LDX PLRLVLREAL ;Extra damage per experience level
 LDA :EXTRADAM-1,X
 TAX
 LDA #0
 JSR RANDOM
 TXA
 CLC
 ADC VTEMP
 SEC
 SBC DR ;Subtract DR
 STA DAMAGE
 DEC
 CMP #$80
 BCC :HIT3M
 JMP :REFLECTED ;Hit bounced off armour

:HIT3M LDA DDAMAGE ;Critical success?
 BEQ :DAMTM
 TAX
 LDA DAMAGE
]LOOP CLC ;Multiply dam by 2 or 3
 ADC DAMAGE
 DEX
 CPX #1
 BNE ]LOOP
 STA DAMAGE
:DAMTM LDA IDAT4 ;Dam type
 CMP #1
 BEQ :IMPALEM
 CMP #3 ;Crush (no dam bonus)
 BEQ :CONT22M
:CUTM LDA DAMAGE ;Dam inc by 50%
 LSR
 CLC
 ADC DAMAGE
 STA DAMAGE
 BRA :CONT22M
:IMPALEM LDA DAMAGE ;Dam x 2 (inc by 100%)
 CLC
 ADC DAMAGE
 STA DAMAGE
:CONT22M JSR PRINT
 ASC "is hit for "
 COLOR PINK
 DEC8 DAMAGE
 COLOR WHITE
 ASC " damage.."
 NULL
 JSR RANDHITSND
* PNOTELOGNUM $D;"Monster took damage (HP) - ";DAMAGE
 LDX VICTIM
 LDA VICTIM+1
 JSR LOADMON2
 LDA MCURHP ;Subtract dam
 SEC
 SBC DAMAGE
 STA MCURHP
 PHP
 LDX VICTIM
 LDA VICTIM+1
 JSR SAVEMON2
 PLP
 BEQ :ZDEAD
 BCSL :ALIVEM
:ZDEAD JSR PRINT
 COLOR PINK
 ASC " and dies!"
 COLOR WHITE
 NULL
 LDA MTYPE
 CMP SCENMON
 BEQ :DWITEM
 LDA MLEVEL ;A guardian will always drop a key
 BEQ :DWITEM
 LDA MTREASURE
 BNE :DWITEM
 JSR PRINT
 SOUND $0D;1;LOUD
 NULL
 BRA :DOMCOND
:DWITEM JSR PRINT
 SOUND $0E;1;LOUD
 NULL
* PNOTELOG $1;"..and is killed!"
:DOMCOND LDA MCOND
 ORA #%1000_0000
 STA MCOND
 LDA #$FF
 STA MCONDX+7
 LDA MARRESTCHAR
 ORA MARRESTCHAR+1
 BEQ :NOCHAR
 LDX MARRESTCHAR
 LDA MARRESTCHAR+1
 JSR LOADPLR
 LDA #%1000_0000
 TRB PLRARRESTFLAG
 LDX MARRESTCHAR
 LDA MARRESTCHAR+1
 JSR SAVEPLR
 LDA PARTYNUM
 STA ARRESTPRTY
 LDX ATTACKER
 LDA ATTACKER+1
 JSR LOADPLR

 STZ MARRESTCHAR
 STZ MARRESTCHAR+1

:NOCHAR LDX VICTIM
 LDA VICTIM+1
 JSR SAVEMON2

 LDX MXPOS
 LDY MYPOS
 LDA #$FF
 JSR PUTMAP2M
 LDX MAPLVL
 LDA #0
 JSR SAVEMAP2

 LDX VICTIM
 LDA VICTIM+1
 JSR LOADMON2

 LDX #3
]LOOP STZ GOLD,X
 DEX
 BPL ]LOOP

 LDX #15
]LOOP STZ ITEMS,X
 DEX
 BPL ]LOOP

 JSR PRINT
 SOUND $27;1;LOUD
 NULL

 LDA MTYPE
 CMP SCENMON
 BNEL :NOTC
 JSR GETITEM
 STZ IFREE
 STZ IBURIED
 LDX SCENARIO
 LDA SCENITEMS,X
 STA INUM
 LDA MXPOS
 STA IXPOS
 LDA MYPOS
 STA IYPOS
 LDA MAPLVL
 STA IZPOS
 STZ IDATA
 STZ IDATA+1
 STZ IDATA+2
 STZ IDATA+3
 JSR SAVEI
 LDX SCENARIO
 LDA #$FF
 STA M2KILLDEAD-1,X
 JSR SAVEVARS
 NOTELOGSTR $1;"Monster to kill is dead - ";MNAME
 NOTELOGSTR $1;"Killed by ";PLRNAME
 JMP :FIXI

:GUARD LDA #1 ;Drop a key (when Guardian dies)
 STA :ITEMS
 STZ :GREC
]LOOP LDA :GREC
 CMP MAXITEMS
 BEQ :NOTC2 ;No key..
 INC :GREC
 LDX :GREC
 LDA :GREC+1
 JSR LOADITEM
 LDA ITYPE
 CMP #6 ;Misc?
 BNE ]LOOP
 LDA IDAT1
 CMP #4 ;Key?
 BNE ]LOOP
 LDX :ITEMS
 LDA :GREC
 STA ITEMS-1,X
 LDA MTREASURE
 BRA :NOTC3

:GREC DS 2

:NOTC LDA MLEVEL
 BEQ :GUARD
:NOTC2 LDA MTREASURE
 BEQL :DOEXP
:NOTC3 AND #%0000_1111
 BEQ :DOITEM
 ASL
 ASL
 TAX
 LDY #0
]LOOP LDA TREASURE,X
 STA GOLD,Y
 INX
 INY
 CPY #4
 BNE ]LOOP

:DOITEM LDA MTREASURE
 AND #%1111_0000
 BEQ :GOITEMS
 LSR
 LSR
 LSR
 LSR
 STA :ITEMS
 LDA MAPLVL
 ASL
 ASL
 ASL
 ASL
 CMP MAXITEMS
 BCC :XITOK
 LDA MAXITEMS
:XITOK STA :RND
]LOOP LDX :RND
 LDA #0
 JSR RANDOM
 TXA
 LDX SCENITEMS
]LOOP2 CMP SCENITEMS,X
 BEQ :NEXTI
 DEX
 BNE ]LOOP2
 LDX :ITEMS
 STA ITEMS-1,X
:NEXTI DEC :ITEMS
 LDA :ITEMS
 BNE ]LOOP

:GOITEMS LDX #3
]LOOP LDA GOLD,X
 BNE :YESG
 DEX
 BPL ]LOOP
 BRA :GOITEMS2
:YESG JSR GETITEM
 STZ IFREE
 STZ IBURIED
 LDA #0 ;Gold
 STA INUM
 LDA MXPOS
 STA IXPOS
 LDA MYPOS
 STA IYPOS
 LDA MAPLVL
 STA IZPOS
 LDX GOLD
 LDA GOLD+1
 JSR RANDOM
 STX IDATA
 STA IDATA+1
 STZ IDATA+2
 STZ IDATA+3
 JSR SAVEI

:GOITEMS2 LDX #15
 STX :ITEMS
]LOOP LDX :ITEMS
 LDA ITEMS-1,X
 BEQ :NXTI
 JSR GETITEM
 LDX :ITEMS
 STZ IFREE
 STZ IBURIED
 LDA ITEMS-1,X
 STA INUM
 LDA MXPOS
 STA IXPOS
 LDA MYPOS
 STA IYPOS
 LDA MAPLVL
 STA IZPOS
 LDX #3
]LOOP2 STZ IDATA,X
 DEX
 BPL ]LOOP2
 JSR SAVEI
:NXTI DEC :ITEMS
 LDA :ITEMS
 BNE ]LOOP

:FIXI LDA IRECS ;Update Maze Items (total)
 STA ITEM2BUFF
 STZ ITEM2BUFF+1
 LDX #0
 LDA #0
 JSR SAVEITEM2

:DOEXP LDX NUMPARTY
 LDY #0
]LOOP PHX
 PHY
 LDA CURPARTY-1,X
 TAY
 LDA CURPARTY2-1,X
 TYX
 CMP #0
 BNE :L21
 CPX #0
 BEQ :PNXT
:L21 JSR LOADPLR
 LDA PLRZPOS
 CMP MAPLVL
 BNE :PNXT
 LDA PLRCOND
 AND #%1100_1001 ;Dead, paralyzed, asleep, stunned?
 BNE :PNXT
 PLY
 INY
 PHY
:PNXT PLY
 PLX
 DEX
 BNE ]LOOP

 STY :DIVISOR
 CLC
 XCE
 REP #$30
 PushLong #0
 PushLong #0
 PushLong MEXPKILL
 PushLong :DIVISOR
 Tool $0D0B ;LongDivide
 PullLong :EXP
 PLA ;Remainder
 PLA
 SEC
 XCE

 LDX #0 ;Add exp to party
]LOOP PHX
 LDA CURPARTY,X
 TAY
 LDA CURPARTY2,X
 TYX
 CMP #0
 BNE :L2
 CPX #0
 BEQ :PNEXT2
:L2 JSR LOADPLR
 LDA PLRZPOS
 CMP MAPLVL
 BNE :PNEXT2
 LDA PLRCOND
 AND #%1100_1001 ;Dead, paralyzed, asleep, stunned?
 BNE :PNEXT2
 CLC
 XCE
 REP #$30
 LDA PLREXP
 CLC
 ADC :EXP
 STA PLREXP
 LDA PLREXP+2
 ADC :EXP+2
 STA PLREXP+2
 SEC
 XCE
 PLX
 PHX
 LDA CURPARTY,X
 TAY
 LDA CURPARTY2,X
 TYX
 JSR SAVEPLR
:PNEXT2 PLX
 INX
 CPX NUMPARTY
 BNE ]LOOP
 JSR PRINT
 ASC " Party gets "
 COLOR YELLOW
 DEC32 :EXP
 COLOR WHITE
 ASC " exp. each"
 SOUND $15;1;LOUD
 NULL
 JSR LOGATTACK
 LDA XLOC
 ASL
 CLC
 ADC #4
 STA :MCH+2
 LDA YLOC
 CLC
 ADC #2
 STA :MCH+3
 JSR PRINT
:MCH GOTOXY 0;0
 NULL
 LDX ATTACKER
 LDA ATTACKER+1
 JSR LOADPLR
 LDA #%0001_0000
 TRB PLRCOND ;Become 'visible' if you attack
 LDX ATTACKER
 LDA ATTACKER+1
 JSR SAVEPLR
 LDX X
 LDY Y
 JSR GETMAP
 JSR DRAWBLOK
 LDA #$FF
 STA VTEMP
 LDA #$7F
 STA VTEMP+1
 CALL "GAME.CHKEXP"
 JMP ASK4IT

:ALIVEM JSR LOGATTACK
 JMP ASKIT

:MISS JSR PRINT
 ASC "missed.."
 NULL
 LDA MTYPE
 CMP SCENMON
 BNE :MISSN
 JSR PRINT
 SOUND $0A;1;LOUD
 NULL
 BRA :MISS2
:MISSN JSR PRINT
 SOUND $09;1;LOUD
 NULL
:MISS2 JSR LOGATTACK
* PNOTELOG $D;"Missed.."
 JMP ASKIT

:BLOCKED JSR PRINT
 ASC "blocked the attack.."
 SOUND $0C;1;LOUD
 NULL
 JSR LOGATTACK
* PNOTELOG $D;"Attack blocked.."
 JMP ASKIT

:REFLECTED JSR PRINT
 ASC "is hit; blow reflected.."
 SOUND $0B;1;LOUD
 NULL
 JSR LOGATTACK
* PNOTELOG $D;"Blow reflected.."
 JMP ASKIT

:EXP DS 4 ;Exp for each plr in party
:DIVISOR DS 4 ;Used to calc :EXP
:RND DS 1 ;For rnd item (treasure)
:ITEMS DS 1
:EXTRADAM DFB 0,1,1,2 ;Levels 1-4  (extra damage)
 DFB 2,3,3,4 ;       5-7
 DFB 4,5,5,6 ;       8-11
 DFB 6,7,7,8 ;       12-16

ATTACKER ENT
 DS 2
VICTIM ENT
 DS 4
SKILL ENT
 DS 1 ;Effective skill of attacker
PD ENT
 DS 1 ;Passive defence of Victim
DR ENT
 DS 1 ;Dam resistance of Victim
DIEDAM ENT
 DS 1 ;(x) Damage = xd+y (eg; 1d-2)
DAMMOD ENT
 DS 1 ;(y)
DAMAGE ENT
 DS 4
X ENT
 DS 1 ;Square being attacked
Y ENT
 DS 1
SQUARE ENT
 DS 1 ;Chars/mons this square (MAP2)
RANGE ENT
 DS 1 ;Distance - party to VICTIM
DDAMAGE ENT
 DS 1 ;Double/triple dam

HELP JSR PRINT
 GOTOXY 68;12
 CLEOL
 ASC "Help"
 NULL
 JSR CLRBOT
 JSR GETFILE
 DFB 15,22
 STR "HELP/COMBAT"
 JSR PRINT
 COLOR YELLOW
 CURSOROFF
 GOTOXY 0;23
 COLOR PINK
 CENTER " Press [RETURN] "
 COLOR WHITE
 NULL
]LOOP JSR KEYIN
 CMP #$8D
 BEQ :YEP
 CMP #$9B
 BNE ]LOOP
:YEP JSR PRINT
 INVERSE
 COLOR YELLOW
 ZAPLINE
 COLOR WHITE
 NORMAL
 NULL
 JSR CLRBOT
 JMP START2

VIEW JSR PRINT
 GOTOXY 0;22
 ZAPLINE
 CURSORUP
 ZAPLINE
 CURSORON
 ASC "Change view to player (1-"
 DEC8 NUMP
 ASC ") : "
 NULL
]LOOP JSR KEYIN
 CMP #$9B
 BEQ :ESC
 SEC
 SBC #"1"
 CMP NUMP
 BCS ]LOOP
 TAX
 LDA CURPARTY,X
 STA MPLR
 LDA CURPARTY2,X
 STA MPLR+1
 JSR PRINT
 ZAPLINE
 CURSOROFF
 NULL
 JMP ASK4IT
:ESC JSR PRINT
 ZAPLINE
 CURSOROFF
 NULL
 JMP ASKIT

EXIT JSR PRINT
 GOTOXY 68;12
 CLEOL
 ASC "Exit"
 CURSOROFF
 NULL
 RETURN

GETMAST JSR LOADMAST
 LDA PLRZPOS
 CMP MAPLVL
 BEQ :SAME
 STA MAPLVL
 LDX MAPLVL
 LDA #0
 JSR LOADMAP
 LDX MAPLVL
 LDA #0
 JSR LOADMAP2
:SAME RTS

* Damage amount table (thr)
DAMTHRUST ENT
 DFB 0,0 ;1
 DFB 0,0 ;2
 DFB 0,0 ;3
 DFB 0,0 ;4
 DFB 1,-5 ;5
 DFB 1,-4 ;6
 DFB 1,-3 ;7
 DFB 1,-3 ;8
 DFB 1,-2 ;9
 DFB 1,0 ;10
 DFB 1,1 ;11
 DFB 1,1 ;12
 DFB 1,2 ;13
 DFB 1,2 ;14
 DFB 1,3 ;15
 DFB 1,3 ;16
 DFB 1,4 ;17
 DFB 2,2 ;18
 DFB 2,4 ;19
 DFB 3,2 ;20
 DFB 4,4 ;20+1  ST cannot go this high, but can be used if
 DFB 5,6 ;20+2  the player is a Ninja or a Lord

* Damage amount table (swing)
DAMSWING ENT
 DFB 0,0 ;1
 DFB 0,0 ;2
 DFB 0,0 ;3
 DFB 0,0 ;4
 DFB 1,-5 ;5
 DFB 1,-4 ;6
 DFB 1,-3 ;7
 DFB 1,-2 ;8
 DFB 1,-1 ;9
 DFB 1,0 ;10
 DFB 1,1 ;11
 DFB 1,2 ;12
 DFB 2,0 ;13
 DFB 2,1 ;14
 DFB 2,2 ;15
 DFB 2,4 ;16
 DFB 3,2 ;17
 DFB 3,4 ;18
 DFB 3,6 ;19
 DFB 4,4 ;20
 DFB 5,4 ;20+1  ST cannot go this high, but can be used if
 DFB 6,6 ;20+2  the player is a Ninja or a Lord

TEMP ENT
 DS 1
MAPLVL ENT
 DS 1
NUMP DS 1

ATTACKST DS 1

GETITEM ENT
 LDA IRECS
 BEQ :NEXT
 LDA :RECS
 CMP IRECS
 BEQ :NEXT
]LOOP INC :RECS
 LDX :RECS
 LDA #0
 JSR LOADITEM2
 LDA IFREE
 BMI :GOTIT
 LDA :RECS
 CMP IRECS
 BCC ]LOOP
:NEXT INC IRECS
 LDA IRECS
 STA NEWITEM
 STA :RECS
 RTS
:GOTIT LDA :RECS
 STA NEWITEM
 RTS
:RECS DS 1
IRECS ENT
 DS 2

SAVEI ENT
 LDX NEWITEM
 LDA #0
 JMP SAVEITEM2

CLRBOT JSR PRINT
 GOTOXY 0;22
 LUP 7
 ZAPLINE
 CURSORUP
 --^
 ZAPLINE
 NULL
 RTS

LOADMAST ENT
 LDX MPLR
 LDA MPLR+1
 JSR LOADPLR
 LDA PLRXPOS
 STA AFROMX
 LDA PLRYPOS
 STA AFROMY
 RTS

GETLOC LDA ANKX
 CLC
 ADC XLOC
 TAX
 LDA ANKY
 CLC
 ADC YLOC
 TAY
 JSR GETMAP
 LDX XLOC
 LDY YLOC
 RTS

AFROMX ENT
 DS 1 ;Attacking from
AFROMY ENT
 DS 1
ATOX ENT
 DS 1 ;to
ATOY ENT
 DS 1

GOLD DS 4
ITEMS DS 15
NEWITEM DS 1
MAXITEMS DS 1

SCENITEMS DS $100
SCENMON DS 1

RANDHITSND ENT
 RANDNUM #6 ;Random hit sound (1 of 6)
 TXA
 CLC
 ADC #2
 STA :S+2
 JSR PRINT
:S SOUND $0;1;LOUD
 NULL
 RTS

LEVEL DS 1

CLRSIDE LDX #7
]LOOP TXA
 CLC
 ADC #15
 STA :DH+3
 JSR PRINT
:DH GOTOXY 55;22
 CLEOL
 NULL
 DEX
 BPL ]LOOP
 RTS

DOPOINT LDA OLDPNTR
 AND #%0000_0111
 CLC
 ADC #15
 STA :CV+2
 JSR PRINT
 NORMAL
 MTOFF
 HTAB 54
:CV VTAB 0
 ASC " "
 NULL
 LDA POINTER
 AND #%0000_0111
 CLC
 ADC #15
 STA :CV2+2
 JSR PRINT
 HTAB 54
:CV2 VTAB 0
 NULL
 JSR SHOWPNTR
 LDA POINTER
 STA OLDPNTR
 RTS
POINTER DS 1
OLDPNTR DS 1

 LST ON
MODEND EQU *
 LST OFF

 do M16PLUS
 SAV GAME.COMBAT1.L
 fin

 END
