*-------------------------------
* GAME.COMBAT (part 2)
*-------------------------------
 DAT
 LST OFF

 REL

 USE MACROS
 USE EQUATES
 USE VARS
 USE TABLES
 USE LIB.JMP
 USE PLR.DSECT
 USE ITEM.DSECT
 USE ITEM2.DSECT
 USE PN.DSECT
 USE MON.DSECT
 USE MON2.DSECT

 do M16PLUS-1
 DSK GAME.COMBAT2.L
 fin

 EXT ASKIT,ATTACKER,VICTIM,SKILL,PD,DR,DIEDAM,DAMMOD,DAMAGE
 EXT X,Y,SQUARE,RANGE,DDAMAGE,TEMP,MAPLVL,DAMTHRUST,DAMSWING,SAVEI
 EXT AFROMX,AFROMY,ATOX,ATOY,LOADMAST,RANDHITSND,IRECS,GETITEM

CHAR ENT
 LDX VTEMP
 LDA VTEMP+1
 JSR LOADPLR
 LDA PLRPARTY
 STA :PARTY
 LDA VTEMP
 STA VICTIM
 LDA VTEMP+1
 STA VICTIM+1
 LDA PLRCOND
 AND #%1000_0000 ;Dead?
 BEQ :VALIVE
 JSR PRINT
 COLOR PINK
 PRSTRING PLRNAME
 ASC " is dead. Attack anyway (y/N) : "
 COLOR WHITE
 NULL
 JSR KEYIN
 JSR UPPER
 CMP #"Y"
 BEQ :VGO
 JSR PRINT
 ASC "No"
 PRPAUSE 1
 ZAPLINE
 NULL
 JMP ASKIT2
:VGO JSR PRINT
 HTAB 0
 CLEOL
 NULL
:VALIVE LDX ATTACKER
 LDA ATTACKER+1
 JSR LOADPLR
 LDA PLRPARTY
 CMP :PARTY
 BNE :PRTYOK
 JSR PRINT
 COLOR PINK
 ASC "You can't attack your own party!"
 COLOR WHITE
 NULL
 JMP ASKIT2
:PRTYOK LDA #7
 STA TEMP
]LOOP LDX TEMP
 LDA PLRITEM,X
 TAX
 LDA #0
 JSR LOADITEM
 LDA ITYPE
 CMP #1 ;A weapon
 BNE :WNEXT
 LDX TEMP
 LDA PLRITEMX,X
 CMP #1 ;Equipped?
 BEQ :GOTWEAP
:WNEXT DEC TEMP
 LDA TEMP
 BPL ]LOOP
 LDA #1 ;Make weapon into a 'fist'
 STA IDAT1 ;Damage amount
 LDA #-2
 STA IDAT2 ;Damage modifier
 LDA #0
 STA IDAT3 ;Skill level
 LDA #3
 STA IDAT4 ;Damage type (cr)
 LDA #0
 STA IDAT5 ;Range
:GOTWEAP LDA RANGE
 CMP IDAT5
 BEQ :RANGEOK
 BCC :RANGEOK
 JSR PRINT
 COLOR PINK
 ASC "Out of range.."
 SOUND $13;1;$80
 COLOR WHITE
 NULL
 JMP ASKIT2

:RANGEOK LDX VICTIM
 LDA VICTIM+1
 JSR LOADPLR
 JSR PRINT
 PRSTRING PLRNAME
 ASC " "
 NULL
 LDA PLRCOND
 AND #%1100_1001 ;Dead, paralyzed, asleep, stunned?
 BEQ :RNGOK2
 LDX ATTACKER
 LDA ATTACKER+1
 JSR LOADPLR
 DEC PLRCURRPNTS
 LDA #%0001_0000
 TRB PLRCOND ;Become 'visible' if you attack
 LDX ATTACKER
 LDA ATTACKER+1
 JSR SAVEPLR
 JMP :DD2
:RNGOK2 LDX ATTACKER
 LDA ATTACKER+1
 JSR LOADPLR
 DEC PLRCURRPNTS
 LDA #%0001_0000
 TRB PLRCOND ;Become 'visible' if you attack
 LDX ATTACKER
 LDA ATTACKER+1
 JSR SAVEPLR

 LDA PLRDX
 CLC
 ADC IDAT3 ;Weapon skill
 ADC #2 ;DX+2
 STA SKILL ;Effective skill

 STZ DDAMAGE
 LDX #3
 JSR ROLLD6 ;Get Attack Roll (3d6)
 LDA VTEMP ;If roll <= SKILL then HIT
 CMP #3 ;Critical success (3 or 4)
 BEQ :DD1 ; hits automatically
 CMP #4
 BEQ :DD2
 CMP SKILL
 BEQ :AOK
 BCC :AOK
 JMP :MISS
:DD1 LDA #3 ;Triple damage
 HEX 2C
:DD2 LDA #2 ;Double damage
 STA DDAMAGE
 JMP :HIT2

:AOK LDX VICTIM
 LDA VICTIM+1
 JSR LOADPLR
 STZ PD
 STZ DR
 LDX #0
]LOOP STX VTEMP
 LDA PLRITEM,X
 BEQ :NO
 TAX
 LDA #0
 JSR LOADITEM
 LDA ITYPE
 CMP #2
 BCC :NO
 CMP #6
 BCS :NO
 LDX VTEMP
 LDA PLRITEMX,X
 CMP #1 ;Equipped?
 BNE :NO
 LDA PD
 CLC
 ADC IDAT1 ;Passive defense
 STA PD
 LDA DR
 CLC
 ADC IDAT2 ;Damage resistance
 STA DR
:NO INC VTEMP
 LDX VTEMP
 CPX #8
 BNE ]LOOP
 LDA PD
 CLC
 ADC PLRSPEED
 STA PD

 LDX #3
 JSR ROLLD6 ;Calc Defense Roll (3d6)

 LDA VTEMP ;If roll <= PD then BLOCKED
 CMP PD ;else HIT
 BEQ :BL
 BCS :HIT2
:BL JMP :BLOCKED

:HIT2 LDX ATTACKER
 LDA ATTACKER+1
 JSR LOADPLR
 RANDNUM #2
 CPX #2
 BEQ :ASND2
:ASND1 JSR PRINT
 SOUND $16;1;LOUD
 NULL
 BRA :HITZ
:ASND2 JSR PRINT
 SOUND $17;1;LOUD
 NULL
:HITZ LDA IDAT1 ;Dam amount (thr or sw)
 CMP #1
 BEQ :SWING
 CMP #2
 BEQ :THRUST
 RANDNUM #2
 STX IDAT1
 BRA :HIT2
:THRUST LDA PLRST
 DEC
 ASL
 TAX
 LDA DAMTHRUST,X ;Dam = xd+y (eg; 1d-2)
 STA DIEDAM
 LDA DAMTHRUST+1,X
 STA DAMMOD
 BRA :CONT
:SWING LDA PLRST
 DEC
 ASL
 TAX
 LDA DAMSWING,X ;Dam = xd+y (eg; 1d-2)
 STA DIEDAM
 LDA DAMSWING+1,X
 STA DAMMOD
:CONT LDA DAMMOD
 CLC
 ADC IDAT2
 STA DAMMOD
 LDX DIEDAM
 JSR ROLLD6 ;Calc damage
 LDA VTEMP
 CLC
 ADC DAMMOD
 SEC
 SBC DR ;Subtract DR
 STA DAMAGE
 DEC
 CMP #$80
 BCC :HIT3
 JMP :REFLECTED ;Hit bounced off armour

:HIT3 LDA DDAMAGE ;Critical success?
 BEQ :DAMT
 TAX
 LDA DAMAGE
]LOOP CLC ;Multiply dam by 2 or 3
 ADC DAMAGE
 DEX
 CPX #1
 BNE ]LOOP
 STA DAMAGE
:DAMT LDA IDAT4 ;Dam type
 CMP #1
 BEQ :IMPALE
 CMP #3 ;Crush (no damage bonus)
 BEQ :CONT2
:CUT LDA DAMAGE ;Dam inc by 50%
 LSR
 CLC
 ADC DAMAGE
 STA DAMAGE
 BRA :CONT2
:IMPALE LDA DAMAGE ;Dam x 2 (inc by 100%)
 CLC
 ADC DAMAGE
 STA DAMAGE
:CONT2 JSR PRINT
 ASC "is hit for "
 COLOR PINK
 DEC8 DAMAGE
 COLOR WHITE
 ASC " damage.."
 NULL
 JSR RANDHITSND
 LDX VICTIM
 LDA VICTIM+1
 JSR LOADPLR
 LDA PLRCOND
 STA :PREVCOND
 LDA PLRHP
 STA :PREVHP
 LDA PLRHP ;Subtract dam
 SEC
 SBC DAMAGE
 STA PLRHP
 LDA DAMAGE
 CMP #127
 BCS :ZDEAD
 LDA PLRHP
 CMP #$80
 BCCL :ALIVE
 LDA PLRHP
 EOR #$FF
 INC
 CMP PLRHP+1 ;HP gone full negative?
 BCCL :UNCON
:ZDEAD LDA :PREVCOND
 AND #%1000_0000
 BEQ :DEADOK
 JSR PRINT
 COLOR PINK
 ASC " and is hacked"
 SOUND $0F;1;LOUD
 COLOR WHITE
 NULL
 LDX VICTIM
 LDA VICTIM+1
 JSR SAVEPLR
* JSR LOGATTACK
* JSR PLOGATTACK
* LDA PARTYNUM
* PHA
* LDA PLRPARTY
* STA PARTYNUM
* PNOTELOGSTR $1;"Hacked - ";PLRNAME
* PLA
* STA PARTYNUM
 JMP :DOASS

:PREVCOND DS 1
:PREVHP DS 1

:DEADOK LDA #%1000_0000 ;Dead
 STA PLRCOND
 LDX #7
]LOOP STZ PLRCONDX,X
 DEX
 BPL ]LOOP
 LDA #$FF
 STA PLRCONDX+7
 JSR PRINT
 ASC " and dies"
 NULL
 JSR CHARITEMS ;If char has items, then 'drop' them all
 LDX VICTIM
 LDA VICTIM+1
 JSR SAVEPLR
 JSR LOGATTACK
 JSR PLOGATTACK
* LDA PARTYNUM
* PHA
* LDA PLRPARTY
* STA PARTYNUM
* PNOTELOGSTR $1;"Killed - ";PLRNAME
* PLA
* STA PARTYNUM
 LDX VICTIM ;If victim is on the hotlist, then it is legal to
 LDA VICTIM+1 ; beat him up and get away with it
 JSR LOADPLR
 LDA PLRPASSAULTS
 ORA PLRPASSAULTS+1
 ORA PLRPKILLS
 ORA PLRPKILLS+1
 BNE :HUMHAK
 BIT BEATUPLEADER ;Able to beat up leader and get away with it?
 BPL :NOWAY
 LDX SCENARIO
 LDA PLRPARTY ;OK to beat up on leading party!
 CMP LEADPRTY-1,X
 BEQ :HUMHAK
:NOWAY LDX ATTACKER
 LDA ATTACKER+1
 JSR LOADPLR
 INCR PLRPKILLS ;Murderer...
 INCR PLRPKILLSMAX ;Murderer...
 LDX ATTACKER
 LDA ATTACKER+1
 JSR SAVEPLR
:HUMHAK LDX ATTACKER
 LDA ATTACKER+1
 JSR LOADPLR
 STZ VTEMP ;Calc exp (all parties)
 LDA #$7F
 STA VTEMP+1
 CALL "GAME.CHKEXP"
 JMP ASKIT2
:ALIVE LDA :PREVHP
 BMI :WASTED
 LDX VICTIM
 LDA VICTIM+1
 JSR SAVEPLR
:DOASS LDX VICTIM ;If victim is on the hotlist, then it is legal to
 LDA VICTIM+1 ; beat him up and get away with it
 JSR LOADPLR
 LDA PLRPASSAULTS
 ORA PLRPASSAULTS+1
 ORA PLRPKILLS
 ORA PLRPKILLS+1
 BNE :HUMHAH
 BIT BEATUPLEADER ;Able to beat up leader and get away with it?
 BPL :NOWAY2
 LDX SCENARIO
 LDA PLRPARTY ;OK to beat up on leading party!
 CMP LEADPRTY-1,X
 BEQ :HUMHAH
:NOWAY2 LDX ATTACKER
 LDA ATTACKER+1
 JSR LOADPLR
 INCR PLRPASSAULTS ;Murderer... not yet
 INCR PLRPASSAULTSMAX ;Murderer... not yet
 LDX ATTACKER
 LDA ATTACKER+1
 JSR SAVEPLR
:HUMHAH LDX ATTACKER
 LDA ATTACKER+1
 JSR LOADPLR
 JSR LOGATTACK
 JSR PLOGATTACK
 JMP ASKIT2

:WASTED JSR PRINT
 COLOR PINK
 ASC " and is wasted"
 COLOR WHITE
 SOUND $0F;1;LOUD
 NULL
 JSR LOGATTACK
 JSR PLOGATTACK
* LDA PARTYNUM
* PHA
* LDA PLRPARTY
* STA PARTYNUM
* PNOTELOGSTR $1;"Wasted - ";PLRNAME
* PLA
* STA PARTYNUM
 NOTELOGNUM $1;"Player has been wasted - #";VICTIM
 NOTELOGSTR $1;"Name = ";PLRNAME
 LDA #$FF
 STA PLRFREE
 LDX VICTIM
 LDA VICTIM+1
 JSR SAVEPLR
 BIT PLRARRESTFLAG
 BPL :UMM
 JSR RESETGUARD ;Reset guardian (no char to take to jail, etc)
:UMM LDX PLRXPOS
 LDY PLRYPOS
 LDA #-1
 JSR PUTMAP2
 LDX PLRZPOS
 LDA #0
 JSR SAVEMAP2
 LDX ATTACKER
 LDA ATTACKER+1
 JSR LOADPLR
 LDX PLRXPOS
 LDY PLRYPOS
 LDA PLRZPOS
 JSR SHOWMAP
 JMP ASKIT2

:UNCON LDX #3
 JSR ROLLD6 ;Roll vs Health
 LDA VTEMP
 CMP PLRHT
 BEQ :CONC
 BCC :CONC
 LDA PLRCOND
 AND #%0000_1000 ;Already unconscious?
 BNE :UNCON2
 JSR PRINT
 ASC " and falls unconscious.."
 NULL
:UNCON2 LDA PLRCOND
 ORA #%0000_1000 ;Unconscious
 STA PLRCOND
 LDA #$FF
 STA PLRCONDX+3 ;Unconscious 'forever' (until failed HT roll)
 JSR CHARITEMS
 LDX VICTIM
 LDA VICTIM+1
 JSR SAVEPLR
* JSR LOGATTACK
* JSR PLOGATTACK
* LDA PARTYNUM
* PHA
* LDA PLRPARTY
* STA PARTYNUM
* PNOTELOG $1;"Knocked out.."
* PLA
* STA PARTYNUM
 JMP :DOASS
:CONC JSR PRINT
 ASC " and stumbles.."
 NULL
 LDX VICTIM
 LDA VICTIM+1
 JSR SAVEPLR
* JSR LOGATTACK
* JSR PLOGATTACK
 LDA PARTYNUM
 PHA
 LDA PLRPARTY
 STA PARTYNUM
 PNOTELOG $1;"Close to death.."
 PLX
 STX PARTYNUM
 LDA #0
 JSR LOADPN
 JMP :DOASS

:MISS JSR PRINT
 ASC "missed.."
 SOUND $0A;1;LOUD
 NULL
 JSR LOGATTACK
 JSR PLOGATTACK
* LDA PARTYNUM
* PHA
* LDA PLRPARTY
* STA PARTYNUM
* PNOTELOG $1;"Missed.."
* PLA
* STA PARTYNUM
 JMP ASKIT2

:BLOCKED JSR PRINT
 ASC "blocked the attack.."
 SOUND $0C;1;LOUD
 NULL
* JSR LOGATTACK
* JSR PLOGATTACK
* LDA PARTYNUM
* PHA
* LDA PLRPARTY
* STA PARTYNUM
* PNOTELOG $1;"Attack blocked.."
* PLA
* STA PARTYNUM
 JMP :DOASS

:REFLECTED JSR PRINT
 ASC "is hit; blow reflected.."
 SOUND $0B;1;LOUD
 NULL
* JSR LOGATTACK
* JSR PLOGATTACK
* LDA PARTYNUM
* PHA
* LDA PLRPARTY
* STA PARTYNUM
* PNOTELOG $1;"Blow reflected.."
* PLA
* STA PARTYNUM
 JMP :DOASS

:PARTY DS 2

ASKIT2 JSR LOADMAST
 JMP ASKIT

LOGATTACK ENT
 LDX ATTACKER
 LDA ATTACKER+1
 JSR LOADPLR
 LDA ATOX
 JSR CONVERT
 STA :BUFF+12
 STX :BUFF+13
 LDA ATOY
 JSR CONVERT
 STA :BUFF+15
 STX :BUFF+16
 LDA AFROMX
 JSR CONVERT
 STA :BUFF+25
 STX :BUFF+26
 LDA AFROMY
 JSR CONVERT
 STA :BUFF+28
 STX :BUFF+29
 LDA #34
 CLC
 ADC PLRNAME
 STA :BUFF
 LDX PLRNAME
]LOOP LDA PLRNAME,X
 STA :BUFFN-1,X
 DEX
 BNE ]LOOP
 PNOTELOGBUFF $D;:BUFF
 LDA #21
 LDX #0
 LDY #79
 JSR PICKLINE
 LDX #79
]LOOP LDA $200,X
 CMP #" "
 BNE :OK
 DEX
 BNE ]LOOP
 RTS ;Blank line
:OK INX
 STX MISCBUFF
]LOOP LDA $200,X
 STA MISCBUFF+1,X
 DEX
 BPL ]LOOP
 PNOTELOGBUFF $9;MISCBUFF
 LDA ARRESTPRTY
 BNE :AAP
 RTS
:AAP LDA PARTYNUM
 PHA
 LDA ARRESTPRTY
 STA PARTYNUM
 PNOTELOGSTR $E;"Guardian killed, party member free : ";PLRNAME
 PLX
 STX PARTYNUM
 LDA #0
 JSR LOADPN
 STZ ARRESTPRTY
 RTS
:BUFF STR "Attack on (x1,y1) from (x2,y2) by "
:BUFFN DS 20

CONVERT STZ :CHAR+1
 CMP #10
 BCC :LESS
 INC :CHAR+1
 SEC
 SBC #10
:LESS STA :CHAR
 ORA #"0"
 TAX
 LDA :CHAR+1
 ORA #"0"
 RTS
:CHAR DS 2

PLOGATTACK ENT
 LDX PARTYNUM
 LDA #0
 JSR LOADPN
 LDX VICTIM
 LDA VICTIM+1
 JSR LOADPLR
 LDY #0
]LOOP LDA PLRNAME+1,Y
 STA MISCBUFF+1,Y
 INY
 CPY PLRNAME
 BNE ]LOOP
 INY
 LDX #0
]LOOP LDA :STR1+1,X
 STA MISCBUFF,Y
 INY
 INX
 CPX :STR1
 BNE ]LOOP
 LDA ATOX
 JSR CONVERT
 STA MISCBUFF,Y
 INY
 TXA
 STA MISCBUFF,Y
 INY
 LDA #","
 STA MISCBUFF,Y
 INY
 LDA ATOY
 JSR CONVERT
 STA MISCBUFF,Y
 INY
 TXA
 STA MISCBUFF,Y
 INY
 LDX #0
]LOOP LDA :STR2+1,X
 STA MISCBUFF,Y
 INY
 INX
 CPX :STR2
 BNE ]LOOP
 LDX #0
]LOOP LDA PNNAME+1,X
 STA MISCBUFF,Y
 INY
 INX
 CPX PNNAME
 BNE ]LOOP
 LDX #0
]LOOP LDA :STR3+1,X
 STA MISCBUFF,Y
 INY
 INX
 CPX :STR3
 BNE ]LOOP
 LDA AFROMX
 JSR CONVERT
 STA MISCBUFF,Y
 INY
 TXA
 STA MISCBUFF,Y
 INY
 LDA #","
 STA MISCBUFF,Y
 INY
 LDA AFROMY
 JSR CONVERT
 STA MISCBUFF,Y
 INY
 TXA
 STA MISCBUFF,Y
 INY
 LDX #0
]LOOP LDA :STR4+1,X
 STA MISCBUFF,Y
 INY
 INX
 CPX :STR4
 BNE ]LOOP
 LDA MAPLVL
 JSR CONVERT
 STA MISCBUFF,Y
 INY
 TXA
 STA MISCBUFF,Y
 INY
 LDX #0
]LOOP LDA :STR5+1,X
 STA MISCBUFF,Y
 INY
 INX
 CPX :STR5
 BNE ]LOOP
 LDA PARTYNUM
 PHA
 LDA PLRPARTY
 STA PARTYNUM
 DEY
 STY MISCBUFF
 PNOTELOGBUFF $D;MISCBUFF
 LDX VICTIM
 LDA VICTIM+1
 JSR LOADPLR
 LDA #21
 LDX #0
 LDY #79
 JSR PICKLINE
 LDX #79
]LOOP LDA $200,X
 CMP #" "
 BNE :OK
 DEX
 BNE ]LOOP
 BRA :ZOUT ;Blank line
:OK INX
 STX MISCBUFF
]LOOP LDA $200,X
 STA MISCBUFF+1,X
 DEX
 BPL ]LOOP
 PNOTELOGBUFF $9;MISCBUFF
:ZOUT PLX
 STX PARTYNUM
 LDA #0
 JSR LOADPN
 RTS
:STR1 STR " at "
:STR2 STR " attacked by Party '"
:STR3 STR "' from "
:STR4 STR " (level "
:STR5 STR ")"

MLOGATTACK ENT
 LDX ATTACKER
 LDA ATTACKER+1
 JSR LOADPLR
 LDY #0
]LOOP LDA PLRNAME+1,Y
 STA MISCBUFF+1,Y
 INY
 CPY PLRNAME
 BNE ]LOOP
 INY
 LDX #0
]LOOP LDA :STR1+1,X
 STA MISCBUFF,Y
 INY
 INX
 CPX :STR1
 BNE ]LOOP
 LDA PLRXPOS
 JSR CONVERT
 STA MISCBUFF,Y
 INY
 TXA
 STA MISCBUFF,Y
 INY
 LDA #","
 STA MISCBUFF,Y
 INY
 LDA PLRYPOS
 JSR CONVERT
 STA MISCBUFF,Y
 INY
 TXA
 STA MISCBUFF,Y
 INY
 LDX #0
]LOOP LDA :STR2+1,X
 STA MISCBUFF,Y
 INY
 INX
 CPX :STR2
 BNE ]LOOP
 LDA MXPOS
 JSR CONVERT
 STA MISCBUFF,Y
 INY
 TXA
 STA MISCBUFF,Y
 INY
 LDA #","
 STA MISCBUFF,Y
 INY
 LDA MYPOS
 JSR CONVERT
 STA MISCBUFF,Y
 INY
 TXA
 STA MISCBUFF,Y
 INY
 LDX #0
]LOOP LDA :STR3+1,X
 STA MISCBUFF,Y
 INY
 INX
 CPX :STR3
 BNE ]LOOP
 LDA MAPLVL
 JSR CONVERT
 STA MISCBUFF,Y
 INY
 TXA
 STA MISCBUFF,Y
 INY
 LDX #0
]LOOP LDA :STR4+1,X
 STA MISCBUFF,Y
 INY
 INX
 CPX :STR4
 BNE ]LOOP
 DEY
 STY MISCBUFF
 PNOTELOGBUFF $D;MISCBUFF
 RTS
:STR1 STR " at "
:STR2 STR " attacked "
:STR3 STR " (lvl "
:STR4 STR ")"

CHARITEMS LDA PLRGOLD
 ORA PLRGOLD+1
 ORA PLRGOLD+2
 ORA PLRGOLD+3
 BEQ :NOGOLD
 JSR GETITEM
 STZ INUM ;0 = gold
 LDA PLRXPOS
 STA IXPOS
 LDA PLRYPOS
 STA IYPOS
 LDA PLRZPOS
 STA IZPOS
 LDX #3
]LOOP LDA PLRGOLD,X
 STA IDATA,X
 DEX
 BPL ]LOOP
 STZ IFREE
 STZ IBURIED
 JSR SAVEI
:NOGOLD LDX #0 ;Put all chars items into maze item file
]LOOP LDA PLRITEM ;ie. drop all his items (or hers)
 BEQ :DONE
 JSR GETITEM
 LDA PLRITEM
 STA INUM
 LDA PLRXPOS
 STA IXPOS
 LDA PLRYPOS
 STA IYPOS
 LDA PLRZPOS
 STA IZPOS
 STZ IDATA
 STZ IDATA+1
 STZ IDATA+2
 STZ IDATA+3
 STZ IFREE
 STZ IBURIED
 PHX
 JSR SAVEI
 LDX #0
]LOOP2 LDA PLRITEM+1,X ;Crunch items
 STA PLRITEM,X
 LDA PLRITEMX+1,X
 STA PLRITEMX,X
 INX
 CPX #7
 BNE ]LOOP2
 STZ PLRITEM+7
 STZ PLRITEMX+7
 PLX
 INX
 CPX #8
 BNE ]LOOP
:DONE LDA IRECS ;Update Maze Items (total)
 STA ITEM2BUFF
 STZ ITEM2BUFF+1
 LDX #0
 LDA #0
 JSR SAVEITEM2
 LDA PLRITEM ;Got anything?
 BEQ :NONE
 JSR PRINT
 SOUND $0E;1;$80
 NULL
 RTS
:NONE JSR PRINT
 SOUND $0D;1;$80
 NULL
 RTS

RESETGUARD LDX #0
 LDA #0
 JSR LOADMON2
 LDX MON2BUFF
]LOOP PHX
 LDA #0
 JSR LOADMON2
 LDA MZPOS
 CMP PLRZPOS
 BNE :NEXT
 LDA MXPOS
 CMP PLRXPOS
 BNE :NEXT
 LDA MYPOS
 CMP PLRYPOS
 BNE :NEXT
 LDX MTYPE
 LDA MTYPE+1
 JSR LOADMON
 LDA MLEVEL
 BNE :NEXT
 LDA MARRESTCHAR
 CMP VICTIM
 BNE :NEXT
 LDA MARRESTCHAR+1
 CMP VICTIM+1
 BNE :NEXT
 STZ MARRESTCHAR ;Reset guard - no char, new direction
 STZ MARRESTCHAR+1
 RANDNUM #9
 STX MDIR
 PLX
 LDA #0
 JSR SAVEMON2
 RTS
:NEXT PLX
 DEX
 BNE ]LOOP
 RTS

ARRESTPRTY ENT
 DS 1

 LST ON
MODEND EQU *
 LST OFF

 do M16PLUS
 SAV GAME.COMBAT2.L
 fin

 END
