*-------------------------------
* GAME.DUNGEON
*-------------------------------
 DAT
 LST OFF

 ORG $8000 ;Always

 USE MACROS
 USE EQUATES
 USE VARS
 USE TABLES
 USE LIB.JMP
 USE PLR.DSECT
 USE ST.DSECT
 USE SPELL.DSECT
 USE ITEM.DSECT

 TYP $F4
 do M16PLUS-1
 DSK RUN/MODULES/GAME.DUNGEON
 fin

 MODID "GAME.DUNGEON"

START LDA MPLR
 BNE :MASTOK
 LDA MPLR+1
 BNE :MASTOK
 LDA CURPARTY
 STA MPLR
 LDA CURPARTY2
 STA MPLR+1
:MASTOK LDX #0
]LOOP PHX
 LDA CURPARTY,X
 STA :REC
 BNE :COK
 LDA CURPARTY2,X
 STA :REC+1
 BEQ :CNEXT
:COK LDX :REC
 LDA :REC+1
 JSR LOADPLR
 LDA PLRZPOS
 BNE :CNEXT
 JSR :PUTPLR
:CNEXT PLX
 INX
 CPX NUMPARTY
 BNE ]LOOP

 LDX MPLR
 LDA MPLR+1
 JSR LOADPLR
 LDA PLRZPOS
 BNE :MPOK
 LDX CURPARTY
 STX MPLR
 LDA CURPARTY2
 STA MPLR+1
 JSR LOADPLR
:MPOK LDX PLRZPOS
 JSR LDMAP
 JMP TOP

:PUTPLR LDX #1
 JSR LDMAP ;Load lvl 1

 STZ :CNTR
]LOOP JSR FINDUP
 BCC :UPOK
 LDA VTEMP
 BEQ :NOST
 INC :CNTR
 LDA :CNTR
 CMP #4
 BCC ]LOOP
 BRA :UPOK ;Not really...
:NOST JSR PRINT
 COLOR PINK
 ASC "No stairs up to Castle."
 COLOR WHITE
 NULL
 DEATH
:REC DS 2
:CNTR DS 1

:UPOK LDA #1
 STA PLRZPOS
 JSR GETXY ;Get stairs location
 STX PLRXPOS
 STY PLRYPOS
 LDX :REC
 LDA :REC+1
 JSR SAVEPLR
 LDX PLRXPOS
 LDY PLRYPOS
 LDA #1
 JSR PUTMAP2

 LDX PLRZPOS
 JSR SVMAP2
 RTS

TOP LDA MAPLVL
 BNE :LVLOK
 JSR PRINT
 HOME
 ASC "Wait.."
 CURSOROFF
 NULL
 STZ VTEMP
 CALL "GAME.PRECSTLE" ;Update conds, points, HP, etc
 LDA #$FF
 STA VTEMP
 STA VTEMP+1
 CALL "GAME.CHKEXP"
 EXEC "GAME.CASTLE" ;Up we go..
:LVLOK JSR PRINT
 GOTOXY 0;0
 CLEOL
 CURSORON
 COLOR AQUAMARINE
 ASC "Entering level "
 DEC8 MAPLVL
 ASC ".."
 CURSOROFF
 COLOR WHITE
 NULL
 JSR DUNGSND

 STZ VTEMP ;Draw everything
 CALL "DRAW.SCREEN" ;Display heaps of stuff

 LDX MPLR
 LDA MPLR+1
 JSR LOADPLR

 LDX PLRZPOS
 JSR LDMAP ;Load the current level
GO LDX PLRXPOS
 LDY PLRYPOS
 LDA PLRZPOS
 JSR SHOWMAP
 JSR PRINT
 GOTOXY 0;0
 ZAPLINE
 NULL

DOCMD JSR CLRBOT
 JSR ZAP14
 JSR PRINT
 GOTOXY 0;14
 COLOR ORANGE
 CENTER " Commands "
 COLOR YELLOW
 CR
 COLOR WHITE
 CURSORON
 LINE "A) Action"
 LINE "C) Combat"
 LINE "I) Inspect"
 LINE "L) Look"
 LINE "M) Movement"
 LINE "S) Spell"
 LINE "T) Trade"
 LINE "U) Use an item"
 GOTOXY 40;15
 ASC "B) Message base"
 GOTOXY 40;16
 ASC "D) System Info"
 GOTOXY 40;17
 ASC "H) Help"
 GOTOXY 40;18
 ASC "N) Notepad"
 GOTOXY 40;19
 ASC "P) Party stats"
 GOTOXY 40;20
 ASC "R) Return to Castle"
 GOTOXY 40;21
 ASC "Q) Quit/logoff"
 NULL

 JSR PRINT
 GOTOXY 55;12
 COLOR AQUAMARINE
 ASC "Command [?]: "
 COLOR WHITE
 NULL

GETCMD JSR PRINT
 GOTOXY 68;12
 CLEOL
 COLOR WHITE
 CURSORON
 NULL

]LOOP JSR KEYIN
 JSR UPPER
 LDX :KEYS
]LOOP2 CMP :KEYS,X
 BEQ :GOTONE
 DEX
 BNE ]LOOP2
 BRA ]LOOP
:GOTONE DEX
 TXA
 ASL
 TAX
 JMP (:TABLE,X)

:KEYS DFB :ENDKEYS-*-1
 DFB "P"
 DFB "M"
 DFB "C"
 DFB "L"
 DFB "S"
 DFB "H"
 DFB "Q"
 DFB "D"
 DFB "?"
 DFB "N"
 DFB "T"
 DFB "R"
 DFB "B"
 DFB "U"
 DFB "I"
 DFB "A"
:ENDKEYS

:TABLE DA PLRSTAT
 DA MOVE
 DA COMBAT
 DA LOOK
 DA SPELL
 DA HELP
 DA EXIT
 DA INFO
 DA DOCMD
 DA NPAD
 DA TRADE
 DA RTSCASTLE
 DA MSGBASE
 DA USE
 DA INSPECT
 DA ACTION

RTSCASTLE JSR PRINT
 HOME
 CURSORON
 ASC "Wait.."
 NULL
 LDA #$FF
 STA VTEMP
 STA VTEMP+1
 CALL "GAME.CHKEXP"
 EXEC "GAME.CASTLE"

SPELL JSR PRINT
 ASC "S"
 CURSOROFF
 NULL
 JSR CLRBOT
 JSR ZAP14
 CALL "GAME.SPELL"
 JSR DUNGSND
 JSR CLRBOT
 JSR ZAP14
 JMP GETCMD

NPAD JSR PRINT
 ASC "N"
 CURSOROFF
 NULL
 JSR CLRBOT
 JSR NOTEPAD
 JSR ZAP14
 JSR PRINT
 GOTOXY 0;23
 COLOR YELLOW
 INVERSE
 ZAPLINE
 NORMAL
 NULL
 JMP GETCMD

HELP JSR PRINT
 ASC "Help"
 NULL
 JSR CLRBOT
 JSR GETFILE
 DFB 15,22 ;Use lines x to y
 STR "HELP/DUNGEON"
 JMP GETCMD

LOOK JSR PRINT
 ASC "L"
 CURSOROFF
 NULL
 JSR CLRBOT
 JSR ZAP14
 CALL "GAME.LOOK"
 JSR CLRBOT
 JSR ZAP14
 JMP GETCMD

ACTION JSR PRINT
 ASC "A"
 CURSOROFF
 NULL
 JSR CLRBOT
 JSR ZAP14
 CALL "GAME.ACTION"
 JSR CLRBOT
 JSR ZAP14
 JMP GETCMD

EXIT JSR PRINT
 ASC "Exit"
 CURSOROFF
 NULL
 JSR CLRBOT
 JSR ZAP14
 JSR PRINT
 GOTOXY 0;15
 CURSORON
 COLOR PINK
 SOUND $13;1;$80
 ASC "Logoff. Are you sure (y/n)? : "
 COLOR WHITE
 NULL
]LOOP JSR KEYIN
 JSR UPPER
 CMP #"Y"
 BEQ :YES
 CMP #"N"
 BNE ]LOOP
 JSR PRINT
 ZAPLINE
 NULL
 JMP GETCMD
:YES JSR PRINT
 HOME
 ASC "Goodbye.."
 SOUND $13;1;LOUD
 NULL
 CALL "GAME.GOODBYE"
 JMP DROP

TRADE JSR PRINT
 ASC "T"
 CURSOROFF
 NULL
 JSR CLRBOT
 JSR ZAP14
 JSR PRINT
 COLOR ORANGE
 CENTER " Trade "
 COLOR YELLOW
 CR
 COLOR WHITE
 CURSORON
 NULL
 CALL "GAME.TRADE"
 JSR DUNGSND
 JSR CLRBOT
 JSR ZAP14
 JMP GETCMD

MOVE JSR PRINT
 ASC "M"
 CURSOROFF
 NULL
 JSR CLRBOT
 JSR ZAP14
 CALL "GAME.MOVE"
 JSR CLRBOT
 JSR ZAP14
 JMP GETCMD

COMBAT JSR PRINT
 ASC "C"
 CURSOROFF
 NULL
 JSR CLRBOT
 JSR ZAP14
 LDA MAPLVL ;Get map level for use in module
 STA VTEMP
 CALL "GAME.COMBAT"
 JSR DUNGSND
 JSR CLRBOT
 JSR ZAP14
 JMP GETCMD

INFO JSR PRINT
 ASC "D"
 CURSOROFF
 NULL
 JSR CLRBOT
 JSR ZAP14
 JSR PRINT
 HOME
 CURSORON
 NULL
 LDA #$FF
 STA VTEMP
 STA VTEMP+1
 CALL "GAME.CHKEXP"
 CALL "GAME.INFO"
 JMP START

MSGBASE JSR PRINT
 ASC "B"
 CURSOROFF
 NULL
 JSR CLRBOT
 JSR ZAP14
 CALL "GAME.MESSAGE"
 JMP START

USE JSR PRINT
 ASC "U"
 CURSOROFF
 NULL
 JSR CLRBOT
 JSR ZAP14
 CALL "GAME.USE"
 JSR ZAP14
 JMP GETCMD

INSPECT JSR PRINT
 ASC "I"
 CURSOROFF
 NULL
 JSR CLRBOT
 JSR ZAP14
 CALL "GAME.INSPECT"
 JSR ZAP14
 JMP GETCMD

PLRSTAT JSR PRINT
 ASC "P"
 CURSOROFF
 NULL
 JSR CLRBOT
 JSR ZAP14
 JSR PRINT
 COLOR ORANGE
 CENTER " Status "
 COLOR YELLOW
 CR
 COLOR WHITE
 CURSORON
 NULL
 CALL "GAME.PLRSTAT"
 BIT VTEMP ;Do we need to update plr stats area?
 BPL :NO
 LDA #$FF ;Draw player stats only
 STA VTEMP
 CALL "DRAW.SCREEN"
:NO JSR ZAP14
 JMP GETCMD

LDMAP STX MAPLVL
 STX MAPLVL2
 LDA #0
 JSR LOADMAP
 LDX MAPLVL2
 LDA #0
 JMP LOADMAP2
MAPLVL DS 1
MAPLVL2 DS 1

SVMAP2 STX MAPLVL3
 LDA #0
 JMP SAVEMAP2
MAPLVL3 DS 1

CLRBOT JSR PRINT
 GOTOXY 0;22
 LUP 7
 ZAPLINE
 CURSORUP
 --^
 ZAPLINE
 NULL
 RTS

ZAP14 JSR PRINT
 GOTOXY 0;14
 CURSOROFF
 INVERSE
 COLOR YELLOW
 ZAPLINE
 COLOR WHITE
 NORMAL
 NULL
 RTS

FINDUP LDX #0
 LDA #0
 JSR LOADST ;First, get the number of records in the file
 LDA STBUFF
 STA :NUMST
 STA :REC
 LDA STBUFF+1
 STA :REC+1
 STA :NUMST+1
 STZ VTEMP
 LDX #0
 LDY #0
]LOOP PHY
 PHX
 JSR GETMAP
 CMP #SHPSTAIRS ;Stairs..
 BNE :NSU
 CPX #STAIRSUP
 BEQ :GOTIT
:NSU PLX
 PLY
:SNEXT2 INX
 CPX #$10
 BNE ]LOOP
 LDX #0
 INY
 CPY #$10
 BNE ]LOOP
 LDA VTEMP
 BMI :FORCE
 SEC
 RTS

:SNEXT LDX STAIRX
 LDY STAIRY
 BRA :SNEXT2

:GOTIT PLX
 PLY
 STX STAIRX
 STY STAIRY
 LDA #$FF
 STA VTEMP
 JSR GETMAP2
 AND #$F
 CMP #8
 BCS :SNEXT

:FORCE LDA :REC
 ORA :REC+1
 BEQ :NOTHING ;No record exists of this stair/teleport
:LOAD LDX :REC
 LDA :REC+1
 JSR LOADST
 LDA STXPOS
 CMP STAIRX
 BNE :NEXT
 LDA STYPOS
 CMP STAIRY
 BNE :NEXT
 LDA STZPOS
 CMP MAPLVL
 BNE :NEXT
 LDA STGOTOX
 STA GOTOX
 LDA STGOTOY
 STA GOTOY
 LDA STGOTOZ
 STA GOTOZ
 CLC
 RTS
:NEXT DECR :REC
 LDA :REC
 ORA :REC+1
 BNE :LOAD
:NOTHING JSR PRINT
 CR
 COLOR PINK
 ASC "[Stair / teleport doesn't exist]"
 COLOR WHITE
 NULL
 DEATH
:REC DA 0
:NUMST DS 2

GETXY LDX STAIRX
 LDY STAIRY
 RTS

STAIRX DS 1
STAIRY DS 1
GOTOX DS 1
GOTOY DS 1
GOTOZ DS 1

DUNGSND JSR PRINT
 SOUND $1E;FOREVER;$C8
 NULL
 RTS

 LST ON
MODEND EQU *
 LST OFF

 do M16PLUS
 SAV RUN/MODULES/GAME.DUNGEON
 fin

 END
