*-------------------------------
* GAME.INFO
*-------------------------------
 DAT
 LST OFF

 ORG $8000 ;Always

 USE MACROS
 USE EQUATES
 USE VARS
 USE LIB.JMP
 USE HOF.DSECT
 USE LOG.DSECT
 USE PN.DSECT
 USE SCEN.DSECT
 USE PLR.DSECT
 USE TABLES
 USE WISH.DSECT

 TYP $F4
 do M16PLUS-1
 DSK RUN/MODULES/GAME.INFO
 fin

 MODID "GAME.INFO"

START JSR PRINT
 HOME
 SOUND $20;FOREVER;$80
 CURSOROFF
 INVERSE
 COLOR YELLOW
 ZAPLINE
 COLOR WHITE
 NORMAL
 CENTER " System Info "
 GOTOXY 0;13
 INVERSE
 COLOR YELLOW
 ZAPLINE
 NORMAL
 GOTOXY 0;2
 COLOR WHITE
 CURSORON
 LINE "[A] Credits"
 LINE "[B] System status"
 LINE "[C] Hall of fame"
 LINE "[D] Party history"
 LINE "[E] Scenario details"
 LINE "[F] Party list"
 LINE "[G] Notepad"
 LINE "[H] Message base"
 GOTOXY 24;2
 ASC "[I] If you must know.."
 GOTOXY 24;3
 ASC "[J] Clockwork"
 GOTOXY 24;4
 ASC "[K] System update history"
 GOTOXY 24;5
 ASC "[L] Download terminal program"
 GOTOXY 24;6
 ASC "[M] Yell for the GM"
 GOTOXY 24;7
 ASC "[N] Tips for beginners"
 GOTOXY 24;8
 ASC "[O] System/party options"
 GOTOXY 24;9
 ASC "[P] Public Notice"
 GOTOXY 54;2
 ASC "[Q] Hot list"
 GOTOXY 54;3
 ASC "[R] Mirror sketch"
 GOTOXY 54;4
 ASC "[S] The Wall"
 GOTOXY 54;5
 ASC "[T] Laws of the Realm"
 GOTOXY 54;6
 ASC "[U] The Register"
 GOTOXY 54;7
 ASC "[V] Ye Wish List"
 GOTOXY 54;8
 ASC "[W] Leave (logoff)"
 GOTOXY 54;9
 ASC "[*] Filing Cabinet"
 GOTOXY 0;11
 COLOR ORANGE
* ASC "Arrow keys move pointer; [RETURN]-select option; [ESC]-exit : "
 ASC "Select an option; [ESC]-exit : "
 COLOR WHITE
 NULL

 LDA CH
 STA TOPCH+2

*TOP JSR DOPOINT
TOP JSR PRINT
TOPCH GOTOXY 0;11
 CLEOL
 CURSORON
 NULL

]LOOP JSR KEYIN
 JSR UPPER
 CMP #$9B
 BEQ EXIT
* CMP #$8D
* BEQL SELECT
* CMP #"H"-$40
* BEQ LEFT
* CMP #"U"-$40
* BEQ RIGHT
* CMP #"K"-$40
* BEQL UP
* CMP #"J"-$40
* BEQL DOWN
 CMP #"*"
 BEQL CABINET
 CMP #"A"
 BCC ]LOOP
 CMP #"W"+1
 BCS ]LOOP
 PHA
 JSR COUT
 PLA
 SEC
 SBC #"A"
*GOTKEY
 ASL
 TAX
 JMP (:OPTIONS,X)

:OPTIONS DA CREDITS
 DA STATS
 DA HALLFAME
 DA HISTORY
 DA PROLOG
 DA LIST
 DA NPAD
 DA MBASE
 DA MUSTKNOW
 DA CLOCK
 DA SYSHIST
 DA DLOAD
 DA YELLGM
 DA TIPS
 DA CHANGE
 DA PNOTICE
 DA HOTLIST
 DA MIRROR
 DA WALL
 DA LAWS
 DA REG
 DA WISHLIST
 DA LOGOFF
 DA CABINET

EXIT JSR PRINT
 HOME
 NULL
 RETURN

*LEFT LDA PNTR
* SEC
* SBC #8
* BEQ :ZERO
* BCS :OK
*:ZERO CLC
* ADC #24
*:OK STA PNTR
* JMP TOP
*
*RIGHT LDA PNTR
* CLC
* ADC #8
* CMP #24+1
* BCC :OK
* SBC #24
*:OK STA PNTR
* JMP TOP
*
*UP LDA PNTR
* DEC
* BNE :OK
* LDA #24
*:OK STA PNTR
* JMP TOP
*
*DOWN LDA PNTR
* INC
* CMP #24+1
* BNE :OK
* LDA #1
*:OK STA PNTR
* JMP TOP
*
*SELECT JSR DOPOINTX
* LDA PNTR
* DEC
* JMP GOTKEY
*
*DOPOINTX LDA #$FF
* HEX 2C
*DOPOINT LDA #0
* STA :XFLAG
* LDA OLDPNTR
* JSR :GETHV
* STX :HV1+2
* STY :HV1+3
* JSR PRINT
* NORMAL
* MTOFF
*:HV1 GOTOXY 0;0
* NULL
* BIT :XFLAG
* BMI :DOX
* JSR PRINT
* ASC " "
* NULL
* LDA PNTR
* JSR :GETHV
* STX :HV2+2
* STY :HV2+3
* JSR PRINT
*:HV2 GOTOXY 0;0
* NULL
* JSR SHOWPNTR
* LDA PNTR
* STA OLDPNTR
* RTS
*:DOX JSR PRINT
* ASC "x"
* NULL
* RTS
*
*:GETHV LDX #0
*]LOOP CMP #9
* BCC :OK
* SBC #8
* INX
* BRA ]LOOP
*:OK INC
* TAY
* LDA :HTABS,X
* TAX
* RTS
*
*:XFLAG DS 1
*:HTABS DFB 1,25,55
*
*PNTR DFB 1
*OLDPNTR DFB 1

WISHLIST JSR PRINT
 HOME
 CENTER "Wish List"
 CR
 INVERSE
 MTON
 COLOR YELLOW
 CENTER "LLLLLLLLL"
 MTOFF
 NORMAL
 COLOR WHITE
 NULL
 JSR LOADSLICE
 STR "FILES/WISH.LIST"
 DA MISCBUFF
 DA 0
 DA WLRECLEN
 LDA MISCBUFF
 STA :RECS
 STZ :REC
:TOP JSR PRINT
 GOTOXY 0;2
 CLEOS
 NULL
 LDA #0
 JSR :LISTEM
:BOT JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 ASC "[A]dd, [D]elete, [L]ist, ["
 MTON
 INVERSE
 ASC "K"
 NORMAL
 ASC "/"
 INVERSE
 ASC "J"
 NORMAL
 MTOFF
 ASC "]-scroll, [H]elp, [ESC]-exit : "
 NULL
]TOPLOOP JSR KEYIN
 JSR UPPER
 CMP #"A"
 BEQL :ADD
 CMP #"D"
 BEQL :DEL
 CMP #"L"
 BEQ :LIST
 CMP #"H"
 BEQ :HELP
 CMP #"J"-$40
 BEQ :PDOWN
 CMP #"K"-$40
 BEQ :PUP
 CMP #$9B
 BNE ]TOPLOOP
 JMP START

:PUP LDA :TOPREC
 BEQ ]TOPLOOP
 SEC
 SBC #9
 BPL :PUPOK
 LDA #0
:PUPOK STA :REC
 LDA :WHO
 JSR :LISTEM
 JMP :BOT

:PDOWN LDA :REC
 CMP :RECS
 BCS ]TOPLOOP
 LDA :WHO
 JSR :LISTEM
 JMP :BOT

:HELP JSR PRINT
 GOTOXY 0;2
 CLEOS
 NULL
 JSR GETFILE
 DFB 2,23 ;Use lines x to y
 STR "HELP/WISH.LIST"
 JSR PRINT
 GOTOXY 0;23
 NULL
 GETRETURN
 LDA :TOPREC
 STA :REC
 JMP :TOP

:LIST JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 ASC "List : [RETURN]-yours, [P]-other party, [A]-all, [ESC]-exit : "
 NULL
]LOOP JSR KEYIN
 JSR UPPER
 CMP #$8D
 BEQ :YOURS
 CMP #"P"
 BEQ :FROMP
 CMP #"A"
 BEQ :LALL
 CMP #$9B
 BNE ]LOOP
 JMP :BOT

:YOURS LDA PARTYNUM
 HEX 2C
:LALL LDA #0
 STZ :REC
 JSR :LISTEM
 JMP :BOT

:FROMP JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 ASC "For party : "
 NULL
 GETLINE #20
 CPX #0
 BEQL :LIST
 PHX
 STX :PP
]LOOP LDA $200-1,X
 JSR UPPER
 STA :PP,X
 DEX
 BNE ]LOOP
 PLX
 CPX #4
 BCS :NAME
 JSR GETNUM
 CPY #0
 BNE :NAME
 CPX #0
 BEQ :NAME
:GOPRTY STX :PARTY
 LDA #0
 JSR LOADPN
 BIT PNFREE
 BMI :NSP
 STZ :REC
 LDA :PARTY
 JSR :LISTEM
 JMP :BOT
:NSP JSR PRINT
 CR
 COLOR PINK
 ASC "No such party. "
 SOUND $25;1;LOUD
 COLOR WHITE
 NULL
 GETRETURN
 JSR PRINT
 ZAPLINE
 CURSORUP
 NULL
 JMP :LIST
:NAME LDX #0
 LDA #0
 JSR LOADPN
 LDA PNBUFF
 STA :TOTP
 LDX #0
]LOOP CPX :TOTP
 BEQ :DONEPN
 INX
 PHX
 LDA #0
 JSR LOADPN
 BIT PNFREE
 BMI :NXTPN
 LDX PNNAME
 CPX :PP
 BNE :NXTPN
]LOOP2 LDA PNNAME,X
 JSR UPPER
 CMP :PP,X
 BNE :NXTPN
 DEX
 BNE ]LOOP2
 PLX
 JMP :GOPRTY
:NXTPN PLX
 BRA ]LOOP
:DONEPN JSR PRINT
 COLOR PINK
 ASC " - Party not found. "
 COLOR WHITE
 SOUND $25;1;LOUD
 NULL
 GETRETURN
 JMP :LIST
:PP DS 1+20
:PARTY DS 1
:TOTP DS 1

:LISTEM STA :WHO
 BIT :DELFLAG
 BMI :DELING
 JSR PRINT
 GOTOXY 0;2
 CLEOS
 LINE "Pty Date      Wish"
 NULL
 BRA :LEM
:DELING JSR PRINT
 GOTOXY 0;2
 CLEOS
 LINE "  # Date      Wish"
 NULL
:LEM LDA :REC
 STA :TOPREC
]LOOP LDA :REC
 CMP :RECS
 BCSL :DDONE
 INC :REC
 JSR LOADSLICE
 STR "FILES/WISH.LIST"
 DA MISCBUFF
:REC DA 0
 DA WLRECLEN
 BIT WISHFREE
 BMI ]LOOP
 LDA :WHO
 BEQ :WHOYEP
 CMP WISHFROM
 BNE ]LOOP
:WHOYEP LDA PADFLAG
 PHA
 LDA PADCHAR
 PHA
 LDA #$FF
 STA PADFLAG
 LDA #" "
 STA PADCHAR
 BIT :DELFLAG
 BPL :NODEL
 JSR PRINT
 COLOR YELLOW
 DEC8 :REC
 NULL
 BRA :ZCONT
:NODEL JSR PRINT
 COLOR YELLOW
 DEC8 WISHFROM
 NULL
:ZCONT JSR PRINT
 ASC " "
 COLOR AQUAMRINE
 DATE WISHDATE
 ASC " "
 COLOR WHITE
 PRSTRING WISHTEXT
 CR
 NULL
 LDA WISHREPLY
 BEQ :DNOR
 JSR PRINT
 HTAB 4
 COLOR ORANGE
 ASC "GM reply: "
 COLOR GREEN
 PRSTRING WISHREPLY
 COLOR WHITE
 CR
 NULL
:DNOR PLA
 STA PADCHAR
 PLA
 STA PADFLAG
 LDA CV
 CMP #21
 BNEL ]LOOP
:DDONE RTS

:ADD LDA :RECS
 CMP #$FF
 BCC :ADDYEH
 JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 COLOR PINK
 ASC "Cannot add - Wish List is full. "
 COLOR WHITE
 NULL
 GETRETURN
 JMP :BOT
:ADDYEH JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 CURSORUP
 ASC "Wish : "
 NULL
 GETLINE #65
 CPX #0
 BNE :ADDOK
 JSR PRINT
 GOTOXY 0;22
 ZAPLINE
 NULL
 JMP :BOT
:ADDOK STX :TXTLEN
 JSR PRINT
 CR
 ASC "OK (y/n)? : "
 NULL
]LOOP JSR KEYIN
 JSR UPPER
 CMP #"Y"
 BEQ :ADYES
 CMP #"N"
 BNE ]LOOP
 JSR PRINT
 ASC "No"
 GOTOXY 0;22
 ZAPLINE
 NULL
 JMP :BOT
:ADYES JSR PRINT
 ASC "Yes"
 NULL
 MLI_GET_TIME
 STZ WISHFREE
 LDA PARTYNUM
 STA WISHFROM
 LDA $BF90
 STA WISHDATE
 LDA $BF91
 STA WISHDATE+1
 LDX :TXTLEN
 STX WISHTEXT
]LOOP LDA $200-1,X
 STA WISHTEXT,X
 DEX
 BNE ]LOOP
 STZ WISHREPLY
 INC :RECS
 LDA :RECS
 STA :REC2
 JSR SAVESLICE
 STR "FILES/WISH.LIST"
 DA MISCBUFF
:REC2 DA 0
 DA WLRECLEN
 LDA :RECS
 STA MISCBUFF
 LDA :RECS+1
 STA MISCBUFF+1
 JSR SAVESLICE
 STR "FILES/WISH.LIST"
 DA MISCBUFF
 DA 0
 DA WLRECLEN
 LDA :TOPREC
 STA :REC
 JMP :TOP

:DEL STZ :REC
 LDA #$FF
 STA :DELFLAG
 LDA PARTYNUM
 JSR :LISTEM
 STZ :DELFLAG
 JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 ASC "Delete which comment? : "
 NULL
 GETLINE #3
 CPX #0
 BEQL :LALL
 JSR GETNUM
 STX :DREC
 STX :DREC2
 DEX
 CPX :RECS
 BCC :DELOK
 JSR PRINT
 COLOR PINK
 ASC " - no such comment. "
 COLOR WHITE
 NULL
 GETRETURN
 JMP :DEL
:DELOK JSR LOADSLICE
 STR "FILES/WISH.LIST"
 DA MISCBUFF
:DREC DA 0
 DA WLRECLEN
 LDA WISHFROM
 CMP PARTYNUM
 BEQ :DELOK2
 JSR PRINT
 COLOR PINK
 ASC " - not your comment. "
 COLOR WHITE
 NULL
 GETRETURN
 JMP :DEL
:DELOK2 LDA #$FF
 STA WISHFREE
 JSR SAVESLICE
 STR "FILES/WISH.LIST"
 DA MISCBUFF
:DREC2 DA 0
 DA WLRECLEN
 JSR PRINT
 COLOR PINK
 ASC " - deleted. "
 COLOR WHITE
 NULL
 GETRETURN
 JMP :LALL

:RECS DS 2
:WHO DS 1
:TXTLEN DS 1
:TOPREC DS 1
:DELFLAG DFB 0

REG JSR PRINT
 HOME
 CENTER "The Register"
 CR
 INVERSE
 MTON
 COLOR YELLOW
 CENTER "LLLLLLLLLLLL"
 MTOFF
 NORMAL
 COLOR WHITE
 NULL
:TOP JSR PRINT
 GOTOXY 0;2
 CLEOS
 ASC "Party name : "
 COLOR AQUAMARINE
 PRSTRING PNNAME
 COLOR WHITE
 CR
 ASC "Comment    : "
 NULL
 LDA PNQUOTE
 BNE :PQ
 JSR PRINT
 COLOR YELLOW
 PRSTRING PNQUOTE
 COLOR WHITE
 NULL
 BRA :GOL
:PQ JSR PRINT
 QUOTE
 COLOR YELLOW
 PRSTRING PNQUOTE
 COLOR WHITE
 QUOTE
 NULL
:GOL JSR PRINT
 CR
 CR
 ASC "#  Name"
 HTAB 24
 ASC "Class      Comment"
 CR
 CR
 NULL
 STZ :PTOTAL
 LDX #-1
]LOOP INX
 PHX
 LDA PARTY,X
 ORA PARTY2,X
 BEQ :NOTHA
 LDA PARTY,X
 TAY
 LDA PARTY2,X
 TYX
 JSR LOADPLR
 INC :PTOTAL
 JSR PRINT
 DEC8 :PTOTAL
 ASC ") "
 COLOR ORANGE
 PRSTRING PLRNAME
 HTAB 24
 COLOR GREEN
 PRTABLE PLRCLASS;CLASSTABLE
 HTAB 35
 COLOR WHITE
 NULL
 LDA PLRQUOTE
 BNE :AQ
 JSR PRINT
 COLOR YELLOW
 PRSTRING PLRQUOTE
 COLOR WHITE
 CR
 NULL
 BRA :NOTHA
:AQ JSR PRINT
 QUOTE
 COLOR YELLOW
 PRSTRING PLRQUOTE
 COLOR WHITE
 QUOTE
 CR
 NULL
:NOTHA PLX
 CPX #4 ;NUMPARTY
 BNE ]LOOP
:BOT JSR PRINT
 GOTOXY 0;15
 ZAPLINE
 ASC "[P]arty quote, "
 NULL
 LDA :PTOTAL
 BEQ :BOTO
 JSR PRINT
 ASC "[1-"
 DEC8 :PTOTAL
 ASC "]-character quote, "
 NULL
:BOTO JSR PRINT
 ASC "[H]elp, [L]ist characters, [ESC]-exit : "
 NULL
]TOPLOOP JSR KEYIN
 JSR UPPER
 CMP #$9B
 BEQL :ESC
 CMP #"P"
 BEQL :PQUOTE
 CMP #"H"
 BEQL :HELP
 CMP #"L"
 BEQL :LIST
 SEC
 SBC #"1"
 CMP :PTOTAL
 BCS ]TOPLOOP
 STA VTEMP
 JSR PRINT
 HTAB 0
 ZAPLINE
 NULL
 LDX VTEMP
 LDA PARTY,X
 TAY
 LDA PARTY2,X
 TYX
 JSR LOADPLR
 LDA PLRZPOS
 BEQ :HERE
 JSR PRINT
 COLOR ORANGE
 PRSTRING PLRNAME
 COLOR PINK
 ASC " is not here. "
 COLOR WHITE
 SOUND $02;1;LOUD
 NULL
 GETRETURN
 JMP :BOT
:HERE JSR PRINT
 ASC "Comment for "
 COLOR ORANGE
 PRSTRING PLRNAME
 COLOR WHITE
 ASC " : "
 NULL
 GETLINE #40
 BCSL :BOT
 STX PLRQUOTE
]LOOP CPX #0
 BEQ :CHKOK
 LDA $200-1,X
 STA PLRQUOTE,X
 DEX
 BRA ]LOOP
:CHKOK JSR :GETOK
 BCCL :BOT
 LDX VTEMP
 LDA PARTY,X
 TAY
 LDA PARTY2,X
 TYX
 JSR SAVEPLR
 JMP :TOP

:PQUOTE JSR PRINT
 HTAB 0
 ZAPLINE
 ASC "Enter new party name quote : "
 NULL
 GETLINE #22
 BCSL :BOT
 STX PNQUOTE
]LOOP CPX #0
 BEQ :CHKOK2
 LDA $200-1,X
 STA PNQUOTE,X
 DEX
 BRA ]LOOP
:CHKOK2 JSR :GETOK
 BCCL :BOT
 LDX PARTYNUM
 LDA #0
 JSR SAVEPN
 JMP :TOP

:HELP JSR PRINT
 GOTOXY 0;2
 CLEOS
 NULL
 JSR GETFILE
 DFB 2,23 ;Use lines x to y
 STR "HELP/REGISTRY"
 JSR PRINT
 GOTOXY 0;23
 NULL
 GETRETURN
 JMP :TOP

:LIST JSR PRINT
 HTAB 0
 ZAPLINE
 ASC "[C]haracters, characters in a [P]arty, [ESC]-exit : "
 NULL
 LDX #0
 LDA #0
 JSR LOADPLR
 LDA PLRBUFF
 STA :PRECS
 LDA PLRBUFF+1
 STA :PRECS+1
]LOOP JSR KEYIN
 JSR UPPER
 CMP #"C"
 BEQL :CHAR
 CMP #"P"
 BEQ :PRTY
 CMP #$9B
 BNE ]LOOP
 JMP :BOT

:PRTY JSR PRINT
 HTAB 0
 ZAPLINE
 ASC "For party : "
 NULL
 GETLINE #20
 CPX #0
 BEQL :LIST
 PHX
 STX :PP
]LOOP LDA $200-1,X
 JSR UPPER
 STA :PP,X
 DEX
 BNE ]LOOP
 PLX
 CPX #4
 BCSL :NAME
 JSR GETNUM
 CPY #0
 BNEL :NAME
 CPX #0
 BEQL :NAME
:GOPRTY STX :PARTY
 LDA #0
 JSR LOADPN
 BIT PNFREE
 BPL :PRTYOK
:NSP JSR PRINT
 CR
 COLOR PINK
 ASC "No such party. "
 SOUND $25;1;LOUD
 COLOR WHITE
 NULL
 GETRETURN
 JSR PRINT
 ZAPLINE
 CURSORUP
 NULL
 JMP :LIST
:PRTYOK LDA PNSCENARIO
 CMP SCENARIO
 BNE :NSP
 JSR PRINT
 GOTOXY 0;2
 CLEOS
 ASC "Party name : "
 COLOR AQUAMARINE
 PRSTRING PNNAME
 COLOR WHITE
 CR
 ASC "Comment    : "
 NULL
 LDA PNQUOTE
 BNE :PQ2
 JSR PRINT
 COLOR YELLOW
 PRSTRING PNQUOTE
 COLOR WHITE
 NULL
 BRA :GOL2
:PQ2 JSR PRINT
 QUOTE
 COLOR YELLOW
 PRSTRING PNQUOTE
 COLOR WHITE
 QUOTE
 NULL
:GOL2 LDX PARTYNUM
 LDA #0
 JSR LOADPN
 LDA #$FF
 STA :PFLAG
 JMP :GOGO

:NAME JSR PRINT
 CR
 ASC "Wait.."
 NULL
 LDX #0
 LDA #0
 JSR LOADPN
 LDA PNBUFF
 STA :TOTP
 LDX #0
]LOOP CPX :TOTP
 BEQ :DONEPN
 INX
 PHX
 LDA #0
 JSR LOADPN
 BIT PNFREE
 BMI :NXTPN
 LDA PNSCENARIO
 CMP SCENARIO
 BNE :NXTPN
 LDX PNNAME
 CPX :PP
 BNE :NXTPN
]LOOP2 LDA PNNAME,X
 JSR UPPER
 CMP :PP,X
 BNE :NXTPN
 DEX
 BNE ]LOOP2
 PLX
 JMP :GOPRTY
:NXTPN PLX
 BRA ]LOOP
:DONEPN JSR PRINT
 CR
 COLOR PINK
 ASC "Party not found. "
 COLOR WHITE
 SOUND $25;1;LOUD
 NULL
 GETRETURN
 JSR PRINT
 ZAPLINE
 CURSORUP
 ZAPLINE
 CURSORUP
 NULL
 JMP :BOT

:TOTP DS 1
:PFLAG DS 1
:PARTY DS 1
:PP DS 1+20
:PTOTAL DS 1

:CHAR JSR PRINT
 HTAB 0
 ZAPLINE
 ASC "Start listing from character #1"
 CURSORLEFT
 NULL
 LDA #1
 STA :REC
 STZ :REC+1
 GETLINE #3
 BCSL :LIST
 CPX #0
 BEQ :FROM1
 JSR GETNUM
 STX :REC
 STY :REC+1
:FROM1 LDA :REC+1
 CMP :PRECS+1
 BEQ :HMM
 BCC :GO
 BCS :ERR
:HMM LDA :REC
 CMP :PRECS
 BEQ :GO
 BCC :GO
:ERR JSR PRINT
 CR
 COLOR PINK
 ASC "Last character is "
 COLOR YELLOW
 DEC16 :PRECS
 COLOR PINK
 ASC ". "
 COLOR WHITE
 SOUND $25;1;LOUD
 NULL
 GETRETURN
 JSR PRINT
 ZAPLINE
 CURSORUP
 NULL
 JMP :CHAR
:GO STZ :PFLAG
 JSR PRINT
 GOTOXY 0;2
 NULL
 BRA :GO2
:GOGO JSR PRINT
 GOTOXY 0;5
 NULL
 LDA #1
 STA :REC
 STZ :REC+1
:GO2 JSR PRINT
 CLEOS
 LINE "Name               Party Class       Comment"
 CR
 NULL
]LOOP LDX :REC
 LDA :REC+1
 JSR LOADPLR
 BIT PLRFREE
 BMIL :NEXTP
 LDA PLRSCENARIO
 CMP SCENARIO
 BNEL :NEXTP
 BIT :PFLAG
 BPL :NOP
 LDA PLRPARTY
 CMP :PARTY
 BNEL :NEXTP
:NOP LDA PADFLAG
 PHA
 LDA PADCHAR
 PHA
 LDA #$FF
 STA PADFLAG
 LDA #" "
 STA PADCHAR
 JSR PRINT
 COLOR ORANGE
 PRSTRING PLRNAME
 HTAB 21
 COLOR YELLOW
 DEC8 PLRPARTY
 ASC " "
 COLOR GREEN
 PRTABLE PLRCLASS;CLASSTABLE
 COLOR WHITE
 NULL
 LDA PLRQUOTE
 BEQ :NOQ
 JSR PRINT
 HTAB 37
 QUOTE
 COLOR YELLOW
 PRSTRING PLRQUOTE
 COLOR WHITE
 QUOTE
 NULL
:NOQ JSR PRINT
 CR
 NULL
 PLA
 STA PADCHAR
 PLA
 STA PADFLAG
 LDA CV
 CMP #22
 BNE :NEXTP
 LDA :REC+1
 CMP :PRECS+1
 BNE :NTE
 LDA :REC
 CMP :PRECS
 BEQ :NEXTP
:NTE JSR PRINT
 CR
 COLOR PINK
 CENTER "[SPACE]-continue, [ESC]-exit : "
 COLOR WHITE
 NULL
]LOOP3 JSR KEYIN
 CMP #$9B
 BEQL :ESC
 CMP #" "
 BNE ]LOOP3
 JSR PRINT
 GOTOXY 0;4
 CLEOS
 NULL
:NEXTP LDA :REC+1
 CMP :PRECS+1
 BNE :NEXTP2
 LDA :REC
 CMP :PRECS
 BNE :NEXTP2
 JSR PRINT
 GOTOXY 0;23
 NULL
 GETRETURN
 JMP :TOP
:NEXTP2 INCR :REC
 JMP ]LOOP

:REC DS 2
:PRECS DS 2

:ESC JMP START

:GETOK JSR PRINT
 CR
 CR
 ASC "Ok (y/n)? : "
 NULL
]LOOP JSR KEYIN
 JSR UPPER
 CMP #"Y"
 BEQ :YES
 CMP #"N"
 BEQ :NO
 CMP #$9B
 BNE ]LOOP
:NO JSR PRINT
 ASC "No"
 ZAPLINE
 NULL
 CLC
 RTS
:YES JSR PRINT
 ASC "Yes"
 NULL
 SEC
 RTS

WALL JSR PRINT
 HOME
 NULL
 CALL "GAME.WALL"
 JMP START

SYSHIST JSR PRINT
 GOTOXY 0;14
 CLEOS
 NULL
 JSR GETFILE
 DFB 14,23 ;Use lines x to y
 STR "FILES/SYSTEM.UPDATES"
 JMP TOP

HISTORY LDA #14 ;Lines to use in module
 STA VTEMP
 LDA #23
 STA VTEMP+1
 CALL "GAME.PHIST"
 JMP TOP

MBASE CALL "GAME.MESSAGE"
 JMP START

MUSTKNOW JSR PRINT
 GOTOXY 0;14
 CLEOS
 NULL
 JSR GETFILE
 DFB 14,23 ;Use lines x to y
 STR "FILES/MUST.KNOW"
 JMP TOP

LAWS JSR PRINT
 GOTOXY 0;14
 CLEOS
 NULL
 JSR GETFILE
 DFB 14,23 ;Use lines x to y
 STR "FILES/LAWS"
 JMP TOP

NPAD JSR PRINT
 GOTOXY 0;14
 CLEOS
 NULL
 JSR NOTEPAD
 JMP TOP

LIST JSR PRINT
 GOTOXY 0;14
 CLEOS
 ASC "#"
 HTAB 6
 ASC "Name"
 HTAB 28
 ASC "Last call Calls Experience Comment"
 CR
 NULL
 LDX #0
 LDA #0
 JSR LOADPN
 LDA PNBUFF
 STA :RECS
 STZ :CNTR
]LOOP LDA :CNTR
 CMP :RECS
 BEQL :DONE
 INC :CNTR
 LDX :CNTR
 LDA #0
 JSR LOADPN
 LDA PNFREE
 BMIL :NEXT
 LDA PNSCENARIO
 CMP SCENARIO
 BNEL :NEXT
 JSR PRINT
 COLOR YELLOW
 DEC8 :CNTR
 HTAB 4
 NULL
 LDA PNCREDITS
 BEQ :NOCRED
 JSR PRINT
 COLOR ORANGE
 ASC "*"
 NULL
 BRA :GOAQ
:NOCRED JSR PRINT
 ASC " "
 NULL
:GOAQ JSR PRINT
 COLOR AQUAMARINE
 NULL
 LDX PNSCENARIO
 LDA :CNTR
 CMP LEADPRTY-1,X
 BNE :NOLEAD
 JSR PRINT
 COLOR PINK
 NULL
:NOLEAD JSR PRINT
 ASC " "
 PRSTRING PNNAME
 HTAB 28
 COLOR ORANGE
 DATE PNLASTON
 COLOR YELLOW
 ASC " "
 NULL
 LDA PADFLAG
 PHA
 LDA PADCHAR
 PHA
 LDA #$FF
 STA PADFLAG
 LDA #" "
 STA PADCHAR
 JSR PRINT
 DEC16 PNCALLS
 HTAB 44
 COLOR PINK
 DEC32 PNEXP
 COLOR WHITE
 NULL
 LDA PNQUOTE
 BEQ :NOQ
 JSR PRINT
 ASC " "
 QUOTE
 COLOR YELLOW
 PRSTRING PNQUOTE
 COLOR WHITE
 QUOTE
 NULL
:NOQ JSR PRINT
 CR
 NULL
 PLA
 STA PADCHAR
 PLA
 STA PADFLAG
:NEXT LDA CV
 CMP #23
 BNEL ]LOOP
 LDA :CNTR
 CMP :RECS
 BEQ :DONE
 JSR PRINT
 GOTOXY 0;23
 COLOR PINK
 CENTER "[SPACE]-continue, [ESC]-exit : "
 COLOR WHITE
 NULL
]LOOP2 JSR KEYIN
 CMP #" "
 BEQ :CLR
 CMP #$9B
 BNE ]LOOP2
:DONE JSR PRINT
 ZAPLINE
 COLOR WHITE
 NULL
 LDX PARTYNUM
 LDA #0
 JSR LOADPN
 JMP TOP
:CLR JSR PRINT
 GOTOXY 0;15
 CLEOS
 NULL
 JMP ]LOOP
:CNTR DS 1
:RECS DS 1

STATS JSR PRINT
 GOTOXY 0;14
 CLEOS
 COLOR GREEN
 CENTER "System status"
 COLOR WHITE
 CR
 CR
 ASC "The Complex II "
 NULL
 LDA SYSTEMNAME
 BEQ :NONAME
 JSR PRINT
 QUOTE
 COLOR GREEN
 PRSTRING SYSTEMNAME
 COLOR WHITE
 QUOTE
 NULL
:NONAME JSR PRINT
 ASC " ["
 COLOR PINK
 PRSTRING VERSION
 COLOR WHITE
 ASC "]"
 NULL
 LDA SCENARIO
 BEQ :NOSCEN
 TAX
 LDA #0
 JSR LOADSCEN
 JSR PRINT
 GOTOXY 0;17
 ASC "Scenario #"
 COLOR YELLOW
 DEC8 SCENARIO
 COLOR WHITE
 ASC " : "
 COLOR ORANGE
 PRSTRING SCNAME
 COLOR WHITE
 NULL
:NOSCEN LDA SCENARIO
 DEC
 ASL
 TAX
 LDA GAMETURN,X
 STA VTEMP
 LDA GAMETURN+1,X
 STA VTEMP+1
 JSR PRINT
 CR
 CR
 ASC "Turn #"
 COLOR YELLOW
 DEC16 VTEMP
 COLOR WHITE
 NULL
 LDX SCENARIO
 LDA QUESTDONE-1,X
 BPL :GOING
 JSR PRINT
 COLOR PINK
 ASC " (this game completed - see Hall Of Fame)"
 COLOR WHITE
 NULL
:GOING JSR PRINT
 CR
 ASC "Total logons #"
 COLOR YELLOW
 DEC16 LOGONS
 COLOR WHITE
 ASC "; active parties #"
 NULL
 LDX SCENARIO
 LDA PARTIES-1,X
 STA VTEMP
 JSR PRINT
 DEC8 VTEMP
 COLOR WHITE
 ASC " ("
 NULL
 LDA SCENARIO
 DEC
 ASL
 TAX
 LDA PLAYERS,X
 STA VTEMP
 LDA PLAYERS+1,X
 STA VTEMP+1
 JSR PRINT
 DEC16 VTEMP
 COLOR WHITE
 LINE " characters)"
 ASC "Time to next turn : "
 NULL
 JSR TILLNEXT
 JSR PRINT
 GOTOXY 0;23
 ASC "Leading party : "
 COLOR AQUAMARINE
 NULL
 LDX SCENARIO
 LDA LEADPRTY-1,X
 BEQ :NOLEAD
 TAX
 LDA #0
 JSR LOADPN
 LDA SCENARIO
 DEC
 ASL
 ASL
 TAX
 LDY #0
]LOOP LDA LEADEXP,X
 STA :EXP,Y
 INX
 INY
 CPY #4
 BNE ]LOOP
 JSR PRINT
 PRSTRING PNNAME
 COLOR WHITE
 ASC " with "
 COLOR YELLOW
 DEC32 :EXP
 COLOR WHITE
 ASC " exp."
 NULL
 BRA :GOFIN

:NOLEAD JSR PRINT
 COLOR PINK
 ASC "<none>"
 COLOR WHITE
 NULL

:GOFIN LDX PARTYNUM
 LDA #0
 JSR LOADPN
 JMP TOP

:EXP DS 4

CREDITS JSR PRINT
 GOTOXY 0;14
 CLEOS
 NULL
 JSR GETFILE
 DFB 14,23 ;Use lines x to y
 STR "FILES/CREDITS"
 JMP TOP

PROLOG LDA SCENARIO
 ORA #"0"
 STA :FILE+14 ;Make sure it matches with :FILE (below)
 JSR PRINT ;---------------------------------------
 GOTOXY 0;14
 CLEOS
 NULL
 JSR GETFILE
 DFB 14,23 ;Use lines x to y
:FILE STR "FILES/PROLOG.0"
 JMP TOP

HALLFAME JSR PRINT
 GOTOXY 0;14
 CLEOS
 COLOR GREEN
 CENTER "-  Hall of Fame  -"
 COLOR WHITE
 NULL
 LDX #0
 LDA #0
 JSR LOADHOF
 LDA MISCBUFF
 STA :HOFS
 BNE :OK
 JSR PRINT
 GOTOXY 0;16
 COLOR PINK
 CENTER "No games have been completed yet."
 COLOR WHITE
 NULL
 JMP TOP
:OK LDA :HOFS
 STA :CNTR
]LOOP LDA :CNTR
 BEQL :DONE
 LDX :CNTR
 LDA #0
 JSR LOADHOF
 LDA #80-11 ;Center
 SEC
 SBC HOFSCEN
 LSR
 STA :HTAB1+2
 LDA #80-21 ;Center
 LSR
 STA :HTAB2+2
 LDA #80-21 ;Center
 LSR
 STA :HTAB3+2
 LDA #80 ;Center
 SEC
 SBC HOFNAME
 LSR
 STA :HTAB4+2
 JSR PRINT
 GOTOXY 0;16
 CLEOS
:HTAB1 HTAB 0
 ASC "Scenario #"
 COLOR YELLOW
 DEC8 HOFGAME
 COLOR WHITE
 ASC " : "
 COLOR ORANGE
 PRSTRING HOFSCEN
 COLOR WHITE
 CR
 CR
:HTAB2 HTAB 0
 ASC "completed on turn #"
 COLOR YELLOW
 DEC8 HOFTURN
 COLOR WHITE
 CR
:HTAB3 HTAB 0
 ASC "on "
 COLOR YELLOW
 DATE HOFDATE
 COLOR WHITE
 ASC " at "
 COLOR YELLOW
 TIME HOFDATE+2
 COLOR WHITE
 CR
 CENTER "by party"
 CR
:HTAB4 HTAB 0
 COLOR AQUAMARINE
 PRSTRING HOFNAME
 COLOR WHITE
 CR
 NULL
 LDA HOFCOMMENT
 BNE :COMOK
 JSR PRINT
 CENTER "<no comment>"
 CR
 NULL
 BRA :NEXT
:COMOK LDA #78
 SEC
 SBC HOFCOMMENT
 LSR
 STA :HTAB5+2
 JSR PRINT
:HTAB5 HTAB 0
 QUOTE
 PRSTRING HOFCOMMENT
 QUOTE
 CR
 NULL
:NEXT DEC :CNTR
 LDA :CNTR
 BEQ :DONE
 JSR PRINT
 GOTOXY 0;23
 COLOR PINK
 CENTER "[SPACE]-continue, [ESC]-exit : "
 COLOR WHITE
 NULL
]LOOP2 JSR KEYIN
 CMP #" "
 BEQL ]LOOP
 CMP #$9B
 BNE ]LOOP2
:DONE JSR PRINT
 ZAPLINE
 NULL
 JMP TOP
:CNTR DS 1
:HOFS DS 1

CLOCK JSR PRINT
 GOTOXY 0;14
 CLEOS
 SOUND $2B;FOREVER;$60
 COLOR GREEN
 CENTER "The Clockwork"
 COLOR WHITE
 NULL
 LDX #0
 LDA #0
 JSR LOADLOGFILE ;Get first record
 LDA LOGBUFF
 STA :VRECS
 LDA LOGBUFF+1
 STA :VRECS+1
 ORA :VRECS
 BNE :TOP
 JSR PRINT
 CR
 CR
 ASC "Nothing to tell about. "
 NULL
 GETRETURN
 JSR PRINT
 ZAPLINE
 SOUND $20;FOREVER;$80
 NULL
 JMP TOP

:TOP LDA #$FF
 STA :LASTDATE
 STA :LASTTIME
 JSR PRINT
 GOTOXY 0;16
 CLEOS
 NULL

]LOOP LDX :VRECS
 LDA :VRECS+1
 JSR LOADLOGFILE
 LDA :LASTDATE
 CMP LOGDATE
 BNE :DODATE
 LDA :LASTDATE+1
 CMP LOGDATE+1
 BEQ :CHKTIME
:DODATE JSR PRINT
 DATE LOGDATE
 NULL
:CHKTIME LDA :LASTTIME
 CMP LOGTIME
 BNE :DOTIME
 LDA :LASTTIME+1
 CMP LOGTIME+1
 BEQ :DOTEXT
:DOTIME JSR PRINT
 HTAB 11
 TIME LOGTIME
 NULL
:DOTEXT JSR PRINT
 HTAB 18
 NULL
 LDA LOGTYPE ;This a logon entry or a comment?
 BEQ :COMMENT
 CMP #1 ;Log entry?
 BNE :COMMENT
 JSR PRINT
 ASC "Call #"
 COLOR YELLOW
 DEC16 LOGCALL
 COLOR WHITE
 ASC " ("
 NULL
 LDA LOGBAUD
 ASL
 TAX
 LDA :BAUDS,X
 STA CADD3
 LDA :BAUDS+1,X
 STA CADD3+1
 LDY #0
]LOOP2 LDA (CADD3),Y
 BEQ :FIN
 JSR COUT
 INY
 BRA ]LOOP2
:FIN JSR PRINT
 ASC ") by Party : "
 COLOR ORANGE
 NULL
:COMMENT JSR PRINT
 PRSTRING LOGTEXT
 COLOR WHITE
 NULL
 LDA LOGTYPE
 CMP #2
 BNE :DOCR
 JSR PRINT
 COLOR YELLOW
 DEC16 LOGCALL
 COLOR WHITE
 NULL
:DOCR JSR PRINT
 CR
 NULL
 LDA LOGDATE
 STA :LASTDATE
 LDA LOGDATE+1
 STA :LASTDATE+1
 LDA LOGTIME
 STA :LASTTIME
 LDA LOGTIME+1
 STA :LASTTIME+1
 DECR :VRECS
 LDA :VRECS+1
 BNE :RECSOK
 LDA :VRECS
 BEQ :DONE
:RECSOK LDA CV
 CMP #23
 BNEL ]LOOP
 JSR PRINT
 COLOR PINK
 CENTER "[SPACE]-continue, [ESC]-exit : "
 COLOR WHITE
 NULL
]LOOP2 JSR KEYIN
 CMP #" "
 BEQL :TOP
 CMP #$9B
 BNE ]LOOP2
:DONE JSR PRINT
 ZAPLINE
 SOUND $20;FOREVER;$80
 NULL
 JMP TOP

:VRECS DS 2
:LASTDATE DS 2
:LASTTIME DS 2
:BAUDS DA :B0
 DA :B1
 DA :B2
 DA :B3
 DA :B4
 DA :B5
 DA :B6
 DA :B7
 DA :B8
 DA :B9
:B0 ASC "dumbterm",00
:B1 ASC "300 baud",00
:B2 ASC "1200 baud",00
:B3 ASC "2400 baud",00
:B4 ASC "4800 baud",00
:B5 ASC "7200 baud",00
:B6 ASC "9600 baud",00
:B7 ASC "12000 baud",00
:B8 ASC "14400 baud",00
:B9 ASC "19200 baud",00

DLOAD JSR PRINT
 HOME
 SOUND RESET
 NULL
 CALL "GAME.XSEND"
 JMP START

YELLGM JSR PRINT
 GOTOXY 0;14
 CLEOS
 NULL
 LDA $C034
 AND #%1111_0000
 ORA #1 ;Red
 STA $C034
 BIT GMSTATUS
 BMIL :IN
:OUT JSR PRINT
 ASC "Sorry, the GameMaster is '"
 COLOR PINK
 ASC "OUT"
 COLOR WHITE
 ASC "' at the moment. Use the "
 COLOR YELLOW
 ASC "Message Base"
 COLOR WHITE
 ASC " if you wish to leave a message."
 NULL
 JSR GETALL
 JSR PRINT
 SOUND $13;1;$80
 NULL
 JSR GETALL
 JMP TOP

:IN JSR PRINT
 ASC "The words of summoning are spoken.."
 SOUND $2A;1;LOUD
 NULL
 LDX #3
]LOOP PHX
 JSR :BEEPIT
 LDX #2
 JSR :WAIT
 JSR :BEEPIT
 LDX #4
 JSR :WAIT
 JSR PRINT
 ASC "."
 NULL
 PLX
 DEX
 BNE ]LOOP
 JSR PRINT
 CR
 CR
 ASC "The GameMaster has been called.."
 NULL
 JMP TOP

:WAIT LDA $C061
 BMI :WAITOUT
 PHX
 LDA #0
 JSR $FCA8
 PLX
 DEX
 BNE :WAIT
:WAITOUT RTS

:BEEPIT LDX #4
]LOOP LDA $C061
 BMI :BEEPOUT
 PHX
 JSR :BEEP
 PLX
 DEX
 BNE ]LOOP
:BEEPOUT RTS

:BEEP LDX #$20
]LOOP LDA #$04
 JSR $FCA8
 STA $C030
 LDA #$24
 JSR $FCA8
 STA $C030
 DEX
 BNE ]LOOP
 RTS

TIPS JSR PRINT
 GOTOXY 0;14
 CLEOS
 NULL
 JSR GETFILE
 DFB 14,23 ;Use lines x to y
 STR "HELP/TIPS.BEGINNERS"
 JMP TOP

PNOTICE JSR PRINT
 GOTOXY 0;14
 CLEOS
 NULL
 JSR GETFILE
 DFB 14,23 ;Use lines x to y
 STR "FILES/PUBLIC.NOTICE"
 JMP TOP

CHANGE JSR PRINT
 GOTOXY 0;14
 CLEOS
 LINE "A) Change logon password"
 LINE "B) Change party name"
 NULL
 LDX PARTYNUM
 LDA #0
 JSR LOADPN
 BIT DUMBTERM
 BMI :SKIP
 JSR PRINT
 LINE "C) Link host/terminal program"
 NULL
:SKIP BIT SOUNDFLAG
 BPL :SKIP3
 JSR PRINT
 ASC "D) Turn background music "
 NULL
 LDA PNSOUNDL
 JSR :ONOFF
 JSR PRINT
 CR
 ASC "E) Turn sounds "
 NULL
 LDA PNSOUNDS
 JSR :ONOFF
 JSR PRINT
 CR
 NULL
:SKIP3 JSR PRINT
 CR
 ASC "Select an option : "
 NULL
]KEYLOOP JSR KEYIN
 JSR UPPER
 LDX :KEYS
]LOOP2 CMP :KEYS,X
 BEQ :GOTONE
 DEX
 BNE ]LOOP2
 JMP ]KEYLOOP
:GOTONE DEX
 TXA
 ASL
 TAX
 JMP (:TABLE,X)

:KEYS DFB :ENDKEYS-*-1
 DFB $9B
 DFB "A"
 DFB "B"
 DFB "C"
 DFB "D"
 DFB "E"
:ENDKEYS

:TABLE DA :EXIT
 DA :PASSWORD
 DA :PNAME
 DA :LINK
 DA :SOUND
 DA :SOUND2

:ONOFF CMP #0
 BNE :OFF
:ON JSR PRINT
 ASC "on"
 NULL
 RTS
:OFF JSR PRINT
 ASC "off"
 NULL
 RTS

:EXIT JSR PRINT
 GOTOXY 0;14
 CLEOS
 NULL
 JMP TOP

:LINK BIT DUMBTERM
 BMI ]KEYLOOP
 JSR PRINT
 HOME
 SOUND RESET
 NULL
 CALL "GAME.LINKTP"
 JMP START

:SOUND BIT SOUNDFLAG ;No sound if user isn't linked with sound
 BPLL ]KEYLOOP
 LDX PARTYNUM
 LDA #0
 JSR LOADPN
 LDA PNSOUNDL
 EOR #$FF
 STA PNSOUNDL
 JSR PRINT
 GOTOXY 0;14
 CLEOS
 ASC "Background music is now "
 NULL
 LDX PARTYNUM
 LDA #0
 JSR SAVEPN
 BIT PNSOUNDL
 BPL :BGSOFF
:BGSON JSR PRINT
 ASC "on."
 SOUND $20;FOREVER;$80
 NULL
 JMP TOP
:BGSOFF LDA PNSOUNDL
 PHA
 LDA PNSOUNDS
 PHA
 LDA #$FF
 STA PNSOUNDL
 STA PNSOUNDS
 JSR PRINT
 ASC "off."
 SOUND RESET
 NULL
 PLA
 STA PNSOUNDS
 PLA
 STA PNSOUNDL
 JMP TOP

:SOUND2 BIT SOUNDFLAG ;No sound if user isn't linked with sound
 BPLL ]KEYLOOP
 LDX PARTYNUM
 LDA #0
 JSR LOADPN
 LDA PNSOUNDS
 EOR #$FF
 STA PNSOUNDS
 JSR PRINT
 GOTOXY 0;14
 CLEOS
 ASC "Sounds are now "
 NULL
 LDX PARTYNUM
 LDA #0
 JSR SAVEPN
 BIT PNSOUNDS
 BPL :SOFF
:SON JSR PRINT
 ASC "on."
 SOUND $25;1;$80
 NULL
 JMP TOP
:SOFF JSR PRINT
 ASC "off."
 NULL
 JMP TOP

:PNAME JSR PRINT
 GOTOXY 0;14
 CLEOS
 ASC "Enter a new party name : "
 NULL
 GETLINE #20
 CPX #0
 BEQL :PNEXIT
 STX :NAME
]LOOP LDA $200-1,X
 STA :NAME,X
 JSR UPPER
 STA :NAMEU,X
 DEX
 BNE ]LOOP
 JSR PRINT
 CR
 CR
 COLOR PINK
 ASC "Wait.."
 COLOR WHITE
 CURSOROFF
 NULL
 LDX #0
 LDA #0
 JSR LOADPN
 LDA PNBUFF
 STA :NUMPARTIES

 STZ :X
]LOOP LDX :X
 CPX :NUMPARTIES
 BEQ :PDONE
 INX
 STX :X
 CPX PARTYNUM ;Skip your own
 BEQ ]LOOP
 LDA #0
 JSR LOADPN
 LDA PNFREE
 BMI ]LOOP
 LDY PNNAME
 CPY :NAME
 BNE ]LOOP
]LOOP2 LDA PNNAME,Y
 JSR UPPER
 CMP :NAMEU,Y
 BNE ]LOOP
 DEY
 BNE ]LOOP2
 JSR PRINT
 HTAB 0
 ZAPLINE
 CURSORON
 COLOR PINK
 ASC "Sorry, that name is already in use. "
 COLOR WHITE
 NULL
 GETRETURN
 JMP :PNAME
:PDONE LDX PARTYNUM
 LDA #0
 JSR LOADPN
 LDX :NAME
 STX PNNAME
]LOOP LDA :NAME,X
 STA PNNAME,X
 DEX
 BNE ]LOOP
 JSR PRINT
 HTAB 0
 ZAPLINE
 CURSORON
 COLOR PINK
 ASC "Party name changed (please remember it). "
 COLOR WHITE
 NULL
 LDX PARTYNUM
 LDA #0
 JSR SAVEPN
 GETRETURN
 JSR PRINT
 GOTOXY 0;14
 CLEOS
 NULL
 JMP TOP
:PNEXIT LDX PARTYNUM
 LDA #0
 JSR LOADPN
 JMP CHANGE
:NAME DS 1+20
:NAMEU DS 1+20
:NUMPARTIES DS 1
:X DS 1

:PASSWORD JSR PRINT
 GOTOXY 0;14
 CLEOS
 ASC "Enter current password : "
 NULL
 STZ ECHO
 GETLINE #8
 DEC ECHO
 CPX #0
 BEQL CHANGE
 CPX PNPASS
 BNEL :WRONG
]LOOP LDA $200-1,X
 CMP PNPASS,X
 BNEL :WRONG
 DEX
 BNE ]LOOP
 JSR PRINT
 GOTOXY 0;16
 ASC "Enter a new password : "
 NULL
 STZ ECHO
 GETLINE #8
 DEC ECHO
 CPX #0
 BEQL :ABORT
 STX :PWORD
]LOOP LDA $200-1,X
 STA :PWORD,X
 DEX
 BNE ]LOOP
 JSR PRINT
 GOTOXY 0;17
 ASC "Enter password again : "
 NULL
 STZ ECHO
 GETLINE #8
 DEC ECHO
 CPX #0
 BEQL :ABORT
 CPX :PWORD
 BNE :WRONG
]LOOP LDA $200-1,X
 CMP :PWORD,X
 BNE :WRONG
 DEX
 BNE ]LOOP
 JSR PRINT
 GOTOXY 0;14
 CLEOS
 ASC "Password changed. Please "
 COLOR PINK
 ASC "remember"
 COLOR WHITE
 ASC " it."
 NULL
 LDX PARTYNUM
 LDA #0
 JSR LOADPN
 LDX :PWORD
 STX PNPASS
]LOOP LDA $200-1,X
 STA PNPASS,X
 DEX
 BNE ]LOOP
 LDX PARTYNUM
 LDA #0
 JSR SAVEPN
 JMP TOP

:WRONG JSR PRINT
 GOTOXY 0;14
 CLEOS
 COLOR PINK
 ASC "Wrong."
 COLOR WHITE
 SOUND $02;1;LOUD
 NULL
 JMP TOP

:ABORT JSR PRINT
 GOTOXY 0;14
 CLEOS
 COLOR PINK
 ASC "Aborted."
 COLOR WHITE
 NULL
 JMP TOP
:PWORD DS 1+8

LOGOFF JSR PRINT
 GOTOXY 0;14
 CLEOS
 SOUND $13;1;$80
 COLOR PINK
 ASC "Logoff. Are you sure (y/n)? : "
 COLOR WHITE
 NULL
]LOOP JSR KEYIN
 JSR UPPER
 CMP #"Y"
 BEQ :OFF
 CMP #"N"
 BNE ]LOOP
 JSR PRINT
 ASC "No"
 CURSOROFF
 ZAPLINE
 NULL
 JMP TOP
:OFF JSR PRINT
 ASC "Yes"
 NULL
 CALL "GAME.GOODBYE"
 JMP DROP

HOTLIST LDA WORDWRAP
 PHA
 STZ WORDWRAP
 JSR PRINT
 GOTOXY 0;14
 CLEOS
 ASC "Name"
 HTAB 21
 ASC "Party"
 HTAB 42
 ASC "Offense"
 HTAB 58
 LINE "Status   Reward #Jail"
 NULL
 PLA
 STA WORDWRAP
 STZ :CNTR2
 STZ :CNTR2+1
 LDX #0
 LDA #0
 JSR LOADPLR
 LDA PLRBUFF
 STA :RECS
 LDA PLRBUFF+1
 STA :RECS+1
 STZ :CNTR
 STZ :CNTR+1
]LOOP LDA :CNTR+1
 CMP :RECS+1
 BNE :OK
 LDA :CNTR
 CMP :RECS
 BEQL :DONE
:OK INCR :CNTR
 LDX :CNTR
 LDA :CNTR+1
 JSR LOADPLR
 BIT PLRFREE
 BMI ]LOOP
 LDA PLRSCENARIO
 CMP PNSCENARIO
 BNE ]LOOP
 LDA PLRPASSAULTS
 ORA PLRPASSAULTS+1
 ORA PLRPKILLS
 ORA PLRPKILLS+1
 BEQ ]LOOP
 LDX PLRPARTY
 LDA #0
 JSR LOADPN
 JSR PRINT
 COLOR ORANGE
 PRSTRING PLRNAME
 HTAB 21
 COLOR AQUAMARINE
 PRSTRING PNNAME
 COLOR WHITE
 HTAB 42
 NULL
 STZ :FLAG
 LDA PLRPKILLS
 BEQ :NOK
 JSR PRINT
 COLOR PINK
 ASC "murder"
 COLOR WHITE
 NULL
 LDA #$FF
 STA :FLAG
:NOK LDA PLRPASSAULTS
 BEQ :NOASS
 BIT :FLAG
 BPL :ASS2
 JSR PRINT
 ASC ", "
 NULL
:ASS2 JSR PRINT
 COLOR YELLOW
 ASC "assault"
 COLOR WHITE
 NULL
:NOASS JSR PRINT
 HTAB 58
 NULL
 BIT PLRARRESTFLAG
 BPL :FREE
 JSR PRINT
 COLOR ORANGE
 ASC "arrested"
 NULL
 BRA :CONT
:FREE BVC :FREE2
 JSR PRINT
 COLOR PINK
 ASC "in jail"
 NULL
 BRA :CONT
:FREE2 JSR PRINT
 COLOR GREEN
 ASC "free"
 NULL
:CONT JSR CALCREWARD
 LDA PADFLAG
 PHA
 LDA PADCHAR
 PHA
 LDA #$FF
 STA PADFLAG
 LDA #" "
 STA PADCHAR
 BIT PLRARRESTFLAG
 BVS :JAILED
 JSR PRINT
 HTAB 68
 COLOR YELLOW
 DEC16 REWARD
 COLOR WHITE
 NULL
:JAILED JSR PRINT
 HTAB 75
 COLOR YELLOW
 DEC8 PLRJAILED
 COLOR WHITE
 CR
 NULL
 PLA
 STA PADCHAR
 PLA
 STA PADFLAG
 INCR :CNTR2
 LDA CV
 CMP #23
 BNEL ]LOOP
 LDA :CNTR+1
 CMP :RECS+1
 BNE :OKSPC
 LDA :CNTR
 CMP :RECS
 BEQ :DONE
:OKSPC JSR PRINT
 GOTOXY 0;23
 COLOR PINK
 CENTER "[SPACE]-continue, [ESC]-exit : "
 COLOR WHITE
 NULL
]LOOP2 JSR KEYIN
 CMP #" "
 BEQ :CLR
 CMP #$9B
 BNE ]LOOP2
:DONE JSR PRINT
 ZAPLINE
 COLOR WHITE
 NULL
 LDA :CNTR2
 ORA :CNTR2+1
 BNE :SOME
 JSR PRINT
 CR
 ASC "No-one on the list."
 NULL
:SOME LDX PARTYNUM
 LDA #0
 JSR LOADPN
 JMP TOP
:CLR JSR PRINT
 GOTOXY 0;15
 CLEOS
 NULL
 JMP ]LOOP

:RECS DS 2
:CNTR DS 2
:CNTR2 DS 2
:FLAG DS 1

CALCREWARD CLC
 XCE
 REP #$30
 LDA #0
 LDX PLRPASSAULTS
]LOOP CPX #0
 BEQ :OK
 CLC
 ADC #250
 DEX
 BRA ]LOOP
:OK LDX PLRPKILLS
]LOOP CPX #0
 BEQ :DONE
 CLC
 ADC #1000
 DEX
 BRA ]LOOP
:DONE STA REWARD
 SEC
 XCE
 RTS
REWARD DS 2

MIRROR JSR PRINT
 HOME
 COLOR WHITE
 CENTER "Mirror Sketch"
 CR
 MTON
 INVERSE
 COLOR YELLOW
 CENTER "LLLLLLLLLLLLL"
 COLOR WHITE
 NORMAL
 MTOFF
 CR
 NULL

 LDX PARTYNUM
 LDA #0
 JSR LOADPN

 STZ :TOTAL
 STZ :DEAD
 STZ :TOTEXP
 STZ :TOTEXP+1
 STZ :TOTEXP+2
 STZ :TOTEXP+3
 LDX NUMPARTY
]LOOP LDA PARTY-1,X
 ORA PARTY2-1,X
 BEQ :NO
 INC :TOTAL
 PHX
 LDA PARTY2-1,X
 TAY
 LDA PARTY-1,X
 TAX
 TYA
 JSR LOADPLR
 CLC
 XCE
 REP #$30
 LDA :TOTEXP
 CLC
 ADC PLREXP
 STA :TOTEXP
 LDA :TOTEXP+2
 ADC PLREXP+2
 STA :TOTEXP+2
 SEC
 XCE
 LDA PLRCOND
 AND #%1000_0000
 BEQ :ALIVE
 INC :DEAD
:ALIVE PLX
:NO DEX
 BNE ]LOOP

 JSR PRINT
 ASC "Party name : "
 COLOR AQUAMARINE
 PRSTRING PNNAME
 COLOR WHITE
 NULL
 LDA PNQUOTE
 BEQ :NOQ
 JSR PRINT
 ASC "  "
 QUOTE
 COLOR YELLOW
 PRSTRING PNQUOTE
 COLOR WHITE
 QUOTE
 NULL
:NOQ JSR PRINT
 CR
 CR
 ASC "Total calls to system   : "
 COLOR YELLOW
 DEC16 PNCALLS
 COLOR WHITE
 CR
 ASC "Last time on the system : "
 COLOR GREEN
 DATE PNLASTON
 ASC "  "
 TIME PNLASTON+2
 COLOR WHITE
 CR
 ASC "Quests completed        : "
 COLOR YELLOW
 NULL
 LDA PNCREDITS
 BNE :SOMEC
 JSR PRINT
 ASC "none"
 NULL
 BRA :CE
:SOMEC JSR PRINT
 DEC8 PNCREDITS
 NULL
:CE JSR PRINT
 COLOR WHITE
 CR
 ASC "Collective experience   : "
 COLOR PINK
 DEC32 PNEXP
 COLOR WHITE
 NULL
 LDA :DEAD
 BEQ :OVER
 JSR PRINT
 ASC " ("
 COLOR YELLOW
 DEC32 :TOTEXP
 COLOR WHITE
 ASC " total exp)"
 NULL
:OVER JSR PRINT
 CR
 NULL
 LDA :TOTAL
 BNE :TOTOK
 JSR PRINT
 CR
 ASC "You have no characters in your party."
 GOTOXY 0;23
 NULL
 GETRETURN
 JMP START
:TOTOK JSR PRINT
 ASC "Characters in party     : "
 COLOR YELLOW
 DEC8 :TOTAL
 COLOR WHITE
 NULL
 LDA :DEAD
 BEQ :OK
 JSR PRINT
 ASC " ("
 COLOR YELLOW
 DEC8 :DEAD
 COLOR PINK
 ASC " dead"
 COLOR WHITE
 ASC ")"
 NULL
:OK JSR PRINT
 CR
 CR
 ASC "# Name"
 HTAB 23
 LINE "Created   Lvl Class       Position Points  Experience"
 NULL
 LDX #0
 LDY #1
]LOOP LDA PARTY,X
 ORA PARTY2,X
 BEQL :NO2
 STY VTEMP
 PHX
 PHY
 LDA PARTY2,X
 TAY
 LDA PARTY,X
 TAX
 TYA
 JSR LOADPLR
 JSR PRINT
 COLOR YELLOW
 DEC8 VTEMP
 COLOR WHITE
 NULL
 LDA PADFLAG
 PHA
 LDA PADCHAR
 PHA
 LDA #$FF
 STA PADFLAG
 LDA #" "
 STA PADCHAR
 LDA PLRCOND
 AND #%1000_0000
 BNE :DEADN
 JSR PRINT
 ASC " "
 NULL
 BRA :GOGO
:DEADN JSR PRINT
 ASC "*"
 NULL
:GOGO JSR PRINT
 COLOR ORANGE
 PRSTRING PLRNAME
 HTAB 23
 COLOR GREEN
 DATE PLRMADE
 ASC " "
 COLOR YELLOW
 DEC8 PLRLVLREAL
 ASC " "
 COLOR GREEN
 PRTABLE PLRCLASS;CLASSTABLE
 HTAB 49
 NULL
 LDA PLRZPOS
 BNE :DUNG
 JSR PRINT
 COLOR ORANGE
 ASC "<Castle>"
 NULL
 BRA :CONT
:DUNG JSR PRINT
 COLOR YELLOW
 PAD2 PLRXPOS
 COLOR WHITE
 ASC ","
 COLOR YELLOW
 PAD2 PLRYPOS
 DEC8 PLRZPOS
 NULL
:CONT JSR PRINT
 ASC " "
 COLOR AQUAMARINE
 DEC8NEG PLRCURRPNTS
 COLOR WHITE
 ASC "/"
 COLOR AQUAMARINE
 DEC8 PLRMAXPNTS
 ASC " "
 COLOR PINK
 DEC32 PLREXP
 COLOR WHITE
 CR
 NULL
 PLA
 STA PADCHAR
 PLA
 STA PADFLAG
 PLY
 INY
 PLX
:NO2 INX
 CPX :TOTAL
 BNEL ]LOOP

 JSR PRINT
 GOTOXY 0;23
 COLOR WHITE
 ASC "[1-"
 DEC8 :TOTAL
 ASC "]-character in detail, [ESC]-exit : "
 NULL
]LOOP JSR KEYIN
 CMP #$9B
 BEQL :ESC
 SEC
 SBC #"1"
 CMP :TOTAL
 BCS ]LOOP
:DISP1 STA :PLRCNTR
 TAX
 LDA PARTY2,X
 TAY
 LDA PARTY,X
 TAX
 TYA
 JSR LOADPLR
 JSR PRINT
 GOTOXY 0;2
 CLEOS
 ASC "Name : "
 COLOR ORANGE
 PRSTRING PLRNAME
 COLOR WHITE
 ASC " ("
 PRTABLE PLRCLASS;CLASSTABLE
 COLOR WHITE
 ASC ")"
 NULL
 LDA PLRQUOTE
 BEQ :NOQP
 JSR PRINT
 ASC "  "
 QUOTE
 COLOR YELLOW
 PRSTRING PLRQUOTE
 COLOR WHITE
 QUOTE
 NULL
:NOQP JSR PRINT
 CR
 CR
 ASC "Created   : "
 COLOR GREEN
 DATE PLRMADE
 COLOR WHITE
 HTAB 40
 ASC "Age          : "
 COLOR YELLOW
 DEC8 PLRAGE
 COLOR WHITE
 CR
 ASC "Strength  : "
 COLOR YELLOW
 PAD2 PLRST
 COLOR WHITE
 HTAB 40
 ASC "Experience   : "
 COLOR PINK
 DEC32 PLREXP
 COLOR WHITE
 ASC " (level "
 COLOR YELLOW
 DEC8 PLRLVLREAL
 COLOR WHITE
 ASC ")"
 CR
 ASC "Dexterity : "
 COLOR YELLOW
 PAD2 PLRDX
 COLOR WHITE
 HTAB 40
 ASC "Honors       : "
 COLOR YELLOW
 NULL
 LDA PLRCREDITS
 BNE :CRED
 JSR PRINT
 ASC "none"
 NULL
 BRA :OVC
:CRED JSR PRINT
 DEC8 PLRCREDITS
 NULL
:OVC JSR PRINT
 COLOR WHITE
 CR
 ASC "IQ        : "
 COLOR YELLOW
 PAD2 PLRIQ
 COLOR WHITE
 HTAB 40
 ASC "Gold         : "
 COLOR YELLOW
 DEC32 PLRGOLD
 COLOR WHITE
 CR
 ASC "Health    : "
 COLOR YELLOW
 PAD2 PLRHT
 COLOR WHITE
 HTAB 40
 ASC "Hit points   : "
 COLOR YELLOW
 DEC8NEG PLRHP
 COLOR WHITE
 ASC "/"
 COLOR YELLOW
 DEC8 PLRHP+1
 COLOR WHITE
 CR
 ASC "Action points : "
 COLOR YELLOW
 DEC8NEG PLRCURRPNTS
 COLOR WHITE
 ASC "/"
 COLOR YELLOW
 DEC8 PLRMAXPNTS
 COLOR WHITE
 HTAB 40
 ASC "Position     : "
 NULL
 LDA PLRZPOS
 BNE :INDUNG
 JSR PRINT
 COLOR ORANGE
 ASC "Castle"
 NULL
 BRA :PCONT
:INDUNG JSR PRINT
 COLOR YELLOW
 PAD2 PLRXPOS
 COLOR WHITE
 ASC ","
 COLOR YELLOW
 PAD2 PLRYPOS
 COLOR WHITE
 ASC " level "
 COLOR YELLOW
 DEC8 PLRZPOS
 NULL
:PCONT JSR PRINT
 COLOR WHITE
 CR
 ASC "Spell points  : "
 COLOR YELLOW
 DEC8NEG PLRMAGIC
 COLOR WHITE
 ASC "/"
 COLOR YELLOW
 DEC8 PLRMAGICMAX
 COLOR WHITE
 HTAB 40
 ASC "Armour class : "
 COLOR AQUAMARINE
 DEC8NEG PLRAC
 COLOR WHITE
 CR
 ASC "Condition : "
 COLOR AQUAMARINE
 PRCOND PLRCOND
 COLOR WHITE
 CR
 CR
 ASC "Criminal record :-"
 CR
 NULL
 LDA CV
 DEC
 STA :RXY+3
 LDA PLRPKILLSMAX
 ORA PLRPKILLSMAX+1
 ORA PLRPASSAULTSMAX
 ORA PLRPASSAULTSMAX+1
 BNE :SOME
 JSR PRINT
 CR
 COLOR AQUAMARINE
 ASC "None"
 COLOR WHITE
 NULL
 JMP :END
:SOME JSR PRINT
 CR
 NULL
 LDA PLRPKILLSMAX
 BEQ :ASS
 JSR PRINT
 COLOR PINK
 ASC "Murder"
 COLOR WHITE
 HTAB 15
 NULL
 LDA PLRPKILLSMAX
 JSR :DOCOUNT
:ASS JSR PRINT
 CR
 NULL
 LDA PLRPASSAULTSMAX
 BEQ :ZZ2
 JSR PRINT
 COLOR YELLOW
 ASC "Assault"
 COLOR WHITE
 HTAB 15
 NULL
 LDA PLRPASSAULTSMAX
 JSR :DOCOUNT

:ZZ2 JSR PRINT
 CR
 CR
 ASC "Times in jail : "
 COLOR YELLOW
 DEC8 PLRJAILED
 COLOR WHITE
 NULL

:CURRENT LDA PLRPKILLS
 ORA PLRPASSAULTS
 BEQL :END
 JSR PRINT
:RXY GOTOXY 40;0
 ASC "Pending charges :-"
 CR
 CR
 NULL
 LDA PLRPKILLS
 BEQ :ASS2
 JSR PRINT
 HTAB 40
 COLOR PINK
 ASC "Murder"
 COLOR WHITE
 HTAB 55
 NULL
 LDA PLRPKILLS
 JSR :DOCOUNT
:ASS2 JSR PRINT
 CR
 NULL
 LDA PLRPASSAULTS
 BEQ :ZEND
 JSR PRINT
 HTAB 40
 COLOR YELLOW
 ASC "Assault"
 COLOR WHITE
 HTAB 55
 NULL
 LDA PLRPASSAULTS
 JSR :DOCOUNT

:ZEND JSR PRINT
 CR
 CR
 HTAB 40
 ASC "Current status : "
 NULL
 BIT PLRARRESTFLAG
 BVS :INJAIL
 BPL :FREE
 JSR PRINT
 COLOR ORANGE
 ASC "arrested"
 COLOR WHITE
 NULL
 BRA :END
:INJAIL JSR PRINT
 COLOR PINK
 ASC "in jail"
 COLOR WHITE
 NULL
 BRA :END
:FREE JSR PRINT
 COLOR GREEN
 ASC "wanted"
 COLOR WHITE
 NULL

:END JSR PRINT
 COLOR WHITE
 GOTOXY 0;23
 ASC "Arrow keys select character; [ESC]-exit : "
 NULL
]LOOP JSR KEYIN
 CMP #"H"-$40
 BEQ :LEFT1
 CMP #"K"-$40
 BEQ :LEFT1
 CMP #"J"-$40
 BEQ :RIGHT1
 CMP #"U"-$40
 BEQ :RIGHT1
 CMP #$9B
 BNE ]LOOP
 JMP MIRROR

:LEFT1 LDA :PLRCNTR
 BNE :L1OK
 LDA :TOTAL
:L1OK DEC
 BRA :GOLOAD
:RIGHT1 LDA :PLRCNTR
 INC
 CMP :TOTAL
 BCC :GOLOAD
 LDA #0
:GOLOAD JMP :DISP1

:PLRCNTR DS 1

:DOCOUNT STA VTEMP
 JSR PRINT
 COLOR YELLOW
 DEC8 VTEMP
 COLOR WHITE
 ASC " count"
 NULL
 LDA VTEMP
 CMP #1
 BEQ :DCEND
 JSR PRINT
 ASC "s"
 NULL
:DCEND RTS

:ESC LDX PARTYNUM
 LDA #0
 JSR LOADPN
 JMP START

:TOTAL DS 1
:DEAD DS 1
:TOTEXP DS 4

TILLNEXT MLI_GET_TIME
 JSR :GETTIME
 LDA #23
 STA :TURNHOUR
 LDA #59
 STA :TURNMIN
 LDA DAYSTOGO
 BNE :NOX
 BIT XTRATIME
 BPL :NOX
 LDA TURNTIME+1
 DEC
 BPL :THOK
 LDA #23
:THOK STA :TURNHOUR
 LDA TURNTIME
 DEC
 BPL :TMOK
 LDA #59
:TMOK STA :TURNMIN
:NOX LDA DAYSTOGO
 BEQ :TIME
 DEC
:TIME STA :DAYS
 LDA #60
 SEC
 SBC :SECOND
 STA :SS
 LDA :TURNMIN
 SEC
 SBC $BF92
 STA :MM
 LDA :TURNHOUR
 SBC $BF93
 STA :HH
 LDA :SS
 CMP #60
 BNE :OKX
 STZ :SS
 INC :MM
 LDA :MM
 CMP #60
 BNE :OKX
 STZ :MM
 INC :HH
:OKX BIT XTRATIME
 BPL :SAYIT
 LDA DAYSTOGO
 BEQ :SAYIT
 LDA :MM
 CLC
 ADC TURNTIME
 STA :MM
 CMP #60
 BCC :OK
 SBC #60
 STA :MM
 INC :HH
:OK LDA :HH
 CLC
 ADC TURNTIME+1
 STA :HH
 CMP #24
 BCC :SAYIT
 SBC #24
 STA :HH
 INC :DAYS
:SAYIT LDA :CURRDAY
 CMP WAITDAY
 BEQ :SAYIT2
 DEC :DAYS
:SAYIT2 LDA :DAYS
 BEQ :HRS
 BMI :NOW
 JSR PRINT
 COLOR YELLOW
 DEC8 :DAYS
 COLOR WHITE
 ASC " days, "
 NULL
:HRS LDA :HH
 BEQ :MINS
 BMI :MINS
 JSR PRINT
 COLOR YELLOW
 PAD2 :HH
 COLOR WHITE
 ASC " hours, "
 NULL
:MINS LDA :MM
 BEQ :SECS
 BMI :NOW
 JSR PRINT
 COLOR YELLOW
 PAD2 :MM
 COLOR WHITE
 ASC " minutes, "
 NULL
:SECS JSR PRINT
 COLOR YELLOW
 PAD2 :SS
 COLOR WHITE
 ASC " seconds"
 CLEOL
 NULL
 RTS

:NOW JSR PRINT
 CLEOL
 COLOR PINK
 ASC "none - gameturn pending"
 COLOR WHITE
 NULL
 RTS

:DAYS DS 1
:HH DS 1
:MM DS 1
:SS DS 1

:TURNHOUR DS 1
:TURNMIN DS 1

:SECOND DS 1
:CURRDAY DS 1

:GETTIME CLC
 XCE
 REP #$30
 PushWord #0
 PushWord #0
 PushWord #0
 PushWord #0
 Tool $0D03 ;ReadTimeHex
 SEC
 XCE
 PLA
 STA :SECOND
 PLA
 PLA
 PLA
 PLA
 PLA
 PLA
 PLA
 STA :CURRDAY
 RTS

CABINET JSR PRINT
 HOME
 SOUND RESET
 NULL
 CALL "GAME.CAB"
 JMP START

 do 0
 GOTOXY 0;14
 CLEOS
 LINE "[U]pload"
 LINE "[D]ownload"
 CR
 ASC "Select an option : "
 NULL
]LOOP JSR KEYIN
 JSR UPPER
 CMP #"U"
 BEQ :UP
 CMP #"D"
 BEQ :DOWN
 CMP #$9B
 BNE ]LOOP
 JSR PRINT
 GOTOXY 0;14
 CLEOS
 NULL
 JMP TOP
:UP JSR PRINT
 HOME
 NULL
 CALL "GAME.XR"
 JMP START
:DOWN JSR PRINT
 HOME
 NULL
 CALL "GAME.XS"
 JMP START
 fin

 LST ON
MODEND EQU *
 LST OFF

 do M16PLUS
 SAV RUN/MODULES/GAME.INFO
 fin

 END
