*-------------------------------
* GAME.INSPECT
*-------------------------------
 DAT
 LST OFF

 ORG $8000 ;Always

 USE MACROS
 USE EQUATES
 USE VARS
 USE LIB.JMP
 USE PLR.DSECT
 USE ITEM.DSECT
 USE ITEM2.DSECT

 TYP $F4
 do M16PLUS-1
 DSK RUN/MODULES/GAME.INSPECT
 fin

 MODID "GAME.INSPECT"

START JSR PRINT
 GOTOXY 0;14
 CURSOROFF
 INVERSE
 COLOR YELLOW
 ZAPLINE
 NORMAL
 VTAB 14
 COLOR ORANGE
 CENTER " Inspect "
 COLOR YELLOW
 CR
 COLOR WHITE
 CURSORON
 NULL

START2 LDX NUMPARTY
]LOOP LDA CURPARTY2-1,X
 BNE :OK
 LDA CURPARTY-1,X
 BNE :OK
 DEX
 BNE ]LOOP
 DEATH ;Should be at least one person in the party
:OK STX NUMP
 JSR CLRBOT
 JSR PRINT
 COLOR AQUAMARINE
 CURSORON
 LINE " 7 8 9"
 LINE "  \|/"
 LINE " 4-x-6"
 LINE "  /|\"
 LINE " 1 2 3"
 COLOR WHITE
 GOTOXY 10;15
 ASC "[V]iew : "
 GOTOXY 10;16
 ASC "[RETURN]-inspect"
 GOTOXY 10;17
 ASC "[L]ist/page"
 GOTOXY 10;18
 ASC "[G]et"
 GOTOXY 10;19
 ASC "[H]elp   [P]ick lock"
 GOTOXY 10;20
 ASC "[E]xit   [C]lose"
 CURSOROFF
 NULL

TOPXY JSR GETMAST

 LDA PLRXPOS ;Get top-left co-ordinate
 SEC
 SBC #4
 STA ANKX
 LDA PLRYPOS
 SEC
 SBC #4
 STA ANKY

 LDA #4
 STA XLOC
 STA YLOC

 STZ CNTR

TOPC JSR GETMAST
 JSR PRINT
 GOTOXY 19;15
 CLEOL
 PRSTRING PLRNAME
 NULL
 LDX PLRXPOS
 LDY PLRYPOS
 LDA PLRZPOS
 JSR SHOWMAP
 JSR GETMAST

TOP JSR PRINT
 GOTOXY 68;12
 CLEOL
 INVERSE
 ASC " "
 NORMAL
 CURSOROFF
 NULL
]LOOP JSR TICKTOCK
 JSR WAITIN
 BCS :YES2
 JSR GETLOC
 JSR DOSPC
 JSR WAITIN
 BCS :YES
 JSR GETLOC
 JSR DOSHP
 JMP ]LOOP
:YES PHA
 JSR GETLOC
 JSR DOSHP
 PLA
 JMP GOTKEY
:YES2 PHA
 JSR GETLOC
 JSR DOSPC
 PLA
 BRA :YES

WAITIN STZ :FLAG
 STZ :CNTR
 STZ :CNTR2
]LOOP BIT DUMBTERM
 BMI :OVER
 JSR CHECKCTRLX
 JSR CHECKIN ;Did we get something from the modem?
 BCS :KEY
:OVER LDA $C000
 BMI :KEY
 BIT :FLAG
 BMI :MINUS
:PLUS LDA $C019
 BPL ]LOOP
 LDA #$FF
 STA :FLAG
 BRA ]LOOP
:MINUS LDA $C019
 BMI ]LOOP
 INC :CNTR
 LDA :CNTR
 BNE ]LOOP
 INC :CNTR2
 LDA :CNTR2
 CMP #16
 BNE ]LOOP
 CLC
 RTS
:KEY SEC
 RTS
:FLAG DS 1
:CNTR DS 1
:CNTR2 DS 1

GOTKEY STA $C010
 PHA
 JSR INITCNTR
 JSR PRINT
 MTOFF
 NORMAL
 COLOR WHITE
 NULL
 PLA
 JSR UPPER
 CMP #$8D
 BEQL DISPLAY
 CMP #"V"
 BEQL VIEW
 CMP #"H"
 BEQL HELP
 CMP #"E"
 BEQL EXIT
 CMP #$9B
 BEQL EXIT
 CMP #"L"
 BEQL PAGE
 CMP #"G"
 BEQL GET
 CMP #"H"-$40
 BEQ :LEFT
 CMP #"U"-$40
 BEQ :RIGHT
 CMP #"K"-$40
 BEQ :UP
 CMP #"J"-$40
 BEQ :DOWN
 CMP #"W"-$40
 BEQ :REFRESH
 CMP #"P"
 BEQL PICKLOCK
 CMP #"C"
 BEQL CLOSE
 CMP #"1"
 BCCL TOP
 CMP #"9"+1
 BCSL TOP
:KEYUP SEC
 SBC #"1"
 ASL
 TAX
 LDA XLOC
 LDY YLOC
 JMP (:KEYS,X)

:REFRESH JSR REFRESH
 JMP TOP

:LEFT LDA #"4"
 BRA :KEYUP
:RIGHT LDA #"6"
 BRA :KEYUP
:UP LDA #"8"
 BRA :KEYUP
:DOWN LDA #"2"
 BRA :KEYUP

:KEYS DA KEY1
 DA KEY2
 DA KEY3
 DA KEY4
 DA KEY5
 DA KEY6
 DA KEY7
 DA KEY8
 DA KEY9

KEY1 DEC
 INY
 BRA DOKEY

KEY2 INY
 BRA DOKEY

KEY3 INC
 INY
 BRA DOKEY

KEY4 DEC
 BRA DOKEY

KEY5 JMP TOP

KEY6 INC
 BRA DOKEY

KEY7 DEC
 DEY
 BRA DOKEY

KEY8 DEY
 BRA DOKEY

KEY9 INC
 DEY
 BRA DOKEY

DOKEY CMP #9
 BCS :NOX
 STA XLOC
:NOX CPY #9
 BCS :NOY
 STY YLOC
:NOY JMP TOP

DISPLAY LDA ANKX
 CLC
 ADC XLOC
 STA MAPX
 CMP #$FF
 BEQL :WALL
 CMP #$10
 BEQL :WALL
 TAX
 LDA ANKY
 CLC
 ADC YLOC
 STA MAPY
 CMP #$FF
 BEQL :WALL
 CMP #$10
 BEQL :WALL
 LDA PLRXPOS
 SEC
 SBC MAPX
 BCS :DOY
 EOR #$FF
 INC
:DOY STA TEMP
 LDA PLRYPOS
 SEC
 SBC MAPY
 BCS :POK
 EOR #$FF
 INC
:POK CMP TEMP
 BCS :TAKEY
 LDA TEMP
:TAKEY CMP #2
 BCSL :TOOFAR
 LDX MAPX
 LDY MAPY
 JSR GETMAP ;Get the shape
 STA :SHAPE
 STX :SHAPETYPE
 LDX XLOC
 LDY YLOC
 JSR GETGRID
 CMP #$FF
 BEQL :VOID
 BIT PLRARRESTFLAG
 BMIL :ARREST
 LDA :SHAPE ;A wall of some sort?
 CMP #SHPWALL
 BNEL :NOTWALL
 LDA :SHAPETYPE
 CMP #WALLSECRET
 BNEL :NOTWALL
 LDX PLRDX ;Find a secret wall (based on DX)
 LDA :ADJTBL-1,X
 CLC
 ADC #10 ;Skill base score (%)
 BMIL :WALL ;Skill not good enough
 LDX PLRCLASS
 CPX #2 ;Thief
 BEQ :THI
 CPX #5 ;Ninja
 BEQ :THI
 CPX #9 ;Lord
 BNEL :WALL ;"Tough luck buster!"
:THI CLC
 ADC #10
 SEC
 SBC PLRZPOS
 STA :PERCENT
 LDX #100
 LDA #0
 JSR RANDOM
 CPX :PERCENT
 BCSL :WALL
 JSR CLRSIDE
 JSR PRINT
 CURSORDOWN
 COLOR PINK
 ASC "A secret wall!"
 SOUND $15;1;LOUD
 COLOR WHITE
 NULL
 LDX MAPX
 LDY MAPY
 LDA #WALLSECRETVIS
 XBA
 LDA #SHPWALL ;Visually obvious secret wall
 JSR PUTMAP
 LDX PLRZPOS ;Save map 'coz other modules (GAME.MOVE) will load
 LDA #0 ; maps in and overwrite the change in memory.
 JSR SAVEMAP
 JMP TOPC

:VOID JSR CLRSIDE
 JSR PRINT
 COLOR YELLOW
 ASC "Can't see that square."
 COLOR WHITE
 NULL
 JMP TOP

:TOOFAR JSR CLRSIDE
 JSR PRINT
 COLOR YELLOW
 ASC "Too far away."
 COLOR WHITE
 NULL
 JMP TOP

:NOTWALL JSR PRITEMS
 LDA CV
 CMP #15
 BEQ :WALL
 JMP TOP

:WALL JSR CLRSIDE
 JSR PRINT
 ASC "You see nothing special."
 NULL
 JMP TOP

:ARREST JSR CLRSIDE
 JSR PRINT
 ASC "The guards stops you!"
 NULL
 JMP TOP

:PERCENT DS 1

:SHAPE DS 1
:SHAPETYPE DS 1

:ADJTBL DFB -25,-25,-20,-20,-10,-10,-10,-10,-10 ;(1 - 9)
 DFB -5,0,0,0,0,0,5,10,15,20,25 ;(10 - 20)
MAPX DS 1
MAPY DS 1

PAGE JSR PRITEMS2
 JMP TOP

GET JSR GETMAST
 LDA PLRCOND
 AND #%1100_1001 ;Can you physically move?
 BEQ :PLROK
 JSR CLRSIDE
 JSR PRINT
 COLOR PINK
 ASC "Out of action."
 SOUND $13;1;$80
 COLOR WHITE
 NULL
 JMP TOP

:PLROK LDA ANKX
 CLC
 ADC XLOC
 STA MAPX
 LDA ANKY
 CLC
 ADC YLOC
 STA MAPY
 LDA PLRXPOS
 SEC
 SBC MAPX
 BCS :SKIP1
 EOR #$FF
 INC
:SKIP1 STA TEMP
 LDA PLRYPOS
 SEC
 SBC MAPY
 BCS :SKIP2
 EOR #$FF
 INC
:SKIP2 CMP TEMP
 BCS :SKIP3
 LDA TEMP
:SKIP3 CMP #2
 BCC :SKIPTF
 JSR CLRSIDE
 JSR PRINT
 COLOR YELLOW
 ASC "Too far away."
 COLOR WHITE
 NULL
 JMP TOP
:SKIPTF LDX #41
 LDY #41
 LDA #15
 JSR PICKLINE
 LDA $200
 SEC
 SBC #"0"
 CMP #9+1
 BCC :LOK
 JSR PRITEMS
 LDX #41
 LDY #41
 LDA #15
 JSR PICKLINE
 LDA $200
 CMP #" "
 BNE :LOK
 JSR PRINT
 GOTOXY 40;15
 CLEOL
 COLOR PINK
 ASC "Nothing to get."
 COLOR WHITE
 NULL
 JMP TOP
:LOK JSR PRINT
 GOTOXY 0;22
 CURSORON
 ASC "Get item #"
 NULL
 GETLINE #3
 CPX #0
 BNE :LOK2
:GOTOP JSR PRINT
 ZAPLINE
 NULL
 JSR CLRSIDE
 JMP TOP
:LOK2 JSR GETNUM
 CPY #0
 BNE :GOTOP
 STX :ITEM

 LDA ANKX
 CLC
 ADC XLOC
 STA MAPX
 TAX
 LDA ANKY
 CLC
 ADC YLOC
 STA MAPY

 LDX #0
 LDA #0
 JSR LOADITEM2
 LDA ITEM2BUFF
 STA :NUM
]LOOP LDA :NUM
 BEQ :ERROR
 LDX :NUM
 LDA #0
 JSR LOADITEM2
 LDA IFREE
 BMI :NEXTI
 BIT IBURIED
 BMI :NEXTI
 LDA IZPOS
 CMP PLRZPOS
 BNE :NEXTI
 LDA IXPOS
 CMP MAPX
 BNE :NEXTI
 LDA IYPOS
 CMP MAPY
 BNE :NEXTI
 DEC :ITEM
 BEQ :GOTIT
:NEXTI DEC :NUM
 BRA ]LOOP
:ERROR JSR PRINT
 ZAPLINE
 NULL
 JSR CLRSIDE
 JSR PRINT
 COLOR PINK
 ASC "Not that many items here."
 SOUND $02;1;$80
 COLOR WHITE
 NULL
 JMP TOP
:GOTIT LDX #0
]LOOP LDA PLRITEM,X
 BEQ :PUT
 INX
 CPX #8
 BNE ]LOOP
 LDA INUM
 BEQ :PUT
 JSR CLRSIDE
 JSR PRINT
 COLOR PINK
 ASC "Can't carry any more items."
 SOUND $13;1;$80
 COLOR WHITE
 NULL
 JMP TOP

:PUT LDA INUM
 BNE :ANITEM
 JSR PRINT
 ZAPLINE
 NULL
 JSR CLRSIDE
 JSR PRINT
 CURSORDOWN
 ASC "Gold taken : "
 COLOR YELLOW
 DEC32 IDATA
 COLOR WHITE
 NULL
 CLC
 XCE
 REP #$30
 LDA PLRGOLD
 CLC
 ADC IDATA
 STA PLRGOLD
 LDA PLRGOLD+2
 ADC IDATA+2
 STA PLRGOLD+2
 SEC
 XCE
 JMP :SAVP

:ANITEM STA PLRITEM,X
 PHX
 LDX INUM
 LDA #0
 JSR LOADITEM
 LDA PLRCLASS
 JSR CHECKUSE ;Can we use this item?
 BCC :USEOK
 LDA #2 ;Unusable
 HEX 2C
:USEOK LDA #0 ;Can use
 PLX
 STA PLRITEMX,X
 JSR PRINT
 ZAPLINE
 NULL
 JSR CLRSIDE
 JSR PRINT
 CURSORDOWN
 PRSTRING INAME
 ASC " taken"
 NULL
:SAVP LDX MPLR
 LDA MPLR+1
 JSR SAVEPLR
 LDA #$FF
 STA IFREE
 LDX :NUM
 LDA #0
 JSR SAVEITEM2 ;Tell database this item is 'gone'
 JMP TOPC
:ITEM DS 1
:NUM DS 1

PRITEMS LDX #0
 LDA #0
 JSR LOADITEM2
 LDA ITEM2BUFF
 STA MAXI
 STA NUM
 STZ ICNTR
PRITEMS2 JSR CLRSIDE
 BIT :FLAG
 BMI :WROK
 LDA MAXI
 STA NUM
 STZ ICNTR
:WROK LDA ANKX
 CLC
 ADC XLOC
 STA MAPX
 TAX
 LDA ANKY
 CLC
 ADC YLOC
 STA MAPY
]LOOP LDA NUM
 BEQ :DONEI
 LDX NUM
 LDA #0
 JSR LOADITEM2
 LDA IFREE
 BMI :NEXTI
 BIT IBURIED
 BMI :NEXTI
 LDA IZPOS
 CMP PLRZPOS
 BNE :NEXTI
 LDA IXPOS
 CMP MAPX
 BNE :NEXTI
 LDA IYPOS
 CMP MAPY
 BNE :NEXTI
 LDX INUM
 CPX #0
 BNE :NOTG
 LDX :GP
 STX INAME
]LOOP2 LDA :GP,X
 STA INAME,X
 DEX
 BNE ]LOOP2
 BRA :GCONT
:NOTG LDA #0
 JSR LOADITEM
:GCONT LDA INAME
 JSR :DOPR
 BCS :DONEI2 ;Enough for this 'page'
:NEXTI DEC NUM
 BRA ]LOOP
:DONEI2 DEC NUM
 LDA #$FF
 HEX 2C
:DONEI LDA #0
 STA :FLAG
 RTS
:FLAG DS 1
:GP STR "gold"

:DOPR LDX ICNTR
 LDA INUM
 STA ITBL,X
 INC ICNTR
 JSR PRINT
 HTAB 40
 NULL
 LDA ICNTR
 CMP #10
 BCS :DOPR2
 JSR PRINT
 ASC " "
 NULL
:DOPR2 JSR PRINT
 DEC8 ICNTR
 ASC ") "
 PRSTRING INAME
 CR
 NULL
 LDA CV
 CMP #23
 RTS
MAXI DS 1
NUM DS 1
ICNTR DS 1
ITBL DS $100

CLRBOT JSR PRINT
 GOTOXY 0;22
 LUP 7
 ZAPLINE
 CURSORUP
 --^
 ZAPLINE
 NULL
 RTS

HELP JSR PRINT
 GOTOXY 68;12
 CLEOL
 ASC "Help"
 NULL
 JSR CLRBOT
 JSR GETFILE
 DFB 15,22 ;Use lines x to y
 STR "HELP/INSPECT"
 JSR PRINT
 COLOR YELLOW
 CURSOROFF
 GOTOXY 0;23
 COLOR PINK
 CENTER " Press [RETURN] "
 NULL
]LOOP JSR KEYIN
 CMP #$8D
 BEQ :YEP
 CMP #$9B
 BNE ]LOOP
:YEP JSR PRINT
 INVERSE
 COLOR YELLOW
 ZAPLINE
 COLOR WHITE
 NORMAL
 NULL
 JMP START2

GETMAST LDX MPLR
 LDA MPLR+1
 JSR LOADPLR ;Get party 'leader'
 LDA PLRZPOS
 CMP LEVEL
 BEQ :OK
 STA LEVEL
 LDX PLRZPOS
 LDA #0
 JSR LOADMAP
 LDX PLRZPOS
 LDA #0
 JSR LOADMAP2
:OK RTS

VIEW JSR CLRSIDE
 JSR PRINT
 CURSORON
 ASC "Change view to player (1-"
 DEC8 NUMP
 ASC ") : "
 NULL
]LOOP JSR KEYIN
 CMP #$9B
 BEQ :ESC
 SEC
 SBC #"1"
 CMP NUMP
 BCS ]LOOP
 TAX
 LDA CURPARTY,X
 STA MPLR
 LDA CURPARTY2,X
 STA MPLR+1
:ESC JSR PRINT
 GOTOXY 40;15
 CLEOL
 CURSOROFF
 NULL
 JMP TOPXY

CLRSIDE JSR PRINT
 GOTOXY 40;22
 CLEOL
 LUP 7
 CURSORUP
 CLEOL
 --^
 NULL
 RTS

GETLOC LDA ANKX
 CLC
 ADC XLOC
 TAX
 LDA ANKY
 CLC
 ADC YLOC
 TAY
 JSR GETMAP
 LDX XLOC
 LDY YLOC
 RTS

EXIT JSR CLRBOT
 RETURN

MSTRX DS 1
MSTRY DS 1
MSTRZ DS 1
PREC DS 2
TEMPX DS 1
NUMP DS 1

ANKX DS 1
ANKY DS 1
XLOC DS 1
YLOC DS 1
CNTR DS 1
TEMP DS 1

LEVEL DS 1

CLOSE LDA #0
 HEX 2C
PICKLOCK LDA #$FF
 STA :PICKFLAG
 LDA ANKX
 CLC
 ADC XLOC
 STA MAPX
 TAX
 LDA ANKY
 CLC
 ADC YLOC
 STA MAPY
 LDA PLRXPOS
 SEC
 SBC MAPX
 BCS :DOY
 EOR #$FF
 INC
:DOY STA TEMP
 LDA PLRYPOS
 SEC
 SBC MAPY
 BCS :POK
 EOR #$FF
 INC
:POK CMP TEMP
 BCS :TAKEY
 LDA TEMP
:TAKEY CMP #2
 BCSL :TOOFAR
 LDX MAPX
 LDY MAPY
 JSR GETMAP ;Get the shape
 STA :SHAPE
 STX :SHAPETYPE
 LDX XLOC
 LDY YLOC
 JSR GETGRID
 CMP #$FF
 BEQL :VOID
 LDA :SHAPE ;A closed gate?
 CMP #SHPGATE
 BNEL :NOTGATE
 LDA :SHAPETYPE
 CMP #GATECLOSED
 BNEL :NOTGATE
 BIT :PICKFLAG
 BMI :PICKIT
 JSR CLRSIDE
 JSR PRINT
 COLOR PICK
 ASC "Gate is already closed."
 COLOR WHITE
 SOUND $02;1;LOUD
 NULL
 JMP TOP
:PICKIT LDX PLRDX ;Pick lock (based on DX)
 LDA :ADJTBL-1,X
 CLC
 ADC #10 ;Skill base score (%)
 BMIL :NOGOOD ;Skill not good enough
 LDX PLRCLASS
 CPX #2 ;Thief
 BEQ :THI
 CPX #5 ;Ninja
 BEQ :THI
 CPX #9 ;Lord
 BNEL :NOGOOD ;"Tough luck buster!"
:THI CLC
 ADC #10
 STA :PERCENT
 LDX #100
 LDA #0
 JSR RANDOM
 CPX :PERCENT
 BCSL :NOGOOD
 JSR CLRSIDE
 JSR PRINT
 CURSORDOWN
 COLOR PINK
 ASC "You picked the lock!"
 SOUND $15;1;LOUD
 COLOR WHITE
 NULL
 LDA #GATEOPEN ;Open gate
:DOIT LDX MAPX
 LDY MAPY
 XBA
 LDA #SHPGATE
 JSR PUTMAP
 LDX PLRZPOS ;Save map 'coz other modules (GAME.MOVE) will load
 LDA #0 ; maps in and overwrite the change in memory.
 JSR SAVEMAP
 JMP TOPC

:VOID JSR CLRSIDE
 JSR PRINT
 COLOR YELLOW
 ASC "Can't see that square."
 COLOR WHITE
 NULL
 JMP TOP

:TOOFAR JSR CLRSIDE
 JSR PRINT
 COLOR YELLOW
 ASC "Too far away."
 COLOR WHITE
 NULL
 JMP TOP

:NOGOOD JSR CLRSIDE
 JSR PRINT
 COLOR ORANGE
 ASC "Gate remains locked."
 COLOR WHITE
 NULL
 JMP TOP

:NOTGATE BIT :PICKFLAG
 BMI :NOTGATEP
 LDA :SHAPE
 CMP #SHPGATE
 BNE :NOTGATE2
 LDA :SHAPETYPE
 CMP #GATEOPEN
 BNE :NOTGATE2
 JSR CLRSIDE
 JSR PRINT
 CURSORDOWN
 COLOR PINK
 ASC "Gate is now closed."
 COLOR WHITE
 NULL
 LDA #GATECLOSED ;Closed gate
 JMP :DOIT
:NOTGATE2 JSR CLRSIDE
 JSR PRINT
 COLOR PINK
 ASC "Nothing to close."
 COLOR WHITE
 SOUND $02;1;LOUD
 NULL
 JMP TOP

:NOTGATEP LDA :SHAPE
 CMP #SHPGATE
 BNE :NOTGATEP2
 LDA :SHAPETYPE
 CMP #GATEOPEN
 BNE :NOTGATEP2
 JSR CLRSIDE
 JSR PRINT
 COLOR PINK
 ASC "Gate is already open."
 COLOR WHITE
 SOUND $02;1;LOUD
 NULL
 JMP TOP
:NOTGATEP2 JSR CLRSIDE
 JSR PRINT
 COLOR PINK
 ASC "Nothing to unlock."
 COLOR WHITE
 SOUND $02;1;LOUD
 NULL
 JMP TOP

:PICKFLAG DS 1

:PERCENT DS 1
:SHAPE DS 1
:SHAPETYPE DS 1

:ADJTBL DFB -25,-25,-20,-20,-10,-10,-10,-10,-10 ;(1 - 9)
 DFB -5,0,0,0,0,0,5,10,15,20,25 ;(10 - 20)

 LST ON
MODEND EQU *
 LST OFF

 do M16PLUS
 SAV RUN/MODULES/GAME.INSPECT
 fin

 END
