*-------------------------------
* GAME.LOOK
*-------------------------------
 DAT
 LST OFF

 ORG $8000 ;Always

 USE MACROS
 USE EQUATES
 USE VARS
 USE LIB.JMP
 USE PLR.DSECT
 USE MON.DSECT
 USE MON2.DSECT
 USE ITEM.DSECT
 USE ITEM2.DSECT
 USE SIGN.DSECT
 USE SCEN.DSECT

 TYP $F4
 do M16PLUS-1
 DSK RUN/MODULES/GAME.LOOK
 fin

ENTRY MAC
HERE STR ]1
 DS HERE-*+]LEN+1
 <<<

 MODID "GAME.LOOK"

START JSR PRINT
 GOTOXY 0;14
 CURSOROFF
 INVERSE
 COLOR YELLOW
 ZAPLINE
 COLOR WHITE
 NORMAL
 VTAB 14
 COLOR ORANGE
 CENTER " Look "
 COLOR YELLOW
 CR
 NULL

 LDX SCENARIO
 LDA #0
 JSR LOADSCEN
 LDA SCMON2KILL
 STA SCENMON

START2 LDX NUMPARTY
]LOOP LDA CURPARTY2-1,X
 BNE :GOT1
 LDA CURPARTY-1,X
 BNE :GOT1
 DEX
 BNE ]LOOP
 DEATH
:GOT1 STX NUMP
]LOOP LDA CURPARTY2-1,X
 CMP MPLR+1
 BNE :NONO
 LDA CURPARTY-1,X
 CMP MPLR
 BNE :NONO
 STX DPLR
 BRA :MPLROK
:NONO DEX
 BNE ]LOOP
 DEATH

:MPLROK JSR GETMAST
 LDA PLRZPOS
 STA CURLVL
 JSR DRAWBOT

TOPXY JSR GETMAST

 LDA PLRXPOS ;Get top-left co-ordinate
 SEC
 SBC #4
 STA ANKX
 LDA PLRYPOS
 SEC
 SBC #4
 STA ANKY

 LDA #4
 STA XLOC
 STA YLOC

 STZ CNTR

TOPC JSR GETMAST
 LDX PLRXPOS
 LDY PLRYPOS
 LDA PLRZPOS
 JSR SHOWMAP
 JSR GETMAST
TOPC2 JSR PRINT
 GOTOXY 17;15
 CLEOL
 NULL
 JSR GETMAST
 JSR SAYNAME

TOP JSR PRINT
 GOTOXY 68;12
 CLEOL
 INVERSE
 ASC " "
 NORMAL
 CURSOROFF
 NULL
]LOOP JSR TICKTOCK
 JSR WAITIN
 BCS :YES2
 JSR GETLOC
 JSR DOSPC
 JSR WAITIN
 BCS :YES
 JSR GETLOC
 JSR DOSHP
 JMP ]LOOP
:YES PHA
 JSR GETLOC
 JSR DOSHP
 PLA
 JMP GOTKEY
:YES2 PHA
 JSR GETLOC
 JSR DOSPC
 PLA
 BRA :YES

WAITIN STZ :FLAG
 STZ :CNTR
 STZ :CNTR2
]LOOP BIT DUMBTERM
 BMI :OVER
 JSR CHECKCTRLX
 JSR CHECKIN ;Did we get something from the modem?
 BCS :KEY
:OVER LDA $C000
 BMI :KEY
 BIT :FLAG
 BMI :MINUS
:PLUS LDA $C019
 BPL ]LOOP
 LDA #$FF
 STA :FLAG
 BRA ]LOOP
:MINUS LDA $C019
 BMI ]LOOP
 INC :CNTR
 LDA :CNTR
 BNE ]LOOP
 INC :CNTR2
 LDA :CNTR2
 CMP #16
 BNE ]LOOP
 CLC
 RTS
:KEY SEC
 RTS
:FLAG DS 1
:CNTR DS 1
:CNTR2 DS 1

GOTKEY STA $C010
 PHA
 JSR INITCNTR
 JSR PRINT
 MTOFF
 NORMAL
 COLOR WHITE
 NULL
 PLA
 JSR UPPER
 CMP #$8D
 BEQL DISPLAY
 CMP #"V"
 BEQL VIEW
 CMP #"H"
 BEQL HELP
 CMP #"E"
 BEQL EXIT
 CMP #$9B
 BEQL EXIT
 CMP #"R"
 BEQL READ
 CMP #"H"-$40
 BEQ :LEFT
 CMP #"U"-$40
 BEQ :RIGHT
 CMP #"K"-$40
 BEQ :UP
 CMP #"J"-$40
 BEQ :DOWN
 CMP #"W"-$40
 BEQ :REFRESH
 CMP #"1"
 BCCL TOP
 CMP #"9"+1
 BCSL TOP
:KEYUP SEC
 SBC #"1"
 ASL
 TAX
 LDA XLOC
 LDY YLOC
 JMP (:KEYS,X)

:REFRESH JSR REFRESH
 JMP TOP

:LEFT LDA #"4"
 BRA :KEYUP
:RIGHT LDA #"6"
 BRA :KEYUP
:UP LDA #"8"
 BRA :KEYUP
:DOWN LDA #"2"
 BRA :KEYUP

:KEYS DA KEY1
 DA KEY2
 DA KEY3
 DA KEY4
 DA KEY5
 DA KEY6
 DA KEY7
 DA KEY8
 DA KEY9

KEY1 DEC
 INY
 BRA DOKEY

KEY2 INY
 BRA DOKEY

KEY3 INC
 INY
 BRA DOKEY

KEY4 DEC
 BRA DOKEY

KEY5 JMP TOP

KEY6 INC
 BRA DOKEY

KEY7 DEC
 DEY
 BRA DOKEY

KEY8 DEY
 BRA DOKEY

KEY9 INC
 DEY
 BRA DOKEY

DOKEY CMP #9
 BCS :NOX
 STA XLOC
:NOX CPY #9
 BCS :NOY
 STY YLOC
:NOY JMP TOP

XLOC DS 1
YLOC DS 1
ANKX DS 1
ANKY DS 1
CNTR DS 1

READ JSR GETMAST
 LDA ANKX
 CLC
 ADC XLOC
 STA :X
 TAX
 LDA ANKY
 CLC
 ADC YLOC
 STA :Y
 LDA PLRXPOS
 SEC
 SBC :X
 BCS :DOY
 EOR #$FF
 INC
:DOY STA TEMP
 LDA PLRYPOS
 SEC
 SBC :Y
 BCS :POK
 EOR #$FF
 INC
:POK CMP TEMP
 BCS :TAKEY
 LDA TEMP
:TAKEY CMP #2
 BCS :TOOFAR
 LDX :X
 LDY :Y
 CPY #$10
 BCS :NOSEE
 CPX #$10
 BCS :NOSEE
 JSR GETMAP ;Get the shape
 CMP #SHPSIGN
 BEQ :SIGN
:NOSEE JSR PRINT
 GOTOXY 0;22
 ZAPLINE
 CURSORUP
 ZAPLINE
 CURSORON
 COLOR PINK
 ASC "Nothing to read"
 SOUND $02;1;LOUD
 COLOR WHITE
 NULL
 JMP TOPC2
:TOOFAR JSR PRINT
 GOTOXY 0;22
 ZAPLINE
 CURSORUP
 ZAPLINE
 CURSORON
 COLOR PINK
 ASC "Not close enough"
 SOUND $13;1;LOUD
 COLOR WHITE
 NULL
 JMP TOPC2
:SIGN JSR CLRBOT
 LDX #0
 LDA #0
 JSR LOADSIGN
 LDA MISCBUFF
 STA :RECS
 LDA MISCBUFF+1
 STA :RECS+1
 LDA :RECS
 ORA :RECS+1
 BEQL :BLANK
]LOOP LDX :RECS
 LDA :RECS+1
 JSR LOADSIGN
 LDA SGZPOS
 CMP CURLVL
 BNE :NEXT
 LDA SGXPOS
 CMP :X
 BNE :NEXT
 LDA SGYPOS
 CMP :Y
 BNE :NEXT
 JSR PRINT
 CURSORON
 NULL
 LDX SGLEN ;Length
 LDA SGLEN+1
 JSR SHOWMSG
 DFB 15,22 ;Lines to use (top, bottom)
 DA SGTEXT
 JSR PRINT
 COLOR YELLOW
 VTAB 23
 CURSOROFF
 COLOR PINK
 CENTER " [Press any key] "
 COLOR WHITE
 NULL
 JSR KEYIN
 JSR PRINT
 INVERSE
 COLOR YELLOW
 ZAPLINE
 COLOR WHITE
 NORMAL
 NULL
 JSR CLRBOT
 JSR DRAWBOT
 JMP TOPC2
:NEXT DECR :RECS ;If we cannot find the sign, then say
 LDA :RECS ; it is blank.
 ORA :RECS+1
 BNEL ]LOOP
:BLANK JSR PRINT
 CURSORON
 COLOR PINK
 ASC "The sign has nothing written on it. "
 SOUND $25;1;LOUD
 COLOR WHITE
 NULL
 GETRETURN
 JSR CLRBOT
 JSR DRAWBOT
 JMP TOPC2
:X DS 1
:Y DS 1
:RECS DS 2
TEMP DS 1

DISPLAY JSR CLRSIDE
 JSR PRINT
 GOTOXY 0;22
 ZAPLINE
 CURSORUP
 ZAPLINE
 CURSORON
 NULL
 STZ :FLAG2 ;Outside flag
 LDX XLOC
 LDY YLOC
 JSR GETGRID
 CMP #$FF
 BEQL :VOID
 LDA ANKX
 CLC
 ADC XLOC
 STA :X
 TAX
 LDA ANKY
 CLC
 ADC YLOC
 STA :Y
 TAY
 CPY #$10
 BCS :NOSEE
 CPX #$10
 BCS :NOSEE
 JSR GETMAP ;Get the shape
 STA :SHAPE
 STX :SHAPETYPE
 JSR PRINT
 ASC "You see : "
 NULL
 LDX #0
]LOOP LDA :SHAPES,X
 CMP #$FF
 BEQ :ERR
 CMP :SHAPE
 BEQ :GOTIT
 INX
 BRA ]LOOP
:ERR JSR PRINT
 COLOR PINK
 ASC "<error>"
 COLOR WHITE
 NULL
 JMP TOPC

:NOSEE LDA #$FF
 STA :FLAG2
 LDA :Y
 INC
 CMP #$12
 BCS :VOID
 LDA :X
 INC
 CMP #$12
 BCS :VOID
 JSR PRINT
 ASC "You see : "
 NULL
 LDX #SHPWALL
 HEX 2C
:VOID LDX #SHPVOID
 LDA #$FF
 STA :FLAG2
:GOTIT TXA
 STA :SHAPE
 ASL
 TAX
 LDA :TBL,X
 STA CADD
 LDA :TBL+1,X
 STA CADD+1
 LDX :SHAPETYPE
]LOOP CPX #0
 BEQ :YOYO
 LDA (CADD)
 SEC
 ADC CADD
 STA CADD
 LDA CADD+1
 ADC #0
 STA CADD+1
 DEX
 BRA ]LOOP
:YOYO LDA (CADD)
 TAX
 LDY #0
]LOOP INY
 LDA (CADD),Y
 JSR COUT
 DEX
 BNE ]LOOP
 LDA :FLAG2
 BMIL TOP ;No 'extras'
 JSR PRINT
 CR
 HTAB 10
 NULL
 LDX :X
 LDY :Y
 JSR GETMAP2
 STA :SHAPE ;There anything on MAP2?
 STZ :CS
 STZ :MS
 CMP #0
 BEQL :CMCHEK
 LDA :SHAPE
 AND #$F
 STA :CS
 LDA :SHAPE
 LSR
 LSR
 LSR
 LSR
 STA :MS
 JSR :INVIS
 LDA :CS
 BEQ :NOCHAR
 CMP #15
 BCC :PL15
 JSR PRINT
 ASC "many people"
 NULL
 BRA :NOCHAR
:PL15 JSR PRINT
 COLOR YELLOW
 DEC8 :CS
 COLOR WHITE
 ASC " persons"
 NULL
:NOCHAR LDA :MS
 BEQ :CMCHEK
 LDA :CS
 BEQ :ZZ
 JSR PRINT
 ASC "/"
 NULL
:ZZ JSR PRINT
 COLOR YELLOW
 DEC8 :MS
 COLOR WHITE
 ASC " monsters"
 NULL
:CMCHEK LDX :X
 LDY :Y
 LDA CURLVL
 JSR GETITEM2 ;Any items on this square
 STA :ITEMS
 BEQ :NOI2
 LDA :CS
 ORA :MS
 CMP #0
 BEQ :NI
:YI JSR PRINT
 ASC "/"
 NULL
:NI JSR PRINT
 COLOR YELLOW
 DEC8 :ITEMS
 COLOR WHITE
 ASC " items"
 NULL
:NOI2 LDA #14
 STA :HV+3
 JSR PRINT
 HTAB 79
 NULL
 LDA :CS
 BEQ :NOTC
 JSR :PRCS
:NOTC LDA :MS
 BEQ :NOTANY
 JSR :PRMS
:NOTANY LDA :ITEMS
 BEQ :NOI3
 JSR :PRITEMS
:NOI3 JMP TOP
:X DS 1
:Y DS 1
:CS DS 1
:MS DS 1
:ITEMS DS 1

:INVIS LDA :CS
 BEQ :INVM
 LDX #0
 LDA #0
 JSR LOADPLR
 LDA PLRBUFF
 STA :CNTRP
 LDA PLRBUFF+1
 STA :CNTRP+1
 LDA :CNTRP
 ORA :CNTRP+1
 BEQ :INVM
]LOOP LDX :CNTRP
 LDA :CNTRP+1
 JSR LOADPLR
 BIT PLRFREE
 BMI :NXTP
 LDA PLRZPOS
 CMP CURLVL
 BNE :NXTP
 LDA PLRXPOS
 CMP :X
 BNE :NXTP
 LDA PLRYPOS
 CMP :Y
 BNE :NXTP
 LDX PLRXPOS
 LDY PLRYPOS
 JSR GETMAP
 CMP #SHPWALL
 BNE :SMM
 CPX #WALLSECRET
 BEQ :CANTSEE
:SMM LDA PLRCOND
 AND #%0001_0000 ;Invisible?
 BEQ :NXTP
:CANTSEE DEC :CS
:NXTP DECR :CNTRP
 LDA :CNTRP
 ORA :CNTRP+1
 BNE ]LOOP

:INVM LDA :MS
 BEQ :INVD
 LDX #0
 LDA #0
 JSR LOADMON2
 LDA MON2BUFF
 STA :CNTRM
 BEQ :INVD
]LOOP LDX :CNTRM
 LDA #0
 JSR LOADMON2
 LDA MTYPE
 ORA MTYPE+1
 BEQ :NXTM
 LDA MZPOS
 CMP CURLVL
 BNE :NXTM
 LDA MXPOS
 CMP :X
 BNE :NXTM
 LDA MYPOS
 CMP :Y
 BNE :NXTM
 LDA MCOND
 AND #%0001_0000 ;Invisible?
 BEQ :NXTM
 DEC :MS
:NXTM DEC :CNTRM
 LDA :CNTRM
 BNE ]LOOP
:INVD RTS

:CNTRP DS 2
:CNTRM DS 1

:PRITEMS LDX #0
 LDA #0
 JSR LOADITEM2
 LDA ITEM2BUFF
 STA :NUM
]LOOP LDA :NUM
 BEQ :DONEI
 LDX :NUM
 LDA #0
 JSR LOADITEM2
 LDA IFREE
 BMI :NEXTI
 BIT IBURIED
 BMI :NEXTI
 LDA IZPOS
 CMP CURLVL
 BNE :NEXTI
 LDA IXPOS
 CMP :X
 BNE :NEXTI
 LDA IYPOS
 CMP :Y
 BNE :NEXTI
 LDX INUM
 CPX #0
 BNE :NOTG
 LDX :GP
 STX INAME
]LOOP2 LDA :GP,X
 STA INAME,X
 DEX
 BNE ]LOOP2
 BRA :GCONT
:NOTG LDA #0
 JSR LOADITEM
:GCONT LDA INAME
 STA :LEN
 JSR :DOPR
 BCS :DONEI
 JSR PRINT
 PRSTRING INAME
 NULL
:NEXTI DEC :NUM
 BRA ]LOOP
:DONEI RTS
:GP STR "gold"

:PRCS LDX #0
 LDA #0
 JSR LOADPLR
 LDA PLRBUFF
 STA :NUM
 LDA PLRBUFF+1
 STA :NUM+1
]LOOP LDA :NUM+1
 BNE :OKPLR
 LDA :NUM
 BEQL :DONEPLR
:OKPLR LDX :NUM
 LDA :NUM+1
 JSR LOADPLR
 BIT PLRFREE
 BMIL :NEXTPLR
 LDA PLRSCENARIO
 CMP SCENARIO
 BNEL :NEXTPLR
 LDA PLRZPOS
 CMP CURLVL
 BNEL :NEXTPLR
 LDA PLRXPOS
 CMP :X
 BNE :NEXTPLR
 LDA PLRYPOS
 CMP :Y
 BNE :NEXTPLR
 LDA PLRCOND
 AND #%0001_0000 ;Invisible?
 BNE :NEXTPLR
 LDA PLRCLASS
 ASL
 ASL
 ASL
 TAX
 LDA :CLASSTBL+1,X
 CLC
 ADC PLRNAME
 ADC #5
 STA :LEN
 LDA PLRCOND
 AND #%1100_1001 ;Can player move?
 BEQ :ZZOK
 INC :LEN
:ZZOK JSR :DOPR
 BCS :DONEPLR
 LDA PLRCOND
 AND #%1100_1001 ;Can player move?
 BEQ :PMOVEOK
 LDA PLRCOND
 AND #%1000_0000
 BEQ :PNOMOVE
 JSR PRINT
 COLOR PINK
 ASC "#" ;Dead
 COLOR WHITE
 NULL
 BRA :PMOVEOK
:PNOMOVE JSR PRINT
 COLOR PINK
 ASC "*" ;Can't move
 COLOR WHITE
 NULL
:PMOVEOK JSR PRINT
 COLOR GREEN
 PRSTRING PLRNAME
 COLOR WHITE
 ASC "("
 COLOR AQUAMARINE
 PRTABLE PLRCLASS;:CLASSTBL
 COLOR WHITE
 ASC "/"
 COLOR YELLOW
 DEC8 PLRPARTY
 COLOR WHITE
 ASC ")"
 NULL
:NEXTPLR DECR :NUM
 JMP ]LOOP
:DONEPLR RTS

]LEN = 7
:CLASSTBL DFB ]LEN
 ENTRY "<?>"
 ENTRY "Fighter" ;Basic
 ENTRY "Thief"
 ENTRY "Wizard"
 ENTRY "Cleric"
 ENTRY "Ninja" ;Elite (Fighter only)
 ENTRY "Sage" ;      (Psychic/Fighter)
 ENTRY "H-Mage" ;      (Wizard/Fighter)
 ENTRY "H-Prst" ;      (Cleric/Fighter)
 ENTRY "Lord" ;Super Elite (Fighter/Thief/Wizard/Cleric)

:PRMS LDX #0
 LDA #0
 JSR LOADMON2
 LDA MON2BUFF
 STA :NUM
 LDA MON2BUFF+1
 STA :NUM+1
]LOOP LDA :NUM
 ORA :NUM+1
 BEQL :DONEMON
 LDX :NUM
 LDA :NUM+1
 JSR LOADMON2
 LDA MCOND
 AND #%1000_0000 ;Dead?
 BMI :NEXTMON
 LDA MZPOS
 CMP CURLVL
 BNE :NEXTMON
 LDA MXPOS
 CMP :X
 BNE :NEXTMON
 LDA MYPOS
 CMP :Y
 BNE :NEXTMON
 LDX MTYPE
 LDA MTYPE+1
 JSR LOADMON
 LDA MNAME
 STA :LEN
 JSR :DOPR
 BCS :DONEMON
 LDA MCOND
 AND #%1100_1001 ;Can monster move?
 BEQ :MMOVEOK
 JSR PRINT
 COLOR PINK
 ASC "*"
 COLOR WHITE
 NULL
:MMOVEOK LDA MLEVEL
 BNE :NOG
 JSR PRINT
 COLOR AQUAMARINE
 NULL
 BRA :MGO
:NOG JSR PRINT
 COLOR ORANGE
 NULL
:MGO JSR PRINT
 PRSTRING MNAME
 COLOR WHITE
 NULL
 LDA MTYPE
 CMP SCENMON
 BNE :NEXTMON
 JSR PRINT
 SOUND $28;1;LOUD
 NULL
:NEXTMON DECR :NUM
 JMP ]LOOP
:DONEMON RTS
:NUM DS 2

:DOPR LDA CH
 CLC
 ADC :LEN
 CMP #78
 BCC :PROK
 INC :HV+3
 LDA :HV+3
 CMP #22
 BCS :PRTS
 JSR PRINT
:HV GOTOXY 33;15
 NULL
 CLC
 RTS
:PROK JSR PRINT
 ASC ", "
 NULL
 CLC
 RTS
:PRTS LDA CH
 CMP #75
 BCC :PRTS2
 JSR PRINT
 HTAB 76
 CLEOL
 NULL
:PRTS2 JSR PRINT
 ASC ".."
 NULL
 SEC
 RTS
:LEN DS 1

:SHAPES DFB SHPWALL,SHPSPACE,SHPSTAIRS,SHPFF,SHPDARK,SHPSIGN
 DFB SHPSWAMP,SHPPLR,SHPVOID,SHPWATER,SHPTPORT,SHPHILLS
 DFB SHPMON,SHPPLRMON,SHPITEM,SHPGATE,SHPMONGEN,SHPSAFETY
 DFB SHPALTAR,SHPFOUNTAIN
 DFB #$FF

:TBL DA :TBL00
 DA :TBL01
 DA :TBL02
 DA :TBL03
 DA :TBL04
 DA :TBL05
 DA :TBL06
 DA :TBL07
 DA :TBL08
 DA :TBL09
 DA :TBL0A
 DA :TBL0B
 DA :TBL0C
 DA :TBL0D
 DA :TBL0E
 DA :TBL0F
 DA :TBL10
 DA :TBL11
 DA :TBL12
 DA :TBL13

* 00 - Wall
:TBL00 STR "a wall" ;0 = Square (normal)
 STR "a wall" ;1 = Bendy (top-left)
 STR "a wall" ;2 = Bendy (top-right)
 STR "a wall" ;3 = Bendy (bottom-left)
 STR "a wall" ;4 = Bendy (bottom-right)
 STR "a wall" ;5 = Secret
 STR "a secret passage" ;6 = Secret (visible)

* 01 - Space
:TBL01 STR "nothing" ;0 = Normal

* 02 - Stairs
:TBL02 STR "stairs up" ;0 = Up
 STR "stairs down" ;1 = Down

* 03 - Force field
:TBL03 STR "a force field" ;0 = Horizontal
 STR "a force field" ;1 = Vertical
 STR "nothing" ;2 = Diminished (horizontal)
 STR "nothing" ;3 = Diminished (vertical)

* 04 - Dark area
:TBL04 STR "darkness" ;0 = Normal

* 05 - Sign post
:TBL05 STR "a sign" ;0 = Normal

* 06 - Swamp
:TBL06 STR "swamp" ;0 = Normal

* 07 - Player
:TBL07 STR "a person" ;0 = Normal
 STR "a person" ;1 = Current

* 08 - Unknown (can't see this square)
:TBL08 STR "You can't see that square" ;0 = Normal

* 09 - Water
:TBL09 STR "shallow water" ;0 = Shallow
 STR "deep water" ;1 = Deep

* 0A - Teleport
:TBL0A STR "a shimmer" ;0 = Normal

* 0B - Hills
:TBL0B STR "hills" ;0 = Normal

* 0C - Monster
:TBL0C STR "a monster" ;0 = Normal

* 0D - Player & Monster
:TBL0D STR "a monster and a person" ;0 = Normal

* 0E - Item
:TBL0E STR "an item" ;0 = Normal

* 0F - Gate
:TBL0F STR "a closed gate" ;0 = Closed
 STR "an open gate" ;1 = Open

* 10 - Monster generator
:TBL10 STR "an astral gate" ;0 = Normal
 STR "a smilie" ;1 = Guardian

* 11 - Holy ground
:TBL11 STR "holy ground" ;0 = Normal

* 12 - Altar
:TBL12 STR "an altar" ;0 = Normal

* 13 - Fountain
:TBL13 STR "a fountain" ;0 = Normal

:SHAPE DS 1
:SHAPETYPE DS 1
:FLAG2 DS 1

VIEW JSR PRINT
 GOTOXY 68;12
 CLEOL
 ASC "View"
 GOTOXY 0;22
 ZAPLINE
 CURSORUP
 ZAPLINE
 CURSORON
 ASC "Change view to player (1-"
 DEC8 NUMP
 ASC ") : "
 NULL
]LOOP JSR KEYIN
 CMP #$9B
 BEQ :ESC
 SEC
 SBC #"1"
 CMP NUMP
 BCS ]LOOP
 TAX
 LDA CURPARTY,X
 STA MPLR
 LDA CURPARTY2,X
 STA MPLR+1
 INX
 STX DPLR
:ESC JSR PRINT
 ZAPLINE
 CURSOROFF
 NULL
 JSR CLRSIDE
 JMP TOPXY

HELP JSR PRINT
 GOTOXY 68;12
 CLEOL
 ASC "Help"
 NULL
 JSR CLRBOT
 JSR GETFILE
 DFB 15,22 ;Use lines x to y
 STR "HELP/LOOK"
 JSR PRINT
 COLOR YELLOW
 CURSOROFF
 GOTOXY 0;23
 COLOR PINK
 CENTER " Press [RETURN] "
 NULL
]LOOP JSR KEYIN
 CMP #$8D
 BEQ :YEP
 CMP #$9B
 BNE ]LOOP
:YEP JSR PRINT
 INVERSE
 COLOR YELLOW
 ZAPLINE
 COLOR WHITE
 NORMAL
 NULL
 JSR CLRBOT
 JMP START2

EXIT JSR PRINT
 GOTOXY 68;12
 CLEOL
 ASC "Exit"
 CURSOROFF
 NULL
 RETURN

GETMAST LDX MPLR
 LDA MPLR+1
 JSR LOADPLR ;Get party 'leader'
 LDA PLRZPOS
 CMP CURLVL
 BEQ :RTS
 STA CURLVL
 LDX CURLVL
 LDA #0
 JSR LOADMAP
 LDX CURLVL
 LDA #0
 JSR LOADMAP2
:RTS RTS

GETITEM2 STX :X
 STY :Y
 STA :Z
 LDX #0
 LDA #0
 JSR LOADITEM2
 LDA ITEM2BUFF
 STA :NUM
 STZ :CNTR
]LOOP LDA :NUM
 BEQ :DONEI
 LDX :NUM
 LDA #0
 JSR LOADITEM2
 LDA IFREE
 BMI :NEXTI
 LDA IZPOS
 CMP :Z
 BNE :NEXTI
 LDA IXPOS
 CMP :X
 BNE :NEXTI
 LDA IYPOS
 CMP :Y
 BNE :NEXTI
 BIT IBURIED
 BMI :NEXTI
 LDX IXPOS
 LDY IYPOS
 JSR GETMAP
 CMP #SHPWALL
 BNE :ZOK
 CPX #WALLSECRETVIS
 BNE :NEXTI
:ZOK INC :CNTR
:NEXTI DEC :NUM
 BRA ]LOOP
:DONEI LDA :CNTR
 RTS
:NUM DS 1
:X DS 1
:Y DS 1
:Z DS 1
:CNTR DS 1

CLRBOT JSR PRINT
 GOTOXY 0;22
 LUP 7
 ZAPLINE
 CURSORUP
 --^
 ZAPLINE
 NULL
 RTS

CLRSIDE LDX #6
]LOOP TXA
 CLC
 ADC #15
 STA :DH+3
 JSR PRINT
:DH GOTOXY 33;21
 CLEOL
 NULL
 DEX
 BPL ]LOOP
 RTS

GETLOC LDA ANKX
 CLC
 ADC XLOC
 TAX
 LDA ANKY
 CLC
 ADC YLOC
 TAY
 JSR GETMAP
 LDX XLOC
 LDY YLOC
 RTS

DRAWBOT JSR PRINT
 GOTOXY 0;15
 CURSORON
 COLOR AQUAMARINE
 LINE " 7 8 9"
 LINE "  \|/"
 LINE " 4-x-6"
 LINE "  /|\"
 LINE " 1 2 3"
 COLOR WHITE
 GOTOXY 8;15
 ASC "[V]iew : "
 GOTOXY 8;16
 ASC "[R]ead"
 GOTOXY 8;17
 ASC "[H]elp"
 GOTOXY 8;18
 ASC "[E]xit"
 GOTOXY 8;19
 ASC "[RETURN]-look"
 CURSOROFF
 NULL
 RTS

CURLVL DS 1
NUMP DS 1 ;Actual people in party

DPLR DFB 1

SCENMON DS 1

SAYNAME LDA PLRNAME
 CMP #15
 BCS :SQUASH
 JSR PRINT
 PRSTRING PLRNAME
 NULL
 RTS
:SQUASH LDX #0
]LOOP LDA PLRNAME+1,X
 JSR COUT
 INX
 CPX #13
 BNE ]LOOP
 JSR PRINT
 ASC ".."
 NULL
 RTS

 LST ON
MODEND EQU *
 LST OFF

 do M16PLUS
 SAV RUN/MODULES/GAME.LOOK
 fin

 END
