*-------------------------------
* GAME.SPELL (part 1)
*-------------------------------
 DAT
 LST OFF

 REL

 USE MACROS
 USE EQUATES
 USE VARS
 USE LIB.JMP
 USE PLR.DSECT
 USE SPELL.DSECT
 USE SCEN.DSECT
 USE ITEM.DSECT
 USE ITEM2.DSECT
 USE PN.DSECT
 USE SD.DSECT

 do M16PLUS-1
 DSK SPELL1.L
 fin

 EXT WIZ11,WIZ12,WIZ13,WIZ14,WIZ21,WIZ22,WIZ23,WIZ24
 EXT WIZ31,WIZ32,WIZ33,WIZ34,WIZ41,WIZ42,WIZ43,WIZ44
 EXT WIZ51,WIZ52,WIZ53,WIZ54,WIZ61,WIZ62,WIZ63,WIZ64
 EXT WIZ71,WIZ72,WIZ73,WIZ74,WIZ81,WIZ82,WIZ83,WIZ84
 EXT CLE11,CLE12,CLE13,CLE14,CLE21,CLE22,CLE23,CLE24
 EXT CLE31,CLE32,CLE33,CLE34,CLE41,CLE42,CLE43,CLE44
 EXT CLE51,CLE52,CLE53,CLE54,CLE61,CLE62,CLE63,CLE64
 EXT CLE71,CLE72,CLE73,CLE74,CLE81,CLE82,CLE83,CLE84
 EXT SAG11,SAG12,SAG13,SAG14,SAG21,SAG22,SAG23,SAG24
 EXT SAG31,SAG32,SAG33,SAG34,SAG41,SAG42,SAG43,SAG44
 EXT SAG51,SAG52,SAG53,SAG54,SAG61,SAG62,SAG63,SAG64
 EXT SAG71,SAG72,SAG73,SAG74,SAG81,SAG82,SAG83,SAG84

 MODID "GAME.SPELL"

ENTRY MAC
HERE STR ]1
 DS HERE-*+]LEN+1
 <<<

START JSR PRINT
 GOTOXY 0;14
 CURSOROFF
 INVERSE
 COLOR YELLOW
 ZAPLINE
 NORMAL
 SOUND $24;FOREVER;$80
 VTAB 14
 COLOR ORANGE
 CENTER " Spell "
 COLOR YELLOW
 CR
 COLOR WHITE
 CURSORON
 NULL

 LDX NUMPARTY
]LOOP LDA CURPARTY2-1,X
 ORA CURPARTY-1,X
 BNE :GOTP
 DEX
 BPL ]LOOP
:GOTP STX NPRTY
]LOOP LDA CURPARTY2-1,X
 CMP MPLR+1
 BNE :NONO
 LDA CURPARTY-1,X
 CMP MPLR
 BNE :NONO
 STX MASTPLR
 BRA :MPLROK
:NONO DEX
 BNE ]LOOP
 DEATH

:MPLROK LDX #0
 LDA #0
 JSR LOADSPELL
 LDA SPELLBUFF
 STA MAXSPELLS

 LDX #0
 LDA #0
 JSR LOADMON2
 LDA MON2BUFF
 STA SMONSTERS
 LDA MON2BUFF+1
 STA SMONSTERS+1

 LDX #0
 LDA #0
 JSR LOADPLR
 LDA PLRBUFF
 STA SPLAYERS
 LDA PLRBUFF+1
 STA SPLAYERS+1

 LDX #0
 LDA #0
 JSR LOADSCEN
 LDX SCENBUFF
 STX SCENITEMS
 STX SCENMONS
]LOOP PHX
 LDA #0
 JSR LOADSCEN
 PLX
 LDA SCITEM
 STA SCENITEMS,X
 LDA SCMON2KILL
 STA SCENMONS,X
 DEX
 BNE ]LOOP
 LDX SCENARIO
 LDA #0
 JSR LOADSCEN
 LDA SCMON2KILL
 STA SCENMON

 LDX #0
 LDA #0
 JSR LOADITEM
 LDA ITEMBUFF
 STA MAXITEMS

 LDX #0
 LDA #0
 JSR LOADITEM2
 LDA ITEM2BUFF
 STA IRECS

 STZ CNTR

TOP ENT
 JSR CLRBOT
 JSR PRINT
 CURSORON
 COLOR AQUAMARINE
 LINE " 7 8 9"
 LINE "  \|/"
 LINE " 4-x-6"
 LINE "  /|\"
 LINE " 1 2 3"
 COLOR WHITE
 GOTOXY 10;15
 ASC "[V]iew :"
 GOTOXY 10;16
 ASC "[S]pell"
 GOTOXY 10;17
 ASC "[H]elp"
 GOTOXY 10;18
 ASC "[E]xit"
 NULL

TOPC JSR LOADMAST
 LDA PLRZPOS
 STA LEVEL
 LDA PLRXPOS ;Get top-left co-ordinate
 SEC
 SBC #4
 STA ANKX
 LDA PLRYPOS
 SEC
 SBC #4
 STA ANKY

 LDA #4
 STA XLOC
 STA YLOC

 LDX PLRXPOS
 LDY PLRYPOS
 LDA PLRZPOS
 JSR SHOWMAP
 JSR LOADMAST

 JSR PRINT
 GOTOXY 19;15
 CLEOL
 NULL
 LDA PLRNAME
 CMP #15
 BCS :SQUASH
 JSR PRINT
 PRSTRING PLRNAME
 NULL
 BRA :NAMEOK
:SQUASH LDX #0
]LOOP LDA PLRNAME+1,X
 JSR COUT
 INX
 CPX #13
 BNE ]LOOP
 JSR PRINT
 ASC ".."
 NULL
:NAMEOK JSR PRINT
 GOTOXY 0;21
 ZAPLINE
 ASC "Spell points : "
 COLOR YELLOW
 DEC8NEG PLRMAGIC
 ASC "/"
 DEC8 PLRMAGICMAX
 COLOR WHITE
 ASC " ("
 COLOR YELLOW
 DEC8NEG PLRCURRPNTS
 ASC "/"
 DEC8 PLRMAXPNTS
 COLOR WHITE
 ASC ")"
 GOTOXY 40;17
 CLEOL
 NULL

GETCMD JSR PRINT
 GOTOXY 68;12
 CLEOL
 CURSORON
 NULL
]LOOP JSR KEYIN
 JSR UPPER
 CMP #"H"
 BEQ HELP
 CMP #"V"
 BEQ CASTER
 CMP #"E"
 BEQ EXIT
 CMP #"S"
 BEQL DOSPELL
 CMP #$9B
 BNE ]LOOP
EXIT JSR PRINT
 ASC "Exit"
 CURSOROFF
 NULL
 RETURN

HELP JSR PRINT
 GOTOXY 68;12
 ASC "Help"
 NULL
 CALL "GAME.SPHELP"
 JMP TOP

CASTER JSR PRINT
 GOTOXY 0;21
 ZAPLINE
 ASC "Change view to (1-"
 DEC8 NPRTY
 ASC ") : "
 NULL
]LOOP JSR KEYIN
 CMP #$9B
 BEQ :OK
 SEC
 SBC #"1"
 CMP NPRTY
 BCS ]LOOP
 TAX
 INC
 STA MASTPLR
 JSR PRINT
 DEC8 MASTPLR
 NULL
 LDA CURPARTY,X
 STA MPLR
 LDA CURPARTY2,X
 STA MPLR+1
 JSR LOADMAST
 LDA PLRZPOS
 CMP LEVEL
 BEQ :OK
 LDX PLRZPOS
 LDA #0
 JSR LOADMAP
 LDX PLRZPOS
 LDA #0
 JSR LOADMAP2
:OK JSR PRINT
 ZAPLINE
 NULL
 JMP TOPC

DOSPELL JSR LOADMAST
 LDA PLRCOND
 AND #%1100_1001 ;Dead, paralyzed, asleep, stunned?
 BEQ :CONDOK
 JSR PRINT
 GOTOXY 40;15
 CLEOL
 COLOR PINK
 ASC "Out of action"
 COLOR WHITE
 SOUND $13;1;LOUD
 NULL
 BRA :ZZNO
:CONDOK LDX PLRXPOS
 LDY PLRYPOS
 JSR GETMAP
 CMP #SHPSAFETY
 BNE :CANDO
:INZONE JSR PRINT
 GOTOXY 0;21
 COLOR PINK
 ASC "Can't cast spells whilst on "
 COLOR AQUAMARINE
 ASC "holy ground"
 COLOR WHITE
 NULL
:ZZNO JMP GETCMD
:CANDO
* CMP #SHPSTAIRS
* BNE :CANDO2
* CPX #STAIRSUP
* BNE :CANDO2
* LDA LEVEL
* CMP #1
* BEQ :INZONE
*:CANDO2
 JSR PRINT
 GOTOXY 40;15
 CLEOL
 ASC "Spell name : "
 NULL

GETSPELL JSR PRINT
 GOTOXY 53;15
 CLEOL
 NULL
 GETLINE #15 ;Get spell name
 CPX #0
 BNE :OK
 JSR PRINT
 GOTOXY 40;15
 CLEOL
 GOTOXY 40;17
 CLEOL
 NULL
 JMP GETCMD

:OK STX SNAME
]LOOP LDA $200-1,X
 JSR UPPER
 STA SNAME,X
 DEX
 BNE ]LOOP

 STZ :CNTR
]LOOP INC :CNTR
 LDX :CNTR
 LDA #0
 JSR LOADSPELL
 LDA SPNAME+1
 CMP #"?" ;Spell doesn't exist
 BEQ :NEXT

 LDX #0
]LOOP2 LDA SNAME+1,X
 CMP SPNAME+1,X
 BNE :NEXT
 INX
 CPX SNAME
 BNE ]LOOP2
 CPX SPNAME
 BNE :NEXT
 LDA :CNTR
 BRA GOTIT

:NEXT LDA :CNTR
 CMP MAXSPELLS
 BNE ]LOOP
 JSR PRINT
 GOTOXY 40;17
 CLEOL
 COLOR PINK
 ASC "<what?>"
 COLOR WHITE
 SOUND $02;1;LOUD
 NULL
 JMP GETSPELL
:CNTR DS 1

GOTIT STA :SPELL
 JSR PRINT
 GOTOXY 40;17
 CLEOL
 NULL
 LDY #1
]LOOP CMP #33
 BCC :GOTY
 SEC
 SBC #32
 INY
 BRA ]LOOP
:GOTY TAX
 TYA ;A = class of spell, X = spell num
 JSR KNOWNSP ;We know this spell?
 BCS :KNOWN
 JSR PRINT
 COLOR PINK
 ASC "<not known>"
 COLOR WHITE
 SOUND $13;1;LOUD
 PRPAUSE 2
 NULL
 BRA :ZGETSP

:KNOWN LDA PLRCURRPNTS
 DEC
 BPL :POK
 JSR PRINT
 COLOR PINK
 ASC "<not enough"
 NULL
 BRA :OAH

:POK LDA PLRMAGIC
 CMP SPMAGIC
 BCS :MOK
 JSR PRINT
 COLOR PINK
 ASC "<not enough magic"
 NULL
:OAH JSR PRINT
 ASC " points>"
 COLOR WHITE
 SOUND $02;1;LOUD
 PRPAUSE 2
 NULL
:ZGETSP JMP GETSPELL

:MOK JSR PRINT
 GOTOXY 40;21
 CLEOL
 SOUND $10;1;LOUD
 NULL
 CLC
 XCE
 REP #$30
 LDA PLRZPOS ;Caster exp = exp + (map level * 2)
 AND #$FF
 ASL
 CLC
 ADC PLREXP
 STA PLREXP
 LDA PLREXP+2
 ADC #0
 STA PLREXP+2
 STZ EXP
 STZ EXP+2
 SEC
 XCE
 STZ LOGEXCEPTION
 STZ LOGPLR
 STZ DRAWSTATS
 STZ DONELOG
 BIT PLRARRESTFLAG
 BPL :MOK2
 RANDNUM #100
 CPX #90
 BCCL FAILED
:MOK2 LDA :SPELL
 DEC
 ASL
 TAX
 JMP (SPELLS,X)
:SPELL DS 1

CLRBOT ENT
 JSR PRINT
 GOTOXY 0;22
 LUP 7
 ZAPLINE
 CURSORUP
 --^
 ZAPLINE
 NULL
 RTS

LOGSPELL ENT
 BIT DONELOG
 BPL :NOPE
 RTS
:NOPE LDY #0 ;Add "<name> casts a <spellname>" to Log
 LDX #0
]LOOP LDA PLRNAME+1,X
 STA MISCBUFF+1,X
 INY
 INX
 CPX PLRNAME
 BNE ]LOOP
 INY
 LDX #0
]LOOP LDA :STR1+1,X
 STA MISCBUFF,Y
 INY
 INX
 CPX :STR1
 BNE ]LOOP
 LDA PLRXPOS
 JSR CONVERT
 STA MISCBUFF,Y
 INY
 TXA
 STA MISCBUFF,Y
 INY
 LDA #","
 STA MISCBUFF,Y
 INY
 LDA PLRYPOS
 JSR CONVERT
 STA MISCBUFF,Y
 INY
 TXA
 STA MISCBUFF,Y
 INY
 LDX #0
]LOOP LDA :STR2+1,X
 STA MISCBUFF,Y
 INY
 INX
 CPX :STR2
 BNE ]LOOP
 LDA LEVEL
 JSR CONVERT
 STA MISCBUFF,Y
 INY
 TXA
 STA MISCBUFF,Y
 INY
 LDX #0
]LOOP LDA :STR3+1,X
 STA MISCBUFF,Y
 INY
 INX
 CPX :STR3
 BNE ]LOOP
 LDX #0
]LOOP LDA SNAME+1,X
 STA MISCBUFF,Y
 INY
 INX
 CPX SNAME
 BNE ]LOOP
 LDA SPTYPE
 CMP #1 ;Regular
 BEQ :ONBIT
 CMP #2 ;Missile
 BNE :FIN
:ONBIT BIT LOGEXCEPTION
 BMI :FIN
 LDX #0
]LOOP LDA :STR4+1,X
 STA MISCBUFF,Y
 INY
 INX
 CPX :STR4
 BNE ]LOOP
 LDA XPOS
 JSR CONVERT
 STA MISCBUFF,Y
 INY
 TXA
 STA MISCBUFF,Y
 INY
 LDA #","
 STA MISCBUFF,Y
 INY
 LDA YPOS
 JSR CONVERT
 STA MISCBUFF,Y
 INY
 TXA
 STA MISCBUFF,Y
 INY
:FIN DEY
 STY MISCBUFF
 PNOTELOGBUFF $3;MISCBUFF
 LDA #$FF
 STA DONELOG
 RTS
:STR1 STR " at "
:STR2 STR " (level "
:STR3 STR ") casts a spell : "
:STR4 STR " on "

DONELOG DS 1

PLOGSPELL ENT
 JSR LOADMAST
 LDX PLRPARTY
 LDA #0
 JSR LOADPN
 LDX PLR
 LDA PLR+1
 JSR LOADPLR
 LDA PLRPARTY
 STA PPARTY
 CMP PARTYNUM
 BNE :OK
 RTS
:OK LDY #1
 LDX #0
]LOOP LDA :STR1+1,X
 STA MISCBUFF,Y
 INY
 INX
 CPX :STR1
 BNE ]LOOP
 LDX #0
]LOOP LDA PNNAME+1,X
 STA MISCBUFF,Y
 INY
 INX
 CPX PNNAME
 BNE ]LOOP
 LDX #0
]LOOP LDA :STR2+1,X
 STA MISCBUFF,Y
 INY
 INX
 CPX :STR2
 BNE ]LOOP
 LDA PLRXPOS
 JSR CONVERT
 STA MISCBUFF,Y
 INY
 TXA
 STA MISCBUFF,Y
 INY
 LDA #","
 STA MISCBUFF,Y
 INY
 LDA PLRYPOS
 JSR CONVERT
 STA MISCBUFF,Y
 INY
 TXA
 STA MISCBUFF,Y
 INY
 LDX #0
]LOOP LDA :STR3+1,X
 STA MISCBUFF,Y
 INY
 INX
 CPX :STR3
 BNE ]LOOP
 LDA LEVEL
 JSR CONVERT
 STA MISCBUFF,Y
 INY
 TXA
 STA MISCBUFF,Y
 INY
 LDX #0
]LOOP LDA :STR4+1,X
 STA MISCBUFF,Y
 INY
 INX
 CPX :STR4
 BNE ]LOOP
 DEY
 STY MISCBUFF
 LDA PARTYNUM
 PHA
 LDX PPARTY
 STX PARTYNUM
 LDA #0
 JSR LOADPN
 PNOTELOGBUFF $D;MISCBUFF
 PLX
 STX PARTYNUM
 LDA #0
 JMP LOADPN
:STR1 STR "Spell cast by Party '"
:STR2 STR "' at "
:STR3 STR " (level "
:STR4 STR ")"

PPARTY DS 1

CONVERT STZ :CHAR+1
 CMP #10
 BCC :LESS
 INC :CHAR+1
 SEC
 SBC #10
:LESS STA :CHAR
 ORA #"0"
 TAX
 LDA :CHAR+1
 ORA #"0"
 RTS
:CHAR DS 2

LOGEXCEPTION ENT
 DS 1

LOGPLR ENT
 DS 1

GETVIEW ENT
 JSR PRINT
 GOTOXY 40;21
 CLEOL
 ASC "Select target.."
 NULL
GETVIEW2 JSR PRINT
 CURSOROFF
 NULL
]TOPLOOP JSR TICKTOCK
 JSR WAITIN
 BCS :YES2
 JSR GETLOC
 JSR DOSPC
 JSR WAITIN
 BCS :YES
 JSR GETLOC
 JSR DOSHP
 BRA ]TOPLOOP
:YES2 PHA
 JSR GETLOC
 JSR DOSPC
 PLA
:YES PHA
 STA $C010
 JSR GETLOC
 JSR DOSHP
 JSR INITCNTR
 JSR PRINT
 MTOFF
 NORMAL
 COLOR WHITE
 NULL
 PLA
 JSR UPPER
 CMP #$8D
 BEQ :GET
 CMP #"H"-$40
 BEQ :KL
 CMP #"U"-$40
 BEQ :KR
 CMP #"K"-$40
 BEQ :KU
 CMP #"J"-$40
 BEQ :KD
 CMP #"W"-$40
 BEQ :REFRESH
 CMP #$9B
 BEQL :EXIT
 CMP #"1"
 BCC :GV
 CMP #"9"+1
 BCS :GV
:KEY2 SEC
 SBC #"1"
 ASL
 TAX
 LDA XLOC
 LDY YLOC
 JMP (:KEYS,X)

:REFRESH JSR REFRESH

:GV JMP GETVIEW2

:KL LDA #"4"
 HEX 2C
:KR LDA #"6"
 HEX 2C
:KU LDA #"8"
 HEX 2C
:KD LDA #"2"
 BRA :KEY2

:GET LDA XLOC
 TAX
 CLC
 ADC ANKX
 STA XPOS
 LDA YLOC
 TAY
 CLC
 ADC ANKY
 STA YPOS
 JSR GETGRID
 CMP #$FF
 BEQL FAILED
 JSR GETLOC
 CMP #SHPSAFETY
 BNE :GETNHG
 JSR PRINT
 GOTOXY 0;21
 CURSORON
 COLOR PINK
 ASC "Can't cast spells upon "
 COLOR AQUAMARINE
 ASC "holy ground"
 COLOR PINK
 ASC ". "
 COLOR WHITE
 CLEOL
 NULL
 GETRETURN
 BRA :EXIT
:GETNHG JSR PRINT
 GOTOXY 40;21
 CLEOL
 CURSORON
 ASC "Cast on ("
 COLOR YELLOW
 PAD2 XPOS
 ASC ","
 PAD2 YPOS
 COLOR WHITE
 ASC ")? : "
 NULL
 JSR KEYIN
 JSR UPPER
 CMP #"Y"
 BNE :GETNO
 JSR COUT
 CLC
 RTS
:GETNO LDA #"N"
 JSR COUT
:EXIT SEC
 RTS

:KEYS DA KEY1
 DA KEY2
 DA KEY3
 DA KEY4
 DA KEY5
 DA KEY6
 DA KEY7
 DA KEY8
 DA KEY9

KEY1 DEC
 INY
 BRA DOKEY

KEY2 INY
 BRA DOKEY

KEY3 INC
 INY
 BRA DOKEY

KEY4 DEC
 BRA DOKEY

ABORT ENT
 JSR PRINT
 GOTOXY 40;21
 CLEOL
 COLOR PINK
 ASC "Spell aborted"
 COLOR WHITE
 NULL
KEY5 JMP TOP

KEY6 INC
 BRA DOKEY

KEY7 DEC
 DEY
 BRA DOKEY

KEY8 DEY
 BRA DOKEY

KEY9 INC
 DEY

DOKEY CMP #9
 BCS :NOX
 STA XLOC
:NOX CPY #9
 BCS :NOY
 STY YLOC
:NOY JMP ]TOPLOOP

WAITIN STZ :FLAG
 STZ :CNTR
 STZ :CNTR2
]LOOP BIT DUMBTERM
 BMI :OVER
 JSR CHECKCTRLX
 JSR CHECKIN ;Did we get something from the modem?
 BCS :KEY
:OVER LDA $C000
 BMI :KEY
 BIT :FLAG
 BMI :MINUS
:PLUS LDA $C019
 BPL ]LOOP
 LDA #$FF
 STA :FLAG
 BRA ]LOOP
:MINUS LDA $C019
 BMI ]LOOP
 INC :CNTR
 BNE ]LOOP
 INC :CNTR2
 LDA :CNTR2
 CMP #16
 BNE ]LOOP
 CLC
 RTS
:KEY SEC
 RTS
:FLAG DS 1
:CNTR DS 1
:CNTR2 DS 1

NOTHING ENT
 JSR PRINT
 GOTOXY 40;21
 CLEOL
 COLOR PINK
 ASC "Nothing there"
 COLOR WHITE
 SOUND $02;1;LOUD
 NULL
 BRA FAILED
FAILEDEX ENT
 LDA #$FF
 STA LOGEXCEPTION
 JSR PRINT
 SOUND $02;1;LOUD
 PRPAUSE 2
 NULL
FAILED ENT
 JSR PRINT
 GOTOXY 0;21
 ZAPLINE
 COLOR PINK
 ASC "Spell failed"
 COLOR WHITE
 SOUND $13;1;LOUD
 PRPAUSE 1
 NULL

SPELLEND ENT
 JSR LOADMAST
 LDA PLRCURRPNTS ;Subtract Action points and Magic points
 SEC
 SBC SPTIME
 STA PLRCURRPNTS
 LDA PLRMAGIC
 SEC
 SBC SPMAGIC
 STA PLRMAGIC
 JSR SAVEMAST ;Save plr
 BIT LOGPLR
 BPL :CONT1
 JSR PLOGSPELL
:CONT1 JSR LOADMAST
 JSR LOGSPELL
 JSR DOEXP
 LDA #21
 JSR LOGLINE
 LDA PLRZPOS
 BNE :DUNGY
 LDX NUMPARTY
]LOOP LDA CURPARTY2-1,X
 BNE :GOTP
 LDA CURPARTY-1,X
 BNE :GOTP
 DEX
 BPL ]LOOP
 JSR POPMOD ;No-one left in the dungeon
 STZ VTEMP
 CALL "GAME.PRECSTLE" ;Update conds, points, HP, etc
 EXEC "GAME.CASTLE" ;Up we go..
:GOTP LDA CURPARTY2-1,X
 STA MPLR+1
 LDA CURPARTY-1,X
 STA MPLR
 STX MASTPLR
 JSR LOADMAST
:DUNGY BIT DRAWSTATS
 BPL :CONT2
 LDA #$FF ;Draw player stats only
 STA VTEMP
 CALL "DRAW.SCREEN"
:CONT2 JSR PRINT
 CURSOROFF
 COLOR YELLOW
 VTAB 23
 COLOR PINK
 CENTER " [Press any key] "
 COLOR WHITE
 NULL
 JSR KEYIN
 JSR PRINT
 INVERSE
 COLOR YELLOW
 ZAPLINE
 COLOR WHITE
 NORMAL
 NULL
 JMP TOP

DRAWSTATS ENT
 DS 1

DOEXP LDX #3
]LOOP LDA EXP,X
 BNE :EXPOK
 DEX
 BPL ]LOOP
 RTS
:EXPOK LDX NUMPARTY
 LDY #0
]LOOP PHX
 PHY
 LDA CURPARTY-1,X
 TAY
 LDA CURPARTY2-1,X
 TYX
 JSR LOADPLR
 LDA PLRZPOS
 CMP LEVEL
 BNE :PNXT
 LDA PLRCOND
 AND #%1100_1001 ;Dead, paralyzed, asleep, stunned?
 BNE :PNXT
 PLY
 INY
 PHY
:PNXT PLY
 PLX
 DEX
 BNE ]LOOP

 STY :DIVISOR
 CLC
 XCE
 REP #$30
 PushLong #0
 PushLong #0
 PushLong EXP
 PushLong :DIVISOR
 Tool $0D0B ;LongDivide
 PullLong EXP
 PLA ;Remainder
 PLA
 SEC
 XCE

 LDX #0 ;Add exp to party
]LOOP PHX
 LDA CURPARTY,X
 TAY
 LDA CURPARTY2,X
 TYX
 CMP #0
 BNE :L2
 CPX #0
 BEQ :PNEXT2
:L2 JSR LOADPLR
 LDA PLRZPOS
 CMP LEVEL
 BNE :PNEXT2
 CLC
 XCE
 REP #$30
 LDA PLREXP
 CLC
 ADC EXP
 STA PLREXP
 LDA PLREXP+2
 ADC EXP+2
 STA PLREXP+2
 SEC
 XCE
 PLX
 PHX
 LDA CURPARTY,X
 TAY
 LDA CURPARTY2,X
 TYX
 JSR SAVEPLR
:PNEXT2 PLX
 INX
 CPX NUMPARTY
 BNE ]LOOP
 LDX #0
 LDY #0
 LDA #21
 JSR PICKLINE
 LDA $200
 CMP #" "
 BEQ :L22OK
 JSR PRINT
 ASC " "
 NULL
:L22OK JSR PRINT
 ASC "Party gets "
 COLOR YELLOW
 DEC32 EXP
 COLOR WHITE
 ASC " exp. each"
 SOUND $25;1;LOUD
 NULL
 RTS
:DIVISOR DS 4

LOGLINE ENT
 LDX #0 ;A reg = line to log
 LDY #79
 JSR PICKLINE
 LDX #79
]LOOP LDA $200,X
 CMP #" "
 BNE :OK
 DEX
 BPL ]LOOP
 RTS ;Blank line
:OK INX
 STX MISCBUFF
]LOOP LDA $200,X
 STA MISCBUFF+1,X
 DEX
 BPL ]LOOP
 PNOTELOGBUFF $3;MISCBUFF
 BIT LOGPLR
 BPL :NO
 LDA PARTYNUM
 CMP PPARTY
 BEQ :NO
 PHA
 LDA PPARTY
 STA PARTYNUM
 PNOTELOGBUFF $1;MISCBUFF
 PLX
 STX PARTYNUM
 LDA #0
 JSR LOADPN
:NO RTS

LOADMAST ENT
 LDX MPLR
 LDA MPLR+1
 JMP LOADPLR

SAVEMAST ENT
 LDX MPLR
 LDA MPLR+1
 JMP SAVEPLR

GETLOC LDA ANKX
 CLC
 ADC XLOC
 TAX
 LDA ANKY
 CLC
 ADC YLOC
 TAY
 JSR GETMAP
 LDX XLOC
 LDY YLOC
 RTS

SPELLS ENT
 DA WIZ11
 DA WIZ12
 DA WIZ13
 DA WIZ14
 DA WIZ21
 DA WIZ22
 DA WIZ23
 DA WIZ24
 DA WIZ31
 DA WIZ32
 DA WIZ33
 DA WIZ34
 DA WIZ41
 DA WIZ42
 DA WIZ43
 DA WIZ44
 DA WIZ51
 DA WIZ52
 DA WIZ53
 DA WIZ54
 DA WIZ61
 DA WIZ62
 DA WIZ63
 DA WIZ64
 DA WIZ71
 DA WIZ72
 DA WIZ73
 DA WIZ74
 DA WIZ81
 DA WIZ82
 DA WIZ83
 DA WIZ84
 DA CLE11
 DA CLE12
 DA CLE13
 DA CLE14
 DA CLE21
 DA CLE22
 DA CLE23
 DA CLE24
 DA CLE31
 DA CLE32
 DA CLE33
 DA CLE34
 DA CLE41
 DA CLE42
 DA CLE43
 DA CLE44
 DA CLE51
 DA CLE52
 DA CLE53
 DA CLE54
 DA CLE61
 DA CLE62
 DA CLE63
 DA CLE64
 DA CLE71
 DA CLE72
 DA CLE73
 DA CLE74
 DA CLE81
 DA CLE82
 DA CLE83
 DA CLE84
 DA SAG11
 DA SAG12
 DA SAG13
 DA SAG14
 DA SAG21
 DA SAG22
 DA SAG23
 DA SAG24
 DA SAG31
 DA SAG32
 DA SAG33
 DA SAG34
 DA SAG41
 DA SAG42
 DA SAG43
 DA SAG44
 DA SAG51
 DA SAG52
 DA SAG53
 DA SAG54
 DA SAG61
 DA SAG62
 DA SAG63
 DA SAG64
 DA SAG71
 DA SAG72
 DA SAG73
 DA SAG74
 DA SAG81
 DA SAG82
 DA SAG83
 DA SAG84

SQUARE ENT
 DS 1 ;Map2 findings (wot's on this square)

NPRTY ENT
 DS 1
MAXSPELLS ENT
 DS 1 ;Number of spells
SNAME ENT
 DS 1+15

XLOC ENT
 DS 1 ;Loc of 'view' area
YLOC ENT
 DS 1
ANKX ENT
 DS 1 ;Top-left of 'view' area
ANKY ENT
 DS 1
CNTR ENT
 DS 1
XPOS ENT
 DS 1 ;Square spell is cast on
YPOS ENT
 DS 1
LEVEL ENT
 DS 1

SPLAYERS ENT
 DS 2 ;Total in file
SMONSTERS ENT
 DS 2

MASTPLR ENT
 DS 1

PLR ENT
 DS 2

EXP ENT
 DS 4 ;Exp gained

SCENITEMS ENT
 DS 1+9
SCENMONS ENT
 DS 1+9
SCENMON ENT
 DS 1
GOLD ENT
 DS 4
ITEMS ENT
 DS 15
NEWITEM ENT
 DS 1
MAXITEMS ENT
 DS 1
IRECS ENT
 DS 2

 LST ON
MODEND EQU *
 LST OFF

 do M16PLUS
 SAV SPELL1.L
 fin

 END
