*-------------------------------
* GAME.SPELL (part 2)
*-------------------------------
 DAT
 LST OFF

 REL

 USE MACROS
 USE EQUATES
 USE VARS
 USE LIB.JMP
 USE TABLES
 USE PLR.DSECT
 USE MON.DSECT
 USE MON2.DSECT
 USE SPELL.DSECT
 USE PN.DSECT

 do M16PLUS-1
 DSK SPELL2.L
 fin

 EXT GETVIEW,TOP,ABORT,NOTHING,FAILED,SPELLEND,SQUARE,DRAWSTATS
 EXT XPOS,YPOS,LEVEL,SPLAYERS,SMONSTERS,ADDPOINTS,LOGEXCEPTION
 EXT DOITEMS,DOROLL,TOOFAR,PLR,LOGPLR,CHECKPOS,NPRTY,ANKX,ANKY
 EXT CLE54,CHARITEMS,MONKILLED,LOADMAST,SAVEMAST,UNKNOWN

STUN = 0
BLIND = 1
LEVITATE = 2
SLEEP = 3
INVISIBLE = 4
POISON = 5
PARALYZE = 6
DIE = 7

UNSTUN = 8
UNBLIND = 9
UNLEVITATE = 10
UNSLEEP = 11
UNINVISIBLE = 12
UNPOISON = 13
UNPARALYZE = 14
UNDIE = 15

WIZ11 ENT
 JMP DOTYPE ;Frebl

WIZ12 ENT
 LDA #SLEEP ;Slef
 JMP DOTYPE

WIZ13 ENT
 LDA #STUN ;Snaf
 JMP DOTYPE

WIZ14 ENT
 LDA #%0000_0100 ;Lefca
 TSB PLRCOND
 LDX SPDUR
 CPX #$FF
 BEQ :PERM
 LDA SPDUR+1
 JSR DOROLL
 HEX 2C
:PERM LDA #$FF
 LDX #LEVITATE
 STA PLRCONDX,X
 JSR PRINT
 GOTOXY 0;21
 ZAPLINE
 PRSTRING PLRNAME
 ASC " levitated"
 NULL
MASTEND ENT
 JSR SAVEMAST
 LDA #$FF
 STA DRAWSTATS
 STA LOGEXCEPTION
 JMP SPELLEND

WIZ21 ENT
:TOP JSR PRINT ;Lenvi
 GOTOXY 0;21
 ZAPLINE
 ASC "Levitate party member #"
 NULL
]LOOP JSR KEYIN
 CMP #$9B
 BEQL ABORT
 SEC
 SBC #"1"
 CMP NPRTY
 BCS ]LOOP
 TAX
 LDA CURPARTY,X
 STA PLR
 LDA CURPARTY2,X
 STA PLR+1
 LDX PLR
 LDA PLR+1
 JSR LOADPLR
 JSR PRINT
 GOTOXY 0;21
 ZAPLINE
 ASC "Levitate "
 PRSTRING PLRNAME
 ASC " (y/N)? : "
 NULL
 JSR KEYIN
 JSR UPPER
 CMP #"Y"
 BNE :TOP
 LDA PLRZPOS
 CMP LEVEL
 BEQ :OK
 JMP TOOFAR
:OK JSR PRINT
 GOTOXY 0;21
 ZAPLINE
 PRSTRING PLRNAME
 ASC " is levitated"
 NULL
 LDX SPDUR
 CPX #$FF
 BEQ :PERM
 LDX SPDUR
 LDA SPDUR+1
 JSR DOROLL
 HEX 2C
:PERM LDA #$FF
 LDX #LEVITATE
 STA PLRCONDX,X
 LDA #%0000_0100
 TSB PLRCOND
 LDX PLR
 LDA PLR+1
 JSR SAVEPLR
 LDA #$FF
 STA DRAWSTATS
 STA LOGEXCEPTION
 JMP SPELLEND

WIZ22 ENT
 ;Smalk

WIZ23 ENT
 JMP DOTYPE ;Blocum

WIZ24 ENT
 LDA #PARALYZE ;Pazcra

WIZ31 ENT
 ;Snablm

WIZ32 ENT
 JMP DOTYPE ;Freblma

WIZ33 ENT
 JMP WIZ14 ;Leftcasma

WIZ34 ENT
 LDA #2 ;Spedi
 LDX #1
 JMP ADDPOINTS

WIZ41 ENT
 JSR GETVIEW ;Difeld
 BCSL ABORT
 LDX XPOS
 LDY YPOS
 JSR GETMAP
 CMP #SHPFF
 BNEL FAILED
 CPX #FFHORIZ
 BEQ :OKH
:OKV LDA #FFDIMVERT
 HEX 2C
:OKH LDA #FFDIMHORIZ
 XBA
 LDX XPOS
 LDY YPOS
 LDA #SHPFF
 JSR PUTMAP
 JSR PRINT
 GOTOXY 40;21
 CLEOL
 NULL
 LDA PLRZPOS
 JSR PRMAPALL
 JSR PRINT
 GOTOXY 0;21
 ASC "Force field diminished at "
 PAD2 XPOS
 ASC ","
 PAD2 YPOS
 ASC " lvl "
 DEC8 LEVEL
 NULL
 LDX LEVEL
 LDA #0
 JSR SAVEMAP
 JMP SPELLEND

WIZ42 ENT
 JMP WIZ21 ;Levimaf

WIZ43 ENT
 LDA #4 ;Spedimaf
 LDX #1
 JMP ADDPOINTS

WIZ44 ENT
 LDA #POISON ;Paraf

WIZ51 ENT
 JMP DOTYPE ;Ardatine

WIZ52 ENT
:TOP JSR PRINT ;Telak
 GOTOXY 0;21
 ZAPLINE
 ASC "Teleport party member #"
 NULL
]LOOP JSR KEYIN
 CMP #$9B
 BEQL ABORT
 SEC
 SBC #"1"
 CMP NPRTY
 BCS ]LOOP
 TAX
 LDA CURPARTY,X
 STA PLR
 LDA CURPARTY2,X
 STA PLR+1
 LDX PLR
 LDA PLR+1
 JSR LOADPLR
 JSR PRINT
 GOTOXY 0;21
 ZAPLINE
 ASC "Teleport "
 PRSTRING PLRNAME
 ASC " (y/N)? : "
 NULL
 JSR KEYIN
 JSR UPPER
 CMP #"Y"
 BNE :TOP
 JSR PRINT
 GOTOXY 0;21
 ZAPLINE
 PRSTRING PLRNAME
 ASC " teleported"
 NULL
 LDA PLRZPOS
 CMP LEVEL
 BNEL TOOFAR
 STZ :CNTR
]LOOP INC :CNTR
 LDA :CNTR
 CMP #32
 BEQL FAILED
 RANDNUM #$10
 DEX
 STX :XGOTO
 RANDNUM #$10
 DEX
 STX :YGOTO
 LDX :XGOTO
 LDY :YGOTO
 JSR CHECKPOS
 BCS ]LOOP
 LDX PLRXPOS
 LDY PLRYPOS
 LDA #-1
 JSR PUTMAP2
 LDX :XGOTO
 LDY :YGOTO
 LDA #1
 JSR PUTMAP2
 LDX LEVEL
 LDA #0
 JSR SAVEMAP2
 LDA :XGOTO
 STA PLRXPOS
 LDA :YGOTO
 STA PLRYPOS
 LDX PLR
 LDA PLR+1
 JSR SAVEPLR
 LDA #$FF
 STA LOGEXCEPTION
 JMP SPELLEND
:XPOS DS 1
:YPOS DS 1
:XGOTO DS 1
:YGOTO DS 1
:CNTR DS 1

WIZ53 ENT
:TOP JSR PRINT ;Telpi
 GOTOXY 0;21
 ZAPLINE
 ASC "Teleport party member #"
 NULL
]LOOP JSR KEYIN
 CMP #$9B
 BEQL ABORT
 SEC
 SBC #"1"
 CMP NPRTY
 BCS ]LOOP
 TAX
 LDA CURPARTY,X
 STA PLR
 LDA CURPARTY2,X
 STA PLR+1
 LDX PLR
 LDA PLR+1
 JSR LOADPLR
 JSR PRINT
 GOTOXY 0;21
 ZAPLINE
 ASC "Teleport "
 PRSTRING PLRNAME
 ASC " (y/N)? : "
 NULL
 JSR KEYIN
 JSR UPPER
 CMP #"Y"
 BNE :TOP
 JSR PRINT
 GOTOXY 0;21
 ZAPLINE
 ASC "To loc X="
 NULL
]LOOP GETLINE #2
 BCSL ABORT
 CPX #0
 BEQ ]LOOP
 JSR GETNUM
 STX :XGOTO
 JSR PRINT
 ASC ", Y="
 NULL
]LOOP GETLINE #2
 BCSL ABORT
 CPX #0
 BEQ ]LOOP
 JSR GETNUM
 STX :YGOTO
 JSR PRINT
 ASC ", Lvl="
 NULL
]LOOP GETLINE #2
 BCSL ABORT
 CPX #0
 BEQ ]LOOP
 JSR GETNUM
 STX :ZGOTO
 DEX
 TXA
 LDX SCENARIO
 CMP MAPLEVELS-1,X
 BCSL :NOPE
 LDA :XGOTO
 CMP #$10
 BCSL :NOPE
 LDA :YGOTO
 CMP #$10
 BCSL :NOPE

 JSR PRINT
 GOTOXY 0;21
 ZAPLINE
 ASC "Teleport "
 PRSTRING PLRNAME
 ASC " to "
 PAD2 :XGOTO
 ASC ","
 PAD2 :YGOTO
 ASC " Lvl "
 DEC8 :ZGOTO
 ASC " (y/N)? : "
 NULL
 JSR KEYIN
 JSR UPPER
 CMP #"Y"
 BNEL ABORT
 JSR PRINT
 ASC "Yes"
 NULL

 LDX :ZGOTO
 LDA #0
 JSR LOADMAP
 LDX :XGOTO
 LDY :YGOTO
 JSR CHECKPOS
 BCC :SHPOK
 JSR LOADMAST
 LDX PLRZPOS
 LDA #0
 JSR LOADMAP
 LDX PLRZPOS
 LDA #0
 JSR LOADMAP2
:NOPE JMP FAILED

:SHPOK JSR PRINT
 GOTOXY 0;21
 ZAPLINE
 PRSTRING PLRNAME
 ASC " teleported to "
 PAD2 :XGOTO
 ASC ","
 PAD2 :YGOTO
 ASC " lvl "
 DEC8 :ZGOTO
 NULL
 LDX PLRZPOS
 LDA #0
 JSR LOADMAP2
 LDX PLRXPOS
 LDY PLRYPOS
 LDA #-1
 JSR PUTMAP2
 LDX PLRZPOS
 LDA #0
 JSR SAVEMAP2

 LDX :ZGOTO
 LDA #0
 JSR LOADMAP2
 LDX :XGOTO
 LDY :YGOTO
 LDA #1
 JSR PUTMAP2
 LDX :ZGOTO
 LDA #0
 JSR SAVEMAP2

 LDA :XGOTO
 STA PLRXPOS
 LDA :YGOTO
 STA PLRYPOS
 LDA :ZGOTO
 STA PLRZPOS
 LDX PLR
 LDA PLR+1
 JSR SAVEPLR
 JSR LOADMAST
 LDA PLRZPOS
 STA LEVEL
 LDX PLRZPOS
 LDA #0
 JSR LOADMAP
 LDX PLRZPOS
 LDA #0
 JSR LOADMAP2
 LDA #$FF
 STA LOGEXCEPTION
 JMP SPELLEND
:XGOTO DS 1
:YGOTO DS 1
:ZGOTO DS 1
:SHAPE DS 1

WIZ54 ENT
 JMP WIZ42 ;Unlevi

WIZ61 ENT
 JMP CLE54 ;Klemna

WIZ62 ENT
 LDA PLRXPOS ;Gathpa
 STA :X
 LDA PLRYPOS
 STA :Y
 LDA PLRZPOS
 STA :Z
 JSR PRINT
 GOTOXY 0;21
 ZAPLINE
 ASC "Gathering party.."
 NULL
 LDX NPRTY
]LOOP PHX
 LDA CURPARTY-1,X
 STA PLR
 LDA CURPARTY2-1,X
 STA PLR+1
 LDX PLR
 LDA PLR+1
 JSR LOADPLR
 LDX PLRZPOS
 LDA #0
 JSR LOADMAP2
 LDX PLRXPOS
 LDY PLRYPOS
 LDA #-1
 JSR PUTMAP2
 LDX PLRZPOS
 LDA #0
 JSR SAVEMAP2

 LDA :X
 STA PLRXPOS
 LDA :Y
 STA PLRYPOS
 LDA :Z
 STA PLRZPOS
 LDX PLR
 LDA PLR+1
 JSR SAVEPLR
 PLX
 DEX
 BNE ]LOOP
 LDX :Z
 LDA #0
 JSR LOADMAP2
 LDX :X
 LDY :Y
 LDA NPRTY
 JSR PUTMAP2
 LDX :Z
 LDA #0
 JSR SAVEMAP2

 JSR PRINT
 GOTOXY 0;21
 ZAPLINE
 ASC "Party gathered at "
 PAD2 :X
 ASC ","
 PAD2 :Y
 ASC " lvl "
 DEC8 :Z
 NULL
 JMP SPELLEND
:X DS 1
:Y DS 1
:Z DS 1

WIZ63 ENT
 JSR PRINT ;Gatelpi
 GOTOXY 0;21
 ZAPLINE
 ASC "Teleport party to loc X="
 NULL
]LOOP GETLINE #2
 BCSL ABORT
 CPX #0
 BEQ ]LOOP
 JSR GETNUM
 STX :X
 JSR PRINT
 ASC ", Y="
 NULL
]LOOP GETLINE #2
 BCSL ABORT
 CPX #0
 BEQ ]LOOP
 JSR GETNUM
 STX :Y
 JSR PRINT
 ASC ", Lvl="
 NULL
]LOOP GETLINE #2
 BCSL ABORT
 CPX #0
 BEQ ]LOOP
 JSR GETNUM
 STX :Z
 DEX
 TXA
 LDX SCENARIO
 CMP MAPLEVELS-1,X
 BCS :NO
 LDA :XGOTO
 CMP #$10
 BCS :NO
 LDA :YGOTO
 CMP #$10
 BCC :OK
:NO JMP FAILED

:OK JSR PRINT
 GOTOXY 0;21
 ZAPLINE
 ASC "Teleport party to "
 PAD2 :X
 ASC ","
 PAD2 :Y
 ASC " level "
 DEC8 :Z
 ASC " (y/N)? : "
 NULL
 JSR KEYIN
 JSR UPPER
 CMP #"Y"
 BNEL ABORT
 JSR PRINT
 ASC "Yes"
 NULL

 LDX :Z
 LDA #0
 JSR LOADMAP
 LDX :X
 LDY :Y
 JSR CHECKPOS
 BCC :SHPOK
 LDX LEVEL
 LDA #0
 JSR LOADMAP
 JMP :NO

:SHPOK JSR PRINT
 GOTOXY 0;21
 ZAPLINE
 ASC "Party teleported to "
 PAD2 :X
 ASC ","
 PAD2 :Y
 ASC " level "
 DEC8 :Z
 NULL
 LDX NPRTY
]LOOP PHX
 LDA CURPARTY-1,X
 STA PLR
 LDA CURPARTY2-1,X
 STA PLR+1
 LDX PLR
 LDA PLR+1
 JSR LOADPLR

 LDX PLRZPOS
 LDA #0
 JSR LOADMAP2
 LDX PLRXPOS
 LDY PLRYPOS
 LDA #-1
 JSR PUTMAP2
 LDX PLRZPOS
 LDA #0
 JSR SAVEMAP2
 LDA :X
 STA PLRXPOS
 LDA :Y
 STA PLRYPOS
 LDA :Z
 STA PLRZPOS
 LDX PLR
 LDA PLR+1
 JSR SAVEPLR
 PLX
 DEX
 BNE ]LOOP

 LDX :Z
 LDA #0
 JSR LOADMAP
 LDX :Z
 LDA #0
 JSR LOADMAP2
 LDX :X
 LDY :Y
 LDA NPRTY
 JSR PUTMAP2
 LDX :Z
 LDA #0
 JSR SAVEMAP2
 JMP SPELLEND
:X DS 1
:Y DS 1
:Z DS 1
:XGOTO DS 1
:YGOTO DS 1
:SHAPE DS 1

WIZ64 ENT
 LDA #3 ;Spedimasup
 LDX #0
 JMP ADDPOINTS

WIZ71 ENT
WIZ72 ENT
WIZ73 ENT
WIZ74 ENT
WIZ81 ENT
WIZ82 ENT
WIZ83 ENT
WIZ84 ENT
 JMP UNKNOWN

DOTYPE ENT
 STA TYPEINFO
 LDA SPTYPE
 BNE :OK
 DEATH
:OK DEC
 ASL
 TAX
 JMP (TYPES,X)
TYPEINFO ENT
 DS 1 ;Action to take (eg; sleep, levitate, etc)

TYPES DA TYPE1 ;Reg
 DA TYPE2 ;Missile
 DA TYPE3 ;Area
 DA TYPE4 ;Info
 DA TYPE5 ;Party

TYPE1 JSR GETVIEW
 BCSL ABORT
 LDX XPOS
 LDY YPOS
 JSR GETMAP2
 CMP #0
 BEQL NOTHING
 STA SQUARE
 AND #%0000_1111
 STA VTEMP
 LDA SQUARE
 LSR
 LSR
 LSR
 LSR
 STA VTEMP+1
 LDA VTEMP
 BEQ :MON
 LDA VTEMP+1
 BEQ :CHAR
 JSR PRINT
 GOTOXY 40;21
 CLEOL
 ASC "Cast on Monsters or Persons (m/p)? : "
 NULL
]LOOP JSR KEYIN
 JSR UPPER
 CMP #$9B
 BEQL ABORT
 CMP #"M"
 BEQ :CMON
 CMP #"P"
 BNE ]LOOP
 JSR COUT
 BRA :CHAR

:WHAT DS 1

:CMON JSR COUT
:MON LDA #0
 HEX 2C
:CHAR LDA #$FF
 STA MISCBUFF+3 ;00=monster, FF=player
 STA :WHAT
 LDA XPOS
 STA MISCBUFF
 LDA YPOS
 STA MISCBUFF+1
 LDA LEVEL
 STA MISCBUFF+2
 LDA #$FF
 STA MISCBUFF+4 ;Own party OK
 JSR PRINT
 GOTOXY 40;15
 CLEOL
 NULL
 CALL "ATTACK.MOD"
 LDA VTEMP
 STA :REC
 LDA VTEMP+1
 STA :REC+1
 JSR LOADMAST
 LDA MISCBUFF+3
 BMIL NOTHING ;Shouldn't happen..
 CMP #$7F
 BEQL ABORT
 LDA :WHAT ;00=monster, FF=player
 BMIL :GOTCHAR

:GOTMON LDX :REC
 LDA :REC+1
 JSR LOADMON2
 LDX MTYPE
 LDA MTYPE+1
 JSR LOADMON
 LDA MLEVEL
 BEQL FAILED
 LDX SPDUR
 CPX #$FF
 BEQ :MPERM
 LDX SPDUR
 LDA SPDUR+1
 JSR DOROLL
 HEX 2C
:MPERM LDA #$FF ;Permanent
 LDX TYPEINFO
 CPX #8
 BCC :MCOK
 PHA
 TXA
 SEC
 SBC #8
 TAX
 PLA
:MCOK STA MCONDX,X
 LDA #1
]LOOP CPX #0
 BEQ :YEHYEH
 ASL
 DEX
 BRA ]LOOP
:YEHYEH LDX TYPEINFO
 CPX #8
 BCS :RESETM
 TSB MCOND ;Add cond
 BRA :MC2
:RESETM TRB MCOND ;Remove cond
:MC2 JSR PRINT
 GOTOXY 0;21
 ZAPLINE
 COLOR ORANGE
 PRSTRING MNAME
 COLOR WHITE
 ASC " is "
 COLOR PINK
 NULL
 LDA TYPEINFO
 ASL
 ASL
 ASL
 ASL
 TAX
 LDA :CNAMES,X
 TAY
]LOOP INX
 LDA :CNAMES,X
 JSR COUT
 DEY
 BNE ]LOOP
 JSR PRINT
 COLOR WHITE
 PRPAUSE 1
 NULL
 LDX :REC
 LDA :REC+1
 JSR SAVEMON2
 JMP SPELLEND

:GOTCHAR LDX :REC
 LDA :REC+1
 JSR LOADPLR
 LDX SPDUR
 CPX #$FF
 BEQ :PPERM
 LDX SPDUR
 LDA SPDUR+1
 JSR DOROLL
 HEX 2C
:PPERM LDA #$FF ;Permanent
 LDX TYPEINFO
 CPX #8
 BCC :PCOK
 PHA
 TXA
 SEC
 SBC #8
 TAX
 PLA
:PCOK STA PLRCONDX,X
 LDA #1
]LOOP CPX #0
 BEQ :PYEH
 ASL
 DEX
 BRA ]LOOP
:PYEH LDX TYPEINFO
 CPX #8
 BCS :RESETP
 STA :CONDO
 TSB PLRCOND ;Add cond
 BRA :PC2
:RESETP TRB PLRCOND ;Remove cond
:PC2 JSR PRINT
 GOTOXY 0;21
 ZAPLINE
 COLOR GREEN
 PRSTRING PLRNAME
 COLOR WHITE
 ASC " is "
 COLOR PINK
 NULL
 LDA TYPEINFO
 ASL
 ASL
 ASL
 ASL
 TAX
 LDA :CNAMES,X
 TAY
]LOOP INX
 LDA :CNAMES,X
 JSR COUT
 DEY
 BNE ]LOOP
 JSR PRINT
 COLOR WHITE
 PRPAUSE 1
 NULL
 LDX :REC
 STX PLR
 LDA :REC+1
 STA PLR+1
 JSR SAVEPLR
 LDA PLRPARTY
 CMP PARTYNUM
 BEQ :PNUMOK
 JSR HOTORNOT ;On hot list?
 BNE :PASS2
 LDA :CONDO
 AND #%1000_0000
 BEQ :PASS
 BIT BEATUPLEADER ;Able to beat up leader and get away with it?
 BPL :NOWAY
 LDX SCENARIO
 LDA PLRPARTY
 CMP LEADPRTY-1,X
 BEQ :PASS
:NOWAY JSR INCKILLSMAST ;Does LOADMAST, INCR PLRPKILLS/MAX, SAVEMAST
:PASS LDA :CONDO
 AND #%0110_1011 ;Paralyzed, poisoned, slept, blinded, stunned
 BEQ :PASS2
 BIT BEATUPLEADER ;Able to beat up leader and get away with it?
 BPL :NOWAY2
 LDX :REC
 LDA :REC+1
 JSR LOADPLR
 LDX SCENARIO
 LDA PLRPARTY
 CMP LEADPRTY-1,X
 BEQ :PASS2
:NOWAY2 JSR INCASSMAST ;Does LOADMAST, INCR PLRPASSAULTS/MAX, SAVEMAST
:PASS2 LDA #$FF
 STA LOGPLR
 STZ DRAWSTATS
 BRA :CFIN
:PNUMOK LDA #$FF
 STA LOGPLR
 STA DRAWSTATS
:CFIN JMP SPELLEND

:REC DS 2
:DAM DS 1
:CONDO DS 1

:CNAMES PAD16 "stunned" ;   0 (bit)
 PAD16 "blinded" ;   1
 PAD16 "levitated" ;  2
 PAD16 "slept" ;   3
 PAD16 "invisible" ;  4
 PAD16 "poisoned" ;   5
 PAD16 "paralyzed" ;  6
 PAD16 "dead!" ;   7
 PAD16 "unstunned" ;  0 (bit)
 PAD16 "unblinded" ;  1
 PAD16 "unlevitated" ;2
 PAD16 "awoken" ;   3
 PAD16 "visible" ;   4
 PAD16 "unpoisoned" ; 5
 PAD16 "unparalyzed" ;6
 PAD16 "alive!" ;   7

TYPE2 JSR GETVIEW
 BCSL ABORT
 JSR PRINT
 GOTOXY 40;21
 CLEOL
 NULL
 LDX XPOS
 LDY YPOS
 JSR GETMAP2
 CMP #0
 BEQL NOTHING
 STA SQUARE
 AND #%0000_1111
 STA VTEMP
 LDA SQUARE
 LSR
 LSR
 LSR
 LSR
 STA VTEMP+1
 LDA VTEMP
 BEQ :MON
 LDA VTEMP+1
 BEQL :CHAR
 JSR PRINT
 ASC "Fire on Monsters or Persons (m/p)? : "
 NULL
]LOOP JSR KEYIN
 JSR UPPER
 CMP #$9B
 BEQL ABORT
 CMP #"M"
 BEQ :CMON
 CMP #"P"
 BNE ]LOOP
 JSR COUT
 BRA :CHAR

:WHAT DS 1

:CMON JSR COUT
:MON LDA #0
 HEX 2C
:CHAR LDA #$FF
 STA MISCBUFF+3 ;00=monster, FF=player
 STA :WHAT
 LDA XPOS
 STA MISCBUFF
 LDA YPOS
 STA MISCBUFF+1
 LDA LEVEL
 STA MISCBUFF+2
 STZ MISCBUFF+4 ;Not on own party
 JSR PRINT
 GOTOXY 40;15
 CLEOL
 NULL
 CALL "ATTACK.MOD"
 LDA VTEMP
 STA :REC
 LDA VTEMP+1
 STA :REC+1
 JSR LOADMAST
 LDA MISCBUFF+3
 BMIL NOTHING ;Shouldn't happen..
 CMP #$7F
 BEQL ABORT
 LDA :WHAT ;00=monster, FF=player
 BMIL :GOTCHAR

:GOTMON LDX :REC
 LDA :REC+1
 JSR LOADMON2
 LDX MTYPE
 LDA MTYPE+1
 JSR LOADMON
 LDA MLEVEL
 BEQL FAILED
 LDX SPDAM
 LDA SPDAM+1
 JSR DOROLL
 STA :DAM
 LDA MCURHP
 SEC
 SBC :DAM
 STA MCURHP
 PHP
 JSR PRINT
 GOTOXY 0;21
 ZAPLINE
 COLOR ORANGE
 PRSTRING MNAME
 COLOR WHITE
 ASC " takes "
 COLOR YELLOW
 DEC8 :DAM
 COLOR WHITE
 ASC " damage"
 SOUND $11;1;LOUD
 PRPAUSE 1
 NULL
 PLP
 BEQ :MDEAD
 BCS :MALIVE
:MDEAD JSR PRINT
 COLOR PINK
 ASC " and dies!"
 COLOR WHITE
 PRPAUSE 1
 NULL
 LDX :REC
 LDA :REC+1
 JSR MONKILLED
 JSR PRINT
 SOUND $27;1;LOUD
 NULL
 JMP SPELLEND
:MALIVE LDX :REC
 LDA :REC+1
 JSR SAVEMON2
 JMP SPELLEND

:GOTCHAR LDX :REC
 LDA :REC+1
 JSR LOADPLR
 LDA PLRCOND ;Fail if already dead
 AND #%1000_0000
 BMIL FAILED
 LDX SPDAM
 LDA SPDAM+1
 JSR DOROLL
 STA :DAM
 LDA #$FF
 STA LOGPLR
 LDA :REC
 STA PLR
 LDA :REC+1
 STA PLR+1
 LDA PLRHP
 SEC
 SBC :DAM
 STA PLRHP
 PHP
 JSR PRINT
 GOTOXY 0;21
 ZAPLINE
 COLOR GREEN
 PRSTRING PLRNAME
 COLOR WHITE
 ASC " takes "
 COLOR YELLOW
 DEC8 :DAM
 COLOR WHITE
 ASC " damage"
 SOUND $11;1;LOUD
 PRPAUSE 1
 NULL
 PLP
 BEQ :PDEAD
 BCS :PALIVE
:PDEAD LDA PLRCOND
 AND #%1000_0000
 BMI :PALIVE ;Already dead
 JSR PRINT
 COLOR PINK
 ASC " and dies!"
 COLOR WHITE
 NULL
 JSR CHARITEMS
 LDA PLRCOND
 ORA #%1000_0000 ;Dead
 STA PLRCOND
 LDA #$FF
 STA PLRCONDX+7
 LDX :REC
 LDA :REC+1
 JSR SAVEPLR
 JSR HOTORNOT ;On hot list?
 BNE :PASS2
 BIT BEATUPLEADER ;Able to beat up leader and get away with it?
 BPL :NOWAY3
 LDX SCENARIO
 LDA PLRPARTY
 CMP LEADPRTY-1,X
 BEQ :PASS
:NOWAY3 JSR INCKILLSMAST ;Does LOADMAST, INCR PLRPKILLS/MAX, SAVEMAST
:PASS BRA :PASS2
:PALIVE LDX :REC
 LDA :REC+1
 JSR SAVEPLR
 BIT BEATUPLEADER ;Able to beat up leader and get away with it?
 BPL :NOWAY4
 LDX SCENARIO
 LDA PLRPARTY
 CMP LEADPRTY-1,X
 BEQ :PASS2
:NOWAY4 JSR INCASSMAST ;Does LOADMAST, INCR PLRPASSAULTS/MAX, SAVEMAST
:PASS2 JMP SPELLEND

:REC DS 2
:DAM DS 1

TYPE3
TYPE4
TYPE5
 JMP UNKNOWN

INCKILLSMAST JSR LOADMAST
 INCR PLRPKILLS
 INCR PLRPKILLSMAX
 JMP SAVEMAST

INCASSMAST JSR LOADMAST
 INCR PLRPASSAULTS
 INCR PLRPASSAULTSMAX
 JMP SAVEMAST

HOTORNOT LDA PLRPASSAULTS ;If victim on hot list, then it's OK
 ORA PLRPASSAULTS+1
 ORA PLRPKILLS
 ORA PLRPKILLS+1
 RTS

 LST ON
MODEND EQU *
 LST OFF

 do M16PLUS
 SAV SPELL2.L
 fin

 END
