*-------------------------------
* GAME.SPELL (part 5)
*-------------------------------
 DAT
 LST OFF

 REL

 USE MACROS
 USE EQUATES
 USE VARS
 USE TABLES
 USE LIB.JMP
 USE PLR.DSECT
 USE MON.DSECT
 USE MON2.DSECT
 USE ITEM.DSECT
 USE ITEM2.DSECT

 do M16PLUS-1
 DSK SPELL5.L
 fin

 EXT NPRTY,PLR,LOGEXCEPTION,SPELLEND,ABORT,FAILED,LEVEL,EXP,TOP
 EXT SCENMON,GOLD,ITEMS,NEWITEM,SCENITEMS,MAXITEMS,IRECS,LOADMAST

ADDPOINTS ENT
 STA :POINTS
 CPX #1
 BEQ :ONE
 JSR PRINT
 GOTOXY 0;21
 ZAPLINE
 DEC8 :POINTS
 ASC " points added to all party members"
 NULL
 LDX NPRTY
]LOOP PHX
 LDA CURPARTY-1,X
 STA PLR
 LDA CURPARTY2-1,X
 STA PLR+1
 LDX PLR
 LDA PLR+1
 JSR LOADPLR
 LDA PLRCURRPNTS
 CLC
 ADC :POINTS
 BPL :POK
 LDA PLRMAXPNTS
:POK STA PLRCURRPNTS
 LDX PLR
 LDA PLR+1
 JSR SAVEPLR
 PLX
 DEX
 BNE ]LOOP
 LDA #$FF
 STA LOGEXCEPTION
 JMP SPELLEND
:ONE JSR PRINT
 GOTOXY 0;21
 ZAPLINE
 ASC "Add "
 DEC8 :POINTS
 ASC " action points to #"
 NULL
]LOOP JSR KEYIN
 CMP #$9B
 BEQL ABORT
 SEC
 SBC #"1"
 CMP NPRTY
 BCS ]LOOP
 TAX
 LDA CURPARTY,X
 STA PLR
 LDA CURPARTY2,X
 STA PLR+1
 LDX PLR
 LDA PLR+1
 JSR LOADPLR
 JSR PRINT
 HTAB 0
 ZAPLINE
 ASC "Add points to "
 PRSTRING PLRNAME
 ASC " (y/N)? : "
 NULL
 JSR KEYIN
 JSR UPPER
 CMP #$9B
 BEQL :ONE
 CMP #"Y"
 BNEL :ONE
 JSR PRINT
 GOTOXY 0;21
 ZAPLINE
 DEC8 :POINTS
 ASC " points added to "
 PRSTRING PLRNAME
 SOUND $15;1;LOUD
 NULL
 LDA PLRCURRPNTS
 CLC
 ADC :POINTS
 BPL :POK2
 LDA PLRMAXPNTS
:POK2 STA PLRCURRPNTS
 LDX PLR
 LDA PLR+1
 JSR SAVEPLR
 LDA #$FF
 STA LOGEXCEPTION
 JMP SPELLEND
:POINTS DS 1

DOITEMS ENT
 LDX #3
]LOOP STZ GOLD,X
 DEX
 BPL ]LOOP

 LDX #15
]LOOP STZ ITEMS,X
 DEX
 BPL ]LOOP

 LDA MTYPE
 CMP SCENMON
 BNEL :NOTC
 JSR GETITEM
 STZ IFREE
 LDX SCENARIO
 LDA SCENITEMS,X
 STA INUM
 LDA MXPOS
 STA IXPOS
 LDA MYPOS
 STA IYPOS
 LDA LEVEL
 STA IZPOS
 STZ IDATA
 STZ IDATA+1
 STZ IDATA+2
 STZ IDATA+3
 JSR SAVEI
 LDX SCENARIO
 LDA #$FF
 STA M2KILLDEAD-1,X
 JSR SAVEVARS
 NOTELOGSTR $D;"Monster to kill is dead - ";MNAME
 NOTELOGSTR $D;"Killed by ";PLRNAME
 JMP :FIXI

:GUARD LDA #1 ;Drop a key (when Guardian dies)
 STA :ITEMS
 STZ :GREC
]LOOP LDA :GREC
 CMP MAXITEMS
 BEQ :NOTC2 ;No key..
 INC :GREC
 LDX :GREC
 LDA :GREC+1
 JSR LOADITEM
 BIT IFREE
 BMI ]LOOP
 LDA ITYPE
 CMP #6 ;Misc?
 BNE ]LOOP
 LDA IDAT1
 CMP #4 ;Key?
 BNE ]LOOP
 LDX :ITEMS
 LDA :GREC
 STA ITEMS-1,X
 LDA MTREASURE
 BRA :NOTC3

:GREC DS 2

:NOTC LDA MLEVEL
 BEQ :GUARD
:NOTC2 LDA MTREASURE
 BEQL :DOEXP
:NOTC3 AND #%0000_1111
 BEQ :DOITEM
 ASL
 ASL
 TAX
 LDY #0
]LOOP LDA TREASURE,X
 STA GOLD,Y
 INX
 INY
 CPY #4
 BNE ]LOOP
 JSR PRINT
 SOUND $0E;1;LOUD
 NULL

:DOITEM LDA MTREASURE
 AND #%1111_0000
 BEQ :GOITEMSZ
 LSR
 LSR
 LSR
 LSR
 STA :ITEMS
 JSR PRINT
 SOUND $0E;1;LOUD
 NULL
 LDA LEVEL
 ASL
 ASL
 ASL
 ASL
 CMP MAXITEMS
 BCC :XITOK
 LDA MAXITEMS
:XITOK STA :RND
]LOOP LDX :RND
 LDA #0
 JSR RANDOM
 TXA
 LDX SCENITEMS
]LOOP2 CMP SCENITEMS,X
 BEQ :NEXTI
 DEX
 BNE ]LOOP2
 LDX :ITEMS
 STA ITEMS-1,X
:NEXTI DEC :ITEMS
 BNE ]LOOP

:GOITEMSZ JSR PRINT
 SOUND $0D;1;LOUD
 NULL
:GOITEMS LDX #3
]LOOP LDA GOLD,X
 BNE :YESG
 DEX
 BPL ]LOOP
 BRA :GOITEMS2
:YESG JSR GETITEM
 STZ IFREE
 LDA #0 ;Gold
 STA INUM
 LDA MXPOS
 STA IXPOS
 LDA MYPOS
 STA IYPOS
 LDA LEVEL
 STA IZPOS
 LDX GOLD
 LDA GOLD+1
 JSR RANDOM
 STX IDATA
 STA IDATA+1
 STZ IDATA+2
 STZ IDATA+3
 JSR SAVEI

:GOITEMS2 LDX #15
 STX :ITEMS
]LOOP LDX :ITEMS
 LDA ITEMS-1,X
 BEQ :NXTI
 JSR GETITEM
 STZ IFREE
 LDX :ITEMS
 LDA ITEMS-1,X
 STA INUM
 LDA MXPOS
 STA IXPOS
 LDA MYPOS
 STA IYPOS
 LDA LEVEL
 STA IZPOS
 LDX #3
]LOOP2 STZ IDATA,X
 DEX
 BPL ]LOOP2
 JSR SAVEI
:NXTI DEC :ITEMS
 BNE ]LOOP

:FIXI LDA IRECS ;Update Maze Items (total)
 STA ITEM2BUFF
 STZ ITEM2BUFF+1
 LDX #0
 LDA #0
 JSR SAVEITEM2
:DOEXP RTS
:ITEMS DS 1
:RND DS 1

GETITEM LDA IRECS
 BEQ :NEXT
 LDA :RECS
 CMP IRECS
 BEQ :NEXT
]LOOP INC :RECS
 LDX :RECS
 LDA #0
 JSR LOADITEM2
 LDA IFREE
 BMI :GOTIT
 LDA :RECS
 CMP IRECS
 BCC ]LOOP
:NEXT INC IRECS
 LDA IRECS
 STA NEWITEM
 STA :RECS
 RTS
:GOTIT LDA :RECS
 STA NEWITEM
 RTS
:RECS DS 1

SAVEI STZ IBURIED
 LDX NEWITEM
 LDA #0
 JMP SAVEITEM2

DOROLL ENT
 STX :DICE
 STA :MOD
 JSR ROLLD6
 LDA VTEMP
 CLC
 ADC :MOD
 BMI :MINUS
 CMP :DICE
 BCS :OK
:MINUS LDA :DICE
:OK RTS
:DICE DS 1
:MOD DS 1

TOOFAR ENT
 JSR PRINT
 GOTOXY 40;21
 CLEOL
 PRSTRING PLRNAME
 ASC " is too far away.."
 SOUND $13;1;LOUD
 NULL
 JMP FAILED

CHECKPOS ENT
 JSR GETMAP
 STA :SHAPE
 LDX #0
]LOOP LDA OKSHAPES,X
 CMP #$FF
 BEQ :BAD
 CMP :SHAPE
 BEQ :SHPOK
 INX
 BRA ]LOOP
:BAD SEC
 RTS
:SHPOK CLC
 RTS
:SHAPE DS 1

OKSHAPES DFB SHPSPACE,SHPSTAIRS,SHPDARK,SHPSIGN,SHPWATER,SHPHILLS
 DFB $FF

CHARITEMS ENT
 STZ :FLAG
 LDA PLRGOLD
 ORA PLRGOLD+1
 ORA PLRGOLD+2
 ORA PLRGOLD+3
 BEQ :NOGOLD
 JSR GETITEM
 STZ INUM ;0 = gold
 LDA PLRXPOS
 STA IXPOS
 LDA PLRYPOS
 STA IYPOS
 LDA PLRZPOS
 STA IZPOS
 LDX #3
]LOOP LDA PLRGOLD,X
 STA IDATA,X
 DEX
 BPL ]LOOP
 STZ IFREE
 JSR SAVEI
 DEC :FLAG
:NOGOLD LDX #0 ;Put all chars items into maze item file
]LOOP LDA PLRITEM ;ie. drop all his items (or hers)
 BEQ :DONE
 JSR GETITEM
 LDA PLRITEM
 STA INUM
 LDA PLRXPOS
 STA IXPOS
 LDA PLRYPOS
 STA IYPOS
 LDA PLRZPOS
 STA IZPOS
 STZ IDATA
 STZ IDATA+1
 STZ IDATA+2
 STZ IDATA+3
 STZ IFREE
 PHX
 JSR SAVEI
 DEC :FLAG
 LDX #0
]LOOP2 LDA PLRITEM+1,X ;Crunch items
 STA PLRITEM,X
 LDA PLRITEMX+1,X
 STA PLRITEMX,X
 INX
 CPX #7
 BNE ]LOOP2
 STZ PLRITEM+7
 STZ PLRITEMX+7
 PLX
 INX
 CPX #8
 BNE ]LOOP
:DONE LDA IRECS ;Update Maze Items (total)
 STA ITEM2BUFF
 STZ ITEM2BUFF+1
 LDX #0
 LDA #0
 JSR SAVEITEM2
 BIT :FLAG ;Got anything?
 BEQ :NONE
 JSR PRINT
 SOUND $0E;1;$80
 NULL
 RTS
:NONE JSR PRINT
 SOUND $0D;1;$80
 NULL
 RTS
:FLAG DS 1

MONKILLED ENT
 PHX
 PHA

 LDX #7
]LOOP STZ MCONDX,X
 DEX
 BPL ]LOOP
 LDA #%1000_0000 ;Dead
 STA MCOND
 LDA #$FF
 STA MCONDX+7

 LDA MARRESTCHAR
 ORA MARRESTCHAR+1
 BEQ :OK
 LDX MARRESTCHAR
 LDA MARRESTCHAR+1
 JSR LOADPLR
 STZ PLRARRESTFLAG
 LDX MARRESTCHAR
 LDA MARRESTCHAR+1
 JSR SAVEPLR
 LDA PARTYNUM
 PHA
 LDA PLRPARTY
 STA PARTYNUM
 PNOTELOGSTR $E;"Guard killed, party member free : ";PLRNAME
 PLX
 STX PARTYNUM
 LDA #0
 JSR LOADPN
 JSR LOADMAST

 STZ MARRESTCHAR
 STZ MARRESTCHAR+1

:OK PLA
 PLX
 JSR SAVEMON2

 CLC
 XCE
 REP #$30
 LDA EXP
 CLC
 ADC MEXPKILL
 STA EXP
 LDA EXP+2
 ADC MEXPKILL+2
 STA EXP+2
 SEC
 XCE

 LDX MXPOS
 LDY MYPOS
 LDA #$FF
 JSR PUTMAP2M
 LDX LEVEL
 LDA #0
 JSR SAVEMAP2
 JMP DOITEMS

UNKNOWN ENT
 JSR PRINT
 GOTOXY 0;21
 ZAPLINE
 ASC "?"
 NULL
 JMP TOP

 LST ON
MODEND EQU *
 LST OFF

 do M16PLUS
 SAV SPELL5.L
 fin

 END
