*-------------------------------
* GAME.SPHELP
*-------------------------------
 DAT
 LST OFF

 ORG $8000 ;Always

 USE MACROS
 USE EQUATES
 USE VARS
 USE LIB.JMP
 USE SPELL.DSECT
 USE SD.DSECT

 TYP $F4
 do M16PLUS-1
 DSK RUN/MODULES/GAME.SPHELP
 fin

 MODID "GAME.SPHELP"

ENTRY MAC
HERE STR ]1
 DS HERE-*+]LEN+1
 <<<

START JSR CLRBOT
 JSR PRINT
 CURSORON
 LINE "1 - General"
 LINE "2 - Specific spell"
 LINE "3 - Index"
 CR
 ASC "Option : "
 NULL
]LOOP JSR KEYIN
 CMP #"1"
 BEQ :GEN
 CMP #"2"
 BEQ :SPEC
 CMP #"3"
 BEQL :INDEX
 CMP #$9B
 BNE ]LOOP
 JMP EXIT
:GEN JSR GETFILE
 DFB 15,22 ;Use lines x to y
 STR "HELP/SPELLS"
 JSR :GETCR
 JMP START

:GETCR JSR PRINT
 COLOR YELLOW
 CURSOROFF
 GOTOXY 0;23
 COLOR PINK
 CENTER " Press [RETURN] "
 COLOR WHITE
 NULL
]LOOP JSR KEYIN
 CMP #$8D
 BEQ :YEP
 CMP #$9B
 BNE ]LOOP
:YEP JSR PRINT
 INVERSE
 COLOR YELLOW
 ZAPLINE
 COLOR WHITE
 NORMAL
 NULL
 RTS

:SPEC JSR CLRBOT
 JSR PRINT
 CURSORON
 ASC "Help on spell : "
 NULL
 GETLINE #15
 CPX #0
 BEQL START
 STX :SPELL
]LOOP LDA $200-1,X
 JSR UPPER
 STA :SPELL,X
 DEX
 BNE ]LOOP
 LDX #0
 LDA #0
 JSR LOADSPELL
 LDA SPELLBUFF
 STA :TOTSP
 STZ :CNTR
]LOOP INC :CNTR
 LDX :CNTR
 LDA #0
 JSR LOADSPELL
 LDA SPNAME+1
 CMP #"?" ;Spell doesn't exist
 BEQ :NEXT
 LDX #0
]LOOP2 LDA :SPELL+1,X
 CMP SPNAME+1,X
 BNE :NEXT
 INX
 CPX :SPELL
 BNE ]LOOP2
 CPX SPNAME
 BEQ :GOTIT
:NEXT LDA :CNTR
 CMP :TOTSP
 BNE ]LOOP
 JSR PRINT
 CR
 COLOR PINK
 ASC "Not found. "
 COLOR WHITE
 NULL
 GETRETURN
 JMP :SPEC
:GOTIT JSR CLRBOT
 JSR PRINT
 ASC "Spell : "
 COLOR PINK
 PRSTRING SPNAME
 COLOR WHITE
 ASC " ("
 NULL
 LDA :CNTR
 LSR
 LSR
 LSR
 LSR
 LSR
 INC
 STA :TYPE
 LDA :CNTR
]LOOP CMP #33
 BCC :LOK
 SEC
 SBC #32
 BRA ]LOOP
:LOK DEC
 LSR
 LSR
 INC
 STA :LVL
 JSR PRINT
 ASC "Lvl "
 COLOR YELLOW
 DEC8 :LVL
 COLOR WHITE
 ASC " / "
 COLOR ORANGE
 PRTABLE :TYPE;:TABLE
 COLOR WHITE
 LINE ")"
 CR
 NULL
 JSR LOADSLICE
 STR "HELP/SPELL.DESCR"
 DA MISCBUFF
:CNTR DA 0
 DA SDRECLEN
 LDX SDLEN ;Length
 LDA SDLEN+1
 JSR SHOWMSG
 DFB 16,22 ;Lines to use (top, bottom)
 DA SDTEXT
 JSR :GETCR
 JMP :SPEC

:INDEX JSR CLRBOT
 JSR PRINT
 CURSORON
 ASC "[W]izard, [C]leric or [S]age : "
 NULL
]LOOP JSR KEYIN
 JSR UPPER
 CMP #"W"
 BEQ :SPW
 CMP #"C"
 BEQ :SPC
 CMP #"S"
 BEQ :SPS
 CMP #$9B
 BNE ]LOOP
 JMP START
:SPW LDX #1
 HEX 2C
:SPC LDX #2
 HEX 2C
:SPS LDX #3
 STX :TYPE
 LDA #0
]LOOP DEX
 CPX #0
 BEQ :SHOWSP
 CLC
 ADC #32 ;32 spells per class
 BRA ]LOOP
:SHOWSP STA :CNTR
 STZ :CNTR2
]LOOP JSR CLRBOT
]LOOP2 INC :CNTR
 LDA :CNTR2
 CMP #32
 BEQL :BOT
 LDX :CNTR
 LDA :CNTR+1
 JSR LOADSPELL
 INC :CNTR2
 LDA SPNAME+1
 CMP #"?"
 BEQ ]LOOP2
 LDA :CNTR
 DEC
 AND #%0000_0011
 BNE :NONUM
 LDA :CNTR2
 DEC
 LSR
 LSR
 INC
 ORA #"0"
 HEX 2C
:NONUM LDA #" "
 JSR COUT
 JSR PRINT
 ASC "  "
 NULL
 JSR PRINT
 PRSTRING SPNAME
 CR
 NULL
 LDA CV
 CMP #22
 BCC ]LOOP2
 JSR PRINT
 COLOR YELLOW
 CURSOROFF
 VTAB 22
 COLOR PINK
 CENTER "[SPACE]-continue, [ESC]-exit"
 COLOR WHITE
 NULL
]LOOP3 JSR KEYIN
 CMP #$9B
 BEQ :BOT2
 CMP #" "
 BNE ]LOOP3
 JMP ]LOOP
:BOT JSR :GETCR
:BOT2 JMP :INDEX
:SPELL DS 1+15
:TYPE DS 1
:LVL DS 1
:CNTR2 DS 1
:TOTSP DS 1

]LEN = 7
:TABLE DFB ]LEN
 ENTRY "<none>"
 ENTRY "Wizard"
 ENTRY "Cleric"
 ENTRY "Sage"

CLRBOT ENT
 JSR PRINT
 GOTOXY 0;22
 LUP 7
 ZAPLINE
 CURSORUP
 --^
 ZAPLINE
 NULL
 RTS

EXIT RETURN

 do M16PLUS
 SAV RUN/MODULES/GAME.SPHELP
 fin

 END
