*-------------------------------
* LIB.FILES (Library)
*-------------------------------
 DAT
 LST OFF

 XC
 XC

 REL

 USE MACROS
 USE EQUATES
 USE VARS

 do M16PLUS-1
 DSK LIB.FILES.L
 fin

 EXT PRINT ;Print
 EXT LIB_DEATH,ERROR,CLOSEALL,MLIERR ;Main
 EXT LOADSLICE,SAVESLICE,LOADFILE,SAVEFILE ;Disk

LOADVARS ENT
 JSR CLOSEALL
 MLI_OPEN VOPARMS
 JSR MLIERR
 LDA VOPARMS+5
 STA VRWPARMS+1
 LDA #<VARS
 STA VRWPARMS+2
 LDA #>VARS
 STA VRWPARMS+3
 MLI_READ VRWPARMS
 JSR MLIERR
 LDA #<VARS2
 STA VRWPARMS+2
 LDA #>VARS2
 STA VRWPARMS+3
 MLI_READ VRWPARMS
 JSR MLIERR
 JMP CLOSEALL

SAVEVARS ENT
 JSR CLOSEALL
 MLI_OPEN VOPARMS
 JSR MLIERR
 LDA VOPARMS+5
 STA VRWPARMS+1
 LDA #<VARS
 STA VRWPARMS+2
 LDA #>VARS
 STA VRWPARMS+3
 MLI_WRITE VRWPARMS
 JSR MLIERR
 LDA #<VARS2
 STA VRWPARMS+2
 LDA #>VARS2
 STA VRWPARMS+3
 MLI_WRITE VRWPARMS
 JSR MLIERR
 JMP CLOSEALL

VOPARMS DFB 3
 DA VPATH
 DA IOBUFFER
 DS 1

VRWPARMS DFB 4
 DS 1
 DS 2
 DA $100
 DS 2

VPATH STR "VARS"

*-------------------------------
* LOAD/SAVE tables:
*  1 - Item
*  2 - Player
*  3 - Monster
*  4 + Maze monster
*  5 + Maze Item
*  6 - Spell
*  7 - Message BitMap
*  8 - Party names
*-------------------------------
MBUFFERS ADRL ITEMBUFF ;1
 ADRL PLRBUFF ;2
 ADRL MONBUFF ;3
 ADRL MON2BUFF ;4
 ADRL ITEM2BUFF ;5
 ADRL SPELLBUFF ;6
 ADRL BITMAPBUFF ;7
 ADRL PNBUFF ;8
 ADRL MODULE ;x

MRECLENS ADRL ITEMRECLEN ;1
 ADRL PLRRECLEN ;2
 ADRL MONRECLEN ;3
 ADRL MON2RECLEN ;4
 ADRL ITEM2RECLEN ;5
 ADRL SPELLRECLEN ;6
 ADRL BITMAPRECLEN ;7
 ADRL PNRECLEN ;8
 ADRL PGSAVE-MODULE+$100+4 ;x

FNAME MAC
HERE STR ]1
 DS HERE-*+16
 <<<

FNAMES FNAME "ITEMS" ;1
 FNAME "PLAYERS" ;2
 FNAME "MONSTERS" ;3
 FNAME "MAZE.MONSTERS.0" ;4
 FNAME "MAZE.ITEMS.0" ;5
 FNAME "SPELLS" ;6
 FNAME "MSG.BITMAP" ;7
 FNAME "PARTY.NAMES" ;8

LOADMON2 ENT
 LDY SCENARIO
 CPY :SCEN
 BEQL :OK
 STY :SCEN
 PHX
 PHA
 LDA SCENARIO
 ORA #"0"
 STA :MMS+15
 STA :MMS2+15
 JSR LOADSLICE
:MMS STR "MAZE.MONSTERS.0"
 DA MON2BUFF
 DA 0
 DA MON2RECLEN
 LDA MON2BUFF
 STA TOTAL
 LDA MON2BUFF+1
 STA TOTAL+1
 LDY #4
 LDX #0
 LDA #0
 JSR METOMEM
 STZ :REC
 STZ :REC+1
]LOOP LDA :REC+1
 CMP TOTAL+1
 BNE :LOAD
 LDA :REC
 CMP TOTAL
 BEQ :DONE
:LOAD INCR :REC
 JSR LOADSLICE
:MMS2 STR "MAZE.MONSTERS.0"
 DA MON2BUFF
:REC DA 0
 DA MON2RECLEN
 LDY #4
 LDX :REC
 LDA :REC+1
 JSR METOMEM
 BRA ]LOOP
:DONE PLA
 PLX
:OK LDY #4
 JMP MEMTOME
:SCEN DS 1

LOADITEM2 ENT
 LDY SCENARIO
 CPY :SCEN
 BEQL :OK
 STY :SCEN
 PHX
 PHA
 LDA SCENARIO
 ORA #"0"
 STA :MIS+12
 STA :MIS2+12
 JSR LOADSLICE
:MIS STR "MAZE.ITEMS.0"
 DA ITEM2BUFF
 DA 0
 DA ITEM2RECLEN
 LDA ITEM2BUFF
 STA TOTAL
 LDA ITEM2BUFF+1
 STA TOTAL+1
 LDY #5
 LDX #0
 LDA #0
 JSR METOMEM
 STZ :REC
 STZ :REC+1
]LOOP LDA :REC+1
 CMP TOTAL+1
 BNE :LOAD
 LDA :REC
 CMP TOTAL
 BEQ :DONE
:LOAD INCR :REC
 JSR LOADSLICE
:MIS2 STR "MAZE.ITEMS.0"
 DA ITEM2BUFF
:REC DA 0
 DA ITEM2RECLEN
 LDY #5
 LDX :REC
 LDA :REC+1
 JSR METOMEM
 BRA ]LOOP
:DONE PLA
 PLX
:OK LDY #5
 JMP MEMTOME
:SCEN DS 1

TOTAL DS 2

LOADITEM ENT
 LDY #1
 HEX 2C
LOADPLR ENT
 LDY #2
 HEX 2C
LOADMON ENT
 LDY #3
 HEX 2C
LOADSPELL ENT
 LDY #6
 HEX 2C
LOADBITMAP ENT
 LDY #7
 HEX 2C
LOADPN ENT
 LDY #8
 JMP MEMTOME

SAVEITEM ENT
 LDY #1
 HEX 2C
SAVEPLR ENT
 LDY #2
 HEX 2C
SAVEMON ENT
 LDY #3
 HEX 2C
SAVEMON2 ENT
 LDY #4
 HEX 2C
SAVEITEM2 ENT
 LDY #5
 HEX 2C
SAVESPELL ENT
 LDY #6
 HEX 2C
SAVEBITMAP ENT
 LDY #7
 HEX 2C
SAVEPN ENT
 LDY #8
 STY NUM
 STX :REC
 STA :REC+1
 LDA NUM
 DEC
 ASL
 ASL
 TAX
 LDA MRECLENS,X
 STA RECLEN
 LDA MRECLENS+1,X
 STA RECLEN+1
 LDY NUM
 LDX :REC
 LDA :REC+1
 JSR METOMEM
 CLC ;Save to disk
 XCE
 REP #$30
 LDA NUM
 DEC
 ASL
 ASL
 ASL
 ASL
 TAX
 LDA FNAMES,X
 AND #$FF
 STA :LEN
 LDY #0
]LOOP LDA FNAMES,X
 STA :TEMPLT,Y
 INX
 INY
 CPY :LEN
 BNE ]LOOP
 SEP #$30
 LDX :TEMPLT
 LDA :TEMPLT,X
 CMP #"0"
 BNE :NOEXT
 LDA :TEMPLT-1,X
 CMP #"."
 BNE :NOEXT
 LDA SCENARIO
 ORA #"0"
 STA :TEMPLT,X
:NOEXT REP #$30
 LDA NUM
 DEC
 ASL
 ASL
 TAX
 LDA MBUFFERS,X
 INY
 STA :TEMPLT,Y
 INY
 INY
 LDA :REC
 STA :TEMPLT,Y
 INY
 INY
 LDA RECLEN
 STA :TEMPLT,Y
 INY
 INY
 SEP #$20
 LDA #$60
 STA :TEMPLT,Y
 SEC
 XCE
 JSR SAVESLICE ;------------- DO NOT MOVE THIS -------------
:TEMPLT DS 1+15 ;Filename
 DS 2 ;Buffer
 DS 2 ;Record
 DS 2 ;Record length
 RTS ;--------------------------------------------
:REC DS 2
:LEN DS 2
RECLEN DS 2
NUM DS 2

METOMEM ENT
 STX MREC
 STA MREC+1
 STY MFILE
 CLC
 XCE
 REP #$30
 LDA MFILE
 DEC
 ASL
 ASL
 TAX
 PEA #0 ;Pointer to start of bytes to be copied
 LDA MBUFFERS,X
 PHA
 LDA HANDLES,X ;Get address of data block
 STA CADD
 LDA HANDLES+2,X
 STA CADD+2
 LDY #0 ;Pointer to destination
 LDA [CADD],Y
 STA DEST
 INY
 INY
 LDA [CADD],Y
 STA DEST+2
 LDY MREC
]LOOP CPY #0
 BEQ :DONE
 LDA MRECLENS,X
 CLC
 ADC DEST
 STA DEST
 LDA DEST+2
 ADC #0
 STA DEST+2
 DEY
 BRA ]LOOP
:DONE LDA DEST+2
 PHA
 LDA DEST
 PHA
 PEA #0 ;Number of bytes to be copied
 LDA MRECLENS,X
 PHA
 Tool $2B02 ;BlockMove
 JSR ERROR
 SEC
 XCE
 RTS

MEMTOME ENT
 STX MREC
 STA MREC+1
 STY MFILE
 CLC
 XCE
 REP #$30
 LDA MFILE
 DEC
 ASL
 ASL
 TAX
 LDA HANDLES,X ;Get address of data block
 STA CADD
 LDA HANDLES+2,X
 STA CADD+2
 LDY #0 ;Pointer to start of bytes to be copied
 LDA [CADD],Y
 STA ORIG
 INY
 INY
 LDA [CADD],Y
 STA ORIG+2
 LDY MREC
]LOOP CPY #0
 BEQ :DONE
 LDA MRECLENS,X
 CLC
 ADC ORIG
 STA ORIG
 LDA ORIG+2
 ADC #0
 STA ORIG+2
 DEY
 BRA ]LOOP
:DONE LDA ORIG+2
 PHA
 LDA ORIG
 PHA
 PEA #0 ;Pointer to destination
 LDA MBUFFERS,X
 PHA
 PEA #0 ;Number of bytes to be copied
 LDA MRECLENS,X
 PHA
 Tool $2B02 ;BlockMove
 JSR ERROR
 SEC
 XCE
 RTS

MREC DS 2
MFILE DS 2
DEST DS 4
ORIG DS 4

*-------------------------------
* Files not loaded into memory
*-------------------------------
FILES FNAME "LOGFILE.0" ;1
 FNAME "MAP.0" ;2
 FNAME "MAP2.0" ;3
 FNAME "STAIRS.TPORT.0" ;4
 FNAME "SCENARIOS" ;5
 FNAME "HALL.OF.FAME" ;6
 FNAME "MESSAGES" ;7
 FNAME "MSG.INDEX" ;8
 FNAME "SIGN.0" ;9
 FNAME "INVENTORY.0" ;10

BUFFERS DA LOGBUFF ;1
 DA MAP ;2
 DA MAP2 ;3
 DA STBUFF ;4
 DA SCENBUFF ;5
 DA MISCBUFF ;6
 DA MSGBUFF ;7
 DA MSGINDXBUFF ;8
 DA MISCBUFF ;9
 DA MISCBUFF ;10

RECLENS DA 80 ;1
 DA MAPRECLEN ;2
 DA MAP2RECLEN ;3
 DA STRECLEN ;4
 DA SCRECLEN ;5
 DA HOFRECLEN ;6
 DA MSGRECLEN ;7
 DA MSGINDXRECLEN ;8
 DA SIGNRECLEN ;9
 DA INVRECLEN ;10

LOADLOGFILE ENT
 LDY #1
 HEX 2C
LOADMAP ENT
 LDY #2
 HEX 2C
LOADMAP2 ENT
 LDY #3
 HEX 2C
LOADST ENT
 LDY #4
 HEX 2C
LOADSCEN ENT
 LDY #5
 HEX 2C
LOADHOF ENT
 LDY #6
 HEX 2C
LOADMSG ENT
 LDY #7
 HEX 2C
LOADMSGINDX ENT
 LDY #8
 HEX 2C
LOADSIGN ENT
 LDY #9
 HEX 2C
LOADINV ENT
 LDY #10
:GO STY FILE
 STX REC
 STA REC+1
 LDX #0 ;0 = load
 JMP LSGO

SAVELOGFILE ENT
 LDY #1
 HEX 2C
SAVEMAP ENT
 LDY #2
 HEX 2C
SAVEMAP2 ENT
 LDY #3
 HEX 2C
SAVEST ENT
 LDY #4
 HEX 2C
SAVESCEN ENT
 LDY #5
 HEX 2C
SAVEHOF ENT
 LDY #6
 HEX 2C
SAVEMSG ENT
 LDY #7
 HEX 2C
SAVEMSGINDX ENT
 LDY #8
 HEX 2C
SAVESIGN ENT
 LDY #9
 HEX 2C
SAVEINV ENT
 LDY #10
:GO STY FILE
 STX REC
 STA REC+1
 LDX #2 ;2 = save
 JMP LSGO

LSGO LDA :LSDA,X
 STA :LSJSR+1
 LDA :LSDA+1,X
 STA :LSJSR+2

 LDA #<FILES
 STA CADD3
 LDA #>FILES
 STA CADD3+1
 LDA FILE
 DEC
 ASL
 ASL
 ASL
 ASL
 TAY
 LDA (CADD3),Y
 STA :PARMS
 LDX #0
]LOOP INY
 LDA (CADD3),Y
 STA :PARMS+1,X
 INX
 CPX :PARMS
 BNE ]LOOP
 INX
 LDA FILE
 DEC
 ASL
 TAY
 LDA BUFFERS,Y
 STA :PARMS,X
 INX
 LDA BUFFERS+1,Y
 STA :PARMS,X
 INX
 LDA REC
 STA :PARMS,X
 INX
 LDA REC+1
 STA :PARMS,X
 INX
 LDA RECLENS,Y
 STA :PARMS,X
 INX
 LDA RECLENS+1,Y
 STA :PARMS,X
 INX
 LDA #$60
 STA :PARMS,X
 LDX :PARMS
 LDA :PARMS,X
 CMP #"0"
 BNE :LSJSR
 LDA :PARMS-1,X
 CMP #"."
 BNE :LSJSR
 LDA SCENARIO
 ORA #"0"
 STA :PARMS,X
:LSJSR JSR SAVESLICE
:PARMS DS 1+16 ;Filename
 DS 2 ;Buffer
 DS 2 ;Record
 DS 2 ;Record length
 RTS

:LSDA DA LOADSLICE
 DA SAVESLICE

REC DS 2
FILE ENT
 DS 1

 LST ON
MODEND EQU *
 LST OFF

 do M16PLUS
 SAV LIB.FILES.L
 fin

 END
