*-------------------------------
* LIB.MAP (Library)
*-------------------------------
 DAT
 LST OFF

 XC
 XC

 REL

 USE MACROS
 USE EQUATES
 USE VARS
 USE PLR.DSECT
 USE MON2.DSECT
 USE ITEM2.DSECT

 do M16PLUS-1
 DSK LIB.MAP.L
 fin

 EXT PRINT,TEXTCOLOR ;Print
 EXT PICKLINE,LIB_DEATH ;Main
 EXT LOADMAP,SAVEMAP2,LOADPLR,LOADMON2,LOADITEM2 ;Files
 EXT ADDR,BUMPCURS,BASCALC,BOTLINE,SCRNTABLE ;Shr
 EXT MSENDBYTE ;Coms

RECLAIM ENT
 LDX #0
 LDA #0
 JSR LOADMAP
 LDA MAP ;Number of levels in dungeon
 STA VTEMP

 LDX #0
 LDA #0
 JSR LOADMON2
 LDA MON2BUFF
 STA :MONS
 LDA MON2BUFF+1
 STA :MONS+1

 LDX #0
 LDA #0
 JSR LOADPLR
 LDA PLRBUFF
 STA :PLRS
 LDA PLRBUFF+1
 STA :PLRS+1

]LOOP LDX VTEMP
 CPX #0
 BEQL :DONE
 JSR PRINT
 CR
 ASC "Checking level "
 DEC8 VTEMP
 ASC ".."
 NULL
 LDX #0 ;Zap it
]LOOP2 STZ MAP2,X
 INX
 BNE ]LOOP2
 STZ :REC
 STZ :REC+1
]LOOP2 LDA :REC+1
 CMP :PLRS+1
 BNE :LOAD
 LDA :REC
 CMP :PLRS
 BEQ :FIN
:LOAD INCR :REC
 LDX :REC
 LDA :REC+1
 JSR LOADPLR
 LDA PLRFREE
 BMI ]LOOP2
 LDA PLRSCENARIO
 CMP SCENARIO
 BNE ]LOOP2
 LDA PLRZPOS ;This player on this level?
 CMP VTEMP
 BNE ]LOOP2
 LDX PLRXPOS
 LDY PLRYPOS
 JSR CALCMAP ;Merge X and Y into X-reg
 LDA MAP2,X
 AND #$0F
 CMP #15
 BCS ]LOOP2
 INC MAP2,X ;Add this player to this square!
 JMP ]LOOP2
:FIN JSR :DOMONS
 LDX VTEMP ;That's it for this level
 LDA #0
 JSR SAVEMAP2
 DEC VTEMP
 JMP ]LOOP
:DONE RTS

:DOMONS STZ :REC
 STZ :REC+1
]LOOP LDA :REC+1
 CMP :MONS+1
 BNE :LOADM
 LDA :REC
 CMP :MONS
 BEQ :DONE
:LOADM INCR :REC
 LDX :REC
 LDA :REC+1
 JSR LOADMON2
 LDA MTYPE
 ORA MTYPE+1
 BEQ ]LOOP
 LDA MCOND
 AND #%1000_0000 ;Dead?
 BNE ]LOOP
 LDA MZPOS
 CMP VTEMP
 BNE ]LOOP ;Monster not on this level
 LDX MXPOS
 LDY MYPOS
 LDA #1 ;Add
 JSR PUTMAP2M
 BRA ]LOOP

:REC DS 2
:MONS DS 2
:PLRS DS 2

PRMAPALL ENT
 STA :LVL
 CLC
 XCE
 REP #$30
 LDX #0
]LOOP2 LDA PLRBUFF,X
 STAL CSAVE,X
 INX
 INX
 CPX #PLRRECLEN
 BNE ]LOOP2
 LDX #0
]LOOP2 LDA MONBUFF,X
 STAL MSAVE,X
 INX
 INX
 CPX #MONRECLEN
 BNE ]LOOP2
 LDX #0
]LOOP2 LDA MON2BUFF,X
 STAL M2SAVE,X
 INX
 INX
 CPX #MONRECLEN
 BNE ]LOOP2
 SEC
 XCE
 LDA :LVL
 JSR PRITEMS
 LDX #0
 LDA #0
 JSR LOADPLR
 LDA PLRBUFF
 STA :PLRS
 LDA PLRBUFF+1
 STA :PLRS+1
 LDX #0
 LDA #0
 JSR LOADMON2
 LDA MON2BUFF
 STA :MONS
 LDY #0
 STZ VTEMP
 STZ VTEMP+1
]LOOP PHY
 LDA GRID,Y
 BMI :NEXT
 LDX VTEMP
 LDY VTEMP+1
 JSR :GET
 STA :SQR
 CMP #0
 BEQ :NEXT
 BIT MAPLOOK
 BMI :SEEALL
 JSR :INVIS ;Anyone invisible around here?
:SEEALL LDA :SQR
 BEQ :NEXT
 AND #%1111_0000
 BEQ :P
 LDA :SQR
 AND #%0000_1111
 BNE :MP
:M LDA #SHPMON ;Monster
 HEX 2C
:P LDA #SHPPLR ;Player
 HEX 2C
:MP LDA #SHPPLRMON ;Player and monster
 LDX VTEMP
 LDY VTEMP+1
 JSR :DRAW
:NEXT PLY
 INY
 INC VTEMP
 LDA VTEMP
 CMP #9
 BNE ]LOOP
 STZ VTEMP
 INC VTEMP+1
 LDA VTEMP+1
 CMP #9
 BNE ]LOOP
 LDA SYSOPFLAG
 BMI :EXIT
 BIT SHOWFLAG
 BPL :PICKY
 LDY #40
 LDA MAPOUT,Y
 CMP #SHPPLR
 BNE :EXIT
 BRA :DOCP
:PICKY LDX #12
 LDY #13
 LDA #6
 JSR PICKLINE
 BIT SHRFLAG
 BPL :TEXT
:SHR LDA $200
 CMP #'g' ;Player
 BEQ :DOCP
 BRA :EXIT
:TEXT LDA $200
 CMP #"p"
 BNE :EXIT
 LDA $201
 CMP #"m"
 BEQ :EXIT
:DOCP BIT SHOWFLAG
 BPL :DOCP2
 LDX #4
 LDY #4
 LDSHP #SHPPLR;#PLRCURRENT
 JSR :DRAW
 BRA :EXIT
:DOCP2 JSR PRINT
 GOTOXY 12;6
 DOSHAPE #SHPPLR;#PLRCURRENT
 NULL
:EXIT CLC
 XCE
 REP #$30
 LDX #0
]LOOP2 LDAL CSAVE,X
 STA PLRBUFF,X
 INX
 INX
 CPX #PLRRECLEN
 BNE ]LOOP2
 LDX #0
]LOOP2 LDAL MSAVE,X
 STA MONBUFF,X
 INX
 INX
 CPX #MONRECLEN
 BNE ]LOOP2
 LDX #0
]LOOP2 LDAL M2SAVE,X
 STA MON2BUFF,X
 INX
 INX
 CPX #MONRECLEN
 BNE ]LOOP2
 SEC
 XCE
 JSR PRINT
 GOTOXY 0;0
 MTOFF
 NORMAL
 NULL
 RTS

:INVIS LDA :SQR
 AND #%0000_1111
 BEQ :INVM
 LDA :PLRS
 STA :CNTRP
 LDA :PLRS+1
 STA :CNTRP+1
 LDA :PLRS
 ORA :PLRS+1
 BEQ :INVM
]LOOP LDX :CNTRP
 LDA :CNTRP+1
 JSR LOADPLR
 BIT PLRFREE
 BMI :NXTP
 LDA PLRSCENARIO
 CMP SCENARIO
 BNE :NXTP
 LDA PLRZPOS
 CMP :LVL
 BNE :NXTP
 LDA PLRXPOS
 CMP :XLOC
 BNE :NXTP
 LDA PLRYPOS
 CMP :YLOC
 BNE :NXTP
 LDX PLRXPOS
 LDY PLRYPOS
 JSR GETMAP
 CMP #SHPWALL
 BEQ :CANTSEE
 LDA PLRCOND
 AND #%0001_0000 ;Invisible?
 BEQ :NXTP
:CANTSEE DEC :SQR
:NXTP DECR :CNTRP
 LDA :CNTRP
 ORA :CNTRP+1
 BNE ]LOOP

:INVM LDA :SQR
 AND #%1111_0000
 BEQ :INVD
 LDA :MONS
 STA :CNTRM
 BEQ :INVD
]LOOP LDX :CNTRM
 LDA #0
 JSR LOADMON2
 LDA MTYPE
 ORA MTYPE+1
 BEQ :NXTM
 LDA MZPOS
 CMP :LVL
 BNE :NXTM
 LDA MXPOS
 CMP :XLOC
 BNE :NXTM
 LDA MYPOS
 CMP :YLOC
 BNE :NXTM
 LDA MCOND
 AND #%0001_0000 ;Invisible?
 BEQ :NXTM
 LDA :SQR
 SEC
 SBC #$10
 STA :SQR
:NXTM DEC :CNTRM
 LDA :CNTRM
 BNE ]LOOP
:INVD RTS

:DRAW BIT SHOWFLAG
 BPL :DRAW2
 STX :TEMP
 PHA
 LDA #0
]LOOP CPY #0
 BEQ :DRAWOK
 CLC
 ADC #9
 DEY
 BRA ]LOOP
:DRAWOK CLC
 ADC :TEMP ;X value
 TAY
 PLA
 STA MAPOUT,Y
 RTS
:TEMP DS 1

:DRAW2 PHA
 TXA
 ASL
 CLC
 ADC #4
 TAX
 TYA
 CLC
 ADC #2
 TAY
 PLA
 JMP DRAWBLOC

:GET TXA
 CLC
 ADC ANKX
 CMP #$10
 BCS :OUT
 STA :XLOC
 TAX
 TYA
 CLC
 ADC ANKY
 CMP #$10
 BCS :OUT
 STA :YLOC
 TAY
 JMP GETMAP2
:OUT LDA #0
 RTS
:SQR DS 1

:PLRS DS 2
:MONS DS 1
:CNTRP DS 1
:CNTRM DS 1
:XLOC DS 1
:YLOC DS 1
:LVL DS 1

PRITEMS STA :LVL
 LDX #0
 LDA #0
 JSR LOADITEM2
 LDA ITEM2BUFF
 BEQ :DONE
 STA VTEMP
]LOOP LDX VTEMP
 LDA #0
 JSR LOADITEM2
 LDA IFREE
 BMI :NEXT
 BIT IBURIED
 BMI :NEXT
 LDA IZPOS
 CMP :LVL
 BNE :NEXT
 LDX IXPOS
 LDY IYPOS
 JSR INVIEW ;In viewing area?
 BCS :NEXT
 LDX IXPOS
 LDY IYPOS
 JSR GETMAP
 CMP #SHPWALL
 BEQ :NEXT
 LDA IXPOS
 SEC
 SBC ANKX
 STA :X
 LDA IYPOS
 SEC
 SBC ANKY
 STA :Y
 TAY
 LDA #0
]LOOP2 CPY #0
 BEQ :DOIT
 CLC
 ADC #9
 DEY
 BRA ]LOOP2
:DOIT CLC
 ADC :X
 TAY
 LDA GRID,Y
 BMI :NEXT
 JSR :DRAW
:NEXT DEC VTEMP
 LDA VTEMP
 BNE ]LOOP
:DONE RTS

:DRAW BIT SHOWFLAG
 BPL :DRAW2
 LDA #SHPITEM
 STA MAPOUT,Y
 RTS

:DRAW2 LDA :X
 ASL
 CLC
 ADC #4
 TAX
 LDA :Y
 CLC
 ADC #2
 TAY
 LDA #SHPITEM
 JMP DRAWBLOC
:LVL DS 1
:X DS 1
:Y DS 1

INVIEW ENT
 LDA ANKX
 CLC
 ADC #9
 STA :XMAX
 LDA ANKY
 CLC
 ADC #9
 STA :YMAX
 LDA ANKX
 BPL :XOK
 LDA #0
:XOK STA :XMIN
 LDA ANKY
 BPL :YOK
 LDA #0
:YOK STA :YMIN
 CPX :XMIN
 BEQ :X2
 BCC :NOGOOD
:X2 CPX :XMAX
 BCS :NOGOOD
 CPY :YMIN
 BEQ :Y2
 BCC :NOGOOD
:Y2 CPY :YMAX
 BCS :NOGOOD
 CLC
 RTS
:NOGOOD SEC
 RTS
:XMAX DS 1
:YMAX DS 1
:XMIN DS 1
:YMIN DS 1

PRPOS JSR PRINT
 GOTOXY 9;12
 NORMAL
 MTOFF
 COLOR YELLOW
 PAD2 PLRXPOS
 ASC ","
 PAD2 PLRYPOS
 HTAB 21
 DEC8 PLRZPOS
 COLOR WHITE
 NULL
 RTS

*
* X,Y = centre of map
*
DRAW9X9 ENT
 TXA
 SEC
 SBC #4
 STA ANKX
 TYA
 SEC
 SBC #4
 STA ANKY

 LDA #<GRID
 STA CADD3
 LDA #>GRID
 STA CADD3+1

 LDY #0 ;Zap grid to "CAN SEE"
]LOOP LDA #0
 STA (CADD3),Y
 INY
 CPY #9*9
 BNE ]LOOP

 LDA #<:TABLE
 STA CADD4
 LDA #>:TABLE
 STA CADD4+1

 BIT MAPLOOK ;Can we see everything (eg; spell)?
 BMIL :DRAWIT ;Yep!

 LDA PARTYNUM
 BEQ :POK
 LDA PLRCOND
 AND #%1000_1010 ;Dead, asleep or blind?
 BEQ :POK
 LDY #0 ;Zap grid to "CAN'T SEE"
]LOOP LDA #$FF
 STA (CADD3),Y
 INY
 CPY #9*9
 BNE ]LOOP
 JMP :DRAWIT

:POK STZ VTEMP ;X
 STZ VTEMP+1 ;Y (for grid)
 STZ :TEMPY
:LOOP LDA ANKX
 CMP #$10
 BCS :VOID
 LDA ANKY
 CMP #$10
 BCS :VOID
 LDX ANKX
 LDY ANKY
 JSR GETMAP
 CMP #SHPWALL
 BEQ :NOSEE
 CMP #SHPDARK
 BEQ :NOSEE
:NEXTBL LDY #0-2
]LOOP INY
 INY
 LDA (CADD4),Y
 BPL ]LOOP
 INY
 INY
 TYA
 CLC
 ADC CADD4
 STA CADD4
 LDA CADD4+1
 ADC #0
 STA CADD4+1
:NEXT INC ANKX
 INC :TEMPY
 INC VTEMP
 LDA VTEMP
 CMP #9
 BNE :LOOP
 STZ VTEMP
 LDA ANKX
 SEC
 SBC #9
 STA ANKX
 INC ANKY
 INC VTEMP+1
 LDA VTEMP+1
 CMP #9
 BNE :LOOP
 LDA ANKY
 SEC
 SBC #9
 STA ANKY
 JMP :DRAWIT
:VOID LDA ANKX
 CMP #$FF
 BEQ :VOID2
 CMP #$10
 BEQ :VOID2
 BCS :VOIDIT
:VOID2 LDA ANKY
 CMP #$FF
 BEQ :VOID3
 CMP #$10
 BEQ :VOID3
 BCC :VOID3
:VOIDIT LDY :TEMPY
 LDA #$FF ;Can't see = $FF
 STA (CADD3),Y
 JMP :NEXTBL
:VOID3
:NOSEE LDX #0
 LDY #0
]LOOP LDA (CADD4),Y
 STA :TEMP
 INY
 LDA (CADD4),Y
 CMP #$FF
 BEQ :NONEXT
 JSR :PUTNO
 INY
 INX
 BRA ]LOOP
:NONEXT INY
 TYA
 CLC
 ADC CADD4
 STA CADD4
 LDA CADD4+1
 ADC #0
 STA CADD4+1
 JMP :NEXT

:PUTNO PHX ;A reg = Y co-ord
 PHY ;:TEMP = X co-ord
 TAX
 LDA #0
]LOOP CPX #0
 BEQ :PUTOK
 CLC
 ADC #9
 DEX
 BRA ]LOOP
:PUTOK CLC
 ADC :TEMP
 TAY
 LDA #$FF
 STA (CADD3),Y ;Now you don't see it
 PLY
 PLX
 RTS

:DRAWIT STZ VTEMP
 STZ VTEMP+1
 STZ :TEMPY
]LOOP LDA ANKX
 CMP #$FF
 BEQ :WALL1
 CMP #$10
 BEQ :WALL1
 BCS :OUTSIDE
 LDA ANKY
 CMP #$FF
 BEQ :WALL2
 CMP #$10
 BEQ :WALL2
 BCS :OUTSIDE
 LDX ANKX
 LDY ANKY
 JSR GETMAP
 XBA
 BRA :DCONT
:WALL2 LDA ANKX
 INC
 CMP #$12
 BCC :WALL
 BCS :OUTSIDE
:WALL1 LDA ANKY
 INC
 CMP #$12
 BCS :OUTSIDE
:WALL LDA #SHPWALL
 HEX 2C
:OUTSIDE LDA #SHPVOID
:DCONT PHA
 LDY :TEMPY
 LDA (CADD3),Y ;Get grid
 BPL :SEEIT
 PLA
 LDA #SHPVOID
 PHA
:SEEIT BIT SHOWFLAG
 BPL :SEEIT2
 PLA
 STA MAPOUT,Y
 BRA :SEE3
:SEEIT2 LDA VTEMP
 ASL
 CLC
 ADC #4
 TAX
 LDA VTEMP+1
 CLC
 ADC #2
 TAY
 PLA
 JSR DRAWBLOC
:SEE3 INC :TEMPY
 INC ANKX
 INC VTEMP
 LDA VTEMP
 CMP #9
 BNE ]LOOP
 STZ VTEMP
 LDA ANKX
 SEC
 SBC #9
 STA ANKX
 INC ANKY
 INC VTEMP+1
 LDA VTEMP+1
 CMP #9
 BNEL ]LOOP
 LDA ANKY
 SEC
 SBC #9
 STA ANKY
 JMP PRPOS

:TEMPY DS 1
:TEMP DS 1

:TABLE MGRID # ;0,0
 MGRID # ;1,0
 MGRID # ;2,0
 MGRID # ;3,0
 MGRID # ;4,0
 MGRID # ;5,0
 MGRID # ;6,0
 MGRID # ;7,0
 MGRID # ;8,0

 MGRID # ;0,1
 MGRID 0,0 ;1,1
 MGRID 1,0,2,0 ;2,1
 MGRID 3,0,2,0 ;3,1
 MGRID 4,0 ;4,1
 MGRID 5,0,6,0 ;5,1
 MGRID 6,0,7,0 ;6,1
 MGRID 8,0 ;7,1
 MGRID # ;8,1

 MGRID # ;0,2
 MGRID 0,1,0,2 ;1,2
 MGRID 1,1,0,0,0,1,1,0 ;2,2
 MGRID 2,1,2,0,1,0,3,1 ;3,2
 MGRID 4,1,4,0,3,0,5,0 ;4,2
 MGRID 6,1,6,0,7,0,5,1 ;5,2
 MGRID 7,1,8,0,7,0,8,1 ;6,2
 MGRID 8,1,8,2 ;7,2
 MGRID # ;8,2

 MGRID # ;0,3
 MGRID 0,3,0,2 ;1,3
 MGRID 1,2,0,2,1,3,0,1 ;2,3
 MGRID 2,2,1,1,0,0,1,0,0,1,2,1,1,2 ;3,3
 MGRID 4,2,3,1,4,1,5,1,2,0,3,0,4,0,5,0,6,0,3,2,5,2 ;4,3
 MGRID 6,2,7,1,8,0,7,0,8,1,6,1,7,2 ;5,3
 MGRID 7,2,8,2,7,3,8,1 ;6,3
 MGRID 8,3,8,2 ;7,3
 MGRID # ;8,3

 MGRID # ;0,4
 MGRID 0,4 ;1,4
 MGRID 1,4,0,4,0,3,0,5 ;2,4
 MGRID 0,2,0,3,0,4,0,5,0,6,1,3,1,4,1,5,2,4,2,3,2,5 ;3,4
 MGRID # ;4,4 (viewpoint)
 MGRID 6,4,7,3,7,4,7,5,8,2,8,3,8,4,8,5,8,6,6,3,6,5 ;5,4
 MGRID 7,4,8,3,8,4,8,5 ;6,4
 MGRID 8,4 ;7,4
 MGRID # ;8,4

 MGRID # ;0,5
 MGRID 0,5,0,6 ;1,5
 MGRID 1,6,0,6,0,7,1,5 ;2,5
 MGRID 2,6,1,7,0,8,1,6,2,7,0,7,1,8 ;3,5
 MGRID 4,6,3,7,4,7,5,7,2,8,3,8,4,8,5,8,6,8,3,6,5,6 ;4,5
 MGRID 6,6,7,7,8,8,7,6,6,7,8,7,7,8 ;5,5
 MGRID 7,6,8,6,8,7,7,5 ;6,5
 MGRID 8,5,8,6 ;7,5
 MGRID # ;8,5

 MGRID # ;0,6
 MGRID 0,7,0,6 ;1,6
 MGRID 1,7,0,8,0,7,1,8 ;2,6
 MGRID 2,7,2,8,1,8,3,7 ;3,6
 MGRID 4,7,3,8,4,8,5,8 ;4,6
 MGRID 6,7,6,8,7,8,5,7 ;5,6
 MGRID 7,7,8,8,8,7,7,8 ;6,6
 MGRID 8,7,8,6 ;7,6
 MGRID # ;8,6

 MGRID # ;0,7
 MGRID 0,8 ;1,7
 MGRID 1,8,2,8 ;2,7
 MGRID 3,8,2,8 ;3,7
 MGRID 4,8 ;4,7
 MGRID 5,8,6,8 ;5,7
 MGRID 7,8,6,8 ;6,7
 MGRID 8,8 ;7,7
 MGRID # ;8,7

 MGRID # ;0,8
 MGRID # ;1,8
 MGRID # ;2,8
 MGRID # ;3,8
 MGRID # ;4,8
 MGRID # ;5,8
 MGRID # ;6,8
 MGRID # ;7,8
 MGRID # ;8,8

ANKX DS 1
ANKY DS 1
GRID DS 9*9

GETGRID ENT
 STX :X
 LDA #0
]LOOP CPY #0
 BEQ :DONE
 CLC
 ADC #9
 DEY
 BRA ]LOOP
:DONE CLC
 ADC :X
 TAX
 LDA GRID,X
 RTS
:X DS 1

DRAWBLOC ENT
 STX :X
 STY :Y
 PHA

 LDX CH
 CPX :X
 BNE :GOTO
 LDY CV
 CPY :Y
 BEQ :SKIP
:GOTO JSR PRINT
 PRCOM 01
:X DS 1
:Y DS 1
 NULL

:SKIP PLA

DRAWBLOCM ENT
 BIT CONNECTED
 BPL :NO
 BIT DUMBTERM
 BMI :NO
 BIT SPECFLAG ;IIgs flag for user
 BPL :TEXT
 PHA
 LDA #SHAPEBYTE
 JSR MSENDBYTE
 LDA $1,S
 JSR MSENDBYTE
 PLA
:NO BIT SHRFLAG
 BMIL DRAWBLOK
 DEC :HOSTEXT
 JSR :DOTEXT
 STZ :HOSTEXT
 RTS

:TEXT JSR :DOTEXT
 BRA :NO

:DOTEXT PHA
 CLC
 XCE
 REP #$30
 LDA $1,S
 AND #%000_11111
 ASL
 ASL
 ASL
 ASL
 ASL
 STA :TXTSHP
 LDA $1,S
 AND #%111_00000
 LSR
 LSR
 LSR
 CLC
 ADC :TXTSHP
 TAX
 LDAL TEXTSHAPES,X
 STA :TXTSHP
 LDAL TEXTSHAPES+2,X
 STA :TXTSHP+2
 SEC
 XCE
 LDA :TXTSHP
 JSR :DOMODE
 LDA :TXTSHP+2
 JSR :SENDIT
 LDA :TXTSHP+1
 JSR :DOMODE
 LDA :TXTSHP+3
 JSR :SENDIT
 PLA
 RTS

:TXTSHP DS 4
:HOSTEXT DFB 0

*
* VMODE bits:
* 4 - cursor     0=on   1=off
* 2 - inverse    0=off  1=on
* 0 - mousetext  0=on   1=off
*
:DOMODE STA :TYPE
 CMP #0
 BEQ :NORMAL
 AND #%1111_0000
 BEQ :TRYINV
 LDA VMODE
 AND #%0000_0001
 BEQ :TRYINV
 TRB VMODE
 LDA #$1B
 JSR :SENDIT
:TRYINV LDA :TYPE
 AND #%0000_1111
 BEQ :NORMAL
 LDA VMODE
 AND #%0000_0100
 BNE :DONE
 LDA #%0000_0100
 TSB VMODE
 LDA #$0F
 JMP :SENDIT
:NORMAL LDA VMODE
 AND #%0000_0100
 BEQ :DONE
 TRB VMODE
 LDA #$0E
 JMP :SENDIT
:DONE RTS
:TYPE DS 1

:SENDIT BIT :HOSTEXT
 BMI :GOHOST
 JMP MSENDBYTE
:GOHOST PHA
 LDX DUMBTERM
 PHX
 LDX #$FF
 STX DUMBTERM
 JSR COUT
 PLX
 STX DUMBTERM
 PLA
 RTS

PUTBLOK ENT
 JSR GETSHPMAP
 STA SHAPE
 LDA CH
 PHA
 LDA CV
 PHA
 STZ PLUS+1
 JSR BLOKOUT
 JSR BUMPCURS
 LDA #$10
 STA PLUS+1
 JSR BLOKOUT
 PLA
 STA CV
 PLA
 STA CH
 RTS

DRAWBLOK ENT
 STA SHAPE

 STZ PLUS+1
 JSR :DOIT
 LDA #$10
 STA PLUS+1

:DOIT JSR BLOKOUT
 JSR PUTSHPMAP

 LDA #$FF
 PHA
 LDA CV
 JSR BASCALC
 LDA CV
 CMP #24 ;Bottom line?
 BEQ :BOT
 LDA CH
 LSR
 TAY
 BCS :SKIP
 STA $C055
:SKIP PLA
 STA (BAS),Y
 STA $C054
 BRA :EXIT
:BOT LDX CH
 PLA
 STA BOTLINE,X
:EXIT JMP BUMPCURS

BLOKOUT CLC
 XCE
 REP #$30
 LDA CV ;Get base address for this line
 AND #$FF
 ASL
 ASL
 ASL
 ASL
 TAY
 LDA [SCRNPNTR],Y
 STA ADDR
 LDA CH
 AND #$FF
 ASL
 CLC
 ADC ADDR
 STA ADDR

 LDA SHAPE ;Select which one we need
 ASL
 ASL
 ASL
 ASL
 ASL
 CLC
PLUS ENT
 ADC #0
 TAX
 LDY #0
]LOOP PHY
 LDAL SHAPES,X
 PHX
 LDX ADDR ;SHR location
 STAL SHRLOC,X ;Put onto screen
 PLX
 LDA ADDR
 CLC
 ADC #$A0 ;Inc SHR line
 STA ADDR
 INX
 INX
 PLY
 INY
 CPY #8
 BNE ]LOOP
 SEC
 XCE
 RTS

GETSHPMAP ENT
 CLC
 XCE
 SEP #$30
 LDA CV
 JSR BASCALC
 REP #$30
 LDA CH
 AND #$FF
 CLC
 ADC BAS
 SEC
 SBC #$400
 TAX
 SEP #$20
 LDAL SHAPEMAP,X
 SEC
 XCE
 RTS

PUTSHPMAP CLC
 XCE
 SEP #$30
 LDA CV
 JSR BASCALC
 REP #$30
 LDA CH
 AND #$FF
 CLC
 ADC BAS
 SEC
 SBC #$400
 TAX
 SEP #$20
 LDA SHAPE
 STAL SHAPEMAP,X
 SEC
 XCE
 RTS

SHAPE ENT
 DS 2

GETMAP ENT ;Out : A=shape (0-31), X=type (0-7)
 JSR CALCMAP
 LDA MAP,X
 XBA
 LDA MAP,X
 PHA
 AND #%111_00000
 LSR
 LSR
 LSR
 LSR
 LSR
 TAX
 PLA
 AND #%000_11111
 RTS

GETMAP2 ENT
 JSR CALCMAP
 LDA MAP2,X
 RTS

CALCMAP TXA
 AND #$F
 STA :VAL
 TYA
 AND #$F
 ASL
 ASL
 ASL
 ASL
 ORA :VAL
 TAX
 RTS
:VAL DS 1

PUTMAP ENT ;X,Y=map location, A=shape, B=type of shape
 PHA
 JSR CALCMAP
 XBA
 ASL
 ASL
 ASL
 ASL
 ASL
 STA :TYPE
 PLA
 ORA :TYPE
 STA MAP,X
 RTS
:TYPE DS 1

PUTMAP2 ENT
 STA :BYTE ;01=add, FF=subtract player
 JSR CALCMAP
 LDA MAP2,X
 AND #$0F
 CMP #15
 BCS :NO
 LDA MAP2,X
 CLC
 ADC :BYTE
 STA MAP2,X
:NO RTS
:BYTE DS 1

PUTMAP2M ENT
 STA :BYTE ;01=add, FF=subtract monster
 JSR CALCMAP
 LDA :BYTE
 BPL :ADD
 LDA MAP2,X
 SEC
 SBC #$10
 STA MAP2,X
 RTS
:ADD LDA MAP2,X
 AND #$F0
 CMP #$F0
 BEQ :NO
 LDA MAP2,X
 CLC
 ADC #$10
 STA MAP2,X
:NO RTS
:BYTE DS 1

DOSPC ENT
 STX XLOC
 STY YLOC
* AND #%0001_1111
* TAX
* LDA COLORS,X
* STA :CL+2
 LDA XLOC
 ASL
 CLC
 ADC #4
 STA :CH+2
 LDA YLOC
 CLC
 ADC #2
 STA :CH+3
 BIT MAPLOOK
 BMI :SEEIT
 LDX XLOC
 LDY YLOC
 JSR GETGRID
 CMP #$FF
 BNE :SEEIT
 LDA #$C
 HEX 2C
:SEEIT LDA #$F
 STA :CL+2
 CLC
 XCE
 SEP #$30
 LDA :CH+3
 JSR BASCALC
 REP #$30
 LDA :CH+2
 AND #$FF
 CLC
 ADC BAS
 SEC
 SBC #$400
 TAX
 SEP #$20
 LDAL SHAPEMAP,X
 SEC
 XCE
 STA SHP
 JSR PRINT
:CH GOTOXY 4;2
 INVERSE
:CL COLOR WHITE
 ASC "  "
 NORMAL
 NULL
 RTS

DOSHP ENT
 STX XLOC
 STY YLOC
 LDA XLOC
 ASL
 CLC
 ADC #4
 STA :CH+2
 LDA YLOC
 CLC
 ADC #2
 STA :CH+3
 LDA SHP
 STA :SHP+2
 JSR PRINT
:CH GOTOXY 4;2
:SHP DOSHAPE 0
 NULL
 RTS

SHP DS 1
XLOC DS 1
YLOC DS 1

SHOWMAP ENT ;Print map and everything on it (plrs, items, etc)
 PHA
 TXA
 SEC
 SBC #4
 STA ANKX
 TYA
 SEC
 SBC #4
 STA ANKY
 LDA #$FF ;Put stuff into a table
 STA SHOWFLAG
 JSR DRAW9X9
 PLA
 JSR PRMAPALL
 LDA PLRZPOS
 STA :LVL
 STZ VTEMP
 STZ VTEMP+1
 LDY #0
]LOOP PHY
 LDA MAPOUT,Y
 JSR :CHECKP ;Check for own party?
 LDX VTEMP
 LDY VTEMP+1
 JSR :DRAW
 PLY
 INY
 INC VTEMP
 LDA VTEMP
 CMP #9
 BNE ]LOOP
 STZ VTEMP
 INC VTEMP+1
 LDA VTEMP+1
 CMP #9
 BNE ]LOOP
 LDX MPLR
 LDA MPLR+1
 JSR LOADPLR
 JSR PRINT
 NORMAL
 MTOFF
 NULL
 STZ SHOWFLAG
 RTS
:XPOS DS 1
:YPOS DS 1

:DRAW PHA
 TXA
 ASL
 CLC
 ADC #4
 TAX
 TYA
 CLC
 ADC #2
 TAY
 PLA
 CMP #WALLSECRET*$20.SHPWALL
 BNE :DRAW2
 LDA #SHPWALL
:DRAW2 JMP DRAWBLOC

:CHECKP PHA
 CMP #PLRCURRENT*$20+SHPPLR
 BEQ :CPFIN
 AND #$1F
 CMP #SHPPLR
 BNE :CPFIN
 LDA PARTYNUM
 BEQ :CPFIN
 LDX #0
]LOOP LDA CURPARTY,X
 STA :REC
 LDA CURPARTY2,X
 STA :REC+1
 ORA :REC
 BEQ :CNEXT
 PHX
 LDX :REC
 LDA :REC+1
 JSR LOADPLR
 PLX
 LDA PLRZPOS
 CMP :LVL
 BNE :CNEXT
 LDA VTEMP
 CLC
 ADC ANKX
 CMP PLRXPOS
 BNE :CNEXT
 LDA VTEMP+1
 CLC
 ADC ANKY
 CMP PLRYPOS
 BEQ :CDOIT
:CNEXT INX
 CPX NUMPARTY
 BNE ]LOOP
:CPFIN PLA
 RTS
:CDOIT PLA
 LDSHP #SHPPLR;#PLRMINE
 RTS
:LVL DS 1
:REC DS 2

* DFB $F ;00 Wall
* DFB $F ;01 Space
* DFB $F ;02 Stairs
* DFB $F ;03 Force field
* DFB $F ;04 Dark area
* DFB $F ;05 Sign post
* DFB $F ;06 Swamp
* DFB $F ;07 Player
* DFB $F ;08 Void
* DFB $F ;09 Water
* DFB $F ;0A Teleport
* DFB $F ;0B Hills
* DFB $F ;0C Monster
* DFB $F ;0D Player & monster
* DFB $F ;0E Item
* DFB $F ;0F Gate
* DFB $F ;10 Monster generator
* DFB $F ;11 Holy ground (safety zone)
* DFB $F ;12 Altar
* DFB $F ;13 Water fountain

MAPOUT DS 9*9

SHOWFLAG DFB 0

 LST ON
MODEND EQU *
 LST OFF

 do M16PLUS
 SAV LIB.MAP.L
 fin

 END
