*-------------------------------
* LIB.MOD (Library)
*-------------------------------
 DAT
 LST OFF

 XC
 XC

 REL

 USE MACROS
 USE EQUATES

 do M16PLUS-1
 DSK LIB.MOD.L
 fin

 EXT PRINT,GETCADD ;Print
 EXT CLOSEALL,MLIERR,LIB_DEATH ;Main
 EXT METOMEM,MEMTOME ;Files

POPMOD ENT
 STZ MODLEVEL
 RTS

MODLEVEL DFB 0

EXECUTE ENT
 PLA
 STA CADD
 PLA
 STA CADD+1
 JSR GETCADD
 STA :LEN
 CLC
 ADC #:FILENAME-:PATH-1 ;Length of subdir name
 STA :PATH
 LDX #0
]LOOP INX
 JSR GETCADD
 STA :FILENAME-1,X
 CPX :LEN
 BNE ]LOOP

 JSR CLOSEALL
 MLI_OPEN :OPARMS
 CMP #$46
 BEQ :ERR
 JSR MLIERR
 LDA :OPARMS+5
 STA :GPARMS+1
 STA :RWPARMS+1
 STA :CPARMS+1
 MLI_GET_EOF :GPARMS
 JSR MLIERR
 LDA :GPARMS+2
 STA :RWPARMS+4
 LDA :GPARMS+3
 STA :RWPARMS+5
 MLI_READ :RWPARMS
 JSR MLIERR
 MLI_CLOSE :CPARMS
 JSR MLIERR
 LDX #$FF
 TXS
 JMP MODULE

:ERR JSR PRINT
 CR
 LINE "EXECUTE failed."
 ASC "File '"
 PRSTRING :PATH
 LINE "' not found."
 NULL
 LDA #$46
 SEC
 JMP MLIERR

:LEN DS 1

:OPARMS DFB 3
:PATHPTR DA :PATH
 DA IOBUFFER
 DS 1

:GPARMS DFB 2
 DS 1
 DS 3

:RWPARMS DFB 4
 DS 1
 DA MODULE
 DS 2
 DS 2

:CPARMS DFB 1
 DS 1

:PATH STR "MODULES/"
:FILENAME DS 15

CALLMOD ENT
 PULL CADD
 TSX
 STX PGSAVE+$102 ;STACKPTR
 LDY #1
 LDA (CADD),Y
 SEC
 ADC CADD
 STA PGSAVE+$100 ;ADDR
 LDA CADD+1
 ADC #0
 STA PGSAVE+$101 ;ADDR+1
 LDX #0
]LOOP LDA $100,X
 STA PGSAVE,X ;STACK
 INX
 BNE ]LOOP
 PUSH CADD

 LDA MODLEVEL
 CMP #7
 BNE :OK
 JSR PRINT
 CR
 LINE "Module call level exhausted."
 NULL
 DEATH
:OK LDY #FILEMOD
 LDX MODLEVEL
 LDA #0 ;always
 JSR METOMEM

 INC MODLEVEL
 JMP EXECUTE

EXITMOD ENT
 LDA MODLEVEL
 BNE :OK
 JSR PRINT
 CR
 LINE "No module to return to."
 NULL
 DEATH

:OK DEC MODLEVEL
 LDY #FILEMOD
 LDX MODLEVEL
 LDA #0 ;always
 JSR MEMTOME

 LDX #0
]LOOP LDA PGSAVE,X
 STA $100,X
 INX
 BNE ]LOOP

 LDX PGSAVE+$102
 TXS

 INCR PGSAVE+$100
 JMP (PGSAVE+$100)

 LST ON
MODEND EQU *
 LST OFF

 do M16PLUS
 SAV LIB.MOD.L
 fin

 END
