*-------------------------------
* LIB.PRINT (Library)
*-------------------------------
 DAT
 LST OFF

 XC
 XC

 REL

 USE MACROS
 USE EQUATES
 USE VARS
 USE PLR.DSECT
 USE TABLES
 USE ITEM.DSECT
 USE PN.DSECT

 do M16PLUS-1
 DSK LIB.PRINT.L
 fin

 EXT DRAWBLOCM ;Map
 EXT LOADITEM ;Files
 EXT DELAY3,LIB_DEATH,PICKLINE,CHATFLAG ;Main
 EXT MSENDBYTE,CHECKIN2 ;Coms
 EXT TEXTCOLOR ;SHR

*-------------------------------
* 00 - End of statement         [NULL]
* 01 - Goto x,y                 [GOTOXY x;y]
* 02 - HTAB                     [HTAB x]
* 03 - VTAB                     [VTAB y]
* 04 - FlagStatus               [PRFLAG addr]
* 05 - Hex8                     [HEX8 addr]
* 06 - Hex16                    [HEX16 addr]
* 07 - Hex32                    [HEX32 addr]
* 08 - Dec8                     [DEC8 addr]
* 09 - Dec16                    [DEC16 addr]
* 0A - Dec32                    [DEC32 addr]
* 0B - Center text (string)     [CENTER str]
* 0C - String                   [PRSTRING addr]
* 0D - SystemDate               [CURRDATE]
* 0E - MyDate                   [DATE addr]
* 0F - SystemTime               [CURRTIME]
* 10 - MyTime                   [TIME addr]
* 11 - Pad2                     [PAD2 addr]
* 12 - Box                      [BOX str]
* 13 - Shape                    [DOSHAPE x]
* 14 - Table                    [PRTABLE addr]
* 15 - Item                     [PRITEM addr]
* 16 - Dec8Neg                  [DEC8NEG addr]
* 17 - Pause                    [PRPAUSE x]
* 18 - Pad3                     [PAD3 addr]
* 19 - Condition                [PRCOND addr]
* 1A - Nibble                   [PRNIBBLE addr]
* 1B - Dec8PosNeg               [DEC8PNEG addr]
* 1C - SHRColor                 [COLOR x]
* 1D - Sound                    [SOUND x;x]
*
LASTCMD = $1D+1
*-------------------------------

PRINT ENT
 STA :AREG+1
 STX :XREG+1
 STY :YREG+1
 PLA
 STA CADD
 PLA
 STA CADD+1
 STZ :LINE
]TOPLOOP JSR GETCADD
 BEQ :DOWORD2
 CMP #$80 ;Command char
 BEQL :COMMAND
 BIT WORDWRAP
 BMI :OKWRAP
 JSR COUT
 BRA ]TOPLOOP
:OKWRAP CMP #$0D
 BEQ :DOWORD
 CMP #" "+1
 BCC :DOWORD
 INC :LINE
 LDX :LINE
 STA :LINE,X
 BRA ]TOPLOOP
:DOWORD JSR :WORD
 JSR COUT
 BRA ]TOPLOOP
:DOWORD2 JSR :WORD
 BRA :DONE
:WORD PHA
 LDA :LINE
 BEQ :WRTS
 LDA CH
 CLC
 ADC :LINE
 CMP #80
 BCC :NORAP
 LDA :LINE
 CMP #80
 BCS :NORAP
 LDA #$0D
 JSR COUT
:NORAP LDX #0
]LOOP LDA :LINE+1,X
 JSR COUT
 INX
 CPX :LINE
 BNE ]LOOP
 STZ :LINE
:WRTS PLA
 RTS
:DONE LDA CADD+1
 PHA
 LDA CADD
 PHA
:BACKTR
:AREG LDA #0
:XREG LDX #0
:YREG LDY #0
 RTS

:LINE DS 1+80

:COMMAND JSR :WORD
 JSR GETCADD
 CMP #LASTCMD
 BCS :CMDERR
 DEC
 ASL
 TAX
 JMP (:TABLE,X)

:CMDERR PHA
 LDX #0
]LOOP LDA :CMDTXT,X
 BEQ :CDONE
 JSR COUT
 INX
 BRA ]LOOP
:CDONE PLA
 JSR PRBYTE
 DEATH
:CMDTXT ASC "Undef PRINT cmd $"
 NULL

:TABLE DA :GOTOXY
 DA :HTAB
 DA :VTAB
 DA :PRFLAG
 DA :PRHEX8
 DA :PRHEX16
 DA :PRHEX32
 DA :PRDEC8
 DA :PRDEC16
 DA :PRDEC32
 DA :CENTER
 DA :PRSTRING
 DA :PRSYSDATE
 DA :PRMYDATE
 DA :PRSYSTIME
 DA :PRMYTIME
 DA :PRPAD2
 DA :PRBOX
 DA :PRSHAPE
 DA :PRTABLE
 DA :PRITEM
 DA :PRDEC8NEG
 DA :PRPAUSE
 DA :PRPAD3
 DA :PRCOND
 DA :PRNIBBLE
 DA :PRDEC8PNEG
 DA :PRCOLOR
 DA :PRSOUND

:GOTOXY LDA #$1E
 JSR COUT
 JSR GETCADD
 CLC
 ADC #32
 JSR COUT
 JSR GETCADD
 CLC
 ADC #32
 JSR COUT
 LDA #1
 JSR USERWAIT ;In case other end is a bit slow..
 JMP ]TOPLOOP

:HTAB LDA #$1E
 JSR COUT
 JSR GETCADD
 CLC
 ADC #32
 JSR COUT
 LDA CV
 CLC
 ADC #32
 JSR COUT
 LDA #1
 JSR USERWAIT ;In case other end is a bit slow..
 JMP ]TOPLOOP

:VTAB LDA #$1E
 JSR COUT
 JSR GETCADD
 CLC
 ADC #32
 PHA
 LDA CH
 CLC
 ADC #32
 JSR COUT
 PLA
 JSR COUT
 LDA #1
 JSR USERWAIT ;In case other end is a bit slow..
 JMP ]TOPLOOP

:PRFLAG JSR GETADDR
 LDY #0
 LDA (CADD2),Y
 BMI :FTICK
 LDA #"x"
 JSR COUT
 JMP ]TOPLOOP
:FTICK LDX #0
]LOOP LDA :TICK,X
 JSR COUT
 INX
 CPX #5
 BNE ]LOOP
 JMP ]TOPLOOP
:TICK MTON
 INVERSE
 ASC "D"
 NORMAL
 MTOFF

:PRHEX8 JSR GETADDR
 LDY #0
 LDA (CADD2),Y
 JSR PRBYTE
 JMP ]TOPLOOP

:PRHEX16 JSR GETADDR
 LDY #1
]LOOP LDA (CADD2),Y
 JSR PRBYTE
 DEY
 BPL ]LOOP
 JMP ]TOPLOOP

:PRHEX32 JSR GETADDR
 LDY #3
]LOOP LDA (CADD2),Y
 JSR PRBYTE
 DEY
 BPL ]LOOP
 JMP ]TOPLOOP

:ZAPNUM LDX #14
]LOOP STZ :NUMBER,X
 DEX
 BPL ]LOOP
 RTS

:DODEC STX :NLEN
 LDY #0
]LOOP JSR :SUB1
 LDA :CHAR
 ORA #"0"
 STA :NUMOUT,Y
 INY
 LDA :NUMBER
 ORA :NUMBER+1
 ORA :NUMBER+2
 ORA :NUMBER+3
 ORA :NUMBER+4
 BNE ]LOOP
 BIT PADFLAG
 BPL :NOPAD
 LDY :NLEN
:NOPAD
]LOOP LDA :NUMOUT-1,Y
 ORA PADCHAR
 JSR COUT
 DEY
 BNE ]LOOP
 RTS
:SUB1 LDX #5*8
 LDA #0
 STA :CHAR
]LOOP ASL :NUMBER
 ROL :NUMBER+1
 ROL :NUMBER+2
 ROL :NUMBER+3
 ROL :NUMBER+4
 ROL :CHAR
 LDA :CHAR
 SEC
 SBC #10
 BCC :OVER
 STA :CHAR
 INC :NUMBER
:OVER DEX
 BNE ]LOOP
 RTS
:NUMBER DS 5 ;Leave these two together
:NUMOUT DS 10 ; (see :ZAPNUM)
:CHAR DS 1
:NLEN DS 1

:PRDEC8 JSR GETADDR
:DEC8 JSR :DEC82
 JMP ]TOPLOOP

:DEC82 JSR :ZAPNUM
 LDY #0
 LDA (CADD2),Y
 STA :NUMBER,Y
 LDX #3
 JMP :DODEC

:PRDEC16 JSR GETADDR
:DEC16 JSR :DEC162
 JMP ]TOPLOOP

:DEC162 JSR :ZAPNUM
 LDY #1
]LOOP LDA (CADD2),Y
 STA :NUMBER,Y
 DEY
 BPL ]LOOP
 LDX #5
 JMP :DODEC

:PRDEC32 JSR GETADDR
 JSR :DEC32
 JMP ]TOPLOOP

:DEC32 JSR :ZAPNUM
 LDY #3
]LOOP LDA (CADD2),Y
 STA :NUMBER,Y
 DEY
 BPL ]LOOP
 LDX #10
 JMP :DODEC

:CENTER JSR GETCADD
 STA :LEN
 LDA #$1E
 JSR COUT
 LDA #80
 SEC
 SBC :LEN
 LSR
 CLC
 ADC #32
 JSR COUT
 LDA CV
 CLC
 ADC #32
 JSR COUT
 LDA #1
 JSR USERWAIT ;In case other end is a bit slow..
 LDX :LEN
]LOOP JSR GETCADD
 JSR COUT
 DEX
 BNE ]LOOP
 JMP ]TOPLOOP
:LEN DS 1

:PRSTRING PUSH CADD2
 JSR GETADDR
 LDY #0
 LDA (CADD2),Y
 BNE :LENOK
 TAX
]LOOP LDA :NOTXT,X
 BEQ :STRDONE
 JSR COUT
 INX
 BRA ]LOOP
:LENOK TAX
]LOOP INY
 LDA (CADD2),Y
 JSR COUT
 DEX
 BNE ]LOOP
:STRDONE PULL CADD2
 JMP ]TOPLOOP
:NOTXT ASC "<nothing>"
 NULL

:PRSYSDATE MLI_GET_TIME
:DODATE LDA $BF91
 LSR
 STA :YEAR
 LDA $BF90
 PHA
 AND #%0001_1111
 STA :DAY
 PLA
 LUP 4
 ROL
 --^
 AND #%0000_1111
 STA :MONTH
:DATEALT LDX #2
]LOOP LDA :YEAR,X
 BNE :DISPLAY
 DEX
 BPL ]LOOP
]LOOP INX
 LDA :NO,X
 BEQL ]TOPLOOP
 JSR COUT
 BRA ]LOOP
:NO ASC "<NO DATE>",00
:DISPLAY LDA :DAY
 JSR PR0DEC
 LDA #"-"
 JSR COUT
 LDX :MONTH
 LDA :M1-1,X
 JSR COUT
 LDA :M2-1,X
 JSR COUT
 LDA :M3-1,X
 JSR COUT
 LDA #"-"
 JSR COUT
 LDA :YEAR
 JSR PR0DEC
 JMP ]TOPLOOP
:M1 ASC "JFMAMJJASOND"
:M2 ASC "aeapauuuecoe"
:M3 ASC "nbrrynlgptvc"
:YEAR DS 1
:MONTH DS 1
:DAY DS 1

:PRSYSTIME MLI_GET_TIME
:DOTIME LDA $BF93
 JSR PR0DEC
 LDA #":"
 JSR COUT
 LDA $BF92
 JSR PR0DEC
 JMP ]TOPLOOP

:PRMYDATE JSR GETCADD
 STA CADD2
 JSR GETCADD
 STA CADD2+1
 LDY #0
 LDA (CADD2),Y
 STA $BF90
 INY
 LDA (CADD2),Y
 STA $BF91
 JMP :DODATE

:PRMYTIME JSR GETCADD
 STA CADD2
 JSR GETCADD
 STA CADD2+1
 LDY #0
 LDA (CADD2),Y
 STA $BF92
 INY
 LDA (CADD2),Y
 STA $BF93
 JMP :DOTIME

:PRPAD2 JSR GETADDR
 LDY #0
 LDA (CADD2),Y
 JSR PR0DEC
 JMP ]TOPLOOP

:PRBOX JSR GETCADD
 STA :LEN
 JSR :GOXY
 LDA #$1B
 JSR COUT
 LDA #$F
 JSR COUT
 LDA #"Z"
 JSR COUT
 LDX :LEN
 INX
 INX
]LOOP LDA #"L"
 JSR COUT
 DEX
 BNE ]LOOP
 LDA #"_"
 JSR COUT
 LDA #$0D
 JSR COUT
 JSR :GOXY
 LDA #"Z"
 JSR COUT
 LDA #$E
 JSR COUT
 LDA #" "
 JSR COUT
 LDX :LEN
]LOOP JSR GETCADD
 JSR COUT
 DEX
 BNE ]LOOP
 LDA #" "
 JSR COUT
 LDA #$F
 JSR COUT
 LDA #"_"
 JSR COUT
 LDA #$0D
 JSR COUT
 JSR :GOXY
 LDA #"Z"
 JSR COUT
 LDA #$E
 JSR COUT
 LDX :LEN
 INX
 INX
]LOOP LDA #"_"
 JSR COUT
 DEX
 BNE ]LOOP
 LDA #$F
 JSR COUT
 LDA #"_"
 JSR COUT
 LDA #$18
 JSR COUT
 LDA #$E
 JSR COUT
 LDA #$0D
 JSR COUT
 JMP ]TOPLOOP
:GOXY LDA #$1E
 JSR COUT
 LDA #80
 SEC
 SBC :LEN
 LSR
 CLC
 ADC #30
 JSR COUT
 LDA CV
 CLC
 ADC #32
 JSR COUT
 LDA #1
 JMP USERWAIT ;In case other end is a bit slow..

:PRSHAPE JSR GETCADD
 JSR DRAWBLOCM
 JMP ]TOPLOOP

:PRTABLE JSR GETADDR
 LDY #0
 LDA (CADD2),Y ;This is the index value
 TAX
 JSR GETADDR ;This is where the table is
 LDY #0
 LDA (CADD2),Y ;Length of each entry in the table
 STA :TLEN
]LOOP CPX #0
 BEQ :TDONE
 LDA CADD2
 SEC
 ADC :TLEN
 STA CADD2
 LDA CADD2+1
 ADC #0
 STA CADD2+1
 DEX
 BRA ]LOOP
:TDONE INCR CADD2
 LDY #0
 LDA (CADD2),Y
 TAX
]LOOP INY
 LDA (CADD2),Y
 JSR COUT
 DEX
 BNE ]LOOP
 JMP ]TOPLOOP
:TLEN DS 1

:PRITEM JSR GETADDR
 LDY #0
 LDA (CADD2),Y
 STA :IREC
 LDY #8
 LDA (CADD2),Y
 STA :ITEMX
 PUSH CADD
 LDX :IREC
 CPX #0
 BEQ :IEDONE
 LDA :IREC+1
 JSR LOADITEM
 LDX :ITEMX
 LDA :ITX,X
 JSR COUT
 LDX INAME
 LDY #0
]LOOP INY
 LDA INAME,Y
 JSR COUT
 DEX
 BNE ]LOOP
:IEDONE PULL CADD
 JMP ]TOPLOOP
:IREC DS 2
:ITEMX DS 1
:ITX ASC " *#-?"

:PRDEC8PNEG LDA #$FF
 HEX 2C
:PRDEC8NEG LDA #0
 STA :PN8FLAG
 JSR GETADDR
 JSR :ZAPNUM
 LDX #3
 LDY #0
 LDA (CADD2),Y
 BPL :POS
 EOR #$FF
 INC
 PHA
 LDA #"-"
 JSR COUT
 LDX #2
 BRA :NEG
:POS BIT :PN8FLAG
 BPL :POS2
 PHA
 CMP #$80
 BCS :NEG
 LDA #"+"
 JSR COUT
:NEG LDX #2
 PLA
:POS2 STA :NUMBER,Y
 JSR :DODEC
 JMP ]TOPLOOP
:PN8FLAG DS 1

:PRPAUSE JSR GETCADD
 TAX
 JSR DELAY3
 JMP ]TOPLOOP

:PRPAD3 JSR GETADDR
 LDY #0
 LDA (CADD2),Y
 CMP #100
 BCS :P3
 PHA
 LDA #"0"
 JSR COUT
 PLA
 CMP #10
 BCS :P3
 LDA #"0"
 JSR COUT
:P3 JMP :DEC8

:PRCOND JSR GETADDR
 LDA #%1000_0000
 STA :ANDX
 LDY #0
 LDA (CADD2),Y
 STA :BYTE
 BNE :PRCOND2
 LDA #"O"
 JSR COUT
 LDA #"k"
 JSR COUT
 JMP ]TOPLOOP
:PRCOND2 STZ :CFLAG
 LDX #7
]LOOP PHX
 LDA :BYTE
 AND :ANDX
 BEQ :NXTCON
 BIT :CFLAG
 BPL :C1X
 LDA #"/"
 JSR COUT
:C1X LDA #$FF
 STA :CFLAG
 TXA
 ASL
 ASL
 ASL
 ASL
 TAY
 LDA :CNAMES,Y
 TAX
]LOOP2 INY
 LDA :CNAMES,Y
 JSR COUT
 LDA CH
 CMP #77
 BCS :TOOLONG
 DEX
 BNE ]LOOP2
 PLY
 PHY
 INY
 LDA (CADD2),Y
 STA :NUMBER
 LDA PARTYNUM
 BNE :NXTCON
 LDA :NUMBER
 CMP #$FF
 BEQ :NXTCON ;Lasts forever
 LDA #"(" ;Moves left b4 cond 'expires'
 JSR COUT
 LDX #3
 JSR :DODEC
 LDA #")"
 JSR COUT
:NXTCON LSR :ANDX
 PLX
 DEX
 BPL ]LOOP
 JMP ]TOPLOOP
:TOOLONG PLA
 LDA #"."
 JSR COUT
 LDA #"."
 JSR COUT
 JMP ]TOPLOOP
:ANDX DS 1
:BYTE DS 1
:CFLAG DS 1
:CNAMES PAD16 "stunned" ;    0 (bit representation)
 PAD16 "blind" ;    1
 PAD16 "levitating" ;  2
 PAD16 "asleep" ;    3
 PAD16 "invisible" ;   4
 PAD16 "poisoned" ;    5
 PAD16 "paralyzed" ;   6
 PAD16 "dead" ;    7

:PRNIBBLE JSR GETADDR
 LDA #%1000_0000
 STA :ANDX
 LDY #0
 LDA (CADD2),Y
 STA :BYTE
 LDX #7
]LOOP LDA :BYTE
 AND :ANDX
 BEQ :NIB0
 LDA #"1"
 HEX 2C
:NIB0 LDA #"0"
 JSR COUT
 CPX #4
 BNE :NOT4
 LDA #"_"
 JSR COUT
:NOT4 LSR :ANDX
 DEX
 BPL ]LOOP
 JMP ]TOPLOOP

:PRCOLOR JSR GETCADD
 STA TEXTCOLOR
 BIT CONNECTED
 BPL :NOPROG
 BIT DUMBTERM
 BMI :NOPROG
 BIT SPECFLAG
 BPL :NOPROG
 PHA
 LDA #COLORBYTE ;Color 'code'
 JSR MSENDBYTE
 PLA
 JSR MSENDBYTE
:NOPROG JMP ]TOPLOOP

:PRSOUND JSR GETCADD
 STA :SNUM ;Sound number
 JSR GETCADD
 STA :COUNT ;Play length
 JSR GETCADD
 STA :VOL ;Volume
 BIT CONNECTED
 BPL :SNOPROG
 BIT DUMBTERM
 BMI :SNOPROG
 BIT SOUNDFLAG
 BPL :SNOPROG
 LDX #0
]LOOP LDA :SNDTBL,X
 BEQ :SNDSHORT
 CMP :SNUM
 BEQ :SNDLONG
 INX
 BRA ]LOOP
:SNDSHORT BIT PNSOUNDS
 BPL :SNOPROG
 BRA :SNDGO
:SNDLONG BIT PNSOUNDL
 BPL :SNOPROG
:SNDGO STZ :SRETRY
:DOSND LDA #SOUNDBYTE
 JSR MSENDBYTE
 LDA :SNUM
 JSR MSENDBYTE
 LDA :COUNT
 JSR MSENDBYTE
 LDA :VOL
 JSR MSENDBYTE
 LDA :SNUM
 CLC
 ADC :COUNT
 ADC :VOL
 JSR MSENDBYTE
]LOOP JSR CHECKINTO
 BCS ]LOOP
 CMP #0
 BEQ :SNOPROG
 LDA :SRETRY
 EOR #$FF
 STA :SRETRY
 BMI :DOSND ;Try one more time
:SNOPROG JMP ]TOPLOOP
:SNUM DS 1
:COUNT DS 1
:VOL DS 1
:SRETRY DS 1

:SNDTBL DFB $01,$18,$19,$1A,$1C,$1D,$1E,$1F,$20,$21,$22,$23,$24,$29,$2B
 DFB 0

GETCADD ENT
 INCR CADD
 LDY #0
 LDA (CADD),Y
 RTS

GETCADD2 ENT
 INCR CADD2
 LDY #0
 LDA (CADD2),Y
 RTS

GETADDR ENT
 JSR GETCADD
 STA CADD2
 JSR GETCADD
 STA CADD2+1
 RTS

PR0DEC ENT
 PHX
 PHY
 PHA
 STZ :NUM
 TAX
]LOOP CLD
 CPX #0
 BEQ :DONE
 SED
 LDA :NUM
 CLC
 ADC #1
 STA :NUM
 DEX
 BRA ]LOOP
:DONE LDA :NUM
 JSR PRBYTE
 PLA
 PLY
 PLX
 RTS
:NUM DS 1

USERWAIT ENT
 BIT DUMBTERM
 BMI :EXIT
 ASL
 ASL
 ASL
 ASL
 JMP WAIT
:EXIT RTS

CHECKINTO LDX #2 ;Two second timeout
]LOOP2 LDY #60
]LOOP PHX
 PHY
]LOOP3 JSR CHECKIN2
 BCS :GOTONE
 BIT $C019
 BPL ]LOOP3
 BIT $C019
 BMI ]LOOP3
 PLY
 PLX
 DEY
 BNE ]LOOP
 DEX
 BNE ]LOOP2
 SEC ;Abort
 RTS
:GOTONE PLY ;OK
 PLX
 CLC
 RTS

 LST ON
MODEND EQU *
 LST OFF

 do M16PLUS
 SAV LIB.PRINT.L
 fin

 END
