*-------------------------------
* MACROS
*-------------------------------
BEQL MAC
 BNE OK
 JMP ]1
OK <<<

BNEL MAC
 BEQ OK
 JMP ]1
OK <<<

BCCL MAC
 BCS OK
 JMP ]1
OK <<<

BCSL MAC
 BCC OK
 JMP ]1
OK <<<

BPLL MAC
 BMI OK
 JMP ]1
OK <<<

BMIL MAC
 BPL OK
 JMP ]1
OK <<<

INCR MAC
 INC ]1
 BNE OK
 if mx/2
 INC ]1+1
 else
 INC ]1+2
 fin
OK <<<

DECR MAC
 LDA ]1
 BNE OK
 if mx/2
 DEC ]1+1
 else
 DEC ]1+2
 fin
OK DEC ]1
 <<<

LDXA MAC
 if #,]1
 if mx/3
 LDX #<]1
 LDA #>]1
 else
 LDX #<]1
 LDA #^]1
 fin
 else
 if mx/3
 LDX ]1
 LDA ]1+1
 else
 LDX ]1
 LDA ]1+2
 fin
 fin
 <<<

STXA MAC
 if mx/3
 STX ]1
 STA ]1+1
 else
 STX ]1
 STA ]1+2
 fin
 <<<

CPXA MAC
 if #,]1
 if mx/3
 CMP #>]1
 BNE LESS
 CPX #<]1
 else
 CMP #^]1
 BNE LESS
 CPX #<]1
 fin
 else
 if mx/3
 CMP ]1+1
 BNE LESS
 CPX ]1
 else
 CMP ]1+2
 BNE LESS
 CPX ]1
LESS fin
 fin
 <<<

MLI_ALLOC_INTERRUPT MAC
 JSR MLI
 HEX 40
 DA ]1
 <<<

MLI_DEALLOC_INTERRUPT MAC
 JSR MLI
 HEX 41
 DA ]1
 <<<

MLI_QUIT MAC
 JSR MLI
 HEX 65
 DA ]1
 <<<

MLI_READ_BLOCK MAC
 JSR MLI
 HEX 80
 DA ]1
 <<<

MLI_WRITE_BLOCK MAC
 JSR MLI
 HEX 81
 DA ]1
 <<<

MLI_GET_TIME MAC
 JSR MLI
 HEX 82
 DA 0
 <<<

MLI_CREATE MAC
 JSR MLI
 HEX C0
 DA ]1
 <<<

MLI_DESTROY MAC
 JSR MLI
 HEX C1
 DA ]1
 <<<

MLI_RENAME MAC
 JSR MLI
 HEX C2
 DA ]1
 <<<

MLI_SET_FILE_INFO MAC
 JSR MLI
 HEX C3
 DA ]1
 <<<

MLI_GET_FILE_INFO MAC
 JSR MLI
 HEX C4
 DA ]1
 <<<

MLI_ONLINE MAC
 JSR MLI
 HEX C5
 DA ]1
 <<<

MLI_SET_PREFIX MAC
 JSR MLI
 HEX C6
 DA ]1
 <<<

MLI_GET_PREFIX MAC
 JSR MLI
 HEX C7
 DA ]1
 <<<

MLI_OPEN MAC
 JSR MLI
 HEX C8
 DA ]1
 <<<

MLI_READ MAC
 JSR MLI
 HEX CA
 DA ]1
 <<<

MLI_WRITE MAC
 JSR MLI
 HEX CB
 DA ]1
 <<<

MLI_CLOSE MAC
 JSR MLI
 HEX CC
 DA ]1
 <<<

MLI_FLUSH MAC
 JSR MLI
 HEX CD
 DA ]1
 <<<

MLI_SET_MARK MAC
 JSR MLI
 HEX CE
 DA ]1
 <<<

MLI_GET_MARK MAC
 JSR MLI
 HEX CF
 DA ]1
 <<<

MLI_SET_EOF MAC
 JSR MLI
 HEX D0
 DA ]1
 <<<

MLI_GET_EOF MAC
 JSR MLI
 HEX D1
 DA ]1
 <<<

PRCOM MAC
 HEX 80
 HEX ]1
 <<<

GOTOXY MAC
 PRCOM 01
 DFB ]1,]2
 <<<

HTAB MAC
 PRCOM 02
 DFB ]1
 <<<

VTAB MAC
 PRCOM 03
 DFB ]1
 <<<

PRFLAG MAC
 PRCOM 04
 DA ]1
 <<<

HEX8 MAC
 PRCOM 05
 DA ]1
 <<<

HEX16 MAC
 PRCOM 06
 DA ]1
 <<<

HEX32 MAC
 PRCOM 07
 DA ]1
 <<<

DEC8 MAC
 PRCOM 08
 DA ]1
 <<<

DEC16 MAC
 PRCOM 09
 DA ]1
 <<<

DEC32 MAC
 PRCOM 0A
 DA ]1
 <<<

CENTER MAC
 PRCOM 0B
 STR ]1
 <<<

PRSTRING MAC
 PRCOM 0C
 DA ]1
 <<<

CURRDATE MAC
 PRCOM 0D
 <<<

DATE MAC
 PRCOM 0E
 DA ]1
 <<<

CURRTIME MAC
 PRCOM 0F
 <<<

TIME MAC
 PRCOM 10
 DA ]1
 <<<

PAD2 MAC
 PRCOM 11
 DA ]1
 <<<

BOX MAC
 PRCOM 12
 STR ]1
 <<<

LDSHP MAC
 do ]0-2
 LDA ]1
 else
 LDA ]2*$20.]1
 fin
 <<<

DOSHAPE MAC ;Parms : shape[;shape_type]
 PRCOM 13
 do ]0-2
 DFB ]1
 else
 DFB ]2*$20.]1
 fin
 <<<

PRTABLE MAC
 PRCOM 14
 DA ]1
 DA ]2
 <<<

PRITEM MAC
 PRCOM 15
 DA ]1
 <<<

DEC8NEG MAC
 PRCOM 16
 DA ]1
 <<<

PRPAUSE MAC
 PRCOM 17
 DFB ]1
 <<<

PAD3 MAC
 PRCOM 18
 DA ]1
 <<<

PRCOND MAC
 PRCOM 19
 DA ]1
 <<<

PRNIBBLE MAC
 PRCOM 1A
 DA ]1
 <<<

DEC8PNEG MAC
 PRCOM 1B
 DA ]1
 <<<

COLOR MAC
 PRCOM 1C
 if B,]1
 DFB $0
 else
 if O,]1
 DFB $9
 else
 if G,]1
 DFB $A
 else
 if Y,]1
 DFB $B
 else
 if P,]1
 DFB $D
 else
 if A,]1
 DFB $E
 else
 if W,]1
 DFB $F
 else
 DFB ]1
 fin
 fin
 fin
 fin
 fin
 fin
 fin
 <<<

SOUND MAC
 PRCOM 1D
 if R,]1
 DFB $00 ;Reset
 DFB $00 ;Stop sound
 DFB $00 ;Volume
 else
 DFB ]1 ;Sound number
 if S,]2
 DFB $00 ;Stop
 DFB $00 ;Volume
 else
 if F,]2
 DFB $FF ;Forever (play)
 else
 DFB ]2 ;Play length
 fin
 if L,]3
 DFB $FF ;Load!
 else
 DFB ]3 ;Volume
 fin
 fin
 fin
 <<<

NULL MAC
 HEX 00
 <<<

CURSORON MAC
 HEX 05
 <<<

CURSOROFF MAC
 HEX 06
 <<<

BELL MAC
 HEX 07
 <<<

CURSORLEFT MAC
 HEX 08
 <<<

CURSORDOWN MAC
 HEX 0A
 <<<

CLEOS MAC
 HEX 0B
 <<<

HOME MAC
 HEX 0C
 <<<

CR MAC
 HEX 0D
 <<<

NORMAL MAC
 HEX 0E
 <<<

INVERSE MAC
 HEX 0F
 <<<

SCROLLUP MAC
 HEX 16
 <<<

SCROLLDOWN MAC
 HEX 17
 <<<

MTOFF MAC
 HEX 18
 <<<

CURSORTOP MAC
 HEX 19
 <<<

ZAPLINE MAC
 HEX 1A
 <<<

MTON MAC
 HEX 1B
 <<<

CURSORRIGHT MAC
 HEX 1C
 <<<

CLEOL MAC
 HEX 1D
 <<<

CURSORGOTO MAC
 HEX 1E
 <<<

CURSORUP MAC
 HEX 1F
 <<<

LINE MAC
 ASC ]1
 CR
 <<<

PUSH MAC
 if mx/2-1
 LDA ]1+2
 else
 LDA ]1+1
 fin
 PHA
 LDA ]1
 PHA
 <<<

PULL MAC
 PLA
 STA ]1
 PLA
 if mx/2-1
 STA ]1+2
 else
 STA ]1+1
 fin
 <<<

EXEC MAC
 JSR EXECUTE
 STR ]1
 STP
 <<<

CALL MAC
 JSR CALLMOD
 STR ]1
 <<<

RETURN MAC
 JMP EXITMOD
 <<<

MODID MAC
 BRA OK
 ASC "["
 ASC ]1
 ASC "]"
OK <<<

OPT MAC
 IF ]1,0
 ASC " "
 ELSE
 ASC "^"
 FIN
 ASC ]2
 ASC " - "
 ASC ]3
 <<<

DAY8 MAC
HERE ASC ]1
 DS HERE-*+8
 <<<

NOTELOG MAC ;Note only
 JSR LOGNOTE
 DFB ]1
 STR ]2
 <<<

NOTELOGSTR MAC ;Note w/string
 JSR LOGNOTESTR
 DFB ]1
 STR ]2
 DA ]3
 <<<

NOTELOGNUM MAC ;Note w/number
 JSR LOGNOTENUM
 DFB ]1
 STR ]2
 DA ]3
 <<<

NOTELOGBUFF MAC ;Points to a buffer with text
 JSR LOGNOTEBUFF
 DFB ]1
 DA ]2
 <<<

GETRETURN MAC
 JSR GETCR
 <<<

GETLINE MAC
 LDX ]1
 JSR GET_LINE
 <<<

PAUSE MAC
 if #,]1
 LDX ]1
 else
 LDX #]1
 fin
 JSR DELAY
 <<<

RANDNUM MAC
 LDX #<]1
 LDA #>]1
 JSR RANDOM
 <<<

MGRID MAC
 if #,]1
 DFB $FF,$FF
 else
 DFB ]1
 DFB $FF,$FF
 fin
 <<<

PAD16 MAC
HERE STR ]1
 DS HERE-*+16
 <<<

PushWord MAC
 if #=]1
 PEA ]1
 else
 if MX/2
 LDA ]1+1
 PHA
 fin
 LDA ]1
 PHA
 fin
 <<<

PushLong MAC
 if #=]1
 PushWord #^]1
 else
 PushWord ]1+2
 fin
 PushWord ]1
 <<<

PullWord MAC
 PLA
 do ]0
 STA ]1
 fin
 IF MX/2
 PLA
 do ]0
 STA ]1+1
 fin
 fin
 <<<

PullLong MAC
 PullWord ]1
 PullWord ]1+2
 <<<

Tool MAC
 LDX #]1
 STX TOOLNUM
 JSL $E10000
 STA TOOLERR
 <<<

QUOTE MAC
 DFB '"'.$80
 <<<

DEATH MAC
 JSR LIB_DEATH
 <<<

PNOTELOG MAC
 JSR PLOGNOTE
 DFB ]1
 STR ]2
 <<<

PNOTELOGSTR MAC
 JSR PLOGNOTESTR
 DFB ]1
 STR ]2
 DA ]3
 <<<

PNOTELOGNUM MAC
 JSR PLOGNOTENUM
 DFB ]1
 STR ]2
 DA ]3
 <<<

PNOTELOGBUFF MAC
 JSR PLOGNOTEBUFF
 DFB ]1
 DA ]2
 <<<

PushZLong MAC
 PEI ]1+2
PushZWord MAC
 PEI ]1
 <<<

*------------------------------- RB's macros

SETREG MAC
 IF X,]1
 ELSE
 LDX ]1
 FIN
 IF A,]2
 ELSE
 LDA ]2
 FIN
 JSR SETPORTREG
 <<<

GETREG MAC
 IF X,]1
 ELSE
 LDX ]1
 FIN
 JSR GETPORTREG
 <<<

*-------------------------------
