*-------------------------------
* MEMORY.MAP
*-------------------------------
* Bank $00
*
* 0800 - 0BFF  I/O buffer for library
* 0C00 - 0CFF  Stats of Player
* 0D00 - 0DFF  Stats for Monster
* 0E00 - 0EFF  Stats for Maze Monster
* 0F00 - 0FFF  Variables used across modules
* 1000 - 5FFF  Library
* 6000 - 60FF  Spell buffer
* 6100 - 61FF  Logfile buffer
* 6200 - 62FF  Stairs/Teleport buffer
* 6300 - 6BFF  Tables
* 6C00 - 6CFF  Scenario buffer
* 6D00 - 6DFF  Party Names buffer
* 6E00 - 6EFF  Item buffer
* 6F00 - 6FFF  Maze Item buffer
* 7000 - 70FF  Message Index buffer
* 7100 - 74FF  Message buffer
* 7500 - 75FF  Message BitMap buffer
* 7600 - 77FF  Misc. data buffer
* 7800 - 7FFF  Library screen-save buffer
* 8000 - B8FF  Modules
* B900 - BA04  Pageout save area (stack, stack pntr, return addr)
* BA05 - BA47  Startup parameters
* BA48 - BAAF  <free>
* BAB0 - BAFF  Clip (for message edit)
* BB00 - BBFF  Map ($100 bytes for 16 x 16)
* BC00 - BCFF  Map2 (for players & monsters only)
* BD00 - BDFF  Variables (part 2)
* BE00 - BEFF  Modem interrupt "char-in" area
*
*
* Bank $01
*
* 0800 - 0FFF  TB colour save area
* 1000 - 10FF  Player save area
* 1100 - 11FF  Monster save area
* 1200 - 12FF  Maze monster save area
* 1300 - 1ACF  Shape screen map
* 1A80 - 1BFF  <free>
* 1C00 - 1FFF  Text shapes
* 2000 - 9FFF  SHR image
* A000 - BFFF  Shapes
*-------------------------------
