*-------------------------------
* SHAPE.EDITOR
*-------------------------------
 DAT
 LST OFF

 XC
 XC

 ORG $8000 ;Always

 USE MACROS
 USE EQUATES
 USE LIB.JMP
 USE VARS

 TYP $F4
 do M16PLUS-1
 DSK RUN/MODULES/SHAPE.EDITOR
 fin

 MODID "SHAPE.EDITOR"

START JSR PRINT
 HOME
 CURSOROFF
 BOX "Shape Editor"
 NULL

TOP JSR PRINT
 NORMAL
 MTOFF
 GOTOXY 0;4
 CLEOS
 CURSORON
 ASC "[L]oad, [S]ave, [ESC]-exit; Edit $"
 COLOR YELLOW
 HEX8 CHAR
 COLOR WHITE
 NULL

]LOOP JSR KEYIN
 CMP #$9B
 BEQL EXIT
 CMP #"L"
 BEQ :LOAD
 CMP #$8D
 BEQL EDIT
 CMP #"S"
 BEQL :SAVE
 CMP #"0"
 BCC ]LOOP
 CMP #"9"+1
 BCC :NUM
 CMP #"A"
 BCC ]LOOP
 CMP #"F"+1
 BCS ]LOOP
 SEC
 SBC #7
:NUM SEC
 SBC #"0"
 STA VTEMP
 LUP 4
 ASL CHAR
 --^
 LDA CHAR
 ORA VTEMP
 STA CHAR
 JSR PRINT
 CURSORLEFT
 CURSORLEFT
 COLOR YELLOW
 HEX8 CHAR
 COLOR WHITE
 NULL
 JMP ]LOOP

:LOAD JSR PRINT
 CR
 COLOR PINK
 ASC "Load (y/N)? : "
 COLOR WHITE
 NULL
 JSR KEYIN
 JSR UPPER
 CMP #"Y"
 BNEL TOP
 JSR COUT
 JSR LOADSHAPES
 JMP TOP

:SAVE JSR PRINT
 CR
 COLOR PINK
 ASC "Save (y/N)? : "
 COLOR WHITE
 NULL
 JSR KEYIN
 JSR UPPER
 CMP #"Y"
 BNEL TOP
 JSR COUT
 JSR SAVESHAPES
 JMP TOP

EDIT JSR PRINT
 GOTOXY 0;6
 CLEOS
 NULL
 CLC
 XCE
 REP #$30
 LDA #<SHAPES
 STA CADD
 LDA #^SHAPES
 STA CADD+2
 LDA CHAR
 ASL
 ASL
 ASL
 ASL
 ASL
 TAY
 LDX #0
]LOOP LDA [CADD],Y
 STA LOC,X
 INY
 INY
 INX
 INX
 CPX #16*2
 BNE ]LOOP
 SEC
 XCE

 LDY #0
]LOOP LDA LOC,Y
 STA TEMP
 LDA LOC+1,Y
 STA TEMP+1

 LDX #0
]LOOP2 ASL TEMP+1
 ROL TEMP
 BCS :ASTER
 LDA #"."
 HEX 2C
:ASTER LDA #"*"
 JSR COUT
 INX
 CPX #16
 BNE ]LOOP2

 LDA LOC+$10,Y
 STA TEMP
 LDA LOC+$10+1,Y
 STA TEMP+1
 LDX #0
]LOOP2 ASL TEMP+1
 ROL TEMP
 BCS :ASTER2
 LDA #"."
 HEX 2C
:ASTER2 LDA #"*"
 JSR COUT
 INX
 CPX #16
 BNE ]LOOP2

 JSR PRINT
 CR
 NULL
 INY
 INY
 CPY #16
 BNE ]LOOP

 LDA CHAR
 STA :CS+2

 JSR PRINT
 GOTOXY 0;6
 NULL

 STZ XLOC
 STZ YLOC

]TOPLOOP LDA CH
 STA :PCV+2
 LDA CV
 STA :PCV+3
 JSR PRINT
 GOTOXY 35;6
:CS DOSHAPE 0
:PCV GOTOXY 0;0
 NULL

]LOOP JSR KEYIN
 CMP #$9B
 BEQL TOP
 CMP #"Z"-$40
 BEQL :ZAP
 CMP #"+"
 BEQL :PLUS
 CMP #"-"
 BEQL :MINUS
 CMP #"H"-$40
 BEQL LEFT
 CMP #"U"-$40
 BEQL RIGHT
 CMP #"K"-$40
 BEQL UP
 CMP #"J"-$40
 BEQL DOWN
 CMP #" "
 BNE ]LOOP
:SPACE CLC
 XCE
 REP #$30
 LDA XLOC
 AND #$F
 TAX
 LDA #%1000_0000_0000_0000
]LOOP2 CPX #0
 BEQ :DONE
 LSR
 DEX
 BRA ]LOOP2
:DONE XBA
 STA VTEMP
 LDA #<SHAPES
 STA CADD
 LDA #^SHAPES
 STA CADD+2
 LDA XLOC
 AND #$10
 STA :ADPLUS+1
 LDA CHAR
 ASL
 ASL
 ASL
 ASL
 ASL
 CLC
 ADC YLOC
 ADC YLOC
:ADPLUS ADC #0
 TAY
 LDA [CADD],Y
 AND VTEMP
 SEP #$20
 BEQ :ZERO
 LDA #"."
 HEX 2C
:ZERO LDA #"*"
 PHA
 REP #$20
 LDA [CADD],Y
 EOR VTEMP
 STA [CADD],Y
 SEC
 XCE
 PLA
 JSR COUT
 JSR PRINT
 CURSORLEFT
 NULL
 JMP ]TOPLOOP

:PMVAL DS 1
:PMVALS DFB $00,$11,$22,$33,$44,$55,$66,$77
 DFB $88,$99,$AA,$BB,$CC,$DD,$EE,$FF

:PLUS LDA :PMVAL
 INC
 AND #$F
 STA :PMVAL
 TAX
 LDA :PMVALS,X
 STA :ZCHAR+1
 STA :ZCHAR+2
 JMP ]TOPLOOP

:MINUS LDA :PMVAL
 DEC
 AND #$F
 STA :PMVAL
 TAX
 LDA :PMVALS,X
 STA :ZCHAR+1
 STA :ZCHAR+2
 JMP ]TOPLOOP

:ZAP CLC
 XCE
 REP #$30
 LDA CHAR
 ASL
 ASL
 ASL
 ASL
 ASL
 TAX
 LDY #0
:ZCHAR LDA #0
]LOOP2 STAL SHAPES,X
 INX
 INX
 INY
 INY
 CPY #16*2
 BNE ]LOOP2
 SEC
 XCE
 JMP EDIT

LEFT LDA XLOC
 BNE :OK
 LDA #31
 STA XLOC
 JSR PRINT
 HTAB 31
 NULL
 JMP ]LOOP
:OK DEC XLOC
 JSR PRINT
 CURSORLEFT
 NULL
 JMP ]LOOP

RIGHT LDA XLOC
 CMP #31
 BCC :OK
 STZ XLOC
 JSR PRINT
 HTAB 0
 NULL
 JMP ]LOOP
:OK INC XLOC
 JSR PRINT
 CURSORRIGHT
 NULL
 JMP ]LOOP

UP LDA YLOC
 BNE :OK
 LDA #7
 STA YLOC
 JSR PRINT
 VTAB 13
 NULL
 JMP ]LOOP
:OK DEC YLOC
 JSR PRINT
 CURSORUP
 NULL
 JMP ]LOOP

DOWN LDA YLOC
 CMP #7
 BCC :OK
 STZ YLOC
 JSR PRINT
 VTAB 6
 NULL
 JMP ]LOOP
:OK INC YLOC
 JSR PRINT
 CURSORDOWN
 NULL
 JMP ]LOOP

LOADSHAPES JSR LOADFILE ;Load shapes into memory
 STR "SHAPES"
 DA TEMPBUFF
 ADRL 0
 CLC
 XCE
 REP #$30
 LDX #0
]LOOP LDA TEMPBUFF,X
 STAL SHAPES,X
 INX
 INX
 CPX #$2000
 BNE ]LOOP
 SEC
 XCE
 RTS

SAVESHAPES CLC ;Save shapes from memory
 XCE
 REP #$30
 LDX #0
]LOOP LDAL SHAPES,X
 STA TEMPBUFF,X
 INX
 INX
 CPX #$2000
 BNE ]LOOP
 SEC
 XCE
 JSR SAVEFILE ;Save shapes from memory
 STR "SHAPES"
 DA TEMPBUFF
 ADRL 0
 RTS

EXIT RETURN

CHAR DS 2
TEMP DS 2
LOC DS 16*2*2

XLOC DS 2
YLOC DS 2

TEMPBUFF DS $2000

 LST ON
MODEND EQU *
 LST OFF

 do M16PLUS
 SAV RUN/MODULES/SHAPE.EDITOR
 fin

 END
