*-------------------------------
* SIGN.EDITOR
*-------------------------------
 DAT
 LST OFF

 ORG $8000 ;Always

 USE MACROS
 USE EQUATES
 USE VARS
 USE LIB.JMP
 USE SIGN.DSECT
 USE SCEN.DSECT

 TYP $F4
 do M16PLUS-1
 DSK RUN/MODULES/SIGN.EDITOR
 fin

 MODID "SIGN.EDITOR"

START JSR PRINT
 HOME
 CURSORON
 BOX "Sign Editor"
 GOTOXY 0;13
 INVERSE
 COLOR YELLOW
 ZAPLINE
 GOTOXY 0;22
 ZAPLINE
 NORMAL
 COLOR WHITE
 NULL
 JSR SAYBOT

 LDA CH
 STA BOTCH+2

 JSR SETXY

 LDX #0
 LDA #0
 JSR LOADSCEN
 LDA SCENBUFF
 STA MAXSCEN

TOPLOAD LDX #0
 LDA #0
 JSR LOADSIGN
 LDA MISCBUFF
 STA TOTSIGNS
 LDA MISCBUFF+1
 STA TOTSIGNS+1

 STZ SGLEN
 STZ SGLEN+1

TOP JSR PRINT
 GOTOXY 60;4
 ASC "Scenario : "
 CLEOL
 COLOR YELLOW
 DEC8 SCENARIO
 COLOR WHITE
 ASC " "
 COLOR PINK
 PRFLAG SCFREE
 COLOR WHITE
 GOTOXY 0;9
 ZAPLINE
 NULL
 LDA CURRSIGN
 ORA CURRSIGN+1
 BEQ :OK
 JSR PRINT
 ASC "Loc : "
 PAD2 SGXPOS
 ASC ","
 PAD2 SGYPOS
 ASC "  Lvl "
 DEC8 SGZPOS
 NULL
:OK JSR PRINT
 GOTOXY 0;4
 ASC "Current sign : "
 COLOR YELLOW
 DEC16 CURRSIGN
 COLOR WHITE
 ASC "    "
 GOTOXY 0;5
 ASC "Total signs  : "
 COLOR YELLOW
 DEC16 TOTSIGNS
 COLOR WHITE
 ASC "    "
 NULL
 JSR PRLEN

BOT JSR PRINT
BOTCH GOTOXY 0;23
 CLEOL
 NULL

]LOOP JSR KEYIN
 JSR UPPER
 LDX :KEYS
]LOOP2 CMP :KEYS,X
 BEQ :GOTONE
 DEX
 BNE ]LOOP2
 JMP ]LOOP
:GOTONE DEX
 TXA
 ASL
 TAX
 JMP (:TABLE,X)

:KEYS DFB :ENDKEYS-*-1
 DFB $9B
 DFB "L"
 DFB "S"
 DFB "I"
 DFB "Q"
 DFB "H"-$40
 DFB "U"-$40
 DFB "G"
 DFB "H"
 DFB "X"
:ENDKEYS

:TABLE DA JUMP
 DA LOAD
 DA SAVE
 DA INDEX
 DA EXIT
 DA LEFT
 DA RIGHT
 DA GOTO
 DA HELP
 DA SCEN

SCEN LDA MAXSCEN
 BEQ :NO
 JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 ASC "Change scenario to (max="
 DEC8 MAXSCEN
 ASC ") : "
 NULL
 GETLINE #1
 CPX #0
 BEQ :NO
 JSR GETNUM
 CPX #0
 BEQ :NO
 STX SCENARIO
 JSR CLOSEALL
 STZ CURRSIGN
 STZ CURRSIGN+1
 JSR CLRBOT
 JSR SAYBOT
 JMP TOPLOAD
:NO JSR SAYBOT
 JMP BOT

GOTO LDA TOTSIGNS
 ORA TOTSIGNS+1
 BEQL BOT
 JSR PRINT
 GOTOXY 0;9
 ZAPLINE
 ASC "Goto sign : "
 NULL
 GETLINE #5
 CPX #0
 BEQL TOP
 JSR GETNUM
 CPX #0
 BNE :OK
 CPY #0
 BEQ :NO
:OK CPY TOTSIGNS+1
 BEQ :CHEKX
 BCS :NO
:CHEKX CPX TOTSIGNS
 BEQ :OK2
 BCS :NO
:OK2 STX CURRSIGN
 STY CURRSIGN+1
 JSR LOADSIGN
 JMP LOAD2
:NO JSR PRINT
 HTAB 0
 ZAPLINE
 COLOR PINK
 ASC "Not found. "
 COLOR WHITE
 NULL
 GETRETURN
 JMP LOAD2

LEFT LDA CURRSIGN+1
 BNE :YES
 LDA CURRSIGN
 CMP #2
 BCCL BOT
:YES DECR CURRSIGN
 JMP LOAD2

RIGHT LDA CURRSIGN+1
 CMP TOTSIGNS+1
 BNE :YES
 LDA CURRSIGN
 CMP TOTSIGNS
 BEQL BOT
:YES INCR CURRSIGN
 JMP LOAD2

INDEX LDA TOTSIGNS
 ORA TOTSIGNS+1
 BEQL BOT
 PUSH CURRSIGN
 STZ CURRSIGN
 STZ CURRSIGN+1
]LOOP2 JSR CLEAR
 JSR SETXY
]LOOP LDA CURRSIGN+1
 CMP TOTSIGNS+1
 BNE :OK
 LDA CURRSIGN
 CMP TOTSIGNS
 BEQ :DONE
:OK INCR CURRSIGN
 LDX CURRSIGN
 LDA CURRSIGN+1
 JSR LOADSIGN
 JSR PRINT
 DEC16 CURRSIGN
 HTAB 7
 PAD2 SGXPOS
 ASC ","
 PAD2 SGYPOS
 ASC "  L "
 DEC8 SGZPOS
 CR
 NULL
 LDA CV
 CMP BOTLINE
 BNE ]LOOP
 JSR PRINT
 COLOR PINK
 CENTER "[Any key continues; ESC-exit]"
 COLOR WHITE
 NULL
 JSR KEYIN
 CMP #$9B
 BNE ]LOOP2
:EXIT PULL CURRSIGN
 JSR CLEAR
 JMP LOAD2
:DONE JSR PRINT
 COLOR PINK
 CENTER "[Press any key]"
 COLOR WHITE
 NULL
 JSR KEYIN
 BRA :EXIT

JUMP LDA CURRSIGN
 ORA CURRSIGN+1
 BEQL BOT
 LDA XPOS
 STA :GOTO+2
 LDA YPOS
 STA :GOTO+3
 JSR PRINT
:GOTO GOTOXY 0;0
 NULL
 JMP EDIT

CLEAR JSR PRINT
 GOTOXY 0;21
 ZAPLINE
 NULL
]LOOP JSR PRINT
 CURSORUP
 ZAPLINE
 NULL
 LDA CV
 CMP TOPLINE
 BNE ]LOOP
 RTS

HELP JSR CLEAR
 LDA TOPLINE
 STA :LINE
 LDA BOTLINE
 DEC
 STA :LINE+1
 JSR GETFILE
:LINE DFB 4,21 ;Use lines x to y
 STR "HELP/SIGN.ED"
 JSR PRINT
 GOTOXY 0;21
 COLOR PINK
 CENTER "[Press any key]"
 COLOR WHITE
 NULL
 JSR KEYIN
 JSR CLEAR
 STZ SGLEN
 STZ SGLEN+1
 JMP LOAD2

LOAD JSR PRINT
 ASC "L"
 NULL
LOAD2 LDA CURRSIGN
 ORA CURRSIGN+1
 BEQL BOT
 JSR CLEAR
 LDX CURRSIGN
 LDA CURRSIGN+1
 JSR LOADSIGN
 LDA TOPLINE
 STA :LINES
 LDA BOTLINE
 STA :LINES+1
 LDX SGLEN ;Length
 LDA SGLEN+1
 JSR SHOWMSG
:LINES DS 2 ;Lines to use (top, bottom)
 DA SGTEXT
 JSR SETXY
 JSR PRLEN
 JMP TOP

SAVE JSR PRINT
 ASC "S"
 NULL
SAVE2 LDA CURRSIGN
 ORA CURRSIGN+1
 BEQL BOT
 LDA TOPLINE
 STA :LINES
 LDA BOTLINE
 STA :LINES+1
 JSR GETSCREEN ;PICKLINE the screen
:LINES DS 2 ;on these lines
 DA SGTEXT ;and put it here
 STX SGLEN ;X and A have length on return
 STA SGLEN+1
 CMP #>SIGNRECLEN
 BCC :LENOK
 LDA #<SIGNRECLEN
 STA SGLEN
 LDA #>SIGNRECLEN
 STA SGLEN+1
:LENOK JSR PRLEN
 LDX CURRSIGN
 LDA CURRSIGN+1
 JSR SAVESIGN
 JMP TOP

EDIT LDA XPOS
 STA :GOTO+2
 LDA YPOS
 STA :GOTO+3
 JSR PRINT
:GOTO GOTOXY 0;0
 NULL
 LDX TOPLINE
 LDA BOTLINE
 JSR MSGEDIT
 LDA CH
 STA XPOS
 LDA CV
 STA YPOS
 JMP BOT

EXIT RETURN

SETXY LDA :TOP
 STA XPOS
 LDA :TOP+1
 STA YPOS
 RTS
:TOP DFB 0,14

PRLEN LDA SGLEN+1
 CMP #>SIGNRECLEN
 BCC :OK
 JSR PRINT
 INVERSE
 NULL
:OK JSR PRINT
 COLOR YELLOW
 GOTOXY 0;7
 COLOR WHITE
 ASC "Length $"
 COLOR YELLOW
 HEX16 SGLEN
 COLOR WHITE
 NORMAL
 NULL
 RTS

SAYBOT JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 ASC "[ESC]-jump, [L]oad, [S]ave, [I]ndex, [H]elp, [G]oto, "
 ASC "[X]-scen, [Q]uit : "
 NULL
 RTS

CLRBOT JSR PRINT
 GOTOXY 0;21
 LUP 7
 ZAPLINE
 CURSORUP
 --^
 ZAPLINE
 NULL
 RTS

XPOS DS 1
YPOS DS 1

TOPLINE DFB 14
BOTLINE DFB 21

CURRSIGN DS 2
TOTSIGNS DS 2

MAXSCEN DS 1

 LST ON
MODEND EQU *
 LST OFF

 do M16PLUS
 SAV RUN/MODULES/SIGN.EDITOR
 fin

 END
