*-------------------------------
* UTIL.MOD
*-------------------------------
 DAT
 LST OFF

 ORG $8000 ;Always

 USE MACROS
 USE EQUATES
 USE VARS
 USE LIB.JMP

 TYP $F4
 do M16PLUS-1
 DSK RUN/MODULES/UTIL.MOD
 fin

 MODID "UTIL.MOD"

FILET MAC
 DFB ]1
 ASC ]2
 <<<

START JSR PRINT
 HOME
 COLOR WHITE
 CURSORON
 BOX "Utility Module"
 GOTOXY 0;5
 LINE "[C] Catalog"
 LINE "[D] Delete a file"
 LINE "[E] Edit The Wall.."
 LINE "[F] Filing Cabinet Editor"
 LINE "[L] Load a file into memory (anywhere)"
 LINE "[O] Online volumes"
 LINE "[S] Shape Editor"
 LINE "[T] Test module"
 LINE "[W] Wish List Editor"
 LINE "[X] Copy files"
 CR
 ASC "Select an option; [ESC]-exit : "
 NULL

 JSR CLOSEALL

]LOOP JSR KEYIN
 JSR UPPER
 LDX :KEYS
]LOOP2 CMP :KEYS,X
 BEQ :GOTONE
 DEX
 BNE ]LOOP2
 BRA ]LOOP
:GOTONE DEX
 TXA
 ASL
 TAX
 JMP (:TABLE,X)

:KEYS DFB :ENDKEYS-*-1
 DFB $9B
 DFB "C"
 DFB "O"
 DFB "E"
 DFB "T"
 DFB "X"
 DFB "W"
 DFB "F"
 DFB "L"
 DFB "D"
 DFB "S"
:ENDKEYS

:TABLE DA EXIT
 DA CATALOG
 DA ONVOLS
 DA SHOWALL
 DA TESTMOD
 DA COPY
 DA WISH
 DA CABED
 DA LOADF
 DA ZAPFILE
 DA SHAPED

EXIT RETURN

SHAPED CALL "SHAPE.EDITOR"
 JMP START

WISH CALL "WL.EDITOR"
 JMP START

SHOWALL CALL "GAME.WALL"
 JMP START

TESTMOD CALL "TEST.MODULE"
 JMP START

CABED CALL "CAB.EDITOR"
 JMP START

LOADF JSR PRINT
 HOME
 ASC "File to load : "
 NULL
 GETLINE #59
 CPX #0
 BEQL START
 STX PATH1
]LOOP LDA $200-1,X
 JSR UPPER
 STA PATH1,X
 DEX
 BNE ]LOOP
 MLI_OPEN :OPARMS
 BCSL MYMLIERR
 LDA :OPARMS+5
 STA :EPARMS+1
 STA :RPARMS+1
 MLI_GET_EOF :EPARMS
 BCSL MYMLIERR
 JSR PRINT
 CR
 ASC "EOF $"
 HEX8 :EOF+2
 HEX16 :EOF
 CR
 ASC "Memory location : $"
 COLOR YELLOW
 ASC "0000"
 COLOR WHITE
 NULL
 STZ :LOC
 STZ :LOC+1
]LOOP JSR KEYIN
 CMP #$9B
 BEQL :FIN
 CMP #$8D
 BEQ :DOIT
 CMP #"0"
 BCC ]LOOP
 CMP #"9"+1
 BCC :NUM
 CMP #"A"
 BCC ]LOOP
 CMP #"F"+1
 BCS ]LOOP
 SEC
 SBC #7
:NUM SEC
 SBC #"0"
 STA :TEMP
 LUP 4
 ASL :LOC
 ROL :LOC+1
 --^
 LDA :LOC
 ORA :TEMP
 STA :LOC
:DISPHEX JSL PRINT
 CURSORLEFT
 CURSORLEFT
 CURSORLEFT
 CURSORLEFT
 COLOR YELLOW
 HEX16 :LOC
 COLOR WHITE
 NULL
 JMP ]LOOP
:DOIT JSR PRINT
 CR
 ASC "Load at $"
 COLOR YELLOW
 HEX16 :LOC
 COLOR WHITE
 ASC ". Are you sure (y/n)? : "
 NULL
]LOOP JSR KEYIN
 JSR UPPER
 CMP #"Y"
 BEQ :YES
 CMP #"N"
 BNE ]LOOP
 BRA :FIN
:YES JSR PRINT
 ASC "Yes"
 NULL
 LDA :EOF
 STA :REQ
 LDA :EOF+1
 STA :REQ+1
 MLI_READ :RPARMS
 BCSL MYMLIERR
:FIN JSR CLOSEALL
 JMP START
:TEMP DS 1

:OPARMS DFB 3
 DA PATH1
 DA IOBUFFER
 DS 1

:EPARMS DFB 2
 DS 1
:EOF DS 3

:RPARMS DFB 4
 DS 1
:LOC DS 2
:REQ DS 2
 DS 2

ZAPFILE JSR PRINT
 GOTOXY 0;5
 CLEOS
 COLOR WHITE
 ASC "File to delete : "
 NULL
 GETLINE #59
 CPX #0
 BEQL START
 STX PATH1
]LOOP LDA $200-1,X
 JSR UPPER
 STA PATH1,X
 DEX
 BNE ]LOOP
 LDA #<PATH1
 STA IPARMS+1
 LDA #>PATH1
 STA IPARMS+2
 MLI_GET_FILE_INFO IPARMS
 BCSL MYMLIERR
 JSR PRINT
 CR
 ASC "Are you sure (y/N)? : "
 NULL
 JSR KEYIN
 JSR UPPER
 CMP #"Y"
 BNEL START
 JSR COUT
 MLI_DESTROY DPARMS
 BCSL MYMLIERR
 JSR PRINT
 CR
 CR
 COLOR PINK
 ASC "Deleted. "
 COLOR WHITE
 NULL
 GETRETURN
 JMP START

COPY JSR PRINT
 GOTOXY 0;5
 CLEOS
 COLOR WHITE
 ASC "Path to copy from : "
 NULL
 GETLINE #59
 BCSL START
 CPX #0
 BEQ COPY
 STX PATH1
]LOOP LDA $200-1,X
 JSR UPPER
 STA PATH1,X
 DEX
 BNE ]LOOP
 LDX PATH1
 LDA PATH1,X
 CMP #"/"
 BEQ :SLOK
 LDA #"/"
 STA PATH1+1,X
 INC PATH1
:SLOK LDA #<PATH1
 STA IPARMS+1
 LDA #>PATH1
 STA IPARMS+2
 MLI_GET_FILE_INFO IPARMS
 BCSL MYMLIERR
 LDA IPARMS+4 ;File type
 CMP #$F ;DIR?
 BEQ :CONT
 JSR PRINT
 GOTOXY 0;6
 COLOR PINK
 ASC "Not a directory. "
 COLOR PINK
 NULL
 GETRETURN
 JMP COPY
:CONT JSR PRINT
 GOTOXY 0;6
 ZAPLINE
 COLOR WHITE
 ASC "Path to copy to   : "
 NULL
 GETLINE #59
 BCSL START
 CPX #0
 BEQL COPY
 STX PATH2
]LOOP LDA $200-1,X
 JSR UPPER
 STA PATH2,X
 DEX
 BNE ]LOOP
 LDX PATH2
 LDA PATH2,X
 CMP #"/"
 BEQ :SLOK2
 LDA #"/"
 STA PATH2+1,X
 INC PATH2
:SLOK2 LDA #<PATH2
 STA IPARMS+1
 LDA #>PATH2
 STA IPARMS+2
 MLI_GET_FILE_INFO IPARMS
 BCSL MYMLIERR
 LDA IPARMS+4 ;File type
 CMP #$F ;DIR?
 BEQ :CONT2
 JSR PRINT
 GOTOXY 0;7
 COLOR PINK
 ASC "Not a directory. "
 COLOR PINK
 NULL
 GETRETURN
 JMP :CONT

:CONT2 JSR COPYALL ;Do it!
 BCS :ERR
 JSR PRINT
 CR
 CR
 COLOR GREEN
 ASC "Copy OK. "
 COLOR WHITE
 NULL
 GETRETURN
 JMP START
:ERR JSR PRINT
 CR
 CR
 COLOR PINK
 ASC "Copy error. "
 COLOR WHITE
 NULL
 GETRETURN
 JMP START

MYMLIERR BCS :OOPS
 RTS
:OOPS PHA
 JSR PRINT
 CR
 ASC "MLI error $"
 NULL
 PLA
 JSR PRBYTE
 JSR PRINT
 ASC " called from $"
 NULL
 LDA $BF9C
 SEC
 SBC #6
 PHA
 LDA $BF9D
 SBC #0
 JSR PRBYTE
 PLA
 JSR PRBYTE
 JSR CLOSEALL
 JSR PRINT
 CR
 NULL
 GETRETURN
 LDX #$FF
 TXS
 JMP START

IPARMS DFB $A
 DA PATH1
 DS 15

PATH1 DS 1+65
PATH2 DS 1+65

PATH1LEN DS 1
PATH2LEN DS 1

ONVOLS JSR ONLINE
 JMP START

ONLINE JSR PRINT
 HOME
 LINE "S D  Volume name      Free  Used  Total"
 CR
 NULL

 MLI_ONLINE :ONPARMS
 JSR MLIERR

 STZ :TEMPX
]TOPLOOP LDX :TEMPX
 LDA DATABUFF1,X
 STA :TEMP
 AND #%0000_1111 ;Get "name_length"
 BEQL :SKIP
 STA PATHNAME
 LDA :TEMP
 AND #%0111_1111
 LSR
 LSR
 LSR
 LSR
 ORA #"0"
 JSR COUT
 LDA #","
 JSR COUT
 LDA :TEMP
 ASL
 BCS :DR2
:DR1 LDA #"1"
 HEX 2C
:DR2 LDA #"2"
 JSR COUT
 LDX #2
 JSR $F94A ;PRBL2

 LDY #0
 LDX :TEMPX
]LOOP INX
 LDA DATABUFF1,X
 STA PATHNAME+2,Y
 INY
 CPY PATHNAME
 BNE ]LOOP

 INC PATHNAME

 LDA #"/"
 STA PATHNAME+1

 MLI_GET_FILE_INFO :GPARMS
 JSR MLIERR

 LDX :TEMPX
 LDA DATABUFF1,X
 STA :RBPARMS+1

 MLI_READ_BLOCK :RBPARMS
 JSR MLIERR

 LDA :RBDATABUFF+$1B
 AND #%1000_0000
 STA :UFLAG
 ASL :RBDATABUFF+$1A
 ROL :RBDATABUFF+$1B

 LDX #2
 LDY #1
]LOOP LDA PATHNAME,X
 ORA #%1000_0000
 STA :TEMP
 LDA :UFLAG
 BEQ :UPPER
 ASL :RBDATABUFF+$1A
 ROL :RBDATABUFF+$1B
 BCC :UPPER
 LDA :TEMP
 JSR :CONVERT
 STA :TEMP
:UPPER LDA :TEMP
 JSR COUT
 INX
 INY
 CPY PATHNAME
 BNE ]LOOP

 LDA #16+1 ;Pad to next 'field'
 SEC
 SBC PATHNAME
 TAX
 JSR $F94A ;PRBL2

 LDA :GPARMS+5 ;Calculate blocks free
 SEC
 SBC :GPARMS+8
 STA :FREE
 LDA :GPARMS+6
 SBC :GPARMS+9
 STA :FREE+1

 LDA PADFLAG
 PHA
 LDA PADCHAR
 PHA
 LDA #$FF
 STA PADFLAG
 LDA #" "
 STA PADCHAR

 JSR PRINT
 DEC16 :FREE
 ASC " "
 DEC16 :GPARMS+8
 ASC "  "
 DEC16 :GPARMS+5
 ASC "  "
 CR
 NULL

 PLA
 STA PADCHAR
 PLA
 STA PADFLAG

:SKIP LDA :TEMPX
 CLC
 ADC #$10
 STA :TEMPX
 BNEL ]TOPLOOP
 JSR PRINT
 CR
 NULL
 GETRETURN
 RTS

:CONVERT CMP #"A"
 BCC :NO
 CMP #"Z"+1
 BCS :NO
 CLC
 ADC #$20
:NO RTS

:ONPARMS DFB 2
 DFB 0
 DA DATABUFF1

:TEMP DS 1
:TEMPX DS 1
:UFLAG DS 1
:FREE DS 2

:GPARMS DFB $A
 DA PATHNAME
 DS 15

:RBPARMS DFB 3
 DS 1
 DA :RBDATABUFF
 DA 2

:RBDATABUFF DS $200

PATHNAME DS 1
 ASC "/"
 DS 15

CATALOG JSR PRINT
 HOME
 LINE "Catalog volume ('*' = show online volumes)"
 ASC "> "
 NULL
 GETLINE #64
 BCC :OK
 JMP START

:OK CPX #0
 BEQ :OKPFX
 CPX #1
 BNE :NOT1
 LDA $200
 CMP #"*"
 BNE :NOT1
 JSR ONLINE
 JMP CATALOG

:OKPFX MLI_GET_PREFIX :GPPARMS
 JSR MLIERR
 LDX :PREFIX
]LOOP LDA :PREFIX,X
 ORA #%1000_0000
 STA :PREFIX,X
 DEX
 BNE ]LOOP
 JSR PRINT
 PRSTRING :PREFIX
 NULL
 BRA :OVER

:NOT1 STX :PREFIX
]LOOP LDA $200-1,X
 ORA #%1000_0000
 JSR UPPER
 STA :PREFIX,X
 DEX
 BNE ]LOOP

:OVER MLI_GET_FILE_INFO :GPARMS
 BCCL :DURHY
 STA :CNTR
 CMP #$45
 BNE :OVER2
 JSR PRINT
 CR
 COLOR PINK
 LINE "Volume not mounted."
 COLOR WHITE
 NULL
 JMP :ABORT
:OVER2 CMP #$27
 BNE :OVER3
 JSR PRINT
 CR
 COLOR PINK
 LINE "I/O error."
 COLOR WHITE
 NULL
 JMP :ABORT
:OVER3 CMP #$52
 BNE :OVER4
 JSR PRINT
 CR
 COLOR PINK
 LINE "Not a ProDOS disk."
 COLOR WHITE
 NULL
 JMP :ABORT
:OVER4 CMP #$40
 BNE :OVER5
 JSR PRINT
 CR
 COLOR PINK
 LINE "Invalid pathname syntax."
 COLOR WHITE
 NULL
 JMP :ABORT
:OVER5 JSR PRINT
 CR
 COLOR PINK
 ASC "MLI error $"
 COLOR YELLOW
 HEX8 :CNTR
 COLOR PINK
 LINE " occurred trying to find prefix."
 COLOR WHITE
 NULL
 JMP :ABORT

:DURHY LDA PADFLAG
 STA :PADFLAG
 LDA PADCHAR
 STA :PADCHAR
 LDA #$FF
 STA PADFLAG
 LDA #" "
 STA PADCHAR

 STZ :CNTR

 JSR PRINT
 HOME
 ASC "  File            Type  Modified         Created"
 LINE "              Size"
 CR
 MTON
 NULL

 MLI_OPEN :OPARMS
 JSR MLIERR
 LDA :OPARMS+5
 STA :RPARMS+1
 STA :CPARMS+1

 MLI_READ :RPARMS
 JSR MLIERR

 LDA #<:BUFFER
 STA CADD4
 LDA #>:BUFFER
 STA CADD4+1

 LDY #$23
 LDA (CADD4),Y
 STA ENTRY_LENGTH
 INY
 LDA (CADD4),Y
 STA ENTRIES_PER_BLOCK
 INY
 LDA (CADD4),Y
 STA FILE_COUNT
 INY
 LDA (CADD4),Y
 STA FILE_COUNT+1

 LDA ENTRY_LENGTH
 CLC
 ADC #4
 STA ENTRY_POINTER
 STZ ENTRY_POINTER+1
 LDA CADD4
 CLC
 ADC ENTRY_POINTER
 STA CADD4
 LDA CADD4+1
 ADC #0
 STA CADD4+1

 LDA #2
 STA BLOCK_ENTRIES

 STZ ACTIVE_ENTRIES
 STZ ACTIVE_ENTRIES+1

:FREAD LDA ACTIVE_ENTRIES+1
 CMP FILE_COUNT+1
 BEQ :HMM
 BCSL :EXIT
:HMM LDA ACTIVE_ENTRIES
 CMP FILE_COUNT
 BCSL :EXIT

 LDY #0 ;ENTRY_POINTER
 LDA (CADD4),Y ;Does the file exist?
 AND #$F0
 BEQ :SKIP ;No it doesn't.. so skip it
 JSR :PROCESS
 INCR ACTIVE_ENTRIES

:SKIP LDA ACTIVE_ENTRIES+1
 CMP FILE_COUNT+1
 BEQ :HMM2
 BCS :FREAD
:HMM2 LDA ACTIVE_ENTRIES
 CMP FILE_COUNT
 BCS :FREAD

 LDA BLOCK_ENTRIES
 CMP ENTRIES_PER_BLOCK
 BNE :DIFF

 MLI_READ :RPARMS
 JSR MLIERR
 LDA #1
 STA BLOCK_ENTRIES
 LDA #4
 STA ENTRY_POINTER
 STZ ENTRY_POINTER+1
 LDA #<:BUFFER
 CLC
 ADC #4
 STA CADD4
 LDA #>:BUFFER
 ADC #0
 STA CADD4+1
 JMP :FREAD

:DIFF LDA ENTRY_POINTER
 CLC
 ADC ENTRY_LENGTH
 STA ENTRY_POINTER
 LDA ENTRY_POINTER+1
 ADC #0
 STA ENTRY_POINTER+1
 LDA #<:BUFFER
 CLC
 ADC ENTRY_POINTER
 STA CADD4
 LDA #>:BUFFER
 ADC ENTRY_POINTER+1
 STA CADD4+1
 INC BLOCK_ENTRIES
 JMP :FREAD

:PROCESS BIT $C061
 BPL :OANO
 LDY #$10
 LDA (CADD4),Y
 CMP #$0F ;DIR?
 BEQ :OANO
 RTS
:OANO LDY #0 ;ENTRY_POINTER
 LDA (CADD4),Y
 AND #$0F
 STA :FILE

 LDY #$1C
 LDA (CADD4),Y
 STA :UC
 INY
 LDA (CADD4),Y
 STA :UC+1
 AND #%1000_0000
 STA :UFLAG
 ASL :UC
 ROL :UC+1
 LDX #0
 LDY #0
]LOOP INY
 LDA (CADD4),Y
 ORA #%1000_0000
 STA :TEMP
 LDA :UFLAG
 BEQ :UPPR
 ASL :UC
 ROL :UC+1
 BCC :UPPR
 LDA :TEMP
 JSR :CONVERT
 STA :TEMP
:UPPR LDA :TEMP
 INX
 STA :FILE,X
 CPX :FILE
 BNE ]LOOP

 LDY #$1E
 LDA (CADD4),Y
 AND #%1100_0010
 BEQ :LOCKED
:UNLOCKED LDA #" "
 HEX 2C
:LOCKED LDA #"*"
 STA :LOCKATTR
 LDA (CADD4),Y
 AND #%0000_0100
 BEQ :VISIBLE
:INVISIBLE LDA :LOCKATTR
 CMP #"*"
 BNE :INVUNL
:INVLOCK JSR PRINT
 INVERSE
 ASC "@"
 NORMAL
 NULL
 BRA :DONAME
:INVUNL JSR PRINT
 INVERSE
 ASC "A"
 NORMAL
 NULL
 BRA :DONAME
:VISIBLE LDA :LOCKATTR
 JSR COUT

:DONAME JSR PRINT
 ASC " "
 COLOR YELLOW
 PRSTRING :FILE
 COLOR AQUAMARINE
 HTAB 19
 NULL

 PushZWord CADD3
 LDA #<:FTYPES
 STA CADD3
 LDA #>:FTYPES
 STA CADD3+1

 LDY #$10
 LDA (CADD4),Y
 STA :TYPE
]LOOP LDY #0
 LDA (CADD3),Y
 CMP :TYPE
 BNE :FNEXT
 INY
 LDA (CADD3),Y
 JSR COUT
 INY
 LDA (CADD3),Y
 JSR COUT
 INY
 LDA (CADD3),Y
 JSR COUT
 BRA :FCONT
:FNEXT INY
 LDA (CADD3),Y
 BEQ :UNKNOWN
 LDA CADD3
 CLC
 ADC #4
 STA CADD3
 LDA CADD3+1
 ADC #0
 STA CADD3+1
 BRA ]LOOP

:UNKNOWN JSR PRINT
 ASC "$"
 HEX8 :TYPE
 NULL

:FCONT PullWord CADD3

 LDY #$18
 LDA (CADD4),Y
 STA :CRDATE
 INY
 LDA (CADD4),Y
 STA :CRDATE+1
 INY
 LDA (CADD4),Y
 STA :CRTIME
 INY
 LDA (CADD4),Y
 STA :CRTIME+1

 LDY #$21
 LDA (CADD4),Y
 STA :MODATE
 INY
 LDA (CADD4),Y
 STA :MODATE+1
 INY
 LDA (CADD4),Y
 STA :MODTIME
 INY
 LDA (CADD4),Y
 STA :MODTIME+1

 JSR PRINT
 ASC "  "
 COLOR PINK
 DATE :MODATE
 ASC " "
 TIME :MODTIME
 ASC "  "
 COLOR GREEN
 DATE :CRDATE
 ASC " "
 TIME :CRTIME
 COLOR WHITE
 NULL

 LDY #$15
 LDA (CADD4),Y
 STA :BLOCKS
 INY
 LDA (CADD4),Y
 STA :BLOCKS+1
 INY
 LDA (CADD4),Y
 STA :BLOCKS+2
 CMP #1
 BCS :DOK
 LDA :BLOCKS+1 ;Get size in K
 CMP #4
 BCC :DOBYTES
:DOK LSR :BLOCKS+2
 ROR :BLOCKS+1
 ROR :BLOCKS
 LSR :BLOCKS+2
 ROR :BLOCKS+1
 ROR :BLOCKS
 LDA :BLOCKS
 BEQ :DOK2
 INCR :BLOCKS+1
:DOK2 JSR PRINT
 DEC32 :BLOCKS+1
 ASC " k"
 NULL
 BRA :CONT
:DOBYTES JSR PRINT
 DEC32 :BLOCKS
 ASC " bytes"
 NULL

:CONT JSR PRINT
 CR
 NULL
 INC :CNTR
 LDA $C000
 BPL :NOKEY
 STA $C010
 CMP #$9B
 BNE :NOKEY
 PLA
 PLA
 JSR PRINT
 CR
 COLOR PINK
 LINE "Aborted."
 COLOR WHITE
 NULL
 JMP :ABORTZ
:NOKEY LDA CV
 CMP #21
 BNE :CONT3
 STZ :CNTR
 JSR PRINT
 GOTOXY 0;22
 ASC "Press any key to continue; [ESC] aborts"
 NULL
 JSR KEYIN
 CMP #$9B
 BEQ :EXITZ
 JSR PRINT
 GOTOXY 0;2
 CLEOS
 NULL
:CONT3 RTS

:EXITZ JSR PRINT
 GOTOXY 0;22
 ZAPLINE
 CURSORUP
 NULL
 PLA ;We got JSR'd
 PLA
:EXIT JSR PRINT
 CR
 NULL

 LDA :PREFIX+1
 CMP #"/"
 BEQ :PFOK
 MLI_GET_PREFIX :GPPARMS
 JSR MLIERR
:PFOK LDX #1
]LOOP INX
 CPX :PREFIX
 BEQ :MASTER
 LDA :PREFIX,X
 ORA #%1000_0000
 CMP #"/"
 BNE ]LOOP
:MASTER STX :PREFIX

 MLI_GET_FILE_INFO :GPARMS
 JSR MLIERR

 LDA :GPARMS+5 ;Calculate blocks free
 SEC
 SBC :GPARMS+8
 STA :FREE
 LDA :GPARMS+6
 SBC :GPARMS+9
 STA :FREE+1

 JSR PRINT
 ASC "Blocks free : "
 COLOR YELLOW
 DEC16 :FREE
 COLOR WHITE
 ASC "  Blocks used : "
 COLOR YELLOW
 DEC16 :GPARMS+8
 COLOR WHITE
 ASC "    Total blocks : "
 COLOR YELLOW
 DEC16 :GPARMS+5
 COLOR WHITE
 NULL

:ABORTZ LDA :PADFLAG
 STA PADFLAG
 LDA :PADCHAR
 STA PADCHAR
 MLI_CLOSE :CPARMS
 JSR MLIERR
:ABORT JSR PRINT
 GOTOXY 0;23
 NULL
 GETRETURN
 JMP START

:CONVERT CMP #"A"
 BCC :CVNO
 CMP #"Z"+1
 BCS :CVNO
 CLC
 ADC #$20
:CVNO RTS

:FTYPES FILET $00;"NON"
 FILET $01;"BAD"
 FILET $04;"TXT"
 FILET $06;"BIN"
 FILET $0F;"DIR"
 FILET $19;"ADB"
 FILET $1A;"AWP"
 FILET $1B;"ASP"
 FILET $B0;"SRC"
 FILET $B1;"OBJ"
 FILET $B2;"LIB"
 FILET $B3;"S16"
 FILET $B5;"EXE"
 FILET $B6;"PIF"
 FILET $B7;"TIF"
 FILET $B8;"NDA"
 FILET $B9;"CDA"
 FILET $BA;"TOL"
 FILET $BB;"DRV"
 FILET $BD;"FST"
 FILET $BF;"DOC"
 FILET $C0;"PNT"
 FILET $C1;"PIC"
 FILET $C8;"FON"
 FILET $CA;"ICN"
 FILET $FC;"BAS"
 FILET $FD;"VAR"
 FILET $FF;"SYS"
 DFB 0,0

:GPPARMS DFB 1
 DA :PREFIX

:GPARMS DFB $A
 DA :PREFIX
 DS 15

:OPARMS DFB 3
 DA :PREFIX
 DA IOBUFFER
 DS 1

:RPARMS DFB 4
 DS 1
 DA :BUFFER
 DA $200
 DS 2

:CPARMS DFB 1
 DS 1

:PREFIX DS 1+65

:PADFLAG DS 1
:PADCHAR DS 1
:UFLAG DS 1
:UC DS 2
:TEMP DS 1

:LOCKATTR DS 1
:FILE DS 1+15
:TYPE DS 1
:CRDATE DS 2
:CRTIME DS 2
:MODATE DS 2
:MODTIME DS 2
:BLOCKS DS 5

:CNTR DS 1
:FREE DS 2

:BUFFER DS $200

*-------------------------------------------------
*       - open both directories
* Loop  - read entry on PREFIX1
*       - if EOF then goto Exit
*       - file exists?
*         - check PREFIX2 filename
*         - if file doesn't exist then create it
*         - copy file
*         - if file is a DIR then set prefix to DIR
*       - goto Loop
* Exit  - pop prefix
*       - if more DIR's then goto Loop
*       - close both files
*       - set carry flag (0=OK, 1=error)
*-------------------------------------------------
COPYALL JSR PRINT
 HOME
 NULL

 LDA PATH1
 STA PATH1LEN
 LDA PATH2
 STA PATH2LEN

 JSR :OPENSET

 STZ :DIRDEPTH

:FREAD LDA ACTIVE_ENTRIES+1
 CMP FILE_COUNT+1
 BEQ :HMM
 BCSL :EXIT
:HMM LDA ACTIVE_ENTRIES
 CMP FILE_COUNT
 BCSL :EXIT

 CLC
 XCE
 REP #$10
 SEP #$20
 LDX ENTRY_POINTER
 LDA DATAXBUFF,X ;Does the file exist?
 AND #$F0
 BEQ :SKIP ;No it doesn't.. so skip it
 SEC
 XCE
 JSR :PROCESS
 INCR ACTIVE_ENTRIES

:SKIP SEC
 XCE
 LDA ACTIVE_ENTRIES+1
 CMP FILE_COUNT+1
 BEQ :HMM2
 BCS :FREAD
:HMM2 LDA ACTIVE_ENTRIES
 CMP FILE_COUNT
 BCS :FREAD

 LDA BLOCK_ENTRIES
 CMP ENTRIES_PER_BLOCK
 BNE :DIFF

 MLI_READ RWXPARMS
 JSR MLIERR
 LDA #1
 STA BLOCK_ENTRIES
 LDA #4
 STA ENTRY_POINTER
 STZ ENTRY_POINTER+1
 JMP :FREAD

:DIFF LDA ENTRY_POINTER
 CLC
 ADC ENTRY_LENGTH
 STA ENTRY_POINTER
 LDA ENTRY_POINTER+1
 ADC #0
 STA ENTRY_POINTER+1
 INC BLOCK_ENTRIES
 JMP :FREAD

:PROCESS CLC
 XCE
 REP #$10 ;Rip out the "file descriptive entry"
 SEP #$20
 LDX ENTRY_POINTER
 LDY #0
]LOOP LDA DATAXBUFF,X
 STA FILECHUNK,Y
 INX
 INY
 CPY #$27
 BNE ]LOOP
 SEC
 XCE

 LDA FILECHUNK
 AND #$0F
 STA FILEPATH
 LDY #0
]LOOP INY
 LDA FILECHUNK,Y
 ORA #%1000_0000
 STA FILEPATH,Y
 CPY FILEPATH
 BNE ]LOOP

 LDA FILECHUNK+$10
 STA FILETYPE

 LDX PATH1LEN ;Add filename to end of pathname 1
 LDY #0
]LOOP INY
 LDA FILEPATH,Y
 INX
 STA PATH1,X
 CPY FILEPATH
 BNE ]LOOP
 LDA PATH1LEN
 CLC
 ADC FILEPATH
 STA PATH1

 LDX PATH2LEN ;Add filename to end of pathname 2
 LDY #0
]LOOP INY
 LDA FILEPATH,Y
 INX
 STA PATH2,X
 CPY FILEPATH
 BNE ]LOOP
 LDA PATH2LEN
 CLC
 ADC FILEPATH
 STA PATH2

 JSR PRINT
 CR
 ASC "File : "
 COLOR YELLOW
 NULL
 LDA FILETYPE
 CMP #$0F ;Dir?
 BNE :PND
 JSR PRINT
 COLOR PINK
 NULL
:PND LDX PATH1LEN
]LOOP INX
 LDA PATH1,X
 JSR COUT
 CPX PATH1
 BNE ]LOOP
 JSR PRINT
 HTAB 35
 COLOR AQUAMARINE
 ASC "$"
 HEX8 FILETYPE
 COLOR WHITE
 HTAB 40
 ASC "Copy (y/n)? : "
 NULL
]LOOP JSR KEYIN
 JSR UPPER
 CMP #$9B
 BEQ :ESC
 CMP #"Y"
 BEQ :GOGO
 CMP #"N"
 BNE ]LOOP
 JSR PRINT
 HTAB 40
 CLEOL
 HTAB 50
 COLOR ORANGE
 ASC "Skipped."
 COLOR WHITE
 NULL
 RTS

:ESC LDX #$FF
 TXS
 JMP START

:GOGO JSR PRINT
 HTAB 40
 CLEOL
 NULL

 MLI_GET_FILE_INFO GPARMS2 ;Get info on file on PREFIX2
 CMP #$46 ;Does it exist already?
 BNE :OKTHEN
 LDA FILECHUNK
 LSR
 LSR
 LSR
 LSR
 STA CRPARMS+7 ;Storage type
 STZ CRPARMS+4 ;File type
 LDA FILECHUNK+$1F ;Aux type
 STA CRPARMS+5
 LDA FILECHUNK+$20
 STA CRPARMS+6
 LDX #3
]LOOP LDA FILECHUNK+$18,X ;Creation date/time
 STA CRPARMS+8,X
 DEX
 BPL ]LOOP
 LDA FILECHUNK+$1E ;Access bits
 STA CRPARMS+3
 MLI_CREATE CRPARMS
 JSR MYMLIERR
 JSR PRINT
 HTAB 40
 ASC "Created"
 NULL
 BRA :OKTHEN2

:OKTHEN CMP #0
 BNE :ERRG
 JSR PRINT
 HTAB 40
 ASC "Exists"
 NULL
:OKTHEN2 LDA FILETYPE
 CMP #$0F ;Dir?
 BNE :COPYIT
 JSR PRINT
 HTAB 40
 CLEOL
 ASC "Directory"
 NULL
 JMP :DIREXT
:ERRG JSR MYMLIERR

:COPYIT JSR PRINT
 HTAB 50
 CLEOL
 ASC "Copying.."
 NULL

 MLI_OPEN OPARMS3
 JSR MYMLIERR
 LDA OPARMS3+5
 STA EPARMS+1
 MLI_GET_EOF EPARMS
 JSR MYMLIERR

 MLI_OPEN OPARMS4
 JSR MYMLIERR

 STZ RWPARMS+4 ;Read in $1000 byte chunks
 LDA #$10
 STA RWPARMS+5

]LOOP LDA OPARMS3+5
 STA RWPARMS+1
 MLI_READ RWPARMS
 CMP #$4C
 BEQ :GOTEOF
 JSR MYMLIERR
:GOTEOF LDA RWPARMS+6 ;Write out length read in
 STA RWPARMS+4
 LDA RWPARMS+7
 STA RWPARMS+5
 LDA OPARMS4+5
 STA RWPARMS+1
 MLI_WRITE RWPARMS
 JSR MYMLIERR
 LDA RWPARMS+7 ;Any more left?
 BNE ]LOOP
 LDA OPARMS4+5
 STA EPARMS+1
 MLI_SET_EOF EPARMS ;Set EOF on destination file
 JSR MYMLIERR

 JSR PRINT
 HTAB 50
 CLEOL
 ASC "Copied."
 NULL

 LDA OPARMS3+5
 STA CPARMS+1
 MLI_CLOSE CPARMS
 JSR MYMLIERR
 LDA OPARMS4+5
 STA CPARMS+1
 MLI_CLOSE CPARMS
 JSR MYMLIERR

:DIREXT MLI_GET_FILE_INFO GPARMS1 ;Get info on file on PREFIX1
 JSR MYMLIERR
 LDX #14
]LOOP LDA GPARMS1+3,X
 STA GPARMS2+3,X
 DEX
 BPL ]LOOP
 LDA #7
 STA GPARMS2
 MLI_SET_FILE_INFO GPARMS2 ;Set info on file on PREFIX2
 JSR MYMLIERR
 LDA #$A
 STA GPARMS2

 LDA FILETYPE
 CMP #$0F ;DIR?
 BNEL :NODIR
 JSR PRINT
 HTAB 60
 COLOR PINK
 ASC "Copy contents? : "
 COLOR WHITE
 NULL
]LOOP JSR KEYIN
 JSR UPPER
 CMP #"Y"
 BEQ :YESGO
 CMP #"N"
 BNE ]LOOP
 JSR PRINT
 HTAB 60
 CLEOL
 COLOR ORANGE
 ASC "Contents skipped."
 COLOR WHITE
 NULL
 JMP :NODIR
:YESGO JSR PRINT
 HTAB 60
 CLEOL
 NULL

 INC PATH1
 LDX PATH1
 LDA #"/"
 STA PATH1,X
 STX PATH1LEN

 INC PATH2
 LDX PATH2
 LDA #"/"
 STA PATH2,X
 STX PATH2LEN

 LDA OPARMS1+5 ;Get mark of PREFIX1
 STA MPARMS+1
 MLI_GET_MARK MPARMS
 JSR MYMLIERR
 LDA :DIRDEPTH ;Save it
 ASL
 ASL
 TAX
 LDY #0
]LOOP LDA MPARMS+2,Y
 STA :DIRMARKS,X
 INX
 INY
 CPY #3
 BNE ]LOOP
 LDA :DIRDEPTH ;Save it
 ASL
 TAX
 LDA :CNTR
 STA :COUNT,X
 LDA :CNTR+1
 STA :COUNT+1,X

 LDA :DIRDEPTH
 ASL
 ASL
 ASL
 ASL
 TAX
 LDA ENTRY_LENGTH
 STA :STUFF,X
 INX
 LDA ENTRIES_PER_BLOCK
 STA :STUFF,X
 INX
 LDA FILE_COUNT
 STA :STUFF,X
 INX
 LDA FILE_COUNT+1
 STA :STUFF,X
 INX
 LDA ENTRY_POINTER
 STA :STUFF,X
 INX
 LDA ENTRY_POINTER+1
 STA :STUFF,X
 INX
 LDA BLOCK_ENTRIES
 STA :STUFF,X
 INX
 LDA ACTIVE_ENTRIES
 STA :STUFF,X
 INX
 LDA ACTIVE_ENTRIES+1
 STA :STUFF,X

 INC :DIRDEPTH ;So we can check files in this directory
 STZ :CNTR2

 LDA OPARMS1+5 ;Close current prefix
 STA CPARMS+1
 MLI_CLOSE CPARMS
 JSR MYMLIERR
 JSR :OPENSET
 LDA ENTRY_POINTER ;On return, it will add ENTRY_LENGTH
 SEC ;Must subtract, otherwise first file will be skipped
 SBC ENTRY_LENGTH
 STA ENTRY_POINTER
 LDA ENTRY_POINTER+1
 SBC #0
 STA ENTRY_POINTER+1
 DECR ACTIVE_ENTRIES
:NODIR LDA OPARMS1+5
 STA RWPARMS+1

 RTS ;Etc..

:EXIT LDA :DIRDEPTH
 BEQL :DONE
 DEC :DIRDEPTH

 LDA OPARMS1+5 ;Close current prefix
 STA CPARMS+1
 MLI_CLOSE CPARMS
 JSR MYMLIERR

 LDX PATH1LEN ;'Pop' on PREFIX1
]LOOP DEX
 LDA PATH1,X
 CMP #"/"
 BNE ]LOOP
 STX PATH1
 STX PATH1LEN

 LDX PATH2LEN ;'Pop' on PREFIX2
]LOOP DEX
 LDA PATH2,X
 CMP #"/"
 BNE ]LOOP
 STX PATH2
 STX PATH2LEN

 MLI_OPEN OPARMS1 ;Open new PREFIX1
 JSR MYMLIERR
 LDA OPARMS1+5
 STA RWPARMS+1

 LDA :DIRDEPTH
 ASL
 ASL
 TAX
 LDY #0
]LOOP LDA :DIRMARKS,X
 STA MPARMS+2,Y
 INX
 INY
 CPY #3
 BNE ]LOOP
 LDA :DIRDEPTH
 ASL
 TAX
 LDA :COUNT,X
 STA :CNTR
 LDA :COUNT+1,X
 STA :CNTR+1

 LDA :DIRDEPTH ;Reset everything
 ASL
 ASL
 ASL
 ASL
 TAX
 LDA :STUFF,X
 STA ENTRY_LENGTH
 INX
 LDA :STUFF,X
 STA ENTRIES_PER_BLOCK
 INX
 LDA :STUFF,X
 STA FILE_COUNT
 INX
 LDA :STUFF,X
 STA FILE_COUNT+1
 INX
 LDA :STUFF,X
 STA ENTRY_POINTER
 INX
 LDA :STUFF,X
 STA ENTRY_POINTER+1
 INX
 LDA :STUFF,X
 STA BLOCK_ENTRIES
 INX
 LDA :STUFF,X
 STA ACTIVE_ENTRIES
 INX
 LDA :STUFF,X
 STA ACTIVE_ENTRIES+1

 LDA MPARMS+2
 SEC
 SBC RWXPARMS+4
 STA MPARMS+2
 LDA MPARMS+3
 SBC RWXPARMS+5
 STA MPARMS+3
 LDA MPARMS+4
 SBC #0
 STA MPARMS+4

 MLI_SET_MARK MPARMS
 JSR MYMLIERR

 MLI_READ RWXPARMS
 JSR MLIERR

 INCR ACTIVE_ENTRIES ;Account for the directory itself

 JSR PRINT
 CR
 NULL

 JMP :DIFF ;Phew... keep going..

:DONE JSR CLOSEALL
 CLC
 RTS

:OPENSET MLI_OPEN OPARMS1 ;Open PREFIX1
 JSR MYMLIERR
 LDA OPARMS1+5
 STA RWXPARMS+1

 MLI_READ RWXPARMS
 JSR MLIERR

 LDA DATAXBUFF+$23
 STA ENTRY_LENGTH
 LDA DATAXBUFF+$24
 STA ENTRIES_PER_BLOCK
 LDA DATAXBUFF+$25
 STA FILE_COUNT
 LDA DATAXBUFF+$26
 STA FILE_COUNT+1

 LDA ENTRY_LENGTH
 CLC
 ADC #4
 STA ENTRY_POINTER
 STZ ENTRY_POINTER+1

 LDA #2
 STA BLOCK_ENTRIES

 STZ ACTIVE_ENTRIES
 STZ ACTIVE_ENTRIES+1
 RTS

:DIRDEPTH DS 1
:DIRMARKS DS 4*64
:COUNT DS 2*64
:STUFF DS 16*16

:CNTR DS 2
:CNTR2 DS 1

ABORT JSR CLOSEALL
 JSR PRINT
 HTAB 60
 COLOR PINK
 LINE "** Aborted **"
 CR
 COLOR WHITE
 GOTOXY 0;23
 NULL
 GETRETURN
 LDX #$FF
 TXS
 JMP START

OPARMS1 DFB 3
 DA PATH1
 DA IOBUFFER
 DS 1

RWPARMS DFB 4
 DS 1
 DA DATABUFF1
 DS 2
 DS 2

RWXPARMS DFB 4
 DS 1
 DA DATAXBUFF
 DA $200
 DS 2

GPARMS1 DFB $A
 DA PATH1
 DS 15

GPARMS2 DFB $A
 DA PATH2
 DS 15

CRPARMS DFB 7
 DA PATH2
 DFB %11000011 ;Access bits ($C3)
 DFB $00 ;Filetype
 DA 0 ;Aux type
 DFB 1 ;Storage type
 DA 0 ;Creation date
 DA 0 ;     & time

OPARMS3 DFB 3
 DA PATH1
 DA IOBUFF3
 DS 1

OPARMS4 DFB 3
 DA PATH2
 DA IOBUFF4
 DS 1

EPARMS DFB 2
 DS 1
 DS 3

MPARMS DFB 2
 DS 1
 DS 3

CPARMS DFB 1
 DS 1

DPARMS DFB 1
 DA PATH1

FILECHUNK DS $27 ;File descriptive entry

FILEPATH DS 1+15

FILETYPE DS 1

ENTRY_LENGTH DS 1
ENTRIES_PER_BLOCK DS 1
FILE_COUNT DS 2

BLOCK_ENTRIES DS 1
ACTIVE_ENTRIES DS 2
ENTRY_POINTER DS 2

 DS \

IOBUFF3 DS $400
IOBUFF4 DS $400

DATAXBUFF DS $200

DATABUFF1 DS $1000

 LST ON
MODEND EQU *
 LST OFF

 do M16PLUS
 SAV RUN/MODULES/UTIL.MOD
 fin

 END
