*-------------------------------
* VIEW.MAP
*-------------------------------
 DAT
 LST OFF

 ORG $8000 ;Always

 USE MACROS
 USE EQUATES
 USE VARS
 USE LIB.JMP
 USE PLR.DSECT
 USE MON.DSECT
 USE MON2.DSECT
 USE ITEM.DSECT
 USE ITEM2.DSECT
 USE ST.DSECT
 USE SIGN.DSECT

 TYP $F4
 do M16PLUS-1
 DSK RUN/MODULES/VIEW.MAP
 fin

ENTRY MAC
HERE STR ]1
 DS HERE-*+]LEN+1
 <<<

 MODID "VIEW.MAP"

START JSR PRINT
 HOME
 CURSOROFF
 INVERSE
 GOTOXY 2;1
 LUP 36
 ASC " "
 --^
 CR
 LUP 16
 HTAB 2
 ASC "  "
 HTAB 36
 ASC "  "
 CR
 --^
 HTAB 2
 LUP 36
 ASC " "
 --^
 NORMAL
 NULL

 LDX #0
 LDA #0
 JSR LOADSCEN
 LDA SCENBUFF
 STA MAXSCEN

 JSR DRAWBOT

START2 STZ XLOC
 STZ YLOC

 LDX #0
 JSR LDMAP
 LDA MAP
 STA LEVELS

 LDX #1
 JSR LDMAP
 LDX #1
 JSR LDMAP2

 STZ PLRCOND
 LDA #$FF
 STA MAPLOOK

UPDATE JSR PRINT
 CURSOROFF
 GOTOXY 4;2
 NULL
 LDX #0
 LDY #0
]LOOP STX :X
 STY :Y
 JSR GETMAP
 XBA
 STA :SHAPE+2
 JSR PRINT
:SHAPE DOSHAPE 0
 NULL
 INC :X
 LDX :X
 LDY :Y
 CPX #$10
 BNE ]LOOP
 JSR PRINT
 CR
 HTAB 4
 NULL
 LDX #0
 STX :X
 INC :Y
 LDY :Y
 CPY #$10
 BNE ]LOOP
 JSR PRALL
 JSR PRINT
 NORMAL
 MTOFF
 NULL
 BRA TOP
:X DS 1
:Y DS 1

TOPC JSR PRINT
 CURSOROFF
 NORMAL
 NULL

TOP JSR PRINT
 GOTOXY 47;9
 PAD2 XLOC
 ASC ","
 PAD2 YLOC
 HTAB 56
 DEC8 CURLVL
 NULL
]LOOP JSR TICKTOCK
 JSR WAITIN
 BCS :YES2
 JSR GETLOC
 JSR DOSPC
 JSR WAITIN
 BCS :YES
 JSR GETLOC
 JSR DOSHP
 JMP ]LOOP
:YES PHA
 JSR GETLOC
 JSR DOSHP
 PLA
 JMP GOTKEY
:YES2 PHA
 JSR GETLOC
 JSR DOSPC
 PLA
 BRA :YES

WAITIN STZ :FLAG
 STZ :CNTR
 STZ :CNTR2
]LOOP BIT DUMBTERM
 BMI :OVER
 JSR CHECKIN ;Did we get something from the modem?
 BCS :KEY
:OVER LDA $C000
 BMI :KEY
 BIT :FLAG
 BMI :MINUS
:PLUS LDA $C019
 BPL ]LOOP
 LDA #$FF
 STA :FLAG
 BRA ]LOOP
:MINUS LDA $C019
 BMI ]LOOP
 INC :CNTR
 LDA :CNTR
 BNE ]LOOP
 INC :CNTR2
 LDA :CNTR2
 CMP #16
 BNE ]LOOP
 CLC
 RTS
:KEY SEC
 RTS
:FLAG DS 1
:CNTR DS 1
:CNTR2 DS 1

GOTKEY STA $C010
 PHA
 JSR INITCNTR
 JSR PRINT
 MTOFF
 NORMAL
 COLOR WHITE
 NULL
 PLA
 JSR UPPER
 LDX :KEYS
]LOOP2 CMP :KEYS,X
 BEQ :GOTONE
 DEX
 BNE ]LOOP2
 CMP #"1"
 BCCL TOP
 CMP #"9"+1
 BCSL TOP
 SEC
 SBC #"1"
 ASL
 TAX
 LDA XLOC
 LDY YLOC
 JMP (:NKEYS,X)
:GOTONE DEX
 TXA
 ASL
 TAX
 JMP (:TABLE,X)

:KEYS DFB :ENDKEYS-*-1
 DFB "E"
 DFB $9B
 DFB "M"-$40
 DFB "H"-$40
 DFB "U"-$40
 DFB "K"-$40
 DFB "J"-$40
 DFB "U"
 DFB "D"
 DFB "R"
 DFB "V"
 DFB "X"
:ENDKEYS

:TABLE DA EXIT
 DA EXIT
 DA DISPLAY
 DA LEFT
 DA RIGHT
 DA UP
 DA DOWN
 DA UPLVL
 DA DOWNLVL
 DA READ
 DA REALVIEW
 DA GETSCEN

:NKEYS DA KEY1
 DA KEY2
 DA KEY3
 DA KEY4
 DA KEY5
 DA KEY6
 DA KEY7
 DA KEY8
 DA KEY9

KEY1 DEC
 INY
 BRA DOKEY

KEY2 INY
 BRA DOKEY

KEY3 INC
 INY
 BRA DOKEY

KEY4 DEC
 BRA DOKEY

KEY5 JMP TOP

KEY6 INC
 BRA DOKEY

KEY7 DEC
 DEY
 BRA DOKEY

KEY8 DEY
 BRA DOKEY

KEY9 INC
 DEY
 BRA DOKEY

DOKEY CMP #16
 BCS :NOX
 STA XLOC
:NOX CPY #16
 BCS :NOY
 STY YLOC
:NOY JMP TOP

LEFT LDA XLOC
 BEQ :NO
 DEC XLOC
:NO JMP TOP

RIGHT LDA XLOC
 CMP #15
 BEQ :NO
 INC XLOC
:NO JMP TOP

UP LDA YLOC
 BEQ :NO
 DEC YLOC
:NO JMP TOP

DOWN LDA YLOC
 CMP #15
 BEQ :NO
 INC YLOC
:NO JMP TOP

UPLVL LDA CURLVL
 CMP #1
 BEQ :NO
 DEC CURLVL
 LDX CURLVL
 JSR LDMAP
 LDX CURLVL
 JSR LDMAP2
 JMP UPDATE
:NO JMP TOP

DOWNLVL LDA CURLVL
 CMP LEVELS
 BEQ :NO
 INC CURLVL
 LDX CURLVL
 JSR LDMAP
 LDX CURLVL
 JSR LDMAP2
 JMP UPDATE
:NO JMP TOP

XLOC DS 1
YLOC DS 1

GETSCEN JSR CLRBOT
 JSR PRINT
 CR
 CURSORON
 ASC "View maps for scenario (1-"
 DEC8 MAXSCEN
 ASC ") : "
 NULL
 GETLINE #1
 CPX #0
 BEQ :OUT
 JSR GETNUM
 DEX
 CPX MAXSCEN
 BCS :OUT
 INX
 STX SCENARIO
 JSR PRINT
 CURSOROFF
 NULL
 JSR DRAWBOT
 LDX SCENARIO
 LDA #0
 JSR LOADSCEN
 LDX #0
 JSR LDMAP
 LDA MAP
 STA LEVELS
 STZ CURLVL
 JSR CLRBOT
 JMP DOWNLVL
:OUT JSR CLRBOT
 JMP TOP

READ LDA XLOC
 STA PLRXPOS
 STA :X
 LDA YLOC
 STA PLRYPOS
 STA :Y
 JSR PRINT
 MTOFF
 NORMAL
 NULL
 LDX :X
 LDY :Y
 CPY #$10
 BCS :NOSEE
 CPX #$10
 BCS :NOSEE
 JSR GETMAP ;Get the shape
 CMP #SHPSIGN
 BEQ :SIGN
:NOSEE JSR PRINT
 GOTOXY 0;22
 ZAPLINE
 CURSORUP
 ZAPLINE
 CURSORON
 COLOR PINK
 ASC "Nothing to read"
 COLOR WHITE
 CURSOROFF
 NULL
 JMP TOP
:SIGN JSR CLRBOT
 LDX #0
 LDA #0
 JSR LOADSIGN
 LDA MISCBUFF
 STA :RECS
 LDA MISCBUFF+1
 STA :RECS+1
 LDA :RECS
 ORA :RECS+1
 BEQ :BLANK
]LOOP LDX :RECS
 LDA :RECS+1
 JSR LOADSIGN
 LDA SGZPOS
 CMP CURLVL
 BNE :NEXT
 LDA SGXPOS
 CMP :X
 BNE :NEXT
 LDA SGYPOS
 CMP :Y
 BNE :NEXT
 JSR PRINT
 CURSORON
 NULL
 LDX SGLEN ;Length
 LDA SGLEN+1
 JSR SHOWMSG
 DFB 20,23 ;Lines to use (top, bottom)
 DA SGTEXT
 JSR PRINT
 CURSOROFF
 VTAB 23
 COLOR PINK
 CENTER " [Press any key] "
 NULL
 JSR KEYIN
 JSR PRINT
 COLOR WHITE
 NULL
 JSR CLRBOT
 JMP TOP
:NEXT DECR :RECS ;If we cannot find the sign, then say
 LDA :RECS ; it is blank.
 ORA :RECS+1
 BNE ]LOOP
:BLANK JSR PRINT
 CURSORON
 COLOR PINK
 ASC "The sign has nothing written on it. "
 COLOR WHITE
 NULL
 GETRETURN
 JSR CLRBOT
 JMP TOP
:X DS 1
:Y DS 1
:RECS DS 2
TEMP DS 1

DISPLAY JSR CLRBOT
 JSR PRINT
 CURSORON
 NULL
 STZ :FLAG ;Outside flag
 LDX XLOC
 STX :X
 LDY YLOC
 STY :Y
 JSR GETMAP ;Get the shape
 STA :SHAPE
 STX :SHAPETYPE
 JSR PRINT
 GOTOXY 41;17
 ASC "You see : "
 CLEOL
 NULL
 LDX #0
]LOOP LDA :SHAPES,X
 CMP #$FF
 BEQ :ERR
 CMP :SHAPE
 BEQ :GOTIT
 INX
 BRA ]LOOP
:ERR JSR PRINT
 COLOR PINK
 ASC "<error>"
 COLOR WHITE
 NULL
 JMP TOPC

:NOSEE LDA #$FF
 STA :FLAG ;We're outside
 LDA :Y
 INC
 CMP #$12
 BCS :VOID
 LDA :X
 INC
 CMP #$12
 BCS :VOID
 JSR PRINT
 GOTOXY 42;17
 ASC "You see : "
 CLEOL
 NULL
 LDX #SHPWALL
 HEX 2C
:VOID LDX #SHPVOID
:GOTIT TXA
 STA :SHAPE
 ASL
 TAX
 LDA :TBL,X
 STA CADD
 LDA :TBL+1,X
 STA CADD+1
 LDX :SHAPETYPE
]LOOP CPX #0
 BEQ :YOYO
 LDA (CADD)
 SEC
 ADC CADD
 STA CADD
 LDA CADD+1
 ADC #0
 STA CADD+1
 DEX
 BRA ]LOOP
:YOYO LDA (CADD)
 TAX
 LDY #0
]LOOP INY
 LDA (CADD),Y
 JSR COUT
 DEX
 BNE ]LOOP
 LDA :SHAPE
 CMP #SHPTPORT
 BEQ :DOST
 CMP #SHPSTAIRS
 BNE :NOST
:DOST JSR :PRST
:NOST LDA :FLAG
 BMIL TOPC ;No 'extras'
 JSR PRINT
 GOTOXY 41;18
 CLEOL
 NULL
 STZ :CS
 STZ :MS
 STZ :ITEMS
 LDX :X
 LDY :Y
 JSR GETMAP2
 STA :SHAPE ;There anything on MAP2?
 CMP #0
 BEQL :CMCHEK
 LDA :SHAPE
 AND #$F
 STA :CS
 LDA :SHAPE
 LSR
 LSR
 LSR
 LSR
 STA :MS
 LDA :CS
 BEQ :NOCHAR
 CMP #15
 BCC :PL15
 JSR PRINT
 ASC "many people"
 NULL
 BRA :NOCHAR
:PL15 JSR PRINT
 COLOR YELLOW
 DEC8 :CS
 COLOR WHITE
 ASC " persons"
 NULL
:NOCHAR LDA :MS
 BEQ :CMCHEK
 LDA :CS
 BEQ :ZZ
 JSR PRINT
 ASC "/"
 NULL
:ZZ JSR PRINT
 COLOR YELLOW
 DEC8 :MS
 COLOR WHITE
 ASC " monsters"
 NULL
:CMCHEK LDX :X
 LDY :Y
 LDA CURLVL
 JSR GETITEM2 ;Any items on this square
 STA :ITEMS
 BEQ :NOI2
 LDA :SHAPE
 BEQ :NI
:YI JSR PRINT
 ASC "/"
 NULL
:NI JSR PRINT
 COLOR YELLOW
 DEC8 :ITEMS
 COLOR WHITE
 ASC " items"
 NULL
:NOI2 JSR CLRBOT
 JSR PRINT
 CURSORLEFT
 NULL
 LDA #19
 STA :HV+3
 LDA :CS
 BEQ :NOTC
 JSR :PRCS
:NOTC LDA :MS
 BEQ :NOTANY
 JSR :PRMS
:NOTANY LDA :ITEMS
 BEQ :NOI3
 JSR :PRITEMS
:NOI3 JMP TOPC
:X DS 1
:Y DS 1
:CS DS 1
:MS DS 1
:NUM DS 2
:ITEMS DS 1

:PRITEMS LDX #0
 LDA #0
 JSR LOADITEM2
 LDA IFREE
 STA :NUM
]LOOP LDA :NUM
 BEQ :DONEI
 LDX :NUM
 LDA #0
 JSR LOADITEM2
 LDA IFREE
 BMI :NEXTI
 LDA IZPOS
 CMP CURLVL
 BNE :NEXTI
 LDA IXPOS
 CMP :X
 BNE :NEXTI
 LDA IYPOS
 CMP :Y
 BNE :NEXTI
 LDX INUM
 CPX #0
 BEQ :IG
 LDA #0
 JSR LOADITEM
 LDA INAME
 STA :LEN
 JSR :DOPR
 BCS :DONEI
 BIT IBURIED
 BPL :ABOVE
 JSR PRINT ;Buried
 ASC "*"
 NULL
:ABOVE JSR PRINT
 PRSTRING INAME
 NULL
 BRA :NEXTI
:IG LDA #4
 STA :LEN
 JSR :DOPR
 BCS :DONEI
 JSR PRINT
 ASC "gold"
 NULL
:NEXTI DEC :NUM
 BRA ]LOOP
:DONEI RTS

:PRCS LDX #0
 LDA #0
 JSR LOADPLR
 LDA PLRBUFF
 STA :NUM
 LDA PLRBUFF+1
 STA :NUM+1
]LOOP LDA :NUM+1
 BNE :OKPLR
 LDA :NUM
 BEQL :DONEPLR
:OKPLR LDX :NUM
 LDA :NUM+1
 JSR LOADPLR
 BIT PLRFREE
 BMIL :NEXTPLR
 LDA PLRSCENARIO
 CMP SCENARIO
 BNEL :NEXTPLR
 LDA PLRZPOS
 CMP CURLVL
 BNE :NEXTPLR
 LDA PLRXPOS
 CMP :X
 BNE :NEXTPLR
 LDA PLRYPOS
 CMP :Y
 BNE :NEXTPLR
 LDA PLRCLASS
 ASL
 ASL
 ASL
 TAX
 LDA :CLASSTBL+1,X
 CLC
 ADC #5
 ADC PLRNAME
 STA :LEN
 LDA PLRCOND
 AND #%1100_1001 ;Can player move?
 BEQ :ZZOK
 INC :LEN
:ZZOK JSR :DOPR
 BCS :DONEPLR
 LDA PLRCOND
 AND #%1100_1001 ;Can player move?
 BEQ :PMOVEOK
 LDA PLRCOND
 AND #%1000_0000
 BEQ :PNOMOVE
 JSR PRINT
 COLOR PINK
 ASC "#" ;Dead
 COLOR WHITE
 NULL
 BRA :PMOVEOK
:PNOMOVE JSR PRINT
 COLOR PINK
 ASC "*" ;Can't move
 COLOR WHITE
 NULL
:PMOVEOK JSR PRINT
 COLOR GREEN
 PRSTRING PLRNAME
 COLOR WHITE
 ASC "("
 COLOR AQUAMARINE
 PRTABLE PLRCLASS;:CLASSTBL
 COLOR WHITE
 ASC "/"
 COLOR YELLOW
 DEC8 PLRPARTY
 COLOR WHITE
 ASC ")"
 NULL
:NEXTPLR DECR :NUM
 JMP ]LOOP
:DONEPLR RTS

]LEN = 7
:CLASSTBL DFB ]LEN
 ENTRY "<?>"
 ENTRY "Fighter" ;Basic
 ENTRY "Thief"
 ENTRY "Wizard"
 ENTRY "Cleric"
 ENTRY "Ninja" ;Elite (Fighter only)
 ENTRY "Sage" ;      (Psychic/Fighter)
 ENTRY "H-Mage" ;      (Wizard/Fighter)
 ENTRY "H-Prst" ;      (Cleric/Fighter)
 ENTRY "Lord" ;Super Elite (Fighter/Thief/Wizard/Cleric)

:PRMS LDX #0
 LDA #0
 JSR LOADMON2
 LDA MON2BUFF
 STA :NUM
 LDA MON2BUFF+1
 STA :NUM+1
]LOOP LDA :NUM
 ORA :NUM+1
 BEQL :DONEMON
 LDX :NUM
 LDA :NUM+1
 JSR LOADMON2
 LDA MCOND
 AND #%1000_0000 ;Dead?
 BMI :NEXTMON
 LDA MZPOS
 CMP CURLVL
 BNE :NEXTMON
 LDA MXPOS
 CMP :X
 BNE :NEXTMON
 LDA MYPOS
 CMP :Y
 BNE :NEXTMON
 LDX MTYPE
 LDA MTYPE+1
 JSR LOADMON
 LDA MNAME
 STA :LEN
 JSR :DOPR
 BCS :DONEMON
 JSR PRINT
 ASC "#"
 DEC16 :NUM
 ASC " "
 DEC16 MTYPE
 ASC "/"
 NULL
 LDA MCOND
 AND #%1100_1001 ;Can monster move?
 BEQ :MMOVEOK
 JSR PRINT
 COLOR PINK
 ASC "*"
 COLOR WHITE
 NULL
:MMOVEOK LDA MLEVEL
 BNE :NOG
 JSR PRINT
 COLOR AQUAMARINE
 NULL
 BRA :MGO
:NOG JSR PRINT
 COLOR ORANGE
 NULL
:MGO JSR PRINT
 PRSTRING MNAME
 COLOR WHITE
 NULL
:NEXTMON DECR :NUM
 JMP ]LOOP
:DONEMON RTS

:PRST LDX #0
 LDA #0
 JSR LOADST
 LDA STBUFF
 BNE :PRST2
 RTS
:PRST2 TAX
]LOOP PHX
 LDA #0
 JSR LOADST
 LDA STZPOS
 CMP CURLVL
 BNE :NEXTST
 LDA STXPOS
 CMP :X
 BNE :NEXTST
 LDA STYPOS
 CMP :Y
 BNE :NEXTST
 LDA STGOTOZ
 BEQ :GOTOC
 JSR PRINT
 ASC " to "
 PAD2 STGOTOX
 ASC ","
 PAD2 STGOTOY
 ASC " L"
 DEC8 STGOTOZ
 NULL
 PLA
 RTS
:GOTOC JSR PRINT
 ASC " to Castle"
 NULL
 PLA
 RTS
:NEXTST PLX
 DEX
 BNE ]LOOP
 JSR PRINT
 ASC "<?>"
 NULL
 RTS

:DOPR LDA CH
 CLC
 ADC :LEN
 CMP #78
 BCC :PROK
 INC :HV+3
 LDA :HV+3
 CMP #23
 BCS :PRTS
 JSR PRINT
:HV GOTOXY 0;20
 NULL
 CLC
 RTS
:PROK JSR PRINT
 ASC ", "
 NULL
 CLC
 RTS
:PRTS LDA CH
 CMP #75
 BCC :PRTS2
 JSR PRINT
 HTAB 76
 CLEOL
 NULL
:PRTS2 JSR PRINT
 ASC ".."
 NULL
 SEC
 RTS
:LEN DS 1

:SHAPES DFB SHPWALL,SHPSPACE,SHPSTAIRS,SHPFF,SHPDARK,SHPSIGN
 DFB SHPSWAMP,SHPPLR,SHPVOID,SHPWATER,SHPTPORT,SHPHILLS
 DFB SHPMON,SHPPLRMON,SHPITEM,SHPGATE,SHPMONGEN,SHPSAFETY
 DFB SHPALTAR,SHPFOUNTAIN
 DFB #$FF

:TBL DA :TBL00
 DA :TBL01
 DA :TBL02
 DA :TBL03
 DA :TBL04
 DA :TBL05
 DA :TBL06
 DA :TBL07
 DA :TBL08
 DA :TBL09
 DA :TBL0A
 DA :TBL0B
 DA :TBL0C
 DA :TBL0D
 DA :TBL0E
 DA :TBL0F
 DA :TBL10
 DA :TBL11
 DA :TBL12
 DA :TBL13

* 00 - Wall
:TBL00 STR "a wall" ;0 = Square (normal)
 STR "a wall" ;1 = Bendy (top-left)
 STR "a wall" ;2 = Bendy (top-right)
 STR "a wall" ;3 = Bendy (bottom-left)
 STR "a wall" ;4 = Bendy (bottom-right)
 STR "a wall" ;5 = Secret
 STR "a secret passage" ;6 = Secret (visible)

* 01 - Space
:TBL01 STR "nothing" ;0 = Normal

* 02 - Stairs
:TBL02 STR "stairs up" ;0 = Up
 STR "stairs down" ;1 = Down

* 03 - Force field
:TBL03 STR "a force field" ;0 = Horizontal
 STR "a force field" ;1 = Vertical
 STR "nothing" ;2 = Diminished (horizontal)
 STR "nothing" ;3 = Diminished (vertical)

* 04 - Dark area
:TBL04 STR "darkness" ;0 = Normal

* 05 - Sign post
:TBL05 STR "a sign" ;0 = Normal

* 06 - Swamp
:TBL06 STR "swamp" ;0 = Normal

* 07 - Player
:TBL07 STR "a person" ;0 = Normal
 STR "a person" ;1 = Current

* 08 - Unknown (can't see this square)
:TBL08 STR "nothing?" ;0 = Normal

* 09 - Water
:TBL09 STR "shallow water" ;0 = Shallow
 STR "deep water" ;1 = Deep

* 0A - Teleport
:TBL0A STR "a shimmer" ;0 = Normal

* 0B - Hills
:TBL0B STR "hills" ;0 = Normal

* 0C - Monster
:TBL0C STR "a monster" ;0 = Normal

* 0D - Player & Monster
:TBL0D STR "a monster and a person" ;0 = Normal

* 0E - Item
:TBL0E STR "an item" ;0 = Normal

* 0F - Gate
:TBL0F STR "a closed gate" ;0 = Closed
 STR "an open gate" ;1 = Open

* 10 - Monster generator
:TBL10 STR "an astral gate" ;0 = Normal
 STR "a smilie" ;1 = Guardian

* 11 - Holy ground
:TBL11 STR "holy ground" ;0 = Normal

* 12 - Altar
:TBL12 STR "an altar" ;0 = Normal

* 13 - Fountain
:TBL13 STR "a fountain" ;0 = Normal

:SHAPE DS 1
:SHAPETYPE DS 1
:FLAG DS 1

LDMAP STX PLRZPOS
 LDA #0
 JMP LOADMAP

LDMAP2 LDA #0
 JMP LOADMAP2

GETITEM2 STX :X
 STY :Y
 STA :Z
 LDX #0
 LDA #0
 JSR LOADITEM2
 LDA IFREE
 STA :NUM
 STZ :CNTR
]LOOP LDA :NUM
 BEQ :DONEI
 LDX :NUM
 LDA #0
 JSR LOADITEM2
 LDA IFREE
 BMI :NEXTI
 LDA IZPOS
 CMP :Z
 BNE :NEXTI
 LDA IXPOS
 CMP :X
 BNE :NEXTI
 LDA IYPOS
 CMP :Y
 BNE :NEXTI
 INC :CNTR
:NEXTI DEC :NUM
 BRA ]LOOP
:DONEI LDA :CNTR
 RTS
:NUM DS 1
:X DS 1
:Y DS 1
:Z DS 1
:CNTR DS 1

LEVELS DS 1
CURLVL DFB 1

EXIT RETURN

CLRBOT JSR PRINT
 GOTOXY 0;23
 LUP 4
 ZAPLINE
 CURSORUP
 --^
 ZAPLINE
 NULL
 RTS

DRAWBOT JSR PRINT
 CURSORON
 COLOR AQUAMARINE
 GOTOXY 40;2
 ASC " 7 8 9"
 GOTOXY 40;3
 ASC "  \|/"
 GOTOXY 40;4
 ASC " 4-x-6"
 GOTOXY 40;5
 ASC "  /|\"
 GOTOXY 40;6
 ASC " 1 2 3"
 COLOR WHITE
 GOTOXY 50;2
 ASC "[R]ead"
 GOTOXY 50;3
 ASC "[U]p"
 GOTOXY 50;4
 ASC "[D]own"
 GOTOXY 50;5
 ASC "[V]iew (real)"
 GOTOXY 50;6
 ASC "[X]-scenario : "
 COLOR YELLOW
 DEC8 SCENARIO
 COLOR WHITE
 GOTOXY 50;7
 ASC "[E]xit"
 GOTOXY 40;9
 ASC " Loc : ??,??  L ?"
 CURSOROFF
 NULL
 RTS

GETLOC LDX XLOC
 LDY YLOC
 JSR GETMAP
 LDX XLOC
 LDY YLOC
 RTS

REALVIEW JSR PRINT
 HOME
 NULL
 STZ MAPLOOK
 CALL "VIEW.MAP2"
 LDA #1
 STA CURLVL
 JMP START

PRALL LDX #0
]LOOP STZ :GRID,X
 INX
 BNE ]LOOP
 LDX #0
 LDA #0
 JSR LOADITEM2
 LDA ITEM2BUFF
 STA :RECS
]LOOP LDX :RECS
 BEQ :DOPLRS
 LDA #0
 JSR LOADITEM2
 BIT IFREE
 BMI :NEXTI
 LDA IZPOS
 CMP CURLVL
 BNE :NEXTI
 LDX IXPOS
 LDY IYPOS
 LDA #SHPITEM
 JSR :PUTGRID
:NEXTI DEC :RECS
 BRA ]LOOP

:DOPLRS LDX #0
 LDA #0
 JSR LOADPLR
 LDA PLRBUFF
 STA :RECS
 LDA PLRBUFF+1
 STA :RECS+1
]LOOP LDA :RECS
 ORA :RECS+1
 BEQ :DOMONS
 LDX :RECS
 LDA :RECS+1
 JSR LOADPLR
 BIT PLRFREE
 BMI :NEXTP
 LDA PLRSCENARIO
 CMP SCENARIO
 BNE :NEXTP
 LDA PLRZPOS
 CMP CURLVL
 BNE :NEXTP
 LDX PLRXPOS
 LDY PLRYPOS
 LDA #SHPPLR
 JSR :PUTGRID
:NEXTP DECR :RECS
 BRA ]LOOP

:DOMONS LDX #0
 LDA #0
 JSR LOADMON2
 LDA MON2BUFF
 STA :RECS
]LOOP LDX :RECS
 BEQ :DOIT
 LDA #0
 JSR LOADMON2
 LDA MTYPE
 ORA MTYPE+1
 BEQ :NEXTM
 LDA MCOND
 AND #%1000_0000
 BNE :NEXTM
 LDA MZPOS
 CMP CURLVL
 BNE :NEXTM
 LDX MXPOS
 LDY MYPOS
 JSR :GETGRID
 CMP #SHPPLR
 BNE :NOPLR
 LDA #SHPPLRMON
 HEX 2C
:NOPLR LDA #SHPMON
 LDX MXPOS
 LDY MYPOS
 JSR :PUTGRID
:NEXTM DEC :RECS
 BRA ]LOOP

:DOIT LDX #0
 LDY #0
]LOOP STX :X
 STY :Y
 JSR :GETGRID
 BEQ :NXT
 STA :SHAPE+2
 LDA :X
 ASL
 CLC
 ADC #4
 STA :HV+2
 LDA :Y
 CLC
 ADC #2
 STA :HV+3
 JSR PRINT
:HV GOTOXY 0;0
:SHAPE DOSHAPE 0
 NULL
:NXT INC :X
 LDX :X
 LDY :Y
 CPX #16
 BNE ]LOOP
 LDX #0
 STX :X
 INC :Y
 LDY :Y
 CPY #16
 BNE ]LOOP
 RTS

:RECS DS 2
:X DS 1
:Y DS 1

:GETGRID STX VTEMP
 TYA
 ASL
 ASL
 ASL
 ASL
 ORA VTEMP
 TAY
 LDA :GRID,Y
 RTS

:PUTGRID STX VTEMP
 PHA
 TYA
 ASL
 ASL
 ASL
 ASL
 ORA VTEMP
 TAY
 PLA
 STA :GRID,Y
 RTS

:GRID DS 16*16

MAXSCEN DS 1

 LST ON
MODEND EQU *
 LST OFF

 do M16PLUS
 SAV RUN/MODULES/VIEW.MAP
 fin

 END
