*-------------------------------
* VIEWLOG
*-------------------------------
 DAT
 LST OFF

 ORG $8000 ;Always

 USE MACROS
 USE EQUATES
 USE VARS
 USE LIB.JMP
 USE PN.DSECT

 TYP $F4
 do M16PLUS-1
 DSK RUN/MODULES/VIEWLOG
 fin

 MODID "VIEWLOG"

START JSR GETLOGLEN
 STZ :RECORD
 STZ :RECORD+1
 STZ :RECORD+2
 STZ :RECORD+3
 STZ :RECS
 LDA #$FF
 STA :TOP
 STA :BOT
 JSR PRINT
 CURSOROFF
 HOME
 NULL
 LDA $C022
 STA :TEMP1
 MLI_OPEN :OPARMS
 JSR MLIERR
 LDA :OPARMS+5
 STA :MPARMS+1
 STA :RPARMS+1
 STA :RPARMS2+1
:MARK MLI_SET_MARK :MPARMS
 JSR MLIERR

:READ LDA :TEMP1
 STA $C022
 MLI_READ :RPARMS
 CMP #$4C ;EOF
 BNE :NOTEOF
 LDA #$FF
 STA :BOT
 JMP :DONE
:NOTEOF JSR MLIERR
 STZ :BOT

:SHOW LDA #<BUFFER
 STA CADD
 LDA #>BUFFER
 STA CADD+1
 LDX CV
 LDY #5
 LDA (CADD),Y
 STA :HILITE,X
 TAX
 LDA :SHRCOLORS,X
 STA :CL+2
 PUSH CADD
 JSR PRINT
:CL COLOR WHITE
 DATE BUFFER
 ASC " "
 TIME BUFFER+2
 ASC ":"
 PAD2 BUFFER+4
 ASC " "
 NULL
 PULL CADD
 LDX #0
 LDY #6
 LDA (CADD),Y ;Length of entry
 STA :LEN
]LOOP INY
 LDA (CADD),Y
 JSR COUT
 INX
 CPX :LEN
 BNE ]LOOP
 LDA :RECORD
 CLC
 ADC #LOGRECLEN
 STA :RECORD
 LDA :RECORD+1
 ADC #0
 STA :RECORD+1
 LDA :RECORD+2
 ADC #0
 STA :RECORD+2
 INC :RECS
 LDA CV
 CMP #21
 BEQ :DONE2
 LDA #$0D
 JSR COUT
 JMP :READ

:SHRCOLORS DFB $0 ;0=Black
 DFB $D ;1=Deep red (pink)
 DFB $4 ;2=Dark blue (dark blue)
 DFB $7 ;3=Purple (purple)
 DFB $2 ;4=Dark green (dark green)
 DFB $3 ;5=Dark gray (gray)
 DFB $4 ;6=Medium blue (dark blue)
 DFB $6 ;7=Light blue (aqua)
 DFB $8 ;8=Brown (poo brown)
 DFB $9 ;9=Orange (orange)
 DFB $C ;A=Light gray (lighter gray)
 DFB $D ;B=Pink (pink)
 DFB $A ;C=Green (green)
 DFB $B ;D=Yellow (yellow)
 DFB $E ;E=Aquamarine (aquamarine)
 DFB $F ;F=White (white)

:DONE LDX CV
]LOOP CPX #22
 BEQ :DONE2
 STZ :HILITE,X
 INX
 BRA ]LOOP
:DONE2 JSR PRINT
 GOTOXY 0;22
 MTON
 INVERSE
 COLOR WHITE
 LUP 80
 ASC "S"
 --^
 NORMAL
 MTOFF
 CLEOL
 ASC "Log "
 COLOR ORANGE
 NULL
 LDA PATH
 CMP #3
 BEQ :CURRLOG
 CMP #14 ;"LOG.yymmddhhmm"?
 BEQ :LWDATE
 TAX
 LDA PATH-1,X
 JSR COUT
 LDA PATH,X
 JSR COUT
 LDA #" "
 JSR COUT
 BRA :CURRLOG
:LWDATE LDA PATH+5
 JSR COUT
 LDA PATH+6
 JSR COUT
 LDA #"/"
 JSR COUT
 LDA PATH+7
 JSR COUT
 LDA PATH+8
 JSR COUT
 LDA #"/"
 JSR COUT
 LDA PATH+9
 JSR COUT
 LDA PATH+10
 JSR COUT
 LDA #" "
 JSR COUT
:CURRLOG CLC
 XCE
 REP #$30
 PushLong #0
 PushLong #0
 PushLong :RECORD
 PushLong #LOGRECLEN
 Tool $0D0B ;LongDivide
 PullLong :LINE
 PLA ;Remainder
 PLA
 SEC
 XCE
 JSR PRINT
 COLOR WHITE
 ASC "- line "
 COLOR YELLOW
 DEC32 :LINE
 COLOR WHITE
 ASC " of "
 COLOR YELLOW
 DEC32 TOTLINES
 COLOR WHITE
 ASC ". ["
 MTON
 INVERSE
 ASC "K"
 NORMAL
 ASC ","
 INVERSE
 ASC "J"
 NORMAL
 MTOFF
 ASC "]-scroll, [E]nd, [R]ead, [P]-hist, [Q]uit."
 NULL

:GETKEY LDY :HILITE
 LDA :HUES,Y
 STA $C022

 LDX #1
]LOOP LDA :HILITE-1,X
 BEQ :NEXT

 TAY
 LDA :HUES,Y
 TAY
 TXA
 DEC
 ASL
 ASL
 ORA #%1000_0000
 STA :TEMP2
 CLC
 ADC #4
 STA :TEMP3
 LDA :TEMP2
]LOOP1 CMP $C02E
 BNE ]LOOP1
 STY $C022
 LDA :TEMP3
]LOOP2 CMP $C02E
 BNE ]LOOP2
 LDA :HILITE,X
 CMP $C022
 BEQ :NEXT
 TAY
 LDA :HUES,Y
 STA $C022
:NEXT INX
 CPX #25
 BNE ]LOOP
:CDONE JSR CHECKIN ;Get anything from modem
 BCS :YEPIN
 LDA $C000
 BPL :GETKEY
:YEPIN STA $C010
 JSR UPPER
 CMP #"J"-$40
 BEQ :DOWN
 CMP #"K"-$40
 BEQL :UP
 CMP #"E"
 BEQ :LEND
 CMP #"R"
 BEQL :NREAD
 CMP #"P"
 BEQL :PHREAD
 CMP #"Q"
 BNE :GETKEY
 JSR PRINT
 NORMAL
 MTOFF
 HOME
 NULL
 LDA :TEMP1
 STA $C022
 JSR CLOSEALL
 RETURN ;Return from module

:LEND BIT :BOT
 BMIL :GETKEY
 MLI_GET_EOF :MPARMS
 JSR MLIERR
 CLC
 XCE
 REP #$30
 LDA :RECORD
 SEC
 SBC #22*LOGRECLEN
 STA :RECORD
 LDA :RECORD+2
 SBC #0
 STA :RECORD+2
 SEC
 XCE
 STZ :TOP
 STZ :RECS
 JSR PRINT
 HOME
 NULL
 JMP :MARK

:DOWN LDA :BOT ;Can we display any more?
 BMIL :GETKEY
 LDX #2
]LOOP LDA :RECORD,X
 CMP LOGLEN,X
 BNE :DOK
 DEX
 BPL ]LOOP
 LDA #$FF
 STA :BOT
 JMP :GETKEY
:DOK STZ :TOP
 STZ :RECS
 JSR PRINT
 HOME
 NULL
 JMP :READ

:UP LDA :TOP ;Ditto..?
 BMIL :GETKEY
 LDA :RECS
 CLC
 ADC #22
 TAX
 STZ TEMP
 STZ TEMP+1
]LOOP LDA TEMP
 CLC
 ADC #LOGRECLEN
 STA TEMP
 LDA TEMP+1
 ADC #0
 STA TEMP+1
 DEX
 BNE ]LOOP
 CLC
 XCE
 REP #$30
 LDA :RECORD
 SEC
 SBC TEMP
 STA :RECORD
 LDA :RECORD+2
 SBC #0
 STA :RECORD+2
 BMI :ZTOP
 BNE :NOTOP
 LDA :RECORD
 BNE :NOTOP
 BRA :YESTOP
:ZTOP STZ :RECORD
 STZ :RECORD+2
:YESTOP SEC
 XCE
 LDA #$FF
 STA :TOP
:NOTOP SEC
 XCE
 STZ :RECS
 STZ :BOT
 JSR PRINT
 HOME
 NULL
 JMP :MARK

:LEN DS 1
:TOP DS 1
:BOT DS 1
:RECS DS 1
:TEMP1 DS 1
:TEMP2 DS 1
:TEMP3 DS 1
:HILITE DS 22
 DFB $F,$F ;Bottom two lines should be hi-lited
 DFB 0 ;Don't delete this line
:HUES HEX 00 ;Black
 HEX 10 ;Deep red
 HEX 20 ;Dark blue
 HEX 30 ;Purple
 HEX 40 ;Dark green
 HEX 50 ;Dark gray
 HEX 60 ;Medium blue
 HEX 70 ;Light blue
 HEX 80 ;Brown
 HEX 90 ;Orange
 HEX A0 ;Light gray
 HEX B0 ;Pink
 HEX C0 ;Green
 HEX D0 ;Yellow
 HEX E0 ;Aquamarine
 HEX F0 ;White

:OPARMS DFB 3
 DA PATH
 DA IOBUFFER
 DS 1

:MPARMS DFB 2
 DS 1
:RECORD DS 4

:RPARMS DFB 4
 DS 1
 DA BUFFER
 DA LOGRECLEN
 DS 2

:RPARMS2 DFB 4
 DS 1
 DA BUFFER
 DA LOGRECLEN*22
 DS 2

:LINE DS 4

:NREAD LDA :TEMP1
 STA $C022
 JSR PRINT
 HOME
 ASC "Checking.."
 NULL

 JSR CLOSEALL

 LDA #<MISCBUFF
 STA CADD3
 LDA #>MISCBUFF
 STA CADD3+1

 MLI_GET_PREFIX :PFXPARMS
 JSR MLIERR

 STZ :NCNTR2
 STZ :NCNTR3

 MLI_OPEN :NOPARMS
 JSR MLIERR
 LDA :NOPARMS+5
 STA :NRPARMS+1

 MLI_READ :NRPARMS
 JSR MLIERR

 LDA BUFFER+$23
 STA ENTRY_LENGTH
 LDA BUFFER+$24
 STA ENTRIES_PER_BLOCK
 LDA BUFFER+$25
 STA FILE_COUNT
 LDA BUFFER+$26
 STA FILE_COUNT+1

 LDA ENTRY_LENGTH
 CLC
 ADC #4
 STA ENTRY_POINTER
 STZ ENTRY_POINTER+1

 LDA #2
 STA BLOCK_ENTRIES

 STZ ACTIVE_ENTRIES
 STZ ACTIVE_ENTRIES+1

:FREAD LDA ACTIVE_ENTRIES+1
 CMP FILE_COUNT+1
 BEQ :HMM
 BCSL :NCLOSE
:HMM LDA ACTIVE_ENTRIES
 CMP FILE_COUNT
 BCSL :NCLOSE

 CLC
 XCE
 REP #$10
 SEP #$20
 LDX ENTRY_POINTER
 LDA BUFFER,X ;Does the file exist?
 AND #$F0
 BEQ :SKIP ;No it doesn't.. so skip it
 SEC
 XCE
 JSR :PROCESS
 INCR ACTIVE_ENTRIES

:SKIP SEC
 XCE
 LDA ACTIVE_ENTRIES+1
 CMP FILE_COUNT+1
 BEQ :HMM2
 BCS :FREAD
:HMM2 LDA ACTIVE_ENTRIES
 CMP FILE_COUNT
 BCS :FREAD

 LDA BLOCK_ENTRIES
 CMP ENTRIES_PER_BLOCK
 BNE :DIFF

 MLI_READ :NRPARMS
 JSR MLIERR
 LDA #1
 STA BLOCK_ENTRIES
 LDA #4
 STA ENTRY_POINTER
 STZ ENTRY_POINTER+1
 JMP :FREAD

:DIFF LDA ENTRY_POINTER
 CLC
 ADC ENTRY_LENGTH
 STA ENTRY_POINTER
 LDA ENTRY_POINTER+1
 ADC #0
 STA ENTRY_POINTER+1
 INC BLOCK_ENTRIES
 JMP :FREAD

:PROCESS CLC
 XCE
 REP #$10
 SEP #$20
 LDX ENTRY_POINTER
 LDA BUFFER,X
 AND #$0F
 STA :FILE
 LDY #0
]LOOP INX
 LDA BUFFER,X
 ORA #%1000_0000
 INY
 STA :FILE,Y
 TYA
 CMP :FILE
 BNE ]LOOP
 SEC
 XCE

 LDA :FILE
 CMP #14 ;Is it a 'LOG.yymmddhhmm' file?
 BNE :NRTS
 LDX #1
]LOOP LDA :FILE,X
 CMP PATH,X
 BNE :NRTS
 INX
 CPX #5
 BNE ]LOOP

 LDY :NCNTR2
 LDA #14
 STA (CADD3),Y
 LDX #1
]LOOP INY
 LDA :FILE,X
 STA (CADD3),Y
 INX
 CPX #16
 BNE ]LOOP
 LDA :NCNTR2
 CLC
 ADC #16
 STA :NCNTR2
 INC :NCNTR3
:NRTS RTS

:NCLOSE JSR CLOSEALL
 JSR PRINT
 HOME
 CURSORON
 LINE "Log files on disk:"
 CR
 NULL

 LDA :NCNTR2
 BNE :YEHOK
 JSR PRINT
 COLOR PINK
 ASC "None. "
 COLOR WHITE
 NULL
 GETRETURN
 JMP START

:YEHOK STZ :NCNTR
 STZ :NCNTR2
 LDA #<MISCBUFF
 STA CADD3
 LDA #>MISCBUFF
 STA CADD3+1

]LOOP INC :NCNTR
 JSR PRINT
 PAD2 :NCNTR
 ASC ") "
 NULL

 LDA :NCNTR2
 CLC
 ADC #5
 TAY
 LDA (CADD3),Y
 JSR COUT
 INY
 LDA (CADD3),Y
 JSR COUT
 LDA #"/"
 JSR COUT
 INY
 LDA (CADD3),Y
 JSR COUT
 INY
 LDA (CADD3),Y
 JSR COUT
 LDA #"/"
 JSR COUT
 INY
 LDA (CADD3),Y
 JSR COUT
 INY
 LDA (CADD3),Y
 JSR COUT
 LDA #" "
 JSR COUT
 LDA #" "
 JSR COUT
 INY
 LDA (CADD3),Y
 JSR COUT
 INY
 LDA (CADD3),Y
 JSR COUT
 LDA #":"
 JSR COUT
 INY
 LDA (CADD3),Y
 JSR COUT
 INY
 LDA (CADD3),Y
 JSR COUT
 JSR PRINT
 CR
 NULL
 LDA :NCNTR2
 CLC
 ADC #16
 STA :NCNTR2
 LDA :NCNTR
 CMP :NCNTR3
 BNEL ]LOOP

 JSR PRINT
 CR
 ASC "View log [0=current] : "
 NULL
 GETLINE #3
 CPX #0
 BEQL :NCLOSE
 JSR GETNUM
 CPX #0
 BEQ :LOG0
 CPX :NCNTR3
 BEQ :NVOK
 BCSL :NCLOSE
:NVOK TXA
 DEC
 ASL
 ASL
 ASL
 ASL
 TAY
 LDX #0
]LOOP LDA (CADD3),Y
 STA PATH,X
 INY
 INX
 CPX #15
 BNE ]LOOP
 JMP START
:LOG0 LDA #3
 STA PATH
 JMP START

:NCNTR DS 1
:NCNTR2 DS 1
:NCNTR3 DS 1

:NOPARMS DFB 3
 DA :PREFIX
 DA IOBUFFER
 DS 1

:NRPARMS DFB 4
 DS 1
 DA BUFFER
 DA $200
 DS 2

:PFXPARMS DFB 1
 DA :PREFIX
:PREFIX DS 1+65

:FILE DS 1+15

:PHREAD LDA :TEMP1
 STA $C022
 LDX #0
 LDA #0
 JSR LOADPN
 LDA PNBUFF
 STA :PHPARTY
 JSR CLOSEALL
 JSR PRINT
 HOME
 CURSORON
 ASC "View log for party ([RETURN]=list, 0=System Log) : "
 NULL
 GETLINE #3
 BCSL :LOG02
 CPX #0
 BNEL :PHNUM
 JSR PRINT
 HOME
 LINE "#  /?/Party Name"
 NULL
 STZ :PHREC
]LOOP LDA :PHREC
 CMP :PHPARTY
 BEQL :PHPDONE
 INC :PHREC
 LDX :PHREC
 LDA #0
 JSR LOADPN
 LDA PADFLAG
 PHA
 LDA PADCHAR
 PHA
 LDA #$FF
 STA PADFLAG
 LDA #" "
 STA PADCHAR
 JSR PRINT
 DEC8 :PHREC
 ASC " "
 PRFLAG PNFREE
 ASC " "
 COLOR AQUAMARINE
 PRSTRING PNNAME
 COLOR WHITE
 CR
 NULL
 PLA
 STA PADCHAR
 PLA
 STA PADFLAG
 LDA CV
 CMP #23
 BNE ]LOOP
 JSR PRINT
 COLOR YELLOW
 CENTER "[SPACE]-continue, [ESC]-exit : "
 COLOR WHITE
 NULL
]LOOP2 JSR KEYIN
 CMP #$9B
 BEQL :PHREAD
 CMP #" "
 BNE ]LOOP2
 JSR PRINT
 GOTOXY 0;1
 CLEOS
 NULL
 JMP ]LOOP
:PHPDONE JSR PRINT
 GOTOXY 0;23
 NULL
 GETRETURN
 JMP :PHREAD
:PHPARTY DS 1
:PHREC DS 1

:PHNUM JSR GETNUM
 CPY #0
 BEQ :PHDOX
:PHERR JSR PRINT
 CR
 COLOR PINK
 ASC "Last party is "
 COLOR YELLOW
 DEC8 :PHPARTY
 COLOR PINK
 ASC ". "
 COLOR WHITE
 NULL
 GETRETURN
 JMP :PHREAD
:PHDOX INX
 CPX :PHPARTY
 BCS :PHERR
 DEX
 CPX #0
 BEQL :LOG02
 STX :PHPARTY
 TXA
 JSR GETHEX
 STX VTEMP
 STY VTEMP+1
 LDX :DATAPFX
]LOOP LDA :DATAPFX+1,X
 STA PATH,X
 DEX
 BNE ]LOOP
 LDX :DATAPFX
 LDY #0
]LOOP LDA DPATH+1,Y
 STA PATH+1,X
 INX
 INY
 CPY DPATH
 BNE ]LOOP
 LDA :DATAPFX
 CLC
 ADC DPATH
 STA PATH
 TAX
 LDA VTEMP+1
 STA PATH,X
 DEX
 LDA VTEMP
 STA PATH,X
 MLI_GET_FILE_INFO :GIPARMS
 BCCL START
 JSR PRINT
 HOME
 COLOR PINK
 ASC "File '"
 COLOR YELLOW
 PRSTRING PATH
 COLOR PINK
 ASC "' doesn't exist. "
 COLOR WHITE
 NULL
 GETRETURN
 JMP :PHREAD
:LOG02 LDX LPATH
 STX PATH
]LOOP LDA LPATH,X
 STA PATH,X
 DEX
 BNE ]LOOP
 LDA #3
 STA PATH
 JMP START

:GIPARMS DFB $A
 DA PATH
 DS 15

:DATAPFX STR "/DATA"
 ASC "/"

DPATH STR "PARTYLOG.XX"
LPATH STR "LOG.yymmddhhmm"

PATH DFB 3
 ASC "LOG.yymmddhhmm"
 DS 16
LOGLEN DS 4

GETLOGLEN MLI_OPEN :OPARMS
 JSR MLIERR
 LDA :OPARMS+5
 STA :GPARMS+1
 MLI_GET_EOF :GPARMS
 JSR MLIERR
 LDX #2
]LOOP LDA :GPARMS+2,X
 STA LOGLEN,X
 DEX
 BPL ]LOOP
 JSR CLOSEALL
 CLC
 XCE
 REP #$30
 PushLong #0
 PushLong #0
 PushLong LOGLEN
 PushLong #LOGRECLEN
 Tool $0D0B ;LongDivide
 PullLong TOTLINES
 PLA ;Remainder
 PLA
 SEC
 XCE
 RTS
:OPARMS DFB 3
 DA PATH
 DA IOBUFFER
 DS 1
:GPARMS DFB 2
 DS 1
 DS 3

TEMP DS 2
TOTLINES DS 4

ENTRY_LENGTH DS 1
ENTRIES_PER_BLOCK DS 1
FILE_COUNT DS 2

BLOCK_ENTRIES DS 1
ACTIVE_ENTRIES DS 2
ENTRY_POINTER DS 2

BUFFER DS $200

 LST ON
MODEND EQU *
 LST OFF

 do M16PLUS
 SAV RUN/MODULES/VIEWLOG
 fin

 END
