*-------------------------------
* VIEWLOGFILE
*-------------------------------
 DAT
 LST OFF

 ORG $8000 ;Always

 USE MACROS
 USE EQUATES
 USE VARS
 USE LIB.JMP
 USE LOG.DSECT

 TYP $F4
 do M16PLUS-1
 DSK RUN/MOFULES/VIEWLOGFILE
 fin

 MODID "VIEWLOGFILE"

START JSR PRINT
 HOME
 NULL
 LDX #0
 LDA #0
 JSR LOADSCEN
 LDA SCENBUFF
 STA MAXSCEN
 LDX #0
 LDA #0
 JSR LOADLOGFILE ;Get first record
 LDA LOGBUFF
 STA :VRECS
 LDA LOGBUFF+1
 STA :VRECS+1
 BNE :VROK
 LDA :VRECS
 BNE :VROK
 STZ :VCNTR
 STZ :VCNTR+1
:TOPNUT JSR PRINT
 GOTOXY 0;23
 COLOR PINK
 ASC "Logfile "
 COLOR YELLOW
 DEC8 SCENARIO
 COLOR PINK
 ASC " is empty."
 COLOR WHITE
 ASC " [X]-scenario, [Q]uit : "
 CURSORON
 NULL
]LOOP JSR KEYIN
 JSR UPPER
 CMP #"X"
 BEQ :SCEN
 CMP #"Q"
 BNE ]LOOP
 RETURN

:SCEN JSR GETSCEN
 BCS :TOPNUT
 JMP START

:VROK LDA #1
 STA :RECORD
 STZ :RECORD+1
 STA :VCNTR
 STZ :VCNTR+1
:BOT JSR :READBIT
:BOT2 DECR :VCNTR
 JSR PRINT
 GOTOXY 0;22
 MTON
 INVERSE
 LUP 80
 ASC "S"
 --^
 NORMAL
 MTOFF
 ASC "Logfile "
 COLOR YELLOW
 DEC8 SCENARIO
 COLOR WHITE
 ASC " - record "
 COLOR YELLOW
 DEC16 :VCNTR
 COLOR WHITE
 ASC " of "
 COLOR YELLOW
 DEC16 :VRECS
 COLOR WHITE
 ASC ". "
 MTON
 INVERSE
 ASC "K"
 NORMAL
 ASC ", "
 INVERSE
 ASC "J"
 NORMAL
 MTOFF
 ASC " to scroll, [E]nd, [X], [Q]uit."
 NULL
 INCR :VCNTR
:GETKEY JSR CHECKIN ;Get anything from modem?
 BCS :YEPIN
 LDA $C000
 BPL :GETKEY
:YEPIN STA $C010
 JSR UPPER
 CMP #"J"-$40
 BEQ :DOWN
 CMP #"K"-$40
 BEQ :UP
 CMP #"E"
 BEQ :END
 CMP #"X"
 BEQ :SCEN2
 CMP #"Q"
 BNE :GETKEY
 RETURN

:SCEN2 JSR GETSCEN
 BCSL :BOT2
 JMP START

:END BIT BOTFLAG
 BMIL :BOT2
 LDA :VRECS
 SEC
 SBC #21
 STA :VCNTR
 LDA :VRECS+1
 SBC #0
 STA :VCNTR+1
 JMP :BOT

:UP LDA :VCNTR+1
 BNE :UPOK
 LDA :VCNTR
 CMP #24
 BCC :GETKEY
 CMP #45
 BCS :UPOK
 LDA #1
 STA :VCNTR
 STZ :VCNTR+1
 JMP :BOT
:UPOK LDA :TOPREC
 SEC
 SBC #22
 STA :VCNTR
 LDA :TOPREC+1
 SBC #0
 STA :VCNTR+1
 JMP :BOT

:DOWN LDA :VCNTR+1
 CMP :VRECS+1
 BCC :DOWNOK
 LDA :VCNTR
 CMP :VRECS
 BCC :DOWNOK
 JMP :GETKEY
:DOWNOK JMP :BOT

:READBIT JSR PRINT
 HOME
 NULL
 LDA :VCNTR
 STA :TOPREC
 LDA :VCNTR+1
 STA :TOPREC+1
:RBIT LDA :VCNTR+1
 CMP :VRECS+1
 BCC :VRSTA
 LDA :VCNTR
 CMP :VRECS
 BEQ :VRSTA
 BCSL :RDONE
:VRSTA LDA :VCNTR
 STA :RECORD
 LDA :VCNTR+1
 STA :RECORD+1
:VREAD LDX :RECORD
 LDA :RECORD+1
 JSR LOADLOGFILE
 INCR :RECORD
 INCR :VCNTR
 JSR PRINT
 DATE LOGDATE
 ASC "  "
 TIME LOGTIME
 ASC ":"
 PAD2 LOGTIME+2
 ASC "  "
 NULL
 LDA LOGTYPE ;This a logon entry or a comment?
 BEQ :COMMENT
 CMP #1
 BNE :COMMENT
 JSR PRINT
 ASC "Call #"
 COLOR YELLOW
 DEC16 LOGCALL
 COLOR WHITE
 ASC " ("
 NULL
 LDA LOGBAUD
 ASL
 TAX
 LDA :BAUDS,X
 STA CADD3
 LDA :BAUDS+1,X
 STA CADD3+1
 LDY #0
]LOOP2 LDA (CADD3),Y
 BEQ :FIN
 JSR COUT
 INY
 BRA ]LOOP2
:FIN JSR PRINT
 ASC ") by Party : "
 COLOR ORANGE
 NULL
:COMMENT JSR PRINT
 PRSTRING LOGTEXT
 COLOR WHITE
 NULL
 LDA LOGTYPE
 CMP #2
 BNE :DOCR
 JSR PRINT
 ASC " "
 COLOR YELLOW
 DEC16 LOGCALL
 COLOR WHITE
 NULL
:DOCR JSR PRINT
 CR
 NULL
 LDA CV
 CMP #22
 BNEL :RBIT
 LDA #0
 HEX 2C
:RDONE LDA #$FF
 STA BOTFLAG
 RTS
:RECORD DA 1

:VRECS DS 2
:TOPREC DS 2
:VCNTR DS 2
:BAUDS DA :B0
 DA :B1
 DA :B2
 DA :B3
 DA :B4
 DA :B5
 DA :B6
 DA :B7
 DA :B8
 DA :B9
:B0 ASC "dumbterm",00
:B1 ASC "300 baud",00
:B2 ASC "1200 baud",00
:B3 ASC "2400 baud",00
:B4 ASC "4800 baud",00
:B5 ASC "7200 baud",00
:B6 ASC "9600 baud",00
:B7 ASC "12000 baud",00
:B8 ASC "14400 baud",00
:B9 ASC "19200 baud",00

BOTFLAG DS 1

GETSCEN JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 CURSORON
 ASC "Scenario (1-"
 DEC8 MAXSCEN
 ASC ") : "
 NULL
 GETLINE #1
 JSR PRINT
 CURSOROFF
 NULL
 CPX #0
 BEQ :NO
 JSR GETNUM
 DEX
 CPX MAXSCEN
 BCS :NO
 INX
 STX SCENARIO
 CLC
 RTS
:NO SEC
 RTS

MAXSCEN DS 1

 LST ON
MODEND EQU *
 LST OFF

 do M16PLUS
 SAV RUN/MODULES/VIEWLOGFILE
 fin

 END
