*-------------------------------
* ADDLOG
*-------------------------------
 DAT
 LST OFF

 ORG $8000 ;Always

 USE MACROS
 USE EQUATES
 USE VARS
 USE LIB.JMP
 USE PN.DSECT
 USE PLR.DSECT

 TYP $F4
 do M16PLUS-1
 DSK RUN/MODULES/ADDLOG
 fin

 MODID "ADDLOG"

START JSR PRINT
 HOME
 COLOR WHITE
 CURSORON
 BOX "Add message to Log"
 CR
 LINE "Add entry to :"
 CR
 LINE "1) System Log"
 LINE "2) All Party History Logs"
 CR
 ASC "Option [ESC-exit] : "
 NULL

]LOOP JSR KEYIN
 CMP #$9B
 BEQL :EXIT
 CMP #"1"
 BEQ :CURR
 CMP #"2"
 BNE ]LOOP
 LDX #$FF
 HEX 2C
:CURR LDX #0
 STX :ALLFLAG
 JSR COUT
 JSR PRINT
 CR
 CR
 COLOR AQUAMARINE
 ASC "Entry : "
 COLOR WHITE
 CURSORON
 NULL
 GETLINE #255
 CPX #0
 BEQL :ABORT

 STX MISCBUFF
]LOOP LDA $200-1,X
 STA MISCBUFF,X
 DEX
 BNE ]LOOP

 BIT :ALLFLAG
 BMI :DOHIST

 NOTELOGBUFF $9;MISCBUFF
 JSR PRINT
 CR
 CR
 COLOR YELLOW
 ASC "Note added to the Log"
 NULL
 JMP :OK

:DOHIST JSR PRINT
 CR
 CR
 ASC "Add note to parties in what scenario (0=all)? : "
 NULL
 GETLINE #1
 CPX #0
 BEQL :ABORT
 JSR GETNUM
 STX :SCEN
 JSR PRINT
 CR
 COLOR PINK
 ASC "Wait.."
 NULL
 LDA PARTYNUM
 PHA
 LDX #0
 LDA #0
 JSR LOADPN
 LDA PNBUFF
 STA :PARTIES
]LOOP LDX :PARTIES
 LDA :PARTIES+1
 JSR LOADPN
 BIT PNFREE
 BMI :NEXTP
 LDA PLRSCENARIO
 CMP :SCEN
 BNE :NEXTP
 LDA :PARTIES
 STA PARTYNUM
 PNOTELOGBUFF $9;MISCBUFF
:NEXTP DEC :PARTIES
 LDA :PARTIES
 BNE ]LOOP
 PLA
 STA PARTYNUM
 JSR PRINT
 CR
 CR
 COLOR YELLOW
 ASC "Note added to all Party History Logs"
 NULL
 BRA :OK

:ABORT JSR PRINT
 CR
 CR
 COLOR PINK
 ASC "Aborted - no note added"
 NULL

:OK JSR PRINT
 ASC ". "
 COLOR WHITE
 NULL
 GETRETURN
 JSR PRINT
 HOME
 NULL

:EXIT RETURN

:PARTIES DS 2
:ALLFLAG DS 1
:SCEN DS 1

 LST ON
MODEND EQU *
 LST OFF

 do M16PLUS
 SAV RUN/MODULES/ADDLOG
 fin

 END
