*-------------------------------
* DRAW.SCREEN
*-------------------------------
 DAT
 LST OFF

 ORG $8000 ;Always

 USE MACROS
 USE EQUATES
 USE VARS
 USE TABLES
 USE LIB.JMP
 USE PLR.DSECT

 TYP $F4
 do M16PLUS-1
 DSK RUN/MODULES/DRAW.SCREEN
 fin

 MODID "DRAW.SCREEN"

START BIT VTEMP
 BMI :P
 JSR MAPBOX
 JSR BOTLINES
:P JSR PLRSTATS
 RETURN

PLRSTATS JSR PRINT
 GOTOXY 24;10
 LUP 8
 CLEOL
 CURSORUP
 --^
 COLOR WHITE
 ASC "# Name"
 GOTOXY 47;2
 ASC "Class"
 GOTOXY 54;2
 ASC "AC"
 GOTOXY 60;2
 ASC "HP"
 GOTOXY 66;2
 ASC "Status"
 NULL
 LDA #1
 STA :PLR
 LDA #3
 STA :VTAB+2
 LDX #0
]LOOP PHX
 LDA CURPARTY2,X
 BNE :DOSTAT
 LDA CURPARTY,X
 BEQL :NEXT
:DOSTAT LDA CURPARTY,X
 TAY
 LDA CURPARTY2,X
 TYX
 JSR LOADPLR
 JSR PRINT
:VTAB VTAB 3
 HTAB 24
 CLEOL
 DEC8 :PLR
 ASC " "
 COLOR GREEN
 PRSTRING PLRNAME
 HTAB 47
 COLOR AQUAMARINE
 PRTABLE PLRCLASS;:CLTABLE
 HTAB 54
 COLOR WHITE
 NULL
 LDA PLRAC
 BPL :ACOK
 CMP #-9
 BCS :ACOK
 JSR PRINT
 ASC "-*" ;If < -9 then display -*
 NULL
 BRA :CONT1
:ACOK CMP #10
 BCS :ACOK2
 JSR PRINT
 ASC " "
 NULL
:ACOK2 JSR PRINT
 DEC8NEG PLRAC
 NULL
:CONT1 LDA PADFLAG
 PHA
 LDA PADCHAR
 PHA
 LDA #$FF
 STA PADFLAG
 LDA #" "
 STA PADCHAR
 LDA PLRHP
 BPL :HPOK
 CMP #-99
 BCS :HPOK
 JSR PRINT
 COLOR YELLOW
 ASC " -**"
 NULL
 BRA :CONT2
:HPOK JSR PRINT
 HTAB 57
 COLOR YELLOW
 DEC8NEG PLRHP
 NULL
:CONT2 JSR PRINT
 COLOR WHITE
 ASC "/"
 COLOR YELLOW
 DEC8 PLRHP+1
 HTAB 66
 NULL
 LDA PLRCOND
 BPL :ZNOTD
 JSR PRINT
 COLOR PINK
 NULL
 BRA :ZZCONT
:ZNOTD JSR PRINT
 COLOR GREEN
 NULL
:ZZCONT JSR PRINT
 PRCOND PLRCOND
 COLOR WHITE
 NULL
 PLA
 STA PADCHAR
 PLA
 STA PADFLAG
 INC :PLR
 INC :VTAB+2
:NEXT PLX
 INX
 CPX NUMPARTY
 BNEL ]LOOP
 RTS
:PLR DS 1

]LEN = 7
:CLTABLE DFB ]LEN
 ENTRY "<None>"
 ENTRY "Fightr" ;Basic
 ENTRY "Thief"
 ENTRY "Wizard"
 ENTRY "Cleric"
 ENTRY "Ninja" ;Elite (Fighter only)
 ENTRY "Sage" ;      (Psychic/Fighter)
 ENTRY "H-Mage" ;      (Wizard/Fighter)
 ENTRY "H-Prst" ;      (Cleric/Fighter)
 ENTRY "Lord" ;Super Elite (Fighter/Thief/Wizard/Cleric)

MAPBOX JSR PRINT
 NORMAL
 MTOFF
 CURSOROFF
 GOTOXY 4;1
 LUP 18
 ASC "_"
 --^
 CR
 MTON
 INVERSE
 NULL
 LDX #9
]LOOP JSR PRINT
 HTAB 3
 ASC "Z"
 HTAB 22
 ASC "_"
 CR
 NULL
 DEX
 BNE ]LOOP
 JSR PRINT
 HTAB 4
 LUP 18
 ASC "L"
 --^
 NORMAL
 MTOFF
 CR
 HTAB 4
 ASC "Loc: ??,??  Lvl: ?"
 NULL
 RTS

BOTLINES JSR PRINT
 GOTOXY 0;14
 INVERSE
 COLOR YELLOW
 ZAPLINE
 GOTOXY 0;23
 ZAPLINE
 NORMAL
 NULL
 RTS

 LST ON
MODEND EQU *
 LST OFF

 do M16PLUS
 SAV RUN/MODULES/DRAW.SCREEN
 fin

 END
