 LST OFF
*-------------------------------------------------
* For TC3 to startup TC2 (check gameturn)
*-------------------------------------------------
 ORG $2000

 mx %11

 USE /TC/TC2/EQUATES
 USE /TC/TC2/MACROS

REAL = 0

START LDX #$FF
 TXS
 LDA #<CODE ;Relocate to MODULE area
 STA CADD
 LDA #>CODE
 STA CADD+1

 LDA #<MODULE
 STA CADD2
 LDA #>MODULE
 STA CADD2+1

 LDY #0
]LOOP LDA (CADD),Y
 STA (CADD2),Y
 INY
 BNE ]LOOP
 INC CADD+1
 INC CADD2+1
 LDA CADD2+1
 CMP #$90
 BNE ]LOOP
 JMP MODULE ;Let's go..

CODE ORG MODULE

 MLI_SET_PREFIX PFXPARMS
 JSR ERR

 MLI_OPEN OPARMS
 JSR ERR
 LDA OPARMS+5
 STA GPARMS+1
 STA RPARMS+1
 STA CPARMS+1

 MLI_GET_EOF GPARMS
 JSR ERR
 LDA GPARMS+2
 STA RPARMS+4
 LDA GPARMS+3
 STA RPARMS+5

 MLI_READ RPARMS
 JSR ERR

 MLI_CLOSE CPARMS
 JSR ERR

 LDX :PATH
 STX $2000+6
]LOOP LDA :PATH,X
 STA $2000+6,X
 DEX
 BNE ]LOOP
 LDA #1
 STA $2FE
 JMP $2000

 do REAL
:PATH STR '/TC.II/TC2/RETURN'
 else
:PATH STR '/TC/TC2/RUN/RETURN'
 fin

MYPRINT PLA
 STA CADD
 PLA
 STA CADD+1
]LOOP INCR CADD
 LDA (CADD)
 BEQ :DONE
 JSR COUT
 BRA ]LOOP
:DONE LDA CADD+1
 PHA
 LDA CADD
 PHA
 RTS

ERR EOR #0
 BNE :OOPS
 RTS
:OOPS STA :ERR
 JSR MYPRINT
 CR
 ASC "MLI error $"
 NULL
 LDA :ERR
 JSR PRBYTE
 JMP $FF59 ;Crash
:ERR DS 1

OPARMS DFB 3
 DA PATH
 DA IOBUFFER
 DS 1

GPARMS DFB 2
 DS 1
 DS 3

RPARMS DFB 4
 DS 1
 DA $2000
 DS 2
 DS 2

CPARMS DFB 1
 DS 1

 do REAL
PATH STR "/TC.II/TC2/TC2.LOAD.SYSTEM"
 else
PATH STR "/TC/TC2/RUN/TC2.LOAD.SYSTEM"
 fin

PFXPARMS DFB 1
 DA :PATH
 do REAL
:PATH STR "/TC.II/TC2/"
 else
:PATH STR "/TC/TC2/RUN/"
 fin

 TYP SYS
 do REAL
 SAV /RAM5/ENTER2
 else
 SAV /TC/TC2/RUN/ENTER2
 fin

 END
