*-------------------------------
* GAME.CHKEXP
*-------------------------------
 DAT
 LST OFF

 ORG $8000 ;Always

 USE MACROS
 USE EQUATES
 USE VARS
 USE LIB.JMP
 USE PN.DSECT
 USE PLR.DSECT

 TYP $F4
 do M16PLUS-1
 DSK RUN/MODULES/GAME.CHKEXP
 fin

 MODID "GAME.CHKEXP"

START LDA VTEMP+1
 STA DISPLAYFLAG
 LDA VTEMP
 BPLL :DOALL
:START2 LDA DISPLAYFLAG
 BNE :ZZOK
 RETURN
:ZZOK LDX PARTYNUM
 STX :PRECS
 LDA #0
 JSR LOADPN
 JSR :DOLEADS
 LDX #3 ;Update amount
]LOOP2 LDA :EXP,X
 STA PNEXP,X
 DEX
 BPL ]LOOP2
 LDX PARTYNUM
 LDA #0
 JSR SAVEPN
 LDX PNSCENARIO
 LDA PARTYNUM
 CMP LEADPRTY-1,X
 BEQL :UMNO
 LDA PNSCENARIO
 DEC
 ASL
 ASL
 TAX
 LDY #0
]LOOP2 LDA LEADEXP,X
 STA :TEMP,Y
 INX
 INY
 CPY #4
 BNE ]LOOP2
 LDX #3 ;This party exp > current amount?
]LOOP2 LDA PNEXP,X
 CMP :TEMP,X
 BEQ :CHKX
 BCCL :UMNO
 BCS :UBETIS ;Yes
:CHKX DEX
 BPL ]LOOP2
 JMP :UMNO
:UBETIS LDX PNSCENARIO
 LDA PARTYNUM
 STA LEADPRTY-1,X
 LDA PNSCENARIO
 DEC
 ASL
 ASL
 TAX
 LDY #0
]LOOP LDA :EXP,Y
 STA LEADEXP,X
 INX
 INY
 CPY #4
 BNE ]LOOP
 LDA DISPLAYFLAG
 BMI :ZC1
 JSR PRINT
 GOTOXY 0;22
 NULL
 GETRETURN
 JSR CLRBOT
 BRA :JOIN1
:ZC1 JSR PRINT
 HOME
 NULL
:JOIN1 JSR PRINT
 CURSORON
 ASC "A little fairy appears out of thin air and says :"
 CR
 CR
 QUOTE
 ASC "Your party is now in the lead with "
 COLOR PINK
 DEC32 PNEXP
 COLOR WHITE
 ASC " experience points (collectively).."
 QUOTE
 CR
 CR
 ASC "The fairy disappears.. "
 COLOR PINK
 SOUND $09;1;LOUD
 NULL
 GETRETURN
 JSR PRINT
 COLOR WHITE
 NULL
 LDA DISPLAYFLAG
 BMI :ZC2
 JSR CLRBOT
 BRA :UMNO
:ZC2 JSR PRINT
 HOME
 NULL
:UMNO RETURN

:DOALL LDX #0
 LDA #0
 JSR LOADPN
 LDA PNBUFF
 STA :PRECS

 LDX #9
]LOOP STZ PARTIES-1,X
 STZ LEADPRTY-1,X
 DEX
 BNE ]LOOP

 LDX #9*4
]LOOP STZ LEADEXP-1,X
 DEX
 BNE ]LOOP

]LOOP LDX :PRECS
 CPX #0
 BEQ :PNDONE
 LDA DISPLAYFLAG
 CMP #$7F
 BNE :ZDOK
 CPX PARTYNUM
 BEQ :PNEXT
:ZDOK LDA #0
 JSR LOADPN
 LDA PNFREE
 BMI :PNEXT
 LDX PNSCENARIO
 INC PARTIES-1,X
 JSR :DOLEADS ;Add up exp from characters in this party
 LDX #3
]LOOP2 LDA :EXP,X
 STA PNEXP,X
 DEX
 BPL ]LOOP2
 LDX :PRECS
 LDA #0
 JSR SAVEPN
 LDA PNSCENARIO
 DEC
 ASL
 ASL
 TAX
 LDY #0
]LOOP2 LDA LEADEXP,X
 STA :TEMP,Y
 INX
 INY
 CPY #4
 BNE ]LOOP2
 LDX #3 ;This party exp > current amount?
]LOOP2 LDA :EXP,X
 CMP :TEMP,X
 BEQ :CHK2
 BCC :PNEXT ;No.. less
 BCS :UBET ;Yes
:CHK2 DEX
 BPL ]LOOP2
 BRA :PNEXT ;Exactly the same.. tough luck buster!

:UBET LDA PNSCENARIO ;Update amount and party number (leader)
 DEC
 ASL
 ASL
 TAX
 LDY #0
]LOOP2 LDA :EXP,Y
 STA LEADEXP,X
 INX
 INY
 CPY #4
 BNE ]LOOP2
 LDX PNSCENARIO
 LDA :PRECS
 STA LEADPRTY-1,X
:PNEXT DEC :PRECS
 JMP ]LOOP

:PNDONE JMP :START2

:PRECS DS 1
:TEMP DS 4

:DOLEADS STZ :REC
 STZ :REC+1
 LDX #0
 LDA #0
 JSR LOADPLR
 LDA PLRBUFF
 STA :PLRS
 LDA PLRBUFF+1
 STA :PLRS+1
 STZ :EXP
 STZ :EXP+1
 STZ :EXP+2
 STZ :EXP+3
]LOOP LDA :REC+1
 CMP :PLRS+1
 BNE :LOAD
 LDA :REC
 CMP :PLRS
 BEQ :DONE
:LOAD INCR :REC
 LDX :REC
 LDA :REC+1
 JSR LOADPLR
 LDA PLRFREE
 BMI :NUP
 LDA PLRPARTY ;Same party?
 CMP :PRECS
 BNE :NUP
 LDA PLRCOND ;Don't count if they're dead
 AND #%1000_0000
 BNE :NUP
 LDA PLRPASSAULTS ;..nor if any pending offences
 ORA PLRPASSAULTS+1
 ORA PLRPKILLS
 ORA PLRPKILLS+1
 BNE :NUP
 CLC
 XCE
 REP #$30
 LDA :EXP
 CLC
 ADC PLREXP
 STA :EXP
 LDA :EXP+2
 ADC PLREXP+2
 STA :EXP+2
 SEC
 XCE
:NUP JMP ]LOOP
:DONE RTS

:REC DS 2
:PLRS DS 2

:EXP DS 4 ;Current party exp

CLRBOT JSR PRINT
 GOTOXY 0;22
 LUP 7
 ZAPLINE
 CURSORUP
 --^
 ZAPLINE
 NULL
 RTS

DISPLAYFLAG DS 1

 LST ON
MODEND EQU *
 LST OFF

 do M16PLUS
 SAV RUN/MODULES/GAME.CHKEXP
 fin

 END
