*-------------------------------
* GAME.GOODBYE
*-------------------------------
 DAT
 LST OFF

 ORG $8000 ;Always

 USE MACROS
 USE EQUATES
 USE VARS
 USE LIB.JMP

 TYP $F4
 do M16PLUS-1
 DSK RUN/MODULES/GAME.GOODBYE
 fin

 MODID "GAME.GOODBYE"

START JSR PRINT
 SOUND RESET
 MTOFF
 NORMAL
 COLOR WHITE
 CURSORON
 HOME
 NULL

 BIT SYSOPFLAG
 BPL :OK
 JSR POPMOD
 EXEC "GAME.SYSOP"

:OK JSR PRINT
 SOUND $14;1;LOUD
 LINE "Thanks for calling."
 CR
 ASC "** "
 COLOR PINK
 ASC "Note"
 COLOR WHITE
 ASC " ** "
 COLOR YELLOW
 ASC "-"
 COLOR WHITE
 ASC " next turn commences in "
 NULL
 JSR TILLNEXT
 JSR PRINT
 LINE "."
 CR
 LINE "Goodbye."
 SOUND RESET
 NULL

 BIT DUMBTERM
 BMI :NOSPEC

 LDA TPSUPPORT
 AND #%1000_0000 ;IIgs special?
 BEQ :NOSPEC

 LDA #ENDSESSIONBYTE ;Tell TP the session is terminated
 JSR MSENDBYTE
 LDA #$01 ;Terminate
 JSR MSENDBYTE
 LDA #$01
 EOR #$FF
 JSR MSENDBYTE
 PAUSE 4
 RETURN

:NOSPEC PAUSE 4
 RETURN

TILLNEXT MLI_GET_TIME
 LDA #23
 STA :TURNHOUR
 LDA #59
 STA :TURNMIN
 LDA DAYSTOGO
 BNE :NOX
 BIT XTRATIME
 BPL :NOX
 LDA TURNTIME+1
 DEC
 BPL :THOK
 LDA #23
:THOK STA :TURNHOUR
 LDA TURNTIME
 DEC
 BPL :TMOK
 LDA #59
:TMOK STA :TURNMIN
:NOX LDA DAYSTOGO
 BEQ :TIME
 DEC
:TIME STA :DAYS
 LDA :TURNMIN
 SEC
 SBC $BF92
 STA :MM
 LDA :TURNHOUR
 SBC $BF93
 STA :HH
 LDA :SS
 CMP #60
 BNE :OKX
 STZ :SS
 INC :MM
 LDA :MM
 CMP #60
 BNE :OKX
 STZ :MM
 INC :HH
:OKX BIT XTRATIME
 BPL :SAYIT
 LDA DAYSTOGO
 BEQ :SAYIT
 LDA :MM
 CLC
 ADC TURNTIME
 STA :MM
 CMP #60
 BCC :OK
 SBC #60
 STA :MM
 INC :HH
:OK LDA :HH
 CLC
 ADC TURNTIME+1
 STA :HH
 CMP #24
 BCC :SAYIT
 SBC #24
 STA :HH
 INC :DAYS
:SAYIT JSR :GETIME
 CMP WAITDAY
 BEQ :SAYIT2
 DEC :DAYS
:SAYIT2 LDA :DAYS
 BEQ :HRS
 BMIL :NOW
 JSR PRINT
 COLOR YELLOW
 DEC8 :DAYS
 COLOR WHITE
 ASC " days"
 NULL
:HRS LDA :HH
 BEQ :MINS
 LDA :DAYS
 BEQ :HRS2
 JSR PRINT
 ASC ", "
 NULL
:HRS2 JSR PRINT
 COLOR YELLOW
 PAD2 :HH
 COLOR WHITE
 ASC " hours"
 NULL
:MINS LDA :MM
 BEQ :SECS
 LDA :DAYS
 ORA :HH
 BEQ :MINS2
 JSR PRINT
 ASC ", "
 NULL
:MINS2 JSR PRINT
 COLOR YELLOW
 PAD2 :MM
 COLOR WHITE
 ASC " minutes"
 NULL
:SECS LDA :SS
 BEQ :END
 LDA :DAYS
 ORA :HH
 ORA :MM
 BEQ :SECS2
 JSR PRINT
 ASC ", "
 NULL
:SECS2 JSR PRINT
 COLOR YELLOW
 PAD2 :SS
 COLOR WHITE
 ASC " seconds"
 CLEOL
 NULL
:END RTS

:NOW JSR PRINT
 CLEOL
 COLOR PINK
 ASC "<none>"
 COLOR WHITE
 NULL
 RTS

:DAYS DS 1
:HH DS 1
:MM DS 1
:SS DS 1

:TURNHOUR DS 1
:TURNMIN DS 1

:GETIME CLC
 XCE
 REP #$30
 PushWord #0
 PushWord #0
 PushWord #0
 PushWord #0
 Tool $0D03 ;ReadTimeHex
 PLA
 PLA
 PLA
 SEC
 XCE
 PLA
 PLA
 RTS

 LST ON
MODEND EQU *
 LST OFF

 do M16PLUS
 SAV RUN/MODULES/GAME.GOODBYE
 fin

 END
