*-------------------------------
* GAME.HELP
*-------------------------------
 DAT
 LST OFF

 ORG $8000 ;Always

 USE MACROS
 USE EQUATES
 USE VARS
 USE LIB.JMP
 USE GLOSS.DSECT
 USE SPELL.DSECT
 USE SD.DSECT

 TYP $F4
 do M16PLUS-1
 DSK RUN/MODULES/GAME.HELP
 fin

 MODID "GAME.HELP"

NUMOPT = 20

ENTRY MAC
HERE STR ]1
 DS HERE-*+]LEN+1
 <<<

START JSR PRINT
 HOME
 SOUND $22;FOREVER;$80
 CURSOROFF
 INVERSE
 COLOR YELLOW
 ZAPLINE
 COLOR WHITE
 NORMAL
 CENTER " Help "
 GOTOXY 0;21
 INVERSE
 COLOR YELLOW
 ZAPLINE
 NORMAL
 GOTOXY 0;2
 COLOR WHITE
 CURSORON
 LINE "  Adventuring"
 LINE "  Combat"
 LINE "  Character classes"
 LINE "  Creating characters"
 LINE "  Dungeon"
 LINE "  Editing messages"
 LINE "  Inspect"
 LINE "  Items"
 LINE "  Jail system"
 LINE "  Look"
 LINE "  Message base"
 LINE "  Movement"
 LINE "  The Church"
 LINE "  The Inn"
 LINE "  The Registry"
 LINE "  The Shoppe"
 LINE "  Tips for beginners"
 LINE "  Spell casting"
 GOTOXY 42;2
 ASC "Spells (specific)"
 GOTOXY 42;3
 ASC "<Glossary>"
 GOTOXY 0;23
 ASC "Use arrow keys to move pointer, [RETURN]-view file, "
 ASC "[ESC]-exit : "
 NULL
 LDA CH
 STA BOTCH+2

]TOPLOOP JSR DOPOINT

 JSR PRINT
BOTCH GOTOXY 0;23
 NULL

]LOOP JSR KEYIN
 CMP #"J"-$40
 BEQ :DOWN
 CMP #"K"-$40
 BEQ :UP
 CMP #$8D
 BEQ :CR
 CMP #$9B
 BNE ]LOOP
 JMP EXIT

:UP LDA PNTR
 CMP #1
 BNE :UPOK
 LDA #NUMOPT+1
:UPOK DEC
 STA PNTR
 JMP ]TOPLOOP

:DOWN LDA PNTR
 CMP #NUMOPT
 BNE :DOWNOK
 LDA #0
:DOWNOK INC
 STA PNTR
 JMP ]TOPLOOP

:CR LDA PNTR
 CMP #NUMOPT
 BEQL GLOSS
 CMP #NUMOPT-1
 BEQL SPDESC
 LDA PNTR
 DEC
 ASL
 TAX
 LDA FILENAME,X
 STA CADD3
 LDA FILENAME+1,X
 STA CADD3+1
 LDY #0
 LDA (CADD3),Y
 STA :LEN
 CLC
 ADC #5
 STA FNAME
]LOOP INY
 LDA (CADD3),Y
 STA FNAME+5,Y
 CPY :LEN
 BNE ]LOOP
 INY
 LDA #$60 ;RTS
 STA FNAME+5,Y
 LDA PNTR
 DEC
 ASL
 TAX
 LDA HELPNAME,X
 STA CADD3
 LDA HELPNAME+1,X
 STA CADD3+1
 LDY #0
 LDA (CADD3),Y
 STA :LEN
]LOOP INY
 LDA (CADD3),Y
 STA :NAME-1,Y
 CPY :LEN
 BNE ]LOOP
 JSR PRINT
 HOME
 ASC "Help : "
 COLOR YELLOW
 PRSTRING :LEN
 COLOR WHITE
 GOTOXY 0;2
 NULL
 JSR SHOW
 JSR PRINT
 GOTOXY 0;23
 COLOR PINK
 NULL
 GETRETURN
 JMP START
:LEN DS 1
:NAME DS 63

SHOW JSR GETFILE
 DFB 2,22 ;Use lines x to y
FNAME STR "HELP/XXXXXXXXXXXXXXX"
 RTS

EXIT JSR PRINT
 HOME
 NULL
 RETURN

HELPNAME DA :H1
 DA :H2
 DA :H3
 DA :H4
 DA :H5
 DA :H6
 DA :H7
 DA :H8
 DA :H9
 DA :H10
 DA :H11
 DA :H12
 DA :H13
 DA :H14
 DA :H15
 DA :H16
 DA :H17
 DA :H18
 DA :H19
 DA :H20

:H1 STR "Adventuring"
:H2 STR "Combat"
:H3 STR "Character classes"
:H4 STR "Creating characters"
:H5 STR "Dungeon"
:H6 STR "Editing messages"
:H7 STR "Inspect"
:H8 STR "Items"
:H9 STR "Jail system"
:H10 STR "Look"
:H11 STR "Message base"
:H12 STR "Movement"
:H13 STR "The Church"
:H14 STR "The Inn"
:H15 STR "The Registry"
:H16 STR "The Shoppe"
:H17 STR "Beginner tips"
:H18 STR "Spell casting"
:H19 STR "Spells"
:H20 STR "<Glossary>"

FILENAME DA :F1
 DA :F2
 DA :F3
 DA :F4
 DA :F5
 DA :F6
 DA :F7
 DA :F8
 DA :F9
 DA :F10
 DA :F11
 DA :F12
 DA :F13
 DA :F14
 DA :F15
 DA :F16
 DA :F17
 DA :F18
 DA :F19
 DA :F20

:F1 STR "ADVENTURING"
:F2 STR "COMBAT"
:F3 STR "CLASSES"
:F4 STR "CREATE.CHAR"
:F5 STR "DUNGEON"
:F6 STR "MSG.EDIT"
:F7 STR "INSPECT"
:F8 STR "ITEMS"
:F9 STR "JAIL.SYSTEM"
:F10 STR "LOOK"
:F11 STR "MSG.BASE"
:F12 STR "MOVE"
:F13 STR "CHURCH"
:F14 STR "INN"
:F15 STR "REGISTRY"
:F16 STR "SHOPPE"
:F17 STR "TIPS.BEGINNERS"
:F18 STR "SPELLS"
:F19 STR "SPELL.DESCR"
:F20 STR "GLOSSARY"

GLOSS JSR PRINT
 GOTOXY 0;2
 COLOR WHITE
 CLEOS
 ASC "Enter glossary word ['*'=index] : "
 NULL
 GETLINE #15
 CPX #0
 BEQL START
 CPX #1
 BNE :NOT1
 LDA $200
 CMP #"*"
 BNE :NOT1
 JMP GLINDEX
:NOT1 STX :WORD
]LOOP LDA $200-1,X
 JSR UPPER
 STA :WORD,X
 DEX
 BNE ]LOOP
 JSR PRINT
 CR
 ASC "Searching.."
 NULL
 JSR LOADSLICE
 STR "HELP/GLOSSARY"
 DA MISCBUFF
 DA 0
 DA GLRECLEN ;Record length
 LDA MISCBUFF
 STA :RECS
 LDA MISCBUFF+1
 STA :RECS+1
]LOOP LDA :RECS+1
 ORA :RECS
 BEQ :NO
 JSR LOADSLICE
 STR "HELP/GLOSSARY"
 DA MISCBUFF
:RECS DA 0
 DA GLRECLEN ;Record length
 LDX GLWORD
 CPX #0
 BEQ :NEXT
 CPX :WORD
 BNE :NEXT
]LOOP2 LDA GLWORD,X
 JSR UPPER
 CMP :WORD,X
 BNE :NEXT
 DEX
 BNE ]LOOP2
 BRA :FOUND
:NEXT DECR :RECS
 BRA ]LOOP
:NO JSR PRINT
 COLOR PINK
 ASC " not found. "
 COLOR WHITE
 NULL
 GETRETURN
 JMP GLOSS
:FOUND JSR PRINT
 GOTOXY 0;2
 CLEOS
 QUOTE
 COLOR AQUAMARINE
 PRSTRING GLWORD
 COLOR WHITE
 QUOTE
 NULL
 LDX GLLEN ;Length
 LDA GLLEN+1
 JSR SHOWMSG
 DFB 4,22 ;Lines to use (top, bottom)
 DA GLTEXT
 JSR PRINT
 GOTOXY 0;23
 COLOR PINK
 NULL
 GETRETURN
 JMP GLOSS
:WORD DS 1+15

GLINDEX JSR PRINT
 GOTOXY 0;2
 CLEOS
 LINE "Glossary Index"
 CR
 NULL
 JSR LOADSLICE
 STR "HELP/GLOSSARY"
 DA MISCBUFF
 DA 0
 DA GLRECLEN ;Record length
 LDA MISCBUFF
 STA :RECS
 LDA MISCBUFF+1
 STA :RECS+1
 LDA :RECS
 ORA :RECS+1
 BNE :OK
 JSR PRINT
 COLOR PINK
 ASC "No words in glossary. "
 COLOR WHITE
 NULL
 GETRETURN
 JMP START
:OK STZ :REC
 STZ :REC+1
]LOOP LDA :REC+1
 CMP :RECS+1
 BNE :READ
 LDA :REC
 CMP :RECS
 BEQL :DONE
:READ INCR :REC
 JSR LOADSLICE
 STR "HELP/GLOSSARY"
 DA MISCBUFF
:REC DA 0
 DA GLRECLEN ;Record length
 LDX GLWORD
 CPX #0
 BEQ ]LOOP
 JSR PRINT
 DEC16 :REC
 HTAB 6
 PRSTRING GLWORD
 CR
 NULL
 LDA CV
 CMP #22
 BNE ]LOOP
 JSR PRINT
 VTAB 23
 COLOR PINK
 CENTER "[SPACE]-continue, [ESC]-exit"
 COLOR WHITE
 NULL
]LOOP2 JSR KEYIN
 CMP #$9B
 BEQ :EXIT
 CMP #" "
 BNE ]LOOP2
 JSR PRINT
 GOTOXY 0;4
 CLEOS
 NULL
 JMP ]LOOP
:DONE JSR PRINT
 GOTOXY 0;23
 COLOR PINK
 NULL
 GETRETURN
:EXIT JMP GLOSS
:RECS DS 2

DOPOINT LDA OLDPNTR
 CMP #19
 BCC :PLEFT
 LDA #40
 STA :CHV+2
 LDA OLDPNTR
 SEC
 SBC #17
 STA :CHV+3
 BRA :DOP1
:PLEFT STZ :CHV+2
 LDA OLDPNTR
 CLC
 ADC #1
 STA :CHV+3
:DOP1 JSR PRINT
 NORMAL
 MTOFF
:CHV GOTOXY 0;0
 ASC " "
 NULL
 LDA PNTR
 CMP #19
 BCC :PLEFT2
 LDA #40
 STA :CHV2+2
 LDA PNTR
 SEC
 SBC #17
 STA :CHV2+3
 BRA :DOP2
:PLEFT2 STZ :CHV2+2
 LDA PNTR
 CLC
 ADC #1
 STA :CHV2+3
:DOP2 JSR PRINT
:CHV2 GOTOXY 0;0
 NULL
 JSR SHOWPNTR
 LDA PNTR
 STA OLDPNTR
 RTS
PNTR DA 1
OLDPNTR DS 1

SPDESC JSR PRINT
 GOTOXY 0;2
 COLOR WHITE
 CLEOS
 ASC "Enter spell name ['*'=index] : "
 NULL
 GETLINE #15
 CPX #0
 BEQL START
 CPX #1
 BNE :NOT1
 LDA $200
 CMP #"*"
 BNE :NOT1
 JMP :INDEX
:NOT1 STX :SPELL
]LOOP LDA $200-1,X
 JSR UPPER
 STA :SPELL,X
 DEX
 BNE ]LOOP
 LDX #0
 LDA #0
 JSR LOADSPELL
 LDA SPELLBUFF
 STA TOTSPELLS
 STZ :CNTR
]LOOP INC :CNTR
 LDX :CNTR
 LDA #0
 JSR LOADSPELL
 LDA SPNAME+1
 CMP #"?" ;Spell doesn't exist
 BEQ :NEXT
 LDX #0
]LOOP2 LDA :SPELL+1,X
 CMP SPNAME+1,X
 BNE :NEXT
 INX
 CPX :SPELL
 BNE ]LOOP2
 CPX SPNAME
 BNE :NEXT
 LDA :CNTR
 JMP :GOTIT
:NEXT LDA :CNTR
 CMP TOTSPELLS
 BNE ]LOOP
 JSR PRINT
 CR
 COLOR PINK
 ASC "Not found. "
 COLOR WHITE
 NULL
 GETRETURN
 JMP SPDESC
:GOTIT JSR PRINT
 GOTOXY 0;2
 CLEOS
 ASC "Spell : "
 COLOR AQUAMARINE
 PRSTRING SPNAME
 COLOR WHITE
 ASC " ("
 NULL
 LDA :CNTR
 LSR
 LSR
 LSR
 LSR
 LSR
 INC
 STA :TYPE
 LDA :CNTR
]LOOP CMP #33
 BCC :LOK
 SEC
 SBC #32
 BRA ]LOOP
:LOK DEC
 LSR
 LSR
 INC
 STA :LVL
 JSR PRINT
 ASC "Level "
 DEC8 :LVL
 ASC " / "
 PRTABLE :TYPE;:TABLE
 LINE ")"
 CR
 NULL
 JSR LOADSLICE
 STR "HELP/SPELL.DESCR"
 DA MISCBUFF
:CNTR DA 0
 DA SDRECLEN
 LDX SDLEN ;Length
 LDA SDLEN+1
 JSR SHOWMSG
 DFB 4,20 ;Lines to use (top, bottom)
 DA SDTEXT
 JSR PRINT
 GOTOXY 0;23
 COLOR PINK
 NULL
 GETRETURN
 JMP SPDESC
:INDEX JSR PRINT
 GOTOXY 0;2
 COLOR WHITE
 CLEOS
 ASC "[W]izard, [C]leric or [S]age : "
 NULL
]LOOP JSR KEYIN
 JSR UPPER
 CMP #$9B
 BEQL SPDESC
 CMP #"W"
 BEQ :SPW
 CMP #"C"
 BEQ :SPC
 CMP #"S"
 BEQ :SPS
 BRA ]LOOP
:SPW LDX #1
 HEX 2C
:SPC LDX #2
 HEX 2C
:SPS LDX #3
 STX :TYPE
 LDA #0
]LOOP DEX
 CPX #0
 BEQ :SHOWSP
 CLC
 ADC #32 ;32 spells per class
 BRA ]LOOP
:SHOWSP STA :CNTR
 JSR PRINT
 GOTOXY 0;2
 CLEOS
 PRTABLE :TYPE;:TABLE
 ASC " spells"
 NULL
 STZ :CNTR2
]LOOP JSR PRINT
 GOTOXY 0;4
 CLEOS
 NULL
]LOOP2 INC :CNTR
 LDA :CNTR2
 CMP #32
 BEQL :BOT
 LDX :CNTR
 LDA :CNTR+1
 JSR LOADSPELL
 INC :CNTR2
 LDA SPNAME+1
 CMP #"?"
 BEQ ]LOOP2
 LDA :CNTR
 DEC
 AND #%0000_0011
 BNE :NONUM
 LDA :CNTR2
 DEC
 LSR
 LSR
 INC
 ORA #"0"
 HEX 2C
:NONUM LDA #" "
 JSR COUT
 JSR PRINT
 ASC "  "
 NULL
 JSR PRINT
 PRSTRING SPNAME
 CR
 NULL
 LDA CV
 CMP #20
 BCC ]LOOP2
 JSR PRINT
 VTAB 23
 COLOR PINK
 CENTER "[SPACE]-continue, [ESC]-exit"
 COLOR WHITE
 NULL
]LOOP3 JSR KEYIN
 CMP #$9B
 BEQL :INDEX
 CMP #" "
 BNE ]LOOP3
 JMP ]LOOP
:BOT JSR PRINT
 GOTOXY 0;23
 COLOR PINK
 NULL
 GETRETURN
 JMP :INDEX
:SPELL DS 1+15
:TYPE DS 1
:LVL DS 1
:CNTR2 DS 1

]LEN = 16
:TABLE DFB ]LEN
 ENTRY "<none>"
 ENTRY "Wizard"
 ENTRY "Cleric"
 ENTRY "Sage"

TOTSPELLS DS 1

 LST ON
MODEND EQU *
 LST OFF

 do M16PLUS
 SAV RUN/MODULES/GAME.HELP
 fin

 END
