*-------------------------------
* GAME.JAIL
*-------------------------------
 DAT
 LST OFF

 ORG $8000 ;Always

 USE MACROS
 USE EQUATES
 USE VARS
 USE LIB.JMP
 USE PLR.DSECT
 USE PN.DSECT

 TYP $F4
 do M16PLUS-1
 DSK RUN/MODULES/GAME.JAIL
 fin

 MODID "GAME.JAIL"

KPMAX = 4

START JSR PRINT
 NORMAL
 MTOFF
 HOME
 SOUND $22;FOREVER;$50
 CURSOROFF
 INVERSE
 COLOR YELLOW
 ZAPLINE
 COLOR WHITE
 NORMAL
 CENTER " Towne Jail "
 GOTOXY 0;10
 INVERSE
 COLOR YELLOW
 ZAPLINE
 NORMAL
 GOTOXY 10;2
 COLOR WHITE
 CURSORON
 HTAB 10
 LINE "List of 'residents'"
 CR
 HTAB 10
 LINE "Bail out someone"
 CR
 HTAB 10
 LINE "Pool/Share gold"
 CR
 HTAB 10
 LINE "Leave"
 GOTOXY 0;23
 CENTER "Use arrow keys to move pointer; [RETURN] to make selection."
 CURSOROFF
 NULL

DOKEY JSR DOPOINT

]LOOP JSR KEYIN
 JSR UPPER
 LDX :KEYS
]LOOP2 CMP :KEYS,X
 BEQ :GOTONE
 DEX
 BNE ]LOOP2
 LDX PNTR
 LDY #KPMAX
 JSR KPCHECK
 BCC ]LOOP
 STX PNTR
 BRA DOKEY
:GOTONE DEX
 TXA
 ASL
 TAX
 JMP (:TABLE,X)

:KEYS DFB :ENDKEYS-*-1
 DFB "K"-$40
 DFB "J"-$40
 DFB "M"-$40
:ENDKEYS

:TABLE DA UP
 DA DOWN
 DA DONE

UP LDA PNTR
 BNE :OK
 LDA #KPMAX
:OK DEC
 STA PNTR
 JMP DOKEY

DOWN LDA PNTR
 CMP #KPMAX-1
 BNE :OK
 LDA #$FF
:OK INC
 STA PNTR
 JMP DOKEY

DONE JSR PRINT
 CURSORLEFT
 ASC "x"
 NULL
 LDA PNTR
 ASL
 TAX
 JMP (:OPTIONS,X)

:OPTIONS DA LIST
 DA BAIL
 DA POOL
 DA LEAVE

DOPOINT LDA OLDPNTR
 ASL
 CLC
 ADC #2
 STA :CV+2
 JSR PRINT
 NORMAL
 MTOFF
 HTAB 8
:CV VTAB 0
 ASC " "
 NULL
 LDA PNTR
 ASL
 CLC
 ADC #2
 STA :CV2+2
 JSR PRINT
 HTAB 8
:CV2 VTAB 0
 NULL
 JSR SHOWPNTR
 LDA PNTR
 STA OLDPNTR
 RTS
PNTR DS 1
OLDPNTR DS 1

LEAVE JSR PRINT
 HOME
 CURSORON
 NULL
 RETURN

BAIL JSR PRINT
 GOTOXY 0;12
 CLEOS
 CURSORON
 NULL
 LDX NUMPARTY
]LOOP LDA CURPARTY-1,X
 ORA CURPARTY2-1,X
 BNE :HEREOK
 DEX
 BNE ]LOOP
 JSR PRINT
 COLOR PINK
 ASC "No-one here to bail someone out. "
 COLOR WHITE
 NULL
 GETRETURN
 JSR PRINT
 CURSOROFF
 ZAPLINE
 NULL
 JMP DOKEY
:HEREOK STZ :CNTR
 LDX NUMPARTY
]LOOP LDA PARTY-1,X
 ORA PARTY2-1,X
 BEQ :NEXT
 PHX
 LDA PARTY2-1,X
 TAY
 LDA PARTY-1,X
 TAX
 TYA
 JSR LOADPLR
 BIT PLRARRESTFLAG
 BVC :CLEAN
 PLY
 PHY
 LDA :CNTR
 ASL
 TAX
 LDA PARTY-1,Y
 STA :TABLE,X
 LDA PARTY2-1,Y
 STA :TABLE+1,X
 INC :CNTR
 JSR CALCBAIL
 JSR PRINT
 HTAB 20
 DEC8 :CNTR
 ASC ") "
 PRSTRING PLRNAME
 HTAB 50
 COLOR YELLOW
 DEC16 BAILAMT
 COLOR WHITE
 CR
 NULL
:CLEAN PLX
:NEXT DEX
 BNE ]LOOP
 LDA :CNTR
 BNE :SOME
 JSR PRINT
 COLOR AQUAMARINE
 ASC "None of your party members are in jail. "
 COLOR WHITE
 NULL
 GETRETURN
 JSR PRINT
 CURSOROFF
 ZAPLINE
 NULL
 JMP DOKEY
:SOME CMP NUMPARTY
 BNE :NOTALL
 JSR PRINT
 COLOR PINK
 ASC "ALL party members are in jail. "
 COLOR WHITE
 NULL
 GETRETURN
 JSR PRINT
 CURSOROFF
 ZAPLINE
 NULL
 JMP DOKEY
:NOTALL JSR PRINT
 GOTOXY 0;12
 ASC "Bail (1-"
 DEC8 :CNTR
 ASC ")? : "
 NULL
]LOOP JSR KEYIN
 CMP #$9B
 BEQ :ESC
 SEC
 SBC #"1"
 CMP :CNTR
 BCS ]LOOP
 ASL
 TAX
 LDA :TABLE,X
 STA :REC
 LDA :TABLE+1,X
 STA :REC+1
 LDX :REC
 LDA :REC+1
 JSR LOADPLR
 JSR CALCBAIL
 JSR PRINT
 GOTOXY 0;12
 CLEOS
 ASC "Bail out "
 COLOR GREEN
 PRSTRING PLRNAME
 COLOR WHITE
 ASC " for "
 COLOR YELLOW
 DEC16 BAILAMT
 COLOR WHITE
 ASC " GP (y/n)? : "
 NULL
]LOOP JSR KEYIN
 JSR UPPER
 CMP #"Y"
 BEQ :YES
 CMP #"N"
 BEQ :ESC
 CMP #$9B
 BNE ]LOOP
:ESC JSR PRINT
 GOTOXY 0;12
 CLEOS
 CURSOROFF
 NULL
 JMP DOKEY

:YES JSR PRINT
 ASC "Yes"
 NULL
 LDX NUMPARTY
]LOOP LDA CURPARTY-1,X
 ORA CURPARTY2-1,X
 BNE :YEHOK
 DEX
 BNE ]LOOP
:YEHOK STX :PLRS
 STZ :CASH
 STZ :CASH+1
 STZ :CASH+2
 STZ :CASH+3
 STZ :FLAG
]LOOP PHX
 LDA CURPARTY-1,X
 TAY
 LDA CURPARTY2-1,X
 TYX
 JSR LOADPLR
 LDA PLRZPOS ;Must be in the Castle
 BNE :C2
 CLC
 XCE
 REP #$30
 LDA :CASH
 CLC
 ADC PLRGOLD
 STA :CASH
 LDA :CASH+2
 ADC PLRGOLD+2
 STA :CASH+2
 BCC :C2
 LDA #$FFFF
 STA :FLAG
:C2 SEC
 XCE
 PLX
 DEX
 BNE ]LOOP

 LDA :FLAG
 BNE :CANPAY
 LDX #3
]LOOP LDA BAILAMT,X
 CMP :CASH,X
 BEQ :MAYBE
 BCC :CANPAY
 BCS :CANTPAY
:MAYBE DEX
 BPL ]LOOP
 BRA :CANPAY

:CANTPAY JSR PRINT
 GOTOXY 0;12
 CLEOS
 COLOR PINK
 ASC "Party has only "
 COLOR YELLOW
 DEC32 :CASH
 COLOR PINK
 ASC " GP. "
 SOUND $25;1;$80
 COLOR WHITE
 NULL
 GETRETURN
 JMP :ESC

:CANPAY LDX :REC
 LDA :REC+1
 JSR LOADPLR
 JSR PRINT
 GOTOXY 0;12
 CLEOS
 COLOR AQUAMARINE
 PRSTRING PLRNAME
 ASC " has been bailed out. "
 COLOR WHITE
 NULL
 STZ PLRJAILDAYS
 LDA #%0100_0000
 TRB PLRARRESTFLAG
 STZ PLRPKILLS
 STZ PLRPASSAULTS
 NOTELOGSTR $E;"Character bailed out of jail : ";PLRNAME
 PNOTELOGSTR $E;"Bailed out of jail : ";PLRNAME
 LDX :REC
 LDA :REC+1
 JSR SAVEPLR
 STZ :FLAG
 LDX #0
]LOOP PHX
 LDA CURPARTY,X
 STA :REC
 LDA CURPARTY2,X
 STA :REC+1
 LDX :REC
 LDA :REC+1
 JSR LOADPLR
 LDA PLRZPOS
 BNE :NXTG2
 CLC
 XCE
 REP #$30
 LDA PLRGOLD+2
 CMP BAILAMT+2
 BEQ :G2
 BCS :ENUFF
 BCC :SCAB
:G2 LDA PLRGOLD
 CMP BAILAMT
 BCS :ENUFF
:SCAB LDA BAILAMT
 SEC
 SBC PLRGOLD
 STA BAILAMT
 LDA BAILAMT+2
 SBC PLRGOLD+2
 STA BAILAMT+2
 STZ PLRGOLD
 STZ PLRGOLD+2
 BRA :NXTG
:ENUFF LDA PLRGOLD
 SEC
 SBC BAILAMT
 STA PLRGOLD
 LDA PLRGOLD+2
 SBC BAILAMT+2
 STA PLRGOLD+2
 LDA #$FFFF
 STA :FLAG
:NXTG SEC
 XCE
 LDX :REC
 LDA :REC+1
 JSR SAVEPLR
:NXTG2 PLX
 LDA :FLAG
 BNE :DONEG
 INX
 CPX :PLRS
 BNE ]LOOP
:DONEG GETRETURN
 JMP :ESC

:REC DS 2
:CNTR DS 1
:TABLE DS 8*2
:CASH DS 4
:FLAG DS 2
:PLRS DS 1

LIST JSR PRINT
 GOTOXY 0;12
 CLEOS
 CURSORON
 ASC "Name"
 HTAB 21
 ASC "Party"
 HTAB 42
 ASC "Offense"
 HTAB 58
 LINE "Days left   Bail"
 NULL
 LDX PARTYNUM
 LDA #0
 JSR LOADPN
 LDA PNSCENARIO
 STA :SCEN
 STZ :INSIDE
 STZ :INSIDE+1
 LDX #0
 LDA #0
 JSR LOADPLR
 LDA PLRBUFF
 STA :RECS
 LDA PLRBUFF+1
 STA :RECS+1
 STZ :REC
 STZ :REC+1
]LOOP LDA :REC+1
 CMP :RECS+1
 BNE :OK
 LDA :REC
 CMP :RECS
 BEQL :DONE
:OK INCR :REC
 LDX :REC
 LDA :REC+1
 JSR LOADPLR
 BIT PLRFREE
 BMI ]LOOP
 BIT PLRARRESTFLAG
 BVC ]LOOP
 LDA PLRSCENARIO
 CMP :SCEN
 BNE ]LOOP
 INCR :INSIDE
 LDX PLRPARTY
 LDA #0
 JSR LOADPN
 JSR PRINT
 COLOR ORANGE
 PRSTRING PLRNAME
 HTAB 21
 COLOR AQUAMARINE
 PRSTRING PNNAME
 COLOR WHITE
 HTAB 42
 NULL
 LDA PLRPKILLS
 BEQ :NOK
 JSR PRINT
 COLOR PINK
 ASC "murder"
 COLOR WHITE
 NULL
:NOK LDA PLRPASSAULTS
 BEQ :NOASS
 LDA PLRPKILLS
 BEQ :ASS2
 JSR PRINT
 ASC ", "
 NULL
:ASS2 JSR PRINT
 COLOR YELLOW
 ASC "assault"
 COLOR WHITE
 NULL
:NOASS LDA PADFLAG
 PHA
 LDA PADCHAR
 PHA
 LDA #$FF
 STA PADFLAG
 LDA #" "
 STA PADCHAR
 JSR CALCBAIL
 JSR PRINT
 HTAB 61
 COLOR YELLOW
 DEC8 PLRJAILDAYS
 HTAB 69
 COLOR GREEN
 DEC16 BAILAMT
 COLOR WHITE
 CR
 NULL
 PLA
 STA PADCHAR
 PLA
 STA PADFLAG
 LDA CV
 CMP #23
 BNEL ]LOOP
 JSR PRINT
 GOTOXY 0;23
 COLOR PINK
 CENTER "[SPACE]-continue, [ESC]-exit : "
 COLOR WHITE
 NULL
]LOOP2 JSR KEYIN
 CMP #" "
 BEQ :CLR
 CMP #$9B
 BNE ]LOOP2
:DONE JSR PRINT
 ZAPLINE
 COLOR WHITE
 NULL
 LDA :INSIDE
 ORA :INSIDE+1
 BNE :SOME
 JSR PRINT
 CR
 ASC "No-one in jail."
 NULL
:SOME LDX PARTYNUM
 LDA #0
 JSR LOADPN
 JSR PRINT
 CURSOROFF
 NULL
 JMP DOKEY
:CLR JSR PRINT
 GOTOXY 0;13
 CLEOS
 NULL
 JMP ]LOOP
:SCEN DS 1
:REC DS 2
:RECS DS 2
:INSIDE DS 2

CALCBAIL CLC
 XCE
 REP #$20
 SEP #$10
 LDX PLRJAILDAYS
 STZ BAILAMT
 STZ BAILAMT+2
]LOOP CPX #0
 BEQ :DONE
 LDA BAILAMT
 CLC
 ADC :BAIL
 STA BAILAMT
 LDA BAILAMT+2
 ADC #0
 STA BAILAMT+2
 DEX
 BRA ]LOOP
:DONE LDA BAILAMT
 CMP #500
 BCS :OK
 LDA #500
 STA BAILAMT
:OK SEC
 XCE
 RTS

:BAIL DA 100

BAILAMT DS 4

POOL JSR PRINT
 GOTOXY 0;12
 CLEOS
 CURSORON
 ASC "[P]ool, [S]hare, [ESC]-exit : "
 NULL
]LOOP JSR KEYIN
 JSR UPPER
 CMP #"P"
 BEQ :POOL2
 CMP #"S"
 BEQ SHARE
 CMP #$9B
 BNE ]LOOP
 JSR PRINT
 ZAPLINE
 CURSOROFF
 NULL
 JMP DOKEY
:POOL2 STZ POOLER
 JSR POOL2
 JMP DOKEY
POOLER DS 1
POOLPLRS DS 1

SHARE JSR PRINT
 GOTOXY 0;12
 CLEOS
 NULL
 LDX NUMPARTY
]LOOP LDA CURPARTY2-1,X
 BNE :OK
 LDA CURPARTY-1,X
 BNE :OK
 DEX
 BNE ]LOOP
:OK STX :PLRS
 CPX #0
 BNE :OK2
 JSR PRINT
 COLOR PINK
 ASC "No-one in the party. "
 SOUND $02;1;LOUD
 COLOR WHITE
 NULL
 GETRETURN
:EXIT JSR PRINT
 GOTOXY 0;12
 CLEOS
 CURSOROFF
 NULL
 JMP DOKEY
:OK2 CPX #1
 BEQ :EXIT
 JSR PRINT
 GOTOXY 0;12
 CLEOS
 ASC "Sharing.."
 NULL
 STZ :GOLD ;Get total gold from all players
 STZ :GOLD+1
 STZ :GOLD+2
 STZ :GOLD+3
 STZ :PLRSC
 LDX :PLRS
]LOOP STX VTEMP
 LDA CURPARTY-1,X
 TAY
 LDA CURPARTY2-1,X
 TYX
 JSR LOADPLR
 LDA PLRZPOS ;In Castle?
 BNE :NXTSHRE
 BIT PLRARRESTFLAG ;In jail?
 BVS :NXTSHRE
 INC :PLRSC
 CLC
 XCE
 REP #$30
 LDA :GOLD
 CLC
 ADC PLRGOLD
 STA :GOLD
 LDA :GOLD+2
 ADC PLRGOLD+2
 STA :GOLD+2
 SEC
 XCE
:NXTSHRE DEC VTEMP
 LDX VTEMP
 BNE ]LOOP

 CLC
 XCE
 REP #$30
 PushLong #0
 PushLong #0
 PushLong :GOLD ;Divide this..
 PushLong :PLRSC ;..by this..
 Tool $0D0B ;LongDivide
 PullLong :DIV ;..and get this..
 PullLong :REMAIN ;..and the remainder
 SEC
 XCE

 LDX :PLRS
]LOOP STX VTEMP
 LDA CURPARTY-1,X
 TAY
 LDA CURPARTY2-1,X
 TYX
 JSR LOADPLR
 LDA PLRZPOS ;In Castle?
 BNE :NXTDIVY
 BIT PLRARRESTFLAG ;In jail?
 BVS :NXTDIVY
 CLC
 XCE
 REP #$30
 LDA :DIV
 STA PLRGOLD
 LDA :DIV+2
 STA PLRGOLD+2
 LDA VTEMP
 CMP #1
 BNE :NOTP1
 LDA PLRGOLD
 CLC
 ADC :REMAIN
 STA PLRGOLD
 LDA PLRGOLD+2
 ADC :REMAIN+2
 STA PLRGOLD+2
:NOTP1 SEC
 XCE
 LDX VTEMP
 LDA CURPARTY-1,X
 TAY
 LDA CURPARTY2-1,X
 TYX
 JSR SAVEPLR
:NXTDIVY DEC VTEMP
 LDX VTEMP
 BNE ]LOOP

 JSR PRINT
 ZAPLINE
 HTAB 0
 ASC "Shared approx. "
 COLOR YELLOW
 DEC32 :DIV
 COLOR WHITE
 ASC " GP each (in Castle only)."
 CURSOROFF
 NULL
 JMP DOKEY

:PLRS DS 1
:PLRSC DS 4 ;For DIVISOR (LongDivide)
:GOLD DS 4 ;Total
:DIV DS 4 ;Shared amount for each player
:REMAIN DS 4 ;Remainder will go to first player

POOL2 JSR PRINT
 GOTOXY 0;12
 CLEOS
 NULL
 LDA POOLER
 BEQ :POOLZ
 LDA POOLPLRS
 STA :PLRS
 LDX POOLER
 JMP :FROMBUY
:POOLZ LDX NUMPARTY
]LOOP LDA CURPARTY2-1,X
 BNE :OK
 LDA CURPARTY-1,X
 BNE :OK
 DEX
 BNE ]LOOP
:OK STX :PLRS
 CPX #0
 BNE :OK2
 JSR PRINT
 COLOR PINK
 ASC "No-one in the party to pool gold to. "
 SOUND $02;1;LOUD
 COLOR WHITE
 NULL
 GETRETURN
:EXIT JSR PRINT
 GOTOXY 0;12
 CLEOS
 CURSOROFF
 NULL
 RTS
:OK2 CPX #1
 BEQ :EXIT
 JSR SHOWNAMES
 JSR PRINT
 ASC "Who will pool gold (1-"
 DEC8 :PLRS
 ASC ")? : "
 NULL
]LOOP JSR KEYIN
 CMP #$9B
 BEQ :EXIT
 SEC
 SBC #"1"
 CMP :PLRS
 BCS ]LOOP
 PHA
 CLC
 ADC #"1"
 JSR COUT
 PLX
:FROMBUY LDA CURPARTY,X
 STA :REC
 LDA CURPARTY2,X
 STA :REC+1

 LDX :REC
 LDA :REC+1
 JSR LOADPLR
 LDA PLRCOND
 AND #%1000_0000 ;Dead?
 BEQ :ALIVE
 JSR PRINT
 CR
 COLOR PINK
 PRSTRING PLRNAME
 ASC " is dead. "
 SOUND $13;1;LOUD
 COLOR WHITE
 NULL
 GETRETURN
 JMP POOL2
:ALIVE LDA PLRZPOS
 BEQ :CASTLE
 JSR PRINT
 CR
 COLOR PINK
 PRSTRING PLRNAME
 ASC " is not here. "
 SOUND $02;1;LOUD
 COLOR WHITE
 NULL
 GETRETURN
 JMP POOL2
:CASTLE JSR PRINT
 GOTOXY 0;12
 CLEOS
 ASC "Pooling.."
 CURSOROFF
 NULL

 LDX #3
]LOOP STZ :CASH,X
 DEX
 BPL ]LOOP

 LDX #0
]LOOP PHX
 LDA CURPARTY,X
 STA :REC2
 TAY
 LDA CURPARTY2,X
 STA :REC2+1
 TYX
 JSR LOADPLR
 LDA PLRZPOS ;Must be in Castle
 BNE :INDNG
 BIT PLRARRESTFLAG ;..and not in jail
 BVS :INDNG
 CLC
 XCE
 REP #$30
 LDA :CASH
 CLC
 ADC PLRGOLD
 STA :CASH
 LDA :CASH+2
 ADC PLRGOLD+2
 STA :CASH+2
 STZ PLRGOLD
 STZ PLRGOLD+2
 SEC
 XCE
 LDX :REC2
 LDA :REC2+1
 JSR SAVEPLR
:INDNG PLX
 INX
 CPX :PLRS
 BNE ]LOOP

 LDX :REC
 LDA :REC+1
 JSR LOADPLR
 LDX #3
]LOOP LDA :CASH,X
 STA PLRGOLD,X
 DEX
 BPL ]LOOP
 LDX :REC
 LDA :REC+1
 JSR SAVEPLR
 LDA POOLER
 BNE :POOLRTS
 JSR PRINT
 HTAB 0
 ZAPLINE
 CURSORON
 PRSTRING PLRNAME
 ASC " now has "
 COLOR YELLOW
 DEC32 PLRGOLD
 COLOR WHITE
 ASC " gold."
 CURSOROFF
 NULL
:POOLRTS RTS
:REC DS 2
:REC2 DS 2
:PLRS DS 1
:CASH DS 4

SHOWNAMES LDX NUMPARTY
]LOOP LDA CURPARTY2-1,X
 ORA CURPARTY-1,X
 BNE :OK
 DEX
 BNE ]LOOP
 RTS
:OK STX :TEMP
 LDA CH
 STA :HV+2
 LDA CV
 STA :HV+3
 STZ :NUM
 LDX #0
]LOOP PHX
 LDA CURPARTY,X
 TAY
 LDA CURPARTY2,X
 TYX
 JSR LOADPLR
 INC :NUM
 JSR PRINT
 HTAB 40
 DEC8 :NUM
 NULL
 LDA PLRZPOS
 BEQ :CASTLE
 JSR PRINT
 ASC ")"
 NULL
 BRA :CONT
:CASTLE JSR PRINT
 ASC ">"
 NULL
:CONT JSR PRINT
 ASC " "
 PRSTRING PLRNAME
 CR
 NULL
 PLX
 INX
 CPX :TEMP
 BNE ]LOOP
 JSR PRINT
:HV GOTOXY 0;0
 NULL
 RTS
:TEMP DS 1
:NUM DS 1

 LST ON
MODEND EQU *
 LST OFF

 do M16PLUS
 SAV RUN/MODULES/GAME.JAIL
 fin

 END
