*-------------------------------
* GAME.MESSAGE
*-------------------------------
 DAT
 LST OFF

 ORG $8000 ;Always

 USE MACROS
 USE EQUATES
 USE VARS
 USE LIB.JMP
 USE MSG.DSECT
 USE PN.DSECT

 TYP $F4
 do M16PLUS-1
 DSK RUN/MODULES/GAME.MESSAGE
 fin

 MODID "GAME.MESSAGE"

TOPLIN = 10
BOTLIN = 21

START JSR PRINT
 HOME
 SOUND RESET
 CURSOROFF
 COLOR ORANGE
 CENTER "Message Base"
 GOTOXY 0;9
 INVERSE
 COLOR YELLOW
 ZAPLINE
 GOTOXY 0;22
 ZAPLINE
 COLOR WHITE
 NORMAL
 NULL

 LDX #0
 LDA #0
 JSR LOADPN
 LDA PNBUFF
 STA PARTYS

 LDX #0
 LDA #0
 JSR LOADMSGINDX
 LDA MSGINDXBUFF
 STA INDX
 LDA MSGINDXBUFF+1
 STA INDX+1

 LDX #0
 LDA #0
 JSR LOADMSG
 LDA MSGBUFF
 STA MSGS
 LDA MSGBUFF+1
 STA MSGS+1

 JSR ZAPI

 LDA PARTYNUM
 STA LASTMSG
 BRA BOT

TOPZ JSR PRINT
 GOTOXY 0;22
 CURSOROFF
 INVERSE
 COLOR YELLOW
 ZAPLINE
 NORMAL
 NULL

TOP JSR TOPDISP

BOT JSR PRBOT
 LDA CH
 STA BOTCH+2

GETKEY LDX #0
 LDY #0
 LDA #23
 JSR PICKLINE
 LDA $200
 CMP #"["
 BNE BOT

 JSR PRINT
BOTCH GOTOXY 0;23
 NULL
]LOOP JSR KEYIN
 JSR UPPER
 LDX :KEYS
]LOOP2 CMP :KEYS,X
 BEQ :GOTONE
 DEX
 BNE ]LOOP2
 JMP ]LOOP
:GOTONE DEX
 TXA
 ASL
 TAX
 JMP (:TABLE,X)

:KEYS DFB :ENDKEYS-*-1
 DFB $9B
 DFB "E"
 DFB "S"
 DFB "D"
 DFB "L"
 DFB "Q"
 DFB "H"
 DFB "N"
:ENDKEYS

:TABLE DA JUMP
 DA EDIT
 DA SAVE
 DA DELETE
 DA LIST
 DA EXIT
 DA HELP
 DA DONEW

DONEW LDA INDX
 ORA INDX+1
 BEQL GETKEY
 JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 ASC "Searching.."
 NULL
]LOOP LDA CURRINDX+1
 CMP INDX+1
 BCC :OK2
 LDA CURRINDX
 CMP INDX
 BCC :OK2
 JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 COLOR PINK
 ASC "End of new-mail scan. "
 COLOR WHITE
 NULL
 GETRETURN
 STZ CURRINDX
 STZ CURRINDX+1
 JMP BOT
:OK2 INCR CURRINDX
 LDX CURRINDX
 LDA CURRINDX+1
 JSR LOADMSGINDX
 BIT MSGFREE
 BMI ]LOOP
 LDA MSGFROM
 CMP PARTYNUM
 BEQ :YEP
 LDA MSGTO
 CMP PARTYNUM
 BNE ]LOOP
 BIT MSGREAD+1 ;Is it new?
 BMI ]LOOP ;No..
 LDA MSGFROM
 STA PRTY
 LDA MSGFROM+1
 STA PRTY+1
 BRA :YEPOK ;Yes
:YEP BIT MSGREAD
 BMI ]LOOP ;No..
 LDA MSGTO
 STA PRTY
 LDA MSGTO+1
 STA PRTY+1
:YEPOK LDX CURRINDX
 LDA CURRINDX+1
 JSR LOAD
 BCSL ]LOOP
 JSR PRINT
 GOTOXY 0;22
 CURSOROFF
 COLOR YELLOW
 INVERSE
 ZAPLINE
 NORMAL
 NULL
 JMP TOP

EXIT JSR PRINT
 HOME
 NULL
 LDX PARTYNUM
 LDA #0
 JSR LOADPN
 JSR CLOSEALL
 RETURN

LIST LDX CURRINDX
 STX :INDSAVE
 LDA CURRINDX+1
 STA :INDSAVE+1
 JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 ASC "Messages to/from other Parties.."
 NULL
 LDA TOPLINE
 STA :LINES
 STA :LINES2
 LDA BOTLINE
 STA :LINES+1
 STA :LINES2+1
 JSR GETSCREEN ;PICKLINE the screen
:LINES DS 2 ;on these lines
 DA MSGBUFF ;and put it here
 STX :LEN ;X and A have length on return
 STA :LEN+1
 JSR PRINT
 GOTOXY 0;22
 COLOR YELLOW
 INVERSE
 ZAPLINE
 NORMAL
 CR
 COLOR WHITE
 NULL
 LDA XPOS
 STA MSGBUFF+MSGRECLEN-2
 LDA YPOS
 STA MSGBUFF+MSGRECLEN-1
 JSR CLEAR
 LDA #TOPLIN
 STZ :CNTR
 STZ :CNTR+1
]LOOP LDA :CNTR
 CMP INDX
 BNE :IOK
 LDA :CNTR+1
 CMP INDX+1
 BEQL :DONE
:IOK INCR :CNTR
 LDX :CNTR
 LDA :CNTR+1
 JSR LOADMSGINDX
 LDA MSGFREE
 BMI ]LOOP
 LDA MSGFROM
 CMP PARTYNUM
 BEQ :GOT2
 LDA MSGTO
 CMP PARTYNUM
 BNE ]LOOP
:GOT1 LDA MSGFROM
 STA :PRTY
 LDA MSGFROM+1
 STA :PRTY+1
 BRA :GOTIT
:GOT2 LDA MSGTO
 STA :PRTY
 LDA MSGTO+1
 STA :PRTY+1
:GOTIT STZ :GMFLAG
 LDA MSGFROM
 CMP MSGTO
 BNE :GOTIT2
 JSR PRINT
 HTAB 8
 COLOR AQUAMARINE
 ASC "GM"
 COLOR WHITE
 NULL
 LDA #$FF
 STA :GMFLAG
 BIT MSGSYSOP ;00=from, FF=to
 BPL :TRY2
 BMI :TRY1
:GOTIT2 LDX :PRTY
 LDA :PRTY+1
 JSR LOADPN
 JSR PRINT
 ASC "#"
 COLOR YELLOW
 DEC16 :PRTY
 COLOR WHITE
 NULL
:GOTIT3 LDA :PRTY
 CMP MSGFROM
 BNE :TRY2
:TRY1 BIT MSGREAD+1
 BMI :TRY12
:NRYET JSR PRINT
 HTAB 7
 COLOR PINK
 ASC "+"
 COLOR WHITE
 NULL
 BRA :GOTIT4
:TRY12 BIT MSGREAD
 BMI :GOTIT4
 JSR PRINT
 HTAB 7
 COLOR PINK
 ASC "-"
 COLOR WHITE
 NULL
 BRA :GOTIT4
:TRY2 BIT MSGREAD
 BMI :TRY22
 JSR PRINT
 HTAB 7
 COLOR PINK
 ASC "+"
 COLOR WHITE
 NULL
 BRA :GOTIT4
:TRY22 BIT MSGREAD+1
 BMI :GOTIT4
 JSR PRINT
 HTAB 7
 COLOR PINK
 ASC "-"
 COLOR WHITE
 NULL
:GOTIT4 BIT :GMFLAG
 BMI :GOTIT5
 JSR PRINT
 HTAB 8
 COLOR ORANGE
 PRSTRING PNNAME
 COLOR WHITE
 NULL
 BRA :GOTIT6
:GOTIT5 JSR PRINT
 COLOR AQUAMARINE
 HTAB 0
 COLOR WHITE
 NULL
:GOTIT6 LDA CV
 CMP #BOTLIN
 BCC :HOK
 JSR PRINT
 GOTOXY 40;23
 CLEOL
 NULL
 GETRETURN
 JSR PRINT
 GOTOXY 40;23
 CLEOL
 NULL
 JSR CLEAR
 JMP ]LOOP
:HOK JSR PRINT
 CR
 NULL
 JMP ]LOOP
:DONE JSR PRINT
 GOTOXY 40;23
 CLEOL
 NULL
 GETRETURN
 JSR CLEAR
 LDX #<MSGRECLEN ;Length
 LDA #>MSGRECLEN
 JSR SHOWMSG
:LINES2 DS 2 ;Lines to use (top, bottom)
 DA MSGBUFF
 LDA MSGBUFF+MSGRECLEN-2
 STA XPOS
 LDA MSGBUFF+MSGRECLEN-1
 STA YPOS
 JSR PRINT
 GOTOXY 0;22
 COLOR YELLOW
 INVERSE
 ZAPLINE
 NORMAL
 CR
 COLOR WHITE
 NULL
 LDX :INDSAVE
 STX CURRINDX
 LDA :INDSAVE+1
 STA CURRINDX+1
 JSR LOADMSGINDX
 JMP BOT
:PRTY DS 2
:LEN DS 2
:CNTR DS 2
:GMFLAG DS 1
:INDSAVE DS 2

JUMP LDA CURRINDX
 ORA CURRINDX+1
 BEQL GETKEY
 LDA XPOS
 STA :GOTO+2
 LDA YPOS
 STA :GOTO+3
 JSR PRINT
:GOTO GOTOXY 0;0
 NULL
 LDX TOPLINE
 LDA BOTLINE
 JSR MSGEDIT
 LDA MSGFROM
 CMP PARTYNUM
 BEQ :TRYTO
 STZ MSGREAD
 BRA :CONT
:TRYTO STZ MSGREAD+1
:CONT LDA CH
 STA XPOS
 LDA CV
 STA YPOS
 JMP GETKEY

DELETE LDA CURRINDX
 ORA CURRINDX+1
 BEQL GETKEY
 JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 COLOR PINK
 ASC "Delete this message (y/N)? : "
 COLOR WHITE
 NULL
 JSR KEYIN
 JSR UPPER
 CMP #"Y"
 BNEL BOT
 JSR PRINT
 ASC "Yes"
 NULL
 LDA #$FF
 STA MSGFREE
 LDX CURRINDX
 LDA CURRINDX+1
 JSR SAVEMSGINDX
 LDX MSGNUM
 LDA MSGNUM+1
 JSR MARKFREE ;Mark this message as being free
 JSR PRINT
 ASC " - "
 COLOR PINK
 ASC "deleted. "
 COLOR WHITE
 NULL
 STZ CURRINDX
 STZ CURRINDX+1
 GETRETURN
 JMP BOT

EDIT JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 ASC "Edit message to Party [def="
 NULL
 LDA LASTMSG
 CMP PARTYNUM
 BNE :NOTGM
 JSR PRINT
 COLOR AQUAMARINE
 ASC "GM"
 COLOR WHITE
 NULL
 BRA :OVERGM
:NOTGM JSR PRINT
 COLOR YELLOW
 DEC16 LASTMSG
 COLOR WHITE
 NULL
:OVERGM JSR PRINT
 ASC "], [L]ist, or [GM] : "
 NULL
 GETLINE #20
 BCSL BOT
 STX :EDLEN
 CPX #0
 BEQ :GOTIT1
 CPX #1
 BNE :NOT1
 LDA $200
 JSR UPPER
 CMP #"L"
 BNE :NOT1
 JSR :LIST
 JMP EDIT
:GOTIT1 JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 ASC "Searching.."
 NULL
 LDX LASTMSG
 LDY LASTMSG+1
 JMP :POK
:NOT1 CPX #2
 BNE :NOT2
 LDA $200
 JSR UPPER
 CMP #"G"
 BNE :NOT2
 LDA $201
 JSR UPPER
 CMP #"M"
 BNE :NOT2
 LDX PARTYNUM
 LDY #0
 JMP :POK ;Message to Sysop
:NOT2 JSR GETNUM
 CPY #1
 BCS :ERR
 CPX #0
 BEQ :PNAME
 CPX PARTYNUM
 BEQL :SAMEP
 CPX PARTYS
 BEQL :POK
 BCCL :POK
:ERR JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 ASC "Last Party is #"
 COLOR YELLOW
 DEC16 PARTYS
 COLOR WHITE
 ASC ". "
 NULL
 GETRETURN
 JMP EDIT
:PNAME LDX :EDLEN
]LOOP LDA $200-1,X
 JSR UPPER
 STA $200-1,X
 DEX
 BNE ]LOOP
 LDX PARTYS
]LOOP PHX
 LDA #0
 JSR LOADPN
 BIT PNFREE
 BMI :NEXTPN
* LDA PNSCENARIO
* CMP SCENARIO
* BNE :NEXTPN
 LDX PNNAME
 CPX :EDLEN
 BNE :NEXTPN
]LOOP2 LDA PNNAME,X
 JSR UPPER
 CMP $200-1,X
 BNE :NEXTPN
 DEX
 BNE ]LOOP2
 PLX
 LDY #0
 BRA :POK
:NEXTPN PLX
 DEX
 BNE ]LOOP
 JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 COLOR PINK
 ASC "No such party. "
 COLOR WHITE
 NULL
 LDX PARTYNUM
 LDY #0
 JSR LOADPN
 GETRETURN
 JMP EDIT
:EDLEN DS 1
:SAMEP JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 COLOR PINK
 ASC "Can't send a message to yourself. "
 COLOR WHITE
 NULL
 GETRETURN
 JMP EDIT
:POK STX PRTY
 STY PRTY+1
 JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 ASC "Searching.."
 NULL
 LDX PRTY
 LDA #0
 JSR LOADPN
 LDA PNFREE
 BPL :POK2
:NTSCEN JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 COLOR PINK
 ASC "Party #"
 COLOR YELLOW
 DEC16 PRTY
 COLOR PINK
 ASC " is not active. "
 COLOR WHITE
 NULL
 LDX PARTYNUM
 LDA #0
 JSR LOADPN
 GETRETURN
 JMP EDIT
:POK2
* LDA PNSCENARIO
* CMP SCENARIO
* BNE :NTSCEN
 STZ :CNTR
 STZ :CNTR+1
]LOOP LDA :CNTR
 CMP INDX
 BNEL :IOK
 LDA :CNTR+1
 CMP INDX+1
 BNE :IOK
 JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 COLOR PINK
 ASC "No message to #"
 COLOR WHITE
 NULL
 LDA PRTY
 CMP PARTYNUM
 BNE :NOTSYSOP
 JSR PRINT
 COLOR AQUAMARINE
 ASC "GM"
 COLOR WHITE
 NULL
 BRA :NSCONT
:NOTSYSOP JSR PRINT
 COLOR YELLOW
 DEC16 PRTY
 COLOR WHITE
 ASC " : "
 COLOR ORANGE
 PRSTRING PNNAME
 COLOR WHITE
 NULL
:NSCONT JSR PRINT
 ASC ". Create one (y/N)? : "
 NULL
 JSR KEYIN
 JSR UPPER
 CMP #"Y"
 BNEL EDIT
 JMP ADDMSG
:IOK INCR :CNTR
 LDX :CNTR
 LDA :CNTR+1
 JSR LOADMSGINDX
 LDA MSGFREE
 BMIL ]LOOP
 LDX :CNTR
 LDA :CNTR+1
 JSR LOAD
 BCSL ]LOOP
 JMP TOPZ
:NOTOME JMP TOP

:LIST LDA TOPLINE
 STA :LLINES
 STA :LLINES2
 LDA BOTLINE
 STA :LLINES+1
 STA :LLINES2+1
 JSR GETSCREEN ;PICKLINE the screen
:LLINES DS 2 ;on these lines
 DA TBUFFER ;and put it here
 STX :LEN ;X and A have length on return
 STA :LEN+1

 JSR CLEAR

 STZ :PREC
 STZ :PREC+1

]LOOP LDA :PREC+1
 CMP PARTYS+1
 BNE :LP
 LDA :PREC
 CMP PARTYS
 BEQL :DONE
:LP INCR :PREC
 LDX :PREC
 LDA :PREC+1
 JSR LOADPN
 LDA PNFREE
 BMI ]LOOP
* LDA PNSCENARIO
* CMP SCENARIO
* BNE ]LOOP
 LDA PADFLAG
 PHA
 LDA #$FF
 STA PADFLAG
 LDA PADCHAR
 PHA
 LDA #" "
 STA PADCHAR
 JSR PRINT
 COLOR YELLOW
 DEC8 :PREC
 ASC "  "
 COLOR AQUAMARINE
 PRSTRING PNNAME
 COLOR YELLOW
 CR
 NULL
 PLA
 STA PADCHAR
 PLA
 STA PADFLAG
 LDA CV
 CMP #BOTLIN+1
 BCC ]LOOP
 JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 COLOR YELLOW
 CENTER "[SPACE]-continue, [ESC]-exit : "
 COLOR WHITE
 NULL
]LOOP2 JSR KEYIN
 CMP #" "
 BEQ :PSPC
 CMP #$9B
 BNE ]LOOP2
 BRA :PESC
:PSPC JSR PRINT
 ZAPLINE
 NULL
 JSR CLEAR
 JMP ]LOOP
:DONE JSR PRINT
 GOTOXY 0;23
 COLOR WHITE
 ZAPLINE
 NULL
 GETRETURN
:PESC JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 NULL

 LDX PARTYNUM
 LDA #0
 JSR LOADPN

 JSR CLEAR

 LDX :LEN ;Length
 LDA :LEN+1
 JSR SHOWMSG
:LLINES2 DS 2 ;Lines to use (top, bottom)
 DA TBUFFER
 RTS
:LEN DS 2
:CNTR DS 2
:PREC DS 2

LOAD STX :CNTR
 STA :CNTR+1
 LDA MSGFROM
 CMP PARTYNUM
 BEQ :TRYTO
 LDA MSGTO
 CMP PARTYNUM
 BNE :BACK
:TRYFROM LDA MSGFROM
 CMP PRTY
 BNE :BACK
 LDA #$FF ;Update 'MSGREAD to' - msg has been read
 STA MSGREAD+1
 BRA :GOTIT
:TRYTO LDA MSGTO
 CMP PRTY
 BNE :BACK
 LDA #$FF ;Update 'MSGREAD from' - msg has been read
 STA MSGREAD
:GOTIT LDX MSGNUM
 LDA MSGNUM+1
 JSR LOADMSG
 LDA TOPLINE
 STA :LINES
 LDA BOTLINE
 STA :LINES+1
 JSR CLEAR
 LDX #<MSGRECLEN ;Length
 LDA #>MSGRECLEN
 JSR SHOWMSG
:LINES DS 2 ;Lines to use (top, bottom)
 DA MSGBUFF
 LDA MSGBUFF+MSGRECLEN-2
 STA XPOS
 LDA MSGBUFF+MSGRECLEN-1
 STA YPOS
 LDX :CNTR
 LDA :CNTR+1
 STX CURRINDX
 STA CURRINDX+1
 JSR SAVEMSGINDX
 CLC
 RTS
:BACK SEC
 RTS
:CNTR DS 2

ADDMSG JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 ASC "Wait.."
 NULL
 JSR GETFREEMSG ;Get the next free message from 'msg map'
 BCC :OK
 JSR PRINT
 COLOR PINK
 ASC " Can't - message base full. "
 COLOR WHITE
 NULL
 GETRETURN
 JMP BOT
:OK STX :NEWMSG
 STA :NEWMSG+1
 STZ :CNTR
 STZ :CNTR+1
]LOOP LDA :CNTR+1 ;Look for a free msg in index
 CMP INDX+1
 BNE :LOOK
 LDA :CNTR
 CMP INDX
 BEQ :ADD1
:LOOK INCR :CNTR
 LDX :CNTR
 LDA :CNTR+1
 JSR LOADMSGINDX
 LDA MSGFREE
 BPL ]LOOP
 BRA :FREE1

:ADD1 INCR :CNTR
 LDA :CNTR
 STA MSGINDXBUFF
 STA INDX
 LDA :CNTR+1
 STA MSGINDXBUFF+1
 STA INDX+1
 STZ MSGREAD
 STZ MSGREAD+1
 STZ MSGSYSOP
 LDX #0
 LDA #0
 JSR SAVEMSGINDX

:FREE1 LDA :CNTR
 STA CURRINDX
 LDA :CNTR+1
 STA CURRINDX+1

 JSR ZAPI

 LDA :NEWMSG
 STA MSGNUM
 LDA :NEWMSG+1
 STA MSGNUM+1

 MLI_GET_TIME
 LDX #3
]LOOP LDA $BF90,X
 STA MSGPOSTED,X
 DEX
 BPL ]LOOP

 LDA :NEWMSG+1
 CMP MSGS+1
 BCC :LESS
 LDA :NEWMSG
 CMP MSGS
 BEQ :LESS
 BCC :LESS
 LDA :NEWMSG
 STA MSGBUFF
 STA MSGS
 LDA :NEWMSG+1
 STA MSGBUFF+1
 STA MSGS+1
 LDX #0
 LDA #0
 JSR SAVEMSG

:LESS JSR CLEAR
 LDA PARTYNUM
 CMP MSGFROM
 BNE :PTO
:PFROM LDA #$FF
 STA MSGREAD
 STZ MSGREAD+1
 BRA :CONT
:PTO STZ MSGREAD
 LDA #$FF
 STA MSGREAD+1
:CONT LDA PARTYNUM
 STA MSGFROM
 STZ MSGFROM+1
 LDA PRTY
 STA MSGTO
 LDA PRTY+1
 STA MSGTO+1
 LDA #$FF
 STA MSGREAD
 STZ MSGREAD+1
 JSR TOPDISP
 JSR SAVE2
 LDA #0
 STA XPOS
 LDA #TOPLIN
 STA YPOS
 JSR PRBOT
 JMP JUMP
:NEWMSG DS 2
:CNTR DS 2

SAVE LDA CURRINDX
 ORA CURRINDX+1
 BEQL GETKEY
 JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 ASC "Saving.."
 NULL
 JSR SAVE2
 BCSL TOP
 JMP BOT

SAVE2 MLI_GET_TIME
 LDX #3
]LOOP LDA $BF90,X
 STA MSGPOSTED,X
 DEX
 BPL ]LOOP

 LDX CURRINDX
 LDA CURRINDX+1
 JSR SAVEMSGINDX
 LDA TOPLINE
 STA :LINES
 LDA BOTLINE
 STA :LINES+1
 JSR GETSCREEN ;PICKLINE the screen
:LINES DS 2 ;on these lines
 DA MSGBUFF ;and put it here
 STX :LEN ;X and A have length on return
 STA :LEN+1
 LDA XPOS
 STA MSGBUFF+MSGRECLEN-2
 LDA YPOS
 STA MSGBUFF+MSGRECLEN-1
 LDX MSGNUM
 LDA MSGNUM+1
 JSR SAVEMSG
 BIT MSGFREE
 BMI :FREE
 LDX MSGNUM
 LDA MSGNUM+1
 JSR MARKUSED ;Mark this message as being used
 SEC
 RTS
 JMP TOP
:FREE LDX MSGNUM
 LDA MSGNUM+1
 JSR MARKFREE ;Mark this message as being free
 CLC
 RTS
:LEN DS 2

HELP JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 ASC "Help"
 NULL
 LDA TOPLINE
 STA :LINES
 STA :LINES2
 STA :LINES3
 LDA BOTLINE
 STA :LINES+1
 STA :LINES2+1
 STA :LINES3+1
 JSR GETSCREEN ;PICKLINE the screen
:LINES DS 2 ;on these lines
 DA TBUFFER ;and put it here
 STX :LEN ;X and A have length on return
 STA :LEN+1

 JSR GETFILE
:LINES2 DS 2 ;Use lines x to y
 STR "HELP/MSG.BASE"
 JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 NULL
 GETRETURN
 JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 NULL

 JSR CLEAR

 LDX :LEN ;Length
 LDA :LEN+1
 JSR SHOWMSG
:LINES3 DS 2 ;Lines to use (top, bottom)
 DA TBUFFER
 JMP BOT
:LEN DS 2
TBUFFER DS BOTLIN-TOPLIN+1*80

CLEAR JSR PRINT
 GOTOXY 0;21
 ZAPLINE
 NULL
]LOOP JSR PRINT
 CURSORUP
 ZAPLINE
 NULL
 LDA CV
 CMP TOPLINE
 BNE ]LOOP
 RTS

ZAPI STZ MSGFREE
 STZ MSGNUM
 STZ MSGNUM+1
 STZ MSGFROM
 STZ MSGFROM+1
 STZ MSGTO
 STZ MSGTO+1
 STZ MSGPOSTED
 STZ MSGPOSTED+1
 STZ MSGPOSTED+2
 STZ MSGPOSTED+3
 RTS

TOPDISP STZ PNNAME
 LDA MSGFROM
 STA LASTMSG
 LDA MSGFROM+1
 STA LASTMSG+1
 LDA MSGFROM
 CMP MSGTO
 BEQ :SKIP
 LDA MSGTO
 BNE :OK
 LDA MSGTO+1
 BEQ :SKIP
:OK LDA MSGFROM
 CMP PARTYNUM
 BNE :TRYTO
 LDX MSGTO
 STX LASTMSG
 LDA MSGTO+1
 STA LASTMSG+1
 JSR LOADPN
 BRA :SKIP
:TRYTO LDX MSGFROM
 STX LASTMSG
 LDA MSGFROM+1
 STA LASTMSG+1
 JSR LOADPN
:SKIP JSR PRINT
 GOTOXY 0;2
 COLOR WHITE
 CURSORON
 ASC "Message to "
 CLEOL
 NULL
 LDA MSGFROM
 CMP MSGTO
 BNE :NOTGM
 JSR PRINT
 COLOR AQUAMARINE
 ASC "GameMaster"
 COLOR WHITE
 NULL
 BRA :OVERGM
:NOTGM JSR PRINT
 ASC "Party #"
 CLEOL
 COLOR YELLOW
 DEC16 LASTMSG
 COLOR WHITE
 ASC " : "
 COLOR ORANGE
 PRSTRING PNNAME
 COLOR WHITE
 NULL
:OVERGM LDA MSGFROM
 CMP PARTYNUM
 BNE :MBTO
 BIT MSGREAD+1 ;Been read yet?
 BMI :OVER2
:NRY JSR PRINT
 COLOR PINK
 ASC " <not read yet>"
 COLOR WHITE
 NULL
 BRA :OVER2
:MBTO BIT MSGREAD ;Been read yet?
 BPL :NRY
:OVER2 JSR PRINT
 CR
 ASC "Last edited : "
 COLOR YELLOW
 DATE MSGPOSTED
 ASC "  "
 TIME MSGPOSTED+2
 COLOR WHITE
 NULL
 RTS

PRBOT JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 COLOR WHITE
 CURSORON
 ASC "[ESC]-jump, [E]dit, [S]ave, [D]elete, [L]ist, [H]elp, "
 ASC "[N]ew mail, [Q]uit : "
 NULL
 RTS

XPOS DFB 0 ;Leave these two together
YPOS DFB TOPLIN ;

TOPLINE DFB TOPLIN
BOTLINE DFB BOTLIN

INDX DS 2
MSGS DS 2

CURRINDX DS 2

PRTY DS 2
PARTYS DS 2

LASTMSG DS 2

 LST ON
MODEND EQU *
 LST OFF

 do M16PLUS
 SAV RUN/MODULES/GAME.MESSAGE
 fin

 END
