*-------------------------------
* GAME.NOTEPAD
*-------------------------------
 DAT
 LST OFF

 ORG $8000 ;Always

 USE MACROS
 USE EQUATES
 USE VARS
 USE LIB.JMP

 TYP $F4
 do M16PLUS-1
 DSK RUN/MODULES/GAME.NOTEPAD
 fin

 MODID "GAME.NOTEPAD"

START JSR PRINT
 GOTOXY 0;14
 CURSOROFF
 INVERSE
 COLOR PINK
 ZAPLINE
 GOTOXY 0;23
 ZAPLINE
 NORMAL
 GOTOXY 0;14
 MTOFF
 COLOR ORANGE
 CENTER " Notepad ([ESC]-exit) "
 COLOR PINK
 CR
 COLOR WHITE
 NULL

 LDA PARTYNUM
 JSR GETHEX
 STX :FNAME+14
 STX PATH+14
 STY :FNAME+15
 STY PATH+15

 JSR CLEAR ;Clear lines

 JSR CHECKFILE
:FNAME STR "DATA/NOTEPAD.XX"
 BCC :THERE
 MLI_CREATE CRPARMS
 JSR MLIERR

 JSR SAVEPAD

:THERE MLI_OPEN OPARMS
 JSR MLIERR
 LDA OPARMS+5
 STA RWPARMS+1
 MLI_READ RWPARMS
 JSR MLIERR
 JSR CLOSEALL

 LDX LEN ;Length
 LDA LEN+1
 JSR SHOWMSG
TOPLINE DFB 15 ;Lines to use (top, bottom)
BOTLINE DFB 22
 DA BUFFER

 LDA CURSOR
 STA :HV+2
 LDA CURSOR+1
 CLC
 ADC #15
 STA :HV+3
 JSR PRINT
:HV GOTOXY 0;0
 CURSORON
 NULL

 LDX TOPLINE
 LDA BOTLINE
 JSR MSGEDIT
 LDA CH
 STA CURSOR
 LDA CV
 SEC
 SBC #15
 STA CURSOR+1

 LDA TOPLINE
 STA :LINES
 LDA BOTLINE
 STA :LINES+1
 JSR GETSCREEN ;PICKLINE the screen
:LINES DS 2 ;on these lines
 DA BUFFER ;and put it here
 JSR SAVEPAD

EXIT INC BOTLINE
 DEC TOPLINE
 JSR CLEAR
 RETURN

CLEAR LDA BOTLINE
 STA :V+3
 JSR PRINT
 NORMAL
 MTOFF
:V GOTOXY 0;22
 ZAPLINE
 NULL
]LOOP JSR PRINT
 CURSORUP
 ZAPLINE
 NULL
 LDA CV
 CMP TOPLINE
 BNE ]LOOP
 RTS

SAVEPAD MLI_OPEN OPARMS
 JSR MLIERR
 LDA OPARMS+5
 STA RWPARMS+1
 MLI_WRITE RWPARMS
 JSR MLIERR
 JMP CLOSEALL

OPARMS DFB 3
 DA PATH
 DA IOBUFFER
 DS 1

RWPARMS DFB 4
 DS 1
 DA BUFFER
LEN DA 80*8+2
 DS 2

CRPARMS DFB 7
 DA PATH
 DFB %11000011 ;Access bits ($C3)
 DFB $F2 ;Filetype
 DA 80*8+2 ;Aux type (8 lines + 2 for cursor loc)
 DFB 1 ;Storage type
 DA 0 ;Creation date
 DA 0 ;     & time
PATH STR "DATA/NOTEPAD.XX"

BUFFER DS 80*8,$8D ;'Empty'
CURSOR DFB 0,0 ;Cursor loc

 LST ON
MODEND EQU *
 LST OFF

 do M16PLUS
 SAV RUN/MODULES/GAME.NOTEPAD
 fin

 END
