*-------------------------------
* GAME.PLRSTAT
*-------------------------------
 DAT
 LST OFF

 ORG $8000 ;Always

 USE MACROS
 USE EQUATES
 USE VARS
 USE PLR.DSECT
 USE LIB.JMP
 USE TABLES
 USE SPELL.DSECT
 USE ITEM.DSECT
 USE ITEM2.DSECT

 TYP $F4
 do M16PLUS-1
 DSK RUN/MODULES/GAME.PLRSTAT
 fin

 MODID "GAME.PLRSTAT"

START STZ UPDATEFLAG
START2 JSR CLRBOT
 JSR PRINT
 GOTOXY 0;15
 CURSORON
 NULL
 LDX NUMPARTY
]LOOP LDA CURPARTY2-1,X
 BNE :OK
 LDA CURPARTY-1,X
 BNE :OK
 DEX
 BNE ]LOOP
 JSR PRINT
 COLOR PINK
 ASC "No-one in the party. "
 SOUND $02;1;LOUD
 COLOR WHITE
 NULL
 GETRETURN
 JMP :EXIT
:OK STX PLRS
 JSR PRINT
 ASC "For character (1-"
 DEC8 PLRS
 ASC ", L=list)? : "
 NULL
]LOOP JSR KEYIN
 JSR UPPER
 CMP #$9B
 BEQL :EXIT
 CMP #"L"
 BEQL PLRLIST
 SEC
 SBC #"1"
 CMP PLRS
 BCS ]LOOP
 PHA
 INC
 STA :PCNTR
 JSR PRINT
 CURSOROFF
 NULL
 PLX
 LDA CURPARTY,X
 STA :REC
 TAY
 LDA CURPARTY2,X
 STA :REC+1
 TYX
 JSR LOADPLR
:SHOW JSR CLRBOT
 JSR PRINT
 CURSORON
 PRSTRING PLRNAME
 ASC " ("
 COLOR AQUAMARINE
 PRTABLE PLRCLASS;CLASSTABLE
 COLOR WHITE
 LINE ")"
 NULL
 LDX PLRCREDITS
 BEQ :NOCRED
]LOOP LDA #"*"
 JSR COUT
 DEX
 BNE ]LOOP
:NOCRED JSR PRINT
 CR
 ASC "ST: "
 COLOR YELLOW
 DEC8 PLRST
 COLOR WHITE
 HTAB 15
 ASC "Gold: "
 COLOR YELLOW
 DEC32 PLRGOLD
 COLOR WHITE
 CR
 ASC "DX: "
 COLOR YELLOW
 DEC8 PLRDX
 COLOR WHITE
 HTAB 15
 ASC "Exp:  "
 COLOR YELLOW
 DEC32 PLREXP
 COLOR WHITE
 CR
 ASC "IQ: "
 COLOR YELLOW
 DEC8 PLRIQ
 COLOR WHITE
 HTAB 15
 ASC "Lvl:  "
 COLOR YELLOW
 DEC8 PLRLVLREAL
 COLOR WHITE
 HTAB 25
 ASC "Age: "
 COLOR YELLOW
 DEC8 PLRAGE
 COLOR WHITE
 ASC "  AC: "
 COLOR YELLOW
 DEC8NEG PLRAC
 COLOR WHITE
 CR
 ASC "HT: "
 COLOR YELLOW
 DEC8 PLRHT
 COLOR WHITE
 HTAB 15
 ASC "Points: "
 COLOR YELLOW
 DEC8NEG PLRCURRPNTS
 ASC "/"
 DEC8 PLRMAXPNTS
 COLOR WHITE
 HTAB 31
 ASC "Magic: "
 COLOR YELLOW
 DEC8 PLRMAGIC
 ASC "/"
 DEC8 PLRMAGICMAX
 COLOR WHITE
 CR
 CR
 ASC "HP: "
 COLOR YELLOW
 DEC8NEG PLRHP
 ASC "/"
 DEC8 PLRHP+1
 COLOR WHITE
 HTAB 15
 ASC "Status: "
 COLOR GREEN
 PRCOND PLRCOND
 COLOR WHITE
 NULL
:DOIT LDA #<PLRITEM
 STA :I+2
 LDA #15
 STA :V+3
 LDX #1
]LOOP STX :TEMPX
 LDA PLRITEM-1,X
 BEQ :NEXT
 LDA PLRITEMX-1,X
 AND #%11
 TAX
 LDA :ICOLORS,X
 STA :IC+2
 JSR PRINT
:V GOTOXY 56;15
 DEC8 :TEMPX
 ASC ")"
:IC COLOR WHITE
:I PRITEM PLRITEM
 COLOR WHITE
 NULL
:NEXT INC :V+3
 INC :I+2
 INC :TEMPX
 LDX :TEMPX
 CPX #9
 BNE ]LOOP
 LDX :REC
 LDA :REC+1
 JSR SAVEPLR
 BRA :EXIT2
:EXIT JSR PRINT
 ZAPLINE
 CURSOROFF
 NULL
 JMP GOBACK
:EXIT2 JSR PRINT
 GOTOXY 35;15
 COLOR PINK
 ASC "D)rop R)ead E)quip:"
 COLOR WHITE
 CURSORON
 NULL
]LOOP JSR KEYIN
 JSR UPPER
 CMP #$9B
 BEQL START2
 CMP #"D"
 BEQL :DROP
 CMP #"R"
 BEQ :READ
 CMP #"E"
 BEQ :EQUIP
 CMP #"H"-$40
 BEQ :GOLEFT
 CMP #"U"-$40
 BEQ :GORIGHT
 BRA ]LOOP

:GOLEFT LDA PLRS
 CMP #1
 BEQ ]LOOP
 LDX :PCNTR
 CPX #1
 BNE :LOK
 LDX PLRS
 INX
:LOK DEX
 STX :PCNTR
 LDA CURPARTY-1,X
 STA :REC
 LDA CURPARTY2-1,X
 STA :REC+1
 BNE :LOK2
 LDA :REC
 BEQ ]LOOP ;Shouldn't happen..
:LOK2 LDX :REC
 LDA :REC+1
 JSR LOADPLR
 JMP :SHOW

:GORIGHT LDA PLRS
 CMP #1
 BEQ ]LOOP
 LDX :PCNTR
 CPX PLRS
 BNE :ROK
 LDX #0
:ROK INX
 STX :PCNTR
 LDA CURPARTY-1,X
 STA :REC
 LDA CURPARTY2-1,X
 STA :REC+1
 BNE :ROK2
 LDA :REC
 BEQL ]LOOP ;Shouldn't happen..
:ROK2 LDX :REC
 LDA :REC+1
 JSR LOADPLR
 JMP :SHOW

:READ JSR COUT
 JSR READ
 JMP :SHOW

:EQUIP JSR COUT
 JSR EQUIP
 JMP :SHOW

:DROP JSR COUT
 JSR DROPITEM
 JMP :SHOW
:TEMPX DS 1
:REC DS 2
:PCNTR DS 1
:ICOLORS DFB $F,$E,$D,$D
PLRS DS 1

DROPITEM LDX #79
 LDY #79
 LDA #23
 JSR PICKLINE
 LDA $200
 STA :BCHAR
:DROP2 LDX #7
]LOOP LDA PLRITEM,X
 BNE :OK
 DEX
 BPL ]LOOP
 LDX #-1
:OK INX
 STX :MAX
 LDX #0
 LDA #0
 JSR LOADITEM2
 LDA ITEM2BUFF
 STA :MAXI2
 JSR CLRBOT
 JSR PRINT
 ASC "Gold : "
 COLOR YELLOW
 DEC32 PLRGOLD
 COLOR WHITE
 NULL
 STZ :I2CNTR

 LDA #<PLRITEM
 STA :I+2
 LDA #15
 STA :V+3
 LDX #1
]LOOP STX :TEMPX
 LDA PLRITEM-1,X
 BEQ :TOPLOOP
 JSR PRINT
:V GOTOXY 40;15
 DEC8 :TEMPX
 ASC ")"
:I PRITEM PLRITEM
 NULL
 INC :V+3
 INC :I+2
 INC :TEMPX
 LDX :TEMPX
 CPX #9
 BNE ]LOOP

:TOPLOOP JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 NULL
 LDA :MAX
 BEQ :GONLY
 JSR PRINT
 ASC "(1-"
 DEC8 :MAX
 ASC ")-item to drop, "
 NULL
:GONLY JSR PRINT
 ASC "[G]old, [ESC]-exit : "
 NULL
]LOOP JSR KEYIN
 JSR UPPER
 CMP #$9B
 BEQL :EXIT
 CMP #"G"
 BEQL :DOGOLD
 SEC
 SBC #"1"
 CMP :MAX
 BCS ]LOOP
 STA :ITEM
 TAX
 LDA PLRITEM,X
 TAX
 LDA #0
 JSR LOADITEM
 JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 ASC "Drop your "
 COLOR GREEN
 PRSTRING INAME
 COLOR WHITE
 ASC " (y/N)? : "
 NULL
 JSR KEYIN
 JSR UPPER
 CMP #"Y"
 BNEL :TOPLOOP
 JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 COLOR GREEN
 PRSTRING INAME
 COLOR WHITE
 ASC " dropped. "
 NULL
 STZ IDATA
 STZ IDATA+1
 STZ IDATA+2
 STZ IDATA+3
 LDX :ITEM
 LDA PLRITEM,X
 JSR :DROPIT
 LDX :ITEM
]LOOP LDA PLRITEM+1,X
 STA PLRITEM,X
 LDA PLRITEMX+1,X
 STA PLRITEMX,X
 INX
 CPX #8
 BCC ]LOOP
 STZ PLRITEM+7
 STZ PLRITEMX+7
 GETRETURN
 JSR CALCPLR
 LDA #$FF
 STA UPDATEFLAG
 JMP :DROP2

:DOGOLD LDA PLRGOLD
 ORA PLRGOLD+1
 ORA PLRGOLD+2
 ORA PLRGOLD+3
 BNE :GOLD2
 JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 COLOR PINK
 ASC "You have no gold to drop. "
 COLOR WHITE
 NULL
 GETRETURN
 JMP :TOPLOOP
:GOLD2 JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 ASC "Enter amount to drop : "
 NULL
 GETLINE #10
 CPX #0
 BEQL :TOPLOOP
 JSR GETNUM
 STX :GOLD
 STY :GOLD+1
 LDA VTEMP
 STA :GOLD+2
 LDA VTEMP+1
 STA :GOLD+3

 LDA :GOLD
 ORA :GOLD+1
 ORA :GOLD+2
 ORA :GOLD+3
 BEQL :TOPLOOP

 LDX #3
]LOOP LDA :GOLD,X
 CMP PLRGOLD,X
 BEQ :MAYBE
 BCC :CANPAY
 BCS :CANTPAY
:MAYBE DEX
 BPL ]LOOP
 BRA :CANPAY

:CANTPAY JSR PRINT
 GOTOXY 0;23
 COLOR PINK
 ASC "You don't have that much gold. "
 COLOR WHITE
 SOUND $02;1;LOUD
 NULL
 GETRETURN
 JMP :TOPLOOP

:CANPAY CLC
 XCE
 REP #$30
 LDA PLRGOLD
 SEC
 SBC :GOLD
 STA PLRGOLD
 LDA PLRGOLD+2
 SBC :GOLD+2
 STA PLRGOLD+2
 SEC
 XCE
 JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 ASC "Dropped "
 COLOR YELLOW
 DEC32 :GOLD
 COLOR WHITE
 ASC " gold. "
 NULL
 LDA #0 ;0=gold
 JSR :DROPIT
 GETRETURN
 JMP :DROP2

:EXIT LDA :BCHAR
 CMP #' '
 BNE :RR
 JSR PRINT
 GOTOXY 0;23
 INVERSE
 COLOR YELLOW
 ZAPLINE
 COLOR WHITE
 NORMAL
 NULL
 JMP CLRBOT
:RR JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 NULL
 RTS

:DROPIT LDX PLRZPOS
 BNE :DROPIT2
 RTS
:DROPIT2 PHA
]LOOP INC :I2CNTR
 LDA :I2CNTR
 CMP :MAXI2
 BEQ :DIOK
 BCS :ADD1
:DIOK LDX :I2CNTR
 LDA #0
 JSR LOADITEM2
 LDA IFREE
 BPL ]LOOP
:PUT1 PLA
 STA INUM
 STZ IFREE
 STZ IBURIED
 LDA PLRXPOS
 STA IXPOS
 LDA PLRYPOS
 STA IYPOS
 LDA PLRZPOS
 STA IZPOS
 LDA INUM
 BNE :NOTG
 LDX #3
]LOOP LDA :GOLD,X
 STA IDATA,X
 DEX
 BPL ]LOOP
:NOTG LDX :I2CNTR
 LDA #0
 JMP SAVEITEM2

:ADD1 INC :MAXI2
 LDA :MAXI2
 STA ITEM2BUFF
 STZ ITEM2BUFF+1
 LDX #0
 LDA #0
 JSR SAVEITEM2
 BRA :PUT1

:I2CNTR DS 1
:ITEM DS 1
:MAX DS 1
:MAXI2 DS 1
:TEMPX DS 1
:GOLD DS 4
:BCHAR DS 1

READ JSR CLRBOT
 LDX #79
 LDY #79
 LDA #23
 JSR PICKLINE
 LDA $200
 STA :BCHAR
 JSR PRINT
 CURSORON
 ASC "[W]izard, [C]leric, [S]age spells, [ESC]-exit : "
 NULL
 LDA CH
 STA :TOPCH+2
:TOPR JSR PRINT
:TOPCH GOTOXY 0;15
 CLEOL
 NULL
]LOOP JSR KEYIN
 JSR UPPER
 CMP #"W"
 BEQ :WIZ
 CMP #"C"
 BEQ :CLE
 CMP #"S"
 BEQ :SAG
 CMP #$9B
 BNE ]LOOP
 JSR PRINT
 CURSOROFF
 GOTOXY 0;23
 NULL
 LDA :BCHAR
 CMP #' '
 BNE :RR
 JSR PRINT
 INVERSE
 COLOR YELLOW
 NULL
:RR JSR PRINT
 ZAPLINE
 COLOR WHITE
 NORMAL
 NULL
 RTS
:WIZ LDX #1
 HEX 2C
:CLE LDX #2
 HEX 2C
:SAG LDX #3
 STX :SPELLCL
 JSR COUT
 JSR PRINT
 CLEOS
 NULL

 LDX :SPELLCL
 LDA #0
]LOOP DEX
 CPX #0
 BEQ :SHOWSP
 CLC
 ADC #32 ;32 spells per class
 BRA ]LOOP
:SHOWSP INC
 STA :CNTR
 STZ :CNTR+1

 JSR CLRBOT2
 LDA #1
 STA :CNTR2
 STZ :CNTR2+1

]LOOP LDA :CNTR2
 DEC
 LSR
 LSR
 LSR
 TAX
 LDA :CNTR2
 DEC
 AND #%0000_0111
 CLC
 ADC #16
 STA :SPHT+3
 LDA #0
]LOOP3 CPX #0
 BEQ :HTABOK
 CLC
 ADC #20
 DEX
 BRA ]LOOP3
:HTABOK STA :SPHT+2
 JSR PRINT
:SPHT GOTOXY 0;0
 NULL

 LDX :CNTR
 LDA :CNTR+1
 JSR LOADSPELL
 LDA SPNAME+1
 CMP #"?"
 BEQ :NEXTSP

 LDA :CNTR2
 DEC
 AND #%0000_0011
 BNE :NONUM
 LDA :CNTR2
 DEC
 LSR
 LSR
 INC
 ORA #"0"
 HEX 2C
:NONUM LDA #" "
 JSR COUT
 JSR PRINT
 ASC " "
 NULL
 LDA :SPELLCL ;Class of spell
 LDX :CNTR2 ;Spell number in this class
 JSR KNOWNSP ;Do we know this spell?
 BCC :NEXTSP

 JSR PRINT
 ASC " "
 PRSTRING SPNAME
 NULL
:NEXTSP INC :CNTR
 INC :CNTR2
 LDA :CNTR2
 CMP #33
 BNEL ]LOOP
 JMP :TOPR
:CNTR DS 2
:CNTR2 DS 2
:SPELLCL DS 1
:BCHAR DS 1

EQUIP LDX #7
]LOOP LDA PLRITEM,X
 BNE :OK
 DEX
 BPL ]LOOP
 RTS
:OK STX :MAX
 JSR PRINT
 CURSORON
 NULL

 LDX #5
]LOOP STZ :EQU,X
 DEX
 BPL ]LOOP

 LDA #1
 STA :CNTR

]LOOP LDX #7
]LOOP2 STZ :STUFF,X
 DEX
 BPL ]LOOP2

 STZ :CNTR2
 LDX #-1
]LOOP2 INX
 PHX
 LDA PLRITEMX,X
 CMP #2 ;unusable
 BEQ :NEXT1
 CMP #4 ;unknown
 BEQ :NEXT1
 STZ PLRITEMX,X ;Unequip all useable items
 LDA PLRITEM,X
 TAX
 LDA #0
 JSR LOADITEM
 LDA ITYPE
 CMP :CNTR
 BNE :NEXT1
 PLX
 PHX
 LDA PLRITEM,X
 LDX :CNTR2
 STA :STUFF,X
 INC :CNTR2
:NEXT1 PLX
 CPX :MAX
 BNE ]LOOP2

 LDA :STUFF
 BEQL :NEXT
 JSR CLRBOT
 JSR PRINT
 PRSTRING PLRNAME
 NULL

 LDX #1
 STX :CNTR2
]LOOP2 LDA :STUFF-1,X
 BEQ :ASK
 TAX
 LDA #0
 JSR LOADITEM
 JSR PRINT
 HTAB 40
 DEC8 :CNTR2
 ASC ") "
 PRSTRING INAME
 CR
 NULL
 INC :CNTR2
 LDX :CNTR2
 CPX #9
 BNE ]LOOP2
 DEX

:ASK STX :CNTR2
 JSR PRINT
 GOTOXY 0;17
 ASC "Select "
 COLOR PINK
 NULL
 LDA :CNTR
 DEC
 ASL
 TAX
 LDA :TBL,X
 STA CADD2
 LDA :TBL+1,X
 STA CADD2+1
 LDY #0
 LDA (CADD2),Y
 TAX
]LOOP2 INY
 LDA (CADD2),Y
 JSR COUT
 DEX
 BNE ]LOOP2
 JSR PRINT
 COLOR WHITE
 ASC " : "
 NULL
]LOOP2 JSR KEYIN
 CMP #$9B
 BEQ :NEXT
 CMP #$8D
 BEQ :NEXT
 CMP #"1"
 BCC ]LOOP2
 CMP #"8"+1
 BCS ]LOOP2
 SEC
 SBC #"1"
 CMP :CNTR2
 BCS ]LOOP2
 TAX
 INC
 STA :CNTR2
 LDA :STUFF,X
 LDX :CNTR
 STA :EQU-1,X
 JSR PRINT
 DEC8 :CNTR2
 NULL

:NEXT INC :CNTR
 LDA :CNTR
 CMP #7
 BNEL ]LOOP

 LDX #0
]LOOP LDA :EQU,X
 BEQ :NEXTEQ
 LDY #0
]LOOP2 CMP PLRITEM,Y
 BEQ :THIS1
 INY
 CPY #8
 BNE ]LOOP2
 DEATH
:THIS1 LDA #1 ;equipped
 STA PLRITEMX,Y
:NEXTEQ INX
 CPX #6
 BNE ]LOOP

 LDA #$FF
 STA UPDATEFLAG
 JMP CALCPLR

:TBL DA :TYPE1
 DA :TYPE2
 DA :TYPE3
 DA :TYPE4
 DA :TYPE5
 DA :TYPE6

:TYPE1 STR "weapon"
:TYPE2 STR "armour"
:TYPE3 STR "shield"
:TYPE4 STR "helmet"
:TYPE5 STR "gloves"
:TYPE6 STR "misc. item"

:CNTR DS 1
:CNTR2 DS 1
:MAX DS 1
:STUFF DS 8
:EQU DS 6

PLRLIST JSR CLRBOT
 LDA PLRS
 CMP #8
 BEQ :LIST2
 JSR PRINT
 COLOR WHITE
 ASC "#  Name"
 HTAB 25
 ASC "Class"
 HTAB 40
 ASC "AC"
 HTAB 47
 ASC "HP"
 HTAB 54
 LINE "Status"
 NULL
:LIST2 LDA #1
 STA :PLR
 LDX #0
]LOOP PHX
 LDA CURPARTY2,X
 BNE :DOSTAT
 LDA CURPARTY,X
 BEQL :NEXT
:DOSTAT LDA CURPARTY,X
 TAY
 LDA CURPARTY2,X
 TYX
 JSR LOADPLR
 JSR PRINT
 DEC8 :PLR
 ASC ") "
 COLOR GREEN
 PRSTRING PLRNAME
 HTAB 25
 COLOR AQUAMARINE
 PRTABLE PLRCLASS;CLASSTABLE
 COLOR WHITE
 HTAB 40
 NULL
 LDA PLRAC
 BPL :ACOK
 CMP #-9
 BCS :ACOK
 JSR PRINT
 ASC "-*" ;If < -9 then display -*
 NULL
 BRA :CONT1
:ACOK CMP #10
 BCS :ACOK2
 JSR PRINT
 ASC " "
 NULL
:ACOK2 JSR PRINT
 DEC8NEG PLRAC
 NULL
:CONT1 LDA PADFLAG
 PHA
 LDA PADCHAR
 PHA
 LDA #$FF
 STA PADFLAG
 LDA #" "
 STA PADCHAR
 LDA PLRHP
 BPL :HPOK
 CMP #-99
 BCS :HPOK
 JSR PRINT
 COLOR YELLOW
 ASC "-**"
 NULL
 BRA :CONT2
:HPOK JSR PRINT
 HTAB 45
 COLOR YELLOW
 DEC8NEG PLRHP
 NULL
:CONT2 JSR PRINT
 COLOR WHITE
 ASC "/"
 COLOR YELLOW
 DEC8 PLRHP+1
 HTAB 54
 NULL
 LDA PLRCOND
 BPL :ZNOTD
 JSR PRINT
 COLOR PINK
 NULL
 BRA :ZZCONT
:ZNOTD JSR PRINT
 COLOR GREEN
 NULL
:ZZCONT JSR PRINT
 PRCOND PLRCOND
 COLOR WHITE
 CR
 NULL
 PLA
 STA PADCHAR
 PLA
 STA PADFLAG
 INC :PLR
:NEXT PLX
 INX
 CPX NUMPARTY
 BNEL ]LOOP
 JSR PRINT
 CURSOROFF
 NULL
 JMP GOBACK
:PLR DS 1

CLRBOT JSR PRINT
 GOTOXY 0;22
 LUP 7
 ZAPLINE
 CURSORUP
 --^
 ZAPLINE
 NULL
 RTS

CLRBOT2 JSR PRINT
 GOTOXY 0;22
 LUP 6
 ZAPLINE
 CURSORUP
 --^
 ZAPLINE
 NULL
 RTS

GOBACK LDA UPDATEFLAG
 STA VTEMP
 RETURN

UPDATEFLAG DFB 0 ;Did anything change? (to show player stats again)

 LST ON
MODEND EQU *
 LST OFF

 do M16PLUS
 SAV RUN/MODULES/GAME.PLRSTAT
 fin

 END
