*-------------------------------
* GAME.REWARD
*-------------------------------
 DAT
 LST OFF

 ORG $8000 ;Always

 USE MACROS
 USE EQUATES
 USE VARS
 USE LIB.JMP
 USE PLR.DSECT

 TYP $F4
 do M16PLUS-1
 DSK RUN/MODULES/GAME.REWARD
 fin

 MODID "GAME.REWARD"

START BIT VTEMP ;00=move, FF=taxi (GOOD card)
 BMI :TAXI
 JSR CLRBOT
 JSR CALCREWARD
 JSR PRINT
 COLOR AQUAMARINE
 PRSTRING PLRNAME
 COLOR WHITE
 ASC " has been jailed. For your efforts, we give you "
 COLOR YELLOW
 DEC16 REWARD
 COLOR WHITE
 ASC " GP."
 CR
 CR
 NULL
 JMP :EXIT

:TAXI JSR CLRBOT
 JSR CALCREWARD
 JSR PRINT
 ASC "After a brief moment, the taxi returns and hands you a note : "
 CR
 CR
 QUOTE
 COLOR AQUAMARINE
 PRSTRING PLRNAME
 COLOR WHITE
 ASC " has been jailed. For your efforts, we give you "
 COLOR YELLOW
 DEC16 REWARD
 COLOR WHITE
 ASC " GP."
 QUOTE
 CR
 CR
 ASC "The taxi driver hands you a weighty bag and speeds off again.."
 SOUND $09;1;LOUD
 CR
 CR
 NULL

:EXIT GETRETURN
 JSR CLRBOT
 LDA REWARD
 STA $200
 LDA REWARD+1
 STA $201
 RETURN

CLRBOT JSR PRINT
 GOTOXY 0;22
 LUP 7
 ZAPLINE
 CURSORUP
 --^
 ZAPLINE
 CURSORON
 NULL
 RTS

CALCREWARD CLC
 XCE
 REP #$30
 LDA #0
 LDX PLRPASSAULTS
]LOOP CPX #0
 BEQ :OK
 CLC
 ADC #250
 DEX
 BRA ]LOOP
:OK LDX PLRPKILLS
]LOOP CPX #0
 BEQ :DONE
 CLC
 ADC #1000
 DEX
 BRA ]LOOP
:DONE STA REWARD
 SEC
 XCE
 RTS
REWARD DS 2

 LST ON
MODEND EQU *
 LST OFF

 do M16PLUS
 SAV RUN/MODULES/GAME.REWARD
 fin

 END
