*-------------------------------
* GAME.SHOP
*-------------------------------
 DAT
 LST OFF

 ORG $8000 ;Always

 USE MACROS
 USE EQUATES
 USE VARS
 USE TABLES
 USE LIB.JMP
 USE ITEM.DSECT
 USE PLR.DSECT
 USE SCEN.DSECT
 USE INV.DSECT

 TYP $F4
 do M16PLUS-1
 DSK RUN/MODULES/GAME.SHOP
 fin

 MODID "GAME.SHOP"

KPMAX = 6

START JSR PRINT
 NORMAL
 MTOFF
 HOME
 SOUND $21;FOREVER;$60
 CURSOROFF
 NULL

 LDX #0
 LDA #0
 JSR LOADSCEN
 LDX SCENBUFF
 STX SCENITEMS
]LOOP PHX
 LDA #0
 JSR LOADSCEN
 LDA SCITEM
 PLX
 STA SCENITEMS,X
 DEX
 BNE ]LOOP

 JSR PRINT
 INVERSE
 COLOR YELLOW
 ZAPLINE
 COLOR WHITE
 NORMAL
 CENTER " Shoppe "
 GOTOXY 0;14
 INVERSE
 COLOR YELLOW
 ZAPLINE
 NORMAL
 GOTOXY 10;2
 COLOR WHITE
 CURSORON
 LINE "Buy items"
 CR
 HTAB 10
 LINE "Sell items"
 CR
 HTAB 10
 LINE "Party stats"
 CR
 HTAB 10
 LINE "Trade stuff"
 CR
 HTAB 10
 LINE "Pool/share gold"
 CR
 HTAB 10
 LINE "Leave"
 GOTOXY 0;23
 CENTER "Use arrow keys to move pointer; [RETURN] to make selection."
 CURSOROFF
 NULL

DOKEY JSR DOPOINT

]LOOP JSR KEYIN
 JSR UPPER
 LDX :KEYS
]LOOP2 CMP :KEYS,X
 BEQ :GOTONE
 DEX
 BNE ]LOOP2
 LDX PNTR
 LDY #KPMAX
 JSR KPCHECK
 BCC ]LOOP
 STX PNTR
 BRA DOKEY
:GOTONE DEX
 TXA
 ASL
 TAX
 JMP (:TABLE,X)

:KEYS DFB :ENDKEYS-*-1
 DFB "K"-$40
 DFB "J"-$40
 DFB "M"-$40
:ENDKEYS

:TABLE DA UP
 DA DOWN
 DA DONE

UP LDA PNTR
 BNE :OK
 LDA #KPMAX
:OK DEC
 STA PNTR
 JMP DOKEY

DOWN LDA PNTR
 CMP #KPMAX-1
 BNE :OK
 LDA #$FF
:OK INC
 STA PNTR
 JMP DOKEY

DONE JSR PRINT
 CURSORLEFT
 ASC "x"
 NULL
 LDA PNTR
 ASL
 TAX
 JMP (:OPTIONS,X)

:OPTIONS DA BUY
 DA SELL
 DA STATS
 DA TRADE
 DA POOL
 DA LEAVE

DOPOINT LDA OLDPNTR
 ASL
 CLC
 ADC #2
 STA :CV+2
 JSR PRINT
 NORMAL
 MTOFF
 HTAB 8
:CV VTAB 0
 ASC " "
 NULL
 LDA PNTR
 ASL
 CLC
 ADC #2
 STA :CV2+2
 JSR PRINT
 HTAB 8
:CV2 VTAB 0
 NULL
 JSR SHOWPNTR
 LDA PNTR
 STA OLDPNTR
 RTS
PNTR DS 1
OLDPNTR DS 1

BUY LDA PADFLAG
 STA :PADFLAG
 LDA PADCHAR
 STA :PADCHAR
:BUY2 JSR PRINT
 GOTOXY 0;16
 CLEOS
 CURSORON
 NULL
 LDX NUMPARTY
]LOOP LDA CURPARTY2-1,X
 BNE :OK
 LDA CURPARTY-1,X
 BNE :OK
 DEX
 BNE ]LOOP
:OK STX :PLRS
 CPX #0
 BNE :OK2
 JSR PRINT
 COLOR PINK
 ASC "No-one in the party to buy. "
 SOUND $02;1;LOUD
 COLOR WHITE
 NULL
 GETRETURN
:EXIT JSR PRINT
 GOTOXY 0;16
 CLEOS
 CURSOROFF
 NULL
 LDA :PADFLAG
 STA PADFLAG
 LDA :PADCHAR
 STA PADCHAR
 JMP DOKEY
:OK2 JSR SHOWNAMES
 JSR PRINT
 ASC "Who will buy (1-"
 DEC8 :PLRS
 ASC ")? : "
 NULL
]LOOP JSR KEYIN
 CMP #$9B
 BEQ :EXIT
 SEC
 SBC #"1"
 CMP :PLRS
 BCS ]LOOP
 STA POOLER
 PHA
 CLC
 ADC #"1"
 JSR COUT
 JSR PRINT
 CLEOS
 NULL
 PLX
 LDA CURPARTY,X
 STA :REC
 TAY
 LDA CURPARTY2,X
 STA :REC+1
 TYX
 JSR LOADPLR
 LDA PLRCOND
 AND #%1000_0000 ;Dead?
 BEQ :ALIVE
 JSR PRINT
 CR
 COLOR PINK
 PRSTRING PLRNAME
 ASC " is dead. "
 SOUND $13;1;LOUD
 COLOR WHITE
 NULL
 GETRETURN
 JMP :BUY2
:ALIVE LDA PLRZPOS ;In Castle?
 BEQ :CASTLE
 JSR PRINT
 CR
 COLOR PINK
 PRSTRING PLRNAME
 ASC " is not here. "
 SOUND $02;1;LOUD
 COLOR WHITE
 NULL
 GETRETURN
 JMP :BUY2
:CASTLE JSR PRINT
 GOTOXY 0;16
 CLEOS
 ASC "What would you like, "
 PRSTRING PLRNAME
 ASC " ("
 PRTABLE PLRCLASS;CLASSTABLE
 ASC ")?"
 NULL

 LDA #$FF
 STA PADFLAG
 LDA #" "
 STA PADCHAR

 LDX #0
 LDA #0
 JSR LOADITEM
 LDA ITEMBUFF
 STA :ITEMS

 STZ :CNTR
 STZ :PNTR

:TOP JSR PRINT
 GOTOXY 0;18
 CLEOS
 CURSORON
 NULL
 STZ :CNTR2
 LDA :CNTR
 STA :TOPC

]LOOP LDA :CNTR
 CMP :ITEMS
 BCS :IONE
 BCC :IOK
:IONE STZ :CNTR
:IOK INC :CNTR
 LDY SCENITEMS
]LOOP2 LDA :CNTR
 CMP SCENITEMS,Y ;We can't buy any 'quest' items (obviously)
 BEQ ]LOOP
 DEY
 BNE ]LOOP2
 LDX :CNTR
 LDA #0
 JSR LOADINV
 LDA INVSTOCK ;Does the shop have any?
 BEQ ]LOOP
 LDX :CNTR
 LDA #0
 JSR LOADITEM
 LDX :CNTR2
 LDA :CNTR
 STA :PTBL,X
 JSR PRINT
 ZAPLINE
 ASC "  "
 PRSTRING INAME
 HTAB 27
 NULL
 LDX ITYPE
 LDA :CTYPES-1,X
 STA :CMOD+2
 JSR PRINT
:CMOD COLOR WHITE
 PRTABLE ITYPE;TYPETABLE
 ASC "  "
 COLOR YELLOW
 DEC32 ICOST
 COLOR WHITE
 NULL
 LDA PLRCLASS
 JSR CHECKUSE ;Can we use this item?
 BCC :USEOK
 JSR PRINT
 COLOR PINK
 ASC " unusable"
 NULL
:USEOK JSR PRINT
 COLOR WHITE
 CR
 NULL
 INC :CNTR2
 LDA :CNTR2
 CMP #4
 BNEL ]LOOP
:BOT JSR PRINT
 GOTOXY 60;16
 ASC "Gold : "
 CLEOL
 COLOR YELLOW
 DEC32 PLRGOLD
 COLOR WHTE
 GOTOXY 0;23
 ZAPLINE
 ASC "["
 MTON
 INVERSE
 ASC "H"
 NORMAL
 MTOFF
 ASC "/"
 MTON
 INVERSE
 ASC "U"
 NORMAL
 MTOFF
 ASC "]-page up/down, ["
 MTON
 INVERSE
 ASC "K"
 NORMAL
 MTOFF
 ASC "/"
 MTON
 INVERSE
 ASC "J"
 NORMAL
 MTOFF
 ASC "]-move pointer, [P]ool gold, [RETURN]-buy, [ESC]-exit."
 CURSOROFF
 NULL
:BOT2 JSR :DOPNTR
]LOOP JSR KEYIN
 JSR UPPER
 CMP #"K"-$40
 BEQ :PTRUP
 CMP #"J"-$40
 BEQ :PTRDOWN
 CMP #"H"-$40
 BEQ :PAGEUP
 CMP #"U"-$40
 BEQL :PAGEDOWN
 CMP #"P"
 BEQ :POOLIT
 CMP #$8D
 BEQL :BUYIT
 CMP #$9B
 BNE ]LOOP
 LDA :PADFLAG
 STA PADFLAG
 LDA :PADCHAR
 STA PADCHAR
 JMP :BUY2

:POOLIT LDA :PADFLAG
 STA PADFLAG
 LDA :PADCHAR
 STA PADCHAR
 LDA :PLRS
 STA POOLPLRS
 JSR PRINT
 CURSORON
 NULL
 JSR POOL2
 JSR PRINT
 COLOR WHITE
 NULL
 JMP :CASTLE

:PTRUP LDA :PNTR
 BNE :PUPOK
 LDA #3
 STA :PNTR
 JMP :PAGEUP
:PUPOK DEC
 STA :PNTR
 JMP :BOT2

:PTRDOWN LDA :PNTR
 CMP #3
 BCC :PDNOK
 LDA #0
 STA :PNTR
 JMP :PAGEDOWN
:PDNOK INC
 STA :PNTR
 JMP :BOT2

:PAGEUP LDA :TOPC
 DEC
 CMP :ITEMS
 BCC :PUOK
 LDA :ITEMS
 DEC
:PUOK TAX
 INX
 STZ :PUCNTR
 STZ :PUFLAG
]LOOP PHX
 LDA #0
 JSR LOADINV
 BIT INVFREE
 BMI :PUNEXT
 LDA INVSTOCK
 BEQ :PUNEXT
 INC :PUCNTR
 LDA :PUCNTR
 CMP #4
 BNE :PUNEXT
 PLX
 DEX
 STX :CNTR
 JMP :TOP
:PUNEXT PLX
 DEX
 BNE ]LOOP
 LDX :ITEMS
 LDA :PUFLAG
 EOR #$FF
 STA :PUFLAG
 BMI ]LOOP
 LDA :TOPC
 STA :CNTR
:PAGEDOWN JMP :TOP

:PUCNTR DS 1
:PUFLAG DS 1

:DOPNTR LDA :OLDPNTR
 CLC
 ADC #18
 STA :PV1+3
 JSR PRINT
:PV1 GOTOXY 0;0
 ASC " "
 NULL
 LDA :PNTR
 CLC
 ADC #18
 STA :PV2+3
 JSR PRINT
:PV2 GOTOXY 0;0
 NULL
 JSR SHOWPNTR
 LDA :PNTR
 STA :OLDPNTR
 RTS

:BUYIT LDX :PNTR
 LDA :PTBL,X
 TAX
 STX :ITEM
 LDA #0
 JSR LOADITEM
 JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 CURSORON
 PRSTRING INAME
 NULL

 LDX #3
]LOOP LDA PLRGOLD,X
 CMP ICOST,X
 BEQ :GNXT
 BCS :AFFORD
 JSR PRINT
 ASC " - "
 COLOR PINK
 ASC "you can't afford it. "
 COLOR WHITE
 SOUND $13;1;LOUD
 NULL
 GETRETURN
 JMP :BOT
:GNXT DEX
 BPL ]LOOP
:AFFORD LDA PLRITEM+7
 BEQ :SPACE
 JSR PRINT
 ASC " - "
 COLOR PINK
 ASC "you cannot hold any more items. "
 COLOR WHITE
 SOUND $13;1;LOUD
 NULL
 GETRETURN
 JMP :EXIT
:SPACE JSR PRINT
 ASC ". Ok (y/N)? : "
 NULL
 JSR KEYIN
 JSR UPPER
 CMP #"Y"
 BNEL :BOT
 JSR PRINT
 ASC "Yes"
 NULL
 CLC
 XCE
 REP #$30
 LDA PLRGOLD
 SEC
 SBC ICOST
 STA PLRGOLD
 LDA PLRGOLD+2
 SBC ICOST+2
 STA PLRGOLD+2
 SEC
 XCE
 LDX #0
]LOOP LDA PLRITEM,X
 BEQ :SPACE2
 INX
 CPX #8
 BNE ]LOOP
 DEATH
:SPACE2 LDA :ITEM
 STA PLRITEM,X
 PHX
 LDA PLRCLASS
 JSR CHECKUSE ;Can we use this item?
 BCC :YESCAN
 LDA #2 ;Unusable
 HEX 2C
:YESCAN LDA #0 ;Can use
 PLX
 STA PLRITEMX,X
 LDX :REC
 LDA :REC+1
 JSR SAVEPLR
 LDX :ITEM ;Dec total in stock
 LDA #0
 JSR LOADINV
 DEC INVSTOCK
 LDA INVSTOCK
 STA :MOD+1
 LDX :ITEM
 LDA #0
 JSR SAVEINV
 JSR PRINT
 ASC ". Another (Y/n)? : "
 NULL
 JSR KEYIN
 JSR UPPER
 CMP #"N"
 BNE :MOD
 LDA :PADFLAG
 STA PADFLAG
 LDA :PADCHAR
 STA PADCHAR
 JMP :BUY2
:MOD LDA #$FF
 BNEL :BOT
 LDA :TOPC
 STA :CNTR
 JMP :TOP

:TBL DA :TYPE1
 DA :TYPE2
 DA :TYPE3
 DA :TYPE4
 DA :TYPE5
 DA :TYPE6

:TYPE1 STR "Weapon"
:TYPE2 STR "Armour"
:TYPE3 STR "Shield"
:TYPE4 STR "Helmet"
:TYPE5 STR "Gloves"
:TYPE6 STR "Misc. "

:CTYPES DFB $D ;Pink
 DFB $A ;Green
 DFB $E ;Aquamarine
 DFB $2 ;Dark green
 DFB $6 ;Aqua?
 DFB $7 ;Purple

:REC DS 2
:PLRS DS 1
:CNTR DS 1
:CNTR2 DS 1
:ITEMS DS 1
:ITEM DS 1
:PNTR DS 1
:OLDPNTR DS 1
:PADFLAG DS 1
:PADCHAR DS 1
:PTBL DS 8
:TOPC DS 1

STATS JSR PRINT
 GOTOXY 0;16
 CLEOS
 NULL
 CALL "GAME.PLRSTAT"
 JMP DOKEY

TRADE CALL "GAME.TRADE"
 JSR PRINT
 SOUND $1F;FOREVER;$60
 NULL
 JMP DOKEY

POOL JSR PRINT
 GOTOXY 0;16
 CLEOS
 CURSORON
 ASC "[P]ool, [S]hare, [ESC]-exit : "
 NULL
]LOOP JSR KEYIN
 JSR UPPER
 CMP #"P"
 BEQ :POOL2
 CMP #"S"
 BEQ SHARE
 CMP #$9B
 BNE ]LOOP
 JSR PRINT
 ZAPLINE
 CURSOROFF
 NULL
 JMP DOKEY
:POOL2 STZ POOLER
 JSR POOL2
 JMP DOKEY
POOLER DS 1
POOLPLRS DS 1

SHARE JSR PRINT
 GOTOXY 0;16
 CLEOS
 NULL
 LDX NUMPARTY
]LOOP LDA CURPARTY2-1,X
 BNE :OK
 LDA CURPARTY-1,X
 BNE :OK
 DEX
 BNE ]LOOP
:OK STX :PLRS
 CPX #0
 BNE :OK2
 JSR PRINT
 COLOR PINK
 ASC "No-one in the party. "
 SOUND $02;1;LOUD
 COLOR WHITE
 NULL
 GETRETURN
:EXIT JSR PRINT
 GOTOXY 0;16
 CLEOS
 CURSOROFF
 NULL
 JMP DOKEY
:OK2 CPX #1
 BEQ :EXIT
 JSR PRINT
 GOTOXY 0;16
 CLEOS
 ASC "Sharing.."
 NULL
 STZ :GOLD ;Get total gold from all players
 STZ :GOLD+1
 STZ :GOLD+2
 STZ :GOLD+3
 STZ :PLRSC
 LDX :PLRS
]LOOP STX VTEMP
 LDA CURPARTY-1,X
 TAY
 LDA CURPARTY2-1,X
 TYX
 JSR LOADPLR
 LDA PLRZPOS ;In Castle?
 BNE :NXTSHRE
 INC :PLRSC
 CLC
 XCE
 REP #$30
 LDA :GOLD
 CLC
 ADC PLRGOLD
 STA :GOLD
 LDA :GOLD+2
 ADC PLRGOLD+2
 STA :GOLD+2
 SEC
 XCE
:NXTSHRE DEC VTEMP
 LDX VTEMP
 BNE ]LOOP

 CLC
 XCE
 REP #$30
 PushLong #0
 PushLong #0
 PushLong :GOLD ;Divide this..
 PushLong :PLRSC ;..by this..
 Tool $0D0B ;LongDivide
 PullLong :DIV ;..and get this..
 PullLong :REMAIN ;..and the remainder
 SEC
 XCE

 LDX :PLRS
]LOOP STX VTEMP
 LDA CURPARTY-1,X
 TAY
 LDA CURPARTY2-1,X
 TYX
 JSR LOADPLR
 LDA PLRZPOS ;In Castle?
 BNE :NXTDIVY
 CLC
 XCE
 REP #$30
 LDA :DIV
 STA PLRGOLD
 LDA :DIV+2
 STA PLRGOLD+2
 LDA VTEMP
 CMP #1
 BNE :NOTP1
 LDA PLRGOLD
 CLC
 ADC :REMAIN
 STA PLRGOLD
 LDA PLRGOLD+2
 ADC :REMAIN+2
 STA PLRGOLD+2
:NOTP1 SEC
 XCE
 LDX VTEMP
 LDA CURPARTY-1,X
 TAY
 LDA CURPARTY2-1,X
 TYX
 JSR SAVEPLR
:NXTDIVY DEC VTEMP
 LDX VTEMP
 BNE ]LOOP

 JSR PRINT
 ZAPLINE
 HTAB 0
 ASC "Shared approx. "
 COLOR YELLOW
 DEC32 :DIV
 COLOR WHITE
 ASC " GP each (in Castle only)."
 CURSOROFF
 NULL
 JMP DOKEY

:PLRS DS 1
:PLRSC DS 4 ;For DIVISOR (LongDivide)
:GOLD DS 4 ;Total
:DIV DS 4 ;Shared amount for each player
:REMAIN DS 4 ;Remainder will go to first player

POOL2 JSR PRINT
 GOTOXY 0;16
 CLEOS
 NULL
 LDA POOLER
 BEQ :POOLZ
 LDA POOLPLRS
 STA :PLRS
 LDX POOLER
 JMP :FROMBUY
:POOLZ LDX NUMPARTY
]LOOP LDA CURPARTY2-1,X
 BNE :OK
 LDA CURPARTY-1,X
 BNE :OK
 DEX
 BNE ]LOOP
:OK STX :PLRS
 CPX #0
 BNE :OK2
 JSR PRINT
 COLOR PINK
 ASC "No-one in the party to pool gold to. "
 SOUND $02;1;LOUD
 COLOR WHITE
 NULL
 GETRETURN
:EXIT JSR PRINT
 GOTOXY 0;16
 CLEOS
 CURSOROFF
 NULL
 RTS
:OK2 CPX #1
 BEQ :EXIT
 JSR SHOWNAMES
 JSR PRINT
 ASC "Who will pool gold (1-"
 DEC8 :PLRS
 ASC ")? : "
 NULL
]LOOP JSR KEYIN
 CMP #$9B
 BEQ :EXIT
 SEC
 SBC #"1"
 CMP :PLRS
 BCS ]LOOP
 PHA
 CLC
 ADC #"1"
 JSR COUT
 PLX
:FROMBUY LDA CURPARTY,X
 STA :REC
 LDA CURPARTY2,X
 STA :REC+1

 LDX :REC
 LDA :REC+1
 JSR LOADPLR
 LDA PLRCOND
 AND #%1000_0000 ;Dead?
 BEQ :ALIVE
 JSR PRINT
 CR
 COLOR PINK
 PRSTRING PLRNAME
 ASC " is dead. "
 SOUND $13;1;LOUD
 COLOR WHITE
 NULL
 GETRETURN
 JMP POOL2
:ALIVE LDA PLRZPOS
 BEQ :CASTLE
 JSR PRINT
 CR
 COLOR PINK
 PRSTRING PLRNAME
 ASC " is not here. "
 SOUND $02;1;LOUD
 COLOR WHITE
 NULL
 GETRETURN
 JMP POOL2
:CASTLE JSR PRINT
 GOTOXY 0;16
 CLEOS
 ASC "Pooling.."
 CURSOROFF
 NULL

 LDX #3
]LOOP STZ :CASH,X
 DEX
 BPL ]LOOP

 LDX #0
]LOOP PHX
 LDA CURPARTY,X
 STA :REC2
 TAY
 LDA CURPARTY2,X
 STA :REC2+1
 TYX
 JSR LOADPLR
 LDA PLRZPOS
 BNE :INDNG
 CLC
 XCE
 REP #$30
 LDA :CASH
 CLC
 ADC PLRGOLD
 STA :CASH
 LDA :CASH+2
 ADC PLRGOLD+2
 STA :CASH+2
 STZ PLRGOLD
 STZ PLRGOLD+2
 SEC
 XCE
 LDX :REC2
 LDA :REC2+1
 JSR SAVEPLR
:INDNG PLX
 INX
 CPX :PLRS
 BNE ]LOOP

 LDX :REC
 LDA :REC+1
 JSR LOADPLR
 LDX #3
]LOOP LDA :CASH,X
 STA PLRGOLD,X
 DEX
 BPL ]LOOP
 LDX :REC
 LDA :REC+1
 JSR SAVEPLR
 LDA POOLER
 BNE :POOLRTS
 JSR PRINT
 HTAB 0
 ZAPLINE
 CURSORON
 PRSTRING PLRNAME
 ASC " now has "
 COLOR YELLOW
 DEC32 PLRGOLD
 COLOR WHITE
 ASC " gold."
 CURSOROFF
 NULL
:POOLRTS RTS
:REC DS 2
:REC2 DS 2
:PLRS DS 1
:CASH DS 4

SELL JSR PRINT
 GOTOXY 0;15
 CLEOS
 CR
 CURSORON
 NULL
 LDX NUMPARTY
]LOOP LDA CURPARTY2-1,X
 BNE :OK
 LDA CURPARTY-1,X
 BNE :OK
 DEX
 BNE ]LOOP
:OK STX :PLRS
 CPX #0
 BNE :OK2
 JSR PRINT
 COLOR PINK
 ASC "No-one in the party to sell. "
 SOUND $02;1;LOUD
 COLOR WHITE
 NULL
 GETRETURN
:EXIT JSR PRINT
 GOTOXY 0;15
 CLEOS
 CURSOROFF
 NULL
 JMP DOKEY
:OK2 JSR SHOWNAMES
 JSR PRINT
 ASC "Who will sell (1-"
 DEC8 :PLRS
 ASC ")? : "
 NULL
]LOOP JSR KEYIN
 CMP #$9B
 BEQL :EXIT
 SEC
 SBC #"1"
 CMP :PLRS
 BCS ]LOOP
 PHA
 CLC
 ADC #"1"
 JSR COUT
 JSR PRINT
 CLEOS
 NULL
 PLX
 LDA CURPARTY,X
 STA :REC
 TAY
 LDA CURPARTY2,X
 STA :REC+1
 TYX
 JSR LOADPLR
 LDA PLRCOND
 AND #%1000_0000 ;Dead?
 BEQ :ALIVE
 JSR PRINT
 CR
 COLOR PINK
 PRSTRING PLRNAME
 ASC " is dead. "
 SOUND $13;1;LOUD
 COLOR WHITE
 NULL
 GETRETURN
 JMP SELL
:ALIVE LDA PLRZPOS ;In Castle?
 BEQ :TOPSELL
 JSR PRINT
 CR
 COLOR PINK
 PRSTRING PLRNAME
 ASC " is not here. "
 SOUND $02;1;LOUD
 COLOR WHITE
 NULL
 GETRETURN
 JMP SELL
:TOPSELL JSR PRINT
 GOTOXY 0;15
 CLEOS
 NULL

 LDA PLRITEM
 BNE :IOK
 JSR PRINT
 COLOR GREEN
 PRSTRING PLRNAME
 COLOR PINK
 ASC " has nothing to sell. "
 SOUND $25;1;LOUD
 COLOR WHITE
 NULL
 GETRETURN
 JMP SELL

:IOK MLI_GET_TIME ;Check for a newly created char
 LDXA $BF90 ;Created today?
 CPXA PLRMADE
 BNE :IOK2
 LDA PLREXP
 ORA PLREXP+1
 ORA PLREXP+2
 ORA PLREXP+3
 BNE :IOK2
 JSR PRINT
 COLOR GREEN
 PRSTRING PLRNAME
 COLOR PINK
 ASC " has nothing I want. "
 SOUND $25;1;LOUD
 COLOR WHITE
 NULL
 GETRETURN
 JMP SELL

:IOK2 LDA #<PLRITEM
 STA :I+2
 LDA #15
 STA :SHV+3
 LDX #0
]LOOP STX :CNTR
 INC :CNTR
 LDA PLRITEM,X
 BEQ :NEXT
 TAX
 LDA #0
 JSR LOADITEM
 CLC
 XCE
 REP #$30
 LSR ICOST+2 ;Halve cost to get selling price
 ROR ICOST
 LDA ICOST
 STA :PRICE
 LDA ICOST+2
 STA :PRICE+2
 SEC
 XCE
 JSR PRINT
:SHV GOTOXY 40;15
 DEC8 :CNTR
 ASC ")"
:I PRITEM PLRITEM
 HTAB 65
 COLOR YELLOW
 DEC32 :PRICE
 COLOR WHITE
 NULL
 INC :SHV+3
:NEXT INC :I+2
 LDX :CNTR
 CPX #8
 BNE ]LOOP

:TOP JSR PRINT
 GOTOXY 0;16
 PRSTRING PLRNAME
 ASC ", sell : "
 NULL

]LOOP JSR KEYIN
 CMP #$9B
 BEQL SELL
 CMP #"1"
 BCC ]LOOP
 CMP #"8"+1
 BCS ]LOOP
 SEC
 SBC #"0"
 STA :ITEM

 LDX #40
 LDY #41
 CLC
 ADC #14
 JSR PICKLINE
 LDA $200
 CMP #" "
 BEQ ]LOOP
 LDX :ITEM
 LDA PLRITEM-1,X
 TAX
 LDA #0
 JSR LOADITEM
 LDX :ITEM
 LDA PLRITEM-1,X
 TAX
 LDA #0
 JSR LOADINV
 LDA INVSTOCK
 CMP #100
 BCS :NOWANT
 JSR PRINT
 GOTOXY 0;23
 ASC "Sell your "
 COLOR ORANGE
 PRSTRING INAME
 COLOR WHITE
 ASC " (y/N)? : "
 NULL
 JSR KEYIN
 JSR UPPER
 CMP #"Y"
 BEQ :YEP
 JSR PRINT
 ZAPLINE
 NULL
 JMP :TOP
:NOWANT JSR PRINT
 GOTOXY 0;23
 COLOR PINK
 ASC "Don't want that "
 COLOR GREEN
 PRSTRING INAME
 COLOR PINK
 ASC " - I have enough of those. "
 COLOR WHITE
 NULL
 GETRETURN
 JMP :TOPSELL
:YEP JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 ASC "Good.."
 PRPAUSE 2
 NULL
 LDX :ITEM ;Inc total in stock
 LDA PLRITEM-1,X
 TAX
 LDA #0
 JSR LOADINV
 INC INVSTOCK
 LDX :ITEM
 LDA PLRITEM-1,X
 TAX
 LDA #0
 JSR SAVEINV
 CLC
 XCE
 REP #$30
 LSR ICOST+2 ;Halve cost to get selling price
 ROR ICOST
 LDA ICOST
 STA :PRICE
 LDA ICOST+2
 STA :PRICE+2
 LDA PLRGOLD
 CLC
 ADC :PRICE
 STA PLRGOLD
 LDA PLRGOLD+2
 ADC :PRICE+2
 STA PLRGOLD+2
 SEC
 XCE
 LDX :ITEM
]LOOP CPX #8
 BEQ :ZAP7
 LDA PLRITEM,X
 STA PLRITEM-1,X
 LDA PLRITEMX,X
 STA PLRITEMX-1,X
 INX
 BRA ]LOOP
:ZAP7 STZ PLRITEM+7
 STZ PLRITEMX+7
 LDX :REC
 LDA :REC+1
 JSR SAVEPLR
 LDA PLRITEM
 BNEL :TOPSELL
 JMP :EXIT
:REC DS 2
:PLRS DS 1
:PRICE DS 4
:ITEM DS 1
:CNTR DS 1

LEAVE JSR PRINT
 HOME
 CURSORON
 NULL
 RETURN

]LEN = 8
TYPETABLE DFB ]LEN
 ENTRY "<unknown>"
 ENTRY "Weapon"
 ENTRY "Armour"
 ENTRY "Shield"
 ENTRY "Helmet"
 ENTRY "Gloves"
 ENTRY "Misc. "

SCENITEMS DS $10

SHOWNAMES LDX NUMPARTY
]LOOP LDA CURPARTY2-1,X
 ORA CURPARTY-1,X
 BNE :OK
 DEX
 BNE ]LOOP
 RTS
:OK STX :TEMP
 LDA CH
 STA :HV+2
 LDA CV
 STA :HV+3
 STZ :NUM
 LDX #0
]LOOP PHX
 LDA CURPARTY,X
 TAY
 LDA CURPARTY2,X
 TYX
 JSR LOADPLR
 INC :NUM
 JSR PRINT
 HTAB 40
 NULL
 LDA PLRZPOS
 BEQ :CASTLE
 JSR PRINT
 COLOR PINK
 NULL
 BRA :CONT
:CASTLE JSR PRINT
 COLOR AQUAMARINE
 NULL
:CONT JSR PRINT
 DEC8 :NUM
 ASC ") "
 PRSTRING PLRNAME
 CR
 NULL
 PLX
 INX
 CPX :TEMP
 BNE ]LOOP
 JSR PRINT
 COLOR WHITE
:HV GOTOXY 0;0
 NULL
 RTS
:TEMP DS 1
:NUM DS 1

 LST ON
MODEND EQU *
 LST OFF

 do M16PLUS
 SAV RUN/MODULES/GAME.SHOP
 fin

 END
