*-------------------------------
* GAME.SPELL (part 3)
*-------------------------------
 DAT
 LST OFF

 REL

 USE MACROS
 USE EQUATES
 USE VARS
 USE LIB.JMP
 USE PLR.DSECT
 USE MON.DSECT
 USE MON2.DSECT
 USE SPELL.DSECT
 USE PN.DSECT
 USE SCEN.DSECT

 do M16PLUS-1
 DSK SPELL3.L
 fin

 EXT GETVIEW,TOP,ABORT,NOTHING,FAILED,SPELLEND,SQUARE,DRAWSTATS
 EXT NPRTY,ANKX,ANKY,LOGEXCEPTION,LOGLINE,PLR,TOOFAR,LOADMAST
 EXT XPOS,YPOS,LEVEL,SPLAYERS,SMONSTERS,DOTYPE,DOROLL,LOGSPELL
 EXT SCENMONS,MONKILLED,MASTPLR,FAILEDEX,UNKNOWN,MASTEND

STUN = 0
BLIND = 1
LEVITATE = 2
SLEEP = 3
INVISIBLE = 4
POISON = 5
PARALYZE = 6
DIE = 7

UNSTUN = 8
UNBLIND = 9
UNLEVITATE = 10
UNSLEEP = 11
UNINVISIBLE = 12
UNPOISON = 13
UNPARALYZE = 14
UNDIE = 15

CLE11 ENT
:TOP JSR PRINT ;Rizap
 GOTOXY 0;21
 ZAPLINE
 ASC "Wake up party member #"
 NULL
]LOOP JSR KEYIN
 CMP #$9B
 BEQL ABORT
 SEC
 SBC #"1"
 CMP NPRTY
 BCS ]LOOP
 TAX
 LDA CURPARTY,X
 STA PLR
 LDA CURPARTY2,X
 STA PLR+1
 LDX PLR
 LDA PLR+1
 JSR LOADPLR
 JSR PRINT
 GOTOXY 0;21
 ZAPLINE
 ASC "Wake up "
 PRSTRING PLRNAME
 ASC " (y/N)? : "
 NULL
 JSR KEYIN
 JSR UPPER
 CMP #"Y"
 BNE :TOP
 LDA PLRZPOS
 CMP LEVEL
 BEQ :OK
 JMP TOOFAR
:OK LDA PLRCOND
 AND #%0000_1000
 BNE :ASLEEP
 JSR PRINT
 GOTOXY 40;21
 CLEOL
 PRSTRING PLRNAME
 ASC " is not asleep"
 NULL
 JMP FAILEDEX
:ASLEEP JSR PRINT
 GOTOXY 0;21
 ZAPLINE
 PRSTRING PLRNAME
 ASC " is now awake"
 NULL
 LDA #%0000_1000
 TRB PLRCOND
 LDX #SLEEP
 STZ PLRCONDX,X
LOGPEND LDX PLR
 LDA PLR+1
 JSR SAVEPLR
 LDA #$FF
 STA DRAWSTATS
 STA LOGEXCEPTION
 JMP SPELLEND

CLE12 ENT
:TOP JSR PRINT ;Minel
 GOTOXY 0;21
 ZAPLINE
 ASC "Heal party member #"
 NULL
]LOOP JSR KEYIN
 CMP #$9B
 BEQL ABORT
 SEC
 SBC #"1"
 CMP NPRTY
 BCS ]LOOP
 TAX
 LDA CURPARTY,X
 STA PLR
 LDA CURPARTY2,X
 STA PLR+1
 LDX PLR
 LDA PLR+1
 JSR LOADPLR
 JSR PRINT
 GOTOXY 0;21
 ZAPLINE
 ASC "Heal "
 PRSTRING PLRNAME
 ASC " (y/N)? : "
 NULL
 JSR KEYIN
 JSR UPPER
 CMP #"Y"
 BNE :TOP
 LDA PLRZPOS
 CMP LEVEL
 BEQ :OK
 JMP TOOFAR
:OK LDA PLRCOND
 AND #%1000_0000
 BEQ :ALIVE
 JSR PRINT
 GOTOXY 40;21
 CLEOL
 PRSTRING PLRNAME
 ASC " is dead"
 SOUND $13;1;LOUD
 NULL
 JMP FAILED
:ALIVE LDX SPDAM
 LDA SPDAM+1
 JSR DOROLL
 STA :HP
 LDA PLRHP
 CLC
 ADC :HP
 STA PLRHP
 BMI :HPOK
 CMP PLRHP+1
 BCC :HPOK
 JSR PRINT
 GOTOXY 0;21
 ZAPLINE
 PRSTRING PLRNAME
 ASC " is restored to full HP"
 SOUND $15;1;LOUD
 NULL
 LDA PLRHP+1
 STA PLRHP
 BRA :CONT
:HPOK JSR PRINT
 GOTOXY 0;21
 ZAPLINE
 PRSTRING PLRNAME
 ASC " is restored by "
 DEC8 :HP
 ASC " HP"
 SOUND $15;1;LOUD
 NULL
:CONT JMP LOGPEND
:HP DS 1

CLE13 ENT
 LDA #PARALYZE ;Pazf
 JMP DOTYPE

CLE14 ENT
 LDA #BLIND ;Blaf
 JMP DOTYPE

CLE21 ENT
:TOP JSR PRINT ;Curbl
 GOTOXY 0;21
 ZAPLINE
 ASC "Cure blindness of party member #"
 NULL
]LOOP JSR KEYIN
 CMP #$9B
 BEQL ABORT
 SEC
 SBC #"1"
 CMP NPRTY
 BCS ]LOOP
 TAX
 LDA CURPARTY,X
 STA PLR
 LDA CURPARTY2,X
 STA PLR+1
 LDX PLR
 LDA PLR+1
 JSR LOADPLR
 JSR PRINT
 GOTOXY 0;21
 ZAPLINE
 ASC "Cure "
 PRSTRING PLRNAME
 ASC " (y/N)? : "
 NULL
 JSR KEYIN
 JSR UPPER
 CMP #"Y"
 BNE :TOP
 LDA PLRZPOS
 CMP LEVEL
 BEQ :OK
 JMP TOOFAR
:OK LDA PLRCOND
 AND #%0000_0010
 BNE :BLIND
 JSR PRINT
 GOTOXY 40;21
 CLEOL
 PRSTRING PLRNAME
 ASC " is not blind"
 NULL
 JMP FAILEDEX
:BLIND JSR PRINT
 GOTOXY 0;21
 ZAPLINE
 PRSTRING PLRNAME
 ASC " can see now"
 NULL
 LDA #%0000_0010
 TRB PLRCOND
 LDX #BLIND
 STZ PLRCONDX,X
 JMP LOGPEND

CLE22 ENT
 JMP CLE12 ;Majel

CLE23 ENT
 LDX SPDAM ;Halcast
 LDA SPDAM+1
 JSR DOROLL
 STA :HP
 LDA PLRHP
 CLC
 ADC :HP
 STA PLRHP
 BMI :HPOK
 CMP PLRHP+1
 BCC :HPOK
 JSR PRINT
 GOTOXY 0;21
 ZAPLINE
 PRSTRING PLRNAME
 ASC " is restored to full HP"
 SOUND $15;1;LOUD
 NULL
 LDA PLRHP+1
 STA PLRHP
 BRA :CONT
:HPOK JSR PRINT
 GOTOXY 0;21
 ZAPLINE
 PRSTRING PLRNAME
 ASC " is restored by "
 DEC8 :HP
 ASC " HP"
 SOUND $15;1;LOUD
 NULL
:CONT JMP MASTEND ;LOGPEND
:HP DS 1

CLE24 ENT
:TOP JSR PRINT ;Curpa
 GOTOXY 0;21
 ZAPLINE
 ASC "Cure poison from party member #"
 NULL
]LOOP JSR KEYIN
 CMP #$9B
 BEQL ABORT
 SEC
 SBC #"1"
 CMP NPRTY
 BCS ]LOOP
 TAX
 LDA CURPARTY,X
 STA PLR
 LDA CURPARTY2,X
 STA PLR+1
 LDX PLR
 LDA PLR+1
 JSR LOADPLR
 JSR PRINT
 GOTOXY 0;21
 ZAPLINE
 ASC "Cure "
 PRSTRING PLRNAME
 ASC " (y/N)? : "
 NULL
 JSR KEYIN
 JSR UPPER
 CMP #"Y"
 BNE :TOP
 LDA PLRZPOS
 CMP LEVEL
 BEQ :OK
 JMP TOOFAR
:OK LDA PLRCOND
 AND #%0010_0000
 BNE :POISON
 JSR PRINT
 GOTOXY 40;21
 CLEOL
 PRSTRING PLRNAME
 ASC " is not poisoned"
 NULL
 JMP FAILEDEX
:POISON JSR PRINT
 GOTOXY 0;21
 ZAPLINE
 PRSTRING PLRNAME
 ASC " is cured of poison"
 SOUND $15;1;LOUD
 NULL
 LDA #%0010_0000
 TRB PLRCOND
 LDX #POISON
 STZ PLRCONDX,X
 JMP LOGPEND

CLE31 ENT
 LDA SMONSTERS ;Blaffak
 STA :MONS
 LDA SMONSTERS+1
 STA :MONS+1
 STZ :CNTR
 LDA ANKX
 CLC
 ADC #9
 STA :XMAX
 LDA ANKY
 CLC
 ADC #9
 STA :YMAX
 LDA ANKX
 CMP #$10
 BCC :XMINOK
 LDA #0
:XMINOK STA :XMIN
 LDA ANKY
 CMP #$10
 BCC :YMINOK
 LDA #0
:YMINOK STA :YMIN
]LOOP LDX :MONS
 LDA :MONS+1
 JSR LOADMON2
 LDA MZPOS
 CMP LEVEL
 BNE :NEXT
 LDA MCOND
 AND #%1000_1000 ;Dead or asleep
 BNE :NEXT
 LDA MXPOS
 CMP :XMIN
 BEQ :X2
 BCC :NEXT
:X2 CMP :XMAX
 BCS :NEXT
 LDA MYPOS
 CMP :YMIN
 BEQ :Y2
 BCC :NEXT
:Y2 CMP :YMAX
 BCS :NEXT
 LDX MTYPE
 LDA MTYPE+1
 JSR LOADMON
 LDA MLEVEL
 BEQ :NEXT
 LDA MXPOS
 SEC
 SBC ANKX
 TAX
 LDA MYPOS
 SEC
 SBC ANKY
 TAY
 JSR GETGRID
 CMP #$FF
 BEQ :NEXT
 LDX SPDUR
 LDA SPDUR+1
 JSR DOROLL
 LDX #BLIND
 STA MCONDX,X
 LDA #%0000_0010 ;Blind
 TSB MCOND
 LDX :MONS
 LDA :MONS+1
 JSR SAVEMON2
 INC :CNTR
 JSR PRINT
 GOTOXY 0;21
 ZAPLINE
 DEC8 :CNTR
 NULL
:NEXT DECR :MONS
 LDA :MONS
 ORA :MONS+1
 BNEL ]LOOP
 LDA :CNTR
 BEQL FAILED
 JSR PRINT
 GOTOXY 0;21
 ZAPLINE
 ASC "Monsters blinded : "
 DEC8 :CNTR
 NULL
 JMP SPELLEND
:MONS DS 2
:XMAX DS 1
:YMAX DS 1
:XMIN DS 1
:YMIN DS 1
:CNTR DS 1

CLE32 ENT
 LDA #UNLEVITATE ;Ledfal
 JMP DOTYPE

CLE33 ENT
 JSR GETVIEW ;Dispund
 BCSL ABORT
 LDX XPOS
 LDY YPOS
 JSR GETMAP2
 CMP #0
 BEQL NOTHING
 STA SQUARE
 LDA SMONSTERS
 STA :MONS
 LDA SMONSTERS+1
 STA :MONS+1
 LDA SQUARE
 AND #%1111_0000
 BEQL NOTHING
 LSR
 LSR
 LSR
 LSR
 TAX
 LDA #0
 JSR RANDOM
 PHX
]LOOP LDX :MONS
 LDA :MONS+1
 JSR LOADMON2
 LDA MXPOS
 CMP XPOS
 BNE :NXTM
 LDA MYPOS
 CMP YPOS
 BNE :NXTM
 LDA MZPOS
 CMP LEVEL
 BNE :NXTM
 LDA MCOND
 AND #%1000_0000 ;Dead?
 BNE :NXTM
 PLX
 DEX
 BEQ :MDONE
 PHX
:NXTM DECR :MONS
 LDA :MONS
 ORA :MONS+1
 BNE ]LOOP
 JMP FAILED

:MDONE LDX MTYPE
 LDA MTYPE+1
 JSR LOADMON
 LDA MHABITAT
 CMP #5 ;Dark/undead
 BNEL FAILED
 JSR PRINT
 GOTOXY 0;21
 ZAPLINE
 COLOR ORANGE
 PRSTRING MNAME
 COLOR WHITE
 ASC " is banished!"
 NULL
 LDA #%1000_0000 ;Dead
 TSB MCOND
 LDA #$FF
 STA MCONDX+7
 LDX :MONS
 LDA :MONS+1
 JSR SAVEMON2
 LDX MXPOS
 LDY MYPOS
 LDA #-$10
 JSR PUTMAP2
 LDX MZPOS
 LDA #0
 JSR SAVEMAP2
 JMP SPELLEND
:MONS DS 2

CLE34 ENT
:TOP JSR PRINT ;Curpza
 GOTOXY 0;21
 ZAPLINE
 ASC "Cure paralysis of party member #"
 NULL
]LOOP JSR KEYIN
 CMP #$9B
 BEQL ABORT
 SEC
 SBC #"1"
 CMP NPRTY
 BCS ]LOOP
 TAX
 LDA CURPARTY,X
 STA PLR
 LDA CURPARTY2,X
 STA PLR+1
 LDX PLR
 LDA PLR+1
 JSR LOADPLR
 JSR PRINT
 GOTOXY 0;21
 ZAPLINE
 ASC "Cure "
 PRSTRING PLRNAME
 ASC " (y/N)? : "
 NULL
 JSR KEYIN
 JSR UPPER
 CMP #"Y"
 BNE :TOP
 LDA PLRZPOS
 CMP LEVEL
 BEQ :OK
 JMP TOOFAR
:OK LDA PLRCOND
 AND #%0100_0000
 BNE :BLIND
 JSR PRINT
 GOTOXY 40;21
 CLEOL
 PRSTRING PLRNAME
 ASC " is not paralyzed"
 NULL
 JMP FAILEDEX
:BLIND JSR PRINT
 GOTOXY 0;21
 ZAPLINE
 PRSTRING PLRNAME
 ASC " is cured of paralysis"
 SOUND $15;1;LOUD
 NULL
 LDA #%0100_0000
 TRB PLRCOND
 LDX #PARALYZE
 STZ PLRCONDX,X
 JMP LOGPEND

CLE41 ENT
 JSR PRINT ;Visep
 GOTOXY 0;21
 ZAPLINE
 NULL
 JSR LOGSPELL
 STZ :CNTR
 LDX #0
 LDY #0
]LOOP STX :X
 STY :Y
 TXA
 CLC
 ADC ANKX
 TAX
 TYA
 CLC
 ADC ANKY
 TAY
 CPX #$10
 BCS :NEXT
 CPY #$10
 BCS :NEXT
 STX :XLOC
 STY :YLOC
 JSR GETMAP
 CMP #SHPWALL
 BNE :NEXT
 CPX #WALLSECRET
 BEQ :YEP
 CPX #WALLSECRETVIS
 BEQ :YEP
:NEXT LDX :X
 LDY :Y
 INX
 CPX #9
 BNE ]LOOP
 LDX #0
 INY
 CPY #9
 BNE ]LOOP
 LDA :CNTR
 BNE :ENDOK
 JSR PRINT
 ASC "Nothing detected"
 SOUND $13;1;$80
 NULL
:ENDOK JMP SPELLEND
:YEP LDA CH
 BNE :YEP2
 JSR PRINT
 ASC "Passage at "
 NULL
 BRA :YEP3
:YEP2 JSR PRINT
 ASC " / "
 NULL
:YEP3 JSR PRINT
 PAD2 :XLOC
 ASC ","
 PAD2 :YLOC
 NULL
 INC :CNTR
 LDA CH
 CMP #63
 BCC :NEXT
 LDA #21
 JSR LOGLINE
 JSR PRINT
 VTAB 23
 CENTER " [More..] "
 CURSOROFF
 NULL
 JSR KEYIN
 JSR PRINT
 INVERSE
 ZAPLINE
 NORMAL
 GOTOXY 0;21
 ZAPLINE
 CURSORON
 NULL
 JMP :NEXT
:X DS 1
:Y DS 1
:XLOC DS 1
:YLOC DS 1
:CNTR DS 1

CLE42 ENT
 JSR PRINT
 GOTOXY 0;21
 ZAPLINE
 NULL
 LDA #$FF ;Mawiv
 STA MAPLOOK
 JSR LOADMAST
 LDX PLRXPOS
 LDY PLRYPOS
 LDA PLRZPOS
 JSR SHOWMAP
 JSR LOADMAST
 STZ MAPLOOK
 JMP SPELLEND

CLE43 ENT
 JMP CLE12 ;Gretel

CLE44 ENT
 JMP DOTYPE ;Akrid

CLE51 ENT
:TOP JSR PRINT ;Invankh
 GOTOXY 0;21
 ZAPLINE
 ASC "Make invisible party member #"
 NULL
]LOOP JSR KEYIN
 CMP #$9B
 BEQL ABORT
 SEC
 SBC #"1"
 CMP NPRTY
 BCS ]LOOP
 TAX
 LDA CURPARTY,X
 STA PLR
 LDA CURPARTY2,X
 STA PLR+1
 LDX PLR
 LDA PLR+1
 JSR LOADPLR
 JSR PRINT
 GOTOXY 0;21
 ZAPLINE
 ASC "Make "
 PRSTRING PLRNAME
 ASC " invisible (y/N)? : "
 NULL
 JSR KEYIN
 JSR UPPER
 CMP #"Y"
 BNE :TOP
 LDA PLRZPOS
 CMP LEVEL
 BEQ :OK
 JMP TOOFAR
:OK JSR PRINT
 GOTOXY 0;21
 ZAPLINE
 PRSTRING PLRNAME
 ASC " is now invisible"
 SOUND $15;1;LOUD
 NULL
 LDX SPDUR
 CPX #$FF
 BEQ :PERM
 LDX SPDUR
 LDA SPDUR+1
 JSR DOROLL
 HEX 2C
:PERM LDA #$FF
 LDX #INVISIBLE
 STA PLRCONDX,X
 LDA #%0001_0000
 TSB PLRCOND
 JMP LOGPEND

CLE52 ENT
 JMP DOTYPE ;Blotnig

CLE53 ENT
:TOP JSR PRINT ;Contel
 GOTOXY 0;21
 ZAPLINE
 ASC "Heal/cure party member #"
 NULL
]LOOP JSR KEYIN
 CMP #$9B
 BEQL ABORT
 SEC
 SBC #"1"
 CMP NPRTY
 BCS ]LOOP
 TAX
 LDA CURPARTY,X
 STA PLR
 LDA CURPARTY2,X
 STA PLR+1
 LDX PLR
 LDA PLR+1
 JSR LOADPLR
 JSR PRINT
 GOTOXY 0;21
 ZAPLINE
 ASC "Heal/cure "
 PRSTRING PLRNAME
 ASC " (y/N)? : "
 NULL
 JSR KEYIN
 JSR UPPER
 CMP #"Y"
 BNE :TOP
 LDA PLRZPOS
 CMP LEVEL
 BEQ :OK
 JMP TOOFAR
:OK LDA PLRCOND
 AND #%1000_0000
 BEQ :ALIVE
 JSR PRINT
 GOTOXY 40;21
 CLEOL
 PRSTRING PLRNAME
 ASC " is dead"
 SOUND $13;1;LOUD
 NULL
 JMP FAILED
:ALIVE JSR PRINT
 GOTOXY 0;21
 ZAPLINE
 PRSTRING PLRNAME
 ASC " is restored to full HP"
 SOUND $15;1;LOUD
 NULL
 LDA PLRHP+1
 STA PLRHP
 LDA PLRCOND
 AND #%0110_1011
 BEQ :FINE
 LDA #%0110_1011
 TRB PLRCOND
 LDX #PARALYZE
 STZ PLRCONDX,X
 LDX #POISON
 STZ PLRCONDX,X
 LDX #SLEEP
 STZ PLRCONDX,X
 LDX #BLIND
 STZ PLRCONDX,X
 LDX #STUN
 STZ PLRCONDX,X
 JSR PRINT
 ASC " & cured"
 SOUND $15;1;LOUD
 NULL
:FINE JMP LOGPEND
:HP DS 1

CLE54 ENT
 LDA SMONSTERS ;Gredat
 STA :MONS
 LDA SMONSTERS+1
 STA :MONS+1
 JSR LOGSPELL
 JSR PRINT
 GOTOXY 0;21
 ZAPLINE
 NULL
 STZ :CNTR
 LDA ANKX
 CLC
 ADC #9
 STA :XMAX
 LDA ANKY
 CLC
 ADC #9
 STA :YMAX
 LDA ANKX
 CMP #$10
 BCC :XMINOK
 LDA #0
:XMINOK STA :XMIN
 LDA ANKY
 CMP #$10
 BCC :YMINOK
 LDA #0
:YMINOK STA :YMIN
]LOOP LDX :MONS
 LDA :MONS+1
 JSR LOADMON2
 LDA MZPOS
 CMP LEVEL
 BNE :NEXT
 LDA MXPOS
 CMP :XMIN
 BEQ :X2
 BCC :NEXT
:X2 CMP :XMAX
 BCS :NEXT
 LDA MYPOS
 CMP :YMIN
 BEQ :Y2
 BCC :NEXT
:Y2 CMP :YMAX
 BCC :OK
:NEXT JMP :NEXT2
:UNAFF LDX MTYPE
 LDA MTYPE+1
 JSR LOADMON
 JSR PRINT
 COLOR ORANGE
 PRSTRING MNAME
 COLOR WHITE
 ASC " is not affected.."
 SOUND $13;1;LOUD
 NULL
 JMP :DOMORE
:OK LDA MCOND
 AND #%1000_0000 ;Dead
 BNE :NEXT
 LDA MCOND
 AND #%0100_1000 ;Paralyzed or asleep
 BNE :UNAFF
 LDX SPDAM
 LDA SPDAM+1
 JSR DOROLL
 STA VTEMP
 LDX MTYPE
 LDA MTYPE+1
 JSR LOADMON
 LDA MLEVEL
 BEQ :UNAFF
 JSR PRINT
 COLOR ORANGE
 PRSTRING MNAME
 COLOR WHITE
 ASC " takes "
 COLOR YELLOW
 DEC8 VTEMP
 COLOR WHITE
 ASC " damage"
 SOUND $11;1;LOUD
 NULL
 INC :CNTR
 LDA MCURHP
 SEC
 SBC VTEMP
 STA MCURHP
 BEQ :DEAD
 BCS :ALIVE
:DEAD JSR PRINT
 COLOR PINK
 ASC " and dies!"
 COLOR WHITE
 SOUND $0D;1;LOUD
 NULL
 LDX :MONS
 LDA :MONS+1
 JSR MONKILLED
:ALIVE LDX :MONS
 LDA :MONS+1
 JSR SAVEMON2
:DOMORE LDA #21
 JSR LOGLINE
 JSR PRINT
 VTAB 23
 CENTER " [More..] "
 CURSOROFF
 NULL
 JSR KEYIN
 JSR PRINT
 COLOR YELLOW
 INVERSE
 ZAPLINE
 NORMAL
 GOTOXY 0;21
 ZAPLINE
 CURSORON
 COLOR WHITE
 NULL
:NEXT2 DECR :MONS
 LDA :MONS
 ORA :MONS+1
 BNEL ]LOOP
 LDA :CNTR
 BEQL FAILED
 JMP SPELLEND
:MONS DS 2
:XMAX DS 1
:YMAX DS 1
:XMIN DS 1
:YMIN DS 1
:CNTR DS 1

CLE61 ENT
 JMP CLE51 ;Incacla

CLE62 ENT
 JSR GETVIEW ;Polmyst
 BCSL ABORT
 LDX XPOS
 LDY YPOS
 JSR GETMAP2
 CMP #0
 BEQL FAILED
 STA SQUARE
 LDA SMONSTERS
 STA :MONS
 LDA SMONSTERS+1
 STA :MONS+1
 LDA SQUARE
 AND #%1111_0000
 BEQL FAILED
 LSR
 LSR
 LSR
 LSR
 TAX
 LDA #0
 JSR RANDOM
 PHX
]LOOP LDX :MONS
 LDA :MONS+1
 JSR LOADMON2
 LDA MXPOS
 CMP XPOS
 BNE :NXTM
 LDA MYPOS
 CMP YPOS
 BNE :NXTM
 LDA MZPOS
 CMP LEVEL
 BNE :NXTM
 LDA MCOND
 AND #%1000_0000 ;Dead?
 BNE :NXTM
 PLX
 DEX
 BEQ :MDONE
 PHX
:NXTM DECR :MONS
 LDA :MONS
 ORA :MONS+1
 BNE ]LOOP
 DEATH

:MDONE LDX SCENMONS
 BEQ :FINE
]LOOP PHX
 LDA SCENMONS,X
 CMP MTYPE
 BEQL FAILED
 PLX
 DEX
 BNE ]LOOP
:FINE LDX SMONSTERS
 LDA SMONSTERS+1
 JSR RANDOM
 STX :NEWMON
 STA :NEWMON+1
 LDX SCENMONS
 BEQ :FINE2
]LOOP PHX
 LDA SCENMONS,X
 CMP :NEWMON
 BEQ :MDONE ;No good
 PLX
 DEX
 BNE ]LOOP

:FINE2 JSR PRINT
 GOTOXY 0;21
 ZAPLINE
 COLOR ORANGE
 PRSTRING MNAME
 COLOR WHITE
 ASC " is changed.."
 SOUND $15;1;LOUD
 PRPAUSE 1
 NULL
 LDA :NEWMON
 STA MTYPE
 LDA :NEWMON+1
 STA MTYPE+1
 LDX :MONS
 LDA :MONS+1
 JSR SAVEMON2
 LDX MTYPE
 LDA MTYPE+1
 JSR LOADMON
 JSR PRINT
 ASC " into a "
 COLOR ORANGE
 PRSTRING MNAME
 COLOR WHITE
 NULL
 JMP SPELLEND
:MONS DS 2
:NEWMON DS 2
:DAM DS 1

CLE63 ENT
:TOP JSR PRINT ;Lywake
 GOTOXY 0;21
 ZAPLINE
 ASC "Resurrect party member #"
 NULL
]LOOP JSR KEYIN
 CMP #$9B
 BEQL ABORT
 SEC
 SBC #"1"
 CMP NPRTY
 BCS ]LOOP
 TAX
 LDA CURPARTY,X
 STA PLR
 LDA CURPARTY2,X
 STA PLR+1
 LDX PLR
 LDA PLR+1
 JSR LOADPLR
 JSR PRINT
 GOTOXY 0;21
 ZAPLINE
 ASC "Resurrect "
 PRSTRING PLRNAME
 ASC " (y/N)? : "
 NULL
 JSR KEYIN
 JSR UPPER
 CMP #"Y"
 BNE :TOP
 LDA PLRZPOS
 CMP LEVEL
 BEQ :OK
 JMP TOOFAR
:OK LDA PLRHT
 CMP #2
 BCS :HTOK
 JSR PRINT
 GOTOXY 40;21
 CLEOL
 PRSTRING PLRNAME
 ASC " is beyond help"
 SOUND $13;1;LOUD
 NULL
 JMP FAILED
:HTOK LDA PLRCOND
 AND #%1000_0000
 BNE :ISDEAD
 JSR PRINT
 GOTOXY 40;21
 CLEOL
 PRSTRING PLRNAME
 ASC " is not dead"
 NULL
 JMP FAILEDEX
:ISDEAD JSR PRINT
 GOTOXY 0;21
 ZAPLINE
 PRSTRING PLRNAME
 ASC " is now alive!"
 SOUND $15;1;LOUD
 NULL
 LDX #DIE
 STZ PLRCONDX,X
 LDA #%1000_0000
 TRB PLRCOND
 DEC PLRHT
 JSR CALCPLR
 LDA #1
 STA PLRHP
 JMP LOGPEND

CLE64 ENT
:TOP JSR PRINT ;Recalst
 GOTOXY 0;21
 ZAPLINE
 ASC "Return to Castle party member #"
 NULL
]LOOP JSR KEYIN
 CMP #$9B
 BEQL ABORT
 SEC
 SBC #"1"
 CMP NPRTY
 BCS ]LOOP
 STA :N
 TAX
 LDA CURPARTY,X
 STA PLR
 LDA CURPARTY2,X
 STA PLR+1
 LDX PLR
 LDA PLR+1
 JSR LOADPLR
 JSR PRINT
 GOTOXY 0;21
 ZAPLINE
 ASC "Return "
 PRSTRING PLRNAME
 ASC " (y/N)? : "
 NULL
 JSR KEYIN
 JSR UPPER
 CMP #"Y"
 BNE :TOP
 JSR PRINT
 GOTOXY 0;21
 ZAPLINE
 PRSTRING PLRNAME
 ASC " is returned to the Castle"
 SOUND $15;1;LOUD
 NULL
 LDX PLRZPOS
 LDA #0
 JSR LOADMAP2
 LDX PLRXPOS
 LDY PLRYPOS
 LDA #-1
 JSR PUTMAP2
 LDX PLRZPOS
 LDA #0
 JSR SAVEMAP2
 STZ PLRXPOS
 STZ PLRYPOS
 STZ PLRZPOS
 LDX PLR
 LDA PLR+1
 JSR SAVEPLR
 LDX :N
]LOOP LDA CURPARTY+1,X
 STA CURPARTY,X
 LDA CURPARTY2+1,X
 STA CURPARTY2,X
 INX
 CPX NPRTY
 BCC ]LOOP
 DEC NPRTY
 LDX NPRTY
 STZ CURPARTY,X
 STZ CURPARTY2,X
 JSR LOADMAST
 LDX NPRTY
 BEQ :MPLROK
]LOOP LDA CURPARTY2-1,X
 CMP MPLR+1
 BNE :NONO
 LDA CURPARTY-1,X
 CMP MPLR
 BNE :NONO
 BRA :MPLROK
:NONO DEX
 BNE ]LOOP
:MPLROK STX MASTPLR
 LDA PLRZPOS
 BEQ :INC
 LDX PLRZPOS
 LDA #0
 JSR LOADMAP2
:INC LDA #$FF
 STA DRAWSTATS
 STA LOGEXCEPTION
 JMP SPELLEND
:NO JMP FAILED
:XMAX DS 1
:YMAX DS 1
:N DS 1

CLE71 ENT
CLE72 ENT
CLE73 ENT
CLE74 ENT
CLE81 ENT
CLE82 ENT
CLE83 ENT
CLE84 ENT
 JMP UNKNOWN

 LST ON
MODEND EQU *
 LST OFF

 do M16PLUS
 SAV SPELL3.L
 fin

 END
