*-------------------------------
* GAME.SPELL (part 4)
*-------------------------------
 DAT
 LST OFF

 REL

 USE MACROS
 USE EQUATES
 USE VARS
 USE TABLES
 USE LIB.JMP
 USE PLR.DSECT
 USE MON.DSECT
 USE MON2.DSECT
 USE SPELL.DSECT
 USE PN.DSECT
 USE SCEN.DSECT
 USE ITEM2.DSECT

 do M16PLUS-1
 DSK SPELL4.L
 fin

 EXT GETVIEW,TOP,ABORT,NOTHING,FAILED,SPELLEND,NPRTY,DRAWSTATS
 EXT LEVEL,SPLAYERS,SMONSTERS,DOTYPE,PLR,ANKX,ANKY,TYPEINFO,TOOFAR
 EXT CLRBOT,LOGLINE,LOGEXCEPTION,DOROLL,LOGSPELL,CHECKPOS
 EXT MONKILLED,CLE42,SAVEMAST,UNKNOWN

STUN = 0
BLIND = 1
LEVITATE = 2
SLEEP = 3
INVISIBLE = 4
POISON = 5
PARALYZE = 6
DIE = 7

UNSTUN = 8
UNBLIND = 9
UNLEVITATE = 10
UNSLEEP = 11
UNINVISIBLE = 12
UNPOISON = 13
UNPARALYZE = 14
UNDIE = 15

SAG11 ENT
 LDA #STUN ;Mestna
 JMP DOTYPE

SAG12 ENT
 LDA #SLEEP ;Melpan
 JMP DOTYPE

SAG13 ENT
 JSR CLRBOT ;Selif
 JSR LOGSPELL
 STZ :CNTR
 LDX #0
 LDY #0
]LOOP STX :X
 STY :Y
 TXA
 CLC
 ADC ANKX
 TAX
 TYA
 CLC
 ADC ANKY
 TAY
 CPX #$10
 BCSL :NEXT
 CPY #$10
 BCSL :NEXT
 STX :XLOC
 STY :YLOC
 JSR GETMAP
 CMP #0
 BEQL :NEXT
 LDA SPLAYERS
 STA :PLRS
 LDA SPLAYERS+1
 STA :PLRS+1
]LOOP2 LDX :PLRS
 LDA :PLRS+1
 JSR LOADPLR
 LDA PLRFREE
 BMI :NEXT1
 LDA PLRSCENARIO
 CMP SCENARIO
 BNE :NEXT1
 LDA PLRPARTY
 CMP PARTYNUM
 BEQ :NEXT1
 LDA PLRZPOS
 CMP LEVEL
 BNE :NEXT1
 LDA PLRXPOS
 CMP :XLOC
 BNE :NEXT1
 LDA PLRYPOS
 CMP :YLOC
 BNE :NEXT1
 LDA CH
 CLC
 ADC PLRNAME
 ADC #9
 CMP #79
 BCC :NAMEOK
 LDA CV
 CMP #22
 BEQL :DONE
 JSR LOGLINE
 JSR PRINT
 CR
 NULL
:NAMEOK LDA CH
 BEQ :NAMEOK2
 JSR PRINT
 ASC ", "
 NULL
:NAMEOK2 JSR PRINT
 PRSTRING PLRNAME
 ASC " ("
 PAD2 PLRXPOS
 ASC ","
 PAD2 PLRYPOS
 ASC ")"
 NULL
 INC :CNTR
:NEXT1 DECR :PLRS
 LDA :PLRS
 ORA :PLRS+1
 BNEL ]LOOP2
 STZ :CNTRM
 LDA SMONSTERS
 STA :PLRS
 LDA SMONSTERS+1
 STA :PLRS+1
 ORA :PLRS
 BEQL :NEXT
]LOOP2 LDX :PLRS
 LDA :PLRS+1
 JSR LOADMON2
 LDA MTYPE
 ORA MTYPE+1
 BEQ :NEXT1M
 LDA MZPOS
 CMP LEVEL
 BNE :NEXT1M
 LDA MXPOS
 CMP :XLOC
 BNE :NEXT1M
 LDA MYPOS
 CMP :YLOC
 BNE :NEXT1M
 LDX MTYPE
 LDA MTYPE+1
 JSR LOADMON
 LDA CH
 CLC
 ADC MNAME
 ADC #9
 CMP #79
 BCC :NAMEOKM
 LDA CV
 CMP #22
 BEQ :DONE
 JSR LOGLINE
 JSR PRINT
 CR
 NULL
:NAMEOKM LDA CH
 BEQ :NAMEOK2M
 JSR PRINT
 ASC ", "
 NULL
:NAMEOK2M JSR PRINT
 COLOR ORANGE
 PRSTRING MNAME
 COLOR WHITE
 ASC " ("
 PAD2 MXPOS
 ASC ","
 PAD2 MYPOS
 ASC ")"
 NULL
 INC :CNTRM
:NEXT1M DECR :PLRS
 LDA :PLRS
 ORA :PLRS+1
 BNEL ]LOOP2
:NEXT LDX :X
 LDY :Y
 INX
 CPX #9
 BNEL ]LOOP
 LDX #0
 INY
 CPY #9
 BNEL ]LOOP
 LDA :CNTR
 ORA :CNTRM
 BNE :DONE
 JSR PRINT
 ASC "Nothing detected"
 SOUND $13;1;LOUD
 NULL
:DONE LDA CV
 JSR LOGLINE
 JSR PRINT
 SOUND $15;1;LOUD
 NULL
 JMP SPELLEND
:PLRS DS 2
:X DS 1
:Y DS 1
:XLOC DS 1
:YLOC DS 1
:CNTR DS 1
:CNTRM DS 1

SAG14 ENT
 LDA #%0000_0100 ;Melevik
 TSB PLRCOND
 LDX SPDUR
 CPX #$FF
 BEQ :PERM
 LDA SPDUR+1
 JSR DOROLL
 HEX 2C
:PERM LDA #$FF
 LDX #LEVITATE
 STA PLRCONDX,X
 JSR PRINT
 GOTOXY 0;21
 ZAPLINE
 PRSTRING PLRNAME
 ASC " is now levitating"
 SOUND $15;1;LOUD
 NULL
 JSR SAVEMAST
 LDA #$FF
 STA DRAWSTATS
 STA LOGEXCEPTION
 JMP SPELLEND

SAG21 ENT
 JMP CLE42 ;Meclarv

SAG22 ENT
 LDA ANKX ;Metelp
 CLC
 ADC #9
 STA :XMAX
 LDA ANKY
 CLC
 ADC #9
 STA :YMAX
 LDA ANKX
 CMP #$10
 BCC :XMINOK
 LDA #0
:XMINOK STA :XMIN
 LDA ANKY
 CMP #$10
 BCC :YMINOK
 LDA #0
:YMINOK STA :YMIN
 JSR PRINT
 GOTOXY 0;21
 ZAPLINE
 ASC "Teleport to loc X="
 NULL
]LOOP GETLINE #2
 BCS :ZABRT
 CPX #0
 BEQ ]LOOP
 JSR GETNUM
 STX :XGOTO
 JSR PRINT
 ASC ", Y="
 NULL
]LOOP GETLINE #2
 BCS :ZABRT
 CPX #0
 BEQ ]LOOP
 JSR GETNUM
 STX :YGOTO

 LDA :XGOTO
 CMP :XMIN
 BEQ :X2
 BCC :NO
:X2 CMP :XMAX
 BCS :NO
 LDA :YGOTO
 CMP :YMIN
 BEQ :Y2
 BCC :NO
:Y2 CMP :YMAX
 BCS :NO
 LDA :XGOTO
 CMP #$10
 BCS :NO
 LDA :YGOTO
 CMP #$10
 BCS :NO
 LDX :XGOTO
 LDY :YGOTO
 JSR CHECKPOS
 BCC :SHPOK
:NO JMP FAILED
:ZABRT JMP ABORT

:SHPOK LDA :XGOTO
 SEC
 SBC ANKX
 TAX
 LDA :YGOTO
 SEC
 SBC ANKY
 TAY
 JSR GETGRID
 CMP #$FF
 BEQ :NO ;Can't see it
 LDX PLRZPOS
 LDA #0
 JSR LOADMAP2
 LDX PLRXPOS
 LDY PLRYPOS
 LDA #-1
 JSR PUTMAP2 ;Remove player from where he currently is
 LDX :XGOTO
 LDY :YGOTO
 LDA #1
 JSR PUTMAP2 ;Add player to new location
 LDX PLRZPOS
 LDA #0
 JSR SAVEMAP2
 JSR PRINT
 GOTOXY 0;21
 ZAPLINE
 PRSTRING PLRNAME
 ASC " teleported to "
 PAD2 :XGOTO
 ASC ","
 PAD2 :YGOTO
 SOUND $15;1;LOUD
 NULL
 LDA :XGOTO ;Update & save player
 STA PLRXPOS
 LDA :YGOTO
 STA PLRYPOS
 JSR SAVEMAST
 LDA #$FF
 STA LOGEXCEPTION
 JMP SPELLEND
:XMAX DS 1
:YMAX DS 1
:XMIN DS 1
:YMIN DS 1
:XGOTO DS 1
:YGOTO DS 1
:SHAPE DS 1

SAG23 ENT
 LDA #STUN ;Mebrash
 JMP DOTYPE

SAG24 ENT
 LDA SMONSTERS ;Mecrum
 STA :MONS
 LDA SMONSTERS+1
 STA :MONS+1
 JSR LOGSPELL
 JSR PRINT
 GOTOXY 0;21
 ZAPLINE
 NULL
 STZ :CNTR
 LDA ANKX
 CLC
 ADC #9
 STA :XMAX
 LDA ANKY
 CLC
 ADC #9
 STA :YMAX
 LDA ANKX
 CMP #$10
 BCC :XMINOK
 LDA #0
:XMINOK STA :XMIN
 LDA ANKY
 CMP #$10
 BCC :YMINOK
 LDA #0
:YMINOK STA :YMIN
]LOOP LDX :MONS
 LDA :MONS+1
 JSR LOADMON2
 LDA MZPOS
 CMP LEVEL
 BNE :NEXT
 LDA MXPOS
 CMP :XMIN
 BEQ :X2
 BCC :NEXT
:X2 CMP :XMAX
 BCS :NEXT
 LDA MYPOS
 CMP :YMIN
 BEQ :Y2
 BCC :NEXT
:Y2 CMP :YMAX
 BCC :OK
:NEXT JMP :NEXT2
:UNAFF LDX MTYPE
 LDA MTYPE+1
 JSR LOADMON
 JSR PRINT
 COLOR ORANGE
 PRSTRING MNAME
 COLOR WHITE
 ASC " is not affected.."
 SOUND $13;1;LOUD
 NULL
 JMP :DOMORE
:OK LDA MCOND
 AND #%1000_0000 ;Dead
 BNE :NEXT
 LDA MCOND
 AND #%0000_1001 ;Asleep or stunned
 BNE :UNAFF
 LDX SPDAM
 LDA SPDAM+1
 JSR DOROLL
 STA VTEMP
 LDX MTYPE
 LDA MTYPE+1
 JSR LOADMON
 LDA MLEVEL
 BEQ :UNAFF
 JSR PRINT
 COLOR ORANGE
 PRSTRING MNAME
 COLOR WHITE
 ASC " takes "
 COLOR YELLOW
 DEC8 VTEMP
 COLOR WHITE
 ASC " damage"
 SOUND $11;1;LOUD
 NULL
 INC :CNTR
 LDA MCURHP
 SEC
 SBC VTEMP
 STA MCURHP
 BEQ :DEAD
 BCS :ALIVE
:DEAD LDA #%1000_0000 ;Dead
 TSB MCOND
 LDA #$FF
 STA MCONDX+7
 JSR PRINT
 ASC " and dies!"
 SOUND $0D;1;LOUD
 NULL
 LDX :MONS
 LDA :MONS+1
 JSR MONKILLED
 LDX MXPOS
 LDY MYPOS
 LDA #-1
 JSR PUTMAP2M
 LDX LEVEL
 LDA #0
 JSR SAVEMAP2
:ALIVE LDX :MONS
 LDA :MONS+1
 JSR SAVEMON2
:DOMORE LDA #21
 JSR LOGLINE
 JSR PRINT
 VTAB 23
 CENTER " [More..] "
 CURSOROFF
 NULL
 JSR KEYIN
 JSR PRINT
 COLOR YELLOW
 INVERSE
 ZAPLINE
 NORMAL
 GOTOXY 0;21
 ZAPLINE
 CURSORON
 COLOR WHITE
 NULL
:NEXT2 DECR :MONS
 LDA :MONS
 ORA :MONS+1
 BNEL ]LOOP
 LDA :CNTR
 BEQL FAILED
 JMP SPELLEND
:MONS DS 2
:XMAX DS 1
:YMAX DS 1
:XMIN DS 1
:YMIN DS 1
:CNTR DS 1

SAG31 ENT
 JSR PRINT ;Mevisk
 GOTOXY 0;21
 ZAPLINE
 ASC "Enter persons name to inspect : "
 NULL
]LOOP GETLINE #20
 BCSL ABORT
 CPX #0
 BEQ ]LOOP
 STX :NAME
]LOOP LDA $200-1,X
 JSR UPPER
 STA :NAME,X
 DEX
 BNE ]LOOP
 JSR PRINT
 GOTOXY 0;21
 ZAPLINE
 PRSTRING SEARCHING
 NULL
 LDA SPLAYERS
 STA :PLRS
 LDA SPLAYERS+1
 STA :PLRS+1
]LOOP LDX :PLRS
 LDA :PLRS+1
 JSR LOADPLR
 LDA PLRFREE
 BMI :NEXT
 LDX PLRNAME
 CPX :NAME
 BNE :NEXT
]LOOP2 LDA PLRNAME,X
 JSR UPPER
 CMP :NAME,X
 BNE :NEXT
 DEX
 BNE ]LOOP2
 BEQ :GOTIT
:NEXT DECR :PLRS
 LDA :PLRS
 ORA :PLRS+1
 BNE ]LOOP
 JSR PRINT
 GOTOXY 40;21
 CLEOL
 ASC "Nothing.."
 SOUND $13;1;LOUD
 NULL
 JMP FAILED
:GOTIT LDX PLRPARTY
 LDA #0
 JSR LOADPN
 JSR CLRBOT
 JSR PRINT
 PRSTRING PLRNAME
 ASC " : lvl "
 DEC8 PLRLVLREAL
 ASC " "
 PRTABLE PLRCLASS;CLASSTABLE
 ASC ", with party '"
 PRSTRING PNNAME
 LINE "'"
 ASC "Age "
 DEC8 PLRAGE
 ASC ". Condition : "
 PRCOND PLRCOND
 CR
 ASC "Loc : "
 NULL
 LDA PLRZPOS
 BEQ :CASTLE
 JSR PRINT
 PAD2 PLRXPOS
 ASC ","
 PAD2 PLRYPOS
 ASC " lvl "
 DEC8 PLRZPOS
 SOUND $25;1;LOUD
 NULL
 BRA :FIN
:CASTLE JSR PRINT
 ASC "<castle>"
 NULL
:FIN LDX MPLR
 LDA MPLR+1
 JSR LOADPLR
 JSR LOGSPELL
 LDA #15
 JSR LOGLINE
 LDA #16
 JSR LOGLINE
 LDA #17
 JSR LOGLINE
 LDA #$FF
 STA LOGEXCEPTION
 JMP SPELLEND
:NAME DS 1+20
:PLRS DS 2

SAG32 ENT
 JSR PRINT ;Locap
 GOTOXY 0;21
 ZAPLINE
 ASC "Locate : "
 NULL
]LOOP GETLINE #20
 BCSL ABORT
 CPX #0
 BEQ ]LOOP
 STX :NAME
]LOOP LDA $200-1,X
 JSR UPPER
 STA :NAME,X
 DEX
 BNE ]LOOP
 JSR PRINT
 GOTOXY 0;21
 ZAPLINE
 PRSTRING SEARCHING
 NULL
 LDA SPLAYERS
 STA :PLRS
 LDA SPLAYERS+1
 STA :PLRS+1
]LOOP LDX :PLRS
 LDA :PLRS+1
 JSR LOADPLR
 LDA PLRFREE
 BMI :NEXT
 LDX PLRNAME
 CPX :NAME
 BNE :NEXT
]LOOP2 LDA PLRNAME,X
 JSR UPPER
 CMP :NAME,X
 BNE :NEXT
 DEX
 BNE ]LOOP2
 LDA PLRZPOS
 BNE :DUNG
 JSR PRINT
 GOTOXY 0;21
 ZAPLINE
 PRSTRING PLRNAME
 ASC " is in the Castle"
 SOUND $25;1;LOUD
 NULL
 JMP SPELLEND
:NEXT DECR :PLRS
 LDA :PLRS
 ORA :PLRS+1
 BNE ]LOOP
 JSR PRINT
 GOTOXY 40;21
 COLOR PINK
 ASC "Person not found."
 COLOR WHITE
 NULL
 JMP FAILED
:DUNG JSR PRINT
 GOTOXY 0;21
 ZAPLINE
 PRSTRING PLRNAME
 ASC " is at "
 PAD2 PLRXPOS
 ASC ","
 PAD2 PLRYPOS
 ASC " lvl "
 DEC8 PLRZPOS
 SOUND $25;1;LOUD
 NULL
 JMP SPELLEND
:NAME DS 1+20
:PLRS DS 2

SAG33 ENT
 LDA ANKX ;Blipak
 CLC
 ADC #9
 STA :XMAX
 LDA ANKY
 CLC
 ADC #9
 STA :YMAX
 LDA ANKX
 CMP #$10
 BCC :XMINOK
 LDA #0
:XMINOK STA :XMIN
 LDA ANKY
 CMP #$10
 BCC :YMINOK
 LDA #0
:YMINOK STA :YMIN
:TOP JSR PRINT
 GOTOXY 0;21
 ZAPLINE
 ASC "Teleport party member #"
 NULL
]LOOP JSR KEYIN
 CMP #$9B
 BEQL ABORT
 SEC
 SBC #"1"
 CMP NPRTY
 BCS ]LOOP
 TAX
 LDA CURPARTY,X
 STA PLR
 LDA CURPARTY2,X
 STA PLR+1
 LDX PLR
 LDA PLR+1
 JSR LOADPLR
 JSR PRINT
 GOTOXY 0;21
 ZAPLINE
 ASC "Teleport "
 PRSTRING PLRNAME
 ASC " (y/N)? : "
 NULL
 JSR KEYIN
 JSR UPPER
 CMP #"Y"
 BNE :TOP
 LDA PLRZPOS
 CMP LEVEL
 BNE :NO
 LDA PLRXPOS
 CMP :XMIN
 BEQ :X2
 BCC :NO
:X2 CMP :XMAX
 BCS :NO
 LDA PLRYPOS
 CMP :YMIN
 BEQ :Y2
 BCC :NO
:Y2 CMP :YMAX
 BCC :OK
:NO JMP TOOFAR
:OK STZ :CNTR
]LOOP INC :CNTR
 LDA :CNTR
 CMP #32
 BEQL FAILED
 RANDNUM #9
 DEX
 TXA
 CLC
 ADC ANKX
 CMP #$10
 BCS ]LOOP
 STA :XGOTO
 RANDNUM #9
 DEX
 TXA
 CLC
 ADC ANKY
 CMP #$10
 BCS ]LOOP
 STA :YGOTO
 LDX :XGOTO
 LDY :YGOTO
 JSR CHECKPOS
 BCS ]LOOP
 JSR PRINT
 GOTOXY 0;21
 ZAPLINE
 PRSTRING PLRNAME
 ASC " teleported"
 SOUND $15;1;LOUD
 NULL
 LDX PLRXPOS
 LDY PLRYPOS
 LDA #-1
 JSR PUTMAP2
 LDX :XGOTO
 LDY :YGOTO
 LDA #1
 JSR PUTMAP2
 LDX LEVEL
 LDA #0
 JSR SAVEMAP2
 LDA :XGOTO
 STA PLRXPOS
 LDA :YGOTO
 STA PLRYPOS
 LDX PLR
 LDA PLR+1
 JSR SAVEPLR
 LDA #$FF
 STA LOGEXCEPTION
 JMP SPELLEND
:XMAX DS 1
:YMAX DS 1
:XMIN DS 1
:YMIN DS 1
:XPOS DS 1
:YPOS DS 1
:XGOTO DS 1
:YGOTO DS 1
:CNTR DS 1

SAG34 ENT
 JSR PRINT ;Vistar
 GOTOXY 0;21
 ZAPLINE
 NULL
 JSR LOGSPELL
 STZ :CNTR
 LDX #0
 LDY #0
]LOOP STX :X
 STY :Y
 TXA
 CLC
 ADC ANKX
 TAX
 TYA
 CLC
 ADC ANKY
 TAY
 CPX #$10
 BCS :NEXT
 CPY #$10
 BCS :NEXT
 STX :XLOC
 STY :YLOC
 JSR GETMAP
 CMP #SHPSTAIRS
 BEQ :YEP
:NEXT LDX :X
 LDY :Y
 INX
 CPX #9
 BNE ]LOOP
 LDX #0
 INY
 CPY #9
 BNE ]LOOP
 LDA :CNTR
 BNE :ENDOK
 JSR PRINT
 ASC "Nothing detected"
 SOUND $13;1;LOUD
 NULL
:ENDOK JMP SPELLEND
:YEP LDA CH
 BEQ :YEP2
 JSR PRINT
 ASC " / "
 NULL
:YEP2 CPX #STAIRSDOWN
 BEQ :YEPD
 JSR PRINT
 ASC "Up"
 NULL
 BRA :LOC
:YEPD JSR PRINT
 ASC "Down"
 NULL
:LOC JSR PRINT
 ASC " at "
 PAD2 :XLOC
 ASC ","
 PAD2 :YLOC
 SOUND $25;1;LOUD
 NULL
 INC :CNTR
 LDA CH
 CMP #65
 BCC :NEXT
 LDA #21
 JSR LOGLINE
 JSR PRINT
 VTAB 23
 CENTER " [More..] "
 CURSOROFF
 NULL
 JSR KEYIN
 JSR PRINT
 INVERSE
 ZAPLINE
 NORMAL
 GOTOXY 0;21
 ZAPLINE
 CURSORON
 NULL
 JMP :NEXT
:X DS 1
:Y DS 1
:XLOC DS 1
:YLOC DS 1
:CNTR DS 1

SAG41 ENT
 JMP DOTYPE ;Fistol

SAG42 ENT
 JSR PRINT ;Parqui
 GOTOXY 0;21
 ZAPLINE
 ASC "Enter Party's name to locate : "
 NULL
]LOOP GETLINE #20
 BCSL ABORT
 CPX #0
 BEQ ]LOOP
 STX :NAME
]LOOP LDA $200-1,X
 JSR UPPER
 STA :NAME,X
 DEX
 BNE ]LOOP
 JSR PRINT
 GOTOXY 40;21
 CLEOL
 PRSTRING SEARCHING
 GOTOXY 0;21
 ZAPLINE
 NULL
 JSR LOGSPELL
 LDX #0
 LDA #0
 JSR LOADPN
 LDA PNBUFF
 STA :PARTYS
]LOOP LDX :PARTYS
 LDA #0
 JSR LOADPN
 LDA PNFREE
 BMI :NEXT
 LDX PNNAME
 CPX :NAME
 BNE :NEXT
]LOOP2 LDA PNNAME,X
 JSR UPPER
 CMP :NAME,X
 BNE :NEXT
 DEX
 BNE ]LOOP2
 BRA :GOTIT
:NEXT DEC :PARTYS
 BNE ]LOOP
 JSR PRINT
 GOTOXY 40;21
 CLEOL
 NULL
 JMP FAILED
:GOTIT LDA SPLAYERS
 STA :PLRS
 LDA SPLAYERS+1
 STA :PLRS+1
]LOOP LDX :PLRS
 LDA :PLRS+1
 JSR LOADPLR
 LDA PLRPARTY
 CMP :PARTYS
 BNE :NEXTP
 LDA CH
 BEQ :CH0
 JSR PRINT
 ASC ", "
 NULL
:CH0 LDA PLRZPOS
 BNE :DUNG
 JSR PRINT
 PRSTRING PLRNAME
 ASC " in Castle"
 NULL
 BRA :CONT
:DUNG JSR PRINT
 PRSTRING PLRNAME
 ASC " ("
 PAD2 PLRXPOS
 ASC ","
 PAD2 PLRYPOS
 ASC ") lvl "
 DEC8 PLRZPOS
 SOUND $25;1;LOUD
 NULL
:CONT LDA CH
 CMP #46
 BCC :NEXTP
 LDA #21
 JSR LOGLINE
 JSR PRINT
 VTAB 23
 CENTER " [More..] "
 CURSOROFF
 NULL
 JSR KEYIN
 JSR PRINT
 INVERSE
 COLOR YELLOW
 ZAPLINE
 COLOR WHITE
 NORMAL
 GOTOXY 0;21
 ZAPLINE
 CURSORON
 NULL
:NEXTP DECR :PLRS
 LDA :PLRS
 ORA :PLRS+1
 BNEL ]LOOP
 JSR PRINT
 GOTOXY 40;21
 CLEOL
 NULL
 JMP SPELLEND
:PLRS DS 2
:PARTYS DS 1
:NAME DS 1+20

SEARCHING STR "Searching.."

SAG43 ENT
SAG44 ENT
SAG51 ENT
SAG52 ENT
SAG53 ENT
SAG54 ENT
SAG61 ENT
SAG62 ENT
SAG63 ENT
SAG64 ENT
SAG71 ENT
SAG72 ENT
SAG73 ENT
SAG74 ENT
SAG81 ENT
SAG82 ENT
SAG83 ENT
SAG84 ENT
 JMP UNKNOWN

 LST ON
MODEND EQU *
 LST OFF

 do M16PLUS
 SAV SPELL4.L
 fin

 END
