*-------------------------------
* GAME.SYSOP
*-------------------------------
 DAT
 LST OFF

 ORG $8000 ;Always

 USE MACROS
 USE EQUATES
 USE VARS
 USE LIB.JMP

 TYP $F4
 do M16PLUS-1
 DSK RUN/MODULES/GAME.SYSOP
 fin

 MODID "GAME.SYSOP"

START JSR PRINT
 HOME
 CURSORON
 COLOR AQUAMARINE
 CENTER "Master Operator"
 COLOR WHITE
 CR
 CR
 ASC "@) Logon"
 HTAB 40
 LINE "*) Logoff/Return"
 LINE "&) Execute a module"
 CR
 LINE "A) View Log"
 LINE "B) View Logfile"
 LINE "C) Add Log Note"
 LINE "D) Map Editor"
 LINE "E) Vars Editor"
 LINE "F) Player Editor"
 LINE "G) Item Editor"
 LINE "H) Monster Editor"
 LINE "I) Maze Monster Editor"
 LINE "J) Reclaim (Map)"
 LINE "K) Force Next Turn"
 LINE "L) Allocate Monsters"
 LINE "M) View Map"
 LINE "N) File Peeker"
 LINE "O) Scenario Editor"
 LINE "P) Party Names Editor"
 GOTOXY 40;5
 LINE "Q) Maze Item Editor"
 HTAB 40
 LINE "R) HOF Editor"
 HTAB 40
 LINE "S) HelpFile Editor"
 HTAB 40
 LINE "T) Technical Info"
 HTAB 40
 LINE "U) Message Editor"
 HTAB 40
 LINE "V) Misc. Utilities"
 HTAB 40
 LINE "W) Font Editor"
 HTAB 40
 LINE "X) Glossary Editor"
 HTAB 40
 LINE "Y) Sign Editor"
 HTAB 40
 LINE "Z) Spell Description Editor"
 HTAB 40
 LINE "^) XMODEM send module"
 NULL

GETKEY JSR PRINT
 GOTOXY 0;23
 CLEOS
 COLOR PINK
 ASC "> "
 COLOR WHITE
 NULL

]LOOP JSR DOTIME
 JSR KEYIN
 JSR UPPER
 CMP #"*"
 BEQL LOGOFF
 CMP #"&"
 BEQL EXECMOD
 CMP #"^"
 BEQL XSEND
 CMP #"@"
 BCC ]LOOP
 CMP #"Z"+1
 BCS ]LOOP
 STA VTEMP
 JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 ASC "Option "
 COLOR YELLOW
 NULL
 LDA VTEMP
 JSR COUT
 JSR PRINT
 COLOR WHITE
 ASC " (y/N)? : "
 NULL
 JSR KEYIN
 JSR UPPER
 CMP #"Y"
 BNE GETKEY
 JSR PRINT
 HOME
 NULL
 LDA VTEMP
 SEC
 SBC #"@"
 ASL
 TAX
 JMP (:OPTIONS,X)

:OPTIONS DA LOGON
 DA VIEWLOG
 DA VIEWLOGFILE
 DA ADDLOG
 DA MAPED
 DA VARSED
 DA PLRED
 DA ITEMED
 DA MONED
 DA MON2ED
 DA UPDATE
 DA NEXTURN
 DA ALLOCM
 DA VIEWMAP
 DA FPEEKER
 DA SCENED
 DA PNED
 DA ITEM2ED
 DA HOFED
 DA HELPED
 DA TECHO
 DA MSGED
 DA UTILS
 DA FONTED
 DA GLOSSED
 DA SIGNED
 DA SPDED

DOTIME LDA CH
 STA :CH+2
 LDA CV
 STA :CV+2
 JSR PRINT
 GOTOXY 63;0
 COLOR GREEB
 CURRDATE
 ASC "  "
 CURRTIME
 COLOR WHITE
:CH HTAB 0
:CV VTAB 0
 NULL
 RTS

LOGOFF JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 COLOR PINK
 ASC "Logoff/Return. Are you sure (y/n)? : "
 COLOR WHITE
 NULL
]LOOP JSR KEYIN
 JSR UPPER
 CMP #"Y"
 BEQ :YES
 CMP #"N"
 BNE ]LOOP
 JMP GETKEY
:YES JSR PRINT
 HOME
 LINE "Bye."
 NULL
 JMP DROP

EXECMOD JSR PRINT
 HOME
 ASC "Enter module name to execute : "
 NULL
 GETLINE #15
 CPX #0
 BEQL START
 STX :PATH
 LDA #$60 ;RTS
 STA :PATH+1,X
]LOOP LDA $200-1,X
 STA :PATH,X
 DEX
 BNE ]LOOP
 MLI_GET_FILE_INFO :GPARMS
 BCS :ERR
 JSR :DOIT
 JMP START
:ERR CMP #$46 ;File not found
 BEQ :NONO
 STA VTEMP
 JSR PRINT
 CR
 ASC "MLI error $"
 COLOR PINK
 HEX8 VTEMP
 COLOR WHITE
 ASC ". "
 NULL
 GETRETURN
 JMP EXECMOD
:NONO JSR PRINT
 CR
 COLOR PINK
 ASC "No such module. "
 COLOR WHITE
 NULL
 GETRETURN
 JMP EXECMOD
:DOIT JSR CALLMOD
:PATH DS 1+15
 RTS
:GPARMS DFB $A
 DA :PATH
 DS 15

LOGON CALL "GAME.LOGON"
 JMP START

VIEWLOG CALL "VIEWLOG"
 JMP START

VIEWLOGFILE CALL "VIEWLOGFILE"
 JMP START

ADDLOG CALL "ADDLOG"
 JMP START

MAPED CALL "MAP.EDITOR"
 JMP START

VARSED CALL "VARS.EDITOR"
 JMP START

PLRED CALL "PLR.EDITOR"
 JMP START

ITEMED CALL "ITEM.EDITOR"
 JMP START

MONED CALL "MON.EDITOR"
 JMP START

MON2ED CALL "MON2.EDITOR"
 JMP START

UPDATE LDA #$FF ;Everything
 STA VTEMP
 CALL "GAME.UPDATE"
 JMP START

NEXTURN CALL "GAME.NEXTURN"
 JMP START

ALLOCM CALL "GAME.ALLOCM"
 JMP START

VIEWMAP CALL "VIEW.MAP"
 JMP START

FPEEKER CALL "FILE.PEEKER"
 JMP START

SCENED CALL "SCEN.EDITOR"
 JMP START

PNED CALL "PN.EDITOR"
 JMP START

ITEM2ED CALL "ITEM2.EDITOR"
 JMP START

HOFED CALL "HOF.EDITOR"
 JMP START

HELPED CALL "HELP.EDITOR"
 JMP START

TECHO CALL "TECHO.INFO"
 JMP START

MSGED CALL "MSG.EDITOR"
 JMP START

UTILS CALL "UTIL.MOD"
 JMP START

FONTED CALL "FONT.EDITOR"
 JMP START

GLOSSED CALL "GLOSS.EDITOR"
 JMP START

SIGNED CALL "SIGN.EDITOR"
 JMP START

SPDED CALL "SPDESC.EDITOR"
 JMP START

XSEND CALL "GAME.XSEND"
 JMP START

 LST ON
MODEND EQU *
 LST OFF

 do M16PLUS
 SAV RUN/MODULES/GAME.SYSOP
 fin

 END
