*-------------------------------
* GAME.TRADE
*-------------------------------
 DAT
 LST OFF

 ORG $8000 ;Always

 USE MACROS
 USE EQUATES
 USE VARS
 USE PLR.DSECT
 USE LIB.JMP
 USE TABLES
 USE ITEM.DSECT

 TYP $F4
 do M16PLUS-1
 DSK RUN/MODULES/GAME.TRADE
 fin

 MODID "GAME.TRADE"

START LDX #79
 LDY #79
 LDA #23
 JSR PICKLINE
 LDA $200
 STA BCHAR
START2 JSR CLRBOT
 JSR PRINT
 CURSORON
 SOUND $29;FOREVER;$80
 NULL
 LDX NUMPARTY
 DEX
]LOOP LDA CURPARTY2,X
 BNE :OK
 LDA CURPARTY,X
 BNE :OK
 DEX
 BNE ]LOOP
 JSR PRINT
 COLOR PINK
 ASC "No-one to trade with. "
 SOUND $25;1;LOUD
 COLOR WHITE
 NULL
 GETRETURN
:EXIT JSR CLRBOT
 LDA BCHAR
 CMP #' ' ;Bottom line inversed?
 BNE :EXIT2
 JSR PRINT
 GOTOXY 0;23
 CURSOROFF
 INVERSE
 COLOR YELLOW
 ZAPLINE
 COLOR WHITE
 NORMAL
 NULL
 RETURN
:EXIT2 JSR PRINT
 CURSOROFF
 NULL
 RETURN
:OK LDX #0
 STX :X
]LOOP INC :X
 LDA CURPARTY,X
 STA :REC
 LDA CURPARTY2,X
 STA :REC+1
 BNE :ROK
 LDA :REC
 BEQ :NEXT
:ROK LDX :REC
 LDA :REC+1
 JSR LOADPLR
 JSR PRINT
 HTAB 40
 NULL
 LDA PLRZPOS
 BEQ :CASTLE
 JSR PRINT
 COLOR PINK
 NULL
 BRA :CCONT
:CASTLE JSR PRINT
 COLOR AQUAMARINE
 NULL
:CCONT JSR PRINT
 DEC8 :X
 ASC ") "
 PRSTRING PLRNAME
 CR
 NULL
:NEXT LDX :X
 CPX NUMPARTY
 BNE ]LOOP
 JSR PRINT
 COLOR WHITE
 GOTOXY 0;15
 ASC "Trade from #"
 NULL
]LOOP JSR KEYIN
 CMP #$9B
 BEQL :EXIT
 SEC
 SBC #"1"
 CMP NUMPARTY
 BCS ]LOOP
 STA VTEMP
 LDX #40
 LDY #41
 CLC
 ADC #15
 JSR PICKLINE
 LDA $200
 CMP #" "
 BEQ ]LOOP
 LDX VTEMP
 LDA CURPARTY,X
 STA :FROM
 LDA CURPARTY2,X
 STA :FROM+1
 TXA
 CLC
 ADC #"1"
 JSR COUT
 LDX :FROM
 LDA :FROM+1
 JSR LOADPLR
 BIT PLRARRESTFLAG
 BVC :CLEAN
 JSR CLRBOT
 JSR PRINT
 COLOR PINK
 PRSTRING PLRNAME
 ASC " is in jail. "
 COLOR WHITE
 NULL
 GETRETURN
 JMP START2
:CLEAN JSR PRINT
 GOTOXY 8;16
 ASC "to #"
 NULL
]LOOP JSR KEYIN
 CMP #$9B
 BEQL START2
 SEC
 SBC #"1"
 CMP NUMPARTY
 BCS ]LOOP
 CMP VTEMP ;Can't trade with self
 BEQ ]LOOP
 STA VTEMP
 LDX #40
 LDY #41
 CLC
 ADC #15
 JSR PICKLINE
 LDA $200
 CMP #" "
 BEQ ]LOOP
 LDX VTEMP
 LDA CURPARTY,X
 STA :TO
 LDA CURPARTY2,X
 STA :TO+1
 TXA
 CLC
 ADC #"1"
 JSR COUT
 BIT PLRARRESTFLAG
 BVC :CLEAN2
 JSR CLRBOT
 JSR PRINT
 COLOR PINK
 PRSTRING PLRNAME
 ASC " is in jail. "
 COLOR WHITE
 NULL
 GETRETURN
 JMP START2
:CLEAN2 STZ :PNTR+1
 LDA #8
 STA :PNTR
 STZ :FLAG
:TOP LDA :PNTR+1
 PHA
 JSR CLRBOT
 JSR PRINT
 CURSORON
 NULL
 LDX :FROM ;Calculate range
 LDA :FROM+1
 JSR LOADPLR
 LDA PLRXPOS
 STA :XPOS
 LDA PLRYPOS
 STA :YPOS
 LDA PLRZPOS
 STA :ZPOS

 LDX :TO
 LDA :TO+1
 JSR LOADPLR
 LDA PLRZPOS
 CMP :ZPOS
 BNE :TOOFAR

 LDA PLRXPOS
 SEC
 SBC :XPOS
 BCS :DOY
 EOR #$FF
 INC
:DOY STA VTEMP
 LDA PLRYPOS
 SEC
 SBC :YPOS
 BCS :POK
 EOR #$FF
 INC
:POK CMP VTEMP
 BCS :TAKEY
 LDA VTEMP
:TAKEY CMP #2
 BCC :RNGOK
:TOOFAR JSR PRINT
 COLOR PINK
 ASC "Too far away. "
 SOUND $13;1;$40
 COLOR WHITE
 NULL
 GETRETURN
 JMP START2
:RNGOK LDX :FROM
 LDA :FROM+1
 JSR LOADPLR
 JSR PRINT
 COLOR GREEN
 NULL
 JSR SAYNAME
 JSR PRINT
 CR
 COLOR WHITE
 ASC "Gold:"
 COLOR GREEN
 NULL
 LDA #0
 STA :PNTR+1
 LDA #16
 JSR :PRIT
 LDX :TO
 LDA :TO+1
 JSR LOADPLR
 JSR PRINT
 GOTOXY 40;15
 COLOR GREEN
 NULL
 JSR SAYNAME
 JSR PRINT
 GOTOXY 40;16
 COLOR WHITE
 ASC "Gold:"
 COLOR GREEN
 NULL
 LDA #40
 STA :PNTR+1
 LDA #56
 JSR :PRIT
 PLA
 STA :PNTR+1
:BOT JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 COLOR WHITE
 ASC "[RETURN]-give, [TAB/"
 MTON
 INVERSE
 ASC "K"
 NORMAL
 ASC "/"
 INVERSE
 ASC "J"
 NORMAL
 MTOFF
 ASC "]-move pointer, [G]old, [ESC]-exit "
 CURSOROFF
 NULL
 BIT :FLAG
 BPL :BOT2
 JMP :UP2
:BOT2 JSR :DOPOINT
]LOOP JSR KEYIN
 JSR UPPER
 LDX :KEYS
]LOOP2 CMP :KEYS,X
 BEQ :GOTONE
 DEX
 BNE ]LOOP2
 BRA ]LOOP
:GOTONE DEX
 TXA
 ASL
 TAX
 JMP (:TABLE,X)

:KEYS DFB :ENDKEYS-*-1
 DFB $9B
 DFB "M"-$40
 DFB "K"-$40
 DFB "J"-$40
 DFB "G"
 DFB "I"-$40
:ENDKEYS

:TABLE DA :RESTART
 DA :GIVE
 DA :UP
 DA :DOWN
 DA :GOLD
 DA :TAB

:RESTART JSR PRINT
 GOTOXY 0;23
 NULL
 LDA BCHAR
 CMP #' ' ;Bottom line inversed?
 BNE :RSTART2
 JSR PRINT
 INVERSE
 COLOR YELLOW
 NULL
:RSTART2 JSR PRINT
 ZAPLINE
 COLOR WHITE
 NORMAL
 NULL
 JMP START2

:TAB LDA :PNTR+1
 EOR #40
 STA :PNTR+1
 JMP :UP2

:UP LDA :PNTR
 BNE :UPOK
 LDA #8
 STA :PNTR
 JMP :BOT2
:UPOK DEC
 STA :PNTR
:UP2 LDA :PNTR+1
 CLC
 ADC #17
 TAX
 TAY
 LDA :PNTR
 CLC
 ADC #15
 JSR PICKLINE
 LDA $200
 CMP #" "
 BEQ :UP
 JMP :BOT2

:DOWN LDA :PNTR
 CMP #7
 BNE :DOWN2
 INC :PNTR
 JMP :BOT2
:DOWN2 CMP #8
 BCC :DNOK
 LDA #-1
:DNOK INC
 STA :PNTR
 LDA :PNTR+1
 CLC
 ADC #17
 TAX
 TAY
 LDA :PNTR
 CLC
 ADC #15
 JSR PICKLINE
 LDA $200
 CMP #" "
 BEQ :DOWN
 JMP :BOT2

:GOLD LDA #8
 STA :PNTR
 JSR :DOPOINT
:GIVE LDA :PNTR
 CMP #8 ;Giving gold?
 BNEL :GIT
 LDA :PNTR+1
 AND #$F
 LSR
 LSR
 TAX
 LDA :FROM,X
 STA :REC
 LDA :FROM+1,X
 STA :REC+1
 LDX :REC ;From
 LDA :REC+1
 JSR LOADPLR
 JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 CURSORON
 ASC "Amount : "
 NULL
 GETLINE #10
 CPX #0
 BEQL :BOT
 JSR GETNUM
 STX :MONEY
 STY :MONEY+1
 LDA VTEMP
 STA :MONEY+2
 LDA VTEMP+1
 STA :MONEY+2
 LDX #3
]LOOP2 LDA PLRGOLD,X
 CMP :MONEY,X
 BEQ :GNXT
 BCS :AFFORD
 JSR PRINT
 ASC " - "
 COLOR PINK
 ASC "not enough. "
 SOUND $02;1;LOUD
 COLOR WHITE
 NULL
 GETRETURN
 JMP :BOT
:GNXT DEX
 BPL ]LOOP2
:AFFORD CLC
 XCE
 REP #$30
 LDA PLRGOLD
 SEC
 SBC :MONEY
 STA PLRGOLD
 LDA PLRGOLD+2
 SBC :MONEY+2
 STA PLRGOLD+2
 SEC
 XCE
 LDX :REC ;From
 LDA :REC+1
 JSR SAVEPLR
 LDA :PNTR+1
 EOR #40
 AND #$F
 LSR
 LSR
 TAX
 LDA :FROM,X
 STA :REC2
 LDA :FROM+1,X
 STA :REC2+1
 LDX :REC2 ;To
 LDA :REC2+1
 JSR LOADPLR
 CLC
 XCE
 REP #$30
 LDA PLRGOLD
 CLC
 ADC :MONEY
 STA PLRGOLD
 LDA PLRGOLD+2
 ADC :MONEY+2
 STA PLRGOLD+2
 SEC
 XCE
 LDX :REC2 ;To
 LDA :REC2+1
 JSR SAVEPLR
 LDA :PNTR+1
 PHA
 LDX :FROM
 LDA :FROM+1
 JSR LOADPLR
 LDA #0
 STA :PNTR+1
 JSR :PRGOLD
 LDX :TO
 LDA :TO+1
 JSR LOADPLR
 LDA #40
 STA :PNTR+1
 JSR :PRGOLD
 PLA
 STA :PNTR+1
 JMP :BOT

:GIT LDA :PNTR+1
 AND #$F
 LSR
 LSR
 TAX
 LDA :FROM,X
 STA :REC
 LDA :FROM+1,X
 STA :REC+1
 LDX :REC ;From
 LDA :REC+1
 JSR LOADPLR
 LDX :PNTR ;Get item to trade
 LDA PLRITEMX,X
 CMP #1 ;Equipped
 BNE :NOTEQ
 JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 CURSORON
 COLOR PINK
 ASC "Equipped. "
 SOUND $02;1;LOUD
 COLOR WHITE
 NULL
 GETRETURN
 JMP :BOT
:NOTEQ LDA PLRITEM,X
 STA :YEITEM
 LDA :PNTR+1
 EOR #40
 AND #$F
 LSR
 LSR
 TAX
 LDA :FROM,X
 STA :REC2
 LDA :FROM+1,X
 STA :REC2+1
 LDX :REC2 ;To
 LDA :REC2+1
 JSR LOADPLR
 LDA PLRITEM+7 ;Full?
 BEQ :NOTFULL
 JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 CURSORON
 COLOR PINK
 ASC "Recipient is full. "
 COLOR WHITE
 NULL
 GETRETURN
 JMP :BOT
:NOTFULL LDX :REC ;From
 LDA :REC+1
 JSR LOADPLR
 LDX :PNTR ;Crunch items
 CPX #7
 BEQ :Z7
]LOOP2 LDA PLRITEM+1,X
 STA PLRITEM,X
 LDA PLRITEMX+1,X
 STA PLRITEMX,X
 INX
 CPX #7
 BCC ]LOOP2
:Z7 STZ PLRITEM+7
 STZ PLRITEMX+7
 LDX :REC ;From
 LDA :REC+1
 JSR SAVEPLR
 LDX :REC2 ;To
 LDA :REC2+1
 JSR LOADPLR
 LDX #0
]LOOP2 LDA PLRITEM,X
 BEQ :PUTHERE
 INX
 CPX #8
 BNE ]LOOP2
 DEATH ;Should never happen
:PUTHERE LDA :YEITEM
 STA PLRITEM,X
 PHX
 LDX :YEITEM
 LDA #0
 JSR LOADITEM
 LDA PLRCLASS
 JSR CHECKUSE
 BCC :YESCAN
 LDA #2 ;Unusable
 HEX 2C
:YESCAN LDA #0 ;Can use
 PLX
 STA PLRITEMX,X
 LDX :REC2 ;To
 LDA :REC2+1
 JSR SAVEPLR
 LDA #$FF
 STA :FLAG
 JMP :TOP

:DOPOINT LDA :PNTR
 CMP #8
 BNE :NOT8
 LDA :PNTR+1
 CLC
 ADC #5
 STA :PHV+2
 LDA #16
 STA :PHV+3
 BRA :DOP
:NOT8 LDA #16
 CLC
 ADC :PNTR+1
 STA :PHV+2
 LDA #15
 CLC
 ADC :PNTR
 STA :PHV+3
:DOP JSR PRINT
 CURSORLEFT
 ASC " "
:PHV GOTOXY 0;0
 NULL
 JSR SHOWPNTR
 RTS
:PNTR DS 2

:PRIT STA :HTV+2
 LDA #<PLRITEM
 STA :I+2
 LDA #15
 STA :HTV+3
 JSR PRINT
 COLOR WHITE
 NULL
 LDX #0
]LOOP STX VTEMP
 INC VTEMP
 LDA PLRITEM,X
 BEQ :NXT1
 LDA PLRITEMX,X
 AND #%11
 TAX
 LDA :ICOLORS,X
 STA :IC+2
 LDA PLRITEM,X
 TAX
 LDA #0
 JSR LOADITEM
 JSR PRINT
:HTV GOTOXY 16;15
 ASC " "
 DEC8 VTEMP
 ASC ")"
:IC COLOR WHITE
:I PRITEM PLRITEM
 COLOR WHITE
 NULL
 INC :HTV+3
:NXT1 INC :I+2
 LDX VTEMP
 CPX #8
 BNE ]LOOP
:PRGOLD LDA PADFLAG
 PHA
 LDA PADCHAR
 PHA
 LDA #$FF
 STA PADFLAG
 LDA #" "
 STA PADCHAR
 LDA :PNTR+1
 CLC
 ADC #6
 STA :PIH+2
 JSR PRINT
:PIH GOTOXY 0;16
 COLOR YELLOW
 DEC32 PLRGOLD
 COLOR WHITE
 NULL
 PLA
 STA PADCHAR
 PLA
 STA PADFLAG
 RTS
:X DS 1
:REC DS 2
:REC2 DS 2
:FROM DS 2
:TO DS 2
:YEITEM DS 1
:MONEY DS 4
:FLAG DS 1
:XPOS DS 1
:YPOS DS 1
:ZPOS DS 1
:ICOLORS DFB $F,$E,$D,$D

CLRBOT JSR PRINT
 GOTOXY 0;22
 LUP 7
 ZAPLINE
 CURSORUP
 --^
 ZAPLINE
 NULL
 RTS

SAYNAME LDA PLRNAME
 CMP #15
 BCS :SQUASH
 JSR PRINT
 PRSTRING PLRNAME
 NULL
 RTS
:SQUASH LDX #0
]LOOP LDA PLRNAME+1,X
 JSR COUT
 INX
 CPX #13
 BNE ]LOOP
 JSR PRINT
 ASC ".."
 NULL
 RTS

BCHAR DS 1

 LST ON
MODEND EQU *
 LST OFF

 do M16PLUS
 SAV RUN/MODULES/GAME.TRADE
 fin

 END
