*-------------------------------
* GAME.WALL
*-------------------------------
 DAT
 LST OFF

 ORG $8000

 USE MACROS
 USE EQUATES
 USE VARS
 USE LIB.JMP
 USE PN.DSECT

 TYP $F4
 do M16PLUS-1
 SAV RUN/MOFULES/GAME.WALL
 fin

START JSR PRINT
 HOME
 COLOR YELLOW
 INVERSE
 ZAPLINE
 COLOR WHITE
 NORMAL
 CENTER " The Wall.. "
 GOTOXY 0;22
 COLOR YELLOW
 INVERSE
 ZAPLINE
 NORMAL
 COLOR WHITE
 CURSORDOWN
 ASC "[L]oad, [S]ave, [ESC]-jump, [Q]uit : "
 NULL
 LDA CH
 STA BOTCH+2

 JSR LOAD

BOT JSR PRINT
BOTCH GOTOXY 0;23
 CLEOL
 NULL
]LOOP JSR KEYIN
 JSR UPPER
 CMP #"L"
 BEQ :LOAD
 CMP #"S"
 BEQ :SAVE
 CMP #$9B
 BEQ JUMP
 CMP #"Q"
 BNE ]LOOP
 RETURN

:LOAD JSR COUT
 JSR LOAD
 JMP BOT

:SAVE JSR COUT
 JSR SAVE
 JMP BOT

JUMP LDA CURSOR
 STA :GOTO+2
 LDA CURSOR+1
 STA :GOTO+3
 JSR PRINT
:GOTO GOTOXY 0;0
 NULL
 LDX TOPLINE
 LDA BOTLINE
 JSR MSGEDIT
 LDA CH
 STA CURSOR
 LDA CV
 STA CURSOR+1
 JMP BOT

LOAD LDA SCENARIO
 ORA #"0"
 STA PATH+17 ;Make sure this matches with PATH
 MLI_OPEN OPARMS
 JSR MLIERR
 LDA OPARMS+5
 STA RWPARMS+1
 MLI_READ RWPARMS
 JSR MLIERR
 JSR CLOSEALL

 LDX LEN ;Length
 LDA LEN+1
 JSR SHOWMSG
TOPLINE DFB 1 ;Lines to use (top, bottom)
BOTLINE DFB 21
 DA BUFFER
 RTS

SAVE LDA SCENARIO
 ORA #"0"
 STA PATH+17 ;Make sure this matches with PATH
 LDA TOPLINE
 STA :LINES
 LDA BOTLINE
 STA :LINES+1
 JSR GETSCREEN ;PICKLINE the screen
:LINES DS 2 ;on these lines
 DA BUFFER ;and put it here

 MLI_OPEN OPARMS
 JSR MLIERR
 LDA OPARMS+5
 STA RWPARMS+1
 MLI_WRITE RWPARMS
 JSR MLIERR
 JMP CLOSEALL

OPARMS DFB 3
 DA PATH
 DA IOBUFFER
 DS 1

RWPARMS DFB 4
 DS 1
 DA BUFFER
LEN DA 80*21+2
 DS 2

PATH STR "FILES/WALL.DATA.0"

BUFFER DS 80*21
CURSOR DFB 0,0 ;Cursor loc

 LST ON
MODEND EQU *
 LST OFF

 do M16PLUS
 SAV RUN/MODULES/GAME.WALL
 fin

 END
