*-------------------------------
* INV.EDITOR
*-------------------------------
 DAT
 LST OFF

 ORG $8000 ;Always

 USE MACROS
 USE EQUATES
 USE VARS
 USE LIB.JMP
 USE TABLES
 USE INV.DSECT
 USE ITEM.DSECT

 TYP $F4
 do M16PLUS-1
 DSK RUN/MODULES/INV.EDITOR
 fin

NUMINV = 4 ;Number of entries

 MODID "INV.EDITOR"

START JSR PRINT
 HOME
 BOX "Shoppe Inventory Editor"
 NULL
 LDX #0
 LDA #0
 JSR LOADSCEN
 LDA SCENBUFF
 STA MAXSCEN
 STZ :FLAG
 STZ :INV
 STZ :INV+1
 LDX #0
 LDA #0
 JSR LOADINV
 LDA MISCBUFF
 STA :RECS
 LDA MISCBUFF+1
 STA :RECS+1
 JMP :FORW1
:BOT JSR PRINT
 GOTOXY 1;1
 ASC "Total in file : "
 COLOR YELLOW
 DEC16 :RECS
 COLOR WHITE
 ASC "  "
 GOTOXY 1;2
 ASC "Scenario      : "
 COLOR YELLOW
 DEC8 SCENARIO
 COLOR WHITE
 ASC "  "
 NULL
:BOTBIT JSR PRINT
 GOTOXY 0;23
 CLEOS
 ASC "[A]dd, [J]ump, [S]ave, [X], [L]ist, [RETURN]-edit, "
 MTON
 INVERSE
 ASC "H"
 NORMAL
 ASC ", "
 INVERSE
 ASC "U"
 NORMAL
 MTOFF
 ASC ", [H]elp, [Q]uit : "
 CURSORON
 NULL
 LDA CH
 STA :BGOTO+2
:GETKEY JSR PRINT
:BGOTO GOTOXY 0;23
 NULL
]LOOP JSR KEYIN
 JSR UPPER
 LDX :KEYS
]LOOP2 CMP :KEYS,X
 BEQ :GOTONE
 DEX
 BNE ]LOOP2
 JMP ]LOOP
:GOTONE DEX
 TXA
 ASL
 TAX
 JMP (:TABLE,X)

:KEYS DFB :ENDKEYS-*-1
 DFB "Q"
 DFB "A"
 DFB "L"
 DFB "J"
 DFB "S"
 DFB "H"-$40
 DFB "U"-$40
 DFB "K"-$40
 DFB "J"-$40
 DFB "M"-$40
 DFB "H"
 DFB "X"
:ENDKEYS

:TABLE DA EXIT
 DA :ADD
 DA :LIST
 DA :LOAD
 DA :SAVE
 DA :BACK1
 DA :FORW1
 DA :UP
 DA :DOWN
 DA :EDIT
 DA :HELP
 DA :SCEN

:SCEN LDA MAXSCEN
 BEQL :GETKEY
 JSR PRINT
 NORMAL
 MTOFF
 GOTOXY 0;23
 ZAPLINE
 ASC "Change scenario to (max="
 DEC8 MAXSCEN
 ASC ") : "
 NULL
 GETLINE #1
 CPX #0
 BEQ :NO
 JSR GETNUM
 CPX MAXSCEN
 BEQ :OK
 BCS :NO
:OK STX SCENARIO
 JSR PRINT
 GOTOXY 0;4
 CLEOS
 NULL
 LDX #0
 LDA #0
 JSR LOADINV
 LDA MISCBUFF
 STA :RECS
 LDA MISCBUFF+1
 STA :RECS+1
 STZ :INV
 STZ :INV+1
 JMP :FORW1
:NO JMP :BOTBIT

:HELP JSR PRINT
 GOTOXY 0;4
 CLEOS
 NULL
 JSR GETFILE
 DFB 4,22 ;Use lines x to y
 STR "HELP/INV.ED"
 JSR PRINT
 GOTOXY 0;23
 COLOR PINK
 NULL
 GETRETURN
 JSR PRINT
 GOTOXY 0;4
 COLOR WHITE
 CLEOS
 NULL
 JMP :INVBACK

:DOPOINT LDA :OLDPNTR
 CMP #19
 BCC :PLEFT
 LDA #40
 STA :CH+2
 LDA :OLDPNTR
 SEC
 SBC #15
 STA :CV+2
 BRA :DOP1
:PLEFT STZ :CH+2
 LDA :OLDPNTR
 CLC
 ADC #3
 STA :CV+2
:DOP1 JSR PRINT
 NORMAL
 MTOFF
:CH HTAB 0
:CV VTAB 0
 ASC " "
 NULL
 LDA :PNTR
 CMP #19
 BCC :PLEFT2
 LDA #40
 STA :CH2+2
 LDA :PNTR
 SEC
 SBC #15
 STA :CV2+2
 BRA :DOP2
:PLEFT2 STZ :CH2+2
 LDA :PNTR
 CLC
 ADC #3
 STA :CV2+2
:DOP2 JSR PRINT
:CH2 HTAB 0
:CV2 VTAB 0
 NULL
 JSR SHOWPNTR
 LDA :PNTR
 STA :OLDPNTR
 RTS
:OLDPNTR DFB 1
:PNTR DFB 1

:UP LDA :RECS
 ORA :RECS+1
 BEQL :BOT
 LDA :PNTR
 CMP #1
 BNE :UPOK
 LDA #NUMINV+1
:UPOK DEC
 STA :PNTR
 JSR :DOPOINT
 JMP :GETKEY

:DOWN LDA :RECS
 ORA :RECS+1
 BEQL :BOT
 LDA :PNTR
 CMP #NUMINV
 BNE :DNOK
 LDA #0
:DNOK INC
 STA :PNTR
 JSR :DOPOINT
 JMP :GETKEY

:EDIT LDA :RECS
 ORA :RECS+1
 BEQL :BOT
 LDA :PNTR
 DEC
 ASL
 TAX
 JMP (:EDITS,X)

:EDITS DA :FREE
 DA :STOCK
 DA :MAX
 DA :ORDER

:LOAD LDA :RECS
 ORA :RECS+1
 BEQL :BOT
 JSR PRINT
 GOTOXY 0;23
 CLEOS
 ASC "Jump to inventory item #"
 CURSORON
 NULL
 GETLINE #5
 JSR GETNUM
 CPX #0
 BNE :LOK
 CPY #0
 BEQL :BOT
:LOK CPY :RECS+1
 BCC :RNGOK
 CPX :RECS
 BEQ :RNGOK
 BCC :RNGOK
 JSR PRINT
 COLOR PINK
 ASC " No such inventory item. "
 COLOR WHITE
 NULL
 GETRETURN
 JMP :BOT
:RNGOK STX :INV
 STY :INV+1
 TYA
 JSR LOADINV
 JSR :DISPLAY
 STZ :FLAG
 JMP :BOT

:SAVE LDA :RECS
 ORA :RECS+1
 BEQL :BOT
 BIT :FLAG
 BPLL :GETKEY
:SAVE2 LDX :INV
 LDA :INV+1
 JSR SAVEINV
 STZ :FLAG
 JMP :BOT

:BACK1 LDA :RECS
 ORA :RECS+1
 BEQL :BOT
 LDA :INV+1
 BNE :GOB
 LDA :INV
 CMP #2
 BCS :GOB
 JMP :BOT
:GOB DECR :INV
 LDX :INV
 LDY :INV+1
 JMP :LOK

:FORW1 LDA :RECS
 ORA :RECS+1
 BEQL :BOT
 LDA :INV+1
 CMP :RECS+1
 BCC :GOF
 LDA :INV
 CMP :RECS
 BCC :GOF
 JMP :BOT
:GOF INCR :INV
 LDX :INV
 LDY :INV+1
 JMP :LOK

:LIST LDA :RECS
 ORA :RECS+1
 BEQL :BOT
 JSR PRINT
 GOTOXY 0;23
 CLEOS
 ASC "Start from inventory item #1"
 CURSORLEFT
 NULL
 LDA PADFLAG
 STA TEMP
 LDA #$FF
 STA PADFLAG
 LDA PADCHAR
 STA TEMP+1
 LDA #" "
 STA PADCHAR
 LDA #1
 STA :TOREAD
 STZ :TOREAD+1
 GETLINE #5
 BCSL :LEXIT
 CPX #0
 BEQ :FROM1
 JSR GETNUM
 STX :TOREAD
 STY :TOREAD+1
:FROM1 LDA :TOREAD+1
 CMP :RECS+1
 BCC :VGO
 BEQ :FROMLO
 BCS :FROMNO
:FROMLO LDA :TOREAD
 CMP :RECS
 BCC :VGO
 BEQ :VGO
:FROMNO JSR PRINT
 ASC " - "
 COLOR PINK
 ASC "Last inventory item is #"
 COLOR YELLOW
 DEC16 :RECS
 COLOR PINK
 ASC ". "
 COLOR WHITE
 NULL
 GETRETURN
 JSR PRINT
 ZAPLINE
 NULL
 JMP :LEXIT
:VGO LDA :TOREAD
 STA :MCNTR
 LDA :TOREAD+1
 STA :MCNTR+1
 JSR PRINT
 GOTOXY 0;3
 CLEOS
 CR
 COLOR AQUAMARINE
 LINE "Inv #  /Name                /Stock / Max  / Order amount"
 COLOR WHITE
 CURSOROFF
 NULL
]LOOP LDA :MCNTR+1
 CMP :RECS+1
 BCC :RREAD
 LDA :MCNTR
 CMP :RECS
 BCC :RREAD
 BEQ :RREAD
 JMP :RDONE
:RREAD LDX :TOREAD
 LDA :TOREAD+1
 JSR LOADINV
 INCR :TOREAD
 LDA CV
 CMP #21
 BNE :VOK
 JSR PRINT
 CR
 CR
 CURSORON
 COLOR YELLOW
 CENTER "[SPACE]-continue, [ESC]-exit : "
 COLOR WHITE
 NULL
]LOOP3 JSR KEYIN
 CMP #$9B
 BEQL :RESC
 CMP #" "
 BNE ]LOOP3
 JSR PRINT
 GOTOXY 0;5
 CLEOS
 CURSOROFF
 NULL
:VOK LDX :MCNTR
 LDA :MCNTR+1
 JSR LOADITEM
 JSR PRINT
 CR
 COLOR YELLOW
 DEC16 :MCNTR
 COLOR WHITE
 ASC ")  "
 COLOR ORANGE
 PRSTRING INAME
 HTAB 30
 COLOR YELLOW
 DEC8 INVSTOCK
 HTAB 37
 COLOR PINK
 DEC8 INVMAX
 HTAB 46
 COLOR GREEN
 DEC8 INVORDER
 COLOR WHITE
 NULL
:MNEXT INCR :MCNTR
 LDA $C000
 BPLL ]LOOP
 STA $C010
 CMP #$9B
 BEQ :RDONE
 JMP ]LOOP
:RESC JSR PRINT
 ZAPLINE
 CURSORON
 NULL
 BRA :RDONE2
:RDONE JSR PRINT
 GOTOXY 0;23
 COLOR PINK
 CURSORON
 NULL
 GETRETURN
 JSR PRINT
 COLOR WHITE
 NULL
:RDONE2 LDA TEMP
 STA PADFLAG
 LDA TEMP+1
 STA PADCHAR
 LDX :INV
 LDY :INV+1
 JMP :LOK
:LEXIT LDA TEMP
 STA PADFLAG
 LDA TEMP+1
 STA PADCHAR
 JMP :BOT
:MCNTR DS 2
:TOREAD DA 2

:DISPLAY LDA :RECS
 ORA :RECS+1
 BEQL :BOT
 LDX :INV
 LDA :INV+1
 JSR LOADITEM
 JSR PRINT
 GOTOXY 60;1
 ASC "Inv. item #"
 COLOR YELLOW
 DEC16 :INV
 COLOR WHITE
 ASC " "
 GOTOXY 0;4
 CLEOS
 CURSOROFF
 ASC "  1 - Free..........."
 PRFLAG INVFREE
 HTAB 40
 COLOR AQUAMARINE
 PRSTRING INAME
 COLOR WHITE
 ASC " ("
 COLOR GREEN
 PRTABLE ITYPE;TYPETABLE
 COLOR WHITE
 ASC ")"
 CR
 ASC "  2 - Amt in stock..."
 COLOR YELLOW
 DEC8 INVSTOCK
 COLOR WHITE
 HTAB 40
 ASC "Price : "
 COLOR YELLOW
 DEC32 ICOST
 COLOR WHITE
 ASC " gp"
 CR
 ASC "  3 - Max. amount...."
 COLOR PINK
 DEC8 INVMAX
 COLOR WHITE
 CR
 ASC "  4 - Order amt......"
 COLOR GREEN
 DEC8 INVORDER
 COLOR WHITE
 CR
 CURSORON
 NULL
 JMP :DOPOINT
:INV DS 2

:INVBACK JSR PRINT
 GOTOXY 0;23
 CLEOS
 NULL
 JSR :DISPLAY
 LDA #$FF
 STA :FLAG
 JMP :BOT

:ADD JSR PRINT
 GOTOXY 0;23
 CLEOS
 ASC "Add - [N]ext free one, [E]nd of file, [ESC] Exit : "
 NULL
]LOOP JSR KEYIN
 JSR UPPER
 CMP #$9B
 BEQL :BOT
 CMP #"N"
 BEQL :ANEXT
 CMP #"E"
 BNE ]LOOP
 JSR COUT
:AEND LDX #0
 LDA #0
 JSR LOADINV
 LDA MISCBUFF
 CMP #$FF
 BCC :AEOK
 JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 COLOR PINK
 ASC "Cannot add any more inventory items. "
 COLOR WHITE
 NULL
 GETRETURN
 JMP :ADD
:AEOK INCR MISCBUFF ;Add 1 to the number of inv items
 LDX #0
 LDA #0
 JSR SAVEINV ;Save it out
 INCR :RECS
 LDA :RECS
 STA :INV
 LDA :RECS+1
 STA :INV+1
:AGOTIT LDX #0
]LOOP STZ MISCBUFF,X
 INX
 BNE ]LOOP
 JSR :DISPLAY
 JMP :SAVE2
:ANEXT JSR COUT
 LDX :INV
 LDY :INV+1
 STX :INVV
 STY :INVV+1
 LDA :RECS
 BNE :NXTOK
 LDA :RECS+1
 BEQL :AEND
:NXTOK
]LOOP LDA :INVV+1
 CMP :RECS+1
 BCC :NRNGOK
 LDA :INVV
 CMP :RECS
 BEQ :NRNGOK
 BCSL :AEND
:NRNGOK LDX :INVV
 LDA :INVV+1
 JSR LOADINV
 INCR :INVV
 LDA INVFREE
 BPL ]LOOP
 DECR :INVV
 LDA :INVV
 STA :INV
 LDA :INVV+1
 STA :INV+1
 JMP :AGOTIT
:INVV DS 2

:FREE LDX #1
 LDY #1
 JSR ASK
 GETLINE #1
 CPX #0
 BEQL :INVBACK
 LDA $200
 CMP #"1"
 BEQ :A1
 CMP #"0"
 BNE :FREE
 LDA #0
 HEX 2C
:A1 LDA #$FF
 STA INVFREE
 JMP :INVBACK

:STOCK LDX #5
 LDY #2
 JSR ASK
 GETLINE #3
 CPX #0
 BEQ :YRTS
 JSR GETNUM
 STX INVSTOCK
:YRTS JMP :INVBACK

:MAX LDX #5
 LDY #3
 JSR ASK
 GETLINE #3
 CPX #0
 BEQ :MRTS
 JSR GETNUM
 STX INVMAX
:MRTS JMP :INVBACK

:ORDER LDX #5
 LDY #4
 JSR ASK
 GETLINE #3
 CPX #0
 BEQ :ORTS
 JSR GETNUM
 STX INVORDER
:ORTS JMP :INVBACK

:RECS DS 2
:FLAG DS 1

EXIT RETURN

TEMP DS 2
TOTINV DS 1

]LEN = 8
TYPETABLE DFB ]LEN
 ENTRY "<unknown>"
 ENTRY "Weapon"
 ENTRY "Armour"
 ENTRY "Shield"
 ENTRY "Helmet"
 ENTRY "Gloves"
 ENTRY "Misc."

MAXSCEN DS 1

 LST ON
MODEND EQU *
 LST OFF

 do M16PLUS
 SAV RUN/MODULES/INV.EDITOR
 fin

 END
