*-------------------------------
* LIB.LOG (Library)
*-------------------------------
 DAT
 LST OFF

 XC
 XC

 REL

 USE MACROS
 USE EQUATES
 USE VARS
 USE LOG.DSECT
 USE PN.DSECT

 do M16PLUS-1
 DSK LIB.LOG.L
 fin

 EXT MLIERR,CLOSEALL,LIB_DEATH,GETHEX ;Main
 EXT PRINT,GETCADD,GETCADD2,GETADDR ;Print
 EXT LOADLOGFILE,SAVELOGFILE ;Files

*
* X=flag (0=normal, FF=party)
*
PLOGNOTEBUFF ENT ;Note with ptr to a buffer
 LDA #3
 HEX 2C
PLOGNOTENUM ENT ;Note with a number (eg; "Call #";CALLS)
 LDA #2
 HEX 2C
PLOGNOTESTR ENT ;Note with a string (eg; "Volume is ";PREFIX)
 LDA #1
 HEX 2C
PLOGNOTE ENT ;Put a note in the log
 LDA #0
 LDX #$FF ;(party note)
 BRA GONOTE

LOGNOTEBUFF ENT ;Note with ptr to a buffer
 LDA #3
 HEX 2C
LOGNOTENUM ENT ;Note with a number (eg; "Call #";CALLS)
 LDA #2
 HEX 2C
LOGNOTESTR ENT ;Note with a string (eg; "Volume is ";PREFIX)
 LDA #1
 HEX 2C
LOGNOTE ENT ;Put a note in the log
 LDA #0
 LDX #0 ;(normal note)
GONOTE STX :PORN ;P or N type of note
 STA :NOTE
 CLC
 XCE
 REP #$30
 PushWord #0
 PushWord #0
 PushWord #0
 PushWord #0
 Tool $0D03 ;ReadTimeHex
 PLX
 PLA
 PLA
 PLA
 SEC
 XCE
 STX :BUFF+4
 MLI_GET_TIME
 LDX #3
]LOOP LDA $BF90,X
 STA :BUFF,X
 DEX
 BPL ]LOOP

 PLA
 STA CADD
 PLA
 STA CADD+1
 JSR GETCADD
 STA :TYPE ;Type of entry
 LDA :NOTE
 CMP #3 ;Note w/buffer ptr
 BEQ :NOTES
 JSR GETCADD
 STA ENTRY ;Length of entry
 LDX #0
]LOOP JSR GETCADD
 STA ENTRY+1,X
 INX
 CPX ENTRY
 BNE ]LOOP

:NOTES LDA :NOTE
 BEQ :CONT
 CMP #1
 BNE :N1
 LDX ENTRY
 JSR GETADDR
 LDY #0
 LDA (CADD2),Y
 STA TEMP ;Length of string
 CLC
 ADC ENTRY
 STA ENTRY
]LOOP INX
 JSR GETCADD2
 STA ENTRY,X
 CPX ENTRY
 BNE ]LOOP
 BRA :CONT
:N1 CMP #2
 BNE :N3
 JSR :BUFDEC32
 BRA :CONT
:N3 CMP #3
 BNE :ERR
 JSR GETADDR
 LDY #0
 LDA (CADD2),Y
 STA ENTRY
 TAX
]LOOP INY
 LDA (CADD2),Y
 STA ENTRY,Y
 DEX
 BNE ]LOOP
 BRA :CONT
:ERR JSR PRINT
 ASC "[Unknown log entry type "
 DEC8 :TYPE
 ASC "]"
 NULL
 DEATH

:CONT JSR CLOSEALL
 LDX ENTRY ;Strip extra spaces (if any)
]LOOP2 LDA ENTRY,X
 CMP #" "
 BNE :CONT2
 DEX
 BNE ]LOOP2
 LDX #1 ;Min length
:CONT2 STX ENTRY
 STX :LINELEN
]LOOP LDA :LINELEN ;Will this fit on 1 line when expanded?
 CMP #60
 BCC :CONT3
 LDX #59 ;Find a space to split into 2 lines
]LOOP2 LDA ENTRY,X
 CMP #" "
 BEQ :SPLIT
 DEX
 BNE ]LOOP2
 LDX #59+1 ;If we can't, then the line will be chopped
:SPLIT DEX
 STX ENTRY
 BIT :PORN ;P or N?
 BPL :NRM
 JSR :LOGIT2
 BRA :PNCONT
:NRM JSR :LOGIT
:PNCONT LDX ENTRY ;Strip back text for next line
 LDY #0
]LOOP2 INX
 INY
 LDA ENTRY,X
 STA ENTRY,Y
 CPX :LINELEN
 BNE ]LOOP2
 LDA :LINELEN
 SEC
 SBC ENTRY
 STA :LINELEN
 STA ENTRY
 BRA ]LOOP

:CONT3 BIT :PORN ;P or N?
 BPL :NORM
 JSR :LOGIT2
 JMP :P

:NORM JSR :LOGIT

 LDA :GPARMS+4
 CMP #1
 BNEL :P

 LDA #1
 STA :TYPE
 LDX :CRTXT2
 STX ENTRY
]LOOP LDA :CRTXT2,X
 STA ENTRY,X
 DEX
 BNE ]LOOP
 JSR :LOGIT

 LDA #<:CRNUM
 STA CADD2
 LDA #>:CRNUM
 STA CADD2+1
 STZ ENTRY

 MLI_GET_TIME
 LDA $BF91
 LSR
 STA :YY
 LDA $BF90
 PHA
 AND #%0001_1111
 STA :DD
 PLA
 ROL
 ROL
 ROL
 ROL
 AND #%0000_1111
 STA :MM

 LDA :YY
 STA :CRNUM
 JSR :BUF32
 LDA :NUMOUT+1
 ORA #"0"
 STA :NEWPATH+5
 LDA :NUMOUT
 STA :NEWPATH+6
 LDA :MM
 STA :CRNUM
 JSR :BUF32
 LDA :NUMOUT+1
 ORA #"0"
 STA :NEWPATH+7
 LDA :NUMOUT
 STA :NEWPATH+8
 LDA :DD
 STA :CRNUM
 JSR :BUF32
 LDA :NUMOUT+1
 ORA #"0"
 STA :NEWPATH+9
 LDA :NUMOUT
 STA :NEWPATH+10
 LDA $BF93
 STA :CRNUM
 JSR :BUF32
 LDA :NUMOUT+1
 ORA #"0"
 STA :NEWPATH+11
 LDA :NUMOUT
 STA :NEWPATH+12
 LDA $BF92
 STA :CRNUM
 JSR :BUF32
 LDA :NUMOUT+1
 ORA #"0"
 STA :NEWPATH+13
 LDA :NUMOUT
 STA :NEWPATH+14

 MLI_RENAME :RPARMS ;Rename "LOG" to "LOG.ddmmyy"
 JSR MLIERR
 MLI_CREATE :CRPARMS ;Create "LOG" again
 JSR MLIERR
 LDA #1
 STA :TYPE
 LDX :CRTXT
 STX ENTRY
]LOOP LDA :CRTXT,X
 STA ENTRY,X
 DEX
 BNE ]LOOP
 JMP :CONT
:CRTXT STR "Log created"
:CRTXT2 STR "*-------------- No more messages in file --------------*"
:CRNUM DS 4
:DD DS 1
:MM DS 1
:YY DS 1

:LOGIT MLI_OPEN :OPARMS
 JSR MLIERR
 LDA :OPARMS+5
 STA :GPARMS+1
 STA :WPARMS+1
 STA :CPARMS+1
 MLI_GET_EOF :GPARMS
 JSR MLIERR
 MLI_SET_MARK :GPARMS
 JSR MLIERR
 MLI_WRITE :WPARMS
 JSR MLIERR
 MLI_CLOSE :CPARMS
 JMP MLIERR

:LOGIT2 LDA PARTYNUM
 JSR GETHEX
 STX :PATH2+15 ;Make sure these match -\
 STY :PATH2+16 ;                       |
 MLI_OPEN :OPARMS2
 JSR MLIERR
 LDA :OPARMS2+5
 STA :GPARMS2+1
 STA :WPARMS2+1
 STA :CPARMS2+1
 MLI_GET_EOF :GPARMS2
 JSR MLIERR
 MLI_SET_MARK :GPARMS2
 JSR MLIERR
 MLI_WRITE :WPARMS2
 JSR MLIERR
 MLI_CLOSE :CPARMS2
 JMP MLIERR

:P LDA CADD+1
 PHA
 LDA CADD
 PHA
 RTS
:NOTE DS 1

:OPARMS DFB 3
 DA :PATH
 DA IOBUFFER
 DS 1
:GPARMS DFB 2
 DS 1
 DS 3
:WPARMS DFB 4
 DS 1
 DA :BUFF
 DA LOGRECLEN
 DS 2
:CPARMS DFB 1
 DS 1
:PATH STR "LOG"

:OPARMS2 DFB 3
 DA :PATH2
 DA IOBUFFER
 DS 1
:GPARMS2 DFB 2
 DS 1
 DS 3
:WPARMS2 DFB 4
 DS 1
 DA :BUFF
 DA LOGRECLEN
 DS 2
:CPARMS2 DFB 1
 DS 1
:PATH2 STR "DATA/PARTYLOG.XX" ;<----------/

:LINELEN DS 1
:PORN DS 1

:RPARMS DFB 2
 DA :PATH ;Old pathname
 DA :NEWPATH ;New

:NEWPATH STR "LOG.yymmddhhmm"

:CRPARMS DFB 7
 DA :PATH
 DFB %11000011
 DFB $F2
 DA LOGRECLEN
 DFB 1
 DA 0
 DA 0

:BUFDEC32 JSR GETADDR
:BUF32 LDX #14
]LOOP STZ :NUMBER,X
 DEX
 BPL ]LOOP
 LDY #3
]LOOP LDA (CADD2),Y
 STA :NUMBER,Y
 DEY
 BPL ]LOOP
 LDX #10
 STX :NLEN
 LDY #0
]LOOP JSR :SUB1
 LDA :CHAR
 ORA #"0"
 STA :NUMOUT,Y
 INY
 LDA :NUMBER
 ORA :NUMBER+1
 ORA :NUMBER+2
 ORA :NUMBER+3
 ORA :NUMBER+4
 BNE ]LOOP
 BIT PADFLAG
 BPL :NOPAD
 LDY :NLEN
:NOPAD TYA
 CLC
 LDX ENTRY
 ADC ENTRY
 STA ENTRY
]LOOP LDA :NUMOUT-1,Y
 ORA #"0"
 INX
 STA ENTRY,X
 DEY
 BNE ]LOOP
 RTS
:SUB1 LDX #5*8
 LDA #0
 STA :CHAR
]LOOP ASL :NUMBER
 ROL :NUMBER+1
 ROL :NUMBER+2
 ROL :NUMBER+3
 ROL :NUMBER+4
 ROL :CHAR
 LDA :CHAR
 SEC
 SBC #10
 BCC :OVER
 STA :CHAR
 INC :NUMBER
:OVER DEX
 BNE ]LOOP
 RTS
:NUMBER DS 5 ;Leave these two together
:NUMOUT DS 10 ; (see :ZAPNUM)
:CHAR DS 1
:NLEN DS 1

:BUFF DS 2 ;Date
 DS 3 ;Time HH:MM:SS
:TYPE DS 1 ;Type
ENTRY DS $100 ;Text

LOGFILENOTE ENT
 STA :TYPE
 LDX #0 ;Save it
]LOOP LDA LOGBUFF,X
 STA ENTRY,X
 INX
 BNE ]LOOP
 LDX #0
 LDA #0
 JSR LOADLOGFILE
 INCR LOGBUFF ;Add 1 to the number of entries
 LDX #0
 LDA #0
 JSR SAVELOGFILE ;Save it out
 LDA LOGBUFF
 STA :REC
 LDA LOGBUFF+1
 STA :REC+1
 LDX #0 ;Restore it
]LOOP LDA ENTRY,X
 STA LOGBUFF,X
 INX
 BNE ]LOOP

 MLI_GET_TIME
 CLC
 XCE
 REP #$30
 PushWord #0
 PushWord #0
 PushWord #0
 PushWord #0
 Tool $0D03 ;ReadTimeHex
 PLX
 PLA
 PLA
 PLA
 SEC
 XCE
 STX LOGTIME+2 ;Second..

 LDX #3
]LOOP LDA $BF90,X
 STA LOGDATE,X
 DEX
 BPL ]LOOP
 LDA :TYPE
 STA LOGTYPE
 BEQ :COMMENT
 CMP #2
 BEQ :COMMENT

 LDX PNNAME
 STX LOGTEXT
]LOOP LDA PNNAME,X
 STA LOGTEXT,X
 DEX
 BNE ]LOOP
 LDA CONNECTRATE
 AND #%0000_1111
 STA LOGBAUD
 BIT DUMBTERM
 BPL :NODUMB
 STZ LOGBAUD ;0 for dumbterm
:NODUMB LDA LOGONS
 STA LOGCALL
 LDA LOGONS+1
 STA LOGCALL+1

:COMMENT LDX :REC
 LDA :REC+1
 JSR SAVELOGFILE
 JMP CLOSEALL
:REC DS 2
:TYPE DS 1

TEMP DS 1

 LST ON
MODEND EQU *
 LST OFF

 do M16PLUS
 SAV LIB.LOG.L
 fin

 END
