*-------------------------------
* Library (Msg)
*-------------------------------
 DAT
 LST OFF

 XC
 XC

 REL

 USE MACROS
 USE EQUATES
 USE VARS

 do M16PLUS-1
 DSK LIB.MSG.L
 fin

 EXT PRINT,GETCADD,CALCTB,BGCOLOR,TEXTCOLOR ;Print
 EXT CALLMOD ;Mod
 EXT MLIERR,PICKLINE,CLOSEALL,CHATFLAG ;Main
 EXT LOADBITMAP,SAVEBITMAP ;Files
 EXT DRAWBLOCM,SHAPE,PLUS,GETSHPMAP ;Map
 EXT MSENDBYTE ;Coms

MARKFREE ENT
 LDY #0
 HEX 2C
MARKUSED ENT
 LDY #$FF
 STY :MODE
 STX :MSG
 STA :MSG+1
 CLC
 XCE
 REP #$30
 LDA :MSG
 LSR
 LSR
 LSR
 STA :BYTE
 LDA :MSG
 AND #%0000_0000_0000_0111
 STA :BIT
 SEC
 XCE
 LDX :BYTE+1
 LDA #0
 JSR LOADBITMAP
 LDX :BIT
 LDA #%1000_0000
]LOOP DEX
 BMI :DONE
 LSR
 BRA ]LOOP
:DONE STA :ALT
 LDX :BYTE
 LDA BITMAPBUFF,X
 STA :VALUE
 LDA :ALT
 BIT :MODE
 BMI :ON
:OFF TRB :VALUE
 BRA :CONT
:ON TSB :VALUE
:CONT LDA :VALUE
 STA BITMAPBUFF,X
 LDX :BYTE+1
 LDA #0
 JMP SAVEBITMAP
:MSG DS 2
:BYTE DS 2
:BIT DS 2
:MODE DS 1
:ALT DS 1
:VALUE DS 1

GETFREEMSG ENT
 STZ :MSG
 STZ :MSG+1
 STZ :CNTR
 LDA #FILEBITMAP
 DEC
 ASL
 ASL
 TAX
 LDA HANDLES,X
 STA CADD
 LDA HANDLES+1,X
 STA CADD+1
 LDA HANDLES+2,X
 STA CADD+2
 STZ CADD+3
 LDY #3
]LOOP2 LDA [CADD],Y
 STA CADD3,Y
 DEY
 BPL ]LOOP2
 LDY #0
]LOOP LDA [CADD3],Y
 LDX #0
]LOOP2 INX
 CPX #9
 BEQ :ADD8
 ASL
 BCS ]LOOP2
 DEX
 TXA
 CLC
 ADC :MSG
 STA :MSG
 LDA :MSG+1
 ADC #0
 STA :MSG+1
 LDX :MSG
 LDA :MSG+1
 CLC ;Found a message OK
 RTS
:ADD8 LDA :MSG
 CLC
 ADC #8
 STA :MSG
 LDA :MSG+1
 ADC #0
 STA :MSG+1
 INY
 BNE ]LOOP
 INC CADD+1
 INC :CNTR
 LDA :CNTR
 CMP #$20 ;Don't change this
 BNE ]LOOP
 SEC ;Couldn't find a free message
 RTS
:CNTR DS 1
:MSG DS 2

NOTEPAD ENT
 BIT EDITFLAG
 BPL :NOK
 RTS
:NOK LDA CH
 STA :HV+2
 LDA CV
 STA :HV+3
 LDA VMODE
 STA :VMODE

 JSR GETSCREEN ;PICKLINE the screen
 DFB 14,23 ;on these lines
 DA :BUFFER ;and put it here
 STX :LEN ;X and A have length on return
 STA :LEN+1

 LDA CHATFLAG
 STA :CHATSAVE
 LDA #$FF
 STA CHATFLAG

 CALL "GAME.NOTEPAD" ;Unusual - but will work

 LDX :LEN ;Length
 LDA :LEN+1
 JSR SHOWMSG
 DFB 14,23 ;Lines to use (top, bottom)
 DA :BUFFER

 LDA :CHATSAVE
 STA CHATFLAG

* VMODE bits:
* 4 - cursor     0=on   1=off
* 2 - inverse    0=off  1=on
* 0 - mousetext  0=on   1=off

 LDA :VMODE
 AND #%0000_0001 ;MouseText?
 BNE :MTOFF
 LDA #$1B
 HEX 2C
:MTOFF LDA #$18
 JSR COUT
 LDA :VMODE
 AND #%0000_0100 ;Inverse?
 BEQ :INVOFF
 LDA #$0F
 HEX 2C
:INVOFF LDA #$0E
 JSR COUT
 LDA :VMODE
 AND #%0001_0000 ;Cursor?
 BNE :CURSOFF
 LDA #$05
 HEX 2C
:CURSOFF LDA #$06
 JSR COUT

 JSR PRINT
:HV GOTOXY 0;0
 NULL
 RTS
:VMODE DS 1
:LEN DS 2
:BUFFER DS 80*9
:CHATSAVE DS 1

EDITFLAG DFB 0

SHOWMSG ENT
 STX :LENGTH
 STA :LENGTH+1
 PULL CADD
 JSR GETCADD
 STA :FROM ;Top line
 JSR GETCADD
 STA :TO ;Bottom line
 JSR GETCADD
 STA CADD4 ;Buffer to get msg from
 JSR GETCADD
 STA CADD4+1

 STZ :LEN
 STZ :LEN+1

 LDA TEXTCOLOR
 STA :TCSAVE
 LDA BGCOLOR
 STA :BGSAVE

 LDA TEXTCOLOR ;So colours will change
 INC
 STA :TBCOLOR

 LDA CHATFLAG
 STA :CHATSAVE
 STZ CHATFLAG

 PUSH CADD

 LDA :FROM
 STA :TOPHV+3
 JSR PRINT
:TOPHV GOTOXY 0;0
 NULL

 LDY #0
]LOOP LDA :LEN+1 ;Finished yet?
 CMP :LENGTH+1
 BNE :DO
 LDA :LEN
 CMP :LENGTH
 BEQL :DONE
:DO LDA (CADD4),Y
 CMP #" "
 BNE :OK
 INC :SPACES
 JMP :NEXT
:OK PHA
 LDA CV
 STA :GOTO+3
 LDA :SPACES
 BEQ :NONE
 CMP #4
 BCC :DOEM
 LDA CH
 CLC
 ADC :SPACES
 STA :GOTO+2
 JSR PRINT
:GOTO GOTOXY 0;0
 NULL
 BRA :NONE
:DOEM TAX
]LOOP2 LDA #" "
 JSR DOMODE
 JSR COUT
 DEX
 BNE ]LOOP2
:NONE PLA
 CMP #$FF ;A shape?
 BEQ :ASHAPE
 JSR DOMODE
 CMP #$8D
 BNE :NOCR
 LDA CV
 CMP #23
 BEQ :DONE
 LDA #$0D
:NOCR BIT :CHATSAVE ;Restore from 'chat mode' or 'screen refresh'?
 BPL :CFREE
 PHA
 PHX
 PHY
 JSR :DOTB ;Do we need to change colour?
 PLY
 PLX
 PLA
:CFREE JSR COUT
 STZ :SPACES
 LDA CH
 CMP #79
 BNE :CHKV
 LDA CV
 CMP #23
 BNE :CHKV
 INY
 BNE :HVOK
 INC CADD4+1
:HVOK LDA (CADD4),Y
 CMP #' '
 BNE :DONE
 JSR PRINT
 INVERSE
 CLEOL
 NULL
 BRA :DONE
:ASHAPE PHY
 PHX
 JSR GETSHPMAP
 JSR DRAWBLOCM ;Updates SHAPEMAP table, text screen and SHR screen
 PLX
 PLY
 STZ :SPACES
 INY
 BNE :CHKV
 INC CADD4+1
:CHKV LDA CV
 CMP :TO
 BEQ :NEXT
 BCS :DONE
:NEXT INCR :LEN
 INY
 BNEL ]LOOP
 INC CADD4+1
 JMP ]LOOP
:DONE LDA :TCSAVE
 STA TEXTCOLOR
 STA :RETC+2
 LDA :BGSAVE
 STA BGCOLOR
 JSR PRINT
 NORMAL
 MTOFF
:RETC COLOR 0
 NULL
 LDA :CHATSAVE
 STA CHATFLAG
 RTS

:DOTB CLC ;Get text/background colours
 XCE
 REP #$30
 PushZLong CADD
 LDA #TBCBUFF
 STA CADD
 LDA #^TBCBUFF
 STA CADD+2
 SEP #$10
 LDX CV
 LDA #0 ;Get address of line
]LOOP CPX #0
 BEQ :CONT2
 CLC
 ADC #80
 DEX
 BRA ]LOOP
:CONT2 CLC
 ADC CADD
 STA CADD

 SEP #$30
 LDY CH
 LDA [CADD],Y
 TAX
 SEC
 XCE
 CPX :TBCOLOR
 BEQ :TBSAME
 STX :TBCOLOR
 TXA
 PHA
 AND #$F
 STA BGCOLOR
 PLA
 LSR
 LSR
 LSR
 LSR
 STA :C+2
 JSR PRINT
:C COLOR 0
 NULL
:TBSAME PullLong CADD
 RTS
:TBCOLOR DS 1

:FROM DS 1
:TO DS 1
:LENGTH DS 2
:LEN DS 2
:SPACES DS 1
:TCSAVE DS 1
:BGSAVE DS 1
:CHATSAVE DS 1

DOMODE STA :CHAR
 CMP #$80
 BCC :LOW
 LDA VMODE
 AND #%0000_0100
 BEQ :DONE
 LDA #$0E
 JSR COUT
 BRA :DONE
:LOW CMP #$40
 BCC :TRYINV
 LDA VMODE
 AND #%0000_0001
 BEQ :MTINV
 LDA #$1B
 JSR COUT
:MTINV LDA VMODE
 AND #%0000_0100
 BNE :SETMI
 LDA #$0F
 JSR COUT
:SETMI LDA #%1000_0000
 TSB :CHAR
 BRA :DONE
:TRYINV LDA VMODE
 AND #%0000_0100
 BNE :SETINV
 LDA #$0F
 JSR COUT
:SETINV LDA :CHAR
 CMP #' '
 BCC :ADDC0
 LDA #%1000_0000
 HEX 2C
:ADDC0 LDA #%1100_0000
 TSB :CHAR
 LDA VMODE
 AND #%0000_0001
 BNE :DONE
 LDA #$18
 JSR COUT
:DONE LDA :CHAR
 RTS
:CHAR DS 1

GETSCREEN ENT ;X and A reg have length of msg (on return)
 PULL CADD
 JSR GETCADD
 STA :FROM ;Top line
 JSR GETCADD
 STA :TO ;Bottom line
 JSR GETCADD
 STA CADD4 ;Buffer to store msg
 JSR GETCADD
 STA CADD4+1
 STZ :Y
 STZ :Y+1
 STZ :CRS

 LDA TEXTCOLOR
 STA :TCSAVE
 LDA BGCOLOR
 STA :BGSAVE

]TOPLOOP BIT CHATFLAG ;For NOTEPAD only
 BMI :SKIPTB
 CLC ;Get text/background colours and save them
 XCE
 REP #$30
 PushZLong CADD
 LDA #TBCBUFF
 STA CADD
 LDA #^TBCBUFF
 STA CADD+2
 SEP #$10
 LDX :FROM
 LDA #0 ;Get address of line
]LOOP CPX #0
 BEQ :CONT2
 CLC
 ADC #80
 DEX
 BRA ]LOOP
:CONT2 CLC
 ADC CADD
 STA CADD

 LDX :FROM
 JSR CALCTB ;Calc 'colour table' address for line X
 SEP #$30
 LDY #0
]LOOP LDA [CADD6],Y
 STA [CADD],Y
 INY
 CPY #80
 BNE ]LOOP

 REP #$30
 PullLong CADD
 SEC
 XCE

:SKIPTB LDX #0
 LDY #79
 LDA :FROM
 JSR PICKLINE

 LDX #79
]LOOP LDA $200,X
 CMP #" "
 BNE :CHAR
 DEX
 BPL ]LOOP
 INC :CRS
 LDY :Y
 BRA :EOL

:CHAR INX
 STX :LEN
 STZ :CRS
 LDY :Y
 LDX #0
]LOOP LDA $200,X
 STA (CADD4),Y
 INY
 BNE :OK
 INC CADD4+1
 INC :Y+1
:OK INX
 CPX :LEN
 BNE ]LOOP
 CPX #80
 BEQ :SAVEY
:EOL LDA #$8D
 STA (CADD4),Y
 INY
 BNE :SAVEY
 INC CADD4+1
 INC :Y+1
:SAVEY STY :Y
 INC :FROM
 LDA :FROM
 CMP :TO
 BEQL ]TOPLOOP
 BCCL ]TOPLOOP

 LDA :Y ;Lessen length of RETURN's at end of file
 SEC
 SBC :CRS
 STA :Y
 LDA :Y+1
 SBC #0
 STA :Y+1

 LDA :TCSAVE
 STA TEXTCOLOR
 STA :RETC+2
 LDA :BGSAVE
 STA BGCOLOR

 PUSH CADD

 JSR PRINT
:RETC COLOR 0
 NULL

 LDX :Y ;Length of 'message'
 LDA :Y+1
 RTS
:LEN DS 1
:FROM DS 1
:TO DS 1
:Y DS 2
:CRS DS 1
:TCSAVE DS 1
:BGSAVE DS 1

MSGEDIT ENT
 STX TOPLINE
 STA BOTLINE
]TOPLOOP LDA CH
 STA MCH
 LDA CV
 STA MCV
]LOOP JSR KEYIN
 CMP #$FF
 BEQ :DELETE
 CMP #" "
 BCC :CTRL
 JMP CHAR
:DELETE JMP DELETE
:CTRL LDX :KEYS
]LOOP2 CMP :KEYS,X
 BEQ :GOTONE
 DEX
 BNE ]LOOP2
 BRA ]LOOP
:GOTONE DEX
 TXA
 ASL
 TAX
 JMP (:TABLE,X)

:KEYS DFB :ENDKEYS-*-1
 DFB $9B ;ESC
 DFB "H"-$40 ;Left
 DFB "U"-$40 ;Right
 DFB "J"-$40 ;Down
 DFB "K"-$40 ;Up
 DFB "M"-$40 ;CR
 DFB "B"-$40 ;Beginning of line
 DFB "C"-$40 ;Center text
 DFB "D"-$40 ;Gobble
 DFB "E"-$40 ;Insert SPACE
 DFB "I"-$40 ;TAB
 DFB "N"-$40 ;End of line
 DFB "L"-$40 ;Top-left
 DFB "Y"-$40 ;Clear to end of line
 DFB "Z"-$40 ;Zap line
 DFB "X"-$40 ;Cut
 DFB "V"-$40 ;Paste
:ENDKEYS

:TABLE DA JUMP
 DA LEFT
 DA RIGHT
 DA DOWN
 DA UP
 DA CTRLM
 DA BOL
 DA CENTRE
 DA GOBBLE
 DA INSERT
 DA TAB
 DA EOL
 DA GOTOP
 DA CLREOF
 DA ZAP
 DA CUT
 DA PASTE

TOPLINE DS 1
BOTLINE DS 1
MCH DS 1
MCV DS 1

JUMP RTS

CHAR STA :OK+1
 LDA CH
 CMP #79
 BNE :OK
 LDA CV
 CMP BOTLINE
 BNE :OK
 LDA TOPLINE
 STA :GOTO+3
 JSR PRINT
 CURSOROFF
 NULL
 LDA :OK+1
 JSR COUT
 JSR PRINT
:GOTO GOTOXY 0;0
 CURSORON
 NULL
 JMP ]TOPLOOP
:OK LDA #" "
 JSR COUT
 JMP ]TOPLOOP

DELETE LDA CV
 CMP TOPLINE
 BNE :OK
 LDA CH
 BNE :OK
 JMP ]TOPLOOP
:OK JSR PRINT
 NORMAL
 CURSORLEFT
 ASC " "
 CURSORLEFT
 NULL
 JMP ]TOPLOOP

LEFT LDA CH
 BNE :OK
 LDA CV
 CMP TOPLINE
 BNE :OK
 LDA BOTLINE
 STA :GOTO+3
 JSR PRINT
:GOTO GOTOXY 79;0
 NULL
 JMP ]TOPLOOP
:OK LDA #"H"-$40
 JSR COUT
 JMP ]TOPLOOP

RIGHT LDA CH
 CMP #79
 BNE :OK
 LDA CV
 CMP BOTLINE
 BNE :OK1
 LDA TOPLINE
 STA :GOTO+3
 JSR PRINT
:GOTO GOTOXY 0;0
 NULL
 JMP ]TOPLOOP
:OK1 LDA #$0D
 HEX 2C
:OK LDA #"\"-$40
 JSR COUT
 JMP ]TOPLOOP

DOWN LDA CV
 CMP BOTLINE
 BNE :OK
 LDA TOPLINE
 STA :GOTO+2
 JSR PRINT
:GOTO VTAB 0
 NULL
 JMP ]TOPLOOP
:OK LDA #"J"-$40
 JSR COUT
 JMP ]TOPLOOP

UP LDA CV
 CMP TOPLINE
 BNE :OK
 LDA BOTLINE
 STA :GOTO+2
 JSR PRINT
:GOTO VTAB 0
 NULL
 JMP ]TOPLOOP
:OK LDA #"_"-$40
 JSR COUT
 JMP ]TOPLOOP

CTRLM LDA CV
 CMP BOTLINE
 BNE :OK
 LDA TOPLINE
 STA :GOTO+3
 JSR PRINT
:GOTO GOTOXY 0;0
 NULL
 JMP ]TOPLOOP
:OK JSR PRINT
 CR
 NULL
 JMP ]TOPLOOP

BOL JSR PRINT
 HTAB 0
 NULL
 JMP ]TOPLOOP

CENTRE LDX #0
 LDY #79
 LDA CV
 JSR PICKLINE
 LDX #0
]LOOP LDA $200,X
 CMP #" "
 BNE :NOSP
 INX
 CPX #80
 BNE ]LOOP
 JMP ]TOPLOOP
:NOSP STX :LBIT
 LDX #79
]LOOP LDA $200,X
 CMP #" "
 BNE :NOSP2
 DEX
 BPL ]LOOP
:NOSP2 STX :RBIT
 INX
 LDA #0
 STA $200,X
 LDA :RBIT
 SEC
 SBC :LBIT
 STA :LEN
 CMP #78
 BCS :END
 LDA #80
 SEC
 SBC :LEN
 LSR
 STA :X+2
 JSR PRINT
 NORMAL
 ZAPLINE
:X HTAB 0
 NULL
 LDX :LBIT
]LOOP LDA $200,X
 BEQ :END
 JSR DOMODE
 JSR COUT
 INX
 BPL ]LOOP
:END JMP ]TOPLOOP
:LBIT DS 1
:RBIT DS 1
:LEN DS 1

GOBBLE LDX #0
 LDY #79
 LDA CV
 JSR PICKLINE
 LDX #79
]LOOP LDA $200,X
 CMP #" "
 BNE :NOSP
 DEX
 BPL ]LOOP
 JMP ]TOPLOOP
:NOSP STX :RBIT
 LDX MCH
 CPX :RBIT
 BCS :DONE
 INX
]LOOP LDA $200,X
 JSR DOMODE
 JSR COUT
 CPX :RBIT
 BEQ :DONE
 INX
 BRA ]LOOP
:DONE LDA MCH
 STA :GOTO+2
 JSR PRINT
 NORMAL
 CLEOL
:GOTO HTAB 0
 NULL
 JMP ]TOPLOOP
:RBIT DS 1

INSERT LDX #0
 LDY #79
 LDA CV
 JSR PICKLINE
 LDA $200+79
 CMP #" "
 BNE :DONT
 LDX #79
]LOOP LDA $200,X
 CMP #" "
 BNE :NOSP
 DEX
 BPL ]LOOP
:DONT JMP ]TOPLOOP
:NOSP CPX MCH
 BCC :DONT
 STX :RBIT
 LDA #" "
 JSR COUT
 LDX MCH
]LOOP2 LDA $200,X
 JSR COUT
 CPX :RBIT
 BEQ :DONE
 INX
 BRA ]LOOP2
:DONE LDA MCH
 STA :GOTO+2
 LDA MCV
 STA :GOTO+3
 JSR PRINT
:GOTO GOTOXY 0;0
 NULL
 JMP ]TOPLOOP
:RBIT DS 1

TAB LDX CH
 LDY CV
]LOOP INX
 TXA
 AND #%0000_0111
 BNE ]LOOP
 TXA
 CMP #80
 BCC :OK
 LDA #0
 LDY CV
 CPY BOTLINE
 BNE :OK1
 LDY TOPLINE
 DEY
:OK1 INY
:OK STA :GOTO+2
 STY :GOTO+3
 JSR PRINT
:GOTO GOTOXY 0;0
 NULL
 JMP ]TOPLOOP

EOL LDX #0
 LDY #79
 LDA CV
 JSR PICKLINE
 LDX #79
]LOOP LDA $200,X
 CMP #" "
 BNE :NOSP
 DEX
 BPL ]LOOP
 JMP ]TOPLOOP
:NOSP CPX #79
 BEQ :DONT
 INX
:DONT STX :GOTO+2
 JSR PRINT
:GOTO HTAB 0
 NULL
 JMP ]TOPLOOP

GOTOP LDA TOPLINE
 STA :GOTO+3
 JSR PRINT
:GOTO GOTOXY 0;0
 NULL
 JMP ]TOPLOOP

CLREOF JSR PRINT
 CLEOL
 NULL
 JMP ]TOPLOOP

ZAP JSR PRINT
 ZAPLINE
 NULL
 JMP ]TOPLOOP

CUT LDX #0
 LDY #79
 LDA CV
 JSR PICKLINE
 LDX #0
]LOOP LDA $200,X
 STA CLIP,X
 INX
 CPX #80
 BNE ]LOOP
 LDA MCH
 STA :GOTO2+2
 JSR PRINT
:GOTO2 HTAB 0
 ZAPLINE
 NULL
 JMP ]TOPLOOP

PASTE JSR PRINT
 HTAB 0
 NORMAL
 ZAPLINE
 CURSOROFF
 NULL
 LDX #0
]LOOP LDA CLIP,X
 JSR DOMODE
 JSR COUT
 INX
 CPX #80
 BNE ]LOOP
 LDA MCH
 STA :GOTO+2
 LDA MCV
 STA :GOTO+3
 JSR PRINT
:GOTO GOTOXY 0;0
 CURSORON
 NULL
 JMP ]TOPLOOP

GETFILE ENT
 LDA #$FF
 STA EDITFLAG
 PULL CADD
 JSR GETCADD
 STA :FROM
 JSR GETCADD
 STA :TO
 JSR GETCADD
 STA :PATH
 TAX
 LDY #0
]LOOP PHY
 JSR GETCADD
 PLY
 STA :PATH+1,Y
 INY
 DEX
 BNE ]LOOP

 PUSH CADD

 JSR :CLEAR

 LDA :FROM
 STA :GOTO+3
 JSR PRINT
:GOTO GOTOXY 0;0
 NULL
 JSR CLOSEALL

 MLI_OPEN :OPARMS
 CMP #$46
 BNE :OK
 JSR PRINT
 ASC "<file "
 QUOTE
 PRSTRING :PATH
 QUOTE
 ASC " not found>"
 NULL
 JMP :DONE

:OK JSR MLIERR
 LDA :OPARMS+5
 STA :GPARMS+1
 STA :RPARMS+1

 MLI_GET_EOF :GPARMS
 JSR MLIERR
 JSR :READ

 LDX #0
]LOOP LDA :GPARMS+3
 BNE :PR
 LDA :GPARMS+2
 BEQ :DONE
:PR LDA MISCBUFF,X
 ORA #%1000_0000
 JSR COUT
 DECR :GPARMS+2
 INX
 BNE :NOR
 JSR :READ
:NOR LDA CV
 CMP :TO
 BCC ]LOOP
 PHX
 JSR PRINT
 COLOR PINK
 CENTER "[ESC]-abort, [SPACE]-continue"
 COLOR WHITE
 CURSOROFF
 NULL
]LOOP2 JSR KEYIN
 CMP #$9B
 BEQ :ESC
 CMP #" "
 BNE ]LOOP2
 JSR PRINT
 CURSORON
 NULL
 JSR :CLEAR
 PLX
 JMP ]LOOP

:ESC PLX
 JSR PRINT
 ZAPLINE
 CURSORON
 NULL
:DONE JSR CLOSEALL
 STZ EDITFLAG
 RTS

:READ PHX
 MLI_READ :RPARMS
 CMP #$4C ;EOF?
 BEQ :ROK
 JSR MLIERR
:ROK PLX
 RTS

:CLEAR LDA :TO
 STA :GOTOC+3
 JSR PRINT
:GOTOC GOTOXY 0;0
 ZAPLINE
 HTAB 0
 NULL
]LOOP JSR PRINT
 CURSORUP
 ZAPLINE
 NULL
 LDA CV
 CMP :FROM
 BNE ]LOOP
 RTS

:OPARMS DFB 3
 DA :PATH
 DA IOBUFFER
 DS 1
:GPARMS DFB 2
 DS 1
 DS 3
:RPARMS DFB 4
 DS 1
 DA MISCBUFF
 DA $100
 DS 2
:PATH DS 1+31

:FROM DS 1
:TO DS 1

 LST ON
MODEND EQU *
 LST OFF

 do M16PLUS
 SAV LIB.MSG.L
 fin

 END
