*-------------------------------
* LIB.TOP (Library)
*-------------------------------
 DAT
 LST OFF

 XC
 XC

 REL

 USE EQUATES

 do M16PLUS-1
 DSK LIB.TOP.L
 fin

* Main
 EXT RESET,MLIERR,INITHOOK,DROP,RESTART,ROLLD6,CHECKUSE
 EXT DELAY,UPPER,QUIT,REBOOT,CLOSEALL,SETRANDSEED
 EXT GETCR,PICKLINE,GET_LINE,GETNUM,LIB_DEATH,CALCPLR
 EXT ASK,GETNIBBLE,ERROR,GETHEX,SHOWPNTR,RANDOM,KPCHECK
 EXT SETDSKACC,REFRESH,INITCNTR,TICKTOCK

* Log
 EXT LOGNOTE,LOGNOTESTR,LOGNOTENUM,LOGNOTEBUFF
 EXT PLOGNOTE,PLOGNOTESTR,PLOGNOTENUM,PLOGNOTEBUFF
 EXT LOGFILENOTE

* Coms
 EXT INITMODEM,MODEMTALK,HANGUP,READY,CHECKIN,CHECKMODEM
 EXT GETPORTREG,SETPORTREG,MGETBYTE,MSENDBYTE,CHECKIN2,GETALL
 EXT INITCARD,CHECKCTRLX

* Mod
 EXT POPMOD,EXECUTE,CALLMOD,EXITMOD

* Disk
 EXT CHECKFILE,LOADFILE,SAVEFILE,LOADSLICE,SAVESLICE

* Files
 EXT LOADITEM,LOADPLR,LOADMON,LOADMON2,LOADITEM2,LOADSPELL
 EXT SAVEITEM,SAVEPLR,SAVEMON,SAVEMON2,SAVEITEM2,SAVESPELL
 EXT LOADLOGFILE,LOADMAP,LOADMAP2,LOADST,LOADSCEN,LOADPN
 EXT SAVELOGFILE,SAVEMAP,SAVEMAP2,SAVEST,SAVESCEN,SAVEPN
 EXT LOADHOF,SAVEHOF,METOMEM,MEMTOME,LOADMSG,SAVEMSG
 EXT LOADMSGINDX,SAVEMSGINDX,LOADBITMAP,SAVEBITMAP
 EXT LOADVARS,SAVEVARS,LOADSIGN,SAVESIGN,LOADINV,SAVEINV

* Print
 EXT PRINT,GETCADD,GETCADD2,GETADDR,PR0DEC

* Map
 EXT RECLAIM,PRMAPALL,DRAW9X9,GETGRID,DRAWBLOK,GETMAP,GETMAP2
 EXT PUTMAP,PUTMAP2,PUTMAP2M,INVIEW,DOSPC,DOSHP,SHOWMAP

* Spell
 EXT KNOWNSP,ALTERSP,SLIST

* Msg
 EXT GETFILE,GETSCREEN,MSGEDIT,SHOWMSG,NOTEPAD,GETFREEMSG
 EXT MARKFREE,MARKUSED

* The following "jump table"
* must agree with LIB.JMP

 JMP PRINT
 JMP EXECUTE
 JMP CALLMOD
 JMP EXITMOD
 JMP INITHOOK
 JMP SETRANDSEED
 JMP RANDOM
 JMP HANGUP
 JMP DROP
 JMP INITMODEM
 JMP CHECKMODEM
 JMP CHECKIN
 JMP MODEMTALK
 JMP QUIT
 JMP REBOOT
 JMP LOGNOTE
 JMP LOGNOTESTR
 JMP LOGNOTENUM
 JMP LOGNOTEBUFF
 JMP UPPER
 JMP CHECKFILE
 JMP MLIERR
 JMP LOADSLICE
 JMP SAVESLICE
 JMP LOADFILE
 JMP SAVEFILE
 JMP CLOSEALL
 JMP GETCR
 JMP GETNUM
 JMP GET_LINE
 JMP DRAWBLOK
 JMP GETMAP
 JMP PUTMAP
 JMP LIB_DEATH
 JMP CALCPLR
 JMP DELAY
 JMP RESTART
 JMP LOADITEM
 JMP SAVEITEM
 JMP LOADPLR
 JMP SAVEPLR
 JMP RESET
 JMP PICKLINE
 JMP DRAW9X9
 JMP PRMAPALL
 JMP PUTMAP2
 JMP READY
 JMP POPMOD
 JMP RECLAIM
 JMP LOADMON
 JMP SAVEMON
 JMP GETMAP2
 JMP LOADMON2
 JMP SAVEMON2
 JMP PUTMAP2M
 JMP GETGRID
 JMP LOGFILENOTE
 JMP LOADLOGFILE
 JMP SAVELOGFILE
 JMP LOADMAP
 JMP SAVEMAP
 JMP LOADMAP2
 JMP SAVEMAP2
 JMP LOADST
 JMP SAVEST
 JMP LOADSCEN
 JMP SAVESCEN
 JMP LOADPN
 JMP SAVEPN
 JMP CHECKUSE
 JMP LOADITEM2
 JMP SAVEITEM2
 JMP LOADSPELL
 JMP SAVESPELL
 JMP KNOWNSP
 JMP ALTERSP
 JMP ROLLD6
 JMP GETFILE
 JMP GETSCREEN
 JMP MSGEDIT
 JMP SHOWMSG
 JMP ASK
 JMP GETNIBBLE
 JMP LOADHOF
 JMP SAVEHOF
 JMP INVIEW
 JMP METOMEM
 JMP MEMTOME
 JMP ERROR
 JMP NOTEPAD
 JMP GETHEX
 JMP LOADMSG
 JMP SAVEMSG
 JMP LOADMSGINDX
 JMP SAVEMSGINDX
 JMP GETFREEMSG
 JMP LOADBITMAP
 JMP SAVEBITMAP
 JMP MARKFREE
 JMP MARKUSED
 JMP LOADVARS
 JMP SAVEVARS
 JMP SHOWPNTR
 JMP PLOGNOTE
 JMP PLOGNOTESTR
 JMP PLOGNOTENUM
 JMP PLOGNOTEBUFF
 JMP KPCHECK
 JMP GETPORTREG
 JMP SETPORTREG
 JMP SETDSKACC
 JMP LOADSIGN
 JMP SAVESIGN
 JMP MGETBYTE
 JMP MSENDBYTE
 JMP DOSPC
 JMP DOSHP
 JMP CHECKIN2
 JMP GETALL
 JMP INITCARD
 JMP REFRESH
 JMP SHOWMAP
 JMP LOADINV
 JMP SAVEINV
 JMP CHECKCTRLX
 JMP INITCNTR
 JMP TICKTOCK

 LST ON
MODEND EQU *
 LST OFF

 do M16PLUS
 SAV LIB.TOP.L
 fin

 END
