*-------------------------------
* MAP.EDITOR
*-------------------------------
 DAT
 LST OFF

 ORG $8000 ;Always

 USE MACROS
 USE EQUATES
 USE VARS
 USE LIB.JMP
 USE ST.DSECT
 USE SCEN.DSECT
 USE SIGN.DSECT

 TYP $F4
 do M16PLUS-1
 DSK RUN/MODULES/MAP.EDITOR
 fin

NUMSHAPES = $13 ;Number of shapes in SHAPES

 MODID "MAP.EDITOR"

START JSR PRINT
 HOME
 CURSOROFF
 BOX "Map Editor"
 NULL
 LDA #$FF
 STA MAPLOOK

 JSR GETLVLS

 LDX #0
 LDA #0
 JSR LOADSCEN
 LDA SCENBUFF
 STA MAXSCEN

START2 JSR PRINT
 GOTOXY 0;4
 CURSOROFF
 INVERSE
 LUP 36
 ASC " "
 --^
 CR
 LUP 16
 ASC "  "
 HTAB 34
 ASC "  "
 CR
 --^
 LUP 36
 ASC " "
 --^
 GOTOXY 70;5
 NULL
 JSR SHOWPNTR

 LDX #0
 JSR DOSHAPES
 JMP DISPLAY

BOT JSR PRINT
 NORMAL
 MTOFF
 GOTOXY 0;0
 ASC "Number/levels : "
 COLOR YELLOW
 DEC8 NUMLVLS
 COLOR WHITE
 CR
 ASC "Current level : "
 COLOR YELLOW
 DEC8 CURRLVL
 COLOR WHITE
 CR
 ASC "Curr Scenario : "
 COLOR YELLOW
 DEC8 SCENARIO
 COLOR WHITE
 ASC " "
 COLOR PINK
 PRFLAG SCFREE
 COLOR WHITE
 NULL

 JSR PRINT
 GOTOXY 0;23
 CLEOS
 ASC "["
 NULL
 LDA SYSOPFLAG
 BPL :NO
 JSR PRINT
 ASC "8/2"
 NULL
 BRA :CONT
:NO JSR PRINT
 MTON
 INVERSE
 ASC "A"
 NORMAL
 ASC "-"
 INVERSE
 ASC "K"
 NORMAL
 ASC "/"
 INVERSE
 ASC "J"
 NORMAL
 MTOFF
 NULL
:CONT JSR PRINT
 ASC "], L)oad, S)ave, "
 ASC "A)dd, Z)ap, U)p, D)own, H)elp, X, V, F, Q)uit : "
 CURSOROFF
 INVERSE
 ASC " "
 NORMAL
 NULL
 LDA CH
 STA BOT2CH+2
 STZ BOTFLAG

BOT2 BIT BOTFLAG
 BMIL BOT
 JSR PRINT
BOT2CH GOTOXY 0;23
 NULL

]TOPLOOP JSR TICKTOCK
 JSR WAITIN
 BCS :YES2
 JSR GETLOC
 JSR DOSPC
 JSR WAITIN
 BCS :YES
 JSR GETLOC
 JSR DOSHP
 JMP ]TOPLOOP
:YES PHA
 JSR GETLOC
 JSR DOSHP
 PLA
 JMP GOTKEY
:YES2 PHA
 JSR GETLOC
 JSR DOSPC
 PLA
 BRA :YES

WAITIN STZ :FLAG
 STZ :CNTR
 STZ :CNTR2
]LOOP BIT DUMBTERM
 BMI :OVER
 JSR CHECKCTRLX
 JSR CHECKIN ;Did we get something from the modem?
 BCS :KEY
:OVER LDA $C000
 BMI :KEY
 BIT :FLAG
 BMI :MINUS
:PLUS LDA $C019
 BPL ]LOOP
 LDA #$FF
 STA :FLAG
 BRA ]LOOP
:MINUS LDA $C019
 BMI ]LOOP
 INC :CNTR
 LDA :CNTR
 BNE ]LOOP
 INC :CNTR2
 LDA :CNTR2
 CMP #16
 BNE ]LOOP
 CLC
 RTS
:KEY SEC
 RTS
:FLAG DS 1
:CNTR DS 1
:CNTR2 DS 1

GOTKEY STA $C010
 PHA
 JSR INITCNTR
 JSR PRINT
 MTOFF
 NORMAL
 COLOR WHITE
 NULL
 PLA
 JSR UPPER
 LDX :KEYS
]LOOP CMP :KEYS,X
 BEQ :GOTONE
 DEX
 BNE ]LOOP
 JMP ]TOPLOOP
:GOTONE DEX
 TXA
 ASL
 TAX
 JMP (:TABLE,X)

:KEYS DFB :ENDKEYS-*-1
 DFB "Q"
 DFB "L"
 DFB "S"
 DFB "A"
 DFB "U"
 DFB "D"
 DFB "H"-$40
 DFB "U"-$40
 DFB "K"-$40
 DFB "J"-$40
 DFB " "
 DFB "F"-$40
 DFB "Z"
 DFB "M"-$40
 DFB "H"
 DFB "8"
 DFB "9"
 DFB "X"
 DFB "V"
 DFB "F"
 DFB "0"
 DFB "1"
 DFB "2"
 DFB "3"
 DFB "4"
 DFB "5"
 DFB "6"
 DFB "7"
:ENDKEYS

:TABLE DA EXIT
 DA LOAD
 DA SAVE
 DA ADDLEVEL
 DA GOUP
 DA GODOWN
 DA LEFT
 DA RIGHT
 DA UP
 DA DOWN
 DA ALTER
 DA DOFLAG
 DA ZAPLEVEL
 DA STAIRS
 DA HELP
 DA BYTEUP
 DA BYTEDN
 DA SCEN
 DA VIEW
 DA FILL
 DA TYPE0
 DA TYPE1
 DA TYPE2
 DA TYPE3
 DA TYPE4
 DA TYPE5
 DA TYPE6
 DA TYPE7

TYPE0 LDA #0
 HEX 2C
TYPE1 LDA #1
 HEX 2C
TYPE2 LDA #2
 HEX 2C
TYPE3 LDA #3
 HEX 2C
TYPE4 LDA #4
 HEX 2C
TYPE5 LDA #5
 HEX 2C
TYPE6 LDA #6
 HEX 2C
TYPE7 LDA #7
 STA SUBTYPE
 ASL
 ASL
 ASL
 ASL
 ASL
 STA :VAL
 LDX XPOS
 LDY YPOS
 JSR GETMAP
 PHA
 ORA :VAL
 STA :VAL
 LDA SUBTYPE
 XBA
 PLA
 LDX XPOS
 LDY YPOS
 JSR PUTMAP
 LDA XPOS
 ASL
 CLC
 ADC #2
 STA :CHV+2
 LDA YPOS
 CLC
 ADC #5
 STA :CHV+3
 STA :CHV2+3
 LDA :VAL
 STA :SHAPE+2
 JSR PRINT
:CHV GOTOXY 0;0
:SHAPE DOSHAPE 0
 NULL
 LDA XPOS
 ASL
 CLC
 ADC #37
 STA :CHV2+2
 JSR PRINT
:CHV2 GOTOXY 0;0
 NORMAL
 MTOFF
 HEX8 :VAL
 NULL
 JSR CURSOR
 JMP BOT2
:VAL DS 1

FILL JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 CURSORON
 COLOR PINK
 ASC "Fill level with current shape (y/n)? : "
 COLOR WHITE
 NULL
 JSR KEYIN
 JSR UPPER
 CMP #"Y"
 BNEL BOT
 JSR PRINT
 ASC "Yes"
 NULL
 LDA SUBTYPE
 ASL
 ASL
 ASL
 ASL
 ASL
 ORA FILBYTE
 LDX #0
]LOOP STA MAP,X
 INX
 BNE ]LOOP
 JMP DISPLAY

VIEW JSR PRINT
 GOTOXY 0;4
 NORMAL
 MTOFF
 CLEOS
 CURSORON
 COLOR AQUAMARINE
 LINE "#   From       To"
 COLOR WHITE
 NULL
 LDX #0
 LDA #0
 JSR LOADST
 LDA STBUFF
 STA :STOT
 LDA STBUFF+1
 STA :STOT+1
 STZ :ST
 STZ :ST+1
]LOOP LDA :ST+1
 CMP :STOT+1
 BCC :LOAD
 LDA :ST
 CMP :STOT
 BEQL :DONE
:LOAD INCR :ST
 LDX :ST
 LDA :ST+1
 JSR LOADST
 JSR PRINT
 PAD2 :ST
 HTAB 4
 PAD2 STXPOS
 ASC ","
 PAD2 STYPOS
 ASC " "
 PAD2 STZPOS
 ASC " - "
 NULL
 LDA STGOTOZ
 BNE :V
 JSR PRINT
 COLOR YELLOW
 ASC "<Castle>"
 COLOR WHITE
 NULL
 BRA :V2
:V JSR PRINT
 PAD2 STGOTOX
 ASC ","
 PAD2 STGOTOY
 ASC " "
 PAD2 STGOTOZ
 NULL
:V2 JSR PRINT
 CR
 NULL
 LDA CV
 CMP #22
 BNE ]LOOP
 JSR PRINT
 GOTOXY 0;23
 COLOR YELLOW
 CENTER "[SPACE] continue, [ESC] exit : "
 COLOR WHITE
 NULL
]LOOP2 JSR KEYIN
 CMP #" "
 BEQ :CONT
 CMP #$9B
 BNE ]LOOP2
 BRA :ESC
:CONT JSR PRINT
 GOTOXY 0;5
 CLEOS
 NULL
 JMP ]LOOP
:DONE JSR PRINT
 GOTOXY 0;23
 NULL
 GETRETURN
:ESC JSR PRINT
 GOTOXY 0;4
 NORMAL
 MTOFF
 CLEOS
 NULL
 STZ FILBYTE
 JMP START2
:ST DS 2
:STOT DS 2

SCEN LDA MAXSCEN
 BEQ :NO
 JSR PRINT
 NORMAL
 MTOFF
 GOTOXY 0;23
 ZAPLINE
 CURSORON
 ASC "Change scenario for maps (max="
 DEC8 MAXSCEN
 ASC ") : "
 NULL
 GETLINE #1
 CPX #0
 BEQ :NO
 JSR GETNUM
 CPX MAXSCEN
 BEQ :OK
 BCS :NO
:OK STX SCENARIO
 JSR GETLVLS
 JMP DISPLAY
:NO JMP BOT

BYTEUP LDX #$FF
 JMP BYTE

BYTEDN LDX #0
 JMP BYTE

HELP JSR PRINT
 GOTOXY 0;4
 NORMAL
 MTOFF
 CLEOS

 HEX8 :SHAPES+#SHPWALL
 ASC "  "
 DOSHAPE #SHPWALL;#WALLNORMAL
 NORMAL
 ASC " "
 DOSHAPE #SHPWALL;#WALLTOPLEFT
 NORMAL
 ASC " "
 DOSHAPE #SHPWALL;#WALLTOPRIGHT
 NORMAL
 ASC " "
 DOSHAPE #SHPWALL;#WALLBOTLEFT
 NORMAL
 ASC " "
 DOSHAPE #SHPWALL;#WALLBOTRIGHT
 NORMAL
 ASC " "
 DOSHAPE #SHPWALL;#WALLSECRET
 NORMAL
 ASC " "
 DOSHAPE #SHPWALL;#WALLSECRETVIS
 NORMAL
 LINE " Wall"

 HEX8 :SHAPES+#SHPSPACE
 ASC "  "
 DOSHAPE #SHPSPACE;#SPACENORMAL
 NORMAL
 LINE " Space"

 HEX8 :SHAPES+#SHPSTAIRS
 ASC "  "
 DOSHAPE #SHPSTAIRS;#STAIRSUP
 NORMAL
 ASC " "
 DOSHAPE #SHPSTAIRS;#STAIRSDOWN
 NORMAL
 LINE " Stairs"

 HEX8 :SHAPES+#SHPFF
 ASC "  "
 DOSHAPE #SHPFF;#FFHORIZ
 NORMAL
 ASC " "
 DOSHAPE #SHPFF;#FFVERT
 NORMAL
 ASC " "
 DOSHAPE #SHPFF;#FFDIMHORIZ
 NORMAL
 ASC " "
 DOSHAPE #SHPFF;#FFDIMVERT
 NORMAL
 LINE " Force field"

 HEX8 :SHAPES+#SHPDARK
 ASC "  "
 DOSHAPE #SHPDARK;#DARKNORMAL
 NORMAL
 LINE " Dark area"

 HEX8 :SHAPES+#SHPSIGN
 ASC "  "
 DOSHAPE #SHPSIGN;#SIGNNORMAL
 NORMAL
 LINE " Sign Post"

 HEX8 :SHAPES+#SHPSWAMP
 ASC "  "
 DOSHAPE #SHPSWAMP;#SWAMPNORMAL
 NORMAL
 LINE " Swamp"

 HEX8 :SHAPES+#SHPPLR
 ASC "  "
 DOSHAPE #SHPPLR;#PLRNORMAL
 NORMAL
 ASC " "
 DOSHAPE #SHPPLR;#PLRCURRENT
 NORMAL
 ASC " "
 DOSHAPE #SHPPLR;#PLRMINE
 NORMAL
 LINE " Player"

 HEX8 :SHAPES+#SHPVOID
 ASC "  "
 DOSHAPE #SHPVOID;#VOIDNORMAL
 NORMAL
 LINE " Unknown"

 HEX8 :SHAPES+#SHPWATER
 ASC "  "
 DOSHAPE #SHPWATER;#WATERSHALLOW
 NORMAL
 ASC " "
 DOSHAPE #SHPWATER;#WATERDEEP
 NORMAL
 LINE " Water"

 HEX8 :SHAPES+#SHPTPORT
 ASC "  "
 DOSHAPE #SHPTPORT;#TPORTNORMAL
 NORMAL
 LINE " Teleport"

 HEX8 :SHAPES+#SHPHILLS
 ASC "  "
 DOSHAPE #SHPHILLS;#HILLSNORMAL
 NORMAL
 LINE " Hills"

 HEX8 :SHAPES+#SHPMON
 ASC "  "
 DOSHAPE #SHPMON;#MONNORMAL
 NORMAL
 LINE " Monster"

 HEX8 :SHAPES+#SHPPLRMON
 ASC "  "
 DOSHAPE #SHPPLRMON;#PLRMONNORMAL
 NORMAL
 LINE " Player & monster"

 HEX8 :SHAPES+#SHPITEM
 ASC "  "
 DOSHAPE #SHPITEM;#ITEMNORMAL
 NORMAL
 LINE " Item"

 HEX8 :SHAPES+#SHPGATE
 ASC "  "
 DOSHAPE #SHPGATE;#GATECLOSED
 NORMAL
 ASC " "
 DOSHAPE #SHPGATE;#GATEOPEN
 NORMAL
 LINE " Gate"

 GOTOXY 40;4
 HEX8 :SHAPES+#SHPMONGEN
 ASC "  "
 DOSHAPE #SHPMONGEN;#MONGENNORMAL
 NORMAL
 ASC " "
 DOSHAPE #SHPMONGEN;#MONGENGUARDIAN
 NORMAL
 LINE " Monster generator"

 GOTOXY 40;5
 HEX8 :SHAPES+#SHPSAFETY
 ASC "  "
 DOSHAPE #SHPSAFETY;#SAFETYNORMAL
 NORMAL
 LINE " Holy ground"

 GOTOXY 40;6
 HEX8 :SHAPES+#SHPALTAR
 ASC "  "
 DOSHAPE #SHPALTAR;#ALTARNORMAL
 NORMAL
 LINE " Altar"

 GOTOXY 40;7
 HEX8 :SHAPES+#SHPFOUNTAIN
 ASC "  "
 DOSHAPE #SHPFOUNTAIN;#FOUNTAINNORMAL
 NORMAL
 LINE " Fountain"

 MTOFF
 NORMAL
 GOTOXY 0;23
 CURSORON
 COLOR YELLOW
 ASC "Press [RETURN] for more help, or [ESC] to exit : "
 COLOR WHITE
 NULL
]LOOP JSR KEYIN
 CMP #$9B
 BEQ :ESC
 CMP #$8D
 BNE ]LOOP
 JSR PRINT
 GOTOXY 0;4
 CLEOS
 NULL
 JSR GETFILE
 DFB 4,22 ;Use lines x to y
 STR "HELP/MAP.ED"
 JSR PRINT
 GOTOXY 0;23
 COLOR PINK
 NULL
 GETRETURN
:ESC JSR PRINT
 GOTOXY 0;4
 COLOR WHITE
 NORMAL
 MTOFF
 CLEOS
 NULL
 STZ FILBYTE
 JMP START2
:SHAPES DFB SHPWALL,SHPSPACE,SHPSTAIRS,SHPFF,SHPDARK,SHPSIGN
 DFB SHPSWAMP,SHPPLR,SHPVOID,SHPWATER,SHPTPORT,SHPHILLS
 DFB SHPMON,SHPPLRMON,SHPITEM,SHPGATE,SHPMONGEN,SHPSAFETY
 DFB SHPALTAR,SHPFOUNTAIN

STAIRS LDX XPOS
 LDY YPOS
 JSR GETMAP
 STA :A
 LDX #0
]LOOP LDA :SHAPES,X
 CMP #$FF
 BEQL BOT2
 CMP :A
 BEQ :YES
 INX
 BRA ]LOOP
:YES JSR PRINT
 NORMAL
 MTOFF
 GOTOXY 0;23
 ZAPLINE
 CURSORON
 COLOR YELLOW
 ASC "Checking stair / teleport.."
 COLOR WHITE
 NULL
 LDX #0
 LDA #0
 JSR LOADST
 LDA STBUFF
 STA :NUMST
 STA :REC
 LDA STBUFF+1
 STA :NUMST+1
 STA :REC+1
 BNE :LOAD
 LDA :REC
 BEQ :NOTHING ;No record exists of this stair/teleport
:LOAD LDX :REC
 LDA :REC+1
 JSR LOADST
 LDA STXPOS
 CMP XPOS
 BNE :NEXT
 LDA STYPOS
 CMP YPOS
 BNE :NEXT
 LDA STZPOS
 CMP CURRLVL
 BNE :NEXT
 JMP :GOTIT
:NEXT DECR :REC
 LDA :REC+1
 BNE :LOAD
 LDA :REC
 BNE :LOAD
:NOTHING JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 COLOR PINK
 ASC "Stair / teleport doesn't exist. [A]dd to file, [Q]uit : "
 COLOR WHITE
 NULL
]LOOP JSR KEYIN
 JSR UPPER
 CMP #"A"
 BEQ :ADD
 CMP #"Q"
 BNE ]LOOP
 JMP BOT
:REC DA 0
:NUMST DS 2

:ADD JSR ADDST
 JMP BOT

:GOTIT JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 ASC "Leads to "
 NULL
 LDA STGOTOZ
 BNE :NOC
 JSR PRINT
 ASC "Castle [Level 00]."
 NULL
 BRA :CONTC
:NOC JSR PRINT
 PAD2 STGOTOX
 ASC ","
 PAD2 STGOTOY
 ASC " Lvl: "
 PAD2 STGOTOZ
 ASC ". [G]oto location,"
 NULL
:CONTC JSR PRINT
 ASC " [C]hange, [D]elete, [Q]uit : "
 NULL
]LOOP JSR KEYIN
 JSR UPPER
 LDX :KEYS
]LOOP2 CMP :KEYS,X
 BEQ :GOTONE
 DEX
 BNE ]LOOP2
 JMP ]LOOP
:GOTONE DEX
 TXA
 ASL
 TAX
 JMP (:TABLE,X)

:KEYS DFB :ENDKEYS-*-1
 DFB "G"
 DFB "C"
 DFB "D"
 DFB "Q"
:ENDKEYS

:TABLE DA :GOTO
 DA :CHANGE
 DA :DELETE
 DA BOT

:DELETE LDX :REC
 LDA :REC+1
 JSR DELETEST
 LDX XPOS
 LDY YPOS
 LDA #SPACENORMAL
 XBA
 LDA #SHPSPACE
 JSR PUTMAP
 LDA XPOS
 ASL
 CLC
 ADC #2
 STA :DCH+2
 LDA YPOS
 CLC
 ADC #5
 STA :DCV+2
 STA :DCV2+2
 LDA #SHPSPACE
 STA :DSHAPE+2
 JSR PRINT
:DCH HTAB 0
:DCV VTAB 0
:DSHAPE DOSHAPE 0
 NULL
 LDA XPOS
 ASL
 CLC
 ADC #37
 STA :DCH2+2
 JSR PRINT
:DCH2 HTAB 0
:DCV2 VTAB 0
 NORMAL
 MTOFF
 NULL
 JMP BOT

:CHANGE JSR GETGOTOLOC
 BCSL BOT
 LDA :REC
 STA :REC3
 LDA :REC+1
 STA :REC3+1
 LDX :REC3
 LDA :REC3+1
 JSR SAVEST
 JMP BOT
:REC3 DA 0

:GOTO LDA STGOTOZ ;Lvl it goes to
 BEQL :GOTIT
 CMP NUMLVLS
 BEQ :LVLOK
 BCC :LVLOK
 JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 COLOR PINK
 ASC "Illegal goto - level "
 COLOR YELLOW
 PAD2 STGOTOZ
 COLOR PINK
 ASC " doesn't exist. "
 COLOR WHITE
 NULL
 GETRETURN
 JMP :GOTIT
:LVLOK LDA STGOTOX
 STA XPOS
 LDA STGOTOY
 STA YPOS
 LDA STGOTOZ
 STA CURRLVL
 JMP LOAD

:SHAPES DFB SHPSTAIRS,SHPTPORT
 DFB $FF
:A DS 1

DOFLAG LDA INCFLAG
 EOR #$FF
 STA INCFLAG
 INC
 TAX
 LDA :TXT,X
 STA $C055
 STA $427
 STA $C054
 JMP BOT2
:TXT ASC "+ "

ALTER STZ :NOFLAG
 LDX XPOS
 LDY YPOS
 JSR GETMAP
 STA :ORIG
* CMP FILBYTE
* BEQL BOT2
 CMP #SHPSIGN
 BEQL :SIGN
 CMP #SHPSTAIRS
 BEQ :ST
 CMP #SHPTPORT
 BNE :NOPE
:ST LDX #0
 LDA #0
 JSR LOADST
 LDA STBUFF
 STA :NUMST
 STA :REC
 LDA STBUFF+1
 STA :NUMST+1
 STA :REC+1
 BNE :LOAD
 LDA :REC
 BEQ :NOPE ;No record exists of this stair/teleport
:LOAD LDX :REC
 LDA :REC+1
 JSR LOADST
 LDA STXPOS
 CMP XPOS
 BNE :NEXT
 LDA STYPOS
 CMP YPOS
 BNE :NEXT
 LDA STZPOS
 CMP CURRLVL
 BEQ :GOTIT
:NEXT DECR :REC
 LDA :REC+1
 BNE :LOAD
 LDA :REC
 BNE :LOAD
 JMP :NOPE
:GOTIT LDX :REC
 LDA :REC+1
 JSR DELETEST
 LDA #SHPWALL
 BRA :NOPE2
:NOPE LDA FILBYTE
:NOPE2 STA :FIL
 XBA
 LDA SUBTYPE
 XBA
 LDX XPOS
 LDY YPOS
 JSR PUTMAP
 LDA XPOS
 ASL
 CLC
 ADC #2
 STA :CHV+2
 LDA YPOS
 CLC
 ADC #5
 STA :CHV+3
 STA :CHV2+3
 LDA SUBTYPE
 ASL
 ASL
 ASL
 ASL
 ASL
 ORA :FIL
 STA :SHAPE+2
 JSR PRINT
:CHV GOTOXY 0;0
:SHAPE DOSHAPE 0
 NULL
 LDA XPOS
 ASL
 CLC
 ADC #37
 STA :CHV2+2
 JSR PRINT
:CHV2 GOTOXY 0;0
 NORMAL
 MTOFF
 HEX8 :FIL
 NULL
 BIT INCFLAG
 BPL :NO
 LDA XPOS
 CMP #$F
 BCC :OK
 STZ XPOS
 INC YPOS
 LDA YPOS
 CMP #$10
 BCC :NO
 STZ YPOS
 LDA #$FF
:OK INC
 STA XPOS
:NO JSR CURSOR
 BIT :NOFLAG
 BMI :NO3
 LDA :FIL
 CMP #SHPSIGN
 BEQ :ADDSG
 CMP #SHPSTAIRS
 BEQ :ADD
 CMP #SHPTPORT
 BEQ :ADD
:NO2 JMP BOT2
:NO3 JMP BOT
:ADD JSR ADDST
:ADDCONT BCC :NO3
 LDA #$FF
 STA :NOFLAG
 JMP :NOPE
:ADDSG JSR ADDSG
 BRA :ADDCONT
:SIGN LDX #0
 LDA #0
 JSR LOADSIGN
 LDA MISCBUFF
 STA :NUMSG
 STA :REC
 LDA MISCBUFF+1
 STA :NUMSG+1
 STA :REC+1
 BNE :LOADS
 LDA :REC
 BEQL :NOPE ;No record exists of this sign
:LOADS LDX :REC
 LDA :REC+1
 JSR LOADSIGN
 LDA SGXPOS
 CMP XPOS
 BNE :NEXTS
 LDA SGYPOS
 CMP YPOS
 BNE :NEXTS
 LDA SGZPOS
 CMP CURRLVL
 BEQ :GOTITS
:NEXTS DECR :REC
 LDA :REC+1
 BNE :LOADS
 LDA :REC
 BNE :LOADS
 JMP :NOPE
:GOTITS LDX :REC
 LDA :REC+1
 JSR DELETESG
 LDA #SHPWALL
 JMP :NOPE2
:NUMST DS 2
:NUMSG DS 2
:REC DS 2
:NOFLAG DS 1
:ORIG DS 1
:FIL DS 1

BYTE PHX
 LDA FILBYTE
 AND #$F
 CLC
 ADC #5
 STA :CV+2
 JSR PRINT
 NORMAL
 HTAB 70
:CV VTAB 0
 ASC " "
 NULL
 PLA
 BPL :PLUS
:MINUS DEC FILBYTE
 LDA FILBYTE
 CMP #$FF
 BNE :MINOK
 LDA #NUMSHAPES
 STA FILBYTE
 JSR :DOSHP
 BRA :POINT
:MINOK AND #$F
 CMP #$F
 BNE :POINT
 JSR :DOSHP
 BRA :POINT
:PLUS INC FILBYTE
 LDA FILBYTE
 CMP #NUMSHAPES+1
 BNE :PLUSOK
 LDA #0
 STA FILBYTE
 JSR :DOSHP
 BRA :POINT
:PLUSOK AND #$F
 CMP #0
 BNE :POINT
 JSR :DOSHP
:POINT LDA FILBYTE
 AND #$F
 CLC
 ADC #5
 STA :CV2+2
 JSR PRINT
 HTAB 70
:CV2 VTAB 0
 NULL
 JSR SHOWPNTR
 JMP BOT2
:DOSHP LDA FILBYTE
 AND #$F0
 TAX
 JMP DOSHAPES

LEFT LDA XPOS
 BNE :OK
 LDA #$10
:OK DEC
 STA XPOS
 JSR CURSOR
 JMP BOT2

RIGHT LDA XPOS
 CMP #$F
 BCC :OK
 LDA #$FF
:OK INC
 STA XPOS
 JSR CURSOR
 JMP BOT2

UP LDX #$FF
 LDA $C061
 BMIL BYTE
 LDA YPOS
 BNE :OK
 LDA #$10
:OK DEC
 STA YPOS
 JSR CURSOR
 JMP BOT2

DOWN LDX #0
 LDA $C061
 BMIL BYTE
 LDA YPOS
 CMP #$F
 BCC :OK
 LDA #$FF
:OK INC
 STA YPOS
 JSR CURSOR
 JMP BOT2

CURSOR LDX OLDX
 LDY OLDY
 LDA #$E
 JSR :DOCURS
 LDX XPOS
 LDY YPOS
 LDA #$F
 JSR :DOCURS
 LDA XPOS
 STA OLDX
 LDA YPOS
 STA OLDY
 JSR PRINT
 GOTOXY 50;1
 NORMAL
 MTOFF
 ASC "Loc: "
 COLOR YELLOW
 PAD2 XPOS
 ASC ","
 PAD2 YPOS
 COLOR WHITE
 ASC "  L: "
 COLOR YELLOW
 PAD2 CURRLVL
 COLOR WHITE
 NULL
 RTS

:DOCURS STA :A
 TXA
 ASL
 CLC
 ADC #37
 STA :X+2
 TYA
 CLC
 ADC #5
 STA :Y+2
 JSR PRINT
:X HTAB 0
:Y VTAB 0
:A HEX 0E
 NULL
 JSR GETMAP
 XBA
 JMP PRBYTE

LOAD LDA CURRLVL
 STA MAPLVL
 JSR LDMAP
 JMP DISPLAY

SAVE LDA CURRLVL
 STA MAPLVL2
 JSR SVMAP
 JMP BOT

ADDLEVEL LDA NUMLVLS
 CMP #16
 BCC :OK
 JSR PRINT
 NORMAL
 MTOFF
 GOTOXY 0;23
 CLEOS
 COLOR PINK
 ASC "Cannot add any more levels. "
 COLOR WHITE
 NULL
 GETRETURN
 JMP BOT
:OK JSR PRINT
 GOTOXY 0;23
 CLEOL
 COLOR PINK
 ASC "Add a level (y/N)? : "
 COLOR WHITE
 NULL
 JSR KEYIN
 JSR UPPER
 CMP #"Y"
 BNEL BOT
 JSR PRINT
 ASC "Yes"
 NULL
 INC NUMLVLS ;Add 1 to vars
 LDA NUMLVLS
 STA CURRLVL
 STA MAPLVL2

 STZ MAPLVL ;Add 1 to record 0 (number of levels in file)
 STZ MAPLVL2
 JSR LDMAP
 LDA NUMLVLS
 STA MAP
 STA MAP2
 JSR SVMAP
 JSR SVMAP2

 LDA CURRLVL
 STA MAPLVL
 STA MAPLVL2
 LDX #0 ;Zero out map
 LDA #SHPSPACE
]LOOP STA MAP,X
 INX
 BNE ]LOOP
 JSR SVMAP ;Save this level
 JSR SVMAP2
 JMP DISPLAY

ZAPLEVEL JSR PRINT
 NORMAL
 MTOFF
 GOTOXY 0;23
 CLEOS
 NULL
 LDA NUMLVLS
 CMP #1
 BNE :ZAPOK
 JSR PRINT
 COLOR PINK
 ASC "Cannot delete level 1. "
 COLOR WHITE
 NULL
 GETRETURN
 JMP BOT
:ZAPOK JSR PRINT
 COLOR PINK
 ASC "Remove level "
 COLOR YELLOW
 DEC8 NUMLVLS
 COLOR PINK
 ASC " (NOTE: current level will be lost). Ok? : "
 COLOR WHITE
 NULL
 GETLINE #1
 CPX #0
 BEQ :RTS
 LDA $200
 JSR UPPER
 CMP #"Y"
 BNE :RTS
 LDA NUMLVLS
 CMP CURRLVL
 BNE :OK
 DEC CURRLVL
:OK DEC NUMLVLS
 STZ MAPLVL
 JSR LDMAP
 LDA NUMLVLS
 STA MAP
 STZ MAPLVL2
 JSR SVMAP
 LDA CURRLVL
 STA MAPLVL
 JSR LDMAP
 JMP DISPLAY
:RTS JMP BOT

GOUP LDA CURRLVL
 CMP #1
 BEQL BOT
 DEC CURRLVL
 JMP LOAD

GODOWN LDA CURRLVL
 CMP NUMLVLS
 BCSL BOT
 INC CURRLVL
 JMP LOAD

DISPLAY JSR PRINT
 CURSOROFF
 GOTOXY 2;5
 NULL
 LDX #0
 LDY #0
]LOOP STX :X
 STY :Y
 JSR GETMAP
 XBA
 STA :SHAPE+2
 JSR PRINT
:SHAPE DOSHAPE 0
 NULL
 INC :X
 LDX :X
 LDY :Y
 CPX #$10
 BNE ]LOOP
 JSR PRINT
 CR
 HTAB 2
 NULL
 LDX #0
 STX :X
 INC :Y
 LDY :Y
 CPY #$10
 BNE ]LOOP
 JSR PRINT
 NORMAL
 MTOFF
 NULL

 JSR PRINT
 GOTOXY 37;5
 NULL
 LDX #0
 LDY #0
]LOOP STX :X
 STY :Y
 JSR GETMAP
 XBA
 JSR PRBYTE
 LDY :Y
 LDX :X
 INX
 CPX #$10
 BNE ]LOOP
 JSR PRINT
 CR
 HTAB 37
 NULL
 LDX #0
 STX :X
 INC :Y
 LDY :Y
 CPY #$10
 BNE ]LOOP
 JSR CURSOR
 JMP BOT
:X DS 1
:Y DS 1

LDMAP LDX MAPLVL
 LDA #0
 JMP LOADMAP
MAPLVL DS 1

SVMAP LDX MAPLVL2
 LDA #0
 JMP SAVEMAP
MAPLVL2 DS 1

SVMAP2 LDX MAPLVL2
 LDA #0
 JMP SAVEMAP2

DOSHAPES STX :SHAPE+2
 JSR PRINT
 VTAB 5
 NULL
]LOOP JSR PRINT
 HTAB 71
 NORMAL
 HEX8 :SHAPE+2
 ASC " = "
:SHAPE DOSHAPE 0
 CR
 NULL
 LDA CV
 CMP #21
 BEQ :DONE
 INC :SHAPE+2
 LDA :SHAPE+2
 CMP #NUMSHAPES+1
 BNE ]LOOP
 JSR PRINT
 NORMAL
 MTOFF
 NULL
]LOOP LDA CV
 CMP #22
 BEQ :DONE
 JSR PRINT
 HTAB 71
 CLEOL
 CR
 NULL
 BRA ]LOOP
:DONE RTS

EXIT JSR PRINT
 NORMAL
 MTOFF
 HOME
 NULL
 STZ MAPLOOK
 RETURN

GETLVLS STZ MAPLVL
 JSR LDMAP
 LDA MAP
 STA NUMLVLS
 LDA #1
 STA CURRLVL
 STA MAPLVL
 JMP LDMAP

DELETEST STX :REC4
 STX :REC5
 STA :REC4+1
 STA :REC5+1
 JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 ASC "Wait.."
 NULL
 LDA #$FF
 STA BOTFLAG
 LDX #0
 LDA #0
 JSR LOADST
 LDA STBUFF
 STA :NUMST
 LDA STBUFF+1
 STA :NUMST+1
]LOOP LDA :REC4+1
 CMP :NUMST+1
 BNE :OKD
 LDA :REC4
 CMP :NUMST
 BEQ :DUPDATE
:OKD INCR :REC4
 LDX :REC4
 LDA :REC4+1
 JSR LOADST
 LDX :REC5
 LDA :REC5+1
 JSR SAVEST
 INCR :REC5
 JMP ]LOOP
:DUPDATE LDX #0
 LDA #0
 JSR LOADST
 DECR STBUFF
 LDX #0
 LDA #0
 JSR SAVEST
 RTS
:NUMST DS 2
:REC4 DA 0
:REC5 DA 0

ADDST LDX #0
 LDA #0
 JSR LOADST
 LDA STBUFF
 STA :REC2
 LDA STBUFF+1
 STA :REC2+1
 INCR :REC2
 LDA XPOS ;X
 STA STXPOS
 LDA YPOS ;Y
 STA STYPOS
 LDA CURRLVL ;Z (Lvl)
 STA STZPOS
 JSR GETGOTOLOC
 BCS :RTS
 LDX :REC2
 LDA :REC2+1
 JSR SAVEST
 LDX #0
 LDA #0
 JSR LOADST
 INCR STBUFF
 LDX #0
 LDA #0
 JSR SAVEST
 CLC
:RTS RTS
:REC2 DA 0

ADDSG JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 ASC "Wait.."
 NULL
 LDA #$FF
 STA BOTFLAG
 LDX #0
 LDA #0
 JSR LOADSIGN
 INCR MISCBUFF
 LDX #0
 LDA #0
 JSR SAVESIGN
 LDA MISCBUFF
 STA :REC2
 LDA MISCBUFF+1
 STA :REC2+1
 LDA XPOS ;X
 STA SGXPOS
 LDA YPOS ;Y
 STA SGYPOS
 LDA CURRLVL ;Z (Lvl)
 STA SGZPOS
 STZ SGLEN
 STZ SGLEN+1
 LDX :REC2
 LDA :REC2+1
 JSR SAVESIGN
 LDX #0
 LDA #0
 JSR LOADSIGN
 CLC
:RTS RTS
:REC2 DA 0

DELETESG STX :REC4
 STX :REC5
 STA :REC4+1
 STA :REC5+1
 JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 ASC "Wait.."
 NULL
 LDA #$FF
 STA BOTFLAG
 LDX #0
 LDA #0
 JSR LOADSIGN
 LDA MISCBUFF
 STA :NUMST
 LDA MISCBUFF+1
 STA :NUMST+1
]LOOP LDA :REC4+1
 CMP :NUMST+1
 BNE :OKD
 LDA :REC4
 CMP :NUMST
 BEQ :DUPDATE
:OKD INCR :REC4
 LDX :REC4
 LDA :REC4+1
 JSR LOADSIGN
 LDX :REC5
 LDA :REC5+1
 JSR SAVESIGN
 INCR :REC5
 JMP ]LOOP
:DUPDATE LDX #0
 LDA #0
 JSR LOADSIGN
 DECR MISCBUFF
 LDX #0
 LDA #0
 JSR SAVESIGN
 RTS
:NUMST DS 2
:REC4 DA 0
:REC5 DA 0

GETGOTOLOC JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 CURSORON
 ASC "Goto location: X="
 NULL
 GETLINE #2
 BCS :ABORT
 CPX #0
 BEQ GETGOTOLOC
 JSR GETNUM
 CPX #$10
 BCS GETGOTOLOC
 STX STGOTOX
:GETY JSR PRINT
 GOTOXY 21;23
 ASC "Y="
 NULL
 GETLINE #2
 BCS :ABORT
 CPX #0
 BEQ :GETY
 JSR GETNUM
 CPX #$10
 BCS :GETY
 STX STGOTOY
:GETZ JSR PRINT
 GOTOXY 27;23
 ASC "Level="
 NULL
 GETLINE #2
 BCS :ABORT
 CPX #0
 BEQ :GETZ
 JSR GETNUM
 STX STGOTOZ
 CLC
 RTS
:ABORT SEC
 RTS

GETLOC LDX XPOS
 LDY YPOS
 JSR GETMAP
 LDA XPOS
 DEC
 TAX
 LDA YPOS
 CLC
 ADC #3
 TAY
 RTS

CURRLVL DFB 1
NUMLVLS DS 1
MAXSCEN DS 1

XPOS DFB 0
YPOS DFB 0

OLDX DFB 0
OLDY DFB 0

FILBYTE DFB 0
INCFLAG DFB 0

BOTFLAG DS 1

SUBTYPE DFB 0

 LST ON
MODEND EQU *
 LST OFF

 do M16PLUS
 SAV RUN/MODULES/MAP.EDITOR
 fin

 END
