*-------------------------------
* MON.EDITOR
*-------------------------------
 DAT
 LST OFF

 ORG $8000 ;Always

 USE MACROS
 USE EQUATES
 USE VARS
 USE MON.DSECT
 USE LIB.JMP
 USE TABLES

 TYP $F4
 do M16PLUS-1
 DSK RUN/MODULES/MON.EDITOR
 fin

NUMMON = 20 ;Number of entries for a MONSTER

 MODID "MON.EDITOR"

START JSR PRINT
 HOME
 BOX "Monster Editor"
 NULL
 STZ :FLAG
 STZ :MON
 STZ :MON+1
 LDX #0
 LDA #0
 JSR LOADMAP
 LDA MAP
 STA NUMLVLS
 LDX #0
 LDA #0
 JSR LOADMON
 LDA MONBUFF
 STA :RECS
 LDA MONBUFF+1
 STA :RECS+1
 JMP :FORW1
:BOT JSR PRINT
 GOTOXY 1;1
 ASC "Total in file : "
 COLOR YELLOW
 DEC16 :RECS
 COLOR WHITE
 GOTOXY 0;23
 CLEOS
 ASC "[A]dd, [J]ump, [S]ave, [L]ist, [RETURN]-edit, "
 MTON
 INVERSE
 ASC "H"
 NORMAL
 ASC ", "
 INVERSE
 ASC "U"
 NORMAL
 MTOFF
 ASC ", [H]elp, [Q]uit : "
 CURSORON
 NULL
 LDA CH
 STA :BGOTO+2
:GETKEY JSR PRINT
:BGOTO GOTOXY 0;23
 NULL
]LOOP JSR KEYIN
 JSR UPPER
 LDX :KEYS
]LOOP2 CMP :KEYS,X
 BEQ :GOTONE
 DEX
 BNE ]LOOP2
 JMP ]LOOP
:GOTONE DEX
 TXA
 ASL
 TAX
 JMP (:TABLE,X)

:KEYS DFB :ENDKEYS-*-1
 DFB "Q"
 DFB "A"
 DFB "L"
 DFB "J"
 DFB "S"
 DFB "H"-$40
 DFB "U"-$40
 DFB "K"-$40
 DFB "J"-$40
 DFB "M"-$40
 DFB "H"
:ENDKEYS

:TABLE DA EXIT
 DA :ADD
 DA :LIST
 DA :LOAD
 DA :SAVE
 DA :BACK1
 DA :FORW1
 DA :UP
 DA :DOWN
 DA :EDIT
 DA :HELP

:HELP JSR PRINT
 GOTOXY 0;4
 CLEOS
 NULL
 JSR GETFILE
 DFB 4,22 ;Use lines x to y
 STR "HELP/MON.ED"
 JSR PRINT
 GOTOXY 0;23
 COLOR PINK
 NULL
 GETRETURN
 JSR PRINT
 GOTOXY 0;4
 COLOR WHITE
 CLEOS
 NULL
 JMP :MBACK

:DOPOINT LDA :OLDPNTR
 CMP #19
 BCC :PLEFT
 LDA #40
 STA :CH+2
 LDA :OLDPNTR
 SEC
 SBC #15
 STA :CV+2
 BRA :DOP1
:PLEFT STZ :CH+2
 LDA :OLDPNTR
 CLC
 ADC #3
 STA :CV+2
:DOP1 JSR PRINT
 NORMAL
 MTOFF
:CH HTAB 0
:CV VTAB 0
 ASC " "
 NULL
 LDA :PNTR
 CMP #19
 BCC :PLEFT2
 LDA #40
 STA :CH2+2
 LDA :PNTR
 SEC
 SBC #15
 STA :CV2+2
 BRA :DOP2
:PLEFT2 STZ :CH2+2
 LDA :PNTR
 CLC
 ADC #3
 STA :CV2+2
:DOP2 JSR PRINT
:CH2 HTAB 0
:CV2 VTAB 0
 NULL
 JSR SHOWPNTR
 LDA :PNTR
 STA :OLDPNTR
 RTS
:OLDPNTR DFB 1
:PNTR DFB 1

:UP LDA :RECS
 ORA :RECS+1
 BEQL :BOT
 LDA :PNTR
 CMP #1
 BNE :UPOK
 LDA #NUMMON+1
:UPOK DEC
 STA :PNTR
 JSR :DOPOINT
 JMP :GETKEY

:DOWN LDA :RECS
 ORA :RECS+1
 BEQL :BOT
 LDA :PNTR
 CMP #NUMMON
 BNE :DNOK
 LDA #0
:DNOK INC
 STA :PNTR
 JSR :DOPOINT
 JMP :GETKEY

:EDIT LDA :RECS
 ORA :RECS+1
 BEQL :BOT
 LDA :PNTR
 DEC
 ASL
 TAX
 JMP (:EDITS,X)

:EDITS DA :FREE
 DA :NAME
 DA :ST
 DA :DX
 DA :IQ
 DA :HT
 DA :SPEED
 DA :PD
 DA :DR
 DA :DAM
 DA :DAMTYPE
 DA :HABITAT
 DA :REACH
 DA :SIZE
 DA :TREAS
 DA :LVL
 DA :EXPKILL
 DA :SPECDAM
 DA :HP
 DA :SCEN

:LOAD LDA :RECS
 ORA :RECS+1
 BEQL :BOT
 JSR PRINT
 GOTOXY 0;23
 CLEOS
 ASC "Jump to monster #"
 CURSORON
 NULL
 GETLINE #5
 JSR GETNUM
 CPX #0
 BNE :LOK
 CPY #0
 BEQL :BOT
:LOK CPY :RECS+1
 BCC :RNGOK
 CPX :RECS
 BEQ :RNGOK
 BCC :RNGOK
 JSR PRINT
 COLOR PINK
 ASC " No such monster. "
 COLOR WHITE
 NULL
 GETRETURN
 JMP :BOT
:RNGOK STX :MON
 STY :MON+1
 TYA
 JSR LOADMON
 JSR :DISPLAY
 STZ :FLAG
 JMP :BOT

:SAVE LDA :RECS
 ORA :RECS+1
 BEQL :BOT
 BIT :FLAG
 BPLL :GETKEY
:SAVE2 LDX :MON
 LDA :MON+1
 JSR SAVEMON
 STZ :FLAG
 JMP :BOT

:BACK1 LDA :RECS
 ORA :RECS+1
 BEQL :BOT
 LDA :MON+1
 BNE :GOB
 LDA :MON
 CMP #2
 BCS :GOB
 JMP :BOT
:GOB DECR :MON
 LDX :MON
 LDY :MON+1
 JMP :LOK

:FORW1 LDA :RECS
 ORA :RECS+1
 BEQL :BOT
 LDA :MON+1
 CMP :RECS+1
 BCC :GOF
 LDA :MON
 CMP :RECS
 BCC :GOF
 JMP :BOT
:GOF INCR :MON
 LDX :MON
 LDY :MON+1
 JMP :LOK

:LIST LDA :RECS
 ORA :RECS+1
 BEQL :BOT
 JSR PRINT
 GOTOXY 0;23
 CLEOS
 ASC "Start from monster #1"
 CURSORLEFT
 NULL
 LDA PADFLAG
 STA TEMP
 LDA #$FF
 STA PADFLAG
 LDA PADCHAR
 STA TEMP+1
 LDA #" "
 STA PADCHAR
 LDA #1
 STA :TOREAD
 STZ :TOREAD+1
 GETLINE #5
 BCSL :LEXIT
 CPX #0
 BEQ :FROM1
 JSR GETNUM
 STX :TOREAD
 STY :TOREAD+1
:FROM1 LDA :TOREAD+1
 CMP :RECS+1
 BCC :VGO
 BEQ :FROMLO
 BCS :FROMNO
:FROMLO LDA :TOREAD
 CMP :RECS
 BCC :VGO
 BEQ :VGO
:FROMNO JSR PRINT
 ASC " - "
 COLOR PINK
 ASC "Last monster is #"
 COLOR YELLOW
 DEC16 :RECS
 COLOR PINK
 ASC ". "
 COLOR WHITE
 NULL
 GETRETURN
 JSR PRINT
 ZAPLINE
 NULL
 JMP :LEXIT
:VGO LDA :TOREAD
 STA :MCNTR
 LDA :TOREAD+1
 STA :MCNTR+1
 JSR PRINT
 GOTOXY 0;3
 CLEOS
 CR
 COLOR AQUAMARINE
 LINE "Monster/ ST/ DX/ IQ/ HT/PD /Sp/Sz/Lv/ R/Tr/Dam      /Name"
 COLOR WHITE
 CURSOROFF
 NULL
]LOOP LDA :MCNTR+1
 CMP :RECS+1
 BCC :RREAD
 LDA :MCNTR
 CMP :RECS
 BCC :RREAD
 BEQ :RREAD
 JMP :RDONE
:RREAD LDX :TOREAD
 LDA :TOREAD+1
 JSR LOADMON
 INCR :TOREAD
 LDA CV
 CMP #21
 BNE :VOK
 JSR PRINT
 CR
 CR
 CURSORON
 COLOR YELLOW
 CENTER "[SPACE]-continue, [ESC]-exit : "
 COLOR WHITE
 NULL
]LOOP3 JSR KEYIN
 CMP #$9B
 BEQL :RESC
 CMP #" "
 BNE ]LOOP3
 JSR PRINT
 GOTOXY 0;5
 CLEOS
 CURSOROFF
 NULL
:VOK JSR PRINT
 CR
 COLOR YELLOW
 DEC16 :MCNTR
 COLOR WHITE
 ASC ")  "
 COLOR YELLOW
 DEC8 MST
 COLOR WHITE
 ASC "/"
 COLOR YELLOW
 DEC8 MDX
 COLOR WHITE
 ASC "/"
 COLOR YELLOW
 DEC8 MIQ
 COLOR WHITE
 ASC "/"
 COLOR YELLOW
 DEC8 MHT
 COLOR WHITE
 ASC " "
 COLOR ORANGE
 DEC8 MPD
 COLOR WHITE
 ASC " "
 COLOR AQUAMARINE
 PAD2 MSPEED
 COLOR WHITE
 ASC " "
 PAD2 MSIZE
 ASC " "
 COLOR ORANGE
 PAD2 MLEVEL
 COLOR WHITE
 ASC " "
 PAD2 MREACH
 ASC " "
 COLOR YELLOW
 HEX8 MTREASURE
 COLOR WHITE
 ASC " "
 COLOR PINK
 PAD2 MDAM
 NULL
 LDA MDAMMOD
 STA VTEMP
 BPL :DPLUS
 EOR #$FF
 INC
 STA VTEMP
 LDA #"-"
 HEX 2C
:DPLUS LDA #"+"
 JSR COUT
 JSR PRINT
 PAD2 VTEMP
 COLOR WHITE
 ASC " "
 COLOR ORANGE
 PRTABLE MDAMTYPE;DAMTYPE
 COLOR WHITE
 ASC " "
 PRSTRING MNAME
 NULL
:MNEXT INCR :MCNTR
 LDA $C000
 BPLL ]LOOP
 STA $C010
 CMP #$9B
 BEQ :RDONE
 JMP ]LOOP
:RESC JSR PRINT
 ZAPLINE
 CURSORON
 NULL
 BRA :RDONE2
:RDONE JSR PRINT
 GOTOXY 0;23
 COLOR PINK
 CURSORON
 NULL
 GETRETURN
 JSR PRINT
 COLOR WHITE
 NULL
:RDONE2 LDA TEMP
 STA PADFLAG
 LDA TEMP+1
 STA PADCHAR
 LDX :MON
 LDY :MON+1
 JMP :LOK
:LEXIT LDA TEMP
 STA PADFLAG
 LDA TEMP+1
 STA PADCHAR
 JMP :BOT
:MCNTR DS 2
:TOREAD DA 2

:DISPLAY LDA :RECS
 ORA :RECS+1
 BEQL :BOT
 JSR PRINT
 GOTOXY 60;1
 ASC "Monster #"
 COLOR YELLOW
 DEC16 :MON
 COLOR WHITE
 ASC " "
 GOTOXY 0;4
 CLEOS
 CURSOROFF
 ASC "  1 - Free..........."
 PRFLAG MFREE
 CR
 ASC "  2 - Name..........."
 COLOR ORANGE
 PRSTRING MNAME
 COLOR WHITE
 CR
 ASC "  3 - Strength......."
 COLOR YELLOW
 DEC8 MST
 COLOR WHITE
 CR
 ASC "  4 - Dexterity......"
 COLOR YELLOW
 DEC8 MDX
 COLOR WHITE
 CR
 ASC "  5 - I.Q............"
 COLOR YELLOW
 DEC8 MIQ
 COLOR WHITE
 CR
 ASC "  6 - Health........."
 COLOR YELLOW
 DEC8 MHT
 COLOR WHITE
 CR
 ASC "  7 - Speed.........."
 COLOR GREEN
 DEC8 MSPEED
 COLOR WHITE
 CR
 ASC "  8 - PD............."
 COLOR AQUAMARINE
 DEC8NEG MPD
 COLOR WHITE
 CR
 ASC "  9 - DR............."
 COLOR AQUAMARINE
 DEC8NEG MDR
 COLOR WHITE
 CR
 ASC " 10 - Damage........."
 COLOR PINK
 DEC8 MDAM
 ASC "d"
 DEC8PNEG MDAMMOD
 COLOR WHITE
 CR
 ASC " 11 - Damage type...."
 COLOR YELLOW
 DEC8 MDAMTYPE
 COLOR WHITE
 ASC "="
 COLOR PINK
 PRTABLE MDAMTYPE;DAMTYPE
 COLOR WHITE
 CR
 ASC " 12 - Habitat........"
 COLOR YELLOW
 DEC8 MHABITAT
 COLOR WHITE
 ASC "="
 COLOR ORANGE
 PRTABLE MHABITAT;HABITATS
 COLOR WHITE
 CR
 ASC " 13 - Reach.........."
 COLOR YELLOW
 DEC8 MREACH
 COLOR WHITE
 CR
 ASC " 14 - Size..........."
 COLOR YELLOW
 DEC8 MSIZE
 COLOR WHITE
 CR
 ASC " 15 - Treasure type.."
 NULL
 LDA MTREASURE
 AND #%0000_1111
 STA VTEMP
 LDA MTREASURE
 LSR
 LSR
 LSR
 LSR
 STA VTEMP+1
 JSR PRINT
 COLOR YELLOW
 DEC8 VTEMP+1
 COLOR WHITE
 ASC "/"
 COLOR YELLOW
 DEC8 VTEMP
 COLOR WHITE
 ASC " (items/gold)"
 CR
 ASC " 16 - Level found...."
 COLOR ORANGE
 NULL
 LDA MLEVEL
 BNE :LEVELOK
 JSR PRINT
 ASC "*"
 NULL
 BRA :LCONT
:LEVELOK JSR PRINT
 DEC8 MLEVEL
 NULL
:LCONT JSR PRINT
 COLOR WHITE
 CR
 ASC " 17 - Exp / kill....."
 COLOR PINK
 DEC32 MEXPKILL
 COLOR WHITE
 CR
 ASC " 18 - Special dam...."
 COLOR YELLOW
 PRNIBBLE MSPECDAM
 COLOR WHITE
 ASC "="
 COLOR AQUAMARINE
 NULL
 LDA MSPECDAM
 JSR PRSPEC
 JSR PRINT
 COLOR WHITE
 GOTOXY 40;4
 ASC " 19 - Hit points....."
 COLOR PINK
 DEC8 MHP
 ASC "d"
 DEC8PNEG MHP+1
 COLOR WHITE
 GOTOXY 40;5
 ASC " 20 - In scenarios..."
 NULL
 LDA MSCENARIO
 CMP #$FF
 BNE :NOTFF
 JSR PRINT
 COLOR GREEN
 ASC "<all>"
 COLOR WHITE
 NULL
 BRA :FFCONT
:NOTFF JSR PRINT
 COLOR YELLOW
 DEC8 MSCENARIO
 COLOR WHITE
 ASC ", "
 COLOR YELLOW
 DEC8 MSCENARIO+1
 COLOR WHITE
 NULL
:FFCONT JSR PRINT
 CR
 CURSORON
 NULL
 JMP :DOPOINT
:MON DS 2

:MBACK JSR PRINT
 GOTOXY 0;23
 CLEOS
 NULL
 JSR :DISPLAY
 LDA #$FF
 STA :FLAG
 JMP :BOT

:ADD JSR PRINT
 GOTOXY 0;23
 CLEOS
 ASC "Add - [N]ext free one, [E]nd of file, [ESC] Exit : "
 NULL
]LOOP JSR KEYIN
 JSR UPPER
 CMP #$9B
 BEQL :BOT
 CMP #"N"
 BEQ :ANEXT
 CMP #"E"
 BNE ]LOOP
 JSR COUT
:AEND LDX #0
 LDA #0
 JSR LOADMON
 LDA MONBUFF
 CMP #$FF
 BCC :AEOK
 JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 COLOR PINK
 ASC "Cannot add any more monsters. "
 COLOR WHITE
 NULL
 GETRETURN
 JMP :ADD
:AEOK INCR MONBUFF ;Add 1 to the number of monsters
 LDX #0
 LDA #0
 JSR SAVEMON ;Save it out
 INCR :RECS
 LDA :RECS
 STA :MON
 LDA :RECS+1
 STA :MON+1
:AGOTIT LDX #0
]LOOP STZ MONBUFF,X
 INX
 BNE ]LOOP
 JSR :DISPLAY
 JMP :SAVE2
:ANEXT JSR COUT
 LDX :MON
 LDY :MON+1
 STX :MONN
 STY :MONN+1
 LDA :RECS
 BNE :NXTOK
 LDA :RECS+1
 BEQL :AEND
:NXTOK
]LOOP LDA :MONN+1
 CMP :RECS+1
 BCC :NRNGOK
 LDA :MONN
 CMP :RECS
 BEQ :NRNGOK
 BCSL :AEND
:NRNGOK LDX :MONN
 LDA :MONN+1
 JSR LOADMON
 INCR :MONN
 LDA MFREE
 BPL ]LOOP
 DECR :MONN
 LDA :MONN
 STA :MON
 LDA :MONN+1
 STA :MON+1
 JMP :AGOTIT
:MONN DS 2

:FREE LDX #1
 LDY #1
 JSR ASK
 GETLINE #1
 CPX #0
 BEQ :FRTS
 LDA $200
 CMP #"1"
 BEQ :A1
 CMP #"0"
 BNE :FREE
 LDA #0
 HEX 2C
:A1 LDA #$FF
 STA MFREE
:FRTS JMP :MBACK

:NAME LDX #2
 LDY #2
 JSR ASK
 GETLINE #20
 CPX #0
 BEQ :NWRTS
 STX MNAME
]LOOP LDA $200-1,X
 STA MNAME,X
 DEX
 BNE ]LOOP
:NWRTS JMP :MBACK

:ST LDX #5
 LDY #3
 JSR ASK
 GETLINE #3
 CPX #0
 BEQ :STRTS
 JSR GETNUM
 STX MST
:STRTS JMP :MBACK

:DX LDX #5
 LDY #4
 JSR ASK
 GETLINE #3
 CPX #0
 BEQ :DXRTS
 JSR GETNUM
 STX MDX
:DXRTS JMP :MBACK

:IQ LDX #5
 LDY #5
 JSR ASK
 GETLINE #3
 CPX #0
 BEQ :IQRTS
 JSR GETNUM
 STX MIQ
:IQRTS JMP :MBACK

:HT LDX #5
 LDY #6
 JSR ASK
 GETLINE #3
 CPX #0
 BEQ :HTRTS
 JSR GETNUM
 STX MHT
:HTRTS JMP :MBACK

:SPEED LDX #5
 LDY #7
 JSR ASK
 GETLINE #3
 CPX #0
 BEQ :SPRTS
 JSR GETNUM
 STX MSPEED
:SPRTS JMP :MBACK

:PD LDX #5
 LDY #8
 JSR ASK
 GETLINE #3
 CPX #0
 BEQ :PDRTS
 JSR GETNUM
 STX MPD
:PDRTS JMP :MBACK

:DR LDX #5
 LDY #9
 JSR ASK
 GETLINE #3
 CPX #0
 BEQ :PDRTS
 JSR GETNUM
 STX MDR
:DRRTS JMP :MBACK

:DAM LDX #5
 LDY #10
 JSR ASK
 GETLINE #3
 CPX #0
 BEQ :DAMMOD
 JSR GETNUM
 STX MDAM
:DAMMOD LDX #5
 LDY #10
 JSR ASK
 GETLINE #3
 CPX #0
 BEQ :DAMMRTS
 JSR GETNUM
 STX MDAMMOD
:DAMMRTS JMP :MBACK

:HABITAT LDX #5
 LDY #11
 JSR ASK
 GETLINE #3
 CPX #0
 BEQ :HABRTS
 JSR GETNUM
 CPX #7
 BCS :HABRTS
 STX MHABITAT
:HABRTS JMP :MBACK

:DAMTYPE LDX #5
 LDY #12
 JSR ASK
 GETLINE #3
 CPX #0
 BEQ :DAMTRTS
 JSR GETNUM
 CPX #4
 BCS :DAMTRTS
 STX MDAMTYPE
:DAMTRTS JMP :MBACK

:REACH LDX #5
 LDY #13
 JSR ASK
 GETLINE #3
 CPX #0
 BEQ :RCRTS
 JSR GETNUM
 CPX #$11
 BCS :RCRTS
 STX MREACH
:RCRTS JMP :MBACK

:SIZE LDX #5
 LDY #14
 JSR ASK
 GETLINE #3
 CPX #0
 BEQ :SZRTS
 JSR GETNUM
 STX MSIZE
:SZRTS JMP :MBACK

:TREAS LDA MTREASURE
 AND #%0000_1111
 STA :TR1
 LDA MTREASURE
 LSR
 LSR
 LSR
 LSR
 STA :TR2
 LDX #5
 LDY #15
 JSR ASK
 GETLINE #2
 CPX #0
 BEQ :TREAS2
 JSR GETNUM
 CPX #16
 BCS :TREAS2
 STX :TR2
:TREAS2 LDX #5
 LDY #15
 JSR ASK
 GETLINE #2
 CPX #0
 BEQ :TRRTS
 JSR GETNUM
 CPX #16
 BCS :TRRTS
 STX :TR1
:TRRTS LDA :TR2
 ASL
 ASL
 ASL
 ASL
 ORA :TR1
 STA MTREASURE
 JMP :MBACK
:TR1 DS 1
:TR2 DS 1

:LVL LDX #5
 LDY #16
 JSR ASK
 GETLINE #3
 CPX #0
 BEQ :LVLRTS
 JSR GETNUM
 CPX #0
 BEQ :LVLOK
 CPX #16+1
 BCS :LVLRTS
:LVLOK STX MLEVEL
:LVLRTS JMP :MBACK

:EXPKILL LDX #5
 LDY #17
 JSR ASK
 GETLINE #10
 CPX #0
 BEQ :EKRTS
 JSR GETNUM
 STX MEXPKILL
 STY MEXPKILL+1
 LDA VTEMP
 STA MEXPKILL+2
 LDA VTEMP+1
 STA MEXPKILL+3
:EKRTS JMP :MBACK

:SPECDAM LDX #6
 LDY #18
 JSR ASK
 GETLINE #8
 CPX #0
 BEQ :SPECRTS
 JSR GETNIBBLE
 STX MSPECDAM
:SPECRTS JMP :MBACK

:HP LDX #5
 LDY #19
 JSR ASK
 GETLINE #3
 CPX #0
 BEQ :HP2
 JSR GETNUM
 STX MHP
:HP2 LDX #5
 LDY #19
 JSR ASK
 GETLINE #3
 CPX #0
 BEQ :HPRTS
 JSR GETNUM
 STX MHP+1
:HPRTS JMP :MBACK

:SCEN LDX #5
 LDY #20
 JSR ASK
 GETLINE #3
 CPX #0
 BEQ :SCEN2
 JSR GETNUM
 STX MSCENARIO
:SCEN2 LDX #5
 LDY #20
 JSR ASK
 GETLINE #3
 CPX #0
 BEQ :SCRTS
 JSR GETNUM
 STX MSCENARIO+1
:SCRTS JMP :MBACK

:RECS DS 2
:FLAG DS 1
:DDAY DS 1
:DMONTH DS 1
:DYEAR DS 1
:DENTRY DS 9

PRSPEC STA :BYTE
 STZ :CFLAG
 LDA #$80
 STA :ANDX
 LDX #7
]LOOP PHX
 LDA :BYTE
 AND :ANDX
 BEQ :NXTCON
 BIT :CFLAG
 BPL :C1X
 LDA #"/"
 JSR COUT
:C1X LDA #$FF
 STA :CFLAG
 TXA
 ASL
 ASL
 ASL
 ASL
 TAY
 LDA :CNAMES,Y
 TAX
]LOOP2 INY
 LDA :CNAMES,Y
 JSR COUT
 DEX
 BNE ]LOOP2
:NXTCON LSR :ANDX
 PLX
 DEX
 BPL ]LOOP
 LDA :CFLAG
 BMI :X
 JSR PRINT
 COLOR AQUAMARINE
 ASC "<none>"
 COLOR WHITE
 NULL
:X RTS
:ANDX DS 1
:BYTE DS 1
:CFLAG DS 1
:CNAMES PAD16 "stunn" ; 0 (bit representation)
 PAD16 "blind" ; 1
 PAD16 "?" ; 2
 PAD16 "K-O" ; 3
 PAD16 "?" ; 4
 PAD16 "poison" ; 5
 PAD16 "p-lyze" ; 6
 PAD16 "death" ; 7

EXIT JSR PRINT
 NORMAL
 MTOFF
 HOME
 NULL
 RETURN

TEMP DS 2
NUMLVLS DS 1

 LST ON
MODEND EQU *
 LST OFF

 do M16PLUS
 SAV RUN/MODULES/MON.EDITOR
 fin

 END
