*-------------------------------
* MSG.EDITOR
*-------------------------------
 DAT
 LST OFF

 ORG $8000 ;Always

 USE MACROS
 USE EQUATES
 USE VARS
 USE LIB.JMP
 USE MSG.DSECT
 USE PN.DSECT

 TYP $F4
 do M16PLUS-1
 DSK RUN/MODULES/MSG.EDITOR
 fin

 MODID "MSG.EDITOR"

TOPLIN = 10
BOTLIN = 21

START JSR PRINT
 HOME
 CURSORON
 CENTER "Message Editor"
 GOTOXY 0;9
 INVERSE
 COLOR YELLOW
 ZAPLINE
 GOTOXY 0;22
 ZAPLINE
 NORMAL
 CR
 COLOR WHITE
 NULL

 LDX #0
 LDA #0
 JSR LOADMSGINDX
 LDA MSGINDXBUFF
 STA INDX
 LDA MSGINDXBUFF+1
 STA INDX+1

 LDX #0
 LDA #0
 JSR LOADMSG
 LDA MSGBUFF
 STA MSGS
 LDA MSGBUFF+1
 STA MSGS+1

 JSR ZAPI

TOPTOP JSR PRINT
 GOTOXY 56;0
 ASC "Total Index    : "
 CLEOL
 COLOR YELLOW
 DEC16 INDX
 COLOR WHITE
 GOTOXY 56;1
 ASC "Total Messages : "
 CLEOL
 COLOR YELLOW
 DEC16 MSGS
 COLOR WHITE
 NULL

TOP JSR PRINT
 COLOR YELLOW
 GOTOXY 0;0
 COLOR WHITE
 ASC "Index message : "
 COLOR YELLOW
 DEC16 CURRINDX
 ASC "  "
 COLOR WHITE
 CR
 ASC "Curr. message : "
 COLOR YELLOW
 DEC16 MSGNUM
 ASC "  "
 COLOR WHITE
 NULL

TOP2 JSR PRINT
 GOTOXY 0;3
 ASC "1 - Free.........."
 PRFLAG MSGFREE
 CLEOL
 CR
 ASC "2 - Msg number...."
 CLEOL
 DEC16 MSGNUM
 CR
 ASC "3 - From.........."
 CLEOL
 NULL
 LDA MSGFROM
 BEQ :OK1
 CMP MSGTO
 BNE :OK1
 LDA MSGSYSOP
 BPL :OK1
 JSR PRINT
 COLOR AQUAMARINE
 ASC "GameMaster"
 COLOR WHITE
 NULL
 BIT MSGREAD ;Read this msg yet?
 BMI :CONT1 ;Yep
 JSR PRINT
 GOTOXY 40;3
 COLOR PINK
 ASC "* New message *"
 COLOR WHITE
 VTAB 6
 NULL
 BRA :CONT1
:OK1 JSR PRINT
 DEC16 MSGFROM
 NULL
 LDA MSGFROM
 BEQ :CONT1
 LDX MSGFROM
 LDA MSGFROM+1
 JSR LOADPN
 JSR PRINT
 ASC " ("
 COLOR ORANGE
 PRSTRING PNNAME
 COLOR WHITE
 ASC ")"
 NULL
:CONT1 JSR PRINT
 CR
 ASC "4 - To............"
 CLEOL
 NULL
 LDA MSGFROM
 BEQ :OK
 CMP MSGTO
 BNE :OK
 LDA MSGSYSOP
 BMI :OK
 JSR PRINT
 COLOR AQUAMARINE
 ASC "GameMaster"
 COLOR WHITE
 NULL
 BIT MSGREAD+1
 BMI :CONT
 JSR PRINT
 GOTOXY 40;3
 COLOR PINK
 ASC "* New message *"
 COLOR WHITE
 VTAB 6
 NULL
 BRA :CONT
:OK JSR PRINT
 DEC16 MSGTO
 NULL
 LDA MSGTO
 BEQ :CONT
 LDX MSGTO
 LDA MSGTO+1
 JSR LOADPN
 JSR PRINT
 ASC " ("
 COLOR ORANGE
 PRSTRING PNNAME
 COLOR WHITE
 ASC ")"
 NULL
:CONT JSR PRINT
 CR
 ASC "5 - Date/time....."
 DATE MSGPOSTED
 ASC "  "
 TIME MSGPOSTED+2
 CR
 ASC "6 - Message read.."
 PRFLAG MSGREAD
 ASC "/"
 PRFLAG MSGREAD+1
 NULL

BOT JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 CURSORON
 ASC "[ESC]-jump, L)oad, S)ave, G)oto, ["
 MTON
 INVERSE
 ASC "H"
 NORMAL
 ASC "/"
 INVERSE
 ASC "U"
 NORMAL
 MTOFF
 ASC "], H)elp, A)dd, D)el, R)ead, I, Q)uit : "
 CLEOL
 NULL
 LDA CH
 STA KEYCH+2

GETKEY LDX #0
 LDY #0
 LDA #23
 JSR PICKLINE
 LDA $200
 CMP #"["
 BNE BOT
 JSR PRINT
KEYCH GOTOXY 0;23
 CLEOL
 NULL
]LOOP JSR KEYIN
 JSR UPPER
 LDX :KEYS
]LOOP2 CMP :KEYS,X
 BEQ :GOTONE
 DEX
 BNE ]LOOP2
 JMP ]LOOP
:GOTONE DEX
 TXA
 ASL
 TAX
 JMP (:TABLE,X)

:KEYS DFB :ENDKEYS-*-1
 DFB $9B
 DFB "L"
 DFB "S"
 DFB "Q"
 DFB "1"
 DFB "2"
 DFB "3"
 DFB "4"
 DFB "5"
 DFB "6"
 DFB "H"
 DFB "G"
 DFB "H"-$40
 DFB "U"-$40
 DFB "A"
 DFB "D"
 DFB "R"
 DFB "I"
:ENDKEYS

:TABLE DA JUMP
 DA LOAD
 DA SAVE
 DA EXIT
 DA MFREE
 DA MNUM
 DA MFROM
 DA MTO
 DA MPOSTED
 DA MREAD
 DA HELP
 DA GOTO
 DA LEFT
 DA RIGHT
 DA ADD
 DA DELETE
 DA READGM
 DA MINDEX

MINDEX JSR CLEAR
 STZ :CNTR
 STZ :CNTR+1
]LOOP LDA :CNTR+1
 CMP INDX+1
 BNE :OK
 LDA :CNTR
 CMP INDX
 BEQL :DONE
:OK INCR :CNTR
 LDX :CNTR
 LDA :CNTR+1
 JSR LOADMSGINDX
 JSR PRINT
 COLOR YELLOW
 DEC16 :CNTR
 HTAB 6
 COLOR WHITE
 PRFLAG MSGFREE
 ASC " "
 COLOR YELLOW
 DEC16 MSGNUM
 HTAB 14
 COLOR ORANGE
 DEC16 MSGFROM
 HTAB 20
 DEC16 MSGTO
 HTAB 26
 COLOR WHITE
 DATE MSGPOSTED
 ASC "  "
 TIME MSGPOSTED+2
 ASC " "
 PRFLAG MSGREAD
 ASC "/"
 PRFLAG MSGREAD+1
 COLOR YELLOW
 CR
 NULL
 LDA CV
 CMP #BOTLIN
 BNE ]LOOP
 JSR PRINT
 COLOR PINK
 CENTER "[ESC]-abort, [SPACE]-continue"
 COLOR WHITE
 CURSOROFF
 NULL
]LOOP2 JSR KEYIN
 CMP #$9B
 BEQ :ESC
 CMP #" "
 BNE ]LOOP2
 JSR PRINT
 CURSORON
 NULL
 JSR CLEAR
 JMP ]LOOP
:DONE LDA #BOTLIN
 STA :HV+3
 JSR PRINT
:HV GOTOXY 0;0
 COLOR PINK
 NULL
 GETRETURN
 JSR PRINT
 COLOR WHITE
 NULL
:ESC JSR PRINT
 CURSORON
 NULL
 JSR CLEAR
 JMP LOAD2
:CNTR DS 2

READGM LDA INDX
 ORA INDX+1
 BEQL GETKEY
]LOOP LDA CURRINDX+1
 CMP INDX+1
 BCC :OK
 LDA CURRINDX
 CMP INDX
 BCC :OK
 JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 COLOR PINK
 ASC "End of mail scan. "
 COLOR WHITE
 NULL
 GETRETURN
 JMP BOT
:OK INCR CURRINDX
 LDX CURRINDX
 LDA CURRINDX+1
 JSR LOADMSGINDX
 BIT MSGFREE
 BMI ]LOOP
 LDA MSGFROM
 CMP MSGTO
 BNE ]LOOP
 JMP LOAD2

DELETE LDA CURRINDX
 BNE :OK
 LDA CURRINDX+1
 BNE :OK
 JMP GETKEY
:OK JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 COLOR PINK
 ASC "Delete this message (y/N)? : "
 COLOR WHITE
 NULL
 JSR KEYIN
 JSR UPPER
 CMP #"Y"
 BNEL BOT
 JSR PRINT
 ASC "Yes"
 NULL
 LDA #$FF
 STA MSGFREE
 LDX CURRINDX
 LDA CURRINDX+1
 JSR SAVEMSGINDX
 LDX MSGNUM
 LDA MSGNUM+1
 JSR MARKFREE ;Mark this message as being free
 JMP TOP2

ADD JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 ASC "Add a new message (y/N)? : "
 NULL
 JSR KEYIN
 JSR UPPER
 CMP #"Y"
 BNEL BOT
 JSR PRINT
 ASC "Yes"
 NULL
 JSR GETFREEMSG ;Get the next free message from 'msg map'
 BCC :OK
 JSR PRINT
 COLOR PINK
 ASC " Can't - message base full. "
 COLOR WHITE
 NULL
 GETRETURN
 JMP BOT

:OK STX :NEWMSG
 STA :NEWMSG+1
 STZ :CNTR
 STZ :CNTR+1
]LOOP LDA :CNTR+1 ;Look for a free msg in index
 CMP INDX+1
 BNE :LOOK
 LDA :CNTR
 CMP INDX
 BEQ :ADD1
:LOOK INCR :CNTR
 LDX :CNTR
 LDA :CNTR+1
 JSR LOADMSGINDX
 LDA MSGFREE
 BPL ]LOOP
 BRA :FREE1

:ADD1 INCR :CNTR
 LDA :CNTR
 STA MSGINDXBUFF
 STA INDX
 LDA :CNTR+1
 STA MSGINDXBUFF+1
 STA INDX+1
 LDX #0
 LDA #0
 JSR SAVEMSGINDX

:FREE1 LDA :CNTR
 STA CURRINDX
 LDA :CNTR+1
 STA CURRINDX+1

 JSR ZAPI

 LDA :NEWMSG
 STA MSGNUM
 LDA :NEWMSG+1
 STA MSGNUM+1

 MLI_GET_TIME
 LDX #3
]LOOP LDA $BF90,X
 STA MSGPOSTED,X
 DEX
 BPL ]LOOP

 LDA :NEWMSG+1
 CMP MSGS+1
 BCC :LESS
 LDA :NEWMSG
 CMP MSGS
 BEQ :LESS
 BCC :LESS
 LDA :NEWMSG
 STA MSGBUFF
 STA MSGS
 LDA :NEWMSG+1
 STA MSGBUFF+1
 STA MSGS+1
 LDX #0
 LDA #0
 JSR SAVEMSG

:LESS JSR CLEAR
 STZ XPOS
 LDA #TOPLIN
 STA YPOS
 JMP SAVE2
:NEWMSG DS 2
:CNTR DS 2

LEFT LDA CURRINDX+1
 BNE :OK
 LDA CURRINDX
 CMP #2
 BCCL GETKEY
:OK DECR CURRINDX
 JMP LOAD2

RIGHT LDA CURRINDX+1
 CMP INDX+1
 BCC :OK
 LDA CURRINDX
 CMP INDX
 BCSL GETKEY
:OK INCR CURRINDX
 JMP LOAD2

GOTO JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 ASC "Goto message : "
 NULL
 GETLINE #5
 CPX #0
 BEQL :RTS
 JSR GETNUM
 CPX #0
 BNE :OK
 CPY #0
 BEQL :RTS
:OK STX :MSG
 STY :MSG+1
 STZ :CURR
 STZ :CURR+1
:SEARCH JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 ASC "Searching (press any key to abort).."
 CURSOROFF
 NULL
]LOOP BIT DUMBTERM
 BMI :OVER
 JSR CHECKIN ;Did we get something from the modem?
 BCS :YES
:OVER LDA $C000
 BMI :YES
 LDA :CURR+1
 CMP INDX+1
 BCC :READ
 LDA :CURR
 CMP INDX
 BCS :NOPE
:READ INCR :CURR
 LDX :CURR
 LDA :CURR+1
 JSR LOADMSGINDX
 LDA MSGNUM
 CMP :MSG
 BNE ]LOOP
 LDA MSGNUM+1
 CMP :MSG+1
 BNE ]LOOP
 JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 CURSORON
 NULL
 LDA MSGNUM
 STA CURRINDX
 LDA MSGNUM+1
 STA CURRINDX+1
 JMP LOAD2
:NOPE JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 CURSORON
 COLOR PINK
 ASC "Message not found. "
 COLOR WHITE
 NULL
 GETRETURN
 BRA :RTS
:YES STA $C010
 JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 CURSORON
 COLOR PINK
 ASC "Abort search (y/N)? : "
 COLOR WHITE
 NULL
 JSR KEYIN
 JSR UPPER
 CMP #"Y"
 BNEL ]LOOP
:RTS JMP BOT
:MSG DS 2
:CURR DS 2

LOAD JSR PRINT
 ASC "L"
 NULL
LOAD2 LDA CURRINDX
 BNE :OK
 LDA CURRINDX+1
 BNE :OK
 JMP GETKEY
:OK LDX CURRINDX
 LDA CURRINDX+1
 JSR LOADMSGINDX
 LDX MSGNUM
 LDA MSGNUM+1
 JSR LOADMSG
 LDA TOPLINE
 STA :LINES
 LDA BOTLINE
 STA :LINES+1
 JSR CLEAR
 LDX #<MSGRECLEN ;Length
 LDA #>MSGRECLEN
 JSR SHOWMSG
:LINES DS 2 ;Lines to use (top, bottom)
 DA MSGBUFF
 LDA MSGBUFF+MSGRECLEN-2
 STA XPOS
 LDA MSGBUFF+MSGRECLEN-1
 STA YPOS
 JMP TOP

SAVE LDA CURRINDX
 ORA CURRINDX+1
 BEQL GETKEY
 JSR PRINT
 ASC "S"
 NULL
SAVE2 LDA MSGFROM
 CMP MSGTO
 BNE :OK
 LDA MSGSYSOP ;Msg to GM (00) or from GM (FF)
 BMI :OK
 LDA #$FF ;Update msg to say it's been read by the GM
 STA MSGREAD+1
:OK LDA $C061 ;Update date/time?
 BPL :OK2
 MLI_GET_TIME
 LDX #3
]LOOP LDA $BF90,X
 STA MSGPOSTED,X
 DEX
 BPL ]LOOP
:OK2 LDX CURRINDX
 LDA CURRINDX+1
 JSR SAVEMSGINDX
 LDA TOPLINE
 STA :LINES
 LDA BOTLINE
 STA :LINES+1
 JSR GETSCREEN ;PICKLINE the screen
:LINES DS 2 ;on these lines
 DA MSGBUFF ;and put it here
 STX :LEN ;X and A have length on return
 STA :LEN+1
 LDA XPOS
 STA MSGBUFF+MSGRECLEN-2
 LDA YPOS
 STA MSGBUFF+MSGRECLEN-1
 LDX MSGNUM
 LDA MSGNUM+1
 JSR SAVEMSG
 BIT MSGFREE
 BMI :FREE
 LDX MSGNUM
 LDA MSGNUM+1
 JSR MARKUSED ;Mark this message as being used
 JMP TOPTOP
:FREE LDX MSGNUM
 LDA MSGNUM+1
 JSR MARKFREE ;Mark this message as being free
 JMP TOPTOP
:LEN DS 2

EXIT JSR CLOSEALL
 RETURN

EDIT LDA XPOS
 STA :GOTO+2
 LDA YPOS
 STA :GOTO+3
 JSR PRINT
:GOTO GOTOXY 0;0
 NULL
 LDX TOPLINE
 LDA BOTLINE
 JSR MSGEDIT
 LDA CH
 STA XPOS
 LDA CV
 STA YPOS
 JMP GETKEY

HELP JSR PRINT
 ASC "H"
 NULL
 LDA TOPLINE
 STA :LINES
 STA :LINES2
 STA :LINES3
 LDA BOTLINE
 STA :LINES+1
 STA :LINES2+1
 STA :LINES3+1
 JSR GETSCREEN ;PICKLINE the screen
:LINES DS 2 ;on these lines
 DA :BUFFER ;and put it here
 STX :LEN ;X and A have length on return
 STA :LEN+1

 JSR GETFILE
:LINES2 DS 2 ;Use lines x to y
 STR "HELP/MSG.ED"
 JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 COLOR PINK
 NULL
 GETRETURN
 JSR PRINT
 GOTOXY 0;23
 COLOR WHITE
 ZAPLINE
 NULL

 JSR CLEAR

 LDX :LEN ;Length
 LDA :LEN+1
 JSR SHOWMSG
:LINES3 DS 2 ;Lines to use (top, bottom)
 DA :BUFFER
 JMP GETKEY
:LEN DS 2
:BUFFER DA BOTLIN-TOPLIN+1*80

MFREE LDX #1
 LDY #1
 JSR ASK
 GETLINE #1
 CPX #0
 BEQ :RTS
 LDA $200
 CMP #"1"
 BEQ :A1
 CMP #"0"
 BNE MFREE
 LDA #0
 HEX 2C
:A1 LDA #$FF
 STA MSGFREE
:RTS JMP TOP2

MNUM LDX #5
 LDY #2
 JSR ASK
 GETLINE #5
 CPX #0
 BEQ :RTS
 JSR GETNUM
 STX MSGNUM
 STY MSGNUM+1
:RTS JMP TOP2

MFROM LDX #5
 LDY #3
 JSR ASK
 GETLINE #5
 CPX #0
 BEQ :RTS
 JSR GETNUM
 STX MSGFROM
 STY MSGFROM+1
:RTS JMP TOP2

MTO LDX #5
 LDY #4
 JSR ASK
 GETLINE #5
 CPX #0
 BEQ :RTS
 JSR GETNUM
 STX MSGTO
 STY MSGTO+1
:RTS JMP TOP2

MPOSTED LDX #4
 LDY #5
 JSR ASK
 GETLINE #11
 CPX #11
 BNEL :RTS
 LDX #8
]LOOP LDA $200+2,X
 STA :DENTRY,X
 DEX
 BPL ]LOOP
 LDA #$8D
 STA $202
 LDX #2
 JSR GETNUM
 STX :DDAY
 LDA :DENTRY
 STA $200
 LDA :DENTRY+1
 STA $201
 LDX #2
 JSR GETNUM
 STX :DMONTH
 LDA :DENTRY+2
 STA $200
 LDA :DENTRY+3
 STA $201
 LDX #2
 JSR GETNUM
 STX :DYEAR
 LDA :DMONTH
 ASL
 ASL
 ASL
 ASL
 ASL
 ROL :DYEAR
 ORA :DDAY
 STA MSGPOSTED
 LDA :DYEAR
 STA MSGPOSTED+1
 LDA :DENTRY+5
 STA $200
 LDA :DENTRY+6
 STA $201
 LDX #2
 JSR GETNUM
 STX MSGPOSTED+3
 LDA :DENTRY+7
 STA $200
 LDA :DENTRY+8
 STA $201
 LDX #2
 JSR GETNUM
 STX MSGPOSTED+2
:RTS JMP TOP2
:DDAY DS 1
:DMONTH DS 1
:DYEAR DS 1
:DENTRY DS 9

MREAD LDX #1
 LDY #6
 JSR ASK
 GETLINE #1
 CPX #0
 BEQ :RTS
 LDA $200
 CMP #"1"
 BEQ :A1
 CMP #"0"
 BNE MREAD
 LDA #0
 HEX 2C
:A1 LDA #$FF
 STA MSGREAD
:RTS LDX #1
 LDY #6
 JSR ASK
 GETLINE #1
 CPX #0
 BEQ :RTS2
 LDA $200
 CMP #"1"
 BEQ :A2
 CMP #"0"
 BNE :RTS
 LDA #0
 HEX 2C
:A2 LDA #$FF
 STA MSGREAD+1
:RTS2 JMP TOP2

JUMP LDA CURRINDX
 ORA CURRINDX+1
 BEQL GETKEY
 LDA XPOS
 STA :GOTO+2
 LDA YPOS
 STA :GOTO+3
 JSR PRINT
:GOTO GOTOXY 0;0
 NULL
 JMP EDIT

CLEAR JSR PRINT
 GOTOXY 0;21
 ZAPLINE
 NULL
]LOOP JSR PRINT
 CURSORUP
 ZAPLINE
 NULL
 LDA CV
 CMP TOPLINE
 BNE ]LOOP
 RTS

ZAPI STZ MSGFREE
 STZ MSGNUM
 STZ MSGNUM+1
 STZ MSGFROM
 STZ MSGFROM+1
 STZ MSGTO
 STZ MSGTO+1
 STZ MSGPOSTED
 STZ MSGPOSTED+1
 STZ MSGPOSTED+2
 STZ MSGPOSTED+3
 RTS

XPOS DFB 0 ;Leave these two together
YPOS DFB 10 ;

TOPLINE DFB TOPLIN
BOTLINE DFB BOTLIN

INDX DS 2
MSGS DS 2

CURRINDX DS 2

 LST ON
MODEND EQU *
 LST OFF

 do M16PLUS
 SAV RUN/MODULES/MSG.EDITOR
 fin

 END
