*-------------------------------
* PLR.EDITOR
*-------------------------------
 DAT
 LST OFF

 ORG $8000 ;Always

 USE MACROS
 USE EQUATES
 USE VARS
 USE PLR.DSECT
 USE LIB.JMP
 USE TABLES
 USE PN.DSECT
 USE SPELL.DSECT
 USE ITEM.DSECT

 TYP $F4
 do M16PLUS-1
 DSK RUN/MODULES/PLR.EDITOR
 fin

NUMPLR = 35 ;Number of entries for a PLAYER

 MODID "PLR.EDITOR"

START JSR PRINT
 HOME
 BOX "Player Editor"
 NULL
 STZ :FLAG
 STZ :CHAR
 STZ :CHAR+1
 LDX #0
 LDA #0
 JSR LOADITEM
 LDA ITEMBUFF
 STA TOTITEMS
 LDX #0
 LDA #0
 JSR LOADPN
 LDA PNBUFF
 STA TOTPRTY

 LDX #0
 LDA #0
 JSR LOADPLR
 LDA PLRBUFF
 STA :RECS
 LDA PLRBUFF+1
 STA :RECS+1
 JMP :FORW1
:BOT JSR PRINT
 GOTOXY 1;1
 ASC "Total in file : "
 COLOR YELLOW
 DEC16 :RECS
 COLOR WHITE
 GOTOXY 0;23
 CLEOS
 ASC "[A]dd, [J]ump, [S]ave, [L]ist, [P]arty, [RETURN]-edit, "
 MTON
 INVERSE
 ASC "H"
 NORMAL
 ASC ", "
 INVERSE
 ASC "U"
 NORMAL
 MTOFF
 ASC ", [H]elp, [Q]uit : "
 CURSORON
 NULL
 LDA CH
 STA :BGOTO+2
:GETKEY JSR PRINT
:BGOTO GOTOXY 0;23
 NULL
]LOOP JSR KEYIN
 JSR UPPER
 LDX :KEYS
]LOOP2 CMP :KEYS,X
 BEQ :GOTONE
 DEX
 BNE ]LOOP2
 JMP ]LOOP
:GOTONE DEX
 TXA
 ASL
 TAX
 JMP (:TABLE,X)

:KEYS DFB :ENDKEYS-*-1
 DFB "Q"
 DFB "A"
 DFB "L"
 DFB "J"
 DFB "S"
 DFB "H"-$40
 DFB "U"-$40
 DFB "K"-$40
 DFB "J"-$40
 DFB "M"-$40
 DFB "P"
 DFB "H"
 DFB "I"
:ENDKEYS

:TABLE DA EXIT
 DA :ADD
 DA :LIST
 DA :LOAD
 DA :SAVE
 DA :BACK1
 DA :FORW1
 DA :UP
 DA :DOWN
 DA :EDIT
 DA :PLIST
 DA :HELP
 DA :ILIST

:ILIST JSR PRINT
 GOTOXY 0;4
 CLEOS
 LINE "#   / Type   / Cost  / Use by    / Name"
 CR
 NULL
 LDA PADFLAG
 PHA
 LDA #$FF
 STA PADFLAG
 LDA PADCHAR
 PHA
 LDA #" "
 STA PADCHAR
 STZ :CNTR
]LOOP LDA :CNTR
 CMP TOTITEMS
 BEQL :IDONE
 INC :CNTR
 LDX :CNTR
 LDA #0
 JSR LOADITEM
 JSR PRINT
 COLOR YELLOW
 DEC8 :CNTR
 COLOR WHITE
 ASC "   "
 COLOR AQUAMARINE
 NULL
 LDA ITYPE
 DEC
 ASL
 TAX
 LDA :TBL,X
 STA CADD2
 LDA :TBL+1,X
 STA CADD2+1
 LDY #0
 LDA (CADD2),Y
 TAX
]LOOP2 INY
 LDA (CADD2),Y
 JSR COUT
 DEX
 BNE ]LOOP2
 JSR PRINT
 COLOR WHITE
 ASC "   "
 DEC16 ICOST
 ASC "   "
 COLOR ORANGE
 PRNIBBLE IUSEBY
 COLOR WHITE
 ASC "   "
 PRSTRING INAME
 CR
 NULL
 LDA CV
 CMP #22
 BNE :IVOK
 JSR PRINT
 VTAB 23
 COLOR YELLOW
 CENTER "[SPACE]-continue, [ESC]-exit : "
 COLOR WHITE
 NULL
]LOOP2 JSR KEYIN
 CMP #$9B
 BEQ :IESC
 CMP #" "
 BNE ]LOOP2
 JSR PRINT
 GOTOXY 0;6
 CLEOS
 NULL
:IVOK JMP ]LOOP
:IDONE JSR PRINT
 GOTOXY 0;23
 COLOR PINK
 NULL
 GETRETURN
:IESC JSR PRINT
 COLOR WHITE
 NULL
 PLA
 STA PADCHAR
 PLA
 STA PADFLAG
 JSR :DISPLAY
 JMP :BOT

:TBL DA :TYPE1
 DA :TYPE2
 DA :TYPE3
 DA :TYPE4
 DA :TYPE5
 DA :TYPE6

:TYPE1 STR "Weapon"
:TYPE2 STR "Armour"
:TYPE3 STR "Shield"
:TYPE4 STR "Helmet"
:TYPE5 STR "Gloves"
:TYPE6 STR "Misc. "

:HELP JSR PRINT
 GOTOXY 0;4
 CLEOS
 NULL
 JSR GETFILE
 DFB 4,22 ;Use lines x to y
 STR "HELP/PLR.ED"
 JSR PRINT
 GOTOXY 0;23
 COLOR PINK
 NULL
 GETRETURN
 JSR PRINT
 GOTOXY 0;4
 COLOR WHITE
 CLEOS
 NULL
 JMP :CHBACK

:DOPOINT LDA :OLDPNTR
 CMP #19
 BCC :PLEFT
 LDA #40
 STA :CH+2
 LDA :OLDPNTR
 SEC
 SBC #15
 STA :CV+2
 BRA :DOP1
:PLEFT STZ :CH+2
 LDA :OLDPNTR
 CLC
 ADC #3
 STA :CV+2
:DOP1 JSR PRINT
 NORMAL
 MTOFF
:CH HTAB 0
:CV VTAB 0
 ASC " "
 NULL
 LDA :PNTR
 CMP #19
 BCC :PLEFT2
 LDA #40
 STA :CH2+2
 LDA :PNTR
 SEC
 SBC #15
 STA :CV2+2
 BRA :DOP2
:PLEFT2 STZ :CH2+2
 LDA :PNTR
 CLC
 ADC #3
 STA :CV2+2
:DOP2 JSR PRINT
:CH2 HTAB 0
:CV2 VTAB 0
 NULL
 JSR SHOWPNTR
 LDA :PNTR
 STA :OLDPNTR
 RTS
:OLDPNTR DFB 1
:PNTR DFB 1

:UP LDA :RECS
 ORA :RECS+1
 BEQL :BOT
 LDA :PNTR
 CMP #1
 BNE :UPOK
 LDA #NUMPLR+1
:UPOK DEC
 STA :PNTR
 JSR :DOPOINT
 JMP :GETKEY

:DOWN LDA :RECS
 ORA :RECS+1
 BEQL :BOT
 LDA :PNTR
 CMP #NUMPLR
 BNE :DNOK
 LDA #0
:DNOK INC
 STA :PNTR
 JSR :DOPOINT
 JMP :GETKEY

:PLIST LDA :RECS
 ORA :RECS+1
 BEQL :BOT
 LDA :CHAR+1
 STA :TEMP+1
 LDA :CHAR
 STA :TEMP
 STZ :PLR
 STZ :PLR+1
 LDA PLRPARTY
 STA :PRTY
 STZ :PLX
 LDA PADFLAG
 STA TEMP
 LDA #$FF
 STA PADFLAG
 LDA PADCHAR
 STA TEMP+1
 LDA #"0"
 STA PADCHAR
 JSR PRINT
 GOTOXY 0;3
 CLEOS
 CR
 ASC "Characters in Party #"
 COLOR YELLOW
 DEC8 :PRTY
 COLOR WHITE
 ASC " ("
 COLOR ORANGE
 PRSTRING PNNAME
 COLOR WHITE
 LINE ")"
 CR
 NULL
 STZ :PEXP
 STZ :PEXP+1
 STZ :PEXP+2
 STZ :PEXP+3
]LOOP INCR :PLR
 LDA :PLR+1
 CMP :RECS+1
 BCC :PLOK
 LDA :PLR
 CMP :RECS
 BEQ :PLOK
 BCC :PLOK
 BCS :PLDONE
:PLOK LDX :PLR
 LDA :PLR+1
 JSR LOADPLR
 LDA PLRPARTY
 CMP :PRTY
 BNE ]LOOP
 LDA PLRFREE
 BMI ]LOOP
 INC :PLX
 JSR PRINT
 DEC8 :PLX
 ASC ") "
 DEC16 :PLR
 ASC " - "
 COLOR PINK
 DEC32 PLREXP
 ASC " "
 COLOR YELLOW
 DEC8 PLRLVLREAL
 ASC " "
 COLOR AQUAMARINE
 PRTABLE PLRCLASS;CLASSTABLE
 COLOR WHITE
 HTAB 40
 PRSTRING PLRNAME
 CR
 NULL
 LDA :PEXP
 CLC
 ADC PLREXP
 STA :PEXP
 LDA :PEXP+1
 ADC PLREXP+1
 STA :PEXP+1
 LDA :PEXP+2
 ADC PLREXP+2
 STA :PEXP+2
 LDA :PEXP+3
 ADC PLREXP+3
 STA :PEXP+3
 JMP ]LOOP
:PLDONE JSR PRINT
 CR
 CR
 ASC "Total exp. : "
 COLOR PINK
 DEC32 :PEXP
 COLOR WHITE
 ASC ". "
 NULL
 GETRETURN
 JSR PRINT
 COLOR WHITE
 NULL
 LDA TEMP
 STA PADFLAG
 LDA TEMP+1
 STA PADCHAR
 LDX :TEMP
 LDY :TEMP+1
 JMP :LOK
:PRTY DS 1
:PLR DS 2
:PLX DS 1
:TEMP DS 2
:PEXP DS 4

:EDIT LDA :RECS
 ORA :RECS+1
 BEQL :BOT
 LDA :PNTR
 DEC
 ASL
 TAX
 JMP (:EDITS,X)

:EDITS DA :FREE
 DA :NAME
 DA :PNAME
 DA :DATECR
 DA :CLASS
 DA :PARTY
 DA :XPOS
 DA :YPOS
 DA :ZPOS
 DA :ST
 DA :DX
 DA :IQ
 DA :HT
 DA :HP
 DA :CREDITS
 DA :EXP
 DA :LEVEL
 DA :COND
 DA :GOLD
 DA :ITEM1
 DA :ITEM2
 DA :ITEM3
 DA :ITEM4
 DA :ITEM5
 DA :ITEM6
 DA :ITEM7
 DA :ITEM8
 DA :AGE
 DA :AC
 DA :APNTS
 DA :MAGIC
 DA :SPELLED
 DA :PKILLS
 DA :HITS
 DA :JAILS

:LOAD LDA :RECS
 ORA :RECS+1
 BEQL :BOT
 JSR PRINT
 GOTOXY 0;23
 CLEOS
 ASC "Jump to player #"
 CURSORON
 NULL
 GETLINE #5
 JSR GETNUM
 CPX #0
 BNE :LOK
 CPY #0
 BEQL :BOT
:LOK CPY :RECS+1
 BCC :RNGOK
 CPX :RECS
 BEQ :RNGOK
 BCC :RNGOK
 JSR PRINT
 COLOR PINK
 ASC " No such player. "
 COLOR WHITE
 NULL
 GETRETURN
 JMP :BOT
:RNGOK STX :CHAR
 STY :CHAR+1
 TYA
 JSR LOADPLR
 JSR :DISPLAY
 STZ :FLAG
 JMP :BOT

:SAVE LDA :RECS
 ORA :RECS+1
 BEQL :BOT
 BIT :FLAG
 BPLL :GETKEY
:SAVE2 LDX :CHAR
 LDA :CHAR+1
 JSR SAVEPLR
 LDX PLRSCENARIO
 BEQ :SZ
 LDA #$FF
 STA SCUPDATE-1,X
:SZ STZ :FLAG
 JMP :BOT

:BACK1 LDA :RECS
 ORA :RECS+1
 BEQL :BOT
 LDA :CHAR+1
 BNE :GOB
 LDA :CHAR
 CMP #2
 BCS :GOB
 JMP :BOT
:GOB DECR :CHAR
 LDX :CHAR
 LDY :CHAR+1
 JMP :LOK

:FORW1 LDA :RECS
 ORA :RECS+1
 BEQL :BOT
 LDA :CHAR+1
 CMP :RECS+1
 BCC :GOF
 LDA :CHAR
 CMP :RECS
 BCC :GOF
 JMP :BOT
:GOF INCR :CHAR
 LDX :CHAR
 LDY :CHAR+1
 JMP :LOK

:LIST LDA :RECS
 ORA :RECS+1
 BEQL :BOT
 JSR PRINT
 GOTOXY 0;23
 CLEOS
 ASC "Start from player #1"
 CURSORLEFT
 NULL
 LDA PADFLAG
 STA TEMP
 LDA #$FF
 STA PADFLAG
 LDA PADCHAR
 STA TEMP+1
 LDA #" "
 STA PADCHAR
 LDA #1
 STA :TOREAD
 STZ :TOREAD+1
 GETLINE #5
 BCSL :LEXIT
 CPX #0
 BEQ :FROM1
 JSR GETNUM
 STX :TOREAD
 STY :TOREAD+1
:FROM1 LDA :TOREAD+1
 CMP :RECS+1
 BCC :VGO
 BEQ :FROMLO
 BCS :FROMNO
:FROMLO LDA :TOREAD
 CMP :RECS
 BCC :VGO
 BEQ :VGO
:FROMNO JSR PRINT
 ASC " - "
 COLOR PINK
 ASC "Last player is #"
 COLOR YELLOW
 DEC16 :RECS
 COLOR PINK
 ASC ". "
 COLOR WHITE
 NULL
 GETRETURN
 JSR PRINT
 ZAPLINE
 NULL
 JMP :LEXIT
:VGO LDA :TOREAD
 STA :MCNTR
 LDA :TOREAD+1
 STA :MCNTR+1
 JSR PRINT
 GOTOXY 0;3
 CLEOS
 CR
 COLOR AQUAMARINE
 NULL
 BIT $C062
 BMI :OPTION
 JSR PRINT
 ASC "Player/?/Created  /Experience/Lv/ST/DX/IQ/HT/Name"
 HTAB 65
 LINE "/Pty/Class/ Sc"
 COLOR WHITE
 CURSOROFF
 NULL
 LDA #0
 BRA :LGOGO
:OPTION JSR PRINT
 LINE "Player/?/ Name                / Comment"
 COLOR WHITE
 CURSOROFF
 NULL
 LDA #$FF
:LGOGO STA :LFLAG
]LOOP LDA :MCNTR+1
 CMP :RECS+1
 BCC :RREAD
 LDA :MCNTR
 CMP :RECS
 BCC :RREAD
 BEQ :RREAD
 JMP :RDONE
:RREAD LDX :TOREAD
 LDA :TOREAD+1
 JSR LOADPLR
 INCR :TOREAD
 BIT $C061
 BPL :LSHOW
 BIT PLRFREE
 BMIL :MNEXT
:LSHOW LDA CV
 CMP #21
 BNE :VOK
 JSR PRINT
 CR
 CR
 CURSORON
 COLOR YELLOW
 CENTER "[SPACE]-continue, [ESC]-exit : "
 COLOR WHITE
 NULL
]LOOP3 JSR KEYIN
 CMP #$9B
 BEQL :RESC
 CMP #" "
 BNE ]LOOP3
 JSR PRINT
 GOTOXY 0;5
 CLEOS
 CURSOROFF
 NULL
:VOK JSR PRINT
 CR
 COLOR YELLOW
 DEC16 :MCNTR
 COLOR WHITE
 ASC ") "
 PRFLAG PLRFREE
 ASC " "
 NULL
 BIT :LFLAG
 BPL :NOPT
 JSR PRINT
 COLOR WHITE
 PRSTRING PLRNAME
 NULL
 LDA PLRQUOTE
 BEQL :MNEXT
 JSR PRINT
 HTAB 32
 QUOTE
 COLOR YELLOW
 PRSTRING PLRQUOTE
 COLOR WHITE
 QUOTE
 NULL
 JMP :MNEXT
:NOPT JSR PRINT
 COLOR GREEN
 DATE PLRMADE
 COLOR WHITE
 ASC " "
 DEC32 PLREXP
 ASC " "
 NULL
 LDA PLRLVLREAL
 CMP #10
 BCS :PLVOK
 JSR PRINT
 ASC " "
 NULL
:PLVOK STZ PADFLAG
 JSR PRINT
 COLOR ORANGE
 DEC8 PLRLVLREAL
 COLOR WHITE
 NULL
 DEC PADFLAG
 JSR PRINT
 ASC " "
 COLOR YELLOW
 PAD2 PLRST
 COLOR WHITE
 ASC "/"
 COLOR YELLOW
 PAD2 PLRDX
 COLOR WHITE
 ASC "/"
 COLOR YELLOW
 PAD2 PLRIQ
 COLOR WHITE
 ASC "/"
 COLOR YELLOW
 PAD2 PLRHT
 COLOR WHITE
 NULL
 LDX #" "
 LDA PLRARRESTFLAG
 BPL :NOARR
 LDX #"*" ;Arrested
:NOARR LDA PLRPASSAULTS
 ORA PLRPASSAULTS+1
 BEQ :NOASS
 LDX #"-" ;People basher
:NOASS LDA PLRPKILLS
 ORA PLRPKILLS+1
 BEQ :NOKILLS
 LDX #"#" ;Murderer
:NOKILLS LDA PLRCREDITS
 BEQ :NOCRED
 JSR PRINT
 COLOR ORANGE
 NULL
:NOCRED STX :XMOD
 JSR PRINT
:XMOD ASC " "
 PRSTRING PLRNAME
 HTAB 66
 COLOR AQUAMARINE
 DEC8 PLRPARTY
 COLOR WHITE
 HTAB 70
 COLOR PINK
 PRTABLE PLRCLASS;:CLTBL
 HTAB 76
 COLOR YELLOW
 DEC8 PLRSCENARIO
 COLOR WHITE
 NULL
:MNEXT INCR :MCNTR
 LDA $C000
 BPLL ]LOOP
 STA $C010
 CMP #$9B
 BEQ :RDONE
 JMP ]LOOP
:RESC JSR PRINT
 ZAPLINE
 CURSORON
 NULL
 BRA :RDONE2
:RDONE JSR PRINT
 GOTOXY 0;23
 COLOR PINK
 CURSORON
 NULL
 GETRETURN
 JSR PRINT
 COLOR WHITE
 NULL
:RDONE2 LDA TEMP
 STA PADFLAG
 LDA TEMP+1
 STA PADCHAR
 LDX :CHAR
 LDY :CHAR+1
 JMP :LOK
:LEXIT LDA TEMP
 STA PADFLAG
 LDA TEMP+1
 STA PADCHAR
 JMP :BOT
:LFLAG DS 1
:MCNTR DS 2
:TOREAD DA 2

]LEN = 7
:CLTBL DFB ]LEN
 ENTRY "<?>"
 ENTRY "Fightr" ;Basic
 ENTRY "Thief"
 ENTRY "Wizard"
 ENTRY "Cleric"
 ENTRY "Ninja" ;Elite (Fighter only)
 ENTRY "Sage" ;      (Psychic/Fighter)
 ENTRY "H-Mage" ;     (Wizard/Fighter)
 ENTRY "H-Prst" ;   (Cleric/Fighter)
 ENTRY "Lord" ;Super Elite (Fighter/Thief/Wizard/Cleric)

:DISPLAY LDA :RECS
 ORA :RECS+1
 BEQL :BOT
 STZ PNNAME
 LDA PLRPARTY
 BEQ :DISPLAY2
 TAX
 LDA #0
 JSR LOADPN
:DISPLAY2 JSR CALCPLR
 JSR PRINT
 GOTOXY 60;1
 ASC "Player #"
 COLOR YELLOW
 DEC16 :CHAR
 COLOR WHITE
 ASC " "
 GOTOXY 0;3
 ZAPLINE
 NULL
 LDA PLRQUOTE
 BEQ :NOQ
 LDA #80
 SEC
 SBC PLRQUOTE
 LSR
 DEC
 STA :QH+2
 JSR PRINT
:QH GOTOXY 0;3
 QUOTE
 COLOR AQUAMARINE
 PRSTRING PLRQUOTE
 COLOR WHITE
 QUOTE
 NULL
:NOQ JSR PRINT
 GOTOXY 0;4
 COLOR WHITE
 CLEOS
 CURSOROFF
 ASC "  1 - Free flag....."
 PRFLAG PLRFREE
 ASC " (Scenario : "
 COLOR YELLOW
 DEC8 PLRSCENARIO
 COLOR WHITE
 ASC ")"
 CR
 ASC "  2 - Name.........."
 COLOR ORANGE
 PRSTRING PLRNAME
 COLOR WHITE
 CR
 ASC "  3 - Party name...."
 COLOR AQUAMARINE
 PRSTRING PNNAME
 COLOR WHITE
 CR
 ASC "  4 - Date Created.."
 COLOR GREEN
 DATE PLRMADE
 COLOR WHITE
 CR
 ASC "  5 - Class........."
 COLOR YELLOW
 DEC8 PLRCLASS
 COLOR WHITE
 ASC "="
 COLOR PINK
 PRTABLE PLRCLASS;CLASSTABLE
 COLOR WHITE
 CR
 ASC "  6 - Party........."
 COLOR AQUAMARINE
 DEC8 PLRPARTY
 COLOR WHITE
 CR
 ASC "  7 - X position...."
 COLOR GREEN
 DEC8 PLRXPOS
 COLOR WHITE
 CR
 ASC "  8 - Y position...."
 COLOR GREEN
 DEC8 PLRYPOS
 COLOR WHITE
 CR
 ASC "  9 - Z pos/level..."
 COLOR GREEN
 DEC8 PLRZPOS
 COLOR WHITE
 CR
 ASC " 10 - Strength......"
 COLOR YELLOW
 DEC8 PLRST
 COLOR WHITE
 CR
 ASC " 11 - Dexterity....."
 COLOR YELLOW
 DEC8 PLRDX
 COLOR WHITE
 HTAB 25
 ASC "(speed = "
 COLOR YELLOW
 DEC8 PLRSPEED
 COLOR WHITE
 ASC ")"
 CR
 ASC " 12 - IQ............"
 COLOR YELLOW
 DEC8 PLRIQ
 COLOR WHITE
 CR
 ASC " 13 - Health........"
 COLOR YELLOW
 DEC8 PLRHT
 COLOR WHITE
 CR
 ASC " 14 - HP / Max HP..."
 COLOR PINK
 DEC8NEG PLRHP
 COLOR WHITE
 ASC "/"
 COLOR PINK
 DEC8 PLRHP+1
 COLOR WHITE
 CR
 ASC " 15 - Credits......."
 COLOR PINK
 DEC8 PLRCREDITS
 COLOR WHITE
 CR
 ASC " 16 - Experience...."
 COLOR PINK
 DEC32 PLREXP
 COLOR WHITE
 CR
 ASC " 17 - Level (exp)..."
 COLOR YELLOW
 DEC8 PLRLVLREAL
 COLOR WHITE
 ASC " ("
 COLOR YELLOW
 DEC8 PLRLEVEL
 COLOR WHITE
 ASC ")"
 CR
 ASC " 18 - Condition....."
 COLOR YELLOW
 PRNIBBLE PLRCOND
 COLOR WHITE
 ASC "="
 COLOR AQUAMARINE
 PRCOND PLRCOND
 COLOR WHITE
 GOTOXY 40;4
 ASC " 19 - Money......."
 COLOR YELLOW
 DEC32 PLRGOLD
 COLOR WHITE
 GOTOXY 40;5
 ASC " 20 - Item 1.."
 PAD3 PLRITEM
 ASC "="
 PRITEM PLRITEM
 GOTOXY 40;6
 ASC " 21 - Item 2.."
 PAD3 PLRITEM+1
 ASC "="
 PRITEM PLRITEM+1
 GOTOXY 40;7
 ASC " 22 - Item 3.."
 PAD3 PLRITEM+2
 ASC "="
 PRITEM PLRITEM+2
 GOTOXY 40;8
 ASC " 23 - Item 4.."
 PAD3 PLRITEM+3
 ASC "="
 PRITEM PLRITEM+3
 GOTOXY 40;9
 ASC " 24 - Item 5.."
 PAD3 PLRITEM+4
 ASC "="
 PRITEM PLRITEM+4
 GOTOXY 40;10
 ASC " 25 - Item 6.."
 PAD3 PLRITEM+5
 ASC "="
 PRITEM PLRITEM+5
 GOTOXY 40;11
 ASC " 26 - Item 7.."
 PAD3 PLRITEM+6
 ASC "="
 PRITEM PLRITEM+6
 GOTOXY 40;12
 ASC " 27 - Item 8.."
 PAD3 PLRITEM+7
 ASC "="
 PRITEM PLRITEM+7
 GOTOXY 40;13
 ASC " 28 - Age........."
 COLOR YELLOW
 DEC8 PLRAGE
 COLOR WHITE
 GOTOXY 40;14
 ASC " 29 - AC.........."
 COLOR YELLOW
 DEC8NEG PLRAC
 COLOR WHITE
 GOTOXY 40;15
 ASC " 30 - Points......"
 COLOR PINK
 DEC8NEG PLRCURRPNTS
 COLOR WHITE
 ASC "/"
 COLOR PINK
 DEC8 PLRMAXPNTS
 COLOR WHITE
 GOTOXY 40;16
 ASC " 31 - Magic pnts.."
 COLOR PINK
 DEC8NEG PLRMAGIC
 COLOR WHITE
 ASC "/"
 COLOR PINK
 DEC8 PLRMAGICMAX
 COLOR WHITE
 GOTOXY 40;17
 ASC " 32 - Spells......[?]"
 GOTOXY 40;18
 ASC " 33 - Char killed."
 COLOR PINK
 DEC16 PLRPKILLS
 COLOR WHITE
 ASC "/"
 COLOR PINK
 DEC16 PLRPKILLSMAX
 COLOR WHITE
 GOTOXY 40;19
 ASC " 34 - Char hits..."
 COLOR PINK
 DEC16 PLRPASSAULTS
 COLOR WHITE
 ASC "/"
 COLOR PINK
 DEC16 PLRPASSAULTSMAX
 COLOR WHITE
 GOTOXY 40;20
 ASC " 35 - Extras......[?]"
 COLOR YELLOW
 ASC "  Arr:"
 COLOR WHITE
 PRFLAG PLRARRESTFLAG
 COLOR YELLOW
 ASC "  Jail:"
 COLOR WHITE
 NULL
 STZ VTEMP
 BIT PLRARRESTFLAG
 BVC :CLEAR
 DEC VTEMP
:CLEAR JSR PRINT
 PRFLAG VTEMP
 CURSORON
 NULL
 JMP :DOPOINT
:CHAR DS 2

:CHBACK JSR PRINT
 GOTOXY 0;23
 CLEOS
 NULL
 JSR :DISPLAY
 LDA #$FF
 STA :FLAG
 JMP :BOT

:ADD JSR PRINT
 GOTOXY 0;23
 CLEOS
 ASC "Add - [N]ext free one, [E]nd of file, [ESC] Exit : "
 NULL
]LOOP JSR KEYIN
 JSR UPPER
 CMP #$9B
 BEQL :BOT
 CMP #"N"
 BEQ :ANEXT
 CMP #"E"
 BNE ]LOOP
 JSR COUT
:AEND LDX #0
 LDA #0
 JSR LOADPLR
 LDA PLRBUFF+1
 CMP #1
 BCC :AEOK
 LDA PLRBUFF
 CMP #$FF
 BCC :AEOK
 JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 COLOR PINK
 ASC "Cannot add any more players. "
 COLOR WHITE
 NULL
 GETRETURN
 JMP :ADD
:AEOK INCR PLRBUFF ;Add 1 to the number of characters
 LDX #0
 LDA #0
 JSR SAVEPLR ;Save it out
 INCR :RECS
 LDA :RECS
 STA :CHAR
 LDA :RECS+1
 STA :CHAR+1
:AGOTIT LDX #0
]LOOP STZ PLRBUFF,X
 INX
 BNE ]LOOP
 JSR :DISPLAY
 JMP :SAVE2
:ANEXT JSR COUT
 LDX :CHAR
 LDY :CHAR+1
 STX :CHARN
 STY :CHARN+1
 LDA :RECS
 BNE :NXTOK
 LDA :RECS+1
 BEQL :AEND
:NXTOK
]LOOP LDA :CHARN+1
 CMP :RECS+1
 BCC :NRNGOK
 LDA :CHARN
 CMP :RECS
 BEQ :NRNGOK
 BCSL :AEND
:NRNGOK LDX :CHARN
 LDA :CHARN+1
 JSR LOADPLR
 INCR :CHARN
 LDA PLRFREE
 BPL ]LOOP
 DECR :CHARN
 LDA :CHARN
 STA :CHAR
 LDA :CHARN+1
 STA :CHAR+1
 JMP :AGOTIT
:CHARN DS 2

:FREE LDX #1
 LDY #1
 JSR ASK
 GETLINE #1
 CPX #0
 BEQL :CHBACK
 LDA $200
 CMP #"1"
 BEQ :A1
 CMP #"0"
 BNE :FREE
 LDA #0
 HEX 2C
:A1 LDA #$FF
 STA PLRFREE
 JMP :CHBACK

:NAME LDX #2
 LDY #2
 JSR ASK
 GETLINE #20
 CPX #0
 BEQ :NWRTS
 STX PLRNAME
]LOOP LDA $200-1,X
 STA PLRNAME,X
 DEX
 BNE ]LOOP
:NWRTS JMP :CHBACK

:PNAME JSR PRINT
 GOTOXY 0;23
 CLEOS
 COLOR PINK
 ASC "Can only be changed in PN Editor. "
 COLOR WHITE
 NULL
 GETRETURN
 JMP :CHBACK

:DATECR LDX #3
 LDY #4
 JSR ASK
 GETLINE #6
 CPX #6
 BNE :DCRTS
 LDX #3
]LOOP LDA $200+2,X
 STA :DENTRY,X
 DEX
 BPL ]LOOP
 LDA #$8D
 STA $202
 LDX #2
 JSR GETNUM
 STX :DDAY
 LDA :DENTRY
 STA $200
 LDA :DENTRY+1
 STA $201
 LDX #2
 JSR GETNUM
 STX :DMONTH
 LDA :DENTRY+2
 STA $200
 LDA :DENTRY+3
 STA $201
 LDX #2
 JSR GETNUM
 STX :DYEAR
 LDA :DMONTH
 ASL
 ASL
 ASL
 ASL
 ASL
 ROL :DYEAR
 ORA :DDAY
 STA PLRMADE
 LDA :DYEAR
 STA PLRMADE+1
:DCRTS JMP :CHBACK

:CLASS LDX #5
 LDY #5
 JSR ASK
 GETLINE #3
 CPX #0
 BEQ :CLRTS
 JSR GETNUM
 DEX
 CPX #9
 BCS :CLRTS
 INX
 STX PLRCLASS
:CLRTS JMP :CHBACK

:PARTY LDX #5
 LDY #6
 JSR ASK
 GETLINE #5
 CPX #0
 BEQ :PYRTS
 JSR GETNUM
 DEX
 CPX TOTPRTY
 BCS :PYRTS
 INX
 STX PLRPARTY
:PYRTS JMP :CHBACK

:XPOS LDX #5
 LDY #7
 JSR ASK
 GETLINE #3
 CPX #0
 BEQ :XRTS
 JSR GETNUM
 CPX #$10
 BCS :XRTS
 STX PLRXPOS
:XRTS JMP :CHBACK

:YPOS LDX #5
 LDY #8
 JSR ASK
 GETLINE #3
 CPX #0
 BEQ :YRTS
 JSR GETNUM
 CPX #$10
 BCS :YRTS
 STX PLRYPOS
:YRTS JMP :CHBACK

:ZPOS LDX #5
 LDY #9
 JSR ASK
 GETLINE #3
 CPX #0
 BEQ :ZRTS
 JSR GETNUM
 CPX #17
 BCS :ZRTS
 STX PLRZPOS
:ZRTS JMP :CHBACK

:ST LDX #5
 LDY #10
 JSR ASK
 GETLINE #3
 CPX #0
 BEQ :STRTS
 JSR GETNUM
 CPX #21
 BCS :STRTS
 STX PLRST
:STRTS JMP :CHBACK

:DX LDX #5
 LDY #11
 JSR ASK
 GETLINE #3
 CPX #0
 BEQ :DXRTS
 JSR GETNUM
 CPX #21
 BCS :DXRTS
 STX PLRDX
:DXRTS JMP :CHBACK

:IQ LDX #5
 LDY #12
 JSR ASK
 GETLINE #3
 CPX #0
 BEQ :IQRTS
 JSR GETNUM
 CPX #21
 BCS :IQRTS
 STX PLRIQ
:IQRTS JMP :CHBACK

:HT LDX #5
 LDY #13
 JSR ASK
 GETLINE #3
 CPX #0
 BEQ :HTRTS
 JSR GETNUM
 CPX #21
 BCS :HTRTS
 STX PLRHT
:HTRTS JMP :CHBACK

:HP LDX #5
 LDY #14
 JSR ASK
 GETLINE #3
 CPX #0
 BEQ :HP2
 JSR GETNUM
 STX PLRHP
:HP2 LDX #5
 LDY #14
 JSR ASK
 GETLINE #3
 CPX #0
 BEQ :HPRTS
 JSR GETNUM
 CPX #128
 BCS :HPRTS
 STX PLRHP+1
:HPRTS JMP :CHBACK

:CREDITS LDX #5
 LDY #15
 JSR ASK
 GETLINE #3
 CPX #0
 BEQ :CDRTS
 JSR GETNUM
 STX PLRCREDITS
:CDRTS JMP :CHBACK

:EXP LDX #5
 LDY #16
 JSR ASK
 GETLINE #10
 CPX #0
 BEQ :EXRTS
 JSR GETNUM
 STX PLREXP
 STY PLREXP+1
 LDA VTEMP
 STA PLREXP+2
 LDA VTEMP+1
 STA PLREXP+3
:EXRTS JMP :CHBACK

:LEVEL LDX #5
 LDY #17
 JSR ASK
 GETLINE #3
 CPX #0
 BEQ :LVRTS
 JSR GETNUM
 STX PLRLVLREAL
:LVRTS JMP :CHBACK

:COND LDX #6
 LDY #18
 JSR ASK
 GETLINE #8
 CPX #0
 BEQ :COND2
 JSR GETNIBBLE
 STX PLRCOND
:COND2 LDA #$80
 STA :ANDX
 LDA PLRCOND
 LDX #7
]LOOP PHA
 STX TEMP
 AND :ANDX
 CMP #0
 BEQ :NXTC
 LDX #5
 LDY #18
 JSR ASK
 JSR PRINT
 CURSORLEFT
 CURSORLEFT
 ASC "bit = "
 DEC8 TEMP
 ASC " : "
 NULL
 GETLINE #3
 CPX #0
 BEQ :NXTC
 JSR GETNUM
 TXA
 LDX TEMP
 STA PLRCONDX,X
:NXTC DEC TEMP
 LSR :ANDX
 PLA
 LDX TEMP
 CPX #$FF
 BNE ]LOOP
 JMP :CHBACK
:ANDX DS 1

:GOLD LDX #5
 LDY #19
 JSR ASK
 GETLINE #10
 CPX #0
 BEQ :GRTS
 JSR GETNUM
 STX PLRGOLD
 STY PLRGOLD+1
 LDA VTEMP
 STA PLRGOLD+2
 LDA VTEMP+1
 STA PLRGOLD+3
:GRTS JMP :CHBACK

:ITEM1 LDX #5
 LDY #20
 LDA #1
 JSR EQUIP
 STA PLRITEMX
 JSR ASK
 GETLINE #3
 CPX #0
 BEQ :I1RTS
 JSR GETNUM
 DEX
 CPX TOTITEMS
 BCS :I1RTS
 INX
 STX PLRITEM
:I1RTS JMP :CHBACK

:ITEM2 LDX #5
 LDY #21
 LDA #2
 JSR EQUIP
 STA PLRITEMX+1
 JSR ASK
 GETLINE #3
 CPX #0
 BEQ :I2RTS
 JSR GETNUM
 DEX
 CPX TOTITEMS
 BCS :I2RTS
 INX
 STX PLRITEM+1
:I2RTS JMP :CHBACK

:ITEM3 LDX #5
 LDY #22
 LDA #3
 JSR EQUIP
 STA PLRITEMX+2
 JSR ASK
 GETLINE #3
 CPX #0
 BEQ :I3RTS
 JSR GETNUM
 DEX
 CPX TOTITEMS
 BCS :I3RTS
 INX
 STX PLRITEM+2
:I3RTS JMP :CHBACK

:ITEM4 LDX #5
 LDY #23
 LDA #4
 JSR EQUIP
 STA PLRITEMX+3
 JSR ASK
 GETLINE #3
 CPX #0
 BEQ :I4RTS
 JSR GETNUM
 DEX
 CPX TOTITEMS
 BCS :I4RTS
 INX
 STX PLRITEM+3
:I4RTS JMP :CHBACK

:ITEM5 LDX #5
 LDY #24
 LDA #5
 JSR EQUIP
 STA PLRITEMX+4
 JSR ASK
 GETLINE #3
 CPX #0
 BEQ :I5RTS
 JSR GETNUM
 DEX
 CPX TOTITEMS
 BCS :I5RTS
 INX
 STX PLRITEM+4
:I5RTS JMP :CHBACK

:ITEM6 LDX #5
 LDY #25
 LDA #6
 JSR EQUIP
 STA PLRITEMX+5
 JSR ASK
 GETLINE #3
 CPX #0
 BEQ :I6RTS
 JSR GETNUM
 DEX
 CPX TOTITEMS
 BCS :I6RTS
 INX
 STX PLRITEM+5
:I6RTS JMP :CHBACK

:ITEM7 LDX #5
 LDY #26
 LDA #7
 JSR EQUIP
 STA PLRITEMX+6
 JSR ASK
 GETLINE #3
 CPX #0
 BEQ :I7RTS
 JSR GETNUM
 DEX
 CPX TOTITEMS
 BCS :I7RTS
 INX
 STX PLRITEM+6
:I7RTS JMP :CHBACK

:ITEM8 LDX #5
 LDY #27
 LDA #8
 JSR EQUIP
 STA PLRITEMX+7
 JSR ASK
 GETLINE #3
 CPX #0
 BEQ :I8RTS
 JSR GETNUM
 DEX
 CPX TOTITEMS
 BCS :I8RTS
 INX
 STX PLRITEM+7
:I8RTS JMP :CHBACK

:AGE LDX #5
 LDY #28
 JSR ASK
 GETLINE #3
 CPX #0
 BEQ :AGRTS
 JSR GETNUM
 STX PLRAGE
:AGRTS JMP :CHBACK

:APNTS LDX #5
 LDY #30
 JSR ASK
 GETLINE #3
 CPX #0
 BEQ :CPRTS
 JSR GETNUM
 STX PLRCURRPNTS
:CPRTS LDX #5
 LDY #30
 JSR ASK
 GETLINE #3
 CPX #0
 BEQ :MPRTS
 JSR GETNUM
 STX PLRMAXPNTS
:MPRTS JMP :CHBACK

:MAGIC LDX #5
 LDY #31
 JSR ASK
 GETLINE #3
 CPX #0
 BEQ :MAGICMAX
 JSR GETNUM
 STX PLRMAGIC
:MAGICMAX LDX #5
 LDY #31
 JSR ASK
 GETLINE #3
 CPX #0
 BEQ :MGRTS
 JSR GETNUM
 STX PLRMAGICMAX
:MGRTS JMP :CHBACK

:PKILLS LDX #5
 LDY #33
 JSR ASK
 GETLINE #5
 CPX #0
 BEQ :PKILLS2
 JSR GETNUM
 STX PLRPKILLS
 STY PLRPKILLS+1
:PKILLS2 LDX #5
 LDY #33
 JSR ASK
 GETLINE #5
 CPX #0
 BEQ :PKRTS
 JSR GETNUM
 STX PLRPKILLSMAX
 STY PLRPKILLSMAX+1
:PKRTS JMP :CHBACK

:HITS LDX #5
 LDY #34
 JSR ASK
 GETLINE #5
 CPX #0
 BEQ :HITS2
 JSR GETNUM
 STX PLRPASSAULTS
 STY PLRPASSAULTS+1
:HITS2 LDX #5
 LDY #34
 JSR ASK
 GETLINE #5
 CPX #0
 BEQ :HRTS
 JSR GETNUM
 STX PLRPASSAULTSMAX
 STY PLRPASSAULTSMAX+1
:HRTS JMP :CHBACK

:JAILS JSR PRINT
 GOTOXY 0;4
 CLEOS
 ASC "1) Arrested?............"
 PRFLAG PLRARRESTFLAG
 CR
 ASC "2) Times in jail........"
 COLOR YELLOW
 DEC16 PLRJAILED
 COLOR WHITE
 CR
 ASC "3) In jail?............."
 NULL
 LDA PLRARRESTFLAG
 ASL
 STA VTEMP
 JSR PRINT
 PRFLAG VTEMP
 CR
 ASC "4) Days left in jail...."
 COLOR YELLOW
 DEC8 PLRJAILDAYS
 COLOR WHITE
 CR
 ASC "5) Comment.............."
 COLOR AQUAMARINE
 PRSTRING PLRQUOTE
 COLOR WHITE
 CR
 ASC "6) Scenario............."
 COLOR YELLOW
 DEC8 PLRSCENARIO
 COLOR WHITE
 CR
 CR
 ASC "Select an option : "
 NULL
]LOOP JSR KEYIN
 CMP #$9B
 BEQL :CHBACK
 SEC
 SBC #"1"
 CMP #6
 BCS ]LOOP
 PHA
 INC
 STA VTEMP
 JSR PRINT
 DEC8 VTEMP
 NULL
 PLA
 ASL
 TAX
 JMP (:EDITS2,X)

:EDITS2 DA :2ARR
 DA :2JTIMES
 DA :2JAIL
 DA :2JDAYS
 DA :2QUOTE
 DA :2SCEN

:2ARR LDX #1
 LDY #1
 JSR ASK
 GETLINE #1
 CPX #0
 BEQL :JAILS
 LDA $200
 CMP #"1"
 BEQ :JA1
 CMP #"0"
 BNEL :JAILS
 LDA #%1000_0000
 TRB PLRARRESTFLAG
 JMP :JAILS
:JA1 LDA #%1000_0000
 TSB PLRARRESTFLAG
 JMP :JAILS

:2JAIL LDX #1
 LDY #2
 JSR ASK
 GETLINE #1
 CPX #0
 BEQL :JAILS
 LDA $200
 CMP #"1"
 BEQ :JA2
 CMP #"0"
 BNEL :JAILS
 LDA #%0100_0000
 TRB PLRARRESTFLAG
 JMP :JAILS
:JA2 LDA #%0100_0000
 TSB PLRARRESTFLAG
 JMP :JAILS

:2JTIMES LDX #5
 LDY #3
 JSR ASK
 GETLINE #5
 CPX #0
 BEQL :JAILS
 JSR GETNUM
 STX PLRJAILED
 STY PLRJAILED+1
 JMP :JAILS

:2JDAYS LDX #5
 LDY #4
 JSR ASK
 GETLINE #3
 CPX #0
 BEQL :JAILS
 JSR GETNUM
 STX PLRJAILDAYS
 JMP :JAILS

:2QUOTE LDX #2
 LDY #5
 JSR ASK
 GETLINE #40
 STX PLRQUOTE
 CPX #0
 BEQL :JAILS
]LOOP LDA $200-1,X
 STA PLRQUOTE,X
 DEX
 BNE ]LOOP
 JMP :JAILS

:2SCEN LDX #5
 LDY #6
 JSR ASK
 GETLINE #1
 CPX #0
 BEQL :JAILS
 JSR GETNUM
 STX PLRSCENARIO
 JMP :JAILS

:AC
 JSR PRINT
 GOTOXY 0;23
 CLEOS
 COLOR PINK
 ASC "This field is calculated and cannot be changed. "
 COLOR WHITE
 NULL
 GETRETURN
 JMP :CHBACK

:RECS DS 2
:FLAG DS 1
:DDAY DS 1
:DMONTH DS 1
:DYEAR DS 1
:DENTRY DS 9

:SPELLED JSR PRINT
 CURSORON
 GOTOXY 0;4
 CLEOS
 NULL
 JSR :PRWIZ
 JSR :PRCLE
 JSR :PRSAG
 JSR PRINT
 CR
 ASC "[W]izard, [C]leric, [S]age, [ESC]-exit : "
 NULL

]LOOP JSR KEYIN
 JSR UPPER
 CMP #"W"
 BEQ :WIZ
 CMP #"C"
 BEQ :CLE
 CMP #"S"
 BEQ :SAG
 CMP #$9B
 BNE ]LOOP
 JSR PRINT
 GOTOXY 0;4
 CLEOS
 NULL
 JMP :CHBACK
:WIZ LDX #1
 HEX 2C
:CLE LDX #2
 HEX 2C
:SAG LDX #3
 STX :SPELLCL
 JSR COUT

 LDX :SPELLCL
 LDA #0
]LOOP DEX
 CPX #0
 BEQ :SHOWSP
 CLC
 ADC #32 ;32 spells per class
 BRA ]LOOP
:SHOWSP INC
 STA :CNTR

 JSR PRINT
 GOTOXY 0;4
 CLEOS
 NULL
 LDA :SPELLCL
 CMP #1
 BNE :ZX2
 JSR :PRWIZ
 BRA :SPGO
:ZX2 CMP #2
 BNE :ZX3
 JSR :PRCLE
 BRA :SPGO
:ZX3 CMP #3
 BNE :ZX4
 JSR :PRSAG
 BRA :SPGO
:ZX4 DEATH

:SPGO LDA #1
 STA :CNTR2

]LOOP LDA :CNTR2
 CMP #17
 BCC :SPL
 BNE :SPR
 JSR PRINT
 VTAB 5
 NULL
:SPR JSR PRINT
 CR
 HTAB 40
 NULL
 BRA :SPRL
:SPL JSR PRINT
 CR
 NULL
:SPRL LDA :CNTR2
 DEC
 AND #%0000_0011
 BNE :NONUM
 LDA :CNTR2
 DEC
 LSR
 LSR
 INC
 ORA #"0"
 HEX 2C
:NONUM LDA #" "
 JSR COUT
 JSR PRINT
 ASC "  "
 NULL
 LDX :CNTR
 LDA :CNTR+1
 JSR LOADSPELL
 LDA :SPELLCL ;Class of spell
 LDX :CNTR2 ;Spell number in this class
 JSR KNOWNSP ;Do we know this spell?
 BCC :NOSPELL
 JSR PRINT
 MTON
 INVERSE
 ASC "D"
 NORMAL
 MTOFF
 NULL
 BRA :SP2
:NOSPELL JSR PRINT
 ASC " "
 NULL
:SP2 JSR PRINT
 ASC ".."
 PRSTRING SPNAME
 NULL
 INC :CNTR
 INC :CNTR2
 LDA :CNTR2
 CMP #33
 BNEL ]LOOP
 JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 COLOR YELLOW
 ASC "Arrow keys move cursor, [SPACE]-toggle known/unknown, "
 ASC "[ESC]-exit"
 COLOR WHITE
 CURSOROFF
 NULL

 LDA #1
 STA :CNTR2

]LOOP LDA :CNTR2
 CLC
 ADC #5
 STA :SPHV+3
 LDA #3
 STA :SPHV+2
 LDA :CNTR2
 CMP #17
 BCC :SPL2
 LDA :CNTR2
 SEC
 SBC #11
 STA :SPHV+3
 LDA #43
 STA :SPHV+2
:SPL2 JSR PRINT
:SPHV GOTOXY 0;0
 NULL
 LDA :SPELLCL ;Class of spell
 LDX :CNTR2 ;Spell number in this class
 JSR KNOWNSP ;Do we know this spell?
 BCC :NOPE
 JSR PRINT
 MTON
 INVERSE
 ASC "E"
 NORMAL
 MTOFF
 NULL
 BRA :KEYSP
:NOPE JSR PRINT
 INVERSE
 ASC " "
 NORMAL
 NULL
:KEYSP JSR KEYIN
 CMP #$9B
 BEQL :SPELLED
 CMP #"J"-$40
 BEQ :SPDOWN
 CMP #"K"-$40
 BEQ :SPUP
 CMP #" "
 BNE :KEYSP
 LDA :SPELLCL ;Class of spell
 LDX :CNTR2 ;Spell number in this class
 JSR KNOWNSP
 BCC :NOPE2
 LDY #0
 HEX 2C
:NOPE2 LDY #1
 LDA :SPELLCL ;Class of spell
 JSR ALTERSP
 JMP ]LOOP

:COFF LDA :SPELLCL ;Class of spell
 LDX :CNTR2 ;Spell number in this class
 JSR KNOWNSP
 BCC :SPCNO
 JSR PRINT
 CURSORLEFT
 MTON
 INVERSE
 ASC "D"
 NORMAL
 MTOFF
 NULL
 RTS
:SPCNO JSR PRINT
 CURSORLEFT
 ASC " "
 NULL
 RTS

:SPDOWN JSR :COFF
 LDA :CNTR2
 CMP #32
 BCC :SPDOK
 LDA #0
:SPDOK INC
 STA :CNTR2
 JMP ]LOOP

:SPUP JSR :COFF
 LDA :CNTR2
 CMP #1
 BNE :SPUOK
 LDA #33
:SPUOK DEC
 STA :CNTR2
 JMP ]LOOP

:PRWIZ JSR PRINT
 ASC "Wizard - "
 PRNIBBLE PLRSPELWIZ
 ASC "  "
 PRNIBBLE PLRSPELWIZ+1
 ASC "  "
 PRNIBBLE PLRSPELWIZ+2
 ASC "  "
 PRNIBBLE PLRSPELWIZ+3
 CR
 NULL
 RTS

:PRCLE JSR PRINT
 ASC "Cleric - "
 PRNIBBLE PLRSPELCLE
 ASC "  "
 PRNIBBLE PLRSPELCLE+1
 ASC "  "
 PRNIBBLE PLRSPELCLE+2
 ASC "  "
 PRNIBBLE PLRSPELCLE+3
 CR
 NULL
 RTS

:PRSAG JSR PRINT
 ASC "Sage   - "
 PRNIBBLE PLRSPELSAG
 ASC "  "
 PRNIBBLE PLRSPELSAG+1
 ASC "  "
 PRNIBBLE PLRSPELSAG+2
 ASC "  "
 PRNIBBLE PLRSPELSAG+3
 CR
 NULL
 RTS

:SPELLCL DS 1
:CNTR DS 2
:CNTR2 DS 1

EQUIP PHX
 PHY
 PHA
 STY TEMP
 JSR PRINT
 GOTOXY 0;23
 CLEOS
 ASC "0=not equipped, 1=equiped, 2=unusable, 3=cursed, 4=unknown : "
 NULL
 GETLINE #1
 CPX #0
 BEQ :DONT
 JSR GETNUM
 PLA
 TXA
 BRA :RTS
:DONT PLX
 LDA PLRITEMX-1,X
:RTS PLY
 PLX
 RTS

EXIT JSR PRINT
 NORMAL
 MTOFF
 HOME
 NULL
 LDA SCENARIO
 PHA
 LDX #0
 LDA #0
 JSR LOADSCEN
 LDA SCENBUFF
 STA :TOTSCEN
 STZ SCENARIO
]LOOP LDX SCENARIO
 CPX :TOTSCEN
 BEQ :DONE
 INC SCENARIO
 LDA SCUPDATE,X
 BEQ ]LOOP
 JSR PRINT
 COLOR AQUAMARINE
 ASC "Reclaiming"
 COLOR WHITE
 ASC " (scenario #"
 COLOR YELLOW
 DEC8 SCENARIO
 COLOR WHITE
 ASC ").."
 NULL
 JSR RECLAIM
 JSR PRINT
 CR
 CR
 NULL
 BRA ]LOOP
:DONE PLA
 STA SCENARIO
 RETURN
:TOTSCEN DS 1

TEMP DS 2
TOTPRTY DS 1
TOTITEMS DS 1

SCUPDATE DS 9

 LST ON
MODEND EQU *
 LST OFF

 do M16PLUS
 SAV RUN/MODULES/PLR.EDITOR
 fin

 END
