*-------------------------------
* PN.EDITOR
*-------------------------------
 DAT
 LST OFF

 ORG $8000 ;Always

 USE MACROS
 USE EQUATES
 USE VARS
 USE LIB.JMP
 USE TABLES
 USE PN.DSECT
 USE PLR.DSECT

 TYP $F4
 do M16PLUS-1
 DSK RUN/MODULES/PN.EDITOR
 fin

NUMPN = 12

 MODID "PN.EDITOR"

START JSR PRINT
 HOME
 BOX "Party Names Editor"
 NULL

 LDX #0
 JSR LOADPNAME
 LDA PNBUFF
 STA NUMPARTIES
 JMP :FORW1

:BOT JSR PRINT
 GOTOXY 1;1
 ASC "Total in file : "
 COLOR YELLOW
 DEC8 NUMPARTIES
 COLOR WHITE
 GOTOXY 0;23
 CLEOS
 ASC "[A]dd, [J]ump, [S]ave, [L]ist, [RETURN]-edit, "
 MTON
 INVERSE
 ASC "H"
 NORMAL
 ASC ", "
 INVERSE
 ASC "U"
 NORMAL
 MTOFF
 ASC ", [H]elp, [P], [Q]uit : "
 CURSORON
 NULL
 LDA CH
 STA :BGOTO+2
:GETKEY JSR PRINT
:BGOTO GOTOXY 0;23
 NULL
]LOOP JSR KEYIN
 JSR UPPER
 LDX :KEYS
]LOOP2 CMP :KEYS,X
 BEQ :GOTONE
 DEX
 BNE ]LOOP2
 JMP ]LOOP
:GOTONE DEX
 TXA
 ASL
 TAX
 JMP (:TABLE,X)

:KEYS DFB :ENDKEYS-*-1
 DFB "Q"
 DFB "A"
 DFB "L"
 DFB "J"
 DFB "S"
 DFB "H"-$40
 DFB "U"-$40
 DFB "K"-$40
 DFB "J"-$40
 DFB "M"-$40
 DFB "H"
 DFB "P"
:ENDKEYS

:TABLE DA EXIT
 DA :ADD
 DA :LIST
 DA :LOAD
 DA :SAVE
 DA :BACK1
 DA :FORW1
 DA :UP
 DA :DOWN
 DA :EDIT
 DA :HELP
 DA :PLIST

:PLIST LDA NUMPARTIES
 BEQL :BOT
 JSR PRINT
 GOTOXY 0;4
 CLEOS
 CURSORON
 ASC "Players in party #"
 COLOR YELLOW
 DEC8 :PN
 COLOR WHITE
 CR
 CR
 NULL
 LDX #0
 LDA #0
 JSR LOADPLR
 LDA PLRBUFF
 STA :RECS
 LDA PLRBUFF+1
 STA :RECS+1
 STZ :REC
 STZ :REC+1
]LOOP LDA :REC+1
 CMP :RECS+1
 BNE :PLOK
 LDA :REC
 CMP :RECS
 BEQ :PLDONE
:PLOK INCR :REC
 LDX :REC
 LDA :REC+1
 JSR LOADPLR
 BIT PLRFREE
 BMI ]LOOP
 LDA PLRPARTY
 CMP :PN
 BNE ]LOOP
 JSR PRINT
 DEC16 :REC
 ASC ")"
 HTAB 8
 PRSTRING PLRNAME
 CR
 NULL
 BRA ]LOOP
:PLDONE JSR PRINT
 GOTOXY 0;23
 COLOR PINK
 NULL
 GETRETURN
 JSR PRINT
 COLOR WHITE
 GOTOXY 0;4
 CLEOS
 NULL
 JMP :PNBACK
:REC DS 2
:RECS DS 2

:HELP JSR PRINT
 GOTOXY 0;4
 CLEOS
 NULL
 JSR GETFILE
 DFB 4,22 ;Use lines x to y
 STR "HELP/PN.ED"
 JSR PRINT
 GOTOXY 0;23
 COLOR PINK
 NULL
 GETRETURN
 JSR PRINT
 GOTOXY 0;4
 COLOR WHITE
 CLEOS
 NULL
 JMP :PNBACK

:DOPOINT LDA :OLDPNTR
 CMP #19
 BCC :PLEFT
 LDA #40
 STA :CH+2
 LDA :OLDPNTR
 SEC
 SBC #15
 STA :CV+2
 BRA :DOP1
:PLEFT STZ :CH+2
 LDA :OLDPNTR
 CLC
 ADC #3
 STA :CV+2
:DOP1 JSR PRINT
 NORMAL
 MTOFF
:CH HTAB 0
:CV VTAB 0
 ASC " "
 NULL
 LDA :PNTR
 CMP #19
 BCC :PLEFT2
 LDA #40
 STA :CH2+2
 LDA :PNTR
 SEC
 SBC #15
 STA :CV2+2
 BRA :DOP2
:PLEFT2 STZ :CH2+2
 LDA :PNTR
 CLC
 ADC #3
 STA :CV2+2
:DOP2 JSR PRINT
:CH2 HTAB 0
:CV2 VTAB 0
 NULL
 JSR SHOWPNTR
 LDA :PNTR
 STA :OLDPNTR
 RTS
:OLDPNTR DFB 1
:PNTR DFB 1

:UP LDA NUMPARTIES
 BEQL :BOT
 LDA :PNTR
 CMP #1
 BNE :UPOK
 LDA #NUMPN+1
:UPOK DEC
 STA :PNTR
 JSR :DOPOINT
 JMP :GETKEY

:DOWN LDA NUMPARTIES
 BEQL :BOT
 LDA :PNTR
 CMP #NUMPN
 BNE :DNOK
 LDA #0
:DNOK INC
 STA :PNTR
 JSR :DOPOINT
 JMP :GETKEY

:EDIT LDA NUMPARTIES
 BEQL :BOT
 LDA :PNTR
 DEC
 ASL
 TAX
 JMP (:EDITS,X)

:EDITS DA :FREE
 DA :NAME
 DA :PASS
 DA :LASTON
 DA :CALLS
 DA :EXP
 DA :CREDITS
 DA :BGMUSIC
 DA :SOUND
 DA :QUOTE
 DA :INSCEN
 DA :SERIAL

:LOAD LDA NUMPARTIES
 BEQL :BOT
 JSR PRINT
 GOTOXY 0;23
 CLEOS
 ASC "Jump to party name #"
 CURSORON
 NULL
 GETLINE #5
 JSR GETNUM
 CPX #0
 BNE :LOK
:LOK CPX NUMPARTIES
 BEQ :RNGOK
 BCC :RNGOK
 JSR PRINT
 COLOR PINK
 ASC " No such party name. "
 COLOR WHITE
 NULL
 GETRETURN
 JMP :BOT
:RNGOK STX :PN
 JSR LOADPNAME
 JSR :DISPLAY
 STZ :FLAG
 JMP :BOT

:SAVE LDA NUMPARTIES
 BEQL :BOT
 BIT :FLAG
 BPLL :GETKEY
:SAVE2 LDX :PN
 JSR SAVEPNAME
 STZ :FLAG
 JMP :BOT

:BACK1 LDA NUMPARTIES
 BEQL :BOT
 LDA :PN
 CMP #2
 BCS :GOB
 JMP :BOT
:GOB DEC :PN
 LDX :PN
 JMP :LOK

:FORW1 LDA NUMPARTIES
 BEQL :BOT
 LDA :PN
 CMP NUMPARTIES
 BCC :GOF
 JMP :BOT
:GOF INC :PN
 LDX :PN
 JMP :LOK

:LIST LDA NUMPARTIES
 BEQL :BOT
 JSR PRINT
 GOTOXY 0;23
 CLEOS
 ASC "Start from party name #1"
 CURSORLEFT
 NULL
 LDA PADFLAG
 STA TEMP
 LDA #$FF
 STA PADFLAG
 LDA PADCHAR
 STA TEMP+1
 LDA #" "
 STA PADCHAR
 LDA #1
 STA :TOREAD
 GETLINE #5
 BCSL :LEXIT
 CPX #0
 BEQ :FROM1
 JSR GETNUM
 STX :TOREAD
:FROM1 LDA :TOREAD
 CMP NUMPARTIES
 BCC :VGO
 BEQ :VGO
 JSR PRINT
 ASC " - "
 COLOR PINK
 ASC "Last party name is #"
 COLOR YELLOW
 DEC8 NUMPARTIES
 COLOR PINK
 ASC ". "
 COLOR WHITE
 NULL
 GETRETURN
 JSR PRINT
 ZAPLINE
 NULL
 JMP :LEXIT
:VGO LDA :TOREAD
 STA :PNCNTR
 JSR PRINT
 GOTOXY 0;3
 CLEOS
 CR
 COLOR AQUAMARINE
 NULL
 BIT $C062
 BMI :OPTION
 JSR PRINT
 ASC "Party/ ?/ Name               / Password / Last call/ Calls"
 LINE " / Experience/ Scen"
 COLOR WHITE
 CURSOROFF
 NULL
 LDA #0
 BRA :LGOGO
:OPTION JSR PRINT
 LINE "Party/ ?/ Name               / Comment"
 CURSOROFF
 NULL
 LDA #$FF
:LGOGO STA :LFLAG
]LOOP LDA :PNCNTR
 CMP NUMPARTIES
 BCC :RREAD
 BEQ :RREAD
 JMP :RDONE
:RREAD LDX :TOREAD
 JSR LOADPNAME
 INC :TOREAD
 BIT $C061
 BPL :LSHOW
 BIT PNFREE
 BMIL :VOK2
:LSHOW LDA CV
 CMP #21
 BNE :VOK
 JSR PRINT
 CR
 CR
 CURSORON
 COLOR YELLOW
 CENTER "[SPACE]-continue, [ESC]-exit : "
 COLOR WHITE
 NULL
]LOOP3 JSR KEYIN
 CMP #$9B
 BEQL :RESC
 CMP #" "
 BNE ]LOOP3
 JSR PRINT
 GOTOXY 0;5
 CLEOS
 CURSOROFF
 NULL
:VOK JSR PRINT
 CR
 ASC " "
 COLOR YELLOW
 DEC8 :PNCNTR
 COLOR WHITE
 ASC ")  "
 PRFLAG PNFREE
 ASC "  "
 NULL
 BIT :LFLAG
 BPL :NOPT
 JSR PRINT
 COLOR ORANGE
 PRSTRING PNNAME
 COLOR WHITE
 NULL
 LDA PNQUOTE
 BEQL :VOK2
 JSR PRINT
 HTAB 31
 QUOTE
 COLOR YELLOW
 PRSTRING PNQUOTE
 COLOR WHITE
 QUOTE
 NULL
 JMP :VOK2
:NOPT JSR PRINT
 COLOR ORANGE
 NULL
 LDX PNSCENARIO
 LDA LEADPRTY-1,X
 CMP :PNCNTR
 BNE :NOPT2
 JSR PRINT
 COLOR AQUAMARINE
 NULL
:NOPT2 JSR PRINT
 PRSTRING PNNAME
 COLOR WHITE
 HTAB 31
 COLOR AQUAMARINE
 PRSTRING PNPASS
 COLOR WHITE
 HTAB 42
 COLOR GREEN
 DATE PNLASTON
 COLOR WHITE
 ASC " "
 COLOR YELLOW
 DEC16 PNCALLS
 COLOR WHITE
 HTAB 61
 COLOR PINK
 DEC32 PNEXP
 COLOR WHITE
 NULL
 LDA PNCREDITS
 BEQ :VOKX
 JSR PRINT
 COLOR YELLOW
 ASC " *"
 COLOR WHITE
 NULL
:VOKX JSR PRINT
 HTAB 73
 COLOR YELLOW
 DEC8 PNSCENARIO
 COLOR WHITE
 NULL
:VOK2 INC :PNCNTR
 LDA $C000
 BPLL ]LOOP
 STA $C010
 CMP #$9B
 BEQ :RDONE
 JMP ]LOOP
:RESC JSR PRINT
 ZAPLINE
 CURSORON
 NULL
 BRA :RDONE2
:RDONE JSR PRINT
 GOTOXY 0;23
 COLOR PINK
 CURSORON
 NULL
 GETRETURN
 JSR PRINT
 COLOR WHITE
 NULL
:RDONE2 LDA TEMP
 STA PADFLAG
 LDA TEMP+1
 STA PADCHAR
 LDX :PN
 JMP :LOK
:LEXIT LDA TEMP
 STA PADFLAG
 LDA TEMP+1
 STA PADCHAR
 JMP :BOT
:LFLAG DS 1
:PNCNTR DS 1
:TOREAD DA 1

:DISPLAY LDA NUMPARTIES
 BEQL :BOT
 JSR PRINT
 GOTOXY 60;1
 ASC "Party #"
 COLOR YELLOW
 DEC8 :PN
 COLOR WHITE
 ASC " "
 GOTOXY 0;4
 CLEOS
 CURSOROFF
 ASC "  1 - Free..........."
 PRFLAG PNFREE
 CR
 ASC "  2 - Name..........."
 COLOR ORANGE
 PRSTRING PNNAME
 COLOR WHITE
 CR
 ASC "  3 - Password......."
 COLOR AQUAMARINE
 PRSTRING PNPASS
 COLOR WHITE
 CR
 ASC "  4 - Last call......"
 COLOR GREEN
 DATE PNLASTON
 ASC "  "
 TIME PNLASTON+2
 COLOR WHITE
 CR
 ASC "  5 - Calls.........."
 COLOR YELLOW
 DEC16 PNCALLS
 COLOR WHITE
 CR
 ASC "  6 - Experience....."
 COLOR PINK
 DEC32 PNEXP
 COLOR WHITE
 CR
 ASC "  7 - Credits........"
 COLOR AQUAMARINE
 DEC8 PNCREDITS
 COLOR WHITE
 CR
 ASC "  8 - BG music flag.."
 PRFLAG PNSOUNDL
 CR
 ASC "  9 - Sound flag....."
 PRFLAG PNSOUNDS
 CR
 ASC " 10 - Comment........"
 COLOR AQUAMRINE
 PRSTRING PNQUOTE
 COLOR WHITE
 CR
 ASC " 11 - In scenario...."
 COLOR YELLOW
 DEC8 PNSCENARIO
 COLOR WHITE
 CR
 ASC " 12 - Serial no......"
 COLOR AQUAMARINE
 HEX16 PNSERIAL
 COLOR WHITE
 CR
 CURSORON
 NULL
 JMP :DOPOINT
:PN DS 1

:PNBACK JSR PRINT
 GOTOXY 0;23
 CLEOS
 NULL
 JSR :DISPLAY
 LDA #$FF
 STA :FLAG
 JMP :BOT

:ADD JSR PRINT
 GOTOXY 0;23
 CLEOS
 ASC "Add - [N]ext free one, [E]nd of file, [ESC] Exit : "
 NULL
]LOOP JSR KEYIN
 JSR UPPER
 CMP #$9B
 BEQL :BOT
 CMP #"N"
 BEQ :ANEXT
 CMP #"E"
 BNE ]LOOP
 JSR COUT
:AEND LDA NUMPARTIES
 CMP #$FF
 BCC :AEOK
 JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 COLOR PINK
 ASC "Cannot add any more parties. "
 COLOR WHITE
 NULL
 GETRETURN
 JMP :ADD
:AEOK INC NUMPARTIES
 LDX NUMPARTIES
 STX PNBUFF
 STX :PN
 LDX #0
 JSR SAVEPNAME
:AGOTIT LDX #0
]LOOP STZ PNBUFF,X
 INX
 BNE ]LOOP
 JSR :DISPLAY
 JMP :SAVE2
:ANEXT JSR COUT
 LDX :PN
 STX :PNN
]LOOP LDA :PNN
 CMP NUMPARTIES
 BEQ :NRNGOK
 BCSL :AEND
:NRNGOK LDX :PNN
 JSR LOADPNAME
 INC :PNN
 LDA PNFREE
 BPL ]LOOP
 DEC :PNN
 LDA :PNN
 STA :PN
 JMP :AGOTIT
:PNN DS 1

:FREE LDX #1
 LDY #1
 JSR ASK
 GETLINE #1
 CPX #0
 BEQL :PNBACK
 LDA $200
 CMP #"1"
 BEQ :A1
 CMP #"0"
 BNE :FREE
 LDA #0
 HEX 2C
:A1 LDA #$FF
 STA PNFREE
 JMP :PNBACK

:NAME LDX #2
 LDY #2
 JSR ASK
 GETLINE #20
 CPX #0
 BEQ :NWRTS
 STX PNNAME
]LOOP LDA $200-1,X
 STA PNNAME,X
 DEX
 BNE ]LOOP
:NWRTS JMP :PNBACK

:PASS LDX #2
 LDY #3
 JSR ASK
 GETLINE #8
 CPX #0
 BEQ :PRTS
 STX PNPASS
]LOOP LDA $200-1,X
 STA PNPASS,X
 DEX
 BNE ]LOOP
:PRTS JMP :PNBACK

:LASTON LDX #4
 LDY #4
 JSR ASK
 GETLINE #11
 CPX #11
 BNEL :DLRTS
 LDX #8
]LOOP LDA $200+2,X
 STA :DENTRY,X
 DEX
 BPL ]LOOP
 LDA #$8D
 STA $202
 LDX #2
 JSR GETNUM
 STX :DDAY
 LDA :DENTRY
 STA $200
 LDA :DENTRY+1
 STA $201
 LDX #2
 JSR GETNUM
 STX :DMONTH
 LDA :DENTRY+2
 STA $200
 LDA :DENTRY+3
 STA $201
 LDX #2
 JSR GETNUM
 STX :DYEAR
 LDA :DMONTH
 ASL
 ASL
 ASL
 ASL
 ASL
 ROL :DYEAR
 ORA :DDAY
 STA PNLASTON
 LDA :DYEAR
 STA PNLASTON+1
 LDA :DENTRY+5
 STA $200
 LDA :DENTRY+6
 STA $201
 LDX #2
 JSR GETNUM
 STX PNLASTON+3
 LDA :DENTRY+7
 STA $200
 LDA :DENTRY+8
 STA $201
 LDX #2
 JSR GETNUM
 STX PNLASTON+2
:DLRTS JMP :PNBACK

:CALLS LDX #5
 LDY #5
 JSR ASK
 GETLINE #5
 CPX #0
 BEQ :CRTS
 JSR GETNUM
 STX PNCALLS
 STY PNCALLS+1
:CRTS JMP :PNBACK

:EXP LDX #5
 LDY #6
 JSR ASK
 GETLINE #10
 CPX #0
 BEQ :EXRTS
 JSR GETNUM
 STX PNEXP
 STY PNEXP+1
 LDA VTEMP
 STA PNEXP+2
 LDA VTEMP+1
 STA PNEXP+3
:EXRTS JMP :PNBACK

:CREDITS LDX #5
 LDY #7
 JSR ASK
 GETLINE #3
 CPX #0
 BEQ :CDRTS
 JSR GETNUM
 STX PNCREDITS
:CDRTS JMP :PNBACK

:BGMUSIC LDX #1
 LDY #8
 JSR ASK
 GETLINE #1
 CPX #0
 BEQL :PNBACK
 LDA $200
 CMP #"1"
 BEQ :BG1
 CMP #"0"
 BNE :BGMUSIC
 LDA #0
 HEX 2C
:BG1 LDA #$FF
 STA PNSOUNDL
 JMP :PNBACK

:SOUND LDX #1
 LDY #9
 JSR ASK
 GETLINE #1
 CPX #0
 BEQL :PNBACK
 LDA $200
 CMP #"1"
 BEQ :AS1
 CMP #"0"
 BNE :SOUND
 LDA #0
 HEX 2C
:AS1 LDA #$FF
 STA PNSOUNDS
 JMP :PNBACK

:QUOTE LDX #2
 LDY #10
 JSR ASK
 GETLINE #22
 BCS :QRTS
 STX PNQUOTE
 CPX #0
 BEQ :QRTS
]LOOP LDA $200-1,X
 STA PNQUOTE,X
 DEX
 BNE ]LOOP
:QRTS JMP :PNBACK

:INSCEN LDX #5
 LDY #11
 JSR ASK
 GETLINE #1
 CPX #0
 BEQ :ISRTS
 JSR GETNUM
 STX PNSCENARIO
:ISRTS JMP :PNBACK

:SERIAL LDX #5
 LDY #12
 JSR ASK
 GETLINE #5
 CPX #0
 BEQ :SRTS
 JSR GETNUM
 STX PNSERIAL
 STY PNSERIAL+1
:SRTS JMP :PNBACK

:FLAG DS 1
:DDAY DS 1
:DMONTH DS 1
:DYEAR DS 1
:DENTRY DS 9

EXIT JSR PRINT
 NORMAL
 MTOFF
 HOME
 NULL
 RETURN

LOADPNAME LDA #0
 JMP LOADPN

SAVEPNAME LDA #0
 JMP SAVEPN

NUMPARTIES DS 1
TEMP DS 2

 LST ON
MODEND EQU *
 LST OFF

 do M16PLUS
 SAV RUN/MODULES/PN.EDITOR
 fin

 END
