*-------------------------------
* TECHO.INFO
*-------------------------------
 DAT
 LST OFF

 ORG $8000 ;Always

 USE MACROS
 USE EQUATES
 USE VARS
 USE LIB.JMP

 TYP $F4
 do M16PLUS-1
 DSK RUN/MODULES/TECHO.INFO
 fin

 MODID "TECHO.INFO"

ENTRY MAC
HERE STR ]1
 DS HERE-*+]LEN+1
 <<<

START JSR PRINT
 HOME
 CURSORON
 NULL

 JSR $FE1F
 STY ROMVERS

 CLC
 XCE
 REP #$30

 PushLong #0
 Tool $1D02 ;TotalMem
 PullLong TOTMEM

 PushLong #0
 Tool $1B02 ;FreeMem
 PullLong FREEMEM

 PushLong #0
 Tool $1C02 ;MaxBlock
 PullLong MAXBLOCK

 SEC
 XCE

 JSR PRINT
 COLOR AQUAMARINE
 CENTER "Technical Information"
 COLOR WHITE
 CR
 CR
 ASC "Total memory : $"
 COLOR YELLOW
 HEX32 TOTMEM
 COLOR WHITE
 HTAB 40
 ASC "Main UserId : $"
 COLOR YELLOW
 HEX16 USERID
 COLOR WHITE
 CR
 ASC "Free memory  : $"
 COLOR YELLOW
 HEX32 FREEMEM
 COLOR WHITE
 HTAB 40
 ASC "TC appl. Id : $"
 COLOR YELLOW
 HEX16 MYID
 COLOR WHITE
 CR
 ASC "Max. block   : $"
 COLOR YELLOW
 HEX32 MAXBLOCK
 COLOR WHITE
 CR
 CR
 ASC "ROM version  : $"
 COLOR PINK
 HEX8 ROMVERS
 COLOR WHITE
 CR
 CR
 COLOR GREEN
 LINE "#   Handle    Address  Size      Contents"
 COLOR WHITE
 MTON
 INVERSE
 ASC "L"
 NORMAL
 ASC "   "
 INVERSE
 ASC "LLLLLL"
 NORMAL
 ASC "    "
 INVERSE
 ASC "LLLLLLL"
 NORMAL
 ASC "  "
 INVERSE
 ASC "LLLL"
 NORMAL
 ASC "      "
 INVERSE
 LINE "LLLLLLLL"
 NORMAL
 MTOFF
 NULL

 CLC
 XCE
 REP #$30

 LDX #0
]LOOP STX VTEMP
 TXA
 ASL
 ASL
 TAX
 LDA HANDLES,X
 STA HNDL
 STA CADD
 LDA HANDLES+2,X
 STA HNDL+2
 STA CADD+2
 LDY #0
 LDA [CADD],Y
 STA ADDR
 INY
 LDA [CADD],Y
 STA ADDR+2
 PushLong #0
 PushLong HNDL
 Tool $1802 ;GetHandleSize
 JSR ERROR
 PullLong HNDLSIZE
 SEC
 XCE
 INC VTEMP
 JSR PRINT
 PAD2 VTEMP
 ASC "  "
 HEX32 HNDL
 ASC "  "
 HEX8 ADDR+3
 ASC "/"
 HEX16 ADDR
 ASC "  "
 HEX32 HNDLSIZE
 ASC "  "
 PRTABLE VTEMP;MEMTBL
 CR
 NULL
 CLC
 XCE
 REP #$30
 LDA TOTMEMALLOC
 CLC
 ADC HNDLSIZE
 STA TOTMEMALLOC
 LDA TOTMEMALLOC+2
 ADC HNDLSIZE+2
 STA TOTMEMALLOC+2
 LDX VTEMP
 CPX #NUMFILES
 BNEL ]LOOP

 LDA TOTMEMALLOC+1
 LSR
 LSR
 STA VTEMP

 SEC
 XCE

 JSR PRINT
 GOTOXY 0;23
 ASC "Total memory alloacted : $"
 COLOR YELLOW
 HEX32 TOTMEMALLOC
 COLOR WHITE
 ASC " ("
 COLOR YELLOW
 DEC16 VTEMP
 COLOR WHITE
 ASC " k). "
 COLOR PINK
 NULL
 GETRETURN
 JSR PRINT
 COLOR WHITE
 NULL

EXIT RETURN

TOTMEM DS 4
FREEMEM DS 4
TOTMEMALLOC DS 4
MAXBLOCK DS 4
HNDL DS 4
ADDR DS 4
HNDLSIZE DS 4
ROMVERS DS 1

]LEN = 16
MEMTBL DFB ]LEN
 ENTRY "<unknown>"
 ENTRY "Items"
 ENTRY "Players"
 ENTRY "Monsters"
 ENTRY "Maze Monsters"
 ENTRY "Maze Items"
 ENTRY "Spells"
 ENTRY "Message BitMap"
 ENTRY "Party Names"
 ENTRY "<pageout area>"
 ENTRY "Font + TBTable"

 LST ON
MODEND EQU *
 LST OFF

 do M16PLUS
 SAV RUN/MODULES/TECHO.INFO
 fin

 END
