*-------------------------------
* VARS.EDITOR
*-------------------------------
 DAT
 LST OFF

 ORG $8000 ;Always

 USE MACROS
 USE EQUATES
 USE VARS
 USE LIB.JMP

 TYP $F4
 do M16PLUS-1
 DSK RUN/MODULES/VARS.EDITOR
 fin

NUMVARS = 31 ;Number of variables

 MODID "VARS.EDITOR"

START JSR PRINT
 HOME
 CURSOROFF
 BOX "Variables Editor"
 NULL

 LDX #0
 LDA #0
 JSR LOADSCEN
 LDA SCENBUFF
 STA SCENS

TOP JSR PRINT
 NORMAL
 MTOFF
 GOTOXY 0;4
 COLOR WHITE
 CLEOS
 CURSOROFF
 ASC "  1 - SmartModem...................."
 PRFLAG SMARTMODEM
 CR
 ASC "  2 - Pointer used.................."
 NULL
 JSR SHOWPNTR
 JSR PRINT
 NORMAL
 MTOFF
 CR
 ASC "  3 - CR after GETLINE.............."
 PRFLAG CRONINP
 CR
 ASC "  4 - Wordwrap......................"
 PRFLAG WORDWRAP
 CR
 ASC "  5 - No of calls..................."
 COLOR YELLOW
 DEC16 CALLS
 COLOR WHITE
 CR
 ASC "  6 - No of logons.................."
 COLOR YELLOW
 DEC16 LOGONS
 COLOR WHITE
 CR
 ASC "  7 - Days between turns............"
 COLOR YELLOW
 DEC8 TURNDAYS
 COLOR WHITE
 CR
 ASC "  8 - Days to next turn............."
 COLOR YELLOW
 DEC8 DAYSTOGO
 COLOR WHITE
 CR
 ASC "  9 - Days to logon before freed...."
 COLOR YELLOW
 DEC8 ALLOCDAY
 COLOR WHITE
 CR
 ASC " 10 - New player creation points...."
 COLOR YELLOW
 DEC8 NEWPOINTS
 COLOR WHITE
 CR
 ASC " 11 - Players per party (max)......."
 COLOR YELLOW
 DEC8 NUMPARTY
 COLOR WHITE
 CR
 ASC " 12 - Starting gold (player)........"
 COLOR YELLOW
 DEC32 STARTGOLD
 COLOR WHITE
 CR
 ASC " 13 - Modem in test status.........."
 PRFLAG TESTFLAG
 CR
 ASC " 14 - Logon password check.........."
 PRFLAG PWCHECK
 CR
 ASC " 15 - Logon password................"
 COLOR ORANGE
 PRSTRING PWORD
 COLOR WHITE
 CR
 ASC " 16 - Modem init string............."
 COLOR ORANGE
 PRSTRING INITSTRING
 COLOR WHITE
 CR
 ASC " 17 - Version......................."
 COLOR ORANGE
 PRSTRING VERSION
 COLOR WHITE
 CR
 ASC " 18 - System name..................."
 COLOR AQUAMARINE
 PRSTRING SYSTEMNAME
 COLOR WHITE
 GOTOXY 40;4
 ASC " 19 - Generation/release date.."
 COLOR ORANGE
 PRSTRING GENDATE
 COLOR WHITE
 GOTOXY 40;5
 ASC " 20 - Modem init baud rate....."
 COLOR YELLOW
 PRTABLE INITRATE;BAUDTABLE
 COLOR WHITE
 GOTOXY 40;6
 ASC " 21 - GM available to chat....."
 PRFLAG GMSTATUS
 GOTOXY 40;7
 ASC " 22 - Public Notice date......."
 COLOR AQUAMARINE
 DATE PNOTICEDATE
 COLOR WHITE
 GOTOXY 40;8
 ASC " 23 - Turn experience points..."
 COLOR YELLOW
 DEC16 TURNEXP
 COLOR WHITE
 GOTOXY 40;9
 ASC " 24 - Added time active........"
 PRFLAG XTRATIME
 GOTOXY 40;10
 ASC " 25 - Added time to next turn.."
 COLOR PINK
 TIME TURNTIME
 COLOR WHITE
 GOTOXY 40;11
 ASC " 26 - Scenario 'stuff'........."
 COLOR YELLOW
 DEC8 SCENARIO
 COLOR WHITE
 ASC " ("
 COLOR YELLOW
 DEC8 SCENS
 COLOR WHITE
 ASC ")"
 GOTOXY 40;12
 ASC " 27 - Beat up on leader........"
 PRFLAG BEATUPLEADER
 GOTOXY 40;13
 ASC " 28 - Serial number............"
 COLOR AQUAMARINE
 HEX16 SERIAL
 COLOR WHITE
 GOTOXY 40;14
 ASC " 29 - Modem constant speed?...."
 PRFLAG MODEMCSFLAG
 GOTOXY 40;15
 ASC " 30 - Flow control cable?......"
 PRFLAG FLOWCONTROL
 GOTOXY 40;16
 ASC " 31 - Skip no party scenarios?."
 PRFLAG SKIPNOPARTYSCEN
 NULL
 JSR DOPOINT

BOT JSR PRINT
 GOTOXY 0;23
 CLEOS
 ASC "[L]oad, [S]ave, [H]elp, [Q]uit : "
 CURSORON
 NULL

 LDA CH
 STA BOTCH+2

BOT2 JSR PRINT
BOTCH GOTOXY 0;23
 NULL
]LOOP JSR KEYIN
 JSR UPPER
 LDX :KEYS
]LOOP2 CMP :KEYS,X
 BEQ :GOTONE
 DEX
 BNE ]LOOP2
 JMP ]LOOP
:GOTONE DEX
 TXA
 ASL
 TAX
 JMP (:TABLE,X)

:KEYS DFB :ENDKEYS-*-1
 DFB "Q"
 DFB "L"
 DFB "S"
 DFB "H"
 DFB "K"-$40
 DFB "J"-$40
 DFB "M"-$40
:ENDKEYS

:TABLE DA EXIT
 DA LOAD
 DA SAVE
 DA HELP
 DA UP
 DA DOWN
 DA EDIT

HELP JSR PRINT
 GOTOXY 0;4
 CLEOS
 NULL
 JSR GETFILE
 DFB 4,22 ;Use lines x to y
 STR "HELP/VARS.ED"
 JSR PRINT
 GOTOXY 0;23
 COLOR PINK
 NULL
 GETRETURN
 JMP TOP

EDIT LDA PNTR
 DEC
 ASL
 TAX
 JMP (:EDITS,X)

:EDITS DA :SMART
 DA :POINTER
 DA :CR
 DA :WORDRAP
 DA :CALLS
 DA :LOGONS
 DA :TDAYS
 DA :DAYS2
 DA :ALLOC
 DA :NEWPNTS
 DA :NUMP
 DA :SGOLD
 DA :TEST
 DA :PWCHECK
 DA :PWORD
 DA :INITSTR
 DA :VERS
 DA :SYSNAME
 DA :GEN
 DA :INITB
 DA :GMSTAT
 DA :PDATE
 DA :TURNEXP
 DA :XTRA
 DA :TTIME
 DA :SCENSTUF
 DA :BEATUP
 DA :SERIAL
 DA :MODEMCS
 DA :FLOW
 DA :NOPSCEN
*-------------------------------------------------
 DA :SHR ;Not displayed (ie; can't edit)
*-------------------------------------------------

:SMART JSR CHECKBETA
 LDX #1
 LDY #1
 JSR ASK
 GETLINE #1
 CPX #0
 BEQL BOT
 LDA $200
 CMP #"1"
 BEQ :A1
 CMP #"0"
 BNE :SMART
 LDA #0
 HEX 2C
:A1 LDA #$FF
 STA SMARTMODEM
 JMP TOP

:VERS JSR CHECKBETA
 LDX #2
 LDY #17
 JSR ASK
 GETLINE #15
 CPX #0
 BEQL BOT
 STX VERSION
]LOOP LDA $200-1,X
 STA VERSION,X
 DEX
 BNE ]LOOP
 JMP TOP

:CR JSR CHECKBETA
 LDX #1
 LDY #3
 JSR ASK
 GETLINE #1
 CPX #0
 BEQL BOT
 LDA $200
 CMP #"1"
 BEQ :CR1
 CMP #"0"
 BNE :CR
 LDA #0
 HEX 2C
:CR1 LDA #$FF
 STA CRONINP
 JMP TOP

:WORDRAP JSR CHECKBETA
 LDX #1
 LDY #4
 JSR ASK
 GETLINE #1
 CPX #0
 BEQL BOT
 LDA $200
 CMP #"1"
 BEQ :W1
 CMP #"0"
 BNE :WORDRAP
 LDA #0
 HEX 2C
:W1 LDA #$FF
 STA WORDWRAP
 JMP TOP

:CALLS LDX #5
 LDY #5
 JSR ASK
 GETLINE #5
 CPX #0
 BEQL BOT
 JSR GETNUM
 STX CALLS
 STY CALLS+1
 JMP TOP

:LOGONS LDX #5
 LDY #6
 JSR ASK
 GETLINE #5
 CPX #0
 BEQL BOT
 JSR GETNUM
 STX LOGONS
 STY LOGONS+1
 JMP TOP

:TDAYS LDX #5
 LDY #7
 JSR ASK
 GETLINE #3
 CPX #0
 BEQL BOT
 JSR GETNUM
 STX TURNDAYS
 JMP TOP

:DAYS2 LDX #5
 LDY #8
 JSR ASK
 GETLINE #3
 CPX #0
 BEQL BOT
 JSR GETNUM
 STX DAYSTOGO
 JMP TOP

:ALLOC LDX #5
 LDY #9
 JSR ASK
 GETLINE #3
 CPX #0
 BEQL BOT
 JSR GETNUM
 STX ALLOCDAY
 JMP TOP

:NEWPNTS LDX #5
 LDY #10
 JSR ASK
 GETLINE #3
 CPX #0
 BEQL BOT
 JSR GETNUM
 STX NEWPOINTS
 JMP TOP

:NUMP LDX #5
 LDY #11
 JSR ASK
 GETLINE #1
 CPX #0
 BEQL BOT
 JSR GETNUM
 CPX #9
 BCSL TOP
 STX NUMPARTY
 JMP TOP

:POINTER JSR CHECKBETA
 LDX #2
 LDY #2
 JSR ASK
 GETLINE #1
 CPX #0
 BEQL BOT
 LDA $200
 STA YEPNTR+1
 JSR PRINT
 ASC "  1=MouseText, 2=Inverse, 3=Normal : "
 NULL
]LOOP JSR KEYIN
 CMP #"1"
 BCC ]LOOP
 CMP #"3"+1
 BCS ]LOOP
 PHA
 JSR COUT
 PLA
 SEC
 SBC #"1"
 TAX
 LDA :PTRS,X
 STA YEPNTR
 JMP TOP
:PTRS DFB $FF,$0F,$00

:SHR JSR CHECKBETA
 LDX #1
 LDY #13
 JSR ASK
 GETLINE #1
 CPX #0
 BEQL BOT
 LDA $200
 CMP #"1"
 BEQ :AB1
 CMP #"0"
 BNE :SHR
 LDA #0
 HEX 2C
:AB1 LDA #$FF
 STA SHRFLAG
 JSR INITHOOK
 JMP START

:SYSNAME LDX #2
 LDY #18
 JSR ASK
 GETLINE #14
 CPX #0
 BEQL BOT
 STX SYSTEMNAME
]LOOP LDA $200-1,X
 STA SYSTEMNAME,X
 DEX
 BNE ]LOOP
 JMP TOP

:TEST LDX #1
 LDY #13
 JSR ASK
 GETLINE #1
 CPX #0
 BEQL BOT
 LDA $200
 CMP #"1"
 BEQ :TT1
 CMP #"0"
 BNE :TEST
 LDA #0
 HEX 2C
:TT1 LDA #$FF
 STA TESTFLAG
 JMP TOP

:PWCHECK LDX #1
 LDY #14
 JSR ASK
 GETLINE #1
 CPX #0
 BEQL BOT
 LDA $200
 CMP #"1"
 BEQ :PWC1
 CMP #"0"
 BNE :PWCHECK
 LDA #0
 HEX 2C
:PWC1 LDA #$FF
 STA PWCHECK
 JMP TOP

:PWORD LDX #2
 LDY #15
 JSR ASK
 GETLINE #8
 CPX #0
 BEQL BOT
 STX PWORD
]LOOP LDA $200-1,X
 STA PWORD,X
 DEX
 BNE ]LOOP
 JMP TOP

:INITSTR LDX #2
 LDY #16
 JSR ASK
 GETLINE #40
 CPX #0
 BEQL BOT
 STX INITSTRING
]LOOP LDA $200-1,X
 STA INITSTRING,X
 DEX
 BNE ]LOOP
 JMP TOP

:SGOLD LDX #5
 LDY #12
 JSR ASK
 GETLINE #10
 CPX #0
 BEQL BOT
 JSR GETNUM
 STX STARTGOLD
 STY STARTGOLD+1
 LDA VTEMP
 STA STARTGOLD+2
 LDA VTEMP+1
 STA STARTGOLD+3
:SGRTS JMP TOP

:GEN JSR CHECKBETA
 LDX #2
 LDY #19
 JSR ASK
 GETLINE #9
 CPX #0
 BEQL BOT
 STX GENDATE
]LOOP LDA $200-1,X
 STA GENDATE,X
 DEX
 BNE ]LOOP
 JMP TOP

:INITB JSR PRINT
 GOTOXY 0;4
 CLEOS
 LINE "Baud rate to initialize modem port with :"
 CR
 LINE " 1 -   300"
 LINE " 2 -  1200"
 LINE " 3 -  2400"
 LINE " 4 -  4800"
 LINE " 5 -  7200"
 LINE " 6 -  9600"
 LINE " 7 - 19200"
 CR
 ASC "Select an option : "
 NULL
 GETLINE #2
 CPX #0
 BEQ :IBNO
 JSR GETNUM
 CPX #0
 BEQ :IBNO
 CPX #8
 BCS :IBNO
 CPX #7
 BNE :BXOK
 LDX #9
:BXOK STX INITRATE
:IBNO JMP TOP

:GMSTAT LDX #1
 LDY #21
 JSR ASK
 GETLINE #1
 CPX #0
 BEQL BOT
 LDA $200
 CMP #"1"
 BEQ :GM1
 CMP #"0"
 BNE :GMSTAT
 LDA #0
 HEX 2C
:GM1 LDA #$FF
 STA GMSTATUS
 JMP TOP

:PDATE LDX #3
 LDY #22
 JSR ASK
 GETLINE #6
 CPX #6
 BNEL BOT
 LDX #3
]LOOP LDA $200+2,X
 STA :DENTRY,X
 DEX
 BPL ]LOOP
 LDA #$8D
 STA $202
 LDX #2
 JSR GETNUM
 STX :DDAY
 LDA :DENTRY
 STA $200
 LDA :DENTRY+1
 STA $201
 LDX #2
 JSR GETNUM
 STX :DMONTH
 LDA :DENTRY+2
 STA $200
 LDA :DENTRY+3
 STA $201
 LDX #2
 JSR GETNUM
 STX :DYEAR
 LDA :DMONTH
 ASL
 ASL
 ASL
 ASL
 ASL
 ROL :DYEAR
 ORA :DDAY
 STA PNOTICEDATE
 LDA :DYEAR
 STA PNOTICEDATE+1
:PDRTS JMP TOP
:DDAY DS 1
:DMONTH DS 1
:DYEAR DS 1
:DENTRY DS 9

:TURNEXP LDX #5
 LDY #23
 JSR ASK
 GETLINE #5
 CPX #0
 BEQL BOT
 JSR GETNUM
 STX TURNEXP
 STY TURNEXP+1
 JMP TOP

:XTRA LDX #1
 LDY #24
 JSR ASK
 GETLINE #1
 CPX #0
 BEQL BOT
 LDA $200
 CMP #"1"
 BEQ :X1
 CMP #"0"
 BNE :XTRA
 LDA #0
 HEX 2C
:X1 LDA #$FF
 STA XTRATIME
 JMP TOP

:TTIME LDX #7
 LDY #25
 JSR ASK
 GETLINE #4
 CPX #4
 BNEL BOT
 LDA $202
 PHA
 LDA #$8D
 STA $202
 LDX #2
 JSR GETNUM
 STX TURNTIME+1
 PLA
 STA $200
 LDA $203
 STA $201
 LDX #2
 JSR GETNUM
 STX TURNTIME
 JMP TOP

:BEATUP LDX #1
 LDY #27
 JSR ASK
 GETLINE #1
 CPX #0
 BEQL BOT
 LDA $200
 CMP #"1"
 BEQ :BU1
 CMP #"0"
 BNE :BEATUP
 LDA #0
 HEX 2C
:BU1 LDA #$FF
 STA BEATUPLEADER
 JMP TOP

:SERIAL LDX #5
 LDY #28
 JSR ASK
 GETLINE #5
 CPX #0
 BEQL BOT
 JSR GETNUM
 STX SERIAL
 STY SERIAL+1
 JMP TOP

:MODEMCS LDX #1
 LDY #29
 JSR ASK
 GETLINE #1
 CPX #0
 BEQL BOT
 LDA $200
 CMP #"1"
 BEQ :CS1
 CMP #"0"
 BNE :MODEMCS
 LDA #0
 HEX 2C
:CS1 LDA #$FF
 STA MODEMCSFLAG
 JMP TOP

:FLOW LDX #1
 LDY #30
 JSR ASK
 GETLINE #1
 CPX #0
 BEQL BOT
 LDA $200
 CMP #"1"
 BEQ :FC1
 CMP #"0"
 BNE :FLOW
 LDA #0
 HEX 2C
:FC1 LDA #$FF
 STA FLOWCONTROL
 JMP TOP

:NOPSCEN LDX #1
 LDY #31
 JSR ASK
 GETLINE #1
 CPX #0
 BEQL BOT
 LDA $200
 CMP #"1"
 BEQ :NPS1
 CMP #"0"
 BNE :NOPSCEN
 LDA #0
 HEX 2C
:NPS1 LDA #$FF
 STA SKIPNOPARTYSCEN
 JMP TOP

:SCENSTUF JSR PRINT
 GOTOXY 0;4
 CLEOS
 ASC "Scenario to alter values for : "
 COLOR YELLOW
 DEC8 SCENARIO
 COLOR WHITE
 CR
 CR
 ASC "1 - Game turn................"
 NULL
 STZ VTEMP
]LOOP LDX VTEMP
 CPX SCENS
 BEQ :YEHOK
 LDA VTEMP
 ASL
 TAX
 LDA GAMETURN,X
 STA :TEMP
 LDA GAMETURN+1,X
 STA :TEMP+1
 INC VTEMP
 JSR PRINT
 DEC8 VTEMP
 ASC "="
 COLOR YELLOW
 DEC16 :TEMP
 COLOR WHITE
 NULL
 LDA VTEMP
 CMP SCENS
 BEQ :YEHOK
 JSR PRINT
 COLOR AQUAMARINE
 ASC "/"
 COLOR WHITE
 NULL
 BRA ]LOOP
:YEHOK JSR PRINT
 CR
 ASC "2 - Scenario completed?......"
 NULL
 STZ VTEMP
]LOOP LDX VTEMP
 CPX SCENS
 BEQ :YEHOK2
 LDA QUESTDONE,X
 STA VTEMP+1
 INC VTEMP
 JSR PRINT
 DEC8 VTEMP
 ASC "="
 COLOR YELLOW
 PRFLAG VTEMP+1
 COLOR WHITE
 NULL
 LDA VTEMP
 CMP SCENS
 BEQ :YEHOK2
 JSR PRINT
 COLOR AQUAMARINE
 ASC " / "
 COLOR WHITE
 NULL
 BRA ]LOOP
:YEHOK2 JSR PRINT
 CR
 ASC "3 - 'Monster to kill' dead?.."
 NULL
 STZ VTEMP
]LOOP LDX VTEMP
 CPX SCENS
 BEQ :YEHOK3
 LDA M2KILLDEAD,X
 STA VTEMP+1
 INC VTEMP
 JSR PRINT
 DEC8 VTEMP
 ASC "="
 COLOR YELLOW
 PRFLAG VTEMP+1
 COLOR WHITE
 NULL
 LDA VTEMP
 CMP SCENS
 BEQ :YEHOK3
 JSR PRINT
 COLOR AQUAMARINE
 ASC " / "
 COLOR WHITE
 NULL
 BRA ]LOOP
:YEHOK3 JSR PRINT
 CR
 ASC "4 - EndQuest experience......"
 NULL
 STZ VTEMP
]LOOP LDX VTEMP
 CPX SCENS
 BEQ :YEHOK4
 LDA VTEMP
 ASL
 TAX
 LDA ENDQUESTEXP,X
 STA :TEMP
 LDA ENDQUESTEXP+1,X
 STA :TEMP+1
 INC VTEMP
 JSR PRINT
 DEC8 VTEMP
 ASC "="
 COLOR YELLOW
 DEC16 :TEMP
 COLOR WHITE
 NULL
 LDA VTEMP
 CMP SCENS
 BEQ :YEHOK4
 JSR PRINT
 COLOR AQUAMARINE
 ASC "/"
 COLOR WHITE
 NULL
 BRA ]LOOP
:YEHOK4 JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 ASC "[1-4], [S]cenario, [ESC]-exit : "
 NULL
]LOOP JSR KEYIN
 CMP #$9B
 BEQL TOP
 CMP #"S"
 BEQ :FIXSCEN
 SEC
 SBC #"1"
 CMP #5
 BCS ]LOOP
 ASL
 TAX
 JMP (:TBL2,X)

:TBL2 DA :GTURN
 DA :SCENEND
 DA :M2K
 DA :ENDQEXP

:FIXSCEN JSR PRINT
 GOTOXY 0;23
 ZAPLINE
 ASC "Scenario to alter values for : "
 NULL
 GETLINE #1
 CPX #0
 BEQL :YEHOK4
 JSR GETNUM
 CPX #0
 BEQL :YEHOK4
 STX SCENARIO
 JMP :SCENSTUF

:GTURN LDX #5
 LDY #1
 JSR ASK
 GETLINE #5
 CPX #0
 BEQL TOP
 JSR GETNUM
 PHY
 PHX
 LDA SCENARIO
 DEC
 ASL
 TAX
 PLA
 STA GAMETURN,X
 PLA
 STA GAMETURN+1,X
 JMP :SCENSTUF

:SCENEND LDX #1
 LDY #2
 JSR ASK
 GETLINE #1
 CPX #0
 BEQL :SCENSTUF
 LDA $200
 CMP #"1"
 BEQ :A2
 CMP #"0"
 BNE :SCENEND
 LDA #0
 HEX 2C
:A2 LDA #$FF
 LDX SCENARIO
 STA QUESTDONE-1,X
 JMP :SCENSTUF

:M2K LDX #1
 LDY #3
 JSR ASK
 GETLINE #1
 CPX #0
 BEQL :SCENSTUF
 LDA $200
 CMP #"1"
 BEQ :AA1
 CMP #"0"
 BNE :M2K
 LDA #0
 HEX 2C
:AA1 LDA #$FF
 LDX SCENARIO
 STA M2KILLDEAD-1,X
 JMP :SCENSTUF

:ENDQEXP LDX #5
 LDY #4
 JSR ASK
 GETLINE #5
 CPX #0
 BEQL :SCENSTUF
 JSR GETNUM
 PHY
 PHX
 LDA SCENARIO
 DEC
 ASL
 TAX
 PLA
 STA ENDQUESTEXP,X
 PLA
 STA ENDQUESTEXP+1,X
 JMP :SCENSTUF

:TEMP DS 2

DOPOINT LDA OLDPNTR
 CMP #19
 BCC :PLEFT
 LDA #40
 STA :CH+2
 LDA OLDPNTR
 SEC
 SBC #15
 STA :CV+2
 BRA :DOP1
:PLEFT STZ :CH+2
 LDA OLDPNTR
 CLC
 ADC #3
 STA :CV+2
:DOP1 JSR PRINT
 NORMAL
 MTOFF
:CH HTAB 0
:CV VTAB 0
 ASC " "
 NULL
 LDA PNTR
 CMP #19
 BCC :PLEFT2
 LDA #40
 STA :CH2+2
 LDA PNTR
 SEC
 SBC #15
 STA :CV2+2
 BRA :DOP2
:PLEFT2 STZ :CH2+2
 LDA PNTR
 CLC
 ADC #3
 STA :CV2+2
:DOP2 JSR PRINT
:CH2 HTAB 0
:CV2 VTAB 0
 NULL
 JSR SHOWPNTR
 LDA PNTR
 STA OLDPNTR
 RTS
OLDPNTR DFB 1
PNTR DFB 1

UP LDA PNTR
 CMP #1
 BNE :OK
 LDA #NUMVARS+1
:OK DEC
 STA PNTR
 JSR DOPOINT
 JMP BOT2

DOWN LDA PNTR
 CMP #NUMVARS
 BNE :OK
 LDA #0
:OK INC
 STA PNTR
 JSR DOPOINT
 JMP BOT2

LOAD JSR LOADVARS
 JMP TOP

SAVE JSR SAVEVARS
 JMP BOT

EXIT RETURN

ENTRY MAC
HERE STR ]1
 DS HERE-*+]LEN+1
 <<<

]LEN = 10
BAUDTABLE DFB ]LEN
 ENTRY "<unknown>"
 ENTRY "300"
 ENTRY "1200"
 ENTRY "2400"
 ENTRY "4800"
 ENTRY "7200"
 ENTRY "9600"
 ENTRY "19200"
 ENTRY "19200"
 ENTRY "19200"

SCENS DS 1

CHECKBETA LDA BETAREL
 BMI :OOPS
 RTS
:OOPS JSR PRINT
 GOTOXY 0;23
 CLEOS
 COLOR PINK
 ASC "This entry is fixed and connot be changed. "
 COLOR WHITE
 NULL
 GETRETURN
 PLA
 JMP BOT

 LST ON
MODEND EQU *
 LST OFF

 do M16PLUS
 SAV RUN/MODULES/VARS.EDITOR
 fin

 END
